import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecAdvancedSettingsPiiLearningConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pii_learning#config_id AppsecAdvancedSettingsPiiLearning#config_id}
    */
    readonly configId: number;
    /**
    * Whether to enable the PII learning advanced setting
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pii_learning#enable_pii_learning AppsecAdvancedSettingsPiiLearning#enable_pii_learning}
    */
    readonly enablePiiLearning: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pii_learning#id AppsecAdvancedSettingsPiiLearning#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pii_learning akamai_appsec_advanced_settings_pii_learning}
*/
export declare class AppsecAdvancedSettingsPiiLearning extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_advanced_settings_pii_learning";
    /**
    * Generates CDKTF code for importing a AppsecAdvancedSettingsPiiLearning resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecAdvancedSettingsPiiLearning to import
    * @param importFromId The id of the existing AppsecAdvancedSettingsPiiLearning that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pii_learning#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecAdvancedSettingsPiiLearning to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pii_learning akamai_appsec_advanced_settings_pii_learning} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecAdvancedSettingsPiiLearningConfig
    */
    constructor(scope: Construct, id: string, config: AppsecAdvancedSettingsPiiLearningConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _enablePiiLearning?;
    get enablePiiLearning(): boolean | cdktf.IResolvable;
    set enablePiiLearning(value: boolean | cdktf.IResolvable);
    get enablePiiLearningInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
