import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecAdvancedSettingsPragmaHeaderConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pragma_header#config_id AppsecAdvancedSettingsPragmaHeader#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pragma_header#id AppsecAdvancedSettingsPragmaHeader#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * JSON-formatted information describing the conditions to exclude from the default remove action
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pragma_header#pragma_header AppsecAdvancedSettingsPragmaHeader#pragma_header}
    */
    readonly pragmaHeader: string;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pragma_header#security_policy_id AppsecAdvancedSettingsPragmaHeader#security_policy_id}
    */
    readonly securityPolicyId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pragma_header akamai_appsec_advanced_settings_pragma_header}
*/
export declare class AppsecAdvancedSettingsPragmaHeader extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_advanced_settings_pragma_header";
    /**
    * Generates CDKTF code for importing a AppsecAdvancedSettingsPragmaHeader resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecAdvancedSettingsPragmaHeader to import
    * @param importFromId The id of the existing AppsecAdvancedSettingsPragmaHeader that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pragma_header#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecAdvancedSettingsPragmaHeader to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_pragma_header akamai_appsec_advanced_settings_pragma_header} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecAdvancedSettingsPragmaHeaderConfig
    */
    constructor(scope: Construct, id: string, config: AppsecAdvancedSettingsPragmaHeaderConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _pragmaHeader?;
    get pragmaHeader(): string;
    set pragmaHeader(value: string);
    get pragmaHeaderInput(): string | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    resetSecurityPolicyId(): void;
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
