import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecCustomDenyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_deny#config_id AppsecCustomDeny#config_id}
    */
    readonly configId: number;
    /**
    * JSON-formatted information about the properties and property values for the custom deny
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_deny#custom_deny AppsecCustomDeny#custom_deny}
    */
    readonly customDeny: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_deny#id AppsecCustomDeny#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_deny akamai_appsec_custom_deny}
*/
export declare class AppsecCustomDeny extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_custom_deny";
    /**
    * Generates CDKTF code for importing a AppsecCustomDeny resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecCustomDeny to import
    * @param importFromId The id of the existing AppsecCustomDeny that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_deny#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecCustomDeny to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_deny akamai_appsec_custom_deny} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecCustomDenyConfig
    */
    constructor(scope: Construct, id: string, config: AppsecCustomDenyConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _customDeny?;
    get customDeny(): string;
    set customDeny(value: string);
    get customDenyInput(): string | undefined;
    get customDenyId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
