import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecCustomRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_rule#config_id AppsecCustomRule#config_id}
    */
    readonly configId: number;
    /**
    * JSON-formatted definition of the custom rule
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_rule#custom_rule AppsecCustomRule#custom_rule}
    */
    readonly customRule: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_rule#id AppsecCustomRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_rule akamai_appsec_custom_rule}
*/
export declare class AppsecCustomRule extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_custom_rule";
    /**
    * Generates CDKTF code for importing a AppsecCustomRule resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecCustomRule to import
    * @param importFromId The id of the existing AppsecCustomRule that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_rule#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecCustomRule to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_custom_rule akamai_appsec_custom_rule} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecCustomRuleConfig
    */
    constructor(scope: Construct, id: string, config: AppsecCustomRuleConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _customRule?;
    get customRule(): string;
    set customRule(value: string);
    get customRuleInput(): string | undefined;
    get customRuleId(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
