import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecMatchTargetConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_match_target#config_id AppsecMatchTarget#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_match_target#id AppsecMatchTarget#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * JSON-formatted definition of the match target
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_match_target#match_target AppsecMatchTarget#match_target}
    */
    readonly matchTarget: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_match_target akamai_appsec_match_target}
*/
export declare class AppsecMatchTarget extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_match_target";
    /**
    * Generates CDKTF code for importing a AppsecMatchTarget resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecMatchTarget to import
    * @param importFromId The id of the existing AppsecMatchTarget that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_match_target#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecMatchTarget to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_match_target akamai_appsec_match_target} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecMatchTargetConfig
    */
    constructor(scope: Construct, id: string, config: AppsecMatchTargetConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _matchTarget?;
    get matchTarget(): string;
    set matchTarget(value: string);
    get matchTargetInput(): string | undefined;
    get matchTargetId(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
