import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecReputationProfileConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_reputation_profile#config_id AppsecReputationProfile#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_reputation_profile#id AppsecReputationProfile#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * JSON-formatted definition of the reputation profile
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_reputation_profile#reputation_profile AppsecReputationProfile#reputation_profile}
    */
    readonly reputationProfile: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_reputation_profile akamai_appsec_reputation_profile}
*/
export declare class AppsecReputationProfile extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_reputation_profile";
    /**
    * Generates CDKTF code for importing a AppsecReputationProfile resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecReputationProfile to import
    * @param importFromId The id of the existing AppsecReputationProfile that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_reputation_profile#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecReputationProfile to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_reputation_profile akamai_appsec_reputation_profile} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecReputationProfileConfig
    */
    constructor(scope: Construct, id: string, config: AppsecReputationProfileConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _reputationProfile?;
    get reputationProfile(): string;
    set reputationProfile(value: string);
    get reputationProfileInput(): string | undefined;
    get reputationProfileId(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
