import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecSecurityPolicyDefaultProtectionsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_default_protections#config_id AppsecSecurityPolicyDefaultProtections#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_default_protections#id AppsecSecurityPolicyDefaultProtections#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Name of the new security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_default_protections#security_policy_name AppsecSecurityPolicyDefaultProtections#security_policy_name}
    */
    readonly securityPolicyName: string;
    /**
    * Four-character alphanumeric string prefix used in creating the security policy ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_default_protections#security_policy_prefix AppsecSecurityPolicyDefaultProtections#security_policy_prefix}
    */
    readonly securityPolicyPrefix: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_default_protections akamai_appsec_security_policy_default_protections}
*/
export declare class AppsecSecurityPolicyDefaultProtections extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_security_policy_default_protections";
    /**
    * Generates CDKTF code for importing a AppsecSecurityPolicyDefaultProtections resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecSecurityPolicyDefaultProtections to import
    * @param importFromId The id of the existing AppsecSecurityPolicyDefaultProtections that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_default_protections#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecSecurityPolicyDefaultProtections to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_default_protections akamai_appsec_security_policy_default_protections} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecSecurityPolicyDefaultProtectionsConfig
    */
    constructor(scope: Construct, id: string, config: AppsecSecurityPolicyDefaultProtectionsConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get securityPolicyId(): string;
    private _securityPolicyName?;
    get securityPolicyName(): string;
    set securityPolicyName(value: string);
    get securityPolicyNameInput(): string | undefined;
    private _securityPolicyPrefix?;
    get securityPolicyPrefix(): string;
    set securityPolicyPrefix(value: string);
    get securityPolicyPrefixInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
