import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecSecurityPolicyRenameConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_rename#config_id AppsecSecurityPolicyRename#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_rename#id AppsecSecurityPolicyRename#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_rename#security_policy_id AppsecSecurityPolicyRename#security_policy_id}
    */
    readonly securityPolicyId: string;
    /**
    * New name to be given to the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_rename#security_policy_name AppsecSecurityPolicyRename#security_policy_name}
    */
    readonly securityPolicyName: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_rename akamai_appsec_security_policy_rename}
*/
export declare class AppsecSecurityPolicyRename extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_security_policy_rename";
    /**
    * Generates CDKTF code for importing a AppsecSecurityPolicyRename resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecSecurityPolicyRename to import
    * @param importFromId The id of the existing AppsecSecurityPolicyRename that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_rename#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecSecurityPolicyRename to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_security_policy_rename akamai_appsec_security_policy_rename} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecSecurityPolicyRenameConfig
    */
    constructor(scope: Construct, id: string, config: AppsecSecurityPolicyRenameConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    private _securityPolicyName?;
    get securityPolicyName(): string;
    set securityPolicyName(value: string);
    get securityPolicyNameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
