import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecSelectedHostnamesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_selected_hostnames#config_id AppsecSelectedHostnames#config_id}
    */
    readonly configId: number;
    /**
    * List of hostnames to be added or removed from the protected hosts list
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_selected_hostnames#hostnames AppsecSelectedHostnames#hostnames}
    */
    readonly hostnames: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_selected_hostnames#id AppsecSelectedHostnames#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * How the hostnames are to be applied (APPEND, REMOVE or REPLACE)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_selected_hostnames#mode AppsecSelectedHostnames#mode}
    */
    readonly mode: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_selected_hostnames akamai_appsec_selected_hostnames}
*/
export declare class AppsecSelectedHostnames extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_selected_hostnames";
    /**
    * Generates CDKTF code for importing a AppsecSelectedHostnames resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecSelectedHostnames to import
    * @param importFromId The id of the existing AppsecSelectedHostnames that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_selected_hostnames#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecSelectedHostnames to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_selected_hostnames akamai_appsec_selected_hostnames} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecSelectedHostnamesConfig
    */
    constructor(scope: Construct, id: string, config: AppsecSelectedHostnamesConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _hostnames?;
    get hostnames(): string[];
    set hostnames(value: string[]);
    get hostnamesInput(): string[] | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    get modeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
