import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecThreatIntelConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_threat_intel#config_id AppsecThreatIntel#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_threat_intel#id AppsecThreatIntel#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_threat_intel#security_policy_id AppsecThreatIntel#security_policy_id}
    */
    readonly securityPolicyId: string;
    /**
    * Whether threat intelligence protection should be on or off
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_threat_intel#threat_intel AppsecThreatIntel#threat_intel}
    */
    readonly threatIntel: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_threat_intel akamai_appsec_threat_intel}
*/
export declare class AppsecThreatIntel extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_threat_intel";
    /**
    * Generates CDKTF code for importing a AppsecThreatIntel resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecThreatIntel to import
    * @param importFromId The id of the existing AppsecThreatIntel that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_threat_intel#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecThreatIntel to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_threat_intel akamai_appsec_threat_intel} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecThreatIntelConfig
    */
    constructor(scope: Construct, id: string, config: AppsecThreatIntelConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    private _threatIntel?;
    get threatIntel(): string;
    set threatIntel(value: string);
    get threatIntelInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
