import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecVersionNotesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_version_notes#config_id AppsecVersionNotes#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_version_notes#id AppsecVersionNotes#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Brief description of the security configuration version
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_version_notes#version_notes AppsecVersionNotes#version_notes}
    */
    readonly versionNotes: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_version_notes akamai_appsec_version_notes}
*/
export declare class AppsecVersionNotes extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_version_notes";
    /**
    * Generates CDKTF code for importing a AppsecVersionNotes resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecVersionNotes to import
    * @param importFromId The id of the existing AppsecVersionNotes that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_version_notes#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecVersionNotes to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_version_notes akamai_appsec_version_notes} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecVersionNotesConfig
    */
    constructor(scope: Construct, id: string, config: AppsecVersionNotesConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get outputText(): string;
    private _versionNotes?;
    get versionNotes(): string;
    set versionNotes(value: string);
    get versionNotesInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
