import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecWapSelectedHostnamesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_wap_selected_hostnames#config_id AppsecWapSelectedHostnames#config_id}
    */
    readonly configId: number;
    /**
    * List of hostnames to be evaluated
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_wap_selected_hostnames#evaluated_hosts AppsecWapSelectedHostnames#evaluated_hosts}
    */
    readonly evaluatedHosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_wap_selected_hostnames#id AppsecWapSelectedHostnames#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * List of hostnames to be protected
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_wap_selected_hostnames#protected_hosts AppsecWapSelectedHostnames#protected_hosts}
    */
    readonly protectedHosts?: string[];
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_wap_selected_hostnames#security_policy_id AppsecWapSelectedHostnames#security_policy_id}
    */
    readonly securityPolicyId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_wap_selected_hostnames akamai_appsec_wap_selected_hostnames}
*/
export declare class AppsecWapSelectedHostnames extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_wap_selected_hostnames";
    /**
    * Generates CDKTF code for importing a AppsecWapSelectedHostnames resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecWapSelectedHostnames to import
    * @param importFromId The id of the existing AppsecWapSelectedHostnames that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_wap_selected_hostnames#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecWapSelectedHostnames to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_wap_selected_hostnames akamai_appsec_wap_selected_hostnames} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecWapSelectedHostnamesConfig
    */
    constructor(scope: Construct, id: string, config: AppsecWapSelectedHostnamesConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _evaluatedHosts?;
    get evaluatedHosts(): string[];
    set evaluatedHosts(value: string[]);
    resetEvaluatedHosts(): void;
    get evaluatedHostsInput(): string[] | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _protectedHosts?;
    get protectedHosts(): string[];
    set protectedHosts(value: string[]);
    resetProtectedHosts(): void;
    get protectedHostsInput(): string[] | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
