import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BotmanChallengeInterceptionRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_challenge_interception_rules#challenge_interception_rules BotmanChallengeInterceptionRules#challenge_interception_rules}
    */
    readonly challengeInterceptionRules: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_challenge_interception_rules#config_id BotmanChallengeInterceptionRules#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_challenge_interception_rules#id BotmanChallengeInterceptionRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_challenge_interception_rules akamai_botman_challenge_interception_rules}
*/
export declare class BotmanChallengeInterceptionRules extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_botman_challenge_interception_rules";
    /**
    * Generates CDKTF code for importing a BotmanChallengeInterceptionRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BotmanChallengeInterceptionRules to import
    * @param importFromId The id of the existing BotmanChallengeInterceptionRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_challenge_interception_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BotmanChallengeInterceptionRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_challenge_interception_rules akamai_botman_challenge_interception_rules} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BotmanChallengeInterceptionRulesConfig
    */
    constructor(scope: Construct, id: string, config: BotmanChallengeInterceptionRulesConfig);
    private _challengeInterceptionRules?;
    get challengeInterceptionRules(): string;
    set challengeInterceptionRules(value: string);
    get challengeInterceptionRulesInput(): string | undefined;
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
