import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BotmanCustomBotCategoryActionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_action#category_id BotmanCustomBotCategoryAction#category_id}
    */
    readonly categoryId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_action#config_id BotmanCustomBotCategoryAction#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_action#custom_bot_category_action BotmanCustomBotCategoryAction#custom_bot_category_action}
    */
    readonly customBotCategoryAction: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_action#id BotmanCustomBotCategoryAction#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_action#security_policy_id BotmanCustomBotCategoryAction#security_policy_id}
    */
    readonly securityPolicyId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_action akamai_botman_custom_bot_category_action}
*/
export declare class BotmanCustomBotCategoryAction extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_botman_custom_bot_category_action";
    /**
    * Generates CDKTF code for importing a BotmanCustomBotCategoryAction resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BotmanCustomBotCategoryAction to import
    * @param importFromId The id of the existing BotmanCustomBotCategoryAction that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_action#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BotmanCustomBotCategoryAction to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_action akamai_botman_custom_bot_category_action} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BotmanCustomBotCategoryActionConfig
    */
    constructor(scope: Construct, id: string, config: BotmanCustomBotCategoryActionConfig);
    private _categoryId?;
    get categoryId(): string;
    set categoryId(value: string);
    get categoryIdInput(): string | undefined;
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _customBotCategoryAction?;
    get customBotCategoryAction(): string;
    set customBotCategoryAction(value: string);
    get customBotCategoryActionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
