import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BotmanCustomBotCategorySequenceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_sequence#category_ids BotmanCustomBotCategorySequence#category_ids}
    */
    readonly categoryIds: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_sequence#config_id BotmanCustomBotCategorySequence#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_sequence#id BotmanCustomBotCategorySequence#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_sequence akamai_botman_custom_bot_category_sequence}
*/
export declare class BotmanCustomBotCategorySequence extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_botman_custom_bot_category_sequence";
    /**
    * Generates CDKTF code for importing a BotmanCustomBotCategorySequence resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BotmanCustomBotCategorySequence to import
    * @param importFromId The id of the existing BotmanCustomBotCategorySequence that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_sequence#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BotmanCustomBotCategorySequence to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_custom_bot_category_sequence akamai_botman_custom_bot_category_sequence} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BotmanCustomBotCategorySequenceConfig
    */
    constructor(scope: Construct, id: string, config: BotmanCustomBotCategorySequenceConfig);
    private _categoryIds?;
    get categoryIds(): string[];
    set categoryIds(value: string[]);
    get categoryIdsInput(): string[] | undefined;
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
