import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BotmanJavascriptInjectionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_javascript_injection#config_id BotmanJavascriptInjection#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_javascript_injection#id BotmanJavascriptInjection#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_javascript_injection#javascript_injection BotmanJavascriptInjection#javascript_injection}
    */
    readonly javascriptInjection: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_javascript_injection#security_policy_id BotmanJavascriptInjection#security_policy_id}
    */
    readonly securityPolicyId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_javascript_injection akamai_botman_javascript_injection}
*/
export declare class BotmanJavascriptInjection extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_botman_javascript_injection";
    /**
    * Generates CDKTF code for importing a BotmanJavascriptInjection resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BotmanJavascriptInjection to import
    * @param importFromId The id of the existing BotmanJavascriptInjection that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_javascript_injection#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BotmanJavascriptInjection to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_javascript_injection akamai_botman_javascript_injection} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BotmanJavascriptInjectionConfig
    */
    constructor(scope: Construct, id: string, config: BotmanJavascriptInjectionConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _javascriptInjection?;
    get javascriptInjection(): string;
    set javascriptInjection(value: string);
    get javascriptInjectionInput(): string | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
