import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BotmanTransactionalEndpointProtectionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_transactional_endpoint_protection#config_id BotmanTransactionalEndpointProtection#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_transactional_endpoint_protection#id BotmanTransactionalEndpointProtection#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_transactional_endpoint_protection#transactional_endpoint_protection BotmanTransactionalEndpointProtection#transactional_endpoint_protection}
    */
    readonly transactionalEndpointProtection: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_transactional_endpoint_protection akamai_botman_transactional_endpoint_protection}
*/
export declare class BotmanTransactionalEndpointProtection extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_botman_transactional_endpoint_protection";
    /**
    * Generates CDKTF code for importing a BotmanTransactionalEndpointProtection resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BotmanTransactionalEndpointProtection to import
    * @param importFromId The id of the existing BotmanTransactionalEndpointProtection that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_transactional_endpoint_protection#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BotmanTransactionalEndpointProtection to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/botman_transactional_endpoint_protection akamai_botman_transactional_endpoint_protection} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BotmanTransactionalEndpointProtectionConfig
    */
    constructor(scope: Construct, id: string, config: BotmanTransactionalEndpointProtectionConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _transactionalEndpointProtection?;
    get transactionalEndpointProtection(): string;
    set transactionalEndpointProtection(value: string);
    get transactionalEndpointProtectionInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
