import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ClientlistActivationConfig extends cdktf.TerraformMetaArguments {
    /**
    * A brief description for the activation.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation#comments ClientlistActivation#comments}
    */
    readonly comments?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation#id ClientlistActivation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The client list unique identifier.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation#list_id ClientlistActivation#list_id}
    */
    readonly listId: string;
    /**
    * The network environment where you activate your client list: either STAGING or PRODUCTION.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation#network ClientlistActivation#network}
    */
    readonly network: string;
    /**
    * Users to notify via email.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation#notification_recipients ClientlistActivation#notification_recipients}
    */
    readonly notificationRecipients?: string[];
    /**
    * Identifies the Siebel ticket, if the activation is linked to one.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation#siebel_ticket_id ClientlistActivation#siebel_ticket_id}
    */
    readonly siebelTicketId?: string;
    /**
    * The client list version.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation#version ClientlistActivation#version}
    */
    readonly version: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation akamai_clientlist_activation}
*/
export declare class ClientlistActivation extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_clientlist_activation";
    /**
    * Generates CDKTF code for importing a ClientlistActivation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ClientlistActivation to import
    * @param importFromId The id of the existing ClientlistActivation that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ClientlistActivation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/clientlist_activation akamai_clientlist_activation} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ClientlistActivationConfig
    */
    constructor(scope: Construct, id: string, config: ClientlistActivationConfig);
    private _comments?;
    get comments(): string;
    set comments(value: string);
    resetComments(): void;
    get commentsInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _listId?;
    get listId(): string;
    set listId(value: string);
    get listIdInput(): string | undefined;
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
    private _notificationRecipients?;
    get notificationRecipients(): string[];
    set notificationRecipients(value: string[]);
    resetNotificationRecipients(): void;
    get notificationRecipientsInput(): string[] | undefined;
    private _siebelTicketId?;
    get siebelTicketId(): string;
    set siebelTicketId(value: string);
    resetSiebelTicketId(): void;
    get siebelTicketIdInput(): string | undefined;
    get status(): string;
    private _version?;
    get version(): number;
    set version(value: number);
    get versionInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
