import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface CloudletsApplicationLoadBalancerActivationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation#id CloudletsApplicationLoadBalancerActivation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The network you want to activate the application load balancer version on (options are Staging and Production)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation#network CloudletsApplicationLoadBalancerActivation#network}
    */
    readonly network: string;
    /**
    * The conditional origin’s unique identifier
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation#origin_id CloudletsApplicationLoadBalancerActivation#origin_id}
    */
    readonly originId: string;
    /**
    * Cloudlets application load balancer version you want to activate
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation#version CloudletsApplicationLoadBalancerActivation#version}
    */
    readonly version: number;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation#timeouts CloudletsApplicationLoadBalancerActivation#timeouts}
    */
    readonly timeouts?: CloudletsApplicationLoadBalancerActivationTimeouts;
}
export interface CloudletsApplicationLoadBalancerActivationTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation#default CloudletsApplicationLoadBalancerActivation#default}
    */
    readonly default?: string;
}
export declare function cloudletsApplicationLoadBalancerActivationTimeoutsToTerraform(struct?: CloudletsApplicationLoadBalancerActivationTimeoutsOutputReference | CloudletsApplicationLoadBalancerActivationTimeouts): any;
export declare function cloudletsApplicationLoadBalancerActivationTimeoutsToHclTerraform(struct?: CloudletsApplicationLoadBalancerActivationTimeoutsOutputReference | CloudletsApplicationLoadBalancerActivationTimeouts): any;
export declare class CloudletsApplicationLoadBalancerActivationTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): CloudletsApplicationLoadBalancerActivationTimeouts | undefined;
    set internalValue(value: CloudletsApplicationLoadBalancerActivationTimeouts | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation akamai_cloudlets_application_load_balancer_activation}
*/
export declare class CloudletsApplicationLoadBalancerActivation extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_cloudlets_application_load_balancer_activation";
    /**
    * Generates CDKTF code for importing a CloudletsApplicationLoadBalancerActivation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the CloudletsApplicationLoadBalancerActivation to import
    * @param importFromId The id of the existing CloudletsApplicationLoadBalancerActivation that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the CloudletsApplicationLoadBalancerActivation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/cloudlets_application_load_balancer_activation akamai_cloudlets_application_load_balancer_activation} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options CloudletsApplicationLoadBalancerActivationConfig
    */
    constructor(scope: Construct, id: string, config: CloudletsApplicationLoadBalancerActivationConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    get originIdInput(): string | undefined;
    get status(): string;
    private _version?;
    get version(): number;
    set version(value: number);
    get versionInput(): number | undefined;
    private _timeouts;
    get timeouts(): CloudletsApplicationLoadBalancerActivationTimeoutsOutputReference;
    putTimeouts(value: CloudletsApplicationLoadBalancerActivationTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): CloudletsApplicationLoadBalancerActivationTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
