import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecAdvancedSettingsRequestBodyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_advanced_settings_request_body#config_id DataAkamaiAppsecAdvancedSettingsRequestBody#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_advanced_settings_request_body#id DataAkamaiAppsecAdvancedSettingsRequestBody#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_advanced_settings_request_body#security_policy_id DataAkamaiAppsecAdvancedSettingsRequestBody#security_policy_id}
    */
    readonly securityPolicyId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_advanced_settings_request_body akamai_appsec_advanced_settings_request_body}
*/
export declare class DataAkamaiAppsecAdvancedSettingsRequestBody extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_advanced_settings_request_body";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecAdvancedSettingsRequestBody resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecAdvancedSettingsRequestBody to import
    * @param importFromId The id of the existing DataAkamaiAppsecAdvancedSettingsRequestBody that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_advanced_settings_request_body#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecAdvancedSettingsRequestBody to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_advanced_settings_request_body akamai_appsec_advanced_settings_request_body} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecAdvancedSettingsRequestBodyConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiAppsecAdvancedSettingsRequestBodyConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get outputText(): string;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    resetSecurityPolicyId(): void;
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
