import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecContractsGroupsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of an Akamai contract
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_contracts_groups#contractid DataAkamaiAppsecContractsGroups#contractid}
    */
    readonly contractid?: string;
    /**
    * Unique identifier of a contract group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_contracts_groups#groupid DataAkamaiAppsecContractsGroups#groupid}
    */
    readonly groupid?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_contracts_groups#id DataAkamaiAppsecContractsGroups#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_contracts_groups akamai_appsec_contracts_groups}
*/
export declare class DataAkamaiAppsecContractsGroups extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_contracts_groups";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecContractsGroups resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecContractsGroups to import
    * @param importFromId The id of the existing DataAkamaiAppsecContractsGroups that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_contracts_groups#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecContractsGroups to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_contracts_groups akamai_appsec_contracts_groups} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecContractsGroupsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiAppsecContractsGroupsConfig);
    private _contractid?;
    get contractid(): string;
    set contractid(value: string);
    resetContractid(): void;
    get contractidInput(): string | undefined;
    get defaultContractid(): string;
    get defaultGroupid(): number;
    private _groupid?;
    get groupid(): number;
    set groupid(value: number);
    resetGroupid(): void;
    get groupidInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get outputText(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
