import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecCustomDenyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_deny#config_id DataAkamaiAppsecCustomDeny#config_id}
    */
    readonly configId: number;
    /**
    * Unique identifier of the custom deny for which to return information
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_deny#custom_deny_id DataAkamaiAppsecCustomDeny#custom_deny_id}
    */
    readonly customDenyId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_deny#id DataAkamaiAppsecCustomDeny#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_deny akamai_appsec_custom_deny}
*/
export declare class DataAkamaiAppsecCustomDeny extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_custom_deny";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecCustomDeny resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecCustomDeny to import
    * @param importFromId The id of the existing DataAkamaiAppsecCustomDeny that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_deny#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecCustomDeny to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_deny akamai_appsec_custom_deny} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecCustomDenyConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiAppsecCustomDenyConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _customDenyId?;
    get customDenyId(): string;
    set customDenyId(value: string);
    resetCustomDenyId(): void;
    get customDenyIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get outputText(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
