import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecCustomRuleActionsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_rule_actions#config_id DataAkamaiAppsecCustomRuleActions#config_id}
    */
    readonly configId: number;
    /**
    * Unique identifier of the custom rule for which to return information
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_rule_actions#custom_rule_id DataAkamaiAppsecCustomRuleActions#custom_rule_id}
    */
    readonly customRuleId?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_rule_actions#id DataAkamaiAppsecCustomRuleActions#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_rule_actions#security_policy_id DataAkamaiAppsecCustomRuleActions#security_policy_id}
    */
    readonly securityPolicyId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_rule_actions akamai_appsec_custom_rule_actions}
*/
export declare class DataAkamaiAppsecCustomRuleActions extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_custom_rule_actions";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecCustomRuleActions resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecCustomRuleActions to import
    * @param importFromId The id of the existing DataAkamaiAppsecCustomRuleActions that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_rule_actions#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecCustomRuleActions to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_custom_rule_actions akamai_appsec_custom_rule_actions} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecCustomRuleActionsConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiAppsecCustomRuleActionsConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _customRuleId?;
    get customRuleId(): number;
    set customRuleId(value: number);
    resetCustomRuleId(): void;
    get customRuleIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get outputText(): string;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
