import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecEvalGroupsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique idenfier of the evaluation group for which to retrieve information
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_eval_groups#attack_group DataAkamaiAppsecEvalGroups#attack_group}
    */
    readonly attackGroup?: string;
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_eval_groups#config_id DataAkamaiAppsecEvalGroups#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_eval_groups#id DataAkamaiAppsecEvalGroups#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_eval_groups#security_policy_id DataAkamaiAppsecEvalGroups#security_policy_id}
    */
    readonly securityPolicyId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_eval_groups akamai_appsec_eval_groups}
*/
export declare class DataAkamaiAppsecEvalGroups extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_eval_groups";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecEvalGroups resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecEvalGroups to import
    * @param importFromId The id of the existing DataAkamaiAppsecEvalGroups that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_eval_groups#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecEvalGroups to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_eval_groups akamai_appsec_eval_groups} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecEvalGroupsConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiAppsecEvalGroupsConfig);
    private _attackGroup?;
    get attackGroup(): string;
    set attackGroup(value: string);
    resetAttackGroup(): void;
    get attackGroupInput(): string | undefined;
    get attackGroupAction(): string;
    get conditionException(): string;
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get outputText(): string;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
