import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecExportConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_export_configuration#config_id DataAkamaiAppsecExportConfiguration#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_export_configuration#id DataAkamaiAppsecExportConfiguration#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * List of template files indicating resources to be exported for later import
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_export_configuration#search DataAkamaiAppsecExportConfiguration#search}
    */
    readonly search?: string[];
    /**
    * Version number of the security configuration to be exported
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_export_configuration#version DataAkamaiAppsecExportConfiguration#version}
    */
    readonly version: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_export_configuration akamai_appsec_export_configuration}
*/
export declare class DataAkamaiAppsecExportConfiguration extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_export_configuration";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecExportConfiguration resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecExportConfiguration to import
    * @param importFromId The id of the existing DataAkamaiAppsecExportConfiguration that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_export_configuration#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecExportConfiguration to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_export_configuration akamai_appsec_export_configuration} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecExportConfigurationConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiAppsecExportConfigurationConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get outputText(): string;
    private _search?;
    get search(): string[];
    set search(value: string[]);
    resetSearch(): void;
    get searchInput(): string[] | undefined;
    private _version?;
    get version(): number;
    set version(value: number);
    get versionInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
