import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecHostnameCoverageOverlappingConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_hostname_coverage_overlapping#config_id DataAkamaiAppsecHostnameCoverageOverlapping#config_id}
    */
    readonly configId: number;
    /**
    * Hostname for which to return coverage overlap information
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_hostname_coverage_overlapping#hostname DataAkamaiAppsecHostnameCoverageOverlapping#hostname}
    */
    readonly hostname: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_hostname_coverage_overlapping#id DataAkamaiAppsecHostnameCoverageOverlapping#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_hostname_coverage_overlapping akamai_appsec_hostname_coverage_overlapping}
*/
export declare class DataAkamaiAppsecHostnameCoverageOverlapping extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_hostname_coverage_overlapping";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecHostnameCoverageOverlapping resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecHostnameCoverageOverlapping to import
    * @param importFromId The id of the existing DataAkamaiAppsecHostnameCoverageOverlapping that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_hostname_coverage_overlapping#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecHostnameCoverageOverlapping to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_hostname_coverage_overlapping akamai_appsec_hostname_coverage_overlapping} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecHostnameCoverageOverlappingConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiAppsecHostnameCoverageOverlappingConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    get hostnameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get outputText(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
