import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecRatePolicyActionsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_rate_policy_actions#config_id DataAkamaiAppsecRatePolicyActions#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_rate_policy_actions#id DataAkamaiAppsecRatePolicyActions#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique identifier of a specific rate policy for which to retrieve information
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_rate_policy_actions#rate_policy_id DataAkamaiAppsecRatePolicyActions#rate_policy_id}
    */
    readonly ratePolicyId?: number;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_rate_policy_actions#security_policy_id DataAkamaiAppsecRatePolicyActions#security_policy_id}
    */
    readonly securityPolicyId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_rate_policy_actions akamai_appsec_rate_policy_actions}
*/
export declare class DataAkamaiAppsecRatePolicyActions extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_rate_policy_actions";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecRatePolicyActions resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecRatePolicyActions to import
    * @param importFromId The id of the existing DataAkamaiAppsecRatePolicyActions that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_rate_policy_actions#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecRatePolicyActions to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_rate_policy_actions akamai_appsec_rate_policy_actions} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecRatePolicyActionsConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiAppsecRatePolicyActionsConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get outputText(): string;
    private _ratePolicyId?;
    get ratePolicyId(): number;
    set ratePolicyId(value: number);
    resetRatePolicyId(): void;
    get ratePolicyIdInput(): number | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
