import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecSelectableHostnamesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Whether to return names of hosts selected in production
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames#active_in_production DataAkamaiAppsecSelectableHostnames#active_in_production}
    */
    readonly activeInProduction?: boolean | cdktf.IResolvable;
    /**
    * Whether to return names of hosts selected in staging
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames#active_in_staging DataAkamaiAppsecSelectableHostnames#active_in_staging}
    */
    readonly activeInStaging?: boolean | cdktf.IResolvable;
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames#config_id DataAkamaiAppsecSelectableHostnames#config_id}
    */
    readonly configId?: number;
    /**
    * Unique identifier of an Akamai contract
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames#contractid DataAkamaiAppsecSelectableHostnames#contractid}
    */
    readonly contractid?: string;
    /**
    * Unique identifier of a contract group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames#groupid DataAkamaiAppsecSelectableHostnames#groupid}
    */
    readonly groupid?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames#id DataAkamaiAppsecSelectableHostnames#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames akamai_appsec_selectable_hostnames}
*/
export declare class DataAkamaiAppsecSelectableHostnames extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_selectable_hostnames";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecSelectableHostnames resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecSelectableHostnames to import
    * @param importFromId The id of the existing DataAkamaiAppsecSelectableHostnames that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecSelectableHostnames to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_selectable_hostnames akamai_appsec_selectable_hostnames} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecSelectableHostnamesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiAppsecSelectableHostnamesConfig);
    private _activeInProduction?;
    get activeInProduction(): boolean | cdktf.IResolvable;
    set activeInProduction(value: boolean | cdktf.IResolvable);
    resetActiveInProduction(): void;
    get activeInProductionInput(): boolean | cdktf.IResolvable | undefined;
    private _activeInStaging?;
    get activeInStaging(): boolean | cdktf.IResolvable;
    set activeInStaging(value: boolean | cdktf.IResolvable);
    resetActiveInStaging(): void;
    get activeInStagingInput(): boolean | cdktf.IResolvable | undefined;
    private _configId?;
    get configId(): number;
    set configId(value: number);
    resetConfigId(): void;
    get configIdInput(): number | undefined;
    private _contractid?;
    get contractid(): string;
    set contractid(value: string);
    resetContractid(): void;
    get contractidInput(): string | undefined;
    private _groupid?;
    get groupid(): number;
    set groupid(value: number);
    resetGroupid(): void;
    get groupidInput(): number | undefined;
    get hostnames(): string[];
    get hostnamesJson(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get outputText(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
