import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiBotmanAkamaiDefinedBotConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_akamai_defined_bot#bot_name DataAkamaiBotmanAkamaiDefinedBot#bot_name}
    */
    readonly botName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_akamai_defined_bot#id DataAkamaiBotmanAkamaiDefinedBot#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_akamai_defined_bot akamai_botman_akamai_defined_bot}
*/
export declare class DataAkamaiBotmanAkamaiDefinedBot extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_botman_akamai_defined_bot";
    /**
    * Generates CDKTF code for importing a DataAkamaiBotmanAkamaiDefinedBot resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiBotmanAkamaiDefinedBot to import
    * @param importFromId The id of the existing DataAkamaiBotmanAkamaiDefinedBot that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_akamai_defined_bot#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiBotmanAkamaiDefinedBot to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_akamai_defined_bot akamai_botman_akamai_defined_bot} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiBotmanAkamaiDefinedBotConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiBotmanAkamaiDefinedBotConfig);
    private _botName?;
    get botName(): string;
    set botName(value: string);
    resetBotName(): void;
    get botNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
