import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiBotmanBotDetectionActionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_bot_detection_action#config_id DataAkamaiBotmanBotDetectionAction#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_bot_detection_action#detection_id DataAkamaiBotmanBotDetectionAction#detection_id}
    */
    readonly detectionId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_bot_detection_action#id DataAkamaiBotmanBotDetectionAction#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_bot_detection_action#security_policy_id DataAkamaiBotmanBotDetectionAction#security_policy_id}
    */
    readonly securityPolicyId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_bot_detection_action akamai_botman_bot_detection_action}
*/
export declare class DataAkamaiBotmanBotDetectionAction extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_botman_bot_detection_action";
    /**
    * Generates CDKTF code for importing a DataAkamaiBotmanBotDetectionAction resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiBotmanBotDetectionAction to import
    * @param importFromId The id of the existing DataAkamaiBotmanBotDetectionAction that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_bot_detection_action#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiBotmanBotDetectionAction to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_bot_detection_action akamai_botman_bot_detection_action} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiBotmanBotDetectionActionConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiBotmanBotDetectionActionConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _detectionId?;
    get detectionId(): string;
    set detectionId(value: string);
    resetDetectionId(): void;
    get detectionIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
