import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiBotmanServeAlternateActionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_serve_alternate_action#action_id DataAkamaiBotmanServeAlternateAction#action_id}
    */
    readonly actionId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_serve_alternate_action#config_id DataAkamaiBotmanServeAlternateAction#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_serve_alternate_action#id DataAkamaiBotmanServeAlternateAction#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_serve_alternate_action akamai_botman_serve_alternate_action}
*/
export declare class DataAkamaiBotmanServeAlternateAction extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_botman_serve_alternate_action";
    /**
    * Generates CDKTF code for importing a DataAkamaiBotmanServeAlternateAction resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiBotmanServeAlternateAction to import
    * @param importFromId The id of the existing DataAkamaiBotmanServeAlternateAction that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_serve_alternate_action#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiBotmanServeAlternateAction to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/botman_serve_alternate_action akamai_botman_serve_alternate_action} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiBotmanServeAlternateActionConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiBotmanServeAlternateActionConfig);
    private _actionId?;
    get actionId(): string;
    set actionId(value: string);
    resetActionId(): void;
    get actionIdInput(): string | undefined;
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
