import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiClientlistListsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/clientlist_lists#id DataAkamaiClientlistLists#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/clientlist_lists#name DataAkamaiClientlistLists#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/clientlist_lists#type DataAkamaiClientlistLists#type}
    */
    readonly type?: string[];
}
export interface DataAkamaiClientlistListsLists {
}
export declare function dataAkamaiClientlistListsListsToTerraform(struct?: DataAkamaiClientlistListsLists): any;
export declare function dataAkamaiClientlistListsListsToHclTerraform(struct?: DataAkamaiClientlistListsLists): any;
export declare class DataAkamaiClientlistListsListsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiClientlistListsLists | undefined;
    set internalValue(value: DataAkamaiClientlistListsLists | undefined);
    get createDate(): string;
    get createdBy(): string;
    get deprecated(): cdktf.IResolvable;
    get itemsCount(): number;
    get listId(): string;
    get listType(): string;
    get name(): string;
    get notes(): string;
    get productionActivationStatus(): string;
    get readOnly(): cdktf.IResolvable;
    get shared(): cdktf.IResolvable;
    get stagingActivationStatus(): string;
    get tags(): string[];
    get type(): string;
    get updateDate(): string;
    get updatedBy(): string;
    get version(): number;
}
export declare class DataAkamaiClientlistListsListsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiClientlistListsListsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/clientlist_lists akamai_clientlist_lists}
*/
export declare class DataAkamaiClientlistLists extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_clientlist_lists";
    /**
    * Generates CDKTF code for importing a DataAkamaiClientlistLists resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiClientlistLists to import
    * @param importFromId The id of the existing DataAkamaiClientlistLists that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/clientlist_lists#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiClientlistLists to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/clientlist_lists akamai_clientlist_lists} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiClientlistListsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiClientlistListsConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get listIds(): string[];
    private _lists;
    get lists(): DataAkamaiClientlistListsListsList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get outputText(): string;
    private _type?;
    get type(): string[];
    set type(value: string[]);
    resetType(): void;
    get typeInput(): string[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
