import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudletsApplicationLoadBalancerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_application_load_balancer#id DataAkamaiCloudletsApplicationLoadBalancer#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The conditional origin’s unique identifier
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_application_load_balancer#origin_id DataAkamaiCloudletsApplicationLoadBalancer#origin_id}
    */
    readonly originId: string;
    /**
    * The load balancer configuration version
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_application_load_balancer#version DataAkamaiCloudletsApplicationLoadBalancer#version}
    */
    readonly version?: number;
}
export interface DataAkamaiCloudletsApplicationLoadBalancerDataCenters {
}
export declare function dataAkamaiCloudletsApplicationLoadBalancerDataCentersToTerraform(struct?: DataAkamaiCloudletsApplicationLoadBalancerDataCenters): any;
export declare function dataAkamaiCloudletsApplicationLoadBalancerDataCentersToHclTerraform(struct?: DataAkamaiCloudletsApplicationLoadBalancerDataCenters): any;
export declare class DataAkamaiCloudletsApplicationLoadBalancerDataCentersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsApplicationLoadBalancerDataCenters | undefined;
    set internalValue(value: DataAkamaiCloudletsApplicationLoadBalancerDataCenters | undefined);
    get city(): string;
    get cloudServerHostHeaderOverride(): cdktf.IResolvable;
    get cloudService(): cdktf.IResolvable;
    get continent(): string;
    get country(): string;
    get hostname(): string;
    get latitude(): number;
    get livenessHosts(): string[];
    get longitude(): number;
    get originId(): string;
    get percent(): number;
    get stateOrProvince(): string;
}
export declare class DataAkamaiCloudletsApplicationLoadBalancerDataCentersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsApplicationLoadBalancerDataCentersOutputReference;
}
export interface DataAkamaiCloudletsApplicationLoadBalancerLivenessSettings {
}
export declare function dataAkamaiCloudletsApplicationLoadBalancerLivenessSettingsToTerraform(struct?: DataAkamaiCloudletsApplicationLoadBalancerLivenessSettings): any;
export declare function dataAkamaiCloudletsApplicationLoadBalancerLivenessSettingsToHclTerraform(struct?: DataAkamaiCloudletsApplicationLoadBalancerLivenessSettings): any;
export declare class DataAkamaiCloudletsApplicationLoadBalancerLivenessSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsApplicationLoadBalancerLivenessSettings | undefined;
    set internalValue(value: DataAkamaiCloudletsApplicationLoadBalancerLivenessSettings | undefined);
    private _additionalHeaders;
    get additionalHeaders(): cdktf.StringMap;
    get hostHeader(): string;
    get interval(): number;
    get path(): string;
    get peerCertificateVerification(): cdktf.IResolvable;
    get port(): number;
    get protocol(): string;
    get requestString(): string;
    get responseString(): string;
    get status3XxFailure(): cdktf.IResolvable;
    get status4XxFailure(): cdktf.IResolvable;
    get status5XxFailure(): cdktf.IResolvable;
    get timeout(): number;
}
export declare class DataAkamaiCloudletsApplicationLoadBalancerLivenessSettingsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsApplicationLoadBalancerLivenessSettingsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_application_load_balancer akamai_cloudlets_application_load_balancer}
*/
export declare class DataAkamaiCloudletsApplicationLoadBalancer extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudlets_application_load_balancer";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudletsApplicationLoadBalancer resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudletsApplicationLoadBalancer to import
    * @param importFromId The id of the existing DataAkamaiCloudletsApplicationLoadBalancer that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_application_load_balancer#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudletsApplicationLoadBalancer to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_application_load_balancer akamai_cloudlets_application_load_balancer} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudletsApplicationLoadBalancerConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCloudletsApplicationLoadBalancerConfig);
    get balancingType(): string;
    get createdBy(): string;
    get createdDate(): string;
    private _dataCenters;
    get dataCenters(): DataAkamaiCloudletsApplicationLoadBalancerDataCentersList;
    get deleted(): cdktf.IResolvable;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get immutable(): cdktf.IResolvable;
    get lastModifiedBy(): string;
    get lastModifiedDate(): string;
    private _livenessSettings;
    get livenessSettings(): DataAkamaiCloudletsApplicationLoadBalancerLivenessSettingsList;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    get originIdInput(): string | undefined;
    get type(): string;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    get warnings(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
