import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudletsAudienceSegmentationMatchRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#id DataAkamaiCloudletsAudienceSegmentationMatchRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * match_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#match_rules DataAkamaiCloudletsAudienceSegmentationMatchRule#match_rules}
    */
    readonly matchRules?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettings {
    /**
    * The ID of the Conditional Origin requests are forwarded to
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#origin_id DataAkamaiCloudletsAudienceSegmentationMatchRule#origin_id}
    */
    readonly originId?: string;
    /**
    * If a value is provided and match conditions are met, this property defines the path/resource/query string to rewrite URL for the incoming request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#path_and_qs DataAkamaiCloudletsAudienceSegmentationMatchRule#path_and_qs}
    */
    readonly pathAndQs?: string;
    /**
    * If set to true, the Cloudlet includes the query string from the request in the rewritten or forwarded URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#use_incoming_query_string DataAkamaiCloudletsAudienceSegmentationMatchRule#use_incoming_query_string}
    */
    readonly useIncomingQueryString?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettingsToTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettingsOutputReference | DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettings): any;
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettingsToHclTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettingsOutputReference | DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettings): any;
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettings | undefined;
    set internalValue(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettings | undefined);
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _pathAndQs?;
    get pathAndQs(): string;
    set pathAndQs(value: string);
    resetPathAndQs(): void;
    get pathAndQsInput(): string | undefined;
    private _useIncomingQueryString?;
    get useIncomingQueryString(): boolean | cdktf.IResolvable;
    set useIncomingQueryString(value: boolean | cdktf.IResolvable);
    resetUseIncomingQueryString(): void;
    get useIncomingQueryStringInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptions {
    /**
    * The value attributes in the incoming request to match on
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#value DataAkamaiCloudletsAudienceSegmentationMatchRule#value}
    */
    readonly value?: string[];
    /**
    * Set to true if the entries for the value property should be evaluated based on case sensitivity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#value_case_sensitive DataAkamaiCloudletsAudienceSegmentationMatchRule#value_case_sensitive}
    */
    readonly valueCaseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Set to true if provided value should be compared in escaped form
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#value_escaped DataAkamaiCloudletsAudienceSegmentationMatchRule#value_escaped}
    */
    readonly valueEscaped?: boolean | cdktf.IResolvable;
    /**
    * Set to true if the entries for the value property include wildcards
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#value_has_wildcard DataAkamaiCloudletsAudienceSegmentationMatchRule#value_has_wildcard}
    */
    readonly valueHasWildcard?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptionsToTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference | DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptions): any;
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptionsToHclTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference | DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptions): any;
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined;
    set internalValue(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined);
    private _value?;
    get value(): string[];
    set value(value: string[]);
    resetValue(): void;
    get valueInput(): string[] | undefined;
    private _valueCaseSensitive?;
    get valueCaseSensitive(): boolean | cdktf.IResolvable;
    set valueCaseSensitive(value: boolean | cdktf.IResolvable);
    resetValueCaseSensitive(): void;
    get valueCaseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _valueEscaped?;
    get valueEscaped(): boolean | cdktf.IResolvable;
    set valueEscaped(value: boolean | cdktf.IResolvable);
    resetValueEscaped(): void;
    get valueEscapedInput(): boolean | cdktf.IResolvable | undefined;
    private _valueHasWildcard?;
    get valueHasWildcard(): boolean | cdktf.IResolvable;
    set valueHasWildcard(value: boolean | cdktf.IResolvable);
    resetValueHasWildcard(): void;
    get valueHasWildcardInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue {
    /**
    * If using a match type that supports name attributes, enter the value in the incoming request to match on. The following match types support this property: cookie, header, parameter, and query
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#name DataAkamaiCloudletsAudienceSegmentationMatchRule#name}
    */
    readonly name?: string;
    /**
    * Set to true if the entry for the name property should be evaluated based on case sensitivity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#name_case_sensitive DataAkamaiCloudletsAudienceSegmentationMatchRule#name_case_sensitive}
    */
    readonly nameCaseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Set to true if the entry for the name property includes wildcards
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#name_has_wildcard DataAkamaiCloudletsAudienceSegmentationMatchRule#name_has_wildcard}
    */
    readonly nameHasWildcard?: boolean | cdktf.IResolvable;
    /**
    * The array type, which can be one of the following: object or simple or range. Use the simple option when adding only an array of string-based values
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#type DataAkamaiCloudletsAudienceSegmentationMatchRule#type}
    */
    readonly type: string;
    /**
    * The value attributes in the incoming request to match on (use only with simple or range type)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#value DataAkamaiCloudletsAudienceSegmentationMatchRule#value}
    */
    readonly value?: string[];
    /**
    * options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#options DataAkamaiCloudletsAudienceSegmentationMatchRule#options}
    */
    readonly options?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptions;
}
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueToTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueToHclTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _nameCaseSensitive?;
    get nameCaseSensitive(): boolean | cdktf.IResolvable;
    set nameCaseSensitive(value: boolean | cdktf.IResolvable);
    resetNameCaseSensitive(): void;
    get nameCaseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _nameHasWildcard?;
    get nameHasWildcard(): boolean | cdktf.IResolvable;
    set nameHasWildcard(value: boolean | cdktf.IResolvable);
    resetNameHasWildcard(): void;
    get nameHasWildcardInput(): boolean | cdktf.IResolvable | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _value?;
    get value(): string[];
    set value(value: string[]);
    resetValue(): void;
    get valueInput(): string[] | undefined;
    private _options;
    get options(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference;
    putOptions(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptions): void;
    resetOptions(): void;
    get optionsInput(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined;
}
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueOutputReference;
}
export interface DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches {
    /**
    * If true, the match is case sensitive
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#case_sensitive DataAkamaiCloudletsAudienceSegmentationMatchRule#case_sensitive}
    */
    readonly caseSensitive?: boolean | cdktf.IResolvable;
    /**
    * For clientip, continent, countrycode, proxy, and regioncode match types, the part of the request that determines the IP address to use
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#check_ips DataAkamaiCloudletsAudienceSegmentationMatchRule#check_ips}
    */
    readonly checkIps?: string;
    /**
    * Valid entries for this property: contains, exists, and equals
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#match_operator DataAkamaiCloudletsAudienceSegmentationMatchRule#match_operator}
    */
    readonly matchOperator?: string;
    /**
    * The type of match used
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#match_type DataAkamaiCloudletsAudienceSegmentationMatchRule#match_type}
    */
    readonly matchType?: string;
    /**
    * Depends on the matchType
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#match_value DataAkamaiCloudletsAudienceSegmentationMatchRule#match_value}
    */
    readonly matchValue?: string;
    /**
    * If true, negates the match
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#negate DataAkamaiCloudletsAudienceSegmentationMatchRule#negate}
    */
    readonly negate?: boolean | cdktf.IResolvable;
    /**
    * object_match_value block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#object_match_value DataAkamaiCloudletsAudienceSegmentationMatchRule#object_match_value}
    */
    readonly objectMatchValue?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesToTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesToHclTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches | cdktf.IResolvable | undefined);
    private _caseSensitive?;
    get caseSensitive(): boolean | cdktf.IResolvable;
    set caseSensitive(value: boolean | cdktf.IResolvable);
    resetCaseSensitive(): void;
    get caseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _checkIps?;
    get checkIps(): string;
    set checkIps(value: string);
    resetCheckIps(): void;
    get checkIpsInput(): string | undefined;
    private _matchOperator?;
    get matchOperator(): string;
    set matchOperator(value: string);
    resetMatchOperator(): void;
    get matchOperatorInput(): string | undefined;
    private _matchType?;
    get matchType(): string;
    set matchType(value: string);
    resetMatchType(): void;
    get matchTypeInput(): string | undefined;
    private _matchValue?;
    get matchValue(): string;
    set matchValue(value: string);
    resetMatchValue(): void;
    get matchValueInput(): string | undefined;
    private _negate?;
    get negate(): boolean | cdktf.IResolvable;
    set negate(value: boolean | cdktf.IResolvable);
    resetNegate(): void;
    get negateInput(): boolean | cdktf.IResolvable | undefined;
    private _objectMatchValue;
    get objectMatchValue(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValueList;
    putObjectMatchValue(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable): void;
    resetObjectMatchValue(): void;
    get objectMatchValueInput(): cdktf.IResolvable | DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesObjectMatchValue[] | undefined;
}
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesOutputReference;
}
export interface DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules {
    /**
    * If set to true, disables a rule so it is not evaluated against incoming requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#disabled DataAkamaiCloudletsAudienceSegmentationMatchRule#disabled}
    */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
    * The end time for this match (in seconds since the epoch)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#end DataAkamaiCloudletsAudienceSegmentationMatchRule#end}
    */
    readonly end?: number;
    /**
    * If using a URL match, this property is the URL that the Cloudlet uses to match the incoming request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#match_url DataAkamaiCloudletsAudienceSegmentationMatchRule#match_url}
    */
    readonly matchUrl?: string;
    /**
    * The name of the rule
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#name DataAkamaiCloudletsAudienceSegmentationMatchRule#name}
    */
    readonly name?: string;
    /**
    * The start time for this match (in seconds since the epoch)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#start DataAkamaiCloudletsAudienceSegmentationMatchRule#start}
    */
    readonly start?: number;
    /**
    * forward_settings block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#forward_settings DataAkamaiCloudletsAudienceSegmentationMatchRule#forward_settings}
    */
    readonly forwardSettings: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettings;
    /**
    * matches block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#matches DataAkamaiCloudletsAudienceSegmentationMatchRule#matches}
    */
    readonly matches?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesToTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesToHclTerraform(struct?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules | cdktf.IResolvable | undefined);
    private _disabled?;
    get disabled(): boolean | cdktf.IResolvable;
    set disabled(value: boolean | cdktf.IResolvable);
    resetDisabled(): void;
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    private _end?;
    get end(): number;
    set end(value: number);
    resetEnd(): void;
    get endInput(): number | undefined;
    private _matchUrl?;
    get matchUrl(): string;
    set matchUrl(value: string);
    resetMatchUrl(): void;
    get matchUrlInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _start?;
    get start(): number;
    set start(value: number);
    resetStart(): void;
    get startInput(): number | undefined;
    get type(): string;
    private _forwardSettings;
    get forwardSettings(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettingsOutputReference;
    putForwardSettings(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettings): void;
    get forwardSettingsInput(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesForwardSettings | undefined;
    private _matches;
    get matches(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatchesList;
    putMatches(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches[] | cdktf.IResolvable): void;
    resetMatches(): void;
    get matchesInput(): cdktf.IResolvable | DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesMatches[] | undefined;
}
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule akamai_cloudlets_audience_segmentation_match_rule}
*/
export declare class DataAkamaiCloudletsAudienceSegmentationMatchRule extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudlets_audience_segmentation_match_rule";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudletsAudienceSegmentationMatchRule resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudletsAudienceSegmentationMatchRule to import
    * @param importFromId The id of the existing DataAkamaiCloudletsAudienceSegmentationMatchRule that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudletsAudienceSegmentationMatchRule to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_audience_segmentation_match_rule akamai_cloudlets_audience_segmentation_match_rule} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudletsAudienceSegmentationMatchRuleConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiCloudletsAudienceSegmentationMatchRuleConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _matchRules;
    get matchRules(): DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRulesList;
    putMatchRules(value: DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules[] | cdktf.IResolvable): void;
    resetMatchRules(): void;
    get matchRulesInput(): cdktf.IResolvable | DataAkamaiCloudletsAudienceSegmentationMatchRuleMatchRules[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
