import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudletsPhasedReleaseMatchRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#id DataAkamaiCloudletsPhasedReleaseMatchRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * match_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#match_rules DataAkamaiCloudletsPhasedReleaseMatchRule#match_rules}
    */
    readonly matchRules?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettings {
    /**
    * The ID of the Conditional Origin requests are forwarded to
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#origin_id DataAkamaiCloudletsPhasedReleaseMatchRule#origin_id}
    */
    readonly originId: string;
    /**
    * The percent of traffic that is sent to the data center.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#percent DataAkamaiCloudletsPhasedReleaseMatchRule#percent}
    */
    readonly percent: number;
}
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettingsToTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettingsOutputReference | DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettings): any;
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettingsToHclTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettingsOutputReference | DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettings): any;
export declare class DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettings | undefined;
    set internalValue(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettings | undefined);
    private _originId?;
    get originId(): string;
    set originId(value: string);
    get originIdInput(): string | undefined;
    private _percent?;
    get percent(): number;
    set percent(value: number);
    get percentInput(): number | undefined;
}
export interface DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptions {
    /**
    * The value attributes in the incoming request to match on
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#value DataAkamaiCloudletsPhasedReleaseMatchRule#value}
    */
    readonly value?: string[];
    /**
    * Set to true if the entries for the value property should be evaluated based on case sensitivity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#value_case_sensitive DataAkamaiCloudletsPhasedReleaseMatchRule#value_case_sensitive}
    */
    readonly valueCaseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Set to true if provided value should be compared in escaped form
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#value_escaped DataAkamaiCloudletsPhasedReleaseMatchRule#value_escaped}
    */
    readonly valueEscaped?: boolean | cdktf.IResolvable;
    /**
    * Set to true if the entries for the value property include wildcards
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#value_has_wildcard DataAkamaiCloudletsPhasedReleaseMatchRule#value_has_wildcard}
    */
    readonly valueHasWildcard?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptionsToTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference | DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptions): any;
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptionsToHclTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference | DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptions): any;
export declare class DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined;
    set internalValue(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined);
    private _value?;
    get value(): string[];
    set value(value: string[]);
    resetValue(): void;
    get valueInput(): string[] | undefined;
    private _valueCaseSensitive?;
    get valueCaseSensitive(): boolean | cdktf.IResolvable;
    set valueCaseSensitive(value: boolean | cdktf.IResolvable);
    resetValueCaseSensitive(): void;
    get valueCaseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _valueEscaped?;
    get valueEscaped(): boolean | cdktf.IResolvable;
    set valueEscaped(value: boolean | cdktf.IResolvable);
    resetValueEscaped(): void;
    get valueEscapedInput(): boolean | cdktf.IResolvable | undefined;
    private _valueHasWildcard?;
    get valueHasWildcard(): boolean | cdktf.IResolvable;
    set valueHasWildcard(value: boolean | cdktf.IResolvable);
    resetValueHasWildcard(): void;
    get valueHasWildcardInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue {
    /**
    * If using a match type that supports name attributes, enter the value in the incoming request to match on. The following match types support this property: cookie, header, parameter, and query
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#name DataAkamaiCloudletsPhasedReleaseMatchRule#name}
    */
    readonly name?: string;
    /**
    * Set to true if the entry for the name property should be evaluated based on case sensitivity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#name_case_sensitive DataAkamaiCloudletsPhasedReleaseMatchRule#name_case_sensitive}
    */
    readonly nameCaseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Set to true if the entry for the name property includes wildcards
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#name_has_wildcard DataAkamaiCloudletsPhasedReleaseMatchRule#name_has_wildcard}
    */
    readonly nameHasWildcard?: boolean | cdktf.IResolvable;
    /**
    * The array type, which can be one of the following: object or simple. Use the simple option when adding only an array of string-based values
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#type DataAkamaiCloudletsPhasedReleaseMatchRule#type}
    */
    readonly type: string;
    /**
    * The value attributes in the incoming request to match on (use only with simple or range type)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#value DataAkamaiCloudletsPhasedReleaseMatchRule#value}
    */
    readonly value?: string[];
    /**
    * options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#options DataAkamaiCloudletsPhasedReleaseMatchRule#options}
    */
    readonly options?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptions;
}
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueToTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueToHclTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _nameCaseSensitive?;
    get nameCaseSensitive(): boolean | cdktf.IResolvable;
    set nameCaseSensitive(value: boolean | cdktf.IResolvable);
    resetNameCaseSensitive(): void;
    get nameCaseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _nameHasWildcard?;
    get nameHasWildcard(): boolean | cdktf.IResolvable;
    set nameHasWildcard(value: boolean | cdktf.IResolvable);
    resetNameHasWildcard(): void;
    get nameHasWildcardInput(): boolean | cdktf.IResolvable | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _value?;
    get value(): string[];
    set value(value: string[]);
    resetValue(): void;
    get valueInput(): string[] | undefined;
    private _options;
    get options(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference;
    putOptions(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptions): void;
    resetOptions(): void;
    get optionsInput(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined;
}
export declare class DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueOutputReference;
}
export interface DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches {
    /**
    * If true, the match is case sensitive
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#case_sensitive DataAkamaiCloudletsPhasedReleaseMatchRule#case_sensitive}
    */
    readonly caseSensitive?: boolean | cdktf.IResolvable;
    /**
    * For clientip, continent, countrycode, proxy, and regioncode match types, the part of the request that determines the IP address to use
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#check_ips DataAkamaiCloudletsPhasedReleaseMatchRule#check_ips}
    */
    readonly checkIps?: string;
    /**
    * Valid entries for this property: contains, exists, and equals
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#match_operator DataAkamaiCloudletsPhasedReleaseMatchRule#match_operator}
    */
    readonly matchOperator?: string;
    /**
    * The type of match used
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#match_type DataAkamaiCloudletsPhasedReleaseMatchRule#match_type}
    */
    readonly matchType?: string;
    /**
    * Depends on the matchType
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#match_value DataAkamaiCloudletsPhasedReleaseMatchRule#match_value}
    */
    readonly matchValue?: string;
    /**
    * If true, negates the match
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#negate DataAkamaiCloudletsPhasedReleaseMatchRule#negate}
    */
    readonly negate?: boolean | cdktf.IResolvable;
    /**
    * object_match_value block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#object_match_value DataAkamaiCloudletsPhasedReleaseMatchRule#object_match_value}
    */
    readonly objectMatchValue?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesToTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesToHclTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches | cdktf.IResolvable | undefined);
    private _caseSensitive?;
    get caseSensitive(): boolean | cdktf.IResolvable;
    set caseSensitive(value: boolean | cdktf.IResolvable);
    resetCaseSensitive(): void;
    get caseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _checkIps?;
    get checkIps(): string;
    set checkIps(value: string);
    resetCheckIps(): void;
    get checkIpsInput(): string | undefined;
    private _matchOperator?;
    get matchOperator(): string;
    set matchOperator(value: string);
    resetMatchOperator(): void;
    get matchOperatorInput(): string | undefined;
    private _matchType?;
    get matchType(): string;
    set matchType(value: string);
    resetMatchType(): void;
    get matchTypeInput(): string | undefined;
    private _matchValue?;
    get matchValue(): string;
    set matchValue(value: string);
    resetMatchValue(): void;
    get matchValueInput(): string | undefined;
    private _negate?;
    get negate(): boolean | cdktf.IResolvable;
    set negate(value: boolean | cdktf.IResolvable);
    resetNegate(): void;
    get negateInput(): boolean | cdktf.IResolvable | undefined;
    private _objectMatchValue;
    get objectMatchValue(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValueList;
    putObjectMatchValue(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable): void;
    resetObjectMatchValue(): void;
    get objectMatchValueInput(): cdktf.IResolvable | DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesObjectMatchValue[] | undefined;
}
export declare class DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesOutputReference;
}
export interface DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules {
    /**
    * If set to true, disables a rule so it is not evaluated against incoming requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#disabled DataAkamaiCloudletsPhasedReleaseMatchRule#disabled}
    */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
    * The end time for this match (in seconds since the epoch)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#end DataAkamaiCloudletsPhasedReleaseMatchRule#end}
    */
    readonly end?: number;
    /**
    * If using a URL match, this property is the URL that the Cloudlet uses to match the incoming request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#match_url DataAkamaiCloudletsPhasedReleaseMatchRule#match_url}
    */
    readonly matchUrl?: string;
    /**
    * Is used in some cloudlets to support default rules (rule that is always matched)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#matches_always DataAkamaiCloudletsPhasedReleaseMatchRule#matches_always}
    */
    readonly matchesAlways?: boolean | cdktf.IResolvable;
    /**
    * The name of the rule
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#name DataAkamaiCloudletsPhasedReleaseMatchRule#name}
    */
    readonly name?: string;
    /**
    * The start time for this match (in seconds since the epoch)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#start DataAkamaiCloudletsPhasedReleaseMatchRule#start}
    */
    readonly start?: number;
    /**
    * forward_settings block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#forward_settings DataAkamaiCloudletsPhasedReleaseMatchRule#forward_settings}
    */
    readonly forwardSettings: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettings;
    /**
    * matches block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#matches DataAkamaiCloudletsPhasedReleaseMatchRule#matches}
    */
    readonly matches?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesToTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesToHclTerraform(struct?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules | cdktf.IResolvable | undefined);
    private _disabled?;
    get disabled(): boolean | cdktf.IResolvable;
    set disabled(value: boolean | cdktf.IResolvable);
    resetDisabled(): void;
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    private _end?;
    get end(): number;
    set end(value: number);
    resetEnd(): void;
    get endInput(): number | undefined;
    private _matchUrl?;
    get matchUrl(): string;
    set matchUrl(value: string);
    resetMatchUrl(): void;
    get matchUrlInput(): string | undefined;
    private _matchesAlways?;
    get matchesAlways(): boolean | cdktf.IResolvable;
    set matchesAlways(value: boolean | cdktf.IResolvable);
    resetMatchesAlways(): void;
    get matchesAlwaysInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _start?;
    get start(): number;
    set start(value: number);
    resetStart(): void;
    get startInput(): number | undefined;
    get type(): string;
    private _forwardSettings;
    get forwardSettings(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettingsOutputReference;
    putForwardSettings(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettings): void;
    get forwardSettingsInput(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesForwardSettings | undefined;
    private _matches;
    get matches(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatchesList;
    putMatches(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches[] | cdktf.IResolvable): void;
    resetMatches(): void;
    get matchesInput(): cdktf.IResolvable | DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesMatches[] | undefined;
}
export declare class DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule akamai_cloudlets_phased_release_match_rule}
*/
export declare class DataAkamaiCloudletsPhasedReleaseMatchRule extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudlets_phased_release_match_rule";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudletsPhasedReleaseMatchRule resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudletsPhasedReleaseMatchRule to import
    * @param importFromId The id of the existing DataAkamaiCloudletsPhasedReleaseMatchRule that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudletsPhasedReleaseMatchRule to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_phased_release_match_rule akamai_cloudlets_phased_release_match_rule} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudletsPhasedReleaseMatchRuleConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiCloudletsPhasedReleaseMatchRuleConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _matchRules;
    get matchRules(): DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRulesList;
    putMatchRules(value: DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules[] | cdktf.IResolvable): void;
    resetMatchRules(): void;
    get matchRulesInput(): cdktf.IResolvable | DataAkamaiCloudletsPhasedReleaseMatchRuleMatchRules[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
