import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudletsPolicyActivationConfig extends cdktf.TerraformMetaArguments {
    /**
    * List of associated properties for non-shared cloudlets activation policy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy_activation#associated_properties DataAkamaiCloudletsPolicyActivation#associated_properties}
    */
    readonly associatedProperties?: string[];
    /**
    * The networks where you can get activated policy version (options are Staging and Production).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy_activation#network DataAkamaiCloudletsPolicyActivation#network}
    */
    readonly network: string;
    /**
    * Identifies the policy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy_activation#policy_id DataAkamaiCloudletsPolicyActivation#policy_id}
    */
    readonly policyId: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy_activation akamai_cloudlets_policy_activation}
*/
export declare class DataAkamaiCloudletsPolicyActivation extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudlets_policy_activation";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudletsPolicyActivation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudletsPolicyActivation to import
    * @param importFromId The id of the existing DataAkamaiCloudletsPolicyActivation that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy_activation#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudletsPolicyActivation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy_activation akamai_cloudlets_policy_activation} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudletsPolicyActivationConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCloudletsPolicyActivationConfig);
    private _associatedProperties?;
    get associatedProperties(): string[];
    set associatedProperties(value: string[]);
    resetAssociatedProperties(): void;
    get associatedPropertiesInput(): string[] | undefined;
    get id(): string;
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
    private _policyId?;
    get policyId(): number;
    set policyId(value: number);
    get policyIdInput(): number | undefined;
    get status(): string;
    get version(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
