import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudletsPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy#id DataAkamaiCloudletsPolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * An integer ID that is associated with a policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy#policy_id DataAkamaiCloudletsPolicy#policy_id}
    */
    readonly policyId: number;
    /**
    * The version number of the policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy#version DataAkamaiCloudletsPolicy#version}
    */
    readonly version?: number;
}
export interface DataAkamaiCloudletsPolicyActivationsPolicyInfo {
}
export declare function dataAkamaiCloudletsPolicyActivationsPolicyInfoToTerraform(struct?: DataAkamaiCloudletsPolicyActivationsPolicyInfo): any;
export declare function dataAkamaiCloudletsPolicyActivationsPolicyInfoToHclTerraform(struct?: DataAkamaiCloudletsPolicyActivationsPolicyInfo): any;
export declare class DataAkamaiCloudletsPolicyActivationsPolicyInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsPolicyActivationsPolicyInfo | undefined;
    set internalValue(value: DataAkamaiCloudletsPolicyActivationsPolicyInfo | undefined);
    get activatedBy(): string;
    get activationDate(): number;
    get name(): string;
    get policyId(): number;
    get status(): string;
    get statusDetail(): string;
    get version(): number;
}
export declare class DataAkamaiCloudletsPolicyActivationsPolicyInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsPolicyActivationsPolicyInfoOutputReference;
}
export interface DataAkamaiCloudletsPolicyActivationsPropertyInfo {
}
export declare function dataAkamaiCloudletsPolicyActivationsPropertyInfoToTerraform(struct?: DataAkamaiCloudletsPolicyActivationsPropertyInfo): any;
export declare function dataAkamaiCloudletsPolicyActivationsPropertyInfoToHclTerraform(struct?: DataAkamaiCloudletsPolicyActivationsPropertyInfo): any;
export declare class DataAkamaiCloudletsPolicyActivationsPropertyInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsPolicyActivationsPropertyInfo | undefined;
    set internalValue(value: DataAkamaiCloudletsPolicyActivationsPropertyInfo | undefined);
    get activatedBy(): string;
    get activationDate(): number;
    get groupId(): number;
    get name(): string;
    get status(): string;
    get version(): number;
}
export declare class DataAkamaiCloudletsPolicyActivationsPropertyInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsPolicyActivationsPropertyInfoOutputReference;
}
export interface DataAkamaiCloudletsPolicyActivations {
}
export declare function dataAkamaiCloudletsPolicyActivationsToTerraform(struct?: DataAkamaiCloudletsPolicyActivations): any;
export declare function dataAkamaiCloudletsPolicyActivationsToHclTerraform(struct?: DataAkamaiCloudletsPolicyActivations): any;
export declare class DataAkamaiCloudletsPolicyActivationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsPolicyActivations | undefined;
    set internalValue(value: DataAkamaiCloudletsPolicyActivations | undefined);
    get apiVersion(): string;
    get network(): string;
    private _policyInfo;
    get policyInfo(): DataAkamaiCloudletsPolicyActivationsPolicyInfoList;
    private _propertyInfo;
    get propertyInfo(): DataAkamaiCloudletsPolicyActivationsPropertyInfoList;
}
export declare class DataAkamaiCloudletsPolicyActivationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsPolicyActivationsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy akamai_cloudlets_policy}
*/
export declare class DataAkamaiCloudletsPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudlets_policy";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudletsPolicy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudletsPolicy to import
    * @param importFromId The id of the existing DataAkamaiCloudletsPolicy that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudletsPolicy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_policy akamai_cloudlets_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudletsPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCloudletsPolicyConfig);
    private _activations;
    get activations(): DataAkamaiCloudletsPolicyActivationsList;
    get apiVersion(): string;
    get cloudletCode(): string;
    get cloudletId(): number;
    get description(): string;
    get groupId(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get matchRuleFormat(): string;
    get matchRules(): string;
    get name(): string;
    private _policyId?;
    get policyId(): number;
    set policyId(value: number);
    get policyIdInput(): number | undefined;
    get revisionId(): number;
    get rulesLocked(): cdktf.IResolvable;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    get versionDescription(): string;
    get warnings(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
