import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudletsRequestControlMatchRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#id DataAkamaiCloudletsRequestControlMatchRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * match_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#match_rules DataAkamaiCloudletsRequestControlMatchRule#match_rules}
    */
    readonly matchRules?: DataAkamaiCloudletsRequestControlMatchRuleMatchRules[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptions {
    /**
    * The value attributes in the incoming request to match on
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#value DataAkamaiCloudletsRequestControlMatchRule#value}
    */
    readonly value?: string[];
    /**
    * Set to true if the entries for the value property should be evaluated based on case sensitivity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#value_case_sensitive DataAkamaiCloudletsRequestControlMatchRule#value_case_sensitive}
    */
    readonly valueCaseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Set to true if provided value should be compared in escaped form
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#value_escaped DataAkamaiCloudletsRequestControlMatchRule#value_escaped}
    */
    readonly valueEscaped?: boolean | cdktf.IResolvable;
    /**
    * Set to true if the entries for the value property include wildcards
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#value_has_wildcard DataAkamaiCloudletsRequestControlMatchRule#value_has_wildcard}
    */
    readonly valueHasWildcard?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptionsToTerraform(struct?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference | DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptions): any;
export declare function dataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptionsToHclTerraform(struct?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference | DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptions): any;
export declare class DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined;
    set internalValue(value: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined);
    private _value?;
    get value(): string[];
    set value(value: string[]);
    resetValue(): void;
    get valueInput(): string[] | undefined;
    private _valueCaseSensitive?;
    get valueCaseSensitive(): boolean | cdktf.IResolvable;
    set valueCaseSensitive(value: boolean | cdktf.IResolvable);
    resetValueCaseSensitive(): void;
    get valueCaseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _valueEscaped?;
    get valueEscaped(): boolean | cdktf.IResolvable;
    set valueEscaped(value: boolean | cdktf.IResolvable);
    resetValueEscaped(): void;
    get valueEscapedInput(): boolean | cdktf.IResolvable | undefined;
    private _valueHasWildcard?;
    get valueHasWildcard(): boolean | cdktf.IResolvable;
    set valueHasWildcard(value: boolean | cdktf.IResolvable);
    resetValueHasWildcard(): void;
    get valueHasWildcardInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue {
    /**
    * If using a match type that supports name attributes, enter the value in the incoming request to match on. The following match types support this property: cookie, header, parameter, and query
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#name DataAkamaiCloudletsRequestControlMatchRule#name}
    */
    readonly name?: string;
    /**
    * Set to true if the entry for the name property should be evaluated based on case sensitivity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#name_case_sensitive DataAkamaiCloudletsRequestControlMatchRule#name_case_sensitive}
    */
    readonly nameCaseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Set to true if the entry for the name property includes wildcards
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#name_has_wildcard DataAkamaiCloudletsRequestControlMatchRule#name_has_wildcard}
    */
    readonly nameHasWildcard?: boolean | cdktf.IResolvable;
    /**
    * The array type, which can be one of the following: object or simple. Use the simple option when adding only an array of string-based values
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#type DataAkamaiCloudletsRequestControlMatchRule#type}
    */
    readonly type: string;
    /**
    * The value attributes in the incoming request to match on (use only with simple type)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#value DataAkamaiCloudletsRequestControlMatchRule#value}
    */
    readonly value?: string[];
    /**
    * options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#options DataAkamaiCloudletsRequestControlMatchRule#options}
    */
    readonly options?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptions;
}
export declare function dataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueToTerraform(struct?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueToHclTerraform(struct?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _nameCaseSensitive?;
    get nameCaseSensitive(): boolean | cdktf.IResolvable;
    set nameCaseSensitive(value: boolean | cdktf.IResolvable);
    resetNameCaseSensitive(): void;
    get nameCaseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _nameHasWildcard?;
    get nameHasWildcard(): boolean | cdktf.IResolvable;
    set nameHasWildcard(value: boolean | cdktf.IResolvable);
    resetNameHasWildcard(): void;
    get nameHasWildcardInput(): boolean | cdktf.IResolvable | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _value?;
    get value(): string[];
    set value(value: string[]);
    resetValue(): void;
    get valueInput(): string[] | undefined;
    private _options;
    get options(): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference;
    putOptions(value: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptions): void;
    resetOptions(): void;
    get optionsInput(): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined;
}
export declare class DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueOutputReference;
}
export interface DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches {
    /**
    * If true, the match is case sensitive
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#case_sensitive DataAkamaiCloudletsRequestControlMatchRule#case_sensitive}
    */
    readonly caseSensitive?: boolean | cdktf.IResolvable;
    /**
    * For clientip, continent, countrycode, proxy, and regioncode match types, the part of the request that determines the IP address to use
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#check_ips DataAkamaiCloudletsRequestControlMatchRule#check_ips}
    */
    readonly checkIps?: string;
    /**
    * Valid entries for this property: contains, exists, and equals
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#match_operator DataAkamaiCloudletsRequestControlMatchRule#match_operator}
    */
    readonly matchOperator?: string;
    /**
    * The type of match used
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#match_type DataAkamaiCloudletsRequestControlMatchRule#match_type}
    */
    readonly matchType?: string;
    /**
    * Depends on the matchType
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#match_value DataAkamaiCloudletsRequestControlMatchRule#match_value}
    */
    readonly matchValue?: string;
    /**
    * If true, negates the match
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#negate DataAkamaiCloudletsRequestControlMatchRule#negate}
    */
    readonly negate?: boolean | cdktf.IResolvable;
    /**
    * object_match_value block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#object_match_value DataAkamaiCloudletsRequestControlMatchRule#object_match_value}
    */
    readonly objectMatchValue?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesToTerraform(struct?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesToHclTerraform(struct?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches | cdktf.IResolvable | undefined);
    private _caseSensitive?;
    get caseSensitive(): boolean | cdktf.IResolvable;
    set caseSensitive(value: boolean | cdktf.IResolvable);
    resetCaseSensitive(): void;
    get caseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _checkIps?;
    get checkIps(): string;
    set checkIps(value: string);
    resetCheckIps(): void;
    get checkIpsInput(): string | undefined;
    private _matchOperator?;
    get matchOperator(): string;
    set matchOperator(value: string);
    resetMatchOperator(): void;
    get matchOperatorInput(): string | undefined;
    private _matchType?;
    get matchType(): string;
    set matchType(value: string);
    resetMatchType(): void;
    get matchTypeInput(): string | undefined;
    private _matchValue?;
    get matchValue(): string;
    set matchValue(value: string);
    resetMatchValue(): void;
    get matchValueInput(): string | undefined;
    private _negate?;
    get negate(): boolean | cdktf.IResolvable;
    set negate(value: boolean | cdktf.IResolvable);
    resetNegate(): void;
    get negateInput(): boolean | cdktf.IResolvable | undefined;
    private _objectMatchValue;
    get objectMatchValue(): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValueList;
    putObjectMatchValue(value: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable): void;
    resetObjectMatchValue(): void;
    get objectMatchValueInput(): cdktf.IResolvable | DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesObjectMatchValue[] | undefined;
}
export declare class DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesOutputReference;
}
export interface DataAkamaiCloudletsRequestControlMatchRuleMatchRules {
    /**
    * If set to allow, the request is sent to origin when all conditions are true. If deny, the request is denied when all conditions are true. If denybranded, the request is denied and rerouted according to the configuration of the Request Control behavior
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#allow_deny DataAkamaiCloudletsRequestControlMatchRule#allow_deny}
    */
    readonly allowDeny: string;
    /**
    * If set to true, disables a rule so it is not evaluated against incoming requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#disabled DataAkamaiCloudletsRequestControlMatchRule#disabled}
    */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
    * The end time for this match (in seconds since the epoch)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#end DataAkamaiCloudletsRequestControlMatchRule#end}
    */
    readonly end?: number;
    /**
    * Is used in some cloudlets to support default rules (rule that is always matched)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#matches_always DataAkamaiCloudletsRequestControlMatchRule#matches_always}
    */
    readonly matchesAlways?: boolean | cdktf.IResolvable;
    /**
    * The name of the rule
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#name DataAkamaiCloudletsRequestControlMatchRule#name}
    */
    readonly name?: string;
    /**
    * The start time for this match (in seconds since the epoch)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#start DataAkamaiCloudletsRequestControlMatchRule#start}
    */
    readonly start?: number;
    /**
    * matches block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#matches DataAkamaiCloudletsRequestControlMatchRule#matches}
    */
    readonly matches?: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsRequestControlMatchRuleMatchRulesToTerraform(struct?: DataAkamaiCloudletsRequestControlMatchRuleMatchRules | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsRequestControlMatchRuleMatchRulesToHclTerraform(struct?: DataAkamaiCloudletsRequestControlMatchRuleMatchRules | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsRequestControlMatchRuleMatchRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsRequestControlMatchRuleMatchRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsRequestControlMatchRuleMatchRules | cdktf.IResolvable | undefined);
    private _allowDeny?;
    get allowDeny(): string;
    set allowDeny(value: string);
    get allowDenyInput(): string | undefined;
    private _disabled?;
    get disabled(): boolean | cdktf.IResolvable;
    set disabled(value: boolean | cdktf.IResolvable);
    resetDisabled(): void;
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    private _end?;
    get end(): number;
    set end(value: number);
    resetEnd(): void;
    get endInput(): number | undefined;
    private _matchesAlways?;
    get matchesAlways(): boolean | cdktf.IResolvable;
    set matchesAlways(value: boolean | cdktf.IResolvable);
    resetMatchesAlways(): void;
    get matchesAlwaysInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _start?;
    get start(): number;
    set start(value: number);
    resetStart(): void;
    get startInput(): number | undefined;
    get type(): string;
    private _matches;
    get matches(): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatchesList;
    putMatches(value: DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches[] | cdktf.IResolvable): void;
    resetMatches(): void;
    get matchesInput(): cdktf.IResolvable | DataAkamaiCloudletsRequestControlMatchRuleMatchRulesMatches[] | undefined;
}
export declare class DataAkamaiCloudletsRequestControlMatchRuleMatchRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsRequestControlMatchRuleMatchRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule akamai_cloudlets_request_control_match_rule}
*/
export declare class DataAkamaiCloudletsRequestControlMatchRule extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudlets_request_control_match_rule";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudletsRequestControlMatchRule resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudletsRequestControlMatchRule to import
    * @param importFromId The id of the existing DataAkamaiCloudletsRequestControlMatchRule that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudletsRequestControlMatchRule to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_request_control_match_rule akamai_cloudlets_request_control_match_rule} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudletsRequestControlMatchRuleConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiCloudletsRequestControlMatchRuleConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _matchRules;
    get matchRules(): DataAkamaiCloudletsRequestControlMatchRuleMatchRulesList;
    putMatchRules(value: DataAkamaiCloudletsRequestControlMatchRuleMatchRules[] | cdktf.IResolvable): void;
    resetMatchRules(): void;
    get matchRulesInput(): cdktf.IResolvable | DataAkamaiCloudletsRequestControlMatchRuleMatchRules[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
