import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudletsSharedPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * An integer ID that is associated with a policy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_shared_policy#policy_id DataAkamaiCloudletsSharedPolicy#policy_id}
    */
    readonly policyId: number;
    /**
    * The number of the policy version.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_shared_policy#version DataAkamaiCloudletsSharedPolicy#version}
    */
    readonly version?: number;
}
export interface DataAkamaiCloudletsSharedPolicyActivationsProductionEffective {
}
export declare function dataAkamaiCloudletsSharedPolicyActivationsProductionEffectiveToTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsProductionEffective | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsSharedPolicyActivationsProductionEffectiveToHclTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsProductionEffective | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsSharedPolicyActivationsProductionEffectiveOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsSharedPolicyActivationsProductionEffective | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsSharedPolicyActivationsProductionEffective | cdktf.IResolvable | undefined);
    get activationId(): number;
    get createdBy(): string;
    get createdDate(): string;
    get finishDate(): string;
    get network(): string;
    get operation(): string;
    get policyId(): number;
    get policyVersion(): number;
    get policyVersionDeleted(): cdktf.IResolvable;
    get status(): string;
}
export interface DataAkamaiCloudletsSharedPolicyActivationsProductionLatest {
}
export declare function dataAkamaiCloudletsSharedPolicyActivationsProductionLatestToTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsProductionLatest | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsSharedPolicyActivationsProductionLatestToHclTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsProductionLatest | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsSharedPolicyActivationsProductionLatestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsSharedPolicyActivationsProductionLatest | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsSharedPolicyActivationsProductionLatest | cdktf.IResolvable | undefined);
    get activationId(): number;
    get createdBy(): string;
    get createdDate(): string;
    get finishDate(): string;
    get network(): string;
    get operation(): string;
    get policyId(): number;
    get policyVersion(): number;
    get policyVersionDeleted(): cdktf.IResolvable;
    get status(): string;
}
export interface DataAkamaiCloudletsSharedPolicyActivationsProduction {
}
export declare function dataAkamaiCloudletsSharedPolicyActivationsProductionToTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsProduction | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsSharedPolicyActivationsProductionToHclTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsProduction | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsSharedPolicyActivationsProductionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsSharedPolicyActivationsProduction | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsSharedPolicyActivationsProduction | cdktf.IResolvable | undefined);
    private _effective;
    get effective(): DataAkamaiCloudletsSharedPolicyActivationsProductionEffectiveOutputReference;
    private _latest;
    get latest(): DataAkamaiCloudletsSharedPolicyActivationsProductionLatestOutputReference;
}
export interface DataAkamaiCloudletsSharedPolicyActivationsStagingEffective {
}
export declare function dataAkamaiCloudletsSharedPolicyActivationsStagingEffectiveToTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsStagingEffective | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsSharedPolicyActivationsStagingEffectiveToHclTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsStagingEffective | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsSharedPolicyActivationsStagingEffectiveOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsSharedPolicyActivationsStagingEffective | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsSharedPolicyActivationsStagingEffective | cdktf.IResolvable | undefined);
    get activationId(): number;
    get createdBy(): string;
    get createdDate(): string;
    get finishDate(): string;
    get network(): string;
    get operation(): string;
    get policyId(): number;
    get policyVersion(): number;
    get policyVersionDeleted(): cdktf.IResolvable;
    get status(): string;
}
export interface DataAkamaiCloudletsSharedPolicyActivationsStagingLatest {
}
export declare function dataAkamaiCloudletsSharedPolicyActivationsStagingLatestToTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsStagingLatest | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsSharedPolicyActivationsStagingLatestToHclTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsStagingLatest | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsSharedPolicyActivationsStagingLatestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsSharedPolicyActivationsStagingLatest | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsSharedPolicyActivationsStagingLatest | cdktf.IResolvable | undefined);
    get activationId(): number;
    get createdBy(): string;
    get createdDate(): string;
    get finishDate(): string;
    get network(): string;
    get operation(): string;
    get policyId(): number;
    get policyVersion(): number;
    get policyVersionDeleted(): cdktf.IResolvable;
    get status(): string;
}
export interface DataAkamaiCloudletsSharedPolicyActivationsStaging {
}
export declare function dataAkamaiCloudletsSharedPolicyActivationsStagingToTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsStaging | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsSharedPolicyActivationsStagingToHclTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivationsStaging | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsSharedPolicyActivationsStagingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsSharedPolicyActivationsStaging | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsSharedPolicyActivationsStaging | cdktf.IResolvable | undefined);
    private _effective;
    get effective(): DataAkamaiCloudletsSharedPolicyActivationsStagingEffectiveOutputReference;
    private _latest;
    get latest(): DataAkamaiCloudletsSharedPolicyActivationsStagingLatestOutputReference;
}
export interface DataAkamaiCloudletsSharedPolicyActivations {
}
export declare function dataAkamaiCloudletsSharedPolicyActivationsToTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivations | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsSharedPolicyActivationsToHclTerraform(struct?: DataAkamaiCloudletsSharedPolicyActivations | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsSharedPolicyActivationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsSharedPolicyActivations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsSharedPolicyActivations | cdktf.IResolvable | undefined);
    private _production;
    get production(): DataAkamaiCloudletsSharedPolicyActivationsProductionOutputReference;
    private _staging;
    get staging(): DataAkamaiCloudletsSharedPolicyActivationsStagingOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_shared_policy akamai_cloudlets_shared_policy}
*/
export declare class DataAkamaiCloudletsSharedPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudlets_shared_policy";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudletsSharedPolicy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudletsSharedPolicy to import
    * @param importFromId The id of the existing DataAkamaiCloudletsSharedPolicy that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_shared_policy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudletsSharedPolicy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_shared_policy akamai_cloudlets_shared_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudletsSharedPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCloudletsSharedPolicyConfig);
    get cloudletType(): string;
    get description(): string;
    get groupId(): number;
    get id(): string;
    get matchRules(): string;
    get name(): string;
    private _policyId?;
    get policyId(): number;
    set policyId(value: number);
    get policyIdInput(): number | undefined;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    get versionDescription(): string;
    get warnings(): string;
    private _activations;
    get activations(): DataAkamaiCloudletsSharedPolicyActivationsOutputReference;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
