import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudletsVisitorPrioritizationMatchRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#id DataAkamaiCloudletsVisitorPrioritizationMatchRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * match_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#match_rules DataAkamaiCloudletsVisitorPrioritizationMatchRule#match_rules}
    */
    readonly matchRules?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptions {
    /**
    * The value attributes in the incoming request to match on
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#value DataAkamaiCloudletsVisitorPrioritizationMatchRule#value}
    */
    readonly value?: string[];
    /**
    * Set to true if the entries for the value property should be evaluated based on case sensitivity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#value_case_sensitive DataAkamaiCloudletsVisitorPrioritizationMatchRule#value_case_sensitive}
    */
    readonly valueCaseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Set to true if provided value should be compared in escaped form
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#value_escaped DataAkamaiCloudletsVisitorPrioritizationMatchRule#value_escaped}
    */
    readonly valueEscaped?: boolean | cdktf.IResolvable;
    /**
    * Set to true if the entries for the value property include wildcards
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#value_has_wildcard DataAkamaiCloudletsVisitorPrioritizationMatchRule#value_has_wildcard}
    */
    readonly valueHasWildcard?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptionsToTerraform(struct?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference | DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptions): any;
export declare function dataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptionsToHclTerraform(struct?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference | DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptions): any;
export declare class DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined;
    set internalValue(value: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined);
    private _value?;
    get value(): string[];
    set value(value: string[]);
    resetValue(): void;
    get valueInput(): string[] | undefined;
    private _valueCaseSensitive?;
    get valueCaseSensitive(): boolean | cdktf.IResolvable;
    set valueCaseSensitive(value: boolean | cdktf.IResolvable);
    resetValueCaseSensitive(): void;
    get valueCaseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _valueEscaped?;
    get valueEscaped(): boolean | cdktf.IResolvable;
    set valueEscaped(value: boolean | cdktf.IResolvable);
    resetValueEscaped(): void;
    get valueEscapedInput(): boolean | cdktf.IResolvable | undefined;
    private _valueHasWildcard?;
    get valueHasWildcard(): boolean | cdktf.IResolvable;
    set valueHasWildcard(value: boolean | cdktf.IResolvable);
    resetValueHasWildcard(): void;
    get valueHasWildcardInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue {
    /**
    * If using a match type that supports name attributes, enter the value in the incoming request to match on. The following match types support this property: cookie, header, parameter, and query
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#name DataAkamaiCloudletsVisitorPrioritizationMatchRule#name}
    */
    readonly name?: string;
    /**
    * Set to true if the entry for the name property should be evaluated based on case sensitivity
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#name_case_sensitive DataAkamaiCloudletsVisitorPrioritizationMatchRule#name_case_sensitive}
    */
    readonly nameCaseSensitive?: boolean | cdktf.IResolvable;
    /**
    * Set to true if the entry for the name property includes wildcards
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#name_has_wildcard DataAkamaiCloudletsVisitorPrioritizationMatchRule#name_has_wildcard}
    */
    readonly nameHasWildcard?: boolean | cdktf.IResolvable;
    /**
    * The array type, which can be one of the following: object or simple. Use the simple option when adding only an array of string-based values
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#type DataAkamaiCloudletsVisitorPrioritizationMatchRule#type}
    */
    readonly type: string;
    /**
    * The value attributes in the incoming request to match on (use only with simple type)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#value DataAkamaiCloudletsVisitorPrioritizationMatchRule#value}
    */
    readonly value?: string[];
    /**
    * options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#options DataAkamaiCloudletsVisitorPrioritizationMatchRule#options}
    */
    readonly options?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptions;
}
export declare function dataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueToTerraform(struct?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueToHclTerraform(struct?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _nameCaseSensitive?;
    get nameCaseSensitive(): boolean | cdktf.IResolvable;
    set nameCaseSensitive(value: boolean | cdktf.IResolvable);
    resetNameCaseSensitive(): void;
    get nameCaseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _nameHasWildcard?;
    get nameHasWildcard(): boolean | cdktf.IResolvable;
    set nameHasWildcard(value: boolean | cdktf.IResolvable);
    resetNameHasWildcard(): void;
    get nameHasWildcardInput(): boolean | cdktf.IResolvable | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _value?;
    get value(): string[];
    set value(value: string[]);
    resetValue(): void;
    get valueInput(): string[] | undefined;
    private _options;
    get options(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptionsOutputReference;
    putOptions(value: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptions): void;
    resetOptions(): void;
    get optionsInput(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOptions | undefined;
}
export declare class DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueOutputReference;
}
export interface DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches {
    /**
    * If true, the match is case sensitive
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#case_sensitive DataAkamaiCloudletsVisitorPrioritizationMatchRule#case_sensitive}
    */
    readonly caseSensitive?: boolean | cdktf.IResolvable;
    /**
    * For clientip, continent, countrycode, proxy, and regioncode match types, the part of the request that determines the IP address to use
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#check_ips DataAkamaiCloudletsVisitorPrioritizationMatchRule#check_ips}
    */
    readonly checkIps?: string;
    /**
    * Valid entries for this property: contains, exists, and equals
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#match_operator DataAkamaiCloudletsVisitorPrioritizationMatchRule#match_operator}
    */
    readonly matchOperator?: string;
    /**
    * The type of match used
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#match_type DataAkamaiCloudletsVisitorPrioritizationMatchRule#match_type}
    */
    readonly matchType?: string;
    /**
    * Depends on the matchType
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#match_value DataAkamaiCloudletsVisitorPrioritizationMatchRule#match_value}
    */
    readonly matchValue?: string;
    /**
    * If true, negates the match
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#negate DataAkamaiCloudletsVisitorPrioritizationMatchRule#negate}
    */
    readonly negate?: boolean | cdktf.IResolvable;
    /**
    * object_match_value block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#object_match_value DataAkamaiCloudletsVisitorPrioritizationMatchRule#object_match_value}
    */
    readonly objectMatchValue?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesToTerraform(struct?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesToHclTerraform(struct?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches | cdktf.IResolvable | undefined);
    private _caseSensitive?;
    get caseSensitive(): boolean | cdktf.IResolvable;
    set caseSensitive(value: boolean | cdktf.IResolvable);
    resetCaseSensitive(): void;
    get caseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
    private _checkIps?;
    get checkIps(): string;
    set checkIps(value: string);
    resetCheckIps(): void;
    get checkIpsInput(): string | undefined;
    private _matchOperator?;
    get matchOperator(): string;
    set matchOperator(value: string);
    resetMatchOperator(): void;
    get matchOperatorInput(): string | undefined;
    private _matchType?;
    get matchType(): string;
    set matchType(value: string);
    resetMatchType(): void;
    get matchTypeInput(): string | undefined;
    private _matchValue?;
    get matchValue(): string;
    set matchValue(value: string);
    resetMatchValue(): void;
    get matchValueInput(): string | undefined;
    private _negate?;
    get negate(): boolean | cdktf.IResolvable;
    set negate(value: boolean | cdktf.IResolvable);
    resetNegate(): void;
    get negateInput(): boolean | cdktf.IResolvable | undefined;
    private _objectMatchValue;
    get objectMatchValue(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValueList;
    putObjectMatchValue(value: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue[] | cdktf.IResolvable): void;
    resetObjectMatchValue(): void;
    get objectMatchValueInput(): cdktf.IResolvable | DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesObjectMatchValue[] | undefined;
}
export declare class DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesOutputReference;
}
export interface DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules {
    /**
    * If set to true, disables a rule so it is not evaluated against incoming requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#disabled DataAkamaiCloudletsVisitorPrioritizationMatchRule#disabled}
    */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
    * The end time for this match (in seconds since the epoch)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#end DataAkamaiCloudletsVisitorPrioritizationMatchRule#end}
    */
    readonly end?: number;
    /**
    * If using a URL match, this property is the URL that the Cloudlet uses to match the incoming request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#match_url DataAkamaiCloudletsVisitorPrioritizationMatchRule#match_url}
    */
    readonly matchUrl?: string;
    /**
    * The name of the rule
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#name DataAkamaiCloudletsVisitorPrioritizationMatchRule#name}
    */
    readonly name?: string;
    /**
    * The range 0.0: 99.0 specifies the percentage of requests that pass through to the origin. The value of 100 means the request always passes through to the origin. A value of -1 means send everyone to the waiting room.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#pass_through_percent DataAkamaiCloudletsVisitorPrioritizationMatchRule#pass_through_percent}
    */
    readonly passThroughPercent: number;
    /**
    * The start time for this match (in seconds since the epoch)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#start DataAkamaiCloudletsVisitorPrioritizationMatchRule#start}
    */
    readonly start?: number;
    /**
    * matches block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#matches DataAkamaiCloudletsVisitorPrioritizationMatchRule#matches}
    */
    readonly matches?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesToTerraform(struct?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules | cdktf.IResolvable): any;
export declare function dataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesToHclTerraform(struct?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules | cdktf.IResolvable): any;
export declare class DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules | cdktf.IResolvable | undefined);
    private _disabled?;
    get disabled(): boolean | cdktf.IResolvable;
    set disabled(value: boolean | cdktf.IResolvable);
    resetDisabled(): void;
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    private _end?;
    get end(): number;
    set end(value: number);
    resetEnd(): void;
    get endInput(): number | undefined;
    private _matchUrl?;
    get matchUrl(): string;
    set matchUrl(value: string);
    resetMatchUrl(): void;
    get matchUrlInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _passThroughPercent?;
    get passThroughPercent(): number;
    set passThroughPercent(value: number);
    get passThroughPercentInput(): number | undefined;
    private _start?;
    get start(): number;
    set start(value: number);
    resetStart(): void;
    get startInput(): number | undefined;
    get type(): string;
    private _matches;
    get matches(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatchesList;
    putMatches(value: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches[] | cdktf.IResolvable): void;
    resetMatches(): void;
    get matchesInput(): cdktf.IResolvable | DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesMatches[] | undefined;
}
export declare class DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule akamai_cloudlets_visitor_prioritization_match_rule}
*/
export declare class DataAkamaiCloudletsVisitorPrioritizationMatchRule extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudlets_visitor_prioritization_match_rule";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudletsVisitorPrioritizationMatchRule resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudletsVisitorPrioritizationMatchRule to import
    * @param importFromId The id of the existing DataAkamaiCloudletsVisitorPrioritizationMatchRule that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudletsVisitorPrioritizationMatchRule to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudlets_visitor_prioritization_match_rule akamai_cloudlets_visitor_prioritization_match_rule} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudletsVisitorPrioritizationMatchRuleConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiCloudletsVisitorPrioritizationMatchRuleConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _matchRules;
    get matchRules(): DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRulesList;
    putMatchRules(value: DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules[] | cdktf.IResolvable): void;
    resetMatchRules(): void;
    get matchRulesInput(): cdktf.IResolvable | DataAkamaiCloudletsVisitorPrioritizationMatchRuleMatchRules[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
