import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudwrapperCapacitiesConfig extends cdktf.TerraformMetaArguments {
    /**
    * List of contract IDs with Cloud Wrapper entitlement.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_capacities#contract_ids DataAkamaiCloudwrapperCapacities#contract_ids}
    */
    readonly contractIds?: string[];
    /**
    * capacities block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_capacities#capacities DataAkamaiCloudwrapperCapacities#capacities}
    */
    readonly capacities?: DataAkamaiCloudwrapperCapacitiesCapacities[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudwrapperCapacitiesCapacitiesApproved {
}
export declare function dataAkamaiCloudwrapperCapacitiesCapacitiesApprovedToTerraform(struct?: DataAkamaiCloudwrapperCapacitiesCapacitiesApproved): any;
export declare function dataAkamaiCloudwrapperCapacitiesCapacitiesApprovedToHclTerraform(struct?: DataAkamaiCloudwrapperCapacitiesCapacitiesApproved): any;
export declare class DataAkamaiCloudwrapperCapacitiesCapacitiesApprovedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperCapacitiesCapacitiesApproved | undefined;
    set internalValue(value: DataAkamaiCloudwrapperCapacitiesCapacitiesApproved | undefined);
    get unit(): string;
    get value(): number;
}
export interface DataAkamaiCloudwrapperCapacitiesCapacitiesAssigned {
}
export declare function dataAkamaiCloudwrapperCapacitiesCapacitiesAssignedToTerraform(struct?: DataAkamaiCloudwrapperCapacitiesCapacitiesAssigned): any;
export declare function dataAkamaiCloudwrapperCapacitiesCapacitiesAssignedToHclTerraform(struct?: DataAkamaiCloudwrapperCapacitiesCapacitiesAssigned): any;
export declare class DataAkamaiCloudwrapperCapacitiesCapacitiesAssignedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperCapacitiesCapacitiesAssigned | undefined;
    set internalValue(value: DataAkamaiCloudwrapperCapacitiesCapacitiesAssigned | undefined);
    get unit(): string;
    get value(): number;
}
export interface DataAkamaiCloudwrapperCapacitiesCapacitiesUnassigned {
}
export declare function dataAkamaiCloudwrapperCapacitiesCapacitiesUnassignedToTerraform(struct?: DataAkamaiCloudwrapperCapacitiesCapacitiesUnassigned): any;
export declare function dataAkamaiCloudwrapperCapacitiesCapacitiesUnassignedToHclTerraform(struct?: DataAkamaiCloudwrapperCapacitiesCapacitiesUnassigned): any;
export declare class DataAkamaiCloudwrapperCapacitiesCapacitiesUnassignedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperCapacitiesCapacitiesUnassigned | undefined;
    set internalValue(value: DataAkamaiCloudwrapperCapacitiesCapacitiesUnassigned | undefined);
    get unit(): string;
    get value(): number;
}
export interface DataAkamaiCloudwrapperCapacitiesCapacities {
}
export declare function dataAkamaiCloudwrapperCapacitiesCapacitiesToTerraform(struct?: DataAkamaiCloudwrapperCapacitiesCapacities | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperCapacitiesCapacitiesToHclTerraform(struct?: DataAkamaiCloudwrapperCapacitiesCapacities | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperCapacitiesCapacitiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperCapacitiesCapacities | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperCapacitiesCapacities | cdktf.IResolvable | undefined);
    private _approved;
    get approved(): DataAkamaiCloudwrapperCapacitiesCapacitiesApprovedOutputReference;
    private _assigned;
    get assigned(): DataAkamaiCloudwrapperCapacitiesCapacitiesAssignedOutputReference;
    get contractId(): string;
    get locationId(): number;
    get locationName(): string;
    get type(): string;
    private _unassigned;
    get unassigned(): DataAkamaiCloudwrapperCapacitiesCapacitiesUnassignedOutputReference;
}
export declare class DataAkamaiCloudwrapperCapacitiesCapacitiesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperCapacitiesCapacities[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperCapacitiesCapacitiesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_capacities akamai_cloudwrapper_capacities}
*/
export declare class DataAkamaiCloudwrapperCapacities extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudwrapper_capacities";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudwrapperCapacities resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudwrapperCapacities to import
    * @param importFromId The id of the existing DataAkamaiCloudwrapperCapacities that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_capacities#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudwrapperCapacities to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_capacities akamai_cloudwrapper_capacities} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudwrapperCapacitiesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiCloudwrapperCapacitiesConfig);
    private _contractIds?;
    get contractIds(): string[];
    set contractIds(value: string[]);
    resetContractIds(): void;
    get contractIdsInput(): string[] | undefined;
    get id(): string;
    private _capacities;
    get capacities(): DataAkamaiCloudwrapperCapacitiesCapacitiesList;
    putCapacities(value: DataAkamaiCloudwrapperCapacitiesCapacities[] | cdktf.IResolvable): void;
    resetCapacities(): void;
    get capacitiesInput(): cdktf.IResolvable | DataAkamaiCloudwrapperCapacitiesCapacities[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
