import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudwrapperConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of a Cloud Wrapper configuration.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configuration#id DataAkamaiCloudwrapperConfiguration#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: number;
    /**
    * locations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configuration#locations DataAkamaiCloudwrapperConfiguration#locations}
    */
    readonly locations?: DataAkamaiCloudwrapperConfigurationLocations[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudwrapperConfigurationLocationsCapacity {
}
export declare function dataAkamaiCloudwrapperConfigurationLocationsCapacityToTerraform(struct?: DataAkamaiCloudwrapperConfigurationLocationsCapacity): any;
export declare function dataAkamaiCloudwrapperConfigurationLocationsCapacityToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationLocationsCapacity): any;
export declare class DataAkamaiCloudwrapperConfigurationLocationsCapacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperConfigurationLocationsCapacity | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationLocationsCapacity | undefined);
    get unit(): string;
    get value(): number;
}
export interface DataAkamaiCloudwrapperConfigurationLocations {
}
export declare function dataAkamaiCloudwrapperConfigurationLocationsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationLocations | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationLocationsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationLocations | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationLocationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationLocations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationLocations | cdktf.IResolvable | undefined);
    private _capacity;
    get capacity(): DataAkamaiCloudwrapperConfigurationLocationsCapacityOutputReference;
    get comments(): string;
    get mapName(): string;
    get trafficTypeId(): number;
}
export declare class DataAkamaiCloudwrapperConfigurationLocationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationLocations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationLocationsOutputReference;
}
export interface DataAkamaiCloudwrapperConfigurationMultiCdnSettingsBocc {
}
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsBoccToTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsBocc | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsBoccToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsBocc | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsBoccOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsBocc | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsBocc | cdktf.IResolvable | undefined);
    get conditionalSamplingFrequency(): string;
    get enabled(): cdktf.IResolvable;
    get forwardType(): string;
    get requestType(): string;
    get samplingFrequency(): string;
}
export interface DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys {
}
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeysToTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeysToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeysOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys | cdktf.IResolvable | undefined);
    get authKeyName(): string;
    get expiryDate(): string;
    get headerName(): string;
    get secret(): string;
}
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeysList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeysOutputReference;
}
export interface DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns {
    /**
    * cdn_auth_keys block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configuration#cdn_auth_keys DataAkamaiCloudwrapperConfiguration#cdn_auth_keys}
    */
    readonly cdnAuthKeys?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns | cdktf.IResolvable | undefined);
    get cdnCode(): string;
    get enabled(): cdktf.IResolvable;
    get httpsOnly(): cdktf.IResolvable;
    get ipAclCidrs(): string[];
    private _cdnAuthKeys;
    get cdnAuthKeys(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeysList;
    putCdnAuthKeys(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys[] | cdktf.IResolvable): void;
    resetCdnAuthKeys(): void;
    get cdnAuthKeysInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsCdnAuthKeys[] | undefined;
}
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsOutputReference;
}
export interface DataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreams {
}
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreamsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreams | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreamsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreams | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreams | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreams | cdktf.IResolvable | undefined);
    get dataStreamIds(): number[];
    get enabled(): cdktf.IResolvable;
    get samplingRate(): number;
}
export interface DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins {
}
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsOriginsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsOriginsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOriginsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins | cdktf.IResolvable | undefined);
    get hostname(): string;
    get originId(): string;
    get propertyId(): number;
}
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOriginsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOriginsOutputReference;
}
export interface DataAkamaiCloudwrapperConfigurationMultiCdnSettings {
    /**
    * cdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configuration#cdns DataAkamaiCloudwrapperConfiguration#cdns}
    */
    readonly cdns?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns[] | cdktf.IResolvable;
    /**
    * origins block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configuration#origins DataAkamaiCloudwrapperConfiguration#origins}
    */
    readonly origins?: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettings | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationMultiCdnSettingsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationMultiCdnSettings | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperConfigurationMultiCdnSettings | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettings | cdktf.IResolvable | undefined);
    get enableSoftAlerts(): cdktf.IResolvable;
    private _bocc;
    get bocc(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsBoccOutputReference;
    private _cdns;
    get cdns(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdnsList;
    putCdns(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns[] | cdktf.IResolvable): void;
    resetCdns(): void;
    get cdnsInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationMultiCdnSettingsCdns[] | undefined;
    private _dataStreams;
    get dataStreams(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsDataStreamsOutputReference;
    private _origins;
    get origins(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOriginsList;
    putOrigins(value: DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins[] | cdktf.IResolvable): void;
    resetOrigins(): void;
    get originsInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOrigins[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configuration akamai_cloudwrapper_configuration}
*/
export declare class DataAkamaiCloudwrapperConfiguration extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudwrapper_configuration";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudwrapperConfiguration resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudwrapperConfiguration to import
    * @param importFromId The id of the existing DataAkamaiCloudwrapperConfiguration that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configuration#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudwrapperConfiguration to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configuration akamai_cloudwrapper_configuration} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudwrapperConfigurationConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCloudwrapperConfigurationConfig);
    get capacityAlertsThreshold(): number;
    get comments(): string;
    get configName(): string;
    get contractId(): string;
    private _id?;
    get id(): number;
    set id(value: number);
    get idInput(): number | undefined;
    get lastActivatedBy(): string;
    get lastActivatedDate(): string;
    get lastUpdatedBy(): string;
    get lastUpdatedDate(): string;
    get notificationEmails(): string[];
    get propertyIds(): string[];
    get retainIdleObjects(): cdktf.IResolvable;
    get status(): string;
    private _locations;
    get locations(): DataAkamaiCloudwrapperConfigurationLocationsList;
    putLocations(value: DataAkamaiCloudwrapperConfigurationLocations[] | cdktf.IResolvable): void;
    resetLocations(): void;
    get locationsInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationLocations[] | undefined;
    private _multiCdnSettings;
    get multiCdnSettings(): DataAkamaiCloudwrapperConfigurationMultiCdnSettingsOutputReference;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
