import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudwrapperConfigurationsConfig extends cdktf.TerraformMetaArguments {
    /**
    * configurations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configurations#configurations DataAkamaiCloudwrapperConfigurations#configurations}
    */
    readonly configurations?: DataAkamaiCloudwrapperConfigurationsConfigurations[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacity {
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacityToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacity): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacityToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacity): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacity | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacity | undefined);
    get unit(): string;
    get value(): number;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurationsLocations {
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsLocationsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsLocations | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsLocationsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsLocations | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurationsLocations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurationsLocations | cdktf.IResolvable | undefined);
    private _capacity;
    get capacity(): DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsCapacityOutputReference;
    get comments(): string;
    get mapName(): string;
    get trafficTypeId(): number;
}
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationsConfigurationsLocations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsOutputReference;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBocc {
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBoccToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBocc | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBoccToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBocc | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBoccOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBocc | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBocc | cdktf.IResolvable | undefined);
    get conditionalSamplingFrequency(): string;
    get enabled(): cdktf.IResolvable;
    get forwardType(): string;
    get requestType(): string;
    get samplingFrequency(): string;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys {
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeysToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeysToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeysOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys | cdktf.IResolvable | undefined);
    get authKeyName(): string;
    get expiryDate(): string;
    get headerName(): string;
    get secret(): string;
}
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeysList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeysOutputReference;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns {
    /**
    * cdn_auth_keys block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configurations#cdn_auth_keys DataAkamaiCloudwrapperConfigurations#cdn_auth_keys}
    */
    readonly cdnAuthKeys?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns | cdktf.IResolvable | undefined);
    get cdnCode(): string;
    get enabled(): cdktf.IResolvable;
    get httpsOnly(): cdktf.IResolvable;
    get ipAclCidrs(): string[];
    private _cdnAuthKeys;
    get cdnAuthKeys(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeysList;
    putCdnAuthKeys(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys[] | cdktf.IResolvable): void;
    resetCdnAuthKeys(): void;
    get cdnAuthKeysInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsCdnAuthKeys[] | undefined;
}
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsOutputReference;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreams {
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreamsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreams | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreamsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreams | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreams | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreams | cdktf.IResolvable | undefined);
    get dataStreamIds(): number[];
    get enabled(): cdktf.IResolvable;
    get samplingRate(): number;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins {
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOriginsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOriginsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOriginsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins | cdktf.IResolvable | undefined);
    get hostname(): string;
    get originId(): string;
    get propertyId(): number;
}
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOriginsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOriginsOutputReference;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettings {
    /**
    * cdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configurations#cdns DataAkamaiCloudwrapperConfigurations#cdns}
    */
    readonly cdns?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns[] | cdktf.IResolvable;
    /**
    * origins block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configurations#origins DataAkamaiCloudwrapperConfigurations#origins}
    */
    readonly origins?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettings | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettings | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettings | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettings | cdktf.IResolvable | undefined);
    get enableSoftAlerts(): cdktf.IResolvable;
    private _bocc;
    get bocc(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsBoccOutputReference;
    private _cdns;
    get cdns(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdnsList;
    putCdns(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns[] | cdktf.IResolvable): void;
    resetCdns(): void;
    get cdnsInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsCdns[] | undefined;
    private _dataStreams;
    get dataStreams(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsDataStreamsOutputReference;
    private _origins;
    get origins(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOriginsList;
    putOrigins(value: DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins[] | cdktf.IResolvable): void;
    resetOrigins(): void;
    get originsInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOrigins[] | undefined;
}
export interface DataAkamaiCloudwrapperConfigurationsConfigurations {
    /**
    * locations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configurations#locations DataAkamaiCloudwrapperConfigurations#locations}
    */
    readonly locations?: DataAkamaiCloudwrapperConfigurationsConfigurationsLocations[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsToTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurations | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperConfigurationsConfigurationsToHclTerraform(struct?: DataAkamaiCloudwrapperConfigurationsConfigurations | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperConfigurationsConfigurations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperConfigurationsConfigurations | cdktf.IResolvable | undefined);
    get capacityAlertsThreshold(): number;
    get comments(): string;
    get configName(): string;
    get contractId(): string;
    get id(): number;
    get lastActivatedBy(): string;
    get lastActivatedDate(): string;
    get lastUpdatedBy(): string;
    get lastUpdatedDate(): string;
    get notificationEmails(): string[];
    get propertyIds(): string[];
    get retainIdleObjects(): cdktf.IResolvable;
    get status(): string;
    private _locations;
    get locations(): DataAkamaiCloudwrapperConfigurationsConfigurationsLocationsList;
    putLocations(value: DataAkamaiCloudwrapperConfigurationsConfigurationsLocations[] | cdktf.IResolvable): void;
    resetLocations(): void;
    get locationsInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationsConfigurationsLocations[] | undefined;
    private _multiCdnSettings;
    get multiCdnSettings(): DataAkamaiCloudwrapperConfigurationsConfigurationsMultiCdnSettingsOutputReference;
}
export declare class DataAkamaiCloudwrapperConfigurationsConfigurationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperConfigurationsConfigurations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperConfigurationsConfigurationsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configurations akamai_cloudwrapper_configurations}
*/
export declare class DataAkamaiCloudwrapperConfigurations extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudwrapper_configurations";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudwrapperConfigurations resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudwrapperConfigurations to import
    * @param importFromId The id of the existing DataAkamaiCloudwrapperConfigurations that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configurations#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudwrapperConfigurations to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_configurations akamai_cloudwrapper_configurations} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudwrapperConfigurationsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiCloudwrapperConfigurationsConfig);
    get id(): string;
    private _configurations;
    get configurations(): DataAkamaiCloudwrapperConfigurationsConfigurationsList;
    putConfigurations(value: DataAkamaiCloudwrapperConfigurationsConfigurations[] | cdktf.IResolvable): void;
    resetConfigurations(): void;
    get configurationsInput(): cdktf.IResolvable | DataAkamaiCloudwrapperConfigurationsConfigurations[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
