import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudwrapperLocationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Name of the location.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_location#location_name DataAkamaiCloudwrapperLocation#location_name}
    */
    readonly locationName: string;
    /**
    * Represents the traffic type. LIVE applies to low-latency media traffic, such as live streaming. LIVE_VOD applies to redundant media traffic, like video on demand content. WEB_STANDARD_TLS or WEB_ENHANCED_TLS applies to web content using Standard TLS security or Enhanced TLS security, respectively.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_location#traffic_type DataAkamaiCloudwrapperLocation#traffic_type}
    */
    readonly trafficType: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_location akamai_cloudwrapper_location}
*/
export declare class DataAkamaiCloudwrapperLocation extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudwrapper_location";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudwrapperLocation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudwrapperLocation to import
    * @param importFromId The id of the existing DataAkamaiCloudwrapperLocation that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_location#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudwrapperLocation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_location akamai_cloudwrapper_location} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudwrapperLocationConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCloudwrapperLocationConfig);
    get id(): string;
    get locationId(): string;
    private _locationName?;
    get locationName(): string;
    set locationName(value: string);
    get locationNameInput(): string | undefined;
    private _trafficType?;
    get trafficType(): string;
    set trafficType(value: string);
    get trafficTypeInput(): string | undefined;
    get trafficTypeId(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
