import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudwrapperLocationsConfig extends cdktf.TerraformMetaArguments {
    /**
    * locations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_locations#locations DataAkamaiCloudwrapperLocations#locations}
    */
    readonly locations?: DataAkamaiCloudwrapperLocationsLocations[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudwrapperLocationsLocationsTrafficTypes {
}
export declare function dataAkamaiCloudwrapperLocationsLocationsTrafficTypesToTerraform(struct?: DataAkamaiCloudwrapperLocationsLocationsTrafficTypes | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperLocationsLocationsTrafficTypesToHclTerraform(struct?: DataAkamaiCloudwrapperLocationsLocationsTrafficTypes | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperLocationsLocationsTrafficTypesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperLocationsLocationsTrafficTypes | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperLocationsLocationsTrafficTypes | cdktf.IResolvable | undefined);
    get locationId(): string;
    get trafficType(): string;
    get trafficTypeId(): number;
}
export declare class DataAkamaiCloudwrapperLocationsLocationsTrafficTypesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperLocationsLocationsTrafficTypes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperLocationsLocationsTrafficTypesOutputReference;
}
export interface DataAkamaiCloudwrapperLocationsLocations {
    /**
    * traffic_types block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_locations#traffic_types DataAkamaiCloudwrapperLocations#traffic_types}
    */
    readonly trafficTypes?: DataAkamaiCloudwrapperLocationsLocationsTrafficTypes[] | cdktf.IResolvable;
}
export declare function dataAkamaiCloudwrapperLocationsLocationsToTerraform(struct?: DataAkamaiCloudwrapperLocationsLocations | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperLocationsLocationsToHclTerraform(struct?: DataAkamaiCloudwrapperLocationsLocations | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperLocationsLocationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperLocationsLocations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperLocationsLocations | cdktf.IResolvable | undefined);
    get locationId(): number;
    get locationName(): string;
    get multiCdnLocationId(): string;
    private _trafficTypes;
    get trafficTypes(): DataAkamaiCloudwrapperLocationsLocationsTrafficTypesList;
    putTrafficTypes(value: DataAkamaiCloudwrapperLocationsLocationsTrafficTypes[] | cdktf.IResolvable): void;
    resetTrafficTypes(): void;
    get trafficTypesInput(): cdktf.IResolvable | DataAkamaiCloudwrapperLocationsLocationsTrafficTypes[] | undefined;
}
export declare class DataAkamaiCloudwrapperLocationsLocationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperLocationsLocations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperLocationsLocationsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_locations akamai_cloudwrapper_locations}
*/
export declare class DataAkamaiCloudwrapperLocations extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudwrapper_locations";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudwrapperLocations resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudwrapperLocations to import
    * @param importFromId The id of the existing DataAkamaiCloudwrapperLocations that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_locations#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudwrapperLocations to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_locations akamai_cloudwrapper_locations} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudwrapperLocationsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiCloudwrapperLocationsConfig);
    get id(): string;
    private _locations;
    get locations(): DataAkamaiCloudwrapperLocationsLocationsList;
    putLocations(value: DataAkamaiCloudwrapperLocationsLocations[] | cdktf.IResolvable): void;
    resetLocations(): void;
    get locationsInput(): cdktf.IResolvable | DataAkamaiCloudwrapperLocationsLocations[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
