import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCloudwrapperPropertiesConfig extends cdktf.TerraformMetaArguments {
    /**
    * List of contract IDs with Cloud Wrapper entitlement.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_properties#contract_ids DataAkamaiCloudwrapperProperties#contract_ids}
    */
    readonly contractIds?: string[];
    /**
    * Specify whether the response should contain only unused properties.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_properties#unused DataAkamaiCloudwrapperProperties#unused}
    */
    readonly unused?: boolean | cdktf.IResolvable;
    /**
    * properties block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_properties#properties DataAkamaiCloudwrapperProperties#properties}
    */
    readonly properties?: DataAkamaiCloudwrapperPropertiesProperties[] | cdktf.IResolvable;
}
export interface DataAkamaiCloudwrapperPropertiesProperties {
}
export declare function dataAkamaiCloudwrapperPropertiesPropertiesToTerraform(struct?: DataAkamaiCloudwrapperPropertiesProperties | cdktf.IResolvable): any;
export declare function dataAkamaiCloudwrapperPropertiesPropertiesToHclTerraform(struct?: DataAkamaiCloudwrapperPropertiesProperties | cdktf.IResolvable): any;
export declare class DataAkamaiCloudwrapperPropertiesPropertiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCloudwrapperPropertiesProperties | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiCloudwrapperPropertiesProperties | cdktf.IResolvable | undefined);
    get contractId(): string;
    get groupId(): number;
    get propertyId(): number;
    get propertyName(): string;
    get type(): string;
}
export declare class DataAkamaiCloudwrapperPropertiesPropertiesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiCloudwrapperPropertiesProperties[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCloudwrapperPropertiesPropertiesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_properties akamai_cloudwrapper_properties}
*/
export declare class DataAkamaiCloudwrapperProperties extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cloudwrapper_properties";
    /**
    * Generates CDKTF code for importing a DataAkamaiCloudwrapperProperties resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCloudwrapperProperties to import
    * @param importFromId The id of the existing DataAkamaiCloudwrapperProperties that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_properties#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCloudwrapperProperties to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cloudwrapper_properties akamai_cloudwrapper_properties} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCloudwrapperPropertiesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiCloudwrapperPropertiesConfig);
    private _contractIds?;
    get contractIds(): string[];
    set contractIds(value: string[]);
    resetContractIds(): void;
    get contractIdsInput(): string[] | undefined;
    get id(): string;
    private _unused?;
    get unused(): boolean | cdktf.IResolvable;
    set unused(value: boolean | cdktf.IResolvable);
    resetUnused(): void;
    get unusedInput(): boolean | cdktf.IResolvable | undefined;
    private _properties;
    get properties(): DataAkamaiCloudwrapperPropertiesPropertiesList;
    putProperties(value: DataAkamaiCloudwrapperPropertiesProperties[] | cdktf.IResolvable): void;
    resetProperties(): void;
    get propertiesInput(): cdktf.IResolvable | DataAkamaiCloudwrapperPropertiesProperties[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
