import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCpsCsrConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of enrollment
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_csr#enrollment_id DataAkamaiCpsCsr#enrollment_id}
    */
    readonly enrollmentId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_csr#id DataAkamaiCpsCsr#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_csr akamai_cps_csr}
*/
export declare class DataAkamaiCpsCsr extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cps_csr";
    /**
    * Generates CDKTF code for importing a DataAkamaiCpsCsr resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCpsCsr to import
    * @param importFromId The id of the existing DataAkamaiCpsCsr that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_csr#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCpsCsr to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_csr akamai_cps_csr} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCpsCsrConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCpsCsrConfig);
    get csrEcdsa(): string;
    get csrRsa(): string;
    private _enrollmentId?;
    get enrollmentId(): number;
    set enrollmentId(value: number);
    get enrollmentIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
