import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCpsEnrollmentConfig extends cdktf.TerraformMetaArguments {
    /**
    * The unique identifier of enrollment
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollment#enrollment_id DataAkamaiCpsEnrollment#enrollment_id}
    */
    readonly enrollmentId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollment#id DataAkamaiCpsEnrollment#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataAkamaiCpsEnrollmentAdminContact {
}
export declare function dataAkamaiCpsEnrollmentAdminContactToTerraform(struct?: DataAkamaiCpsEnrollmentAdminContact): any;
export declare function dataAkamaiCpsEnrollmentAdminContactToHclTerraform(struct?: DataAkamaiCpsEnrollmentAdminContact): any;
export declare class DataAkamaiCpsEnrollmentAdminContactOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentAdminContact | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentAdminContact | undefined);
    get addressLineOne(): string;
    get addressLineTwo(): string;
    get city(): string;
    get countryCode(): string;
    get email(): string;
    get firstName(): string;
    get lastName(): string;
    get organization(): string;
    get phone(): string;
    get postalCode(): string;
    get region(): string;
    get title(): string;
}
export declare class DataAkamaiCpsEnrollmentAdminContactList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentAdminContactOutputReference;
}
export interface DataAkamaiCpsEnrollmentCsr {
}
export declare function dataAkamaiCpsEnrollmentCsrToTerraform(struct?: DataAkamaiCpsEnrollmentCsr): any;
export declare function dataAkamaiCpsEnrollmentCsrToHclTerraform(struct?: DataAkamaiCpsEnrollmentCsr): any;
export declare class DataAkamaiCpsEnrollmentCsrOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentCsr | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentCsr | undefined);
    get city(): string;
    get countryCode(): string;
    get organization(): string;
    get organizationalUnit(): string;
    get preferredTrustChain(): string;
    get state(): string;
}
export declare class DataAkamaiCpsEnrollmentCsrList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentCsrOutputReference;
}
export interface DataAkamaiCpsEnrollmentDnsChallenges {
}
export declare function dataAkamaiCpsEnrollmentDnsChallengesToTerraform(struct?: DataAkamaiCpsEnrollmentDnsChallenges): any;
export declare function dataAkamaiCpsEnrollmentDnsChallengesToHclTerraform(struct?: DataAkamaiCpsEnrollmentDnsChallenges): any;
export declare class DataAkamaiCpsEnrollmentDnsChallengesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentDnsChallenges | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentDnsChallenges | undefined);
    get domain(): string;
    get fullPath(): string;
    get responseBody(): string;
}
export declare class DataAkamaiCpsEnrollmentDnsChallengesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentDnsChallengesOutputReference;
}
export interface DataAkamaiCpsEnrollmentHttpChallenges {
}
export declare function dataAkamaiCpsEnrollmentHttpChallengesToTerraform(struct?: DataAkamaiCpsEnrollmentHttpChallenges): any;
export declare function dataAkamaiCpsEnrollmentHttpChallengesToHclTerraform(struct?: DataAkamaiCpsEnrollmentHttpChallenges): any;
export declare class DataAkamaiCpsEnrollmentHttpChallengesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentHttpChallenges | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentHttpChallenges | undefined);
    get domain(): string;
    get fullPath(): string;
    get responseBody(): string;
}
export declare class DataAkamaiCpsEnrollmentHttpChallengesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentHttpChallengesOutputReference;
}
export interface DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthentication {
}
export declare function dataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthenticationToTerraform(struct?: DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthentication): any;
export declare function dataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthenticationToHclTerraform(struct?: DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthentication): any;
export declare class DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthenticationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthentication | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthentication | undefined);
    get ocspEnabled(): cdktf.IResolvable;
    get sendCaListToClient(): cdktf.IResolvable;
    get setId(): string;
}
export declare class DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthenticationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthenticationOutputReference;
}
export interface DataAkamaiCpsEnrollmentNetworkConfiguration {
}
export declare function dataAkamaiCpsEnrollmentNetworkConfigurationToTerraform(struct?: DataAkamaiCpsEnrollmentNetworkConfiguration): any;
export declare function dataAkamaiCpsEnrollmentNetworkConfigurationToHclTerraform(struct?: DataAkamaiCpsEnrollmentNetworkConfiguration): any;
export declare class DataAkamaiCpsEnrollmentNetworkConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentNetworkConfiguration | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentNetworkConfiguration | undefined);
    private _clientMutualAuthentication;
    get clientMutualAuthentication(): DataAkamaiCpsEnrollmentNetworkConfigurationClientMutualAuthenticationList;
    get cloneDnsNames(): cdktf.IResolvable;
    get disallowedTlsVersions(): string[];
    get geography(): string;
    get mustHaveCiphers(): string;
    get ocspStapling(): string;
    get preferredCiphers(): string;
    get quicEnabled(): cdktf.IResolvable;
}
export declare class DataAkamaiCpsEnrollmentNetworkConfigurationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentNetworkConfigurationOutputReference;
}
export interface DataAkamaiCpsEnrollmentOrganization {
}
export declare function dataAkamaiCpsEnrollmentOrganizationToTerraform(struct?: DataAkamaiCpsEnrollmentOrganization): any;
export declare function dataAkamaiCpsEnrollmentOrganizationToHclTerraform(struct?: DataAkamaiCpsEnrollmentOrganization): any;
export declare class DataAkamaiCpsEnrollmentOrganizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentOrganization | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentOrganization | undefined);
    get addressLineOne(): string;
    get addressLineTwo(): string;
    get city(): string;
    get countryCode(): string;
    get name(): string;
    get phone(): string;
    get postalCode(): string;
    get region(): string;
}
export declare class DataAkamaiCpsEnrollmentOrganizationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentOrganizationOutputReference;
}
export interface DataAkamaiCpsEnrollmentTechContact {
}
export declare function dataAkamaiCpsEnrollmentTechContactToTerraform(struct?: DataAkamaiCpsEnrollmentTechContact): any;
export declare function dataAkamaiCpsEnrollmentTechContactToHclTerraform(struct?: DataAkamaiCpsEnrollmentTechContact): any;
export declare class DataAkamaiCpsEnrollmentTechContactOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentTechContact | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentTechContact | undefined);
    get addressLineOne(): string;
    get addressLineTwo(): string;
    get city(): string;
    get countryCode(): string;
    get email(): string;
    get firstName(): string;
    get lastName(): string;
    get organization(): string;
    get phone(): string;
    get postalCode(): string;
    get region(): string;
    get title(): string;
}
export declare class DataAkamaiCpsEnrollmentTechContactList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentTechContactOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollment akamai_cps_enrollment}
*/
export declare class DataAkamaiCpsEnrollment extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cps_enrollment";
    /**
    * Generates CDKTF code for importing a DataAkamaiCpsEnrollment resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCpsEnrollment to import
    * @param importFromId The id of the existing DataAkamaiCpsEnrollment that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollment#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCpsEnrollment to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollment akamai_cps_enrollment} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCpsEnrollmentConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCpsEnrollmentConfig);
    private _adminContact;
    get adminContact(): DataAkamaiCpsEnrollmentAdminContactList;
    get certificateChainType(): string;
    get certificateType(): string;
    get commonName(): string;
    get contractId(): string;
    private _csr;
    get csr(): DataAkamaiCpsEnrollmentCsrList;
    private _dnsChallenges;
    get dnsChallenges(): DataAkamaiCpsEnrollmentDnsChallengesList;
    get enableMultiStackedCertificates(): cdktf.IResolvable;
    private _enrollmentId?;
    get enrollmentId(): number;
    set enrollmentId(value: number);
    get enrollmentIdInput(): number | undefined;
    private _httpChallenges;
    get httpChallenges(): DataAkamaiCpsEnrollmentHttpChallengesList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _networkConfiguration;
    get networkConfiguration(): DataAkamaiCpsEnrollmentNetworkConfigurationList;
    private _organization;
    get organization(): DataAkamaiCpsEnrollmentOrganizationList;
    get pendingChanges(): cdktf.IResolvable;
    get registrationAuthority(): string;
    get sans(): string[];
    get secureNetwork(): string;
    get signatureAlgorithm(): string;
    get sniOnly(): cdktf.IResolvable;
    private _techContact;
    get techContact(): DataAkamaiCpsEnrollmentTechContactList;
    get validationType(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
