import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiCpsEnrollmentsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Contract ID for which enrollments are retrieved
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollments#contract_id DataAkamaiCpsEnrollments#contract_id}
    */
    readonly contractId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollments#id DataAkamaiCpsEnrollments#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataAkamaiCpsEnrollmentsEnrollmentsAdminContact {
}
export declare function dataAkamaiCpsEnrollmentsEnrollmentsAdminContactToTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsAdminContact): any;
export declare function dataAkamaiCpsEnrollmentsEnrollmentsAdminContactToHclTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsAdminContact): any;
export declare class DataAkamaiCpsEnrollmentsEnrollmentsAdminContactOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentsEnrollmentsAdminContact | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentsEnrollmentsAdminContact | undefined);
    get addressLineOne(): string;
    get addressLineTwo(): string;
    get city(): string;
    get countryCode(): string;
    get email(): string;
    get firstName(): string;
    get lastName(): string;
    get organization(): string;
    get phone(): string;
    get postalCode(): string;
    get region(): string;
    get title(): string;
}
export declare class DataAkamaiCpsEnrollmentsEnrollmentsAdminContactList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentsEnrollmentsAdminContactOutputReference;
}
export interface DataAkamaiCpsEnrollmentsEnrollmentsCsr {
}
export declare function dataAkamaiCpsEnrollmentsEnrollmentsCsrToTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsCsr): any;
export declare function dataAkamaiCpsEnrollmentsEnrollmentsCsrToHclTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsCsr): any;
export declare class DataAkamaiCpsEnrollmentsEnrollmentsCsrOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentsEnrollmentsCsr | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentsEnrollmentsCsr | undefined);
    get city(): string;
    get countryCode(): string;
    get organization(): string;
    get organizationalUnit(): string;
    get preferredTrustChain(): string;
    get state(): string;
}
export declare class DataAkamaiCpsEnrollmentsEnrollmentsCsrList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentsEnrollmentsCsrOutputReference;
}
export interface DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthentication {
}
export declare function dataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthenticationToTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthentication): any;
export declare function dataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthenticationToHclTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthentication): any;
export declare class DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthenticationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthentication | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthentication | undefined);
    get ocspEnabled(): cdktf.IResolvable;
    get sendCaListToClient(): cdktf.IResolvable;
    get setId(): string;
}
export declare class DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthenticationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthenticationOutputReference;
}
export interface DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfiguration {
}
export declare function dataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationToTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfiguration): any;
export declare function dataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationToHclTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfiguration): any;
export declare class DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfiguration | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfiguration | undefined);
    private _clientMutualAuthentication;
    get clientMutualAuthentication(): DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationClientMutualAuthenticationList;
    get cloneDnsNames(): cdktf.IResolvable;
    get disallowedTlsVersions(): string[];
    get geography(): string;
    get mustHaveCiphers(): string;
    get ocspStapling(): string;
    get preferredCiphers(): string;
    get quicEnabled(): cdktf.IResolvable;
}
export declare class DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationOutputReference;
}
export interface DataAkamaiCpsEnrollmentsEnrollmentsOrganization {
}
export declare function dataAkamaiCpsEnrollmentsEnrollmentsOrganizationToTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsOrganization): any;
export declare function dataAkamaiCpsEnrollmentsEnrollmentsOrganizationToHclTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsOrganization): any;
export declare class DataAkamaiCpsEnrollmentsEnrollmentsOrganizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentsEnrollmentsOrganization | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentsEnrollmentsOrganization | undefined);
    get addressLineOne(): string;
    get addressLineTwo(): string;
    get city(): string;
    get countryCode(): string;
    get name(): string;
    get phone(): string;
    get postalCode(): string;
    get region(): string;
}
export declare class DataAkamaiCpsEnrollmentsEnrollmentsOrganizationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentsEnrollmentsOrganizationOutputReference;
}
export interface DataAkamaiCpsEnrollmentsEnrollmentsTechContact {
}
export declare function dataAkamaiCpsEnrollmentsEnrollmentsTechContactToTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsTechContact): any;
export declare function dataAkamaiCpsEnrollmentsEnrollmentsTechContactToHclTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollmentsTechContact): any;
export declare class DataAkamaiCpsEnrollmentsEnrollmentsTechContactOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentsEnrollmentsTechContact | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentsEnrollmentsTechContact | undefined);
    get addressLineOne(): string;
    get addressLineTwo(): string;
    get city(): string;
    get countryCode(): string;
    get email(): string;
    get firstName(): string;
    get lastName(): string;
    get organization(): string;
    get phone(): string;
    get postalCode(): string;
    get region(): string;
    get title(): string;
}
export declare class DataAkamaiCpsEnrollmentsEnrollmentsTechContactList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentsEnrollmentsTechContactOutputReference;
}
export interface DataAkamaiCpsEnrollmentsEnrollments {
}
export declare function dataAkamaiCpsEnrollmentsEnrollmentsToTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollments): any;
export declare function dataAkamaiCpsEnrollmentsEnrollmentsToHclTerraform(struct?: DataAkamaiCpsEnrollmentsEnrollments): any;
export declare class DataAkamaiCpsEnrollmentsEnrollmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiCpsEnrollmentsEnrollments | undefined;
    set internalValue(value: DataAkamaiCpsEnrollmentsEnrollments | undefined);
    private _adminContact;
    get adminContact(): DataAkamaiCpsEnrollmentsEnrollmentsAdminContactList;
    get certificateChainType(): string;
    get certificateType(): string;
    get commonName(): string;
    private _csr;
    get csr(): DataAkamaiCpsEnrollmentsEnrollmentsCsrList;
    get enableMultiStackedCertificates(): cdktf.IResolvable;
    get enrollmentId(): number;
    private _networkConfiguration;
    get networkConfiguration(): DataAkamaiCpsEnrollmentsEnrollmentsNetworkConfigurationList;
    private _organization;
    get organization(): DataAkamaiCpsEnrollmentsEnrollmentsOrganizationList;
    get pendingChanges(): cdktf.IResolvable;
    get registrationAuthority(): string;
    get sans(): string[];
    get secureNetwork(): string;
    get signatureAlgorithm(): string;
    get sniOnly(): cdktf.IResolvable;
    private _techContact;
    get techContact(): DataAkamaiCpsEnrollmentsEnrollmentsTechContactList;
    get validationType(): string;
}
export declare class DataAkamaiCpsEnrollmentsEnrollmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiCpsEnrollmentsEnrollmentsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollments akamai_cps_enrollments}
*/
export declare class DataAkamaiCpsEnrollments extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_cps_enrollments";
    /**
    * Generates CDKTF code for importing a DataAkamaiCpsEnrollments resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiCpsEnrollments to import
    * @param importFromId The id of the existing DataAkamaiCpsEnrollments that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollments#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiCpsEnrollments to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/cps_enrollments akamai_cps_enrollments} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiCpsEnrollmentsConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiCpsEnrollmentsConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    get contractIdInput(): string | undefined;
    private _enrollments;
    get enrollments(): DataAkamaiCpsEnrollmentsEnrollmentsList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
