import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiDatastreamActivationHistoryConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastream_activation_history#id DataAkamaiDatastreamActivationHistory#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Identifies the stream
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastream_activation_history#stream_id DataAkamaiDatastreamActivationHistory#stream_id}
    */
    readonly streamId: number;
}
export interface DataAkamaiDatastreamActivationHistoryActivations {
}
export declare function dataAkamaiDatastreamActivationHistoryActivationsToTerraform(struct?: DataAkamaiDatastreamActivationHistoryActivations): any;
export declare function dataAkamaiDatastreamActivationHistoryActivationsToHclTerraform(struct?: DataAkamaiDatastreamActivationHistoryActivations): any;
export declare class DataAkamaiDatastreamActivationHistoryActivationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiDatastreamActivationHistoryActivations | undefined;
    set internalValue(value: DataAkamaiDatastreamActivationHistoryActivations | undefined);
    get modifiedBy(): string;
    get modifiedDate(): string;
    get status(): string;
    get streamId(): number;
    get streamVersion(): number;
}
export declare class DataAkamaiDatastreamActivationHistoryActivationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiDatastreamActivationHistoryActivationsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastream_activation_history akamai_datastream_activation_history}
*/
export declare class DataAkamaiDatastreamActivationHistory extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_datastream_activation_history";
    /**
    * Generates CDKTF code for importing a DataAkamaiDatastreamActivationHistory resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiDatastreamActivationHistory to import
    * @param importFromId The id of the existing DataAkamaiDatastreamActivationHistory that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastream_activation_history#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiDatastreamActivationHistory to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastream_activation_history akamai_datastream_activation_history} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiDatastreamActivationHistoryConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiDatastreamActivationHistoryConfig);
    private _activations;
    get activations(): DataAkamaiDatastreamActivationHistoryActivationsList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _streamId?;
    get streamId(): number;
    set streamId(value: number);
    get streamIdInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
