import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiDatastreamsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifies the group where the stream is created.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastreams#group_id DataAkamaiDatastreams#group_id}
    */
    readonly groupId?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastreams#id DataAkamaiDatastreams#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataAkamaiDatastreamsStreamsDetailsProperties {
}
export declare function dataAkamaiDatastreamsStreamsDetailsPropertiesToTerraform(struct?: DataAkamaiDatastreamsStreamsDetailsProperties): any;
export declare function dataAkamaiDatastreamsStreamsDetailsPropertiesToHclTerraform(struct?: DataAkamaiDatastreamsStreamsDetailsProperties): any;
export declare class DataAkamaiDatastreamsStreamsDetailsPropertiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiDatastreamsStreamsDetailsProperties | undefined;
    set internalValue(value: DataAkamaiDatastreamsStreamsDetailsProperties | undefined);
    get propertyId(): number;
    get propertyName(): string;
}
export declare class DataAkamaiDatastreamsStreamsDetailsPropertiesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiDatastreamsStreamsDetailsPropertiesOutputReference;
}
export interface DataAkamaiDatastreamsStreamsDetails {
}
export declare function dataAkamaiDatastreamsStreamsDetailsToTerraform(struct?: DataAkamaiDatastreamsStreamsDetails): any;
export declare function dataAkamaiDatastreamsStreamsDetailsToHclTerraform(struct?: DataAkamaiDatastreamsStreamsDetails): any;
export declare class DataAkamaiDatastreamsStreamsDetailsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiDatastreamsStreamsDetails | undefined;
    set internalValue(value: DataAkamaiDatastreamsStreamsDetails | undefined);
    get contractId(): string;
    get createdBy(): string;
    get createdDate(): string;
    get groupId(): number;
    get latestVersion(): number;
    get modifiedBy(): string;
    get modifiedDate(): string;
    get productId(): string;
    private _properties;
    get properties(): DataAkamaiDatastreamsStreamsDetailsPropertiesList;
    get streamId(): number;
    get streamName(): string;
    get streamStatus(): string;
    get streamVersion(): number;
}
export declare class DataAkamaiDatastreamsStreamsDetailsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiDatastreamsStreamsDetailsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastreams akamai_datastreams}
*/
export declare class DataAkamaiDatastreams extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_datastreams";
    /**
    * Generates CDKTF code for importing a DataAkamaiDatastreams resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiDatastreams to import
    * @param importFromId The id of the existing DataAkamaiDatastreams that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastreams#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiDatastreams to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/datastreams akamai_datastreams} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiDatastreamsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiDatastreamsConfig);
    private _groupId?;
    get groupId(): number;
    set groupId(value: number);
    resetGroupId(): void;
    get groupIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _streamsDetails;
    get streamsDetails(): DataAkamaiDatastreamsStreamsDetailsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
