import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiDnsRecordSetConfig extends cdktf.TerraformMetaArguments {
    /**
    * The base credential hostname without the protocol
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/dns_record_set#host DataAkamaiDnsRecordSet#host}
    */
    readonly host: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/dns_record_set#id DataAkamaiDnsRecordSet#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The DNS record type
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/dns_record_set#record_type DataAkamaiDnsRecordSet#record_type}
    */
    readonly recordType: string;
    /**
    * The domain zone, including any nested subdomains
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/dns_record_set#zone DataAkamaiDnsRecordSet#zone}
    */
    readonly zone: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/dns_record_set akamai_dns_record_set}
*/
export declare class DataAkamaiDnsRecordSet extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_dns_record_set";
    /**
    * Generates CDKTF code for importing a DataAkamaiDnsRecordSet resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiDnsRecordSet to import
    * @param importFromId The id of the existing DataAkamaiDnsRecordSet that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/dns_record_set#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiDnsRecordSet to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/dns_record_set akamai_dns_record_set} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiDnsRecordSetConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiDnsRecordSetConfig);
    private _host?;
    get host(): string;
    set host(value: string);
    get hostInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get rdata(): string[];
    private _recordType?;
    get recordType(): string;
    set recordType(value: string);
    get recordTypeInput(): string | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    get zoneInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
