import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiEdgekvGroupItemsConfig extends cdktf.TerraformMetaArguments {
    /**
    * The name of the EdgeKV group.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_group_items#group_name DataAkamaiEdgekvGroupItems#group_name}
    */
    readonly groupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_group_items#id DataAkamaiEdgekvGroupItems#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of an EdgeKV namespace.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_group_items#namespace_name DataAkamaiEdgekvGroupItems#namespace_name}
    */
    readonly namespaceName: string;
    /**
    * The network against which to execute the API request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_group_items#network DataAkamaiEdgekvGroupItems#network}
    */
    readonly network: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_group_items akamai_edgekv_group_items}
*/
export declare class DataAkamaiEdgekvGroupItems extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_edgekv_group_items";
    /**
    * Generates CDKTF code for importing a DataAkamaiEdgekvGroupItems resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiEdgekvGroupItems to import
    * @param importFromId The id of the existing DataAkamaiEdgekvGroupItems that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_group_items#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiEdgekvGroupItems to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_group_items akamai_edgekv_group_items} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiEdgekvGroupItemsConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiEdgekvGroupItemsConfig);
    private _groupName?;
    get groupName(): string;
    set groupName(value: string);
    get groupNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _items;
    get items(): cdktf.StringMap;
    private _namespaceName?;
    get namespaceName(): string;
    set namespaceName(value: string);
    get namespaceNameInput(): string | undefined;
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
