import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiEdgekvGroupsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_groups#id DataAkamaiEdgekvGroups#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The name of an EdgeKV namespace.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_groups#namespace_name DataAkamaiEdgekvGroups#namespace_name}
    */
    readonly namespaceName: string;
    /**
    * The network against which to execute the API request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_groups#network DataAkamaiEdgekvGroups#network}
    */
    readonly network: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_groups akamai_edgekv_groups}
*/
export declare class DataAkamaiEdgekvGroups extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_edgekv_groups";
    /**
    * Generates CDKTF code for importing a DataAkamaiEdgekvGroups resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiEdgekvGroups to import
    * @param importFromId The id of the existing DataAkamaiEdgekvGroups that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_groups#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiEdgekvGroups to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgekv_groups akamai_edgekv_groups} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiEdgekvGroupsConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiEdgekvGroupsConfig);
    get groups(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _namespaceName?;
    get namespaceName(): string;
    set namespaceName(value: string);
    get namespaceNameInput(): string | undefined;
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
