import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiEdgeworkerActivationConfig extends cdktf.TerraformMetaArguments {
    /**
    * The unique identifier of the EdgeWorker
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker_activation#edgeworker_id DataAkamaiEdgeworkerActivation#edgeworker_id}
    */
    readonly edgeworkerId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker_activation#id DataAkamaiEdgeworkerActivation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The network from which the activation will be fetched
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker_activation#network DataAkamaiEdgeworkerActivation#network}
    */
    readonly network: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker_activation akamai_edgeworker_activation}
*/
export declare class DataAkamaiEdgeworkerActivation extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_edgeworker_activation";
    /**
    * Generates CDKTF code for importing a DataAkamaiEdgeworkerActivation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiEdgeworkerActivation to import
    * @param importFromId The id of the existing DataAkamaiEdgeworkerActivation that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker_activation#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiEdgeworkerActivation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker_activation akamai_edgeworker_activation} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiEdgeworkerActivationConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiEdgeworkerActivationConfig);
    get activationId(): number;
    private _edgeworkerId?;
    get edgeworkerId(): number;
    set edgeworkerId(value: number);
    get edgeworkerIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
    get version(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
