import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiEdgeworkerConfig extends cdktf.TerraformMetaArguments {
    /**
    * The unique identifier of the EdgeWorker
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker#edgeworker_id DataAkamaiEdgeworker#edgeworker_id}
    */
    readonly edgeworkerId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker#id DataAkamaiEdgeworker#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The path where the EdgeWorkers tgz code bundle will be stored
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker#local_bundle DataAkamaiEdgeworker#local_bundle}
    */
    readonly localBundle?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker akamai_edgeworker}
*/
export declare class DataAkamaiEdgeworker extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_edgeworker";
    /**
    * Generates CDKTF code for importing a DataAkamaiEdgeworker resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiEdgeworker to import
    * @param importFromId The id of the existing DataAkamaiEdgeworker that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiEdgeworker to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworker akamai_edgeworker} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiEdgeworkerConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiEdgeworkerConfig);
    private _edgeworkerId?;
    get edgeworkerId(): number;
    set edgeworkerId(value: number);
    get edgeworkerIdInput(): number | undefined;
    get groupId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _localBundle?;
    get localBundle(): string;
    set localBundle(value: string);
    resetLocalBundle(): void;
    get localBundleInput(): string | undefined;
    get localBundleHash(): string;
    get name(): string;
    get resourceTierId(): number;
    get version(): string;
    get warnings(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
