import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiEdgeworkersPropertyRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of an EdgeWorker ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_property_rules#edgeworker_id DataAkamaiEdgeworkersPropertyRules#edgeworker_id}
    */
    readonly edgeworkerId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_property_rules#id DataAkamaiEdgeworkersPropertyRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_property_rules akamai_edgeworkers_property_rules}
*/
export declare class DataAkamaiEdgeworkersPropertyRules extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_edgeworkers_property_rules";
    /**
    * Generates CDKTF code for importing a DataAkamaiEdgeworkersPropertyRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiEdgeworkersPropertyRules to import
    * @param importFromId The id of the existing DataAkamaiEdgeworkersPropertyRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_property_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiEdgeworkersPropertyRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_property_rules akamai_edgeworkers_property_rules} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiEdgeworkersPropertyRulesConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiEdgeworkersPropertyRulesConfig);
    private _edgeworkerId?;
    get edgeworkerId(): number;
    set edgeworkerId(value: number);
    get edgeworkerIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
