import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiEdgeworkersResourceTierConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of a contract
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_resource_tier#contract_id DataAkamaiEdgeworkersResourceTier#contract_id}
    */
    readonly contractId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_resource_tier#id DataAkamaiEdgeworkersResourceTier#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique name of the resource tier
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_resource_tier#resource_tier_name DataAkamaiEdgeworkersResourceTier#resource_tier_name}
    */
    readonly resourceTierName: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_resource_tier akamai_edgeworkers_resource_tier}
*/
export declare class DataAkamaiEdgeworkersResourceTier extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_edgeworkers_resource_tier";
    /**
    * Generates CDKTF code for importing a DataAkamaiEdgeworkersResourceTier resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiEdgeworkersResourceTier to import
    * @param importFromId The id of the existing DataAkamaiEdgeworkersResourceTier that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_resource_tier#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiEdgeworkersResourceTier to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/edgeworkers_resource_tier akamai_edgeworkers_resource_tier} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiEdgeworkersResourceTierConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiEdgeworkersResourceTierConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    get contractIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get resourceTierId(): number;
    private _resourceTierName?;
    get resourceTierName(): string;
    set resourceTierName(value: string);
    get resourceTierNameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
