import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiGtmAsmapConfig extends cdktf.TerraformMetaArguments {
    /**
    * A descriptive label for the AS map.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_asmap#domain DataAkamaiGtmAsmap#domain}
    */
    readonly domain: string;
    /**
    * A descriptive label for the AS map
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_asmap#map_name DataAkamaiGtmAsmap#map_name}
    */
    readonly mapName: string;
    /**
    * assignments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_asmap#assignments DataAkamaiGtmAsmap#assignments}
    */
    readonly assignments?: DataAkamaiGtmAsmapAssignments[] | cdktf.IResolvable;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_asmap#links DataAkamaiGtmAsmap#links}
    */
    readonly links?: DataAkamaiGtmAsmapLinks[] | cdktf.IResolvable;
}
export interface DataAkamaiGtmAsmapAssignments {
}
export declare function dataAkamaiGtmAsmapAssignmentsToTerraform(struct?: DataAkamaiGtmAsmapAssignments | cdktf.IResolvable): any;
export declare function dataAkamaiGtmAsmapAssignmentsToHclTerraform(struct?: DataAkamaiGtmAsmapAssignments | cdktf.IResolvable): any;
export declare class DataAkamaiGtmAsmapAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmAsmapAssignments | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmAsmapAssignments | cdktf.IResolvable | undefined);
    get asNumbers(): number[];
    get datacenterId(): number;
    get nickname(): string;
}
export declare class DataAkamaiGtmAsmapAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmAsmapAssignments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmAsmapAssignmentsOutputReference;
}
export interface DataAkamaiGtmAsmapDefaultDatacenter {
}
export declare function dataAkamaiGtmAsmapDefaultDatacenterToTerraform(struct?: DataAkamaiGtmAsmapDefaultDatacenter | cdktf.IResolvable): any;
export declare function dataAkamaiGtmAsmapDefaultDatacenterToHclTerraform(struct?: DataAkamaiGtmAsmapDefaultDatacenter | cdktf.IResolvable): any;
export declare class DataAkamaiGtmAsmapDefaultDatacenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiGtmAsmapDefaultDatacenter | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmAsmapDefaultDatacenter | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get nickname(): string;
}
export interface DataAkamaiGtmAsmapLinks {
}
export declare function dataAkamaiGtmAsmapLinksToTerraform(struct?: DataAkamaiGtmAsmapLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmAsmapLinksToHclTerraform(struct?: DataAkamaiGtmAsmapLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmAsmapLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmAsmapLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmAsmapLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmAsmapLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmAsmapLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmAsmapLinksOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_asmap akamai_gtm_asmap}
*/
export declare class DataAkamaiGtmAsmap extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_gtm_asmap";
    /**
    * Generates CDKTF code for importing a DataAkamaiGtmAsmap resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiGtmAsmap to import
    * @param importFromId The id of the existing DataAkamaiGtmAsmap that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_asmap#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiGtmAsmap to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_asmap akamai_gtm_asmap} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiGtmAsmapConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiGtmAsmapConfig);
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    get id(): string;
    private _mapName?;
    get mapName(): string;
    set mapName(value: string);
    get mapNameInput(): string | undefined;
    private _assignments;
    get assignments(): DataAkamaiGtmAsmapAssignmentsList;
    putAssignments(value: DataAkamaiGtmAsmapAssignments[] | cdktf.IResolvable): void;
    resetAssignments(): void;
    get assignmentsInput(): cdktf.IResolvable | DataAkamaiGtmAsmapAssignments[] | undefined;
    private _defaultDatacenter;
    get defaultDatacenter(): DataAkamaiGtmAsmapDefaultDatacenterOutputReference;
    private _links;
    get links(): DataAkamaiGtmAsmapLinksList;
    putLinks(value: DataAkamaiGtmAsmapLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmAsmapLinks[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
