import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiGtmCidrmapConfig extends cdktf.TerraformMetaArguments {
    /**
    * GTM domain name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_cidrmap#domain DataAkamaiGtmCidrmap#domain}
    */
    readonly domain: string;
    /**
    * A descriptive label for the CIDR map.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_cidrmap#map_name DataAkamaiGtmCidrmap#map_name}
    */
    readonly mapName: string;
    /**
    * assignments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_cidrmap#assignments DataAkamaiGtmCidrmap#assignments}
    */
    readonly assignments?: DataAkamaiGtmCidrmapAssignments[] | cdktf.IResolvable;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_cidrmap#links DataAkamaiGtmCidrmap#links}
    */
    readonly links?: DataAkamaiGtmCidrmapLinks[] | cdktf.IResolvable;
}
export interface DataAkamaiGtmCidrmapAssignments {
}
export declare function dataAkamaiGtmCidrmapAssignmentsToTerraform(struct?: DataAkamaiGtmCidrmapAssignments | cdktf.IResolvable): any;
export declare function dataAkamaiGtmCidrmapAssignmentsToHclTerraform(struct?: DataAkamaiGtmCidrmapAssignments | cdktf.IResolvable): any;
export declare class DataAkamaiGtmCidrmapAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmCidrmapAssignments | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmCidrmapAssignments | cdktf.IResolvable | undefined);
    get blocks(): string[];
    get datacenterId(): number;
    get nickname(): string;
}
export declare class DataAkamaiGtmCidrmapAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmCidrmapAssignments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmCidrmapAssignmentsOutputReference;
}
export interface DataAkamaiGtmCidrmapDefaultDatacenter {
}
export declare function dataAkamaiGtmCidrmapDefaultDatacenterToTerraform(struct?: DataAkamaiGtmCidrmapDefaultDatacenter | cdktf.IResolvable): any;
export declare function dataAkamaiGtmCidrmapDefaultDatacenterToHclTerraform(struct?: DataAkamaiGtmCidrmapDefaultDatacenter | cdktf.IResolvable): any;
export declare class DataAkamaiGtmCidrmapDefaultDatacenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiGtmCidrmapDefaultDatacenter | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmCidrmapDefaultDatacenter | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get nickname(): string;
}
export interface DataAkamaiGtmCidrmapLinks {
}
export declare function dataAkamaiGtmCidrmapLinksToTerraform(struct?: DataAkamaiGtmCidrmapLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmCidrmapLinksToHclTerraform(struct?: DataAkamaiGtmCidrmapLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmCidrmapLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmCidrmapLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmCidrmapLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmCidrmapLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmCidrmapLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmCidrmapLinksOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_cidrmap akamai_gtm_cidrmap}
*/
export declare class DataAkamaiGtmCidrmap extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_gtm_cidrmap";
    /**
    * Generates CDKTF code for importing a DataAkamaiGtmCidrmap resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiGtmCidrmap to import
    * @param importFromId The id of the existing DataAkamaiGtmCidrmap that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_cidrmap#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiGtmCidrmap to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_cidrmap akamai_gtm_cidrmap} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiGtmCidrmapConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiGtmCidrmapConfig);
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    get id(): string;
    private _mapName?;
    get mapName(): string;
    set mapName(value: string);
    get mapNameInput(): string | undefined;
    private _assignments;
    get assignments(): DataAkamaiGtmCidrmapAssignmentsList;
    putAssignments(value: DataAkamaiGtmCidrmapAssignments[] | cdktf.IResolvable): void;
    resetAssignments(): void;
    get assignmentsInput(): cdktf.IResolvable | DataAkamaiGtmCidrmapAssignments[] | undefined;
    private _defaultDatacenter;
    get defaultDatacenter(): DataAkamaiGtmCidrmapDefaultDatacenterOutputReference;
    private _links;
    get links(): DataAkamaiGtmCidrmapLinksList;
    putLinks(value: DataAkamaiGtmCidrmapLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmCidrmapLinks[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
