import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiGtmDatacentersConfig extends cdktf.TerraformMetaArguments {
    /**
    * GTM domain name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_datacenters#domain DataAkamaiGtmDatacenters#domain}
    */
    readonly domain: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_datacenters#id DataAkamaiGtmDatacenters#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataAkamaiGtmDatacentersDatacentersDefaultLoadObject {
}
export declare function dataAkamaiGtmDatacentersDatacentersDefaultLoadObjectToTerraform(struct?: DataAkamaiGtmDatacentersDatacentersDefaultLoadObject): any;
export declare function dataAkamaiGtmDatacentersDatacentersDefaultLoadObjectToHclTerraform(struct?: DataAkamaiGtmDatacentersDatacentersDefaultLoadObject): any;
export declare class DataAkamaiGtmDatacentersDatacentersDefaultLoadObjectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDatacentersDatacentersDefaultLoadObject | undefined;
    set internalValue(value: DataAkamaiGtmDatacentersDatacentersDefaultLoadObject | undefined);
    get loadObject(): string;
    get loadObjectPort(): number;
    get loadServers(): string[];
}
export declare class DataAkamaiGtmDatacentersDatacentersDefaultLoadObjectList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDatacentersDatacentersDefaultLoadObjectOutputReference;
}
export interface DataAkamaiGtmDatacentersDatacentersLinks {
}
export declare function dataAkamaiGtmDatacentersDatacentersLinksToTerraform(struct?: DataAkamaiGtmDatacentersDatacentersLinks): any;
export declare function dataAkamaiGtmDatacentersDatacentersLinksToHclTerraform(struct?: DataAkamaiGtmDatacentersDatacentersLinks): any;
export declare class DataAkamaiGtmDatacentersDatacentersLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDatacentersDatacentersLinks | undefined;
    set internalValue(value: DataAkamaiGtmDatacentersDatacentersLinks | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDatacentersDatacentersLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDatacentersDatacentersLinksOutputReference;
}
export interface DataAkamaiGtmDatacentersDatacenters {
}
export declare function dataAkamaiGtmDatacentersDatacentersToTerraform(struct?: DataAkamaiGtmDatacentersDatacenters): any;
export declare function dataAkamaiGtmDatacentersDatacentersToHclTerraform(struct?: DataAkamaiGtmDatacentersDatacenters): any;
export declare class DataAkamaiGtmDatacentersDatacentersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDatacentersDatacenters | undefined;
    set internalValue(value: DataAkamaiGtmDatacentersDatacenters | undefined);
    get city(): string;
    get cloneOf(): number;
    get cloudServerHostHeaderOverride(): cdktf.IResolvable;
    get cloudServerTargeting(): cdktf.IResolvable;
    get continent(): string;
    get country(): string;
    get datacenterId(): number;
    private _defaultLoadObject;
    get defaultLoadObject(): DataAkamaiGtmDatacentersDatacentersDefaultLoadObjectList;
    get latitude(): number;
    private _links;
    get links(): DataAkamaiGtmDatacentersDatacentersLinksList;
    get longitude(): number;
    get nickname(): string;
    get scorePenalty(): number;
    get servermonitorPool(): string;
    get stateOrProvince(): string;
    get virtual(): cdktf.IResolvable;
}
export declare class DataAkamaiGtmDatacentersDatacentersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDatacentersDatacentersOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_datacenters akamai_gtm_datacenters}
*/
export declare class DataAkamaiGtmDatacenters extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_gtm_datacenters";
    /**
    * Generates CDKTF code for importing a DataAkamaiGtmDatacenters resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiGtmDatacenters to import
    * @param importFromId The id of the existing DataAkamaiGtmDatacenters that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_datacenters#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiGtmDatacenters to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_datacenters akamai_gtm_datacenters} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiGtmDatacentersConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiGtmDatacentersConfig);
    private _datacenters;
    get datacenters(): DataAkamaiGtmDatacentersDatacentersList;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
