import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiGtmDefaultDatacenterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_default_datacenter#datacenter DataAkamaiGtmDefaultDatacenter#datacenter}
    */
    readonly datacenter?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_default_datacenter#domain DataAkamaiGtmDefaultDatacenter#domain}
    */
    readonly domain: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_default_datacenter#id DataAkamaiGtmDefaultDatacenter#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_default_datacenter akamai_gtm_default_datacenter}
*/
export declare class DataAkamaiGtmDefaultDatacenter extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_gtm_default_datacenter";
    /**
    * Generates CDKTF code for importing a DataAkamaiGtmDefaultDatacenter resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiGtmDefaultDatacenter to import
    * @param importFromId The id of the existing DataAkamaiGtmDefaultDatacenter that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_default_datacenter#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiGtmDefaultDatacenter to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_default_datacenter akamai_gtm_default_datacenter} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiGtmDefaultDatacenterConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiGtmDefaultDatacenterConfig);
    private _datacenter?;
    get datacenter(): number;
    set datacenter(value: number);
    resetDatacenter(): void;
    get datacenterInput(): number | undefined;
    get datacenterId(): number;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get nickname(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
