import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiGtmDomainConfig extends cdktf.TerraformMetaArguments {
    /**
    * The full GTM domain name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#name DataAkamaiGtmDomain#name}
    */
    readonly name: string;
    /**
    * as_maps block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#as_maps DataAkamaiGtmDomain#as_maps}
    */
    readonly asMaps?: DataAkamaiGtmDomainAsMaps[] | cdktf.IResolvable;
    /**
    * cidr_maps block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#cidr_maps DataAkamaiGtmDomain#cidr_maps}
    */
    readonly cidrMaps?: DataAkamaiGtmDomainCidrMaps[] | cdktf.IResolvable;
    /**
    * datacenters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#datacenters DataAkamaiGtmDomain#datacenters}
    */
    readonly datacenters?: DataAkamaiGtmDomainDatacenters[] | cdktf.IResolvable;
    /**
    * geographic_maps block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#geographic_maps DataAkamaiGtmDomain#geographic_maps}
    */
    readonly geographicMaps?: DataAkamaiGtmDomainGeographicMaps[] | cdktf.IResolvable;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#links DataAkamaiGtmDomain#links}
    */
    readonly links?: DataAkamaiGtmDomainLinks[] | cdktf.IResolvable;
    /**
    * properties block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#properties DataAkamaiGtmDomain#properties}
    */
    readonly properties?: DataAkamaiGtmDomainProperties[] | cdktf.IResolvable;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#resources DataAkamaiGtmDomain#resources}
    */
    readonly resources?: DataAkamaiGtmDomainResources[] | cdktf.IResolvable;
}
export interface DataAkamaiGtmDomainAsMapsAssignments {
}
export declare function dataAkamaiGtmDomainAsMapsAssignmentsToTerraform(struct?: DataAkamaiGtmDomainAsMapsAssignments | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainAsMapsAssignmentsToHclTerraform(struct?: DataAkamaiGtmDomainAsMapsAssignments | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainAsMapsAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainAsMapsAssignments | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainAsMapsAssignments | cdktf.IResolvable | undefined);
    get asNumbers(): number[];
    get datacenterId(): number;
    get nickname(): string;
}
export declare class DataAkamaiGtmDomainAsMapsAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainAsMapsAssignments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainAsMapsAssignmentsOutputReference;
}
export interface DataAkamaiGtmDomainAsMapsDefaultDatacenter {
}
export declare function dataAkamaiGtmDomainAsMapsDefaultDatacenterToTerraform(struct?: DataAkamaiGtmDomainAsMapsDefaultDatacenter | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainAsMapsDefaultDatacenterToHclTerraform(struct?: DataAkamaiGtmDomainAsMapsDefaultDatacenter | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainAsMapsDefaultDatacenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiGtmDomainAsMapsDefaultDatacenter | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainAsMapsDefaultDatacenter | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get nickname(): string;
}
export interface DataAkamaiGtmDomainAsMapsLinks {
}
export declare function dataAkamaiGtmDomainAsMapsLinksToTerraform(struct?: DataAkamaiGtmDomainAsMapsLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainAsMapsLinksToHclTerraform(struct?: DataAkamaiGtmDomainAsMapsLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainAsMapsLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainAsMapsLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainAsMapsLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainAsMapsLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainAsMapsLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainAsMapsLinksOutputReference;
}
export interface DataAkamaiGtmDomainAsMaps {
    /**
    * assignments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#assignments DataAkamaiGtmDomain#assignments}
    */
    readonly assignments?: DataAkamaiGtmDomainAsMapsAssignments[] | cdktf.IResolvable;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#links DataAkamaiGtmDomain#links}
    */
    readonly links?: DataAkamaiGtmDomainAsMapsLinks[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainAsMapsToTerraform(struct?: DataAkamaiGtmDomainAsMaps | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainAsMapsToHclTerraform(struct?: DataAkamaiGtmDomainAsMaps | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainAsMapsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainAsMaps | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainAsMaps | cdktf.IResolvable | undefined);
    get name(): string;
    private _assignments;
    get assignments(): DataAkamaiGtmDomainAsMapsAssignmentsList;
    putAssignments(value: DataAkamaiGtmDomainAsMapsAssignments[] | cdktf.IResolvable): void;
    resetAssignments(): void;
    get assignmentsInput(): cdktf.IResolvable | DataAkamaiGtmDomainAsMapsAssignments[] | undefined;
    private _defaultDatacenter;
    get defaultDatacenter(): DataAkamaiGtmDomainAsMapsDefaultDatacenterOutputReference;
    private _links;
    get links(): DataAkamaiGtmDomainAsMapsLinksList;
    putLinks(value: DataAkamaiGtmDomainAsMapsLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainAsMapsLinks[] | undefined;
}
export declare class DataAkamaiGtmDomainAsMapsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainAsMaps[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainAsMapsOutputReference;
}
export interface DataAkamaiGtmDomainCidrMapsAssignments {
}
export declare function dataAkamaiGtmDomainCidrMapsAssignmentsToTerraform(struct?: DataAkamaiGtmDomainCidrMapsAssignments | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainCidrMapsAssignmentsToHclTerraform(struct?: DataAkamaiGtmDomainCidrMapsAssignments | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainCidrMapsAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainCidrMapsAssignments | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainCidrMapsAssignments | cdktf.IResolvable | undefined);
    get blocks(): string[];
    get datacenterId(): number;
    get nickname(): string;
}
export declare class DataAkamaiGtmDomainCidrMapsAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainCidrMapsAssignments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainCidrMapsAssignmentsOutputReference;
}
export interface DataAkamaiGtmDomainCidrMapsDefaultDatacenter {
}
export declare function dataAkamaiGtmDomainCidrMapsDefaultDatacenterToTerraform(struct?: DataAkamaiGtmDomainCidrMapsDefaultDatacenter | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainCidrMapsDefaultDatacenterToHclTerraform(struct?: DataAkamaiGtmDomainCidrMapsDefaultDatacenter | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainCidrMapsDefaultDatacenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiGtmDomainCidrMapsDefaultDatacenter | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainCidrMapsDefaultDatacenter | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get nickname(): string;
}
export interface DataAkamaiGtmDomainCidrMapsLinks {
}
export declare function dataAkamaiGtmDomainCidrMapsLinksToTerraform(struct?: DataAkamaiGtmDomainCidrMapsLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainCidrMapsLinksToHclTerraform(struct?: DataAkamaiGtmDomainCidrMapsLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainCidrMapsLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainCidrMapsLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainCidrMapsLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainCidrMapsLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainCidrMapsLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainCidrMapsLinksOutputReference;
}
export interface DataAkamaiGtmDomainCidrMaps {
    /**
    * assignments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#assignments DataAkamaiGtmDomain#assignments}
    */
    readonly assignments?: DataAkamaiGtmDomainCidrMapsAssignments[] | cdktf.IResolvable;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#links DataAkamaiGtmDomain#links}
    */
    readonly links?: DataAkamaiGtmDomainCidrMapsLinks[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainCidrMapsToTerraform(struct?: DataAkamaiGtmDomainCidrMaps | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainCidrMapsToHclTerraform(struct?: DataAkamaiGtmDomainCidrMaps | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainCidrMapsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainCidrMaps | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainCidrMaps | cdktf.IResolvable | undefined);
    get name(): string;
    private _assignments;
    get assignments(): DataAkamaiGtmDomainCidrMapsAssignmentsList;
    putAssignments(value: DataAkamaiGtmDomainCidrMapsAssignments[] | cdktf.IResolvable): void;
    resetAssignments(): void;
    get assignmentsInput(): cdktf.IResolvable | DataAkamaiGtmDomainCidrMapsAssignments[] | undefined;
    private _defaultDatacenter;
    get defaultDatacenter(): DataAkamaiGtmDomainCidrMapsDefaultDatacenterOutputReference;
    private _links;
    get links(): DataAkamaiGtmDomainCidrMapsLinksList;
    putLinks(value: DataAkamaiGtmDomainCidrMapsLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainCidrMapsLinks[] | undefined;
}
export declare class DataAkamaiGtmDomainCidrMapsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainCidrMaps[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainCidrMapsOutputReference;
}
export interface DataAkamaiGtmDomainDatacentersDefaultLoadObject {
}
export declare function dataAkamaiGtmDomainDatacentersDefaultLoadObjectToTerraform(struct?: DataAkamaiGtmDomainDatacentersDefaultLoadObject | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainDatacentersDefaultLoadObjectToHclTerraform(struct?: DataAkamaiGtmDomainDatacentersDefaultLoadObject | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainDatacentersDefaultLoadObjectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainDatacentersDefaultLoadObject | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainDatacentersDefaultLoadObject | cdktf.IResolvable | undefined);
    get loadObject(): string;
    get loadObjectPort(): number;
    get loadServers(): string[];
}
export declare class DataAkamaiGtmDomainDatacentersDefaultLoadObjectList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainDatacentersDefaultLoadObject[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainDatacentersDefaultLoadObjectOutputReference;
}
export interface DataAkamaiGtmDomainDatacentersLinks {
}
export declare function dataAkamaiGtmDomainDatacentersLinksToTerraform(struct?: DataAkamaiGtmDomainDatacentersLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainDatacentersLinksToHclTerraform(struct?: DataAkamaiGtmDomainDatacentersLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainDatacentersLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainDatacentersLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainDatacentersLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainDatacentersLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainDatacentersLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainDatacentersLinksOutputReference;
}
export interface DataAkamaiGtmDomainDatacenters {
    /**
    * default_load_object block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#default_load_object DataAkamaiGtmDomain#default_load_object}
    */
    readonly defaultLoadObject?: DataAkamaiGtmDomainDatacentersDefaultLoadObject[] | cdktf.IResolvable;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#links DataAkamaiGtmDomain#links}
    */
    readonly links?: DataAkamaiGtmDomainDatacentersLinks[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainDatacentersToTerraform(struct?: DataAkamaiGtmDomainDatacenters | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainDatacentersToHclTerraform(struct?: DataAkamaiGtmDomainDatacenters | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainDatacentersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainDatacenters | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainDatacenters | cdktf.IResolvable | undefined);
    get city(): string;
    get cloneOf(): number;
    get cloudServerHostHeaderOverride(): cdktf.IResolvable;
    get cloudServerTargeting(): cdktf.IResolvable;
    get continent(): string;
    get country(): string;
    get datacenterId(): number;
    get latitude(): number;
    get longitude(): number;
    get nickname(): string;
    get scorePenalty(): number;
    get serverMonitorPool(): string;
    get stateOrProvince(): string;
    get virtual(): cdktf.IResolvable;
    private _defaultLoadObject;
    get defaultLoadObject(): DataAkamaiGtmDomainDatacentersDefaultLoadObjectList;
    putDefaultLoadObject(value: DataAkamaiGtmDomainDatacentersDefaultLoadObject[] | cdktf.IResolvable): void;
    resetDefaultLoadObject(): void;
    get defaultLoadObjectInput(): cdktf.IResolvable | DataAkamaiGtmDomainDatacentersDefaultLoadObject[] | undefined;
    private _links;
    get links(): DataAkamaiGtmDomainDatacentersLinksList;
    putLinks(value: DataAkamaiGtmDomainDatacentersLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainDatacentersLinks[] | undefined;
}
export declare class DataAkamaiGtmDomainDatacentersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainDatacenters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainDatacentersOutputReference;
}
export interface DataAkamaiGtmDomainGeographicMapsAssignments {
}
export declare function dataAkamaiGtmDomainGeographicMapsAssignmentsToTerraform(struct?: DataAkamaiGtmDomainGeographicMapsAssignments | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainGeographicMapsAssignmentsToHclTerraform(struct?: DataAkamaiGtmDomainGeographicMapsAssignments | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainGeographicMapsAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainGeographicMapsAssignments | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainGeographicMapsAssignments | cdktf.IResolvable | undefined);
    get countries(): string[];
    get datacenterId(): number;
    get nickname(): string;
}
export declare class DataAkamaiGtmDomainGeographicMapsAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainGeographicMapsAssignments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainGeographicMapsAssignmentsOutputReference;
}
export interface DataAkamaiGtmDomainGeographicMapsDefaultDatacenter {
}
export declare function dataAkamaiGtmDomainGeographicMapsDefaultDatacenterToTerraform(struct?: DataAkamaiGtmDomainGeographicMapsDefaultDatacenter | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainGeographicMapsDefaultDatacenterToHclTerraform(struct?: DataAkamaiGtmDomainGeographicMapsDefaultDatacenter | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainGeographicMapsDefaultDatacenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiGtmDomainGeographicMapsDefaultDatacenter | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainGeographicMapsDefaultDatacenter | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get nickname(): string;
}
export interface DataAkamaiGtmDomainGeographicMapsLinks {
}
export declare function dataAkamaiGtmDomainGeographicMapsLinksToTerraform(struct?: DataAkamaiGtmDomainGeographicMapsLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainGeographicMapsLinksToHclTerraform(struct?: DataAkamaiGtmDomainGeographicMapsLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainGeographicMapsLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainGeographicMapsLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainGeographicMapsLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainGeographicMapsLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainGeographicMapsLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainGeographicMapsLinksOutputReference;
}
export interface DataAkamaiGtmDomainGeographicMaps {
    /**
    * assignments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#assignments DataAkamaiGtmDomain#assignments}
    */
    readonly assignments?: DataAkamaiGtmDomainGeographicMapsAssignments[] | cdktf.IResolvable;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#links DataAkamaiGtmDomain#links}
    */
    readonly links?: DataAkamaiGtmDomainGeographicMapsLinks[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainGeographicMapsToTerraform(struct?: DataAkamaiGtmDomainGeographicMaps | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainGeographicMapsToHclTerraform(struct?: DataAkamaiGtmDomainGeographicMaps | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainGeographicMapsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainGeographicMaps | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainGeographicMaps | cdktf.IResolvable | undefined);
    get name(): string;
    private _assignments;
    get assignments(): DataAkamaiGtmDomainGeographicMapsAssignmentsList;
    putAssignments(value: DataAkamaiGtmDomainGeographicMapsAssignments[] | cdktf.IResolvable): void;
    resetAssignments(): void;
    get assignmentsInput(): cdktf.IResolvable | DataAkamaiGtmDomainGeographicMapsAssignments[] | undefined;
    private _defaultDatacenter;
    get defaultDatacenter(): DataAkamaiGtmDomainGeographicMapsDefaultDatacenterOutputReference;
    private _links;
    get links(): DataAkamaiGtmDomainGeographicMapsLinksList;
    putLinks(value: DataAkamaiGtmDomainGeographicMapsLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainGeographicMapsLinks[] | undefined;
}
export declare class DataAkamaiGtmDomainGeographicMapsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainGeographicMaps[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainGeographicMapsOutputReference;
}
export interface DataAkamaiGtmDomainLinks {
}
export declare function dataAkamaiGtmDomainLinksToTerraform(struct?: DataAkamaiGtmDomainLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainLinksToHclTerraform(struct?: DataAkamaiGtmDomainLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainLinksOutputReference;
}
export interface DataAkamaiGtmDomainPropertiesLinks {
}
export declare function dataAkamaiGtmDomainPropertiesLinksToTerraform(struct?: DataAkamaiGtmDomainPropertiesLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainPropertiesLinksToHclTerraform(struct?: DataAkamaiGtmDomainPropertiesLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainPropertiesLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainPropertiesLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainPropertiesLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainPropertiesLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainPropertiesLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainPropertiesLinksOutputReference;
}
export interface DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders {
}
export declare function dataAkamaiGtmDomainPropertiesLivenessTestsHttpHeadersToTerraform(struct?: DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainPropertiesLivenessTestsHttpHeadersToHclTerraform(struct?: DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders | cdktf.IResolvable | undefined);
    get name(): string;
    get value(): string;
}
export declare class DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeadersOutputReference;
}
export interface DataAkamaiGtmDomainPropertiesLivenessTests {
    /**
    * http_headers block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#http_headers DataAkamaiGtmDomain#http_headers}
    */
    readonly httpHeaders?: DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainPropertiesLivenessTestsToTerraform(struct?: DataAkamaiGtmDomainPropertiesLivenessTests | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainPropertiesLivenessTestsToHclTerraform(struct?: DataAkamaiGtmDomainPropertiesLivenessTests | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainPropertiesLivenessTestsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainPropertiesLivenessTests | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainPropertiesLivenessTests | cdktf.IResolvable | undefined);
    get answersRequired(): cdktf.IResolvable;
    get disableNonstandardPortWarning(): cdktf.IResolvable;
    get disabled(): cdktf.IResolvable;
    get errorPenalty(): number;
    get httpError3Xx(): cdktf.IResolvable;
    get httpError4Xx(): cdktf.IResolvable;
    get httpError5Xx(): cdktf.IResolvable;
    get name(): string;
    get peerCertificateVerification(): cdktf.IResolvable;
    get recursionRequested(): cdktf.IResolvable;
    get requestString(): string;
    get resourceType(): string;
    get responseString(): string;
    get sslClientCertificate(): string;
    get sslClientPrivateKey(): string;
    get testInterval(): number;
    get testObject(): string;
    get testObjectPassword(): string;
    get testObjectPort(): number;
    get testObjectProtocol(): string;
    get testObjectUsername(): string;
    get testTimeout(): number;
    get timeoutPenalty(): number;
    private _httpHeaders;
    get httpHeaders(): DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeadersList;
    putHttpHeaders(value: DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders[] | cdktf.IResolvable): void;
    resetHttpHeaders(): void;
    get httpHeadersInput(): cdktf.IResolvable | DataAkamaiGtmDomainPropertiesLivenessTestsHttpHeaders[] | undefined;
}
export declare class DataAkamaiGtmDomainPropertiesLivenessTestsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainPropertiesLivenessTests[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainPropertiesLivenessTestsOutputReference;
}
export interface DataAkamaiGtmDomainPropertiesStaticRrSets {
}
export declare function dataAkamaiGtmDomainPropertiesStaticRrSetsToTerraform(struct?: DataAkamaiGtmDomainPropertiesStaticRrSets | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainPropertiesStaticRrSetsToHclTerraform(struct?: DataAkamaiGtmDomainPropertiesStaticRrSets | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainPropertiesStaticRrSetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainPropertiesStaticRrSets | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainPropertiesStaticRrSets | cdktf.IResolvable | undefined);
    get rdata(): string[];
    get ttl(): number;
    get type(): string;
}
export declare class DataAkamaiGtmDomainPropertiesStaticRrSetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainPropertiesStaticRrSets[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainPropertiesStaticRrSetsOutputReference;
}
export interface DataAkamaiGtmDomainPropertiesTrafficTargets {
}
export declare function dataAkamaiGtmDomainPropertiesTrafficTargetsToTerraform(struct?: DataAkamaiGtmDomainPropertiesTrafficTargets | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainPropertiesTrafficTargetsToHclTerraform(struct?: DataAkamaiGtmDomainPropertiesTrafficTargets | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainPropertiesTrafficTargetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainPropertiesTrafficTargets | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainPropertiesTrafficTargets | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get enabled(): cdktf.IResolvable;
    get handoutCname(): string;
    get name(): string;
    get servers(): string[];
    get weight(): number;
}
export declare class DataAkamaiGtmDomainPropertiesTrafficTargetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainPropertiesTrafficTargets[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainPropertiesTrafficTargetsOutputReference;
}
export interface DataAkamaiGtmDomainProperties {
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#links DataAkamaiGtmDomain#links}
    */
    readonly links?: DataAkamaiGtmDomainPropertiesLinks[] | cdktf.IResolvable;
    /**
    * liveness_tests block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#liveness_tests DataAkamaiGtmDomain#liveness_tests}
    */
    readonly livenessTests?: DataAkamaiGtmDomainPropertiesLivenessTests[] | cdktf.IResolvable;
    /**
    * static_rr_sets block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#static_rr_sets DataAkamaiGtmDomain#static_rr_sets}
    */
    readonly staticRrSets?: DataAkamaiGtmDomainPropertiesStaticRrSets[] | cdktf.IResolvable;
    /**
    * traffic_targets block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#traffic_targets DataAkamaiGtmDomain#traffic_targets}
    */
    readonly trafficTargets?: DataAkamaiGtmDomainPropertiesTrafficTargets[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainPropertiesToTerraform(struct?: DataAkamaiGtmDomainProperties | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainPropertiesToHclTerraform(struct?: DataAkamaiGtmDomainProperties | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainPropertiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainProperties | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainProperties | cdktf.IResolvable | undefined);
    get backupCname(): string;
    get backupIp(): string;
    get balanceByDownloadScore(): cdktf.IResolvable;
    get cname(): string;
    get comments(): string;
    get dynamicTtl(): number;
    get failbackDelay(): number;
    get failoverDelay(): number;
    get ghostDemandReporting(): cdktf.IResolvable;
    get handoutLimit(): number;
    get handoutMode(): string;
    get healthMax(): number;
    get healthMultiplier(): number;
    get healthThreshold(): number;
    get ipv6(): cdktf.IResolvable;
    get lastModified(): string;
    get loadImbalancePercentage(): number;
    get mapName(): string;
    get maxUnreachablePenalty(): number;
    get minLiveFraction(): number;
    get name(): string;
    get scoreAggregationType(): string;
    get staticTtl(): number;
    get sticknessBonusConstant(): number;
    get sticknessBonusPercentage(): number;
    get type(): string;
    get unreachableThreshold(): number;
    get useComputedTargets(): cdktf.IResolvable;
    get weightedHashBitsForIpv4(): number;
    get weightedHashBitsForIpv6(): number;
    private _links;
    get links(): DataAkamaiGtmDomainPropertiesLinksList;
    putLinks(value: DataAkamaiGtmDomainPropertiesLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainPropertiesLinks[] | undefined;
    private _livenessTests;
    get livenessTests(): DataAkamaiGtmDomainPropertiesLivenessTestsList;
    putLivenessTests(value: DataAkamaiGtmDomainPropertiesLivenessTests[] | cdktf.IResolvable): void;
    resetLivenessTests(): void;
    get livenessTestsInput(): cdktf.IResolvable | DataAkamaiGtmDomainPropertiesLivenessTests[] | undefined;
    private _staticRrSets;
    get staticRrSets(): DataAkamaiGtmDomainPropertiesStaticRrSetsList;
    putStaticRrSets(value: DataAkamaiGtmDomainPropertiesStaticRrSets[] | cdktf.IResolvable): void;
    resetStaticRrSets(): void;
    get staticRrSetsInput(): cdktf.IResolvable | DataAkamaiGtmDomainPropertiesStaticRrSets[] | undefined;
    private _trafficTargets;
    get trafficTargets(): DataAkamaiGtmDomainPropertiesTrafficTargetsList;
    putTrafficTargets(value: DataAkamaiGtmDomainPropertiesTrafficTargets[] | cdktf.IResolvable): void;
    resetTrafficTargets(): void;
    get trafficTargetsInput(): cdktf.IResolvable | DataAkamaiGtmDomainPropertiesTrafficTargets[] | undefined;
}
export declare class DataAkamaiGtmDomainPropertiesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainProperties[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainPropertiesOutputReference;
}
export interface DataAkamaiGtmDomainResourcesLinks {
}
export declare function dataAkamaiGtmDomainResourcesLinksToTerraform(struct?: DataAkamaiGtmDomainResourcesLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainResourcesLinksToHclTerraform(struct?: DataAkamaiGtmDomainResourcesLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainResourcesLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainResourcesLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainResourcesLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainResourcesLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainResourcesLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainResourcesLinksOutputReference;
}
export interface DataAkamaiGtmDomainResourcesResourceInstances {
}
export declare function dataAkamaiGtmDomainResourcesResourceInstancesToTerraform(struct?: DataAkamaiGtmDomainResourcesResourceInstances | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainResourcesResourceInstancesToHclTerraform(struct?: DataAkamaiGtmDomainResourcesResourceInstances | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainResourcesResourceInstancesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainResourcesResourceInstances | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainResourcesResourceInstances | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get loadObject(): string;
    get loadObjectPort(): number;
    get loadServers(): string[];
    get useDefaultLoadObject(): cdktf.IResolvable;
}
export declare class DataAkamaiGtmDomainResourcesResourceInstancesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainResourcesResourceInstances[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainResourcesResourceInstancesOutputReference;
}
export interface DataAkamaiGtmDomainResources {
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#links DataAkamaiGtmDomain#links}
    */
    readonly links?: DataAkamaiGtmDomainResourcesLinks[] | cdktf.IResolvable;
    /**
    * resource_instances block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#resource_instances DataAkamaiGtmDomain#resource_instances}
    */
    readonly resourceInstances?: DataAkamaiGtmDomainResourcesResourceInstances[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainResourcesToTerraform(struct?: DataAkamaiGtmDomainResources | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainResourcesToHclTerraform(struct?: DataAkamaiGtmDomainResources | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainResources | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainResources | cdktf.IResolvable | undefined);
    get aggregationType(): string;
    get constrainedProperty(): string;
    get decayRate(): number;
    get description(): string;
    get hostHeader(): string;
    get leaderString(): string;
    get leastSquaresDecay(): number;
    get loadImbalancePercentage(): number;
    get maxUMultiplicativeIncrement(): number;
    get name(): string;
    get type(): string;
    get upperBound(): number;
    private _links;
    get links(): DataAkamaiGtmDomainResourcesLinksList;
    putLinks(value: DataAkamaiGtmDomainResourcesLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainResourcesLinks[] | undefined;
    private _resourceInstances;
    get resourceInstances(): DataAkamaiGtmDomainResourcesResourceInstancesList;
    putResourceInstances(value: DataAkamaiGtmDomainResourcesResourceInstances[] | cdktf.IResolvable): void;
    resetResourceInstances(): void;
    get resourceInstancesInput(): cdktf.IResolvable | DataAkamaiGtmDomainResourcesResourceInstances[] | undefined;
}
export declare class DataAkamaiGtmDomainResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainResources[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainResourcesOutputReference;
}
export interface DataAkamaiGtmDomainStatusLinks {
}
export declare function dataAkamaiGtmDomainStatusLinksToTerraform(struct?: DataAkamaiGtmDomainStatusLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainStatusLinksToHclTerraform(struct?: DataAkamaiGtmDomainStatusLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainStatusLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainStatusLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainStatusLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainStatusLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainStatusLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainStatusLinksOutputReference;
}
export interface DataAkamaiGtmDomainStatus {
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#links DataAkamaiGtmDomain#links}
    */
    readonly links?: DataAkamaiGtmDomainStatusLinks[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainStatusToTerraform(struct?: DataAkamaiGtmDomainStatus | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainStatusToHclTerraform(struct?: DataAkamaiGtmDomainStatus | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainStatusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiGtmDomainStatus | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainStatus | cdktf.IResolvable | undefined);
    get changeId(): string;
    get message(): string;
    get passingValidation(): cdktf.IResolvable;
    get propagationStatus(): string;
    get propagationStatusDate(): string;
    private _links;
    get links(): DataAkamaiGtmDomainStatusLinksList;
    putLinks(value: DataAkamaiGtmDomainStatusLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainStatusLinks[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain akamai_gtm_domain}
*/
export declare class DataAkamaiGtmDomain extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_gtm_domain";
    /**
    * Generates CDKTF code for importing a DataAkamaiGtmDomain resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiGtmDomain to import
    * @param importFromId The id of the existing DataAkamaiGtmDomain that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiGtmDomain to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domain akamai_gtm_domain} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiGtmDomainConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiGtmDomainConfig);
    get cnameCoalescingEnabled(): cdktf.IResolvable;
    get defaultErrorPenalty(): number;
    get defaultHealthMax(): number;
    get defaultHealthMultiplier(): number;
    get defaultHealthThreshold(): number;
    get defaultMaxUnreachablePenalty(): number;
    get defaultSslClientCertificate(): string;
    get defaultSslClientPrivateKey(): string;
    get defaultTimeoutPenalty(): number;
    get defaultUnreachableThreshold(): number;
    get emailNotificationList(): string[];
    get endUserMappingEnabled(): cdktf.IResolvable;
    get id(): string;
    get lastModified(): string;
    get lastModifiedBy(): string;
    get loadFeedback(): cdktf.IResolvable;
    get loadImbalancePercentage(): number;
    get mapUpdateInterval(): number;
    get maxProperties(): number;
    get maxResources(): number;
    get maxTestTimeout(): number;
    get maxTtl(): number;
    get minPingableRegionFraction(): number;
    get minTestInterval(): number;
    get minTtl(): number;
    get modificationComments(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get roundRobinPrefix(): string;
    get serverMonitorPool(): string;
    get type(): string;
    private _asMaps;
    get asMaps(): DataAkamaiGtmDomainAsMapsList;
    putAsMaps(value: DataAkamaiGtmDomainAsMaps[] | cdktf.IResolvable): void;
    resetAsMaps(): void;
    get asMapsInput(): cdktf.IResolvable | DataAkamaiGtmDomainAsMaps[] | undefined;
    private _cidrMaps;
    get cidrMaps(): DataAkamaiGtmDomainCidrMapsList;
    putCidrMaps(value: DataAkamaiGtmDomainCidrMaps[] | cdktf.IResolvable): void;
    resetCidrMaps(): void;
    get cidrMapsInput(): cdktf.IResolvable | DataAkamaiGtmDomainCidrMaps[] | undefined;
    private _datacenters;
    get datacenters(): DataAkamaiGtmDomainDatacentersList;
    putDatacenters(value: DataAkamaiGtmDomainDatacenters[] | cdktf.IResolvable): void;
    resetDatacenters(): void;
    get datacentersInput(): cdktf.IResolvable | DataAkamaiGtmDomainDatacenters[] | undefined;
    private _geographicMaps;
    get geographicMaps(): DataAkamaiGtmDomainGeographicMapsList;
    putGeographicMaps(value: DataAkamaiGtmDomainGeographicMaps[] | cdktf.IResolvable): void;
    resetGeographicMaps(): void;
    get geographicMapsInput(): cdktf.IResolvable | DataAkamaiGtmDomainGeographicMaps[] | undefined;
    private _links;
    get links(): DataAkamaiGtmDomainLinksList;
    putLinks(value: DataAkamaiGtmDomainLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainLinks[] | undefined;
    private _properties;
    get properties(): DataAkamaiGtmDomainPropertiesList;
    putProperties(value: DataAkamaiGtmDomainProperties[] | cdktf.IResolvable): void;
    resetProperties(): void;
    get propertiesInput(): cdktf.IResolvable | DataAkamaiGtmDomainProperties[] | undefined;
    private _resources;
    get resources(): DataAkamaiGtmDomainResourcesList;
    putResources(value: DataAkamaiGtmDomainResources[] | cdktf.IResolvable): void;
    resetResources(): void;
    get resourcesInput(): cdktf.IResolvable | DataAkamaiGtmDomainResources[] | undefined;
    private _status;
    get status(): DataAkamaiGtmDomainStatusOutputReference;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
