import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiGtmDomainsConfig extends cdktf.TerraformMetaArguments {
    /**
    * domains block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domains#domains DataAkamaiGtmDomains#domains}
    */
    readonly domains?: DataAkamaiGtmDomainsDomains[] | cdktf.IResolvable;
}
export interface DataAkamaiGtmDomainsDomainsLinks {
}
export declare function dataAkamaiGtmDomainsDomainsLinksToTerraform(struct?: DataAkamaiGtmDomainsDomainsLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainsDomainsLinksToHclTerraform(struct?: DataAkamaiGtmDomainsDomainsLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainsDomainsLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainsDomainsLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainsDomainsLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmDomainsDomainsLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainsDomainsLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainsDomainsLinksOutputReference;
}
export interface DataAkamaiGtmDomainsDomains {
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domains#links DataAkamaiGtmDomains#links}
    */
    readonly links?: DataAkamaiGtmDomainsDomainsLinks[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmDomainsDomainsToTerraform(struct?: DataAkamaiGtmDomainsDomains | cdktf.IResolvable): any;
export declare function dataAkamaiGtmDomainsDomainsToHclTerraform(struct?: DataAkamaiGtmDomainsDomains | cdktf.IResolvable): any;
export declare class DataAkamaiGtmDomainsDomainsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmDomainsDomains | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmDomainsDomains | cdktf.IResolvable | undefined);
    get acgId(): string;
    get activationState(): string;
    get changeId(): string;
    get deleteRequestId(): string;
    get lastModified(): string;
    get lastModifiedBy(): string;
    get modificationComments(): string;
    get name(): string;
    get signAndServe(): cdktf.IResolvable;
    get signAndServeAlgorithm(): string;
    get status(): string;
    private _links;
    get links(): DataAkamaiGtmDomainsDomainsLinksList;
    putLinks(value: DataAkamaiGtmDomainsDomainsLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmDomainsDomainsLinks[] | undefined;
}
export declare class DataAkamaiGtmDomainsDomainsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmDomainsDomains[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmDomainsDomainsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domains akamai_gtm_domains}
*/
export declare class DataAkamaiGtmDomains extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_gtm_domains";
    /**
    * Generates CDKTF code for importing a DataAkamaiGtmDomains resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiGtmDomains to import
    * @param importFromId The id of the existing DataAkamaiGtmDomains that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domains#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiGtmDomains to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_domains akamai_gtm_domains} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiGtmDomainsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiGtmDomainsConfig);
    get id(): string;
    private _domains;
    get domains(): DataAkamaiGtmDomainsDomainsList;
    putDomains(value: DataAkamaiGtmDomainsDomains[] | cdktf.IResolvable): void;
    resetDomains(): void;
    get domainsInput(): cdktf.IResolvable | DataAkamaiGtmDomainsDomains[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
