import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiGtmResourceConfig extends cdktf.TerraformMetaArguments {
    /**
    * GTM domain name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resource#domain DataAkamaiGtmResource#domain}
    */
    readonly domain: string;
    /**
    * A descriptive label for the resource.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resource#resource_name DataAkamaiGtmResource#resource_name}
    */
    readonly resourceName: string;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resource#links DataAkamaiGtmResource#links}
    */
    readonly links?: DataAkamaiGtmResourceLinks[] | cdktf.IResolvable;
    /**
    * resource_instances block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resource#resource_instances DataAkamaiGtmResource#resource_instances}
    */
    readonly resourceInstances?: DataAkamaiGtmResourceResourceInstances[] | cdktf.IResolvable;
}
export interface DataAkamaiGtmResourceLinks {
}
export declare function dataAkamaiGtmResourceLinksToTerraform(struct?: DataAkamaiGtmResourceLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmResourceLinksToHclTerraform(struct?: DataAkamaiGtmResourceLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmResourceLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmResourceLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmResourceLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmResourceLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmResourceLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmResourceLinksOutputReference;
}
export interface DataAkamaiGtmResourceResourceInstances {
}
export declare function dataAkamaiGtmResourceResourceInstancesToTerraform(struct?: DataAkamaiGtmResourceResourceInstances | cdktf.IResolvable): any;
export declare function dataAkamaiGtmResourceResourceInstancesToHclTerraform(struct?: DataAkamaiGtmResourceResourceInstances | cdktf.IResolvable): any;
export declare class DataAkamaiGtmResourceResourceInstancesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmResourceResourceInstances | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmResourceResourceInstances | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get loadObject(): string;
    get loadObjectPort(): number;
    get loadServers(): string[];
    get useDefaultLoadObject(): cdktf.IResolvable;
}
export declare class DataAkamaiGtmResourceResourceInstancesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmResourceResourceInstances[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmResourceResourceInstancesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resource akamai_gtm_resource}
*/
export declare class DataAkamaiGtmResource extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_gtm_resource";
    /**
    * Generates CDKTF code for importing a DataAkamaiGtmResource resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiGtmResource to import
    * @param importFromId The id of the existing DataAkamaiGtmResource that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resource#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiGtmResource to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resource akamai_gtm_resource} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiGtmResourceConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiGtmResourceConfig);
    get aggregationType(): string;
    get constrainedProperty(): string;
    get decayRate(): number;
    get description(): string;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    get hostHeader(): string;
    get id(): string;
    get leaderString(): string;
    get leastSquaresDecay(): number;
    get loadImbalancePercentage(): number;
    get maxUMultiplicativeIncrement(): number;
    private _resourceName?;
    get resourceName(): string;
    set resourceName(value: string);
    get resourceNameInput(): string | undefined;
    get type(): string;
    get upperBound(): number;
    private _links;
    get links(): DataAkamaiGtmResourceLinksList;
    putLinks(value: DataAkamaiGtmResourceLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmResourceLinks[] | undefined;
    private _resourceInstances;
    get resourceInstances(): DataAkamaiGtmResourceResourceInstancesList;
    putResourceInstances(value: DataAkamaiGtmResourceResourceInstances[] | cdktf.IResolvable): void;
    resetResourceInstances(): void;
    get resourceInstancesInput(): cdktf.IResolvable | DataAkamaiGtmResourceResourceInstances[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
