import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiGtmResourcesConfig extends cdktf.TerraformMetaArguments {
    /**
    * GTM domain name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resources#domain DataAkamaiGtmResources#domain}
    */
    readonly domain: string;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resources#resources DataAkamaiGtmResources#resources}
    */
    readonly resources?: DataAkamaiGtmResourcesResources[] | cdktf.IResolvable;
}
export interface DataAkamaiGtmResourcesResourcesLinks {
}
export declare function dataAkamaiGtmResourcesResourcesLinksToTerraform(struct?: DataAkamaiGtmResourcesResourcesLinks | cdktf.IResolvable): any;
export declare function dataAkamaiGtmResourcesResourcesLinksToHclTerraform(struct?: DataAkamaiGtmResourcesResourcesLinks | cdktf.IResolvable): any;
export declare class DataAkamaiGtmResourcesResourcesLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmResourcesResourcesLinks | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmResourcesResourcesLinks | cdktf.IResolvable | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataAkamaiGtmResourcesResourcesLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmResourcesResourcesLinks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmResourcesResourcesLinksOutputReference;
}
export interface DataAkamaiGtmResourcesResourcesResourceInstances {
}
export declare function dataAkamaiGtmResourcesResourcesResourceInstancesToTerraform(struct?: DataAkamaiGtmResourcesResourcesResourceInstances | cdktf.IResolvable): any;
export declare function dataAkamaiGtmResourcesResourcesResourceInstancesToHclTerraform(struct?: DataAkamaiGtmResourcesResourcesResourceInstances | cdktf.IResolvable): any;
export declare class DataAkamaiGtmResourcesResourcesResourceInstancesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmResourcesResourcesResourceInstances | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmResourcesResourcesResourceInstances | cdktf.IResolvable | undefined);
    get datacenterId(): number;
    get loadObject(): string;
    get loadObjectPort(): number;
    get loadServers(): string[];
    get useDefaultLoadObject(): cdktf.IResolvable;
}
export declare class DataAkamaiGtmResourcesResourcesResourceInstancesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmResourcesResourcesResourceInstances[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmResourcesResourcesResourceInstancesOutputReference;
}
export interface DataAkamaiGtmResourcesResources {
    /**
    * A descriptive label for the resource.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resources#name DataAkamaiGtmResources#name}
    */
    readonly name: string;
    /**
    * links block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resources#links DataAkamaiGtmResources#links}
    */
    readonly links?: DataAkamaiGtmResourcesResourcesLinks[] | cdktf.IResolvable;
    /**
    * resource_instances block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resources#resource_instances DataAkamaiGtmResources#resource_instances}
    */
    readonly resourceInstances?: DataAkamaiGtmResourcesResourcesResourceInstances[] | cdktf.IResolvable;
}
export declare function dataAkamaiGtmResourcesResourcesToTerraform(struct?: DataAkamaiGtmResourcesResources | cdktf.IResolvable): any;
export declare function dataAkamaiGtmResourcesResourcesToHclTerraform(struct?: DataAkamaiGtmResourcesResources | cdktf.IResolvable): any;
export declare class DataAkamaiGtmResourcesResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiGtmResourcesResources | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiGtmResourcesResources | cdktf.IResolvable | undefined);
    get aggregationType(): string;
    get constrainedProperty(): string;
    get decayRate(): number;
    get description(): string;
    get hostHeader(): string;
    get leaderString(): string;
    get leastSquaresDecay(): number;
    get loadImbalancePercentage(): number;
    get maxUMultiplicativeIncrement(): number;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get type(): string;
    get upperBound(): number;
    private _links;
    get links(): DataAkamaiGtmResourcesResourcesLinksList;
    putLinks(value: DataAkamaiGtmResourcesResourcesLinks[] | cdktf.IResolvable): void;
    resetLinks(): void;
    get linksInput(): cdktf.IResolvable | DataAkamaiGtmResourcesResourcesLinks[] | undefined;
    private _resourceInstances;
    get resourceInstances(): DataAkamaiGtmResourcesResourcesResourceInstancesList;
    putResourceInstances(value: DataAkamaiGtmResourcesResourcesResourceInstances[] | cdktf.IResolvable): void;
    resetResourceInstances(): void;
    get resourceInstancesInput(): cdktf.IResolvable | DataAkamaiGtmResourcesResourcesResourceInstances[] | undefined;
}
export declare class DataAkamaiGtmResourcesResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiGtmResourcesResources[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiGtmResourcesResourcesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resources akamai_gtm_resources}
*/
export declare class DataAkamaiGtmResources extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_gtm_resources";
    /**
    * Generates CDKTF code for importing a DataAkamaiGtmResources resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiGtmResources to import
    * @param importFromId The id of the existing DataAkamaiGtmResources that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resources#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiGtmResources to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/gtm_resources akamai_gtm_resources} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiGtmResourcesConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiGtmResourcesConfig);
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    get id(): string;
    private _resources;
    get resources(): DataAkamaiGtmResourcesResourcesList;
    putResources(value: DataAkamaiGtmResourcesResources[] | cdktf.IResolvable): void;
    resetResources(): void;
    get resourcesInput(): cdktf.IResolvable | DataAkamaiGtmResourcesResources[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
