import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiIamGrantableRolesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_grantable_roles#id DataAkamaiIamGrantableRoles#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataAkamaiIamGrantableRolesGrantableRoles {
}
export declare function dataAkamaiIamGrantableRolesGrantableRolesToTerraform(struct?: DataAkamaiIamGrantableRolesGrantableRoles): any;
export declare function dataAkamaiIamGrantableRolesGrantableRolesToHclTerraform(struct?: DataAkamaiIamGrantableRolesGrantableRoles): any;
export declare class DataAkamaiIamGrantableRolesGrantableRolesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiIamGrantableRolesGrantableRoles | undefined;
    set internalValue(value: DataAkamaiIamGrantableRolesGrantableRoles | undefined);
    get description(): string;
    get grantedRoleId(): number;
    get name(): string;
}
export declare class DataAkamaiIamGrantableRolesGrantableRolesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiIamGrantableRolesGrantableRolesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_grantable_roles akamai_iam_grantable_roles}
*/
export declare class DataAkamaiIamGrantableRoles extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_iam_grantable_roles";
    /**
    * Generates CDKTF code for importing a DataAkamaiIamGrantableRoles resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiIamGrantableRoles to import
    * @param importFromId The id of the existing DataAkamaiIamGrantableRoles that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_grantable_roles#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiIamGrantableRoles to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_grantable_roles akamai_iam_grantable_roles} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiIamGrantableRolesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiIamGrantableRolesConfig);
    private _grantableRoles;
    get grantableRoles(): DataAkamaiIamGrantableRolesGrantableRolesList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
