import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiIamGroupsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_groups#id DataAkamaiIamGroups#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataAkamaiIamGroupsGroupsSubGroups {
}
export declare function dataAkamaiIamGroupsGroupsSubGroupsToTerraform(struct?: DataAkamaiIamGroupsGroupsSubGroups): any;
export declare function dataAkamaiIamGroupsGroupsSubGroupsToHclTerraform(struct?: DataAkamaiIamGroupsGroupsSubGroups): any;
export declare class DataAkamaiIamGroupsGroupsSubGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiIamGroupsGroupsSubGroups | undefined;
    set internalValue(value: DataAkamaiIamGroupsGroupsSubGroups | undefined);
    get createdBy(): string;
    get groupId(): string;
    get modifiedBy(): string;
    get name(): string;
    get parentGroupId(): string;
    private _subGroups;
    get subGroups(): DataAkamaiIamGroupsGroupsSubGroupsList;
    get timeCreated(): string;
    get timeModified(): string;
}
export declare class DataAkamaiIamGroupsGroupsSubGroupsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiIamGroupsGroupsSubGroupsOutputReference;
}
export interface DataAkamaiIamGroupsGroups {
}
export declare function dataAkamaiIamGroupsGroupsToTerraform(struct?: DataAkamaiIamGroupsGroups): any;
export declare function dataAkamaiIamGroupsGroupsToHclTerraform(struct?: DataAkamaiIamGroupsGroups): any;
export declare class DataAkamaiIamGroupsGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiIamGroupsGroups | undefined;
    set internalValue(value: DataAkamaiIamGroupsGroups | undefined);
    get createdBy(): string;
    get groupId(): string;
    get modifiedBy(): string;
    get name(): string;
    get parentGroupId(): string;
    private _subGroups;
    get subGroups(): DataAkamaiIamGroupsGroupsSubGroupsList;
    get timeCreated(): string;
    get timeModified(): string;
}
export declare class DataAkamaiIamGroupsGroupsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiIamGroupsGroupsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_groups akamai_iam_groups}
*/
export declare class DataAkamaiIamGroups extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_iam_groups";
    /**
    * Generates CDKTF code for importing a DataAkamaiIamGroups resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiIamGroups to import
    * @param importFromId The id of the existing DataAkamaiIamGroups that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_groups#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiIamGroups to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_groups akamai_iam_groups} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiIamGroupsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiIamGroupsConfig);
    private _groups;
    get groups(): DataAkamaiIamGroupsGroupsList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
