import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiIamStatesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Specifies a US state or Canadian province
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_states#country DataAkamaiIamStates#country}
    */
    readonly country: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_states#id DataAkamaiIamStates#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_states akamai_iam_states}
*/
export declare class DataAkamaiIamStates extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_iam_states";
    /**
    * Generates CDKTF code for importing a DataAkamaiIamStates resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiIamStates to import
    * @param importFromId The id of the existing DataAkamaiIamStates that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_states#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiIamStates to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_states akamai_iam_states} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiIamStatesConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiIamStatesConfig);
    private _country?;
    get country(): string;
    set country(value: string);
    get countryInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get states(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
