import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiIamTimeoutPoliciesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_timeout_policies#id DataAkamaiIamTimeoutPolicies#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_timeout_policies akamai_iam_timeout_policies}
*/
export declare class DataAkamaiIamTimeoutPolicies extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_iam_timeout_policies";
    /**
    * Generates CDKTF code for importing a DataAkamaiIamTimeoutPolicies resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiIamTimeoutPolicies to import
    * @param importFromId The id of the existing DataAkamaiIamTimeoutPolicies that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_timeout_policies#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiIamTimeoutPolicies to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/iam_timeout_policies akamai_iam_timeout_policies} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiIamTimeoutPoliciesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiIamTimeoutPoliciesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _policies;
    get policies(): cdktf.NumberMap;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
