import { DataAkamaiImagingPolicyImagePolicy, DataAkamaiImagingPolicyImagePolicyOutputReference } from './index-structs';
export * from './index-structs';
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiImagingPolicyImageConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#id DataAkamaiImagingPolicyImage#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#policy DataAkamaiImagingPolicyImage#policy}
    */
    readonly policy: DataAkamaiImagingPolicyImagePolicy;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image akamai_imaging_policy_image}
*/
export declare class DataAkamaiImagingPolicyImage extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_imaging_policy_image";
    /**
    * Generates CDKTF code for importing a DataAkamaiImagingPolicyImage resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiImagingPolicyImage to import
    * @param importFromId The id of the existing DataAkamaiImagingPolicyImage that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiImagingPolicyImage to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image akamai_imaging_policy_image} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiImagingPolicyImageConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiImagingPolicyImageConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _policy;
    get policy(): DataAkamaiImagingPolicyImagePolicyOutputReference;
    putPolicy(value: DataAkamaiImagingPolicyImagePolicy): void;
    get policyInput(): DataAkamaiImagingPolicyImagePolicy | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
