import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiImagingPolicyVideoConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#id DataAkamaiImagingPolicyVideo#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#policy DataAkamaiImagingPolicyVideo#policy}
    */
    readonly policy: DataAkamaiImagingPolicyVideoPolicy;
}
export interface DataAkamaiImagingPolicyVideoPolicyBreakpoints {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#widths DataAkamaiImagingPolicyVideo#widths}
    */
    readonly widths?: number[];
}
export declare function dataAkamaiImagingPolicyVideoPolicyBreakpointsToTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyBreakpointsOutputReference | DataAkamaiImagingPolicyVideoPolicyBreakpoints): any;
export declare function dataAkamaiImagingPolicyVideoPolicyBreakpointsToHclTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyBreakpointsOutputReference | DataAkamaiImagingPolicyVideoPolicyBreakpoints): any;
export declare class DataAkamaiImagingPolicyVideoPolicyBreakpointsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyVideoPolicyBreakpoints | undefined;
    set internalValue(value: DataAkamaiImagingPolicyVideoPolicyBreakpoints | undefined);
    private _widths?;
    get widths(): number[];
    set widths(value: number[]);
    resetWidths(): void;
    get widthsInput(): number[] | undefined;
}
export interface DataAkamaiImagingPolicyVideoPolicyOutput {
    /**
    * The quality of derivative videos. High preserves video quality with reduced byte savings while low reduces video quality to increase byte savings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#perceptual_quality DataAkamaiImagingPolicyVideo#perceptual_quality}
    */
    readonly perceptualQuality?: string;
    /**
    * The quality of derivative videos. High preserves video quality with reduced byte savings while low reduces video quality to increase byte savings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#perceptual_quality_var DataAkamaiImagingPolicyVideo#perceptual_quality_var}
    */
    readonly perceptualQualityVar?: string;
    /**
    * Allows you to add a specific placeholder video that appears when a user first requests a video, but before Image & Video Manager processes the video. If not specified the original video plays during the processing time.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#placeholder_video_url DataAkamaiImagingPolicyVideo#placeholder_video_url}
    */
    readonly placeholderVideoUrl?: string;
    /**
    * Allows you to add a specific placeholder video that appears when a user first requests a video, but before Image & Video Manager processes the video. If not specified the original video plays during the processing time.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#placeholder_video_url_var DataAkamaiImagingPolicyVideo#placeholder_video_url_var}
    */
    readonly placeholderVideoUrlVar?: string;
    /**
    * Override the quality of video to serve when Image & Video Manager detects a slow connection. Specifying lower values lets users with slow connections browse your site with reduced load times without impacting the quality of videos for users with faster connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#video_adaptive_quality DataAkamaiImagingPolicyVideo#video_adaptive_quality}
    */
    readonly videoAdaptiveQuality?: string;
    /**
    * Override the quality of video to serve when Image & Video Manager detects a slow connection. Specifying lower values lets users with slow connections browse your site with reduced load times without impacting the quality of videos for users with faster connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#video_adaptive_quality_var DataAkamaiImagingPolicyVideo#video_adaptive_quality_var}
    */
    readonly videoAdaptiveQualityVar?: string;
}
export declare function dataAkamaiImagingPolicyVideoPolicyOutputToTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyOutputOutputReference | DataAkamaiImagingPolicyVideoPolicyOutput): any;
export declare function dataAkamaiImagingPolicyVideoPolicyOutputToHclTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyOutputOutputReference | DataAkamaiImagingPolicyVideoPolicyOutput): any;
export declare class DataAkamaiImagingPolicyVideoPolicyOutputOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyVideoPolicyOutput | undefined;
    set internalValue(value: DataAkamaiImagingPolicyVideoPolicyOutput | undefined);
    private _perceptualQuality?;
    get perceptualQuality(): string;
    set perceptualQuality(value: string);
    resetPerceptualQuality(): void;
    get perceptualQualityInput(): string | undefined;
    private _perceptualQualityVar?;
    get perceptualQualityVar(): string;
    set perceptualQualityVar(value: string);
    resetPerceptualQualityVar(): void;
    get perceptualQualityVarInput(): string | undefined;
    private _placeholderVideoUrl?;
    get placeholderVideoUrl(): string;
    set placeholderVideoUrl(value: string);
    resetPlaceholderVideoUrl(): void;
    get placeholderVideoUrlInput(): string | undefined;
    private _placeholderVideoUrlVar?;
    get placeholderVideoUrlVar(): string;
    set placeholderVideoUrlVar(value: string);
    resetPlaceholderVideoUrlVar(): void;
    get placeholderVideoUrlVarInput(): string | undefined;
    private _videoAdaptiveQuality?;
    get videoAdaptiveQuality(): string;
    set videoAdaptiveQuality(value: string);
    resetVideoAdaptiveQuality(): void;
    get videoAdaptiveQualityInput(): string | undefined;
    private _videoAdaptiveQualityVar?;
    get videoAdaptiveQualityVar(): string;
    set videoAdaptiveQualityVar(value: string);
    resetVideoAdaptiveQualityVar(): void;
    get videoAdaptiveQualityVarInput(): string | undefined;
}
export interface DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions {
    /**
    * The unique identifier for each enum value, up to 50 alphanumeric characters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#id DataAkamaiImagingPolicyVideo#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
    /**
    * The value of the variable when the `id` is provided.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#value DataAkamaiImagingPolicyVideo#value}
    */
    readonly value: string;
}
export declare function dataAkamaiImagingPolicyVideoPolicyVariablesEnumOptionsToTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyVideoPolicyVariablesEnumOptionsToHclTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions | cdktf.IResolvable | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptionsOutputReference;
}
export interface DataAkamaiImagingPolicyVideoPolicyVariables {
    /**
    * The default value of the variable if no query parameter is provided. It needs to be one of the `enumOptions` if any are provided.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#default_value DataAkamaiImagingPolicyVideo#default_value}
    */
    readonly defaultValue: string;
    /**
    * The name of the variable, also available as the query parameter name to set the variable's value dynamically. Use up to 50 alphanumeric characters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#name DataAkamaiImagingPolicyVideo#name}
    */
    readonly name: string;
    /**
    * A postfix added to the value provided for the variable, or to the default value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#postfix DataAkamaiImagingPolicyVideo#postfix}
    */
    readonly postfix?: string;
    /**
    * A prefix added to the value provided for the variable, or to the default value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#prefix DataAkamaiImagingPolicyVideo#prefix}
    */
    readonly prefix?: string;
    /**
    * The type of value for the variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#type DataAkamaiImagingPolicyVideo#type}
    */
    readonly type: string;
    /**
    * enum_options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#enum_options DataAkamaiImagingPolicyVideo#enum_options}
    */
    readonly enumOptions?: DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyVideoPolicyVariablesToTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyVariables | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyVideoPolicyVariablesToHclTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyVariables | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyVideoPolicyVariablesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyVideoPolicyVariables | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyVideoPolicyVariables | cdktf.IResolvable | undefined);
    private _defaultValue?;
    get defaultValue(): string;
    set defaultValue(value: string);
    get defaultValueInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _postfix?;
    get postfix(): string;
    set postfix(value: string);
    resetPostfix(): void;
    get postfixInput(): string | undefined;
    private _prefix?;
    get prefix(): string;
    set prefix(value: string);
    resetPrefix(): void;
    get prefixInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _enumOptions;
    get enumOptions(): DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptionsList;
    putEnumOptions(value: DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions[] | cdktf.IResolvable): void;
    resetEnumOptions(): void;
    get enumOptionsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyVideoPolicyVariablesEnumOptions[] | undefined;
}
export declare class DataAkamaiImagingPolicyVideoPolicyVariablesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyVideoPolicyVariables[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyVideoPolicyVariablesOutputReference;
}
export interface DataAkamaiImagingPolicyVideoPolicy {
    /**
    * Hosts that are allowed for image/video URLs within transformations or variables.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#hosts DataAkamaiImagingPolicyVideo#hosts}
    */
    readonly hosts?: string[];
    /**
    * The amount of time in seconds that the policy takes to rollout. During the rollout an increasing proportion of images/videos will begin to use the new policy instead of the cached images/videos from the previous version. This value has no effect on the staging network.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#rollout_duration DataAkamaiImagingPolicyVideo#rollout_duration}
    */
    readonly rolloutDuration?: string;
    /**
    * breakpoints block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#breakpoints DataAkamaiImagingPolicyVideo#breakpoints}
    */
    readonly breakpoints?: DataAkamaiImagingPolicyVideoPolicyBreakpoints;
    /**
    * output block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#output DataAkamaiImagingPolicyVideo#output}
    */
    readonly output?: DataAkamaiImagingPolicyVideoPolicyOutput;
    /**
    * variables block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#variables DataAkamaiImagingPolicyVideo#variables}
    */
    readonly variables?: DataAkamaiImagingPolicyVideoPolicyVariables[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyVideoPolicyToTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyOutputReference | DataAkamaiImagingPolicyVideoPolicy): any;
export declare function dataAkamaiImagingPolicyVideoPolicyToHclTerraform(struct?: DataAkamaiImagingPolicyVideoPolicyOutputReference | DataAkamaiImagingPolicyVideoPolicy): any;
export declare class DataAkamaiImagingPolicyVideoPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyVideoPolicy | undefined;
    set internalValue(value: DataAkamaiImagingPolicyVideoPolicy | undefined);
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _rolloutDuration?;
    get rolloutDuration(): string;
    set rolloutDuration(value: string);
    resetRolloutDuration(): void;
    get rolloutDurationInput(): string | undefined;
    private _breakpoints;
    get breakpoints(): DataAkamaiImagingPolicyVideoPolicyBreakpointsOutputReference;
    putBreakpoints(value: DataAkamaiImagingPolicyVideoPolicyBreakpoints): void;
    resetBreakpoints(): void;
    get breakpointsInput(): DataAkamaiImagingPolicyVideoPolicyBreakpoints | undefined;
    private _output;
    get output(): DataAkamaiImagingPolicyVideoPolicyOutputOutputReference;
    putOutput(value: DataAkamaiImagingPolicyVideoPolicyOutput): void;
    resetOutput(): void;
    get outputInput(): DataAkamaiImagingPolicyVideoPolicyOutput | undefined;
    private _variables;
    get variables(): DataAkamaiImagingPolicyVideoPolicyVariablesList;
    putVariables(value: DataAkamaiImagingPolicyVideoPolicyVariables[] | cdktf.IResolvable): void;
    resetVariables(): void;
    get variablesInput(): cdktf.IResolvable | DataAkamaiImagingPolicyVideoPolicyVariables[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video akamai_imaging_policy_video}
*/
export declare class DataAkamaiImagingPolicyVideo extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_imaging_policy_video";
    /**
    * Generates CDKTF code for importing a DataAkamaiImagingPolicyVideo resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiImagingPolicyVideo to import
    * @param importFromId The id of the existing DataAkamaiImagingPolicyVideo that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiImagingPolicyVideo to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_video akamai_imaging_policy_video} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiImagingPolicyVideoConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiImagingPolicyVideoConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _policy;
    get policy(): DataAkamaiImagingPolicyVideoPolicyOutputReference;
    putPolicy(value: DataAkamaiImagingPolicyVideoPolicy): void;
    get policyInput(): DataAkamaiImagingPolicyVideoPolicy | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
