import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiNetworklistNetworkListsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/networklist_network_lists#id DataAkamaiNetworklistNetworkLists#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/networklist_network_lists#name DataAkamaiNetworklistNetworkLists#name}
    */
    readonly name?: string;
    /**
    * The ID of a specific network list to retrieve. If not supplied, information about all network lists will be returned.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/networklist_network_lists#network_list_id DataAkamaiNetworklistNetworkLists#network_list_id}
    */
    readonly networkListId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/networklist_network_lists#type DataAkamaiNetworklistNetworkLists#type}
    */
    readonly type?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/networklist_network_lists akamai_networklist_network_lists}
*/
export declare class DataAkamaiNetworklistNetworkLists extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_networklist_network_lists";
    /**
    * Generates CDKTF code for importing a DataAkamaiNetworklistNetworkLists resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiNetworklistNetworkLists to import
    * @param importFromId The id of the existing DataAkamaiNetworklistNetworkLists that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/networklist_network_lists#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiNetworklistNetworkLists to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/networklist_network_lists akamai_networklist_network_lists} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiNetworklistNetworkListsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiNetworklistNetworkListsConfig);
    get contractId(): string;
    get groupId(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get list(): string[];
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkListId?;
    get networkListId(): string;
    set networkListId(value: string);
    resetNetworkListId(): void;
    get networkListIdInput(): string | undefined;
    get outputText(): string;
    get syncPoint(): number;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
