import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyHostnamesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_hostnames#contract_id DataAkamaiPropertyHostnames#contract_id}
    */
    readonly contractId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_hostnames#group_id DataAkamaiPropertyHostnames#group_id}
    */
    readonly groupId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_hostnames#id DataAkamaiPropertyHostnames#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_hostnames#property_id DataAkamaiPropertyHostnames#property_id}
    */
    readonly propertyId: string;
    /**
    * Version of property to fetch hostnames for. If not provided, 'latest' is used
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_hostnames#version DataAkamaiPropertyHostnames#version}
    */
    readonly version?: number;
}
export interface DataAkamaiPropertyHostnamesHostnamesCertStatus {
}
export declare function dataAkamaiPropertyHostnamesHostnamesCertStatusToTerraform(struct?: DataAkamaiPropertyHostnamesHostnamesCertStatus): any;
export declare function dataAkamaiPropertyHostnamesHostnamesCertStatusToHclTerraform(struct?: DataAkamaiPropertyHostnamesHostnamesCertStatus): any;
export declare class DataAkamaiPropertyHostnamesHostnamesCertStatusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyHostnamesHostnamesCertStatus | undefined;
    set internalValue(value: DataAkamaiPropertyHostnamesHostnamesCertStatus | undefined);
    get hostname(): string;
    get productionStatus(): string;
    get stagingStatus(): string;
    get target(): string;
}
export declare class DataAkamaiPropertyHostnamesHostnamesCertStatusList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyHostnamesHostnamesCertStatusOutputReference;
}
export interface DataAkamaiPropertyHostnamesHostnames {
}
export declare function dataAkamaiPropertyHostnamesHostnamesToTerraform(struct?: DataAkamaiPropertyHostnamesHostnames): any;
export declare function dataAkamaiPropertyHostnamesHostnamesToHclTerraform(struct?: DataAkamaiPropertyHostnamesHostnames): any;
export declare class DataAkamaiPropertyHostnamesHostnamesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyHostnamesHostnames | undefined;
    set internalValue(value: DataAkamaiPropertyHostnamesHostnames | undefined);
    get certProvisioningType(): string;
    private _certStatus;
    get certStatus(): DataAkamaiPropertyHostnamesHostnamesCertStatusList;
    get cnameFrom(): string;
    get cnameTo(): string;
    get cnameType(): string;
    get edgeHostnameId(): string;
}
export declare class DataAkamaiPropertyHostnamesHostnamesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyHostnamesHostnamesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_hostnames akamai_property_hostnames}
*/
export declare class DataAkamaiPropertyHostnames extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_property_hostnames";
    /**
    * Generates CDKTF code for importing a DataAkamaiPropertyHostnames resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiPropertyHostnames to import
    * @param importFromId The id of the existing DataAkamaiPropertyHostnames that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_hostnames#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiPropertyHostnames to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_hostnames akamai_property_hostnames} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiPropertyHostnamesConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiPropertyHostnamesConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    get contractIdInput(): string | undefined;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    get groupIdInput(): string | undefined;
    private _hostnames;
    get hostnames(): DataAkamaiPropertyHostnamesHostnamesList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _propertyId?;
    get propertyId(): string;
    set propertyId(value: string);
    get propertyIdInput(): string | undefined;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
