import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyIncludeActivationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifies the contract under which the include is activated
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_activation#contract_id DataAkamaiPropertyIncludeActivation#contract_id}
    */
    readonly contractId: string;
    /**
    * Identifies the group under which the include is activated
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_activation#group_id DataAkamaiPropertyIncludeActivation#group_id}
    */
    readonly groupId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_activation#id DataAkamaiPropertyIncludeActivation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Identifies include targeted with activation
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_activation#include_id DataAkamaiPropertyIncludeActivation#include_id}
    */
    readonly includeId: string;
    /**
    * The network for which the activation is to be found
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_activation#network DataAkamaiPropertyIncludeActivation#network}
    */
    readonly network: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_activation akamai_property_include_activation}
*/
export declare class DataAkamaiPropertyIncludeActivation extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_property_include_activation";
    /**
    * Generates CDKTF code for importing a DataAkamaiPropertyIncludeActivation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiPropertyIncludeActivation to import
    * @param importFromId The id of the existing DataAkamaiPropertyIncludeActivation that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_activation#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiPropertyIncludeActivation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_activation akamai_property_include_activation} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiPropertyIncludeActivationConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiPropertyIncludeActivationConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    get contractIdInput(): string | undefined;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    get groupIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _includeId?;
    get includeId(): string;
    set includeId(value: string);
    get includeIdInput(): string | undefined;
    get name(): string;
    private _network?;
    get network(): string;
    set network(value: string);
    get networkInput(): string | undefined;
    get note(): string;
    get notifyEmails(): string[];
    get version(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
