import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyIncludeRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifies the contract under which the include was created
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_rules#contract_id DataAkamaiPropertyIncludeRules#contract_id}
    */
    readonly contractId: string;
    /**
    * Identifies the group under which the include was created
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_rules#group_id DataAkamaiPropertyIncludeRules#group_id}
    */
    readonly groupId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_rules#id DataAkamaiPropertyIncludeRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The unique identifier of the property include
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_rules#include_id DataAkamaiPropertyIncludeRules#include_id}
    */
    readonly includeId: string;
    /**
    * The version of the include that a rule tree represents
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_rules#version DataAkamaiPropertyIncludeRules#version}
    */
    readonly version: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_rules akamai_property_include_rules}
*/
export declare class DataAkamaiPropertyIncludeRules extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_property_include_rules";
    /**
    * Generates CDKTF code for importing a DataAkamaiPropertyIncludeRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiPropertyIncludeRules to import
    * @param importFromId The id of the existing DataAkamaiPropertyIncludeRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiPropertyIncludeRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include_rules akamai_property_include_rules} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiPropertyIncludeRulesConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiPropertyIncludeRulesConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    get contractIdInput(): string | undefined;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    get groupIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _includeId?;
    get includeId(): string;
    set includeId(value: string);
    get includeIdInput(): string | undefined;
    get name(): string;
    get ruleErrors(): string;
    get ruleFormat(): string;
    get ruleWarnings(): string;
    get rules(): string;
    get type(): string;
    private _version?;
    get version(): number;
    set version(value: number);
    get versionInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
