import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyIncludeConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifies the contract under which the include was created
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include#contract_id DataAkamaiPropertyInclude#contract_id}
    */
    readonly contractId: string;
    /**
    * Identifies the group under which the include was created
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include#group_id DataAkamaiPropertyInclude#group_id}
    */
    readonly groupId: string;
    /**
    * Identifies the group under which the include was created
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include#include_id DataAkamaiPropertyInclude#include_id}
    */
    readonly includeId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include akamai_property_include}
*/
export declare class DataAkamaiPropertyInclude extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_property_include";
    /**
    * Generates CDKTF code for importing a DataAkamaiPropertyInclude resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiPropertyInclude to import
    * @param importFromId The id of the existing DataAkamaiPropertyInclude that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiPropertyInclude to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_include akamai_property_include} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiPropertyIncludeConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiPropertyIncludeConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    get contractIdInput(): string | undefined;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    get groupIdInput(): string | undefined;
    get id(): string;
    private _includeId?;
    get includeId(): string;
    set includeId(value: string);
    get includeIdInput(): string | undefined;
    get latestVersion(): number;
    get name(): string;
    get productionVersion(): number;
    get stagingVersion(): number;
    get type(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
