import { DataAkamaiPropertyRulesBuilderRulesV20230105, DataAkamaiPropertyRulesBuilderRulesV20230105OutputReference, DataAkamaiPropertyRulesBuilderRulesV20230530, DataAkamaiPropertyRulesBuilderRulesV20230530OutputReference, DataAkamaiPropertyRulesBuilderRulesV20230920, DataAkamaiPropertyRulesBuilderRulesV20230920OutputReference, DataAkamaiPropertyRulesBuilderRulesV20231030, DataAkamaiPropertyRulesBuilderRulesV20231030OutputReference, DataAkamaiPropertyRulesBuilderRulesV20240109, DataAkamaiPropertyRulesBuilderRulesV20240109OutputReference } from './index-structs';
export * from './index-structs';
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyRulesBuilderConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * rules_v2023_01_05 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_01_05 DataAkamaiPropertyRulesBuilder#rules_v2023_01_05}
    */
    readonly rulesV20230105?: DataAkamaiPropertyRulesBuilderRulesV20230105;
    /**
    * rules_v2023_05_30 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_05_30 DataAkamaiPropertyRulesBuilder#rules_v2023_05_30}
    */
    readonly rulesV20230530?: DataAkamaiPropertyRulesBuilderRulesV20230530;
    /**
    * rules_v2023_09_20 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_09_20 DataAkamaiPropertyRulesBuilder#rules_v2023_09_20}
    */
    readonly rulesV20230920?: DataAkamaiPropertyRulesBuilderRulesV20230920;
    /**
    * rules_v2023_10_30 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_10_30 DataAkamaiPropertyRulesBuilder#rules_v2023_10_30}
    */
    readonly rulesV20231030?: DataAkamaiPropertyRulesBuilderRulesV20231030;
    /**
    * rules_v2024_01_09 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2024_01_09 DataAkamaiPropertyRulesBuilder#rules_v2024_01_09}
    */
    readonly rulesV20240109?: DataAkamaiPropertyRulesBuilderRulesV20240109;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder akamai_property_rules_builder}
*/
export declare class DataAkamaiPropertyRulesBuilder extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_property_rules_builder";
    /**
    * Generates CDKTF code for importing a DataAkamaiPropertyRulesBuilder resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiPropertyRulesBuilder to import
    * @param importFromId The id of the existing DataAkamaiPropertyRulesBuilder that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiPropertyRulesBuilder to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder akamai_property_rules_builder} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiPropertyRulesBuilderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiPropertyRulesBuilderConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    get ruleFormat(): string;
    private _rulesV20230105;
    get rulesV20230105(): DataAkamaiPropertyRulesBuilderRulesV20230105OutputReference;
    putRulesV20230105(value: DataAkamaiPropertyRulesBuilderRulesV20230105): void;
    resetRulesV20230105(): void;
    get rulesV20230105Input(): DataAkamaiPropertyRulesBuilderRulesV20230105 | undefined;
    private _rulesV20230530;
    get rulesV20230530(): DataAkamaiPropertyRulesBuilderRulesV20230530OutputReference;
    putRulesV20230530(value: DataAkamaiPropertyRulesBuilderRulesV20230530): void;
    resetRulesV20230530(): void;
    get rulesV20230530Input(): DataAkamaiPropertyRulesBuilderRulesV20230530 | undefined;
    private _rulesV20230920;
    get rulesV20230920(): DataAkamaiPropertyRulesBuilderRulesV20230920OutputReference;
    putRulesV20230920(value: DataAkamaiPropertyRulesBuilderRulesV20230920): void;
    resetRulesV20230920(): void;
    get rulesV20230920Input(): DataAkamaiPropertyRulesBuilderRulesV20230920 | undefined;
    private _rulesV20231030;
    get rulesV20231030(): DataAkamaiPropertyRulesBuilderRulesV20231030OutputReference;
    putRulesV20231030(value: DataAkamaiPropertyRulesBuilderRulesV20231030): void;
    resetRulesV20231030(): void;
    get rulesV20231030Input(): DataAkamaiPropertyRulesBuilderRulesV20231030 | undefined;
    private _rulesV20240109;
    get rulesV20240109(): DataAkamaiPropertyRulesBuilderRulesV20240109OutputReference;
    putRulesV20240109(value: DataAkamaiPropertyRulesBuilderRulesV20240109): void;
    resetRulesV20240109(): void;
    get rulesV20240109Input(): DataAkamaiPropertyRulesBuilderRulesV20240109 | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
