import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyRulesTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#id DataAkamaiPropertyRulesTemplate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * File path to the template file
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#template_file DataAkamaiPropertyRulesTemplate#template_file}
    */
    readonly templateFile?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#var_definition_file DataAkamaiPropertyRulesTemplate#var_definition_file}
    */
    readonly varDefinitionFile?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#var_values_file DataAkamaiPropertyRulesTemplate#var_values_file}
    */
    readonly varValuesFile?: string;
    /**
    * template block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#template DataAkamaiPropertyRulesTemplate#template}
    */
    readonly template?: DataAkamaiPropertyRulesTemplateTemplate[] | cdktf.IResolvable;
    /**
    * variables block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#variables DataAkamaiPropertyRulesTemplate#variables}
    */
    readonly variables?: DataAkamaiPropertyRulesTemplateVariables[] | cdktf.IResolvable;
}
export interface DataAkamaiPropertyRulesTemplateTemplate {
    /**
    * Content of the template as string
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#template_data DataAkamaiPropertyRulesTemplate#template_data}
    */
    readonly templateData: string;
    /**
    * Directory points to a folder, which contains snippets to include into template.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#template_dir DataAkamaiPropertyRulesTemplate#template_dir}
    */
    readonly templateDir: string;
}
export declare function dataAkamaiPropertyRulesTemplateTemplateToTerraform(struct?: DataAkamaiPropertyRulesTemplateTemplate | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesTemplateTemplateToHclTerraform(struct?: DataAkamaiPropertyRulesTemplateTemplate | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesTemplateTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesTemplateTemplate | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesTemplateTemplate | cdktf.IResolvable | undefined);
    private _templateData?;
    get templateData(): string;
    set templateData(value: string);
    get templateDataInput(): string | undefined;
    private _templateDir?;
    get templateDir(): string;
    set templateDir(value: string);
    get templateDirInput(): string | undefined;
}
export declare class DataAkamaiPropertyRulesTemplateTemplateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesTemplateTemplate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesTemplateTemplateOutputReference;
}
export interface DataAkamaiPropertyRulesTemplateVariables {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#name DataAkamaiPropertyRulesTemplate#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#type DataAkamaiPropertyRulesTemplate#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#value DataAkamaiPropertyRulesTemplate#value}
    */
    readonly value: string;
}
export declare function dataAkamaiPropertyRulesTemplateVariablesToTerraform(struct?: DataAkamaiPropertyRulesTemplateVariables | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesTemplateVariablesToHclTerraform(struct?: DataAkamaiPropertyRulesTemplateVariables | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesTemplateVariablesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesTemplateVariables | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesTemplateVariables | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class DataAkamaiPropertyRulesTemplateVariablesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesTemplateVariables[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesTemplateVariablesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template akamai_property_rules_template}
*/
export declare class DataAkamaiPropertyRulesTemplate extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_property_rules_template";
    /**
    * Generates CDKTF code for importing a DataAkamaiPropertyRulesTemplate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiPropertyRulesTemplate to import
    * @param importFromId The id of the existing DataAkamaiPropertyRulesTemplate that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiPropertyRulesTemplate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_template akamai_property_rules_template} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiPropertyRulesTemplateConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkamaiPropertyRulesTemplateConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _templateFile?;
    get templateFile(): string;
    set templateFile(value: string);
    resetTemplateFile(): void;
    get templateFileInput(): string | undefined;
    private _varDefinitionFile?;
    get varDefinitionFile(): string;
    set varDefinitionFile(value: string);
    resetVarDefinitionFile(): void;
    get varDefinitionFileInput(): string | undefined;
    private _varValuesFile?;
    get varValuesFile(): string;
    set varValuesFile(value: string);
    resetVarValuesFile(): void;
    get varValuesFileInput(): string | undefined;
    private _template;
    get template(): DataAkamaiPropertyRulesTemplateTemplateList;
    putTemplate(value: DataAkamaiPropertyRulesTemplateTemplate[] | cdktf.IResolvable): void;
    resetTemplate(): void;
    get templateInput(): cdktf.IResolvable | DataAkamaiPropertyRulesTemplateTemplate[] | undefined;
    private _variables;
    get variables(): DataAkamaiPropertyRulesTemplateVariablesList;
    putVariables(value: DataAkamaiPropertyRulesTemplateVariables[] | cdktf.IResolvable): void;
    resetVariables(): void;
    get variablesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesTemplateVariables[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
