import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules#contract_id DataAkamaiPropertyRules#contract_id}
    */
    readonly contractId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules#group_id DataAkamaiPropertyRules#group_id}
    */
    readonly groupId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules#id DataAkamaiPropertyRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules#property_id DataAkamaiPropertyRules#property_id}
    */
    readonly propertyId: string;
    /**
    * Rule format
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules#rule_format DataAkamaiPropertyRules#rule_format}
    */
    readonly ruleFormat?: string;
    /**
    * This is a computed value - provider will always use 'latest' version, providing own version number is not supported
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules#version DataAkamaiPropertyRules#version}
    */
    readonly version?: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules akamai_property_rules}
*/
export declare class DataAkamaiPropertyRules extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_property_rules";
    /**
    * Generates CDKTF code for importing a DataAkamaiPropertyRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiPropertyRules to import
    * @param importFromId The id of the existing DataAkamaiPropertyRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiPropertyRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules akamai_property_rules} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiPropertyRulesConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiPropertyRulesConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    resetContractId(): void;
    get contractIdInput(): string | undefined;
    get errors(): string;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    resetGroupId(): void;
    get groupIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _propertyId?;
    get propertyId(): string;
    set propertyId(value: string);
    get propertyIdInput(): string | undefined;
    private _ruleFormat?;
    get ruleFormat(): string;
    set ruleFormat(value: string);
    resetRuleFormat(): void;
    get ruleFormatInput(): string | undefined;
    get rules(): string;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
