import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DnsRecordConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#active DnsRecord#active}
    */
    readonly active?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#algorithm DnsRecord#algorithm}
    */
    readonly algorithm?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#certificate DnsRecord#certificate}
    */
    readonly certificate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#digest DnsRecord#digest}
    */
    readonly digest?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#digest_type DnsRecord#digest_type}
    */
    readonly digestType?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#email_address DnsRecord#email_address}
    */
    readonly emailAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#expiration DnsRecord#expiration}
    */
    readonly expiration?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#expiry DnsRecord#expiry}
    */
    readonly expiry?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#fingerprint DnsRecord#fingerprint}
    */
    readonly fingerprint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#fingerprint_type DnsRecord#fingerprint_type}
    */
    readonly fingerprintType?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#flags DnsRecord#flags}
    */
    readonly flags?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#flagsnaptr DnsRecord#flagsnaptr}
    */
    readonly flagsnaptr?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#hardware DnsRecord#hardware}
    */
    readonly hardware?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#id DnsRecord#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#inception DnsRecord#inception}
    */
    readonly inception?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#iterations DnsRecord#iterations}
    */
    readonly iterations?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#key DnsRecord#key}
    */
    readonly key?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#keytag DnsRecord#keytag}
    */
    readonly keytag?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#labels DnsRecord#labels}
    */
    readonly labels?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#mailbox DnsRecord#mailbox}
    */
    readonly mailbox?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#match_type DnsRecord#match_type}
    */
    readonly matchType?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#name DnsRecord#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#name_server DnsRecord#name_server}
    */
    readonly nameServer?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#next_hashed_owner_name DnsRecord#next_hashed_owner_name}
    */
    readonly nextHashedOwnerName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#nxdomain_ttl DnsRecord#nxdomain_ttl}
    */
    readonly nxdomainTtl?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#order DnsRecord#order}
    */
    readonly order?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#original_ttl DnsRecord#original_ttl}
    */
    readonly originalTtl?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#port DnsRecord#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#preference DnsRecord#preference}
    */
    readonly preference?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#priority DnsRecord#priority}
    */
    readonly priority?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#priority_increment DnsRecord#priority_increment}
    */
    readonly priorityIncrement?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#protocol DnsRecord#protocol}
    */
    readonly protocol?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#recordtype DnsRecord#recordtype}
    */
    readonly recordtype: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#refresh DnsRecord#refresh}
    */
    readonly refresh?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#regexp DnsRecord#regexp}
    */
    readonly regexp?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#replacement DnsRecord#replacement}
    */
    readonly replacement?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#retry DnsRecord#retry}
    */
    readonly retry?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#salt DnsRecord#salt}
    */
    readonly salt?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#selector DnsRecord#selector}
    */
    readonly selector?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#service DnsRecord#service}
    */
    readonly service?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#signature DnsRecord#signature}
    */
    readonly signature?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#signer DnsRecord#signer}
    */
    readonly signer?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#software DnsRecord#software}
    */
    readonly softwareAttribute?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#subtype DnsRecord#subtype}
    */
    readonly subtype?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#svc_params DnsRecord#svc_params}
    */
    readonly svcParams?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#svc_priority DnsRecord#svc_priority}
    */
    readonly svcPriority?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#target DnsRecord#target}
    */
    readonly target?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#target_name DnsRecord#target_name}
    */
    readonly targetName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#ttl DnsRecord#ttl}
    */
    readonly ttl: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#txt DnsRecord#txt}
    */
    readonly txt?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#type_bitmaps DnsRecord#type_bitmaps}
    */
    readonly typeBitmaps?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#type_covered DnsRecord#type_covered}
    */
    readonly typeCovered?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#type_mnemonic DnsRecord#type_mnemonic}
    */
    readonly typeMnemonic?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#type_value DnsRecord#type_value}
    */
    readonly typeValue?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#usage DnsRecord#usage}
    */
    readonly usage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#weight DnsRecord#weight}
    */
    readonly weight?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#zone DnsRecord#zone}
    */
    readonly zone: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record akamai_dns_record}
*/
export declare class DnsRecord extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_dns_record";
    /**
    * Generates CDKTF code for importing a DnsRecord resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DnsRecord to import
    * @param importFromId The id of the existing DnsRecord that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DnsRecord to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_record akamai_dns_record} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DnsRecordConfig
    */
    constructor(scope: Construct, id: string, config: DnsRecordConfig);
    private _active?;
    get active(): boolean | cdktf.IResolvable;
    set active(value: boolean | cdktf.IResolvable);
    resetActive(): void;
    get activeInput(): boolean | cdktf.IResolvable | undefined;
    private _algorithm?;
    get algorithm(): number;
    set algorithm(value: number);
    resetAlgorithm(): void;
    get algorithmInput(): number | undefined;
    get answerType(): string;
    private _certificate?;
    get certificate(): string;
    set certificate(value: string);
    resetCertificate(): void;
    get certificateInput(): string | undefined;
    private _digest?;
    get digest(): string;
    set digest(value: string);
    resetDigest(): void;
    get digestInput(): string | undefined;
    private _digestType?;
    get digestType(): number;
    set digestType(value: number);
    resetDigestType(): void;
    get digestTypeInput(): number | undefined;
    get dnsName(): string;
    private _emailAddress?;
    get emailAddress(): string;
    set emailAddress(value: string);
    resetEmailAddress(): void;
    get emailAddressInput(): string | undefined;
    private _expiration?;
    get expiration(): string;
    set expiration(value: string);
    resetExpiration(): void;
    get expirationInput(): string | undefined;
    private _expiry?;
    get expiry(): number;
    set expiry(value: number);
    resetExpiry(): void;
    get expiryInput(): number | undefined;
    private _fingerprint?;
    get fingerprint(): string;
    set fingerprint(value: string);
    resetFingerprint(): void;
    get fingerprintInput(): string | undefined;
    private _fingerprintType?;
    get fingerprintType(): number;
    set fingerprintType(value: number);
    resetFingerprintType(): void;
    get fingerprintTypeInput(): number | undefined;
    private _flags?;
    get flags(): number;
    set flags(value: number);
    resetFlags(): void;
    get flagsInput(): number | undefined;
    private _flagsnaptr?;
    get flagsnaptr(): string;
    set flagsnaptr(value: string);
    resetFlagsnaptr(): void;
    get flagsnaptrInput(): string | undefined;
    private _hardware?;
    get hardware(): string;
    set hardware(value: string);
    resetHardware(): void;
    get hardwareInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _inception?;
    get inception(): string;
    set inception(value: string);
    resetInception(): void;
    get inceptionInput(): string | undefined;
    private _iterations?;
    get iterations(): number;
    set iterations(value: number);
    resetIterations(): void;
    get iterationsInput(): number | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    resetKey(): void;
    get keyInput(): string | undefined;
    private _keytag?;
    get keytag(): number;
    set keytag(value: number);
    resetKeytag(): void;
    get keytagInput(): number | undefined;
    private _labels?;
    get labels(): number;
    set labels(value: number);
    resetLabels(): void;
    get labelsInput(): number | undefined;
    private _mailbox?;
    get mailbox(): string;
    set mailbox(value: string);
    resetMailbox(): void;
    get mailboxInput(): string | undefined;
    private _matchType?;
    get matchType(): number;
    set matchType(value: number);
    resetMatchType(): void;
    get matchTypeInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _nameServer?;
    get nameServer(): string;
    set nameServer(value: string);
    resetNameServer(): void;
    get nameServerInput(): string | undefined;
    private _nextHashedOwnerName?;
    get nextHashedOwnerName(): string;
    set nextHashedOwnerName(value: string);
    resetNextHashedOwnerName(): void;
    get nextHashedOwnerNameInput(): string | undefined;
    private _nxdomainTtl?;
    get nxdomainTtl(): number;
    set nxdomainTtl(value: number);
    resetNxdomainTtl(): void;
    get nxdomainTtlInput(): number | undefined;
    private _order?;
    get order(): number;
    set order(value: number);
    resetOrder(): void;
    get orderInput(): number | undefined;
    private _originalTtl?;
    get originalTtl(): number;
    set originalTtl(value: number);
    resetOriginalTtl(): void;
    get originalTtlInput(): number | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _preference?;
    get preference(): number;
    set preference(value: number);
    resetPreference(): void;
    get preferenceInput(): number | undefined;
    private _priority?;
    get priority(): number;
    set priority(value: number);
    resetPriority(): void;
    get priorityInput(): number | undefined;
    private _priorityIncrement?;
    get priorityIncrement(): number;
    set priorityIncrement(value: number);
    resetPriorityIncrement(): void;
    get priorityIncrementInput(): number | undefined;
    private _protocol?;
    get protocol(): number;
    set protocol(value: number);
    resetProtocol(): void;
    get protocolInput(): number | undefined;
    get recordSha(): string;
    private _recordtype?;
    get recordtype(): string;
    set recordtype(value: string);
    get recordtypeInput(): string | undefined;
    private _refresh?;
    get refresh(): number;
    set refresh(value: number);
    resetRefresh(): void;
    get refreshInput(): number | undefined;
    private _regexp?;
    get regexp(): string;
    set regexp(value: string);
    resetRegexp(): void;
    get regexpInput(): string | undefined;
    private _replacement?;
    get replacement(): string;
    set replacement(value: string);
    resetReplacement(): void;
    get replacementInput(): string | undefined;
    private _retry?;
    get retry(): number;
    set retry(value: number);
    resetRetry(): void;
    get retryInput(): number | undefined;
    private _salt?;
    get salt(): string;
    set salt(value: string);
    resetSalt(): void;
    get saltInput(): string | undefined;
    private _selector?;
    get selector(): number;
    set selector(value: number);
    resetSelector(): void;
    get selectorInput(): number | undefined;
    get serial(): number;
    private _service?;
    get service(): string;
    set service(value: string);
    resetService(): void;
    get serviceInput(): string | undefined;
    private _signature?;
    get signature(): string;
    set signature(value: string);
    resetSignature(): void;
    get signatureInput(): string | undefined;
    private _signer?;
    get signer(): string;
    set signer(value: string);
    resetSigner(): void;
    get signerInput(): string | undefined;
    private _software?;
    get softwareAttribute(): string;
    set softwareAttribute(value: string);
    resetSoftwareAttribute(): void;
    get softwareAttributeInput(): string | undefined;
    private _subtype?;
    get subtype(): number;
    set subtype(value: number);
    resetSubtype(): void;
    get subtypeInput(): number | undefined;
    private _svcParams?;
    get svcParams(): string;
    set svcParams(value: string);
    resetSvcParams(): void;
    get svcParamsInput(): string | undefined;
    private _svcPriority?;
    get svcPriority(): number;
    set svcPriority(value: number);
    resetSvcPriority(): void;
    get svcPriorityInput(): number | undefined;
    private _target?;
    get target(): string[];
    set target(value: string[]);
    resetTarget(): void;
    get targetInput(): string[] | undefined;
    private _targetName?;
    get targetName(): string;
    set targetName(value: string);
    resetTargetName(): void;
    get targetNameInput(): string | undefined;
    private _ttl?;
    get ttl(): number;
    set ttl(value: number);
    get ttlInput(): number | undefined;
    private _txt?;
    get txt(): string;
    set txt(value: string);
    resetTxt(): void;
    get txtInput(): string | undefined;
    private _typeBitmaps?;
    get typeBitmaps(): string;
    set typeBitmaps(value: string);
    resetTypeBitmaps(): void;
    get typeBitmapsInput(): string | undefined;
    private _typeCovered?;
    get typeCovered(): string;
    set typeCovered(value: string);
    resetTypeCovered(): void;
    get typeCoveredInput(): string | undefined;
    private _typeMnemonic?;
    get typeMnemonic(): string;
    set typeMnemonic(value: string);
    resetTypeMnemonic(): void;
    get typeMnemonicInput(): string | undefined;
    private _typeValue?;
    get typeValue(): number;
    set typeValue(value: number);
    resetTypeValue(): void;
    get typeValueInput(): number | undefined;
    private _usage?;
    get usage(): number;
    set usage(value: number);
    resetUsage(): void;
    get usageInput(): number | undefined;
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    get zoneInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
