import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DnsZoneConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#comment DnsZone#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#contract DnsZone#contract}
    */
    readonly contract: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#end_customer_id DnsZone#end_customer_id}
    */
    readonly endCustomerId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#group DnsZone#group}
    */
    readonly group?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#id DnsZone#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#masters DnsZone#masters}
    */
    readonly masters?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#sign_and_serve DnsZone#sign_and_serve}
    */
    readonly signAndServe?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#sign_and_serve_algorithm DnsZone#sign_and_serve_algorithm}
    */
    readonly signAndServeAlgorithm?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#target DnsZone#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#type DnsZone#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#zone DnsZone#zone}
    */
    readonly zone: string;
    /**
    * tsig_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#tsig_key DnsZone#tsig_key}
    */
    readonly tsigKey?: DnsZoneTsigKey;
}
export interface DnsZoneTsigKey {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#algorithm DnsZone#algorithm}
    */
    readonly algorithm: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#name DnsZone#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#secret DnsZone#secret}
    */
    readonly secret: string;
}
export declare function dnsZoneTsigKeyToTerraform(struct?: DnsZoneTsigKeyOutputReference | DnsZoneTsigKey): any;
export declare function dnsZoneTsigKeyToHclTerraform(struct?: DnsZoneTsigKeyOutputReference | DnsZoneTsigKey): any;
export declare class DnsZoneTsigKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DnsZoneTsigKey | undefined;
    set internalValue(value: DnsZoneTsigKey | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    get algorithmInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _secret?;
    get secret(): string;
    set secret(value: string);
    get secretInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone akamai_dns_zone}
*/
export declare class DnsZone extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_dns_zone";
    /**
    * Generates CDKTF code for importing a DnsZone resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DnsZone to import
    * @param importFromId The id of the existing DnsZone that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DnsZone to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/dns_zone akamai_dns_zone} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DnsZoneConfig
    */
    constructor(scope: Construct, id: string, config: DnsZoneConfig);
    get activationState(): string;
    get aliasCount(): number;
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    private _contract?;
    get contract(): string;
    set contract(value: string);
    get contractInput(): string | undefined;
    private _endCustomerId?;
    get endCustomerId(): string;
    set endCustomerId(value: string);
    resetEndCustomerId(): void;
    get endCustomerIdInput(): string | undefined;
    private _group?;
    get group(): string;
    set group(value: string);
    resetGroup(): void;
    get groupInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _masters?;
    get masters(): string[];
    set masters(value: string[]);
    resetMasters(): void;
    get mastersInput(): string[] | undefined;
    private _signAndServe?;
    get signAndServe(): boolean | cdktf.IResolvable;
    set signAndServe(value: boolean | cdktf.IResolvable);
    resetSignAndServe(): void;
    get signAndServeInput(): boolean | cdktf.IResolvable | undefined;
    private _signAndServeAlgorithm?;
    get signAndServeAlgorithm(): string;
    set signAndServeAlgorithm(value: string);
    resetSignAndServeAlgorithm(): void;
    get signAndServeAlgorithmInput(): string | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    resetTarget(): void;
    get targetInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    get versionId(): string;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    get zoneInput(): string | undefined;
    private _tsigKey;
    get tsigKey(): DnsZoneTsigKeyOutputReference;
    putTsigKey(value: DnsZoneTsigKey): void;
    resetTsigKey(): void;
    get tsigKeyInput(): DnsZoneTsigKey | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
