import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface EdgeHostnameConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#certificate EdgeHostname#certificate}
    */
    readonly certificate?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#contract_id EdgeHostname#contract_id}
    */
    readonly contractId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#edge_hostname EdgeHostname#edge_hostname}
    */
    readonly edgeHostname: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#group_id EdgeHostname#group_id}
    */
    readonly groupId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#id EdgeHostname#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#ip_behavior EdgeHostname#ip_behavior}
    */
    readonly ipBehavior: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#product_id EdgeHostname#product_id}
    */
    readonly productId?: string;
    /**
    * Email address that should receive updates on the IP behavior update request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#status_update_email EdgeHostname#status_update_email}
    */
    readonly statusUpdateEmail?: string[];
    /**
    * A JSON encoded list of use cases
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#use_cases EdgeHostname#use_cases}
    */
    readonly useCases?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#timeouts EdgeHostname#timeouts}
    */
    readonly timeouts?: EdgeHostnameTimeouts;
}
export interface EdgeHostnameTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#default EdgeHostname#default}
    */
    readonly default?: string;
}
export declare function edgeHostnameTimeoutsToTerraform(struct?: EdgeHostnameTimeoutsOutputReference | EdgeHostnameTimeouts): any;
export declare function edgeHostnameTimeoutsToHclTerraform(struct?: EdgeHostnameTimeoutsOutputReference | EdgeHostnameTimeouts): any;
export declare class EdgeHostnameTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): EdgeHostnameTimeouts | undefined;
    set internalValue(value: EdgeHostnameTimeouts | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname akamai_edge_hostname}
*/
export declare class EdgeHostname extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_edge_hostname";
    /**
    * Generates CDKTF code for importing a EdgeHostname resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the EdgeHostname to import
    * @param importFromId The id of the existing EdgeHostname that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the EdgeHostname to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/edge_hostname akamai_edge_hostname} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options EdgeHostnameConfig
    */
    constructor(scope: Construct, id: string, config: EdgeHostnameConfig);
    private _certificate?;
    get certificate(): number;
    set certificate(value: number);
    resetCertificate(): void;
    get certificateInput(): number | undefined;
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    get contractIdInput(): string | undefined;
    private _edgeHostname?;
    get edgeHostname(): string;
    set edgeHostname(value: string);
    get edgeHostnameInput(): string | undefined;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    get groupIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipBehavior?;
    get ipBehavior(): string;
    set ipBehavior(value: string);
    get ipBehaviorInput(): string | undefined;
    private _productId?;
    get productId(): string;
    set productId(value: string);
    resetProductId(): void;
    get productIdInput(): string | undefined;
    private _statusUpdateEmail?;
    get statusUpdateEmail(): string[];
    set statusUpdateEmail(value: string[]);
    resetStatusUpdateEmail(): void;
    get statusUpdateEmailInput(): string[] | undefined;
    private _useCases?;
    get useCases(): string;
    set useCases(value: string);
    resetUseCases(): void;
    get useCasesInput(): string | undefined;
    private _timeouts;
    get timeouts(): EdgeHostnameTimeoutsOutputReference;
    putTimeouts(value: EdgeHostnameTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): EdgeHostnameTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
