import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GtmAsmapConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#default_datacenter GtmAsmap#default_datacenter}
    */
    readonly defaultDatacenter: GtmAsmapDefaultDatacenter[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#domain GtmAsmap#domain}
    */
    readonly domain: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#id GtmAsmap#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#name GtmAsmap#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#wait_on_complete GtmAsmap#wait_on_complete}
    */
    readonly waitOnComplete?: boolean | cdktf.IResolvable;
    /**
    * assignment block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#assignment GtmAsmap#assignment}
    */
    readonly assignment?: GtmAsmapAssignment[] | cdktf.IResolvable;
}
export interface GtmAsmapDefaultDatacenter {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#datacenter_id GtmAsmap#datacenter_id}
    */
    readonly datacenterId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#nickname GtmAsmap#nickname}
    */
    readonly nickname: string;
}
export declare function gtmAsmapDefaultDatacenterToTerraform(struct?: GtmAsmapDefaultDatacenter | cdktf.IResolvable): any;
export declare function gtmAsmapDefaultDatacenterToHclTerraform(struct?: GtmAsmapDefaultDatacenter | cdktf.IResolvable): any;
export declare class GtmAsmapDefaultDatacenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmAsmapDefaultDatacenter | cdktf.IResolvable | undefined;
    set internalValue(value: GtmAsmapDefaultDatacenter | cdktf.IResolvable | undefined);
    private _datacenterId?;
    get datacenterId(): number;
    set datacenterId(value: number);
    get datacenterIdInput(): number | undefined;
    private _nickname?;
    get nickname(): string;
    set nickname(value: string);
    get nicknameInput(): string | undefined;
}
export declare class GtmAsmapDefaultDatacenterList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmAsmapDefaultDatacenter[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmAsmapDefaultDatacenterOutputReference;
}
export interface GtmAsmapAssignment {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#as_numbers GtmAsmap#as_numbers}
    */
    readonly asNumbers: number[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#datacenter_id GtmAsmap#datacenter_id}
    */
    readonly datacenterId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#nickname GtmAsmap#nickname}
    */
    readonly nickname: string;
}
export declare function gtmAsmapAssignmentToTerraform(struct?: GtmAsmapAssignment | cdktf.IResolvable): any;
export declare function gtmAsmapAssignmentToHclTerraform(struct?: GtmAsmapAssignment | cdktf.IResolvable): any;
export declare class GtmAsmapAssignmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmAsmapAssignment | cdktf.IResolvable | undefined;
    set internalValue(value: GtmAsmapAssignment | cdktf.IResolvable | undefined);
    private _asNumbers?;
    get asNumbers(): number[];
    set asNumbers(value: number[]);
    get asNumbersInput(): number[] | undefined;
    private _datacenterId?;
    get datacenterId(): number;
    set datacenterId(value: number);
    get datacenterIdInput(): number | undefined;
    private _nickname?;
    get nickname(): string;
    set nickname(value: string);
    get nicknameInput(): string | undefined;
}
export declare class GtmAsmapAssignmentList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmAsmapAssignment[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmAsmapAssignmentOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap akamai_gtm_asmap}
*/
export declare class GtmAsmap extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_gtm_asmap";
    /**
    * Generates CDKTF code for importing a GtmAsmap resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GtmAsmap to import
    * @param importFromId The id of the existing GtmAsmap that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GtmAsmap to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_asmap akamai_gtm_asmap} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GtmAsmapConfig
    */
    constructor(scope: Construct, id: string, config: GtmAsmapConfig);
    private _defaultDatacenter;
    get defaultDatacenter(): GtmAsmapDefaultDatacenterList;
    putDefaultDatacenter(value: GtmAsmapDefaultDatacenter[] | cdktf.IResolvable): void;
    get defaultDatacenterInput(): cdktf.IResolvable | GtmAsmapDefaultDatacenter[] | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _waitOnComplete?;
    get waitOnComplete(): boolean | cdktf.IResolvable;
    set waitOnComplete(value: boolean | cdktf.IResolvable);
    resetWaitOnComplete(): void;
    get waitOnCompleteInput(): boolean | cdktf.IResolvable | undefined;
    private _assignment;
    get assignment(): GtmAsmapAssignmentList;
    putAssignment(value: GtmAsmapAssignment[] | cdktf.IResolvable): void;
    resetAssignment(): void;
    get assignmentInput(): cdktf.IResolvable | GtmAsmapAssignment[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
