import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GtmCidrmapConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#domain GtmCidrmap#domain}
    */
    readonly domain: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#id GtmCidrmap#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#name GtmCidrmap#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#wait_on_complete GtmCidrmap#wait_on_complete}
    */
    readonly waitOnComplete?: boolean | cdktf.IResolvable;
    /**
    * assignment block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#assignment GtmCidrmap#assignment}
    */
    readonly assignment?: GtmCidrmapAssignment[] | cdktf.IResolvable;
    /**
    * default_datacenter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#default_datacenter GtmCidrmap#default_datacenter}
    */
    readonly defaultDatacenter: GtmCidrmapDefaultDatacenter;
}
export interface GtmCidrmapAssignment {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#blocks GtmCidrmap#blocks}
    */
    readonly blocks?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#datacenter_id GtmCidrmap#datacenter_id}
    */
    readonly datacenterId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#nickname GtmCidrmap#nickname}
    */
    readonly nickname: string;
}
export declare function gtmCidrmapAssignmentToTerraform(struct?: GtmCidrmapAssignment | cdktf.IResolvable): any;
export declare function gtmCidrmapAssignmentToHclTerraform(struct?: GtmCidrmapAssignment | cdktf.IResolvable): any;
export declare class GtmCidrmapAssignmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmCidrmapAssignment | cdktf.IResolvable | undefined;
    set internalValue(value: GtmCidrmapAssignment | cdktf.IResolvable | undefined);
    private _blocks?;
    get blocks(): string[];
    set blocks(value: string[]);
    resetBlocks(): void;
    get blocksInput(): string[] | undefined;
    private _datacenterId?;
    get datacenterId(): number;
    set datacenterId(value: number);
    get datacenterIdInput(): number | undefined;
    private _nickname?;
    get nickname(): string;
    set nickname(value: string);
    get nicknameInput(): string | undefined;
}
export declare class GtmCidrmapAssignmentList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmCidrmapAssignment[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmCidrmapAssignmentOutputReference;
}
export interface GtmCidrmapDefaultDatacenter {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#datacenter_id GtmCidrmap#datacenter_id}
    */
    readonly datacenterId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#nickname GtmCidrmap#nickname}
    */
    readonly nickname?: string;
}
export declare function gtmCidrmapDefaultDatacenterToTerraform(struct?: GtmCidrmapDefaultDatacenterOutputReference | GtmCidrmapDefaultDatacenter): any;
export declare function gtmCidrmapDefaultDatacenterToHclTerraform(struct?: GtmCidrmapDefaultDatacenterOutputReference | GtmCidrmapDefaultDatacenter): any;
export declare class GtmCidrmapDefaultDatacenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): GtmCidrmapDefaultDatacenter | undefined;
    set internalValue(value: GtmCidrmapDefaultDatacenter | undefined);
    private _datacenterId?;
    get datacenterId(): number;
    set datacenterId(value: number);
    get datacenterIdInput(): number | undefined;
    private _nickname?;
    get nickname(): string;
    set nickname(value: string);
    resetNickname(): void;
    get nicknameInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap akamai_gtm_cidrmap}
*/
export declare class GtmCidrmap extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_gtm_cidrmap";
    /**
    * Generates CDKTF code for importing a GtmCidrmap resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GtmCidrmap to import
    * @param importFromId The id of the existing GtmCidrmap that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GtmCidrmap to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_cidrmap akamai_gtm_cidrmap} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GtmCidrmapConfig
    */
    constructor(scope: Construct, id: string, config: GtmCidrmapConfig);
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _waitOnComplete?;
    get waitOnComplete(): boolean | cdktf.IResolvable;
    set waitOnComplete(value: boolean | cdktf.IResolvable);
    resetWaitOnComplete(): void;
    get waitOnCompleteInput(): boolean | cdktf.IResolvable | undefined;
    private _assignment;
    get assignment(): GtmCidrmapAssignmentList;
    putAssignment(value: GtmCidrmapAssignment[] | cdktf.IResolvable): void;
    resetAssignment(): void;
    get assignmentInput(): cdktf.IResolvable | GtmCidrmapAssignment[] | undefined;
    private _defaultDatacenter;
    get defaultDatacenter(): GtmCidrmapDefaultDatacenterOutputReference;
    putDefaultDatacenter(value: GtmCidrmapDefaultDatacenter): void;
    get defaultDatacenterInput(): GtmCidrmapDefaultDatacenter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
