import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GtmDatacenterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#city GtmDatacenter#city}
    */
    readonly city?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#clone_of GtmDatacenter#clone_of}
    */
    readonly cloneOf?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#cloud_server_host_header_override GtmDatacenter#cloud_server_host_header_override}
    */
    readonly cloudServerHostHeaderOverride?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#cloud_server_targeting GtmDatacenter#cloud_server_targeting}
    */
    readonly cloudServerTargeting?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#continent GtmDatacenter#continent}
    */
    readonly continent?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#country GtmDatacenter#country}
    */
    readonly country?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#domain GtmDatacenter#domain}
    */
    readonly domain: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#id GtmDatacenter#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#latitude GtmDatacenter#latitude}
    */
    readonly latitude?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#longitude GtmDatacenter#longitude}
    */
    readonly longitude?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#nickname GtmDatacenter#nickname}
    */
    readonly nickname?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#state_or_province GtmDatacenter#state_or_province}
    */
    readonly stateOrProvince?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#wait_on_complete GtmDatacenter#wait_on_complete}
    */
    readonly waitOnComplete?: boolean | cdktf.IResolvable;
    /**
    * default_load_object block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#default_load_object GtmDatacenter#default_load_object}
    */
    readonly defaultLoadObject?: GtmDatacenterDefaultLoadObject;
}
export interface GtmDatacenterDefaultLoadObject {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#load_object GtmDatacenter#load_object}
    */
    readonly loadObject?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#load_object_port GtmDatacenter#load_object_port}
    */
    readonly loadObjectPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#load_servers GtmDatacenter#load_servers}
    */
    readonly loadServers?: string[];
}
export declare function gtmDatacenterDefaultLoadObjectToTerraform(struct?: GtmDatacenterDefaultLoadObjectOutputReference | GtmDatacenterDefaultLoadObject): any;
export declare function gtmDatacenterDefaultLoadObjectToHclTerraform(struct?: GtmDatacenterDefaultLoadObjectOutputReference | GtmDatacenterDefaultLoadObject): any;
export declare class GtmDatacenterDefaultLoadObjectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): GtmDatacenterDefaultLoadObject | undefined;
    set internalValue(value: GtmDatacenterDefaultLoadObject | undefined);
    private _loadObject?;
    get loadObject(): string;
    set loadObject(value: string);
    resetLoadObject(): void;
    get loadObjectInput(): string | undefined;
    private _loadObjectPort?;
    get loadObjectPort(): number;
    set loadObjectPort(value: number);
    resetLoadObjectPort(): void;
    get loadObjectPortInput(): number | undefined;
    private _loadServers?;
    get loadServers(): string[];
    set loadServers(value: string[]);
    resetLoadServers(): void;
    get loadServersInput(): string[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter akamai_gtm_datacenter}
*/
export declare class GtmDatacenter extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_gtm_datacenter";
    /**
    * Generates CDKTF code for importing a GtmDatacenter resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GtmDatacenter to import
    * @param importFromId The id of the existing GtmDatacenter that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GtmDatacenter to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_datacenter akamai_gtm_datacenter} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GtmDatacenterConfig
    */
    constructor(scope: Construct, id: string, config: GtmDatacenterConfig);
    private _city?;
    get city(): string;
    set city(value: string);
    resetCity(): void;
    get cityInput(): string | undefined;
    private _cloneOf?;
    get cloneOf(): number;
    set cloneOf(value: number);
    resetCloneOf(): void;
    get cloneOfInput(): number | undefined;
    private _cloudServerHostHeaderOverride?;
    get cloudServerHostHeaderOverride(): boolean | cdktf.IResolvable;
    set cloudServerHostHeaderOverride(value: boolean | cdktf.IResolvable);
    resetCloudServerHostHeaderOverride(): void;
    get cloudServerHostHeaderOverrideInput(): boolean | cdktf.IResolvable | undefined;
    private _cloudServerTargeting?;
    get cloudServerTargeting(): boolean | cdktf.IResolvable;
    set cloudServerTargeting(value: boolean | cdktf.IResolvable);
    resetCloudServerTargeting(): void;
    get cloudServerTargetingInput(): boolean | cdktf.IResolvable | undefined;
    private _continent?;
    get continent(): string;
    set continent(value: string);
    resetContinent(): void;
    get continentInput(): string | undefined;
    private _country?;
    get country(): string;
    set country(value: string);
    resetCountry(): void;
    get countryInput(): string | undefined;
    get datacenterId(): number;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _latitude?;
    get latitude(): number;
    set latitude(value: number);
    resetLatitude(): void;
    get latitudeInput(): number | undefined;
    private _longitude?;
    get longitude(): number;
    set longitude(value: number);
    resetLongitude(): void;
    get longitudeInput(): number | undefined;
    private _nickname?;
    get nickname(): string;
    set nickname(value: string);
    resetNickname(): void;
    get nicknameInput(): string | undefined;
    get pingInterval(): number;
    get pingPacketSize(): number;
    get scorePenalty(): number;
    get servermonitorLivenessCount(): number;
    get servermonitorLoadCount(): number;
    get servermonitorPool(): string;
    private _stateOrProvince?;
    get stateOrProvince(): string;
    set stateOrProvince(value: string);
    resetStateOrProvince(): void;
    get stateOrProvinceInput(): string | undefined;
    get virtual(): cdktf.IResolvable;
    private _waitOnComplete?;
    get waitOnComplete(): boolean | cdktf.IResolvable;
    set waitOnComplete(value: boolean | cdktf.IResolvable);
    resetWaitOnComplete(): void;
    get waitOnCompleteInput(): boolean | cdktf.IResolvable | undefined;
    private _defaultLoadObject;
    get defaultLoadObject(): GtmDatacenterDefaultLoadObjectOutputReference;
    putDefaultLoadObject(value: GtmDatacenterDefaultLoadObject): void;
    resetDefaultLoadObject(): void;
    get defaultLoadObjectInput(): GtmDatacenterDefaultLoadObject | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
