import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GtmDomainConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#cname_coalescing_enabled GtmDomain#cname_coalescing_enabled}
    */
    readonly cnameCoalescingEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#comment GtmDomain#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#contract GtmDomain#contract}
    */
    readonly contract?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#default_error_penalty GtmDomain#default_error_penalty}
    */
    readonly defaultErrorPenalty?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#default_ssl_client_certificate GtmDomain#default_ssl_client_certificate}
    */
    readonly defaultSslClientCertificate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#default_ssl_client_private_key GtmDomain#default_ssl_client_private_key}
    */
    readonly defaultSslClientPrivateKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#default_timeout_penalty GtmDomain#default_timeout_penalty}
    */
    readonly defaultTimeoutPenalty?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#email_notification_list GtmDomain#email_notification_list}
    */
    readonly emailNotificationList?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#end_user_mapping_enabled GtmDomain#end_user_mapping_enabled}
    */
    readonly endUserMappingEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#group GtmDomain#group}
    */
    readonly group?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#id GtmDomain#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#load_feedback GtmDomain#load_feedback}
    */
    readonly loadFeedback?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#load_imbalance_percentage GtmDomain#load_imbalance_percentage}
    */
    readonly loadImbalancePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#name GtmDomain#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#type GtmDomain#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#wait_on_complete GtmDomain#wait_on_complete}
    */
    readonly waitOnComplete?: boolean | cdktf.IResolvable;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain akamai_gtm_domain}
*/
export declare class GtmDomain extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_gtm_domain";
    /**
    * Generates CDKTF code for importing a GtmDomain resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GtmDomain to import
    * @param importFromId The id of the existing GtmDomain that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GtmDomain to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_domain akamai_gtm_domain} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GtmDomainConfig
    */
    constructor(scope: Construct, id: string, config: GtmDomainConfig);
    private _cnameCoalescingEnabled?;
    get cnameCoalescingEnabled(): boolean | cdktf.IResolvable;
    set cnameCoalescingEnabled(value: boolean | cdktf.IResolvable);
    resetCnameCoalescingEnabled(): void;
    get cnameCoalescingEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    private _contract?;
    get contract(): string;
    set contract(value: string);
    resetContract(): void;
    get contractInput(): string | undefined;
    private _defaultErrorPenalty?;
    get defaultErrorPenalty(): number;
    set defaultErrorPenalty(value: number);
    resetDefaultErrorPenalty(): void;
    get defaultErrorPenaltyInput(): number | undefined;
    get defaultHealthMax(): number;
    get defaultHealthMultiplier(): number;
    get defaultHealthThreshold(): number;
    get defaultMaxUnreachablePenalty(): number;
    private _defaultSslClientCertificate?;
    get defaultSslClientCertificate(): string;
    set defaultSslClientCertificate(value: string);
    resetDefaultSslClientCertificate(): void;
    get defaultSslClientCertificateInput(): string | undefined;
    private _defaultSslClientPrivateKey?;
    get defaultSslClientPrivateKey(): string;
    set defaultSslClientPrivateKey(value: string);
    resetDefaultSslClientPrivateKey(): void;
    get defaultSslClientPrivateKeyInput(): string | undefined;
    private _defaultTimeoutPenalty?;
    get defaultTimeoutPenalty(): number;
    set defaultTimeoutPenalty(value: number);
    resetDefaultTimeoutPenalty(): void;
    get defaultTimeoutPenaltyInput(): number | undefined;
    get defaultUnreachableThreshold(): number;
    private _emailNotificationList?;
    get emailNotificationList(): string[];
    set emailNotificationList(value: string[]);
    resetEmailNotificationList(): void;
    get emailNotificationListInput(): string[] | undefined;
    private _endUserMappingEnabled?;
    get endUserMappingEnabled(): boolean | cdktf.IResolvable;
    set endUserMappingEnabled(value: boolean | cdktf.IResolvable);
    resetEndUserMappingEnabled(): void;
    get endUserMappingEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _group?;
    get group(): string;
    set group(value: string);
    resetGroup(): void;
    get groupInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _loadFeedback?;
    get loadFeedback(): boolean | cdktf.IResolvable;
    set loadFeedback(value: boolean | cdktf.IResolvable);
    resetLoadFeedback(): void;
    get loadFeedbackInput(): boolean | cdktf.IResolvable | undefined;
    private _loadImbalancePercentage?;
    get loadImbalancePercentage(): number;
    set loadImbalancePercentage(value: number);
    resetLoadImbalancePercentage(): void;
    get loadImbalancePercentageInput(): number | undefined;
    get mapUpdateInterval(): number;
    get maxProperties(): number;
    get maxResources(): number;
    get maxTestTimeout(): number;
    get maxTtl(): number;
    get minPingableRegionFraction(): number;
    get minTestInterval(): number;
    get minTtl(): number;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get pingInterval(): number;
    get pingPacketSize(): number;
    get roundRobinPrefix(): string;
    get servermonitorLivenessCount(): number;
    get servermonitorLoadCount(): number;
    get servermonitorPool(): string;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _waitOnComplete?;
    get waitOnComplete(): boolean | cdktf.IResolvable;
    set waitOnComplete(value: boolean | cdktf.IResolvable);
    resetWaitOnComplete(): void;
    get waitOnCompleteInput(): boolean | cdktf.IResolvable | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
