import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GtmGeomapConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#default_datacenter GtmGeomap#default_datacenter}
    */
    readonly defaultDatacenter: GtmGeomapDefaultDatacenter[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#domain GtmGeomap#domain}
    */
    readonly domain: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#id GtmGeomap#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#name GtmGeomap#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#wait_on_complete GtmGeomap#wait_on_complete}
    */
    readonly waitOnComplete?: boolean | cdktf.IResolvable;
    /**
    * assignment block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#assignment GtmGeomap#assignment}
    */
    readonly assignment?: GtmGeomapAssignment[] | cdktf.IResolvable;
}
export interface GtmGeomapDefaultDatacenter {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#datacenter_id GtmGeomap#datacenter_id}
    */
    readonly datacenterId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#nickname GtmGeomap#nickname}
    */
    readonly nickname: string;
}
export declare function gtmGeomapDefaultDatacenterToTerraform(struct?: GtmGeomapDefaultDatacenter | cdktf.IResolvable): any;
export declare function gtmGeomapDefaultDatacenterToHclTerraform(struct?: GtmGeomapDefaultDatacenter | cdktf.IResolvable): any;
export declare class GtmGeomapDefaultDatacenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmGeomapDefaultDatacenter | cdktf.IResolvable | undefined;
    set internalValue(value: GtmGeomapDefaultDatacenter | cdktf.IResolvable | undefined);
    private _datacenterId?;
    get datacenterId(): number;
    set datacenterId(value: number);
    get datacenterIdInput(): number | undefined;
    private _nickname?;
    get nickname(): string;
    set nickname(value: string);
    get nicknameInput(): string | undefined;
}
export declare class GtmGeomapDefaultDatacenterList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmGeomapDefaultDatacenter[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmGeomapDefaultDatacenterOutputReference;
}
export interface GtmGeomapAssignment {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#countries GtmGeomap#countries}
    */
    readonly countries?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#datacenter_id GtmGeomap#datacenter_id}
    */
    readonly datacenterId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#nickname GtmGeomap#nickname}
    */
    readonly nickname: string;
}
export declare function gtmGeomapAssignmentToTerraform(struct?: GtmGeomapAssignment | cdktf.IResolvable): any;
export declare function gtmGeomapAssignmentToHclTerraform(struct?: GtmGeomapAssignment | cdktf.IResolvable): any;
export declare class GtmGeomapAssignmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmGeomapAssignment | cdktf.IResolvable | undefined;
    set internalValue(value: GtmGeomapAssignment | cdktf.IResolvable | undefined);
    private _countries?;
    get countries(): string[];
    set countries(value: string[]);
    resetCountries(): void;
    get countriesInput(): string[] | undefined;
    private _datacenterId?;
    get datacenterId(): number;
    set datacenterId(value: number);
    get datacenterIdInput(): number | undefined;
    private _nickname?;
    get nickname(): string;
    set nickname(value: string);
    get nicknameInput(): string | undefined;
}
export declare class GtmGeomapAssignmentList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmGeomapAssignment[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmGeomapAssignmentOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap akamai_gtm_geomap}
*/
export declare class GtmGeomap extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_gtm_geomap";
    /**
    * Generates CDKTF code for importing a GtmGeomap resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GtmGeomap to import
    * @param importFromId The id of the existing GtmGeomap that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GtmGeomap to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_geomap akamai_gtm_geomap} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GtmGeomapConfig
    */
    constructor(scope: Construct, id: string, config: GtmGeomapConfig);
    private _defaultDatacenter;
    get defaultDatacenter(): GtmGeomapDefaultDatacenterList;
    putDefaultDatacenter(value: GtmGeomapDefaultDatacenter[] | cdktf.IResolvable): void;
    get defaultDatacenterInput(): cdktf.IResolvable | GtmGeomapDefaultDatacenter[] | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _waitOnComplete?;
    get waitOnComplete(): boolean | cdktf.IResolvable;
    set waitOnComplete(value: boolean | cdktf.IResolvable);
    resetWaitOnComplete(): void;
    get waitOnCompleteInput(): boolean | cdktf.IResolvable | undefined;
    private _assignment;
    get assignment(): GtmGeomapAssignmentList;
    putAssignment(value: GtmGeomapAssignment[] | cdktf.IResolvable): void;
    resetAssignment(): void;
    get assignmentInput(): cdktf.IResolvable | GtmGeomapAssignment[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
