import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GtmPropertyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#backup_cname GtmProperty#backup_cname}
    */
    readonly backupCname?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#backup_ip GtmProperty#backup_ip}
    */
    readonly backupIp?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#balance_by_download_score GtmProperty#balance_by_download_score}
    */
    readonly balanceByDownloadScore?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#cname GtmProperty#cname}
    */
    readonly cname?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#comments GtmProperty#comments}
    */
    readonly comments?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#domain GtmProperty#domain}
    */
    readonly domain: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#dynamic_ttl GtmProperty#dynamic_ttl}
    */
    readonly dynamicTtl?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#failback_delay GtmProperty#failback_delay}
    */
    readonly failbackDelay?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#failover_delay GtmProperty#failover_delay}
    */
    readonly failoverDelay?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#ghost_demand_reporting GtmProperty#ghost_demand_reporting}
    */
    readonly ghostDemandReporting?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#handout_limit GtmProperty#handout_limit}
    */
    readonly handoutLimit: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#handout_mode GtmProperty#handout_mode}
    */
    readonly handoutMode: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#health_max GtmProperty#health_max}
    */
    readonly healthMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#health_multiplier GtmProperty#health_multiplier}
    */
    readonly healthMultiplier?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#health_threshold GtmProperty#health_threshold}
    */
    readonly healthThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#id GtmProperty#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#ipv6 GtmProperty#ipv6}
    */
    readonly ipv6?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#load_imbalance_percentage GtmProperty#load_imbalance_percentage}
    */
    readonly loadImbalancePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#map_name GtmProperty#map_name}
    */
    readonly mapName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#max_unreachable_penalty GtmProperty#max_unreachable_penalty}
    */
    readonly maxUnreachablePenalty?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#min_live_fraction GtmProperty#min_live_fraction}
    */
    readonly minLiveFraction?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#name GtmProperty#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#score_aggregation_type GtmProperty#score_aggregation_type}
    */
    readonly scoreAggregationType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#static_ttl GtmProperty#static_ttl}
    */
    readonly staticTtl?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#stickiness_bonus_constant GtmProperty#stickiness_bonus_constant}
    */
    readonly stickinessBonusConstant?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#stickiness_bonus_percentage GtmProperty#stickiness_bonus_percentage}
    */
    readonly stickinessBonusPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#type GtmProperty#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#unreachable_threshold GtmProperty#unreachable_threshold}
    */
    readonly unreachableThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#use_computed_targets GtmProperty#use_computed_targets}
    */
    readonly useComputedTargets?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#wait_on_complete GtmProperty#wait_on_complete}
    */
    readonly waitOnComplete?: boolean | cdktf.IResolvable;
    /**
    * liveness_test block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#liveness_test GtmProperty#liveness_test}
    */
    readonly livenessTest?: GtmPropertyLivenessTest[] | cdktf.IResolvable;
    /**
    * static_rr_set block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#static_rr_set GtmProperty#static_rr_set}
    */
    readonly staticRrSet?: GtmPropertyStaticRrSet[] | cdktf.IResolvable;
    /**
    * traffic_target block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#traffic_target GtmProperty#traffic_target}
    */
    readonly trafficTarget?: GtmPropertyTrafficTarget[] | cdktf.IResolvable;
}
export interface GtmPropertyLivenessTestHttpHeader {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#name GtmProperty#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#value GtmProperty#value}
    */
    readonly value?: string;
}
export declare function gtmPropertyLivenessTestHttpHeaderToTerraform(struct?: GtmPropertyLivenessTestHttpHeader | cdktf.IResolvable): any;
export declare function gtmPropertyLivenessTestHttpHeaderToHclTerraform(struct?: GtmPropertyLivenessTestHttpHeader | cdktf.IResolvable): any;
export declare class GtmPropertyLivenessTestHttpHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmPropertyLivenessTestHttpHeader | cdktf.IResolvable | undefined;
    set internalValue(value: GtmPropertyLivenessTestHttpHeader | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class GtmPropertyLivenessTestHttpHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmPropertyLivenessTestHttpHeader[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmPropertyLivenessTestHttpHeaderOutputReference;
}
export interface GtmPropertyLivenessTest {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#answers_required GtmProperty#answers_required}
    */
    readonly answersRequired?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#disable_nonstandard_port_warning GtmProperty#disable_nonstandard_port_warning}
    */
    readonly disableNonstandardPortWarning?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#disabled GtmProperty#disabled}
    */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#error_penalty GtmProperty#error_penalty}
    */
    readonly errorPenalty?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#http_error3xx GtmProperty#http_error3xx}
    */
    readonly httpError3Xx?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#http_error4xx GtmProperty#http_error4xx}
    */
    readonly httpError4Xx?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#http_error5xx GtmProperty#http_error5xx}
    */
    readonly httpError5Xx?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#name GtmProperty#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#peer_certificate_verification GtmProperty#peer_certificate_verification}
    */
    readonly peerCertificateVerification?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#recursion_requested GtmProperty#recursion_requested}
    */
    readonly recursionRequested?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#request_string GtmProperty#request_string}
    */
    readonly requestString?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#resource_type GtmProperty#resource_type}
    */
    readonly resourceType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#response_string GtmProperty#response_string}
    */
    readonly responseString?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#ssl_client_certificate GtmProperty#ssl_client_certificate}
    */
    readonly sslClientCertificate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#ssl_client_private_key GtmProperty#ssl_client_private_key}
    */
    readonly sslClientPrivateKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#test_interval GtmProperty#test_interval}
    */
    readonly testInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#test_object GtmProperty#test_object}
    */
    readonly testObject?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#test_object_password GtmProperty#test_object_password}
    */
    readonly testObjectPassword?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#test_object_port GtmProperty#test_object_port}
    */
    readonly testObjectPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#test_object_protocol GtmProperty#test_object_protocol}
    */
    readonly testObjectProtocol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#test_object_username GtmProperty#test_object_username}
    */
    readonly testObjectUsername?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#test_timeout GtmProperty#test_timeout}
    */
    readonly testTimeout: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#timeout_penalty GtmProperty#timeout_penalty}
    */
    readonly timeoutPenalty?: number;
    /**
    * http_header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#http_header GtmProperty#http_header}
    */
    readonly httpHeader?: GtmPropertyLivenessTestHttpHeader[] | cdktf.IResolvable;
}
export declare function gtmPropertyLivenessTestToTerraform(struct?: GtmPropertyLivenessTest | cdktf.IResolvable): any;
export declare function gtmPropertyLivenessTestToHclTerraform(struct?: GtmPropertyLivenessTest | cdktf.IResolvable): any;
export declare class GtmPropertyLivenessTestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmPropertyLivenessTest | cdktf.IResolvable | undefined;
    set internalValue(value: GtmPropertyLivenessTest | cdktf.IResolvable | undefined);
    private _answersRequired?;
    get answersRequired(): boolean | cdktf.IResolvable;
    set answersRequired(value: boolean | cdktf.IResolvable);
    resetAnswersRequired(): void;
    get answersRequiredInput(): boolean | cdktf.IResolvable | undefined;
    private _disableNonstandardPortWarning?;
    get disableNonstandardPortWarning(): boolean | cdktf.IResolvable;
    set disableNonstandardPortWarning(value: boolean | cdktf.IResolvable);
    resetDisableNonstandardPortWarning(): void;
    get disableNonstandardPortWarningInput(): boolean | cdktf.IResolvable | undefined;
    private _disabled?;
    get disabled(): boolean | cdktf.IResolvable;
    set disabled(value: boolean | cdktf.IResolvable);
    resetDisabled(): void;
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    private _errorPenalty?;
    get errorPenalty(): number;
    set errorPenalty(value: number);
    resetErrorPenalty(): void;
    get errorPenaltyInput(): number | undefined;
    private _httpError3Xx?;
    get httpError3Xx(): boolean | cdktf.IResolvable;
    set httpError3Xx(value: boolean | cdktf.IResolvable);
    resetHttpError3Xx(): void;
    get httpError3XxInput(): boolean | cdktf.IResolvable | undefined;
    private _httpError4Xx?;
    get httpError4Xx(): boolean | cdktf.IResolvable;
    set httpError4Xx(value: boolean | cdktf.IResolvable);
    resetHttpError4Xx(): void;
    get httpError4XxInput(): boolean | cdktf.IResolvable | undefined;
    private _httpError5Xx?;
    get httpError5Xx(): boolean | cdktf.IResolvable;
    set httpError5Xx(value: boolean | cdktf.IResolvable);
    resetHttpError5Xx(): void;
    get httpError5XxInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _peerCertificateVerification?;
    get peerCertificateVerification(): boolean | cdktf.IResolvable;
    set peerCertificateVerification(value: boolean | cdktf.IResolvable);
    resetPeerCertificateVerification(): void;
    get peerCertificateVerificationInput(): boolean | cdktf.IResolvable | undefined;
    private _recursionRequested?;
    get recursionRequested(): boolean | cdktf.IResolvable;
    set recursionRequested(value: boolean | cdktf.IResolvable);
    resetRecursionRequested(): void;
    get recursionRequestedInput(): boolean | cdktf.IResolvable | undefined;
    private _requestString?;
    get requestString(): string;
    set requestString(value: string);
    resetRequestString(): void;
    get requestStringInput(): string | undefined;
    private _resourceType?;
    get resourceType(): string;
    set resourceType(value: string);
    resetResourceType(): void;
    get resourceTypeInput(): string | undefined;
    private _responseString?;
    get responseString(): string;
    set responseString(value: string);
    resetResponseString(): void;
    get responseStringInput(): string | undefined;
    private _sslClientCertificate?;
    get sslClientCertificate(): string;
    set sslClientCertificate(value: string);
    resetSslClientCertificate(): void;
    get sslClientCertificateInput(): string | undefined;
    private _sslClientPrivateKey?;
    get sslClientPrivateKey(): string;
    set sslClientPrivateKey(value: string);
    resetSslClientPrivateKey(): void;
    get sslClientPrivateKeyInput(): string | undefined;
    private _testInterval?;
    get testInterval(): number;
    set testInterval(value: number);
    get testIntervalInput(): number | undefined;
    private _testObject?;
    get testObject(): string;
    set testObject(value: string);
    resetTestObject(): void;
    get testObjectInput(): string | undefined;
    private _testObjectPassword?;
    get testObjectPassword(): string;
    set testObjectPassword(value: string);
    resetTestObjectPassword(): void;
    get testObjectPasswordInput(): string | undefined;
    private _testObjectPort?;
    get testObjectPort(): number;
    set testObjectPort(value: number);
    resetTestObjectPort(): void;
    get testObjectPortInput(): number | undefined;
    private _testObjectProtocol?;
    get testObjectProtocol(): string;
    set testObjectProtocol(value: string);
    get testObjectProtocolInput(): string | undefined;
    private _testObjectUsername?;
    get testObjectUsername(): string;
    set testObjectUsername(value: string);
    resetTestObjectUsername(): void;
    get testObjectUsernameInput(): string | undefined;
    private _testTimeout?;
    get testTimeout(): number;
    set testTimeout(value: number);
    get testTimeoutInput(): number | undefined;
    private _timeoutPenalty?;
    get timeoutPenalty(): number;
    set timeoutPenalty(value: number);
    resetTimeoutPenalty(): void;
    get timeoutPenaltyInput(): number | undefined;
    private _httpHeader;
    get httpHeader(): GtmPropertyLivenessTestHttpHeaderList;
    putHttpHeader(value: GtmPropertyLivenessTestHttpHeader[] | cdktf.IResolvable): void;
    resetHttpHeader(): void;
    get httpHeaderInput(): cdktf.IResolvable | GtmPropertyLivenessTestHttpHeader[] | undefined;
}
export declare class GtmPropertyLivenessTestList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmPropertyLivenessTest[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmPropertyLivenessTestOutputReference;
}
export interface GtmPropertyStaticRrSet {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#rdata GtmProperty#rdata}
    */
    readonly rdata?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#ttl GtmProperty#ttl}
    */
    readonly ttl?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#type GtmProperty#type}
    */
    readonly type?: string;
}
export declare function gtmPropertyStaticRrSetToTerraform(struct?: GtmPropertyStaticRrSet | cdktf.IResolvable): any;
export declare function gtmPropertyStaticRrSetToHclTerraform(struct?: GtmPropertyStaticRrSet | cdktf.IResolvable): any;
export declare class GtmPropertyStaticRrSetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmPropertyStaticRrSet | cdktf.IResolvable | undefined;
    set internalValue(value: GtmPropertyStaticRrSet | cdktf.IResolvable | undefined);
    private _rdata?;
    get rdata(): string[];
    set rdata(value: string[]);
    resetRdata(): void;
    get rdataInput(): string[] | undefined;
    private _ttl?;
    get ttl(): number;
    set ttl(value: number);
    resetTtl(): void;
    get ttlInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export declare class GtmPropertyStaticRrSetList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmPropertyStaticRrSet[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmPropertyStaticRrSetOutputReference;
}
export interface GtmPropertyTrafficTarget {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#datacenter_id GtmProperty#datacenter_id}
    */
    readonly datacenterId?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#enabled GtmProperty#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#handout_cname GtmProperty#handout_cname}
    */
    readonly handoutCname?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#name GtmProperty#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#servers GtmProperty#servers}
    */
    readonly servers?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#weight GtmProperty#weight}
    */
    readonly weight?: number;
}
export declare function gtmPropertyTrafficTargetToTerraform(struct?: GtmPropertyTrafficTarget | cdktf.IResolvable): any;
export declare function gtmPropertyTrafficTargetToHclTerraform(struct?: GtmPropertyTrafficTarget | cdktf.IResolvable): any;
export declare class GtmPropertyTrafficTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmPropertyTrafficTarget | cdktf.IResolvable | undefined;
    set internalValue(value: GtmPropertyTrafficTarget | cdktf.IResolvable | undefined);
    private _datacenterId?;
    get datacenterId(): number;
    set datacenterId(value: number);
    resetDatacenterId(): void;
    get datacenterIdInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _handoutCname?;
    get handoutCname(): string;
    set handoutCname(value: string);
    resetHandoutCname(): void;
    get handoutCnameInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _servers?;
    get servers(): string[];
    set servers(value: string[]);
    resetServers(): void;
    get serversInput(): string[] | undefined;
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
}
export declare class GtmPropertyTrafficTargetList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmPropertyTrafficTarget[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmPropertyTrafficTargetOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property akamai_gtm_property}
*/
export declare class GtmProperty extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_gtm_property";
    /**
    * Generates CDKTF code for importing a GtmProperty resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GtmProperty to import
    * @param importFromId The id of the existing GtmProperty that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GtmProperty to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_property akamai_gtm_property} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GtmPropertyConfig
    */
    constructor(scope: Construct, id: string, config: GtmPropertyConfig);
    private _backupCname?;
    get backupCname(): string;
    set backupCname(value: string);
    resetBackupCname(): void;
    get backupCnameInput(): string | undefined;
    private _backupIp?;
    get backupIp(): string;
    set backupIp(value: string);
    resetBackupIp(): void;
    get backupIpInput(): string | undefined;
    private _balanceByDownloadScore?;
    get balanceByDownloadScore(): boolean | cdktf.IResolvable;
    set balanceByDownloadScore(value: boolean | cdktf.IResolvable);
    resetBalanceByDownloadScore(): void;
    get balanceByDownloadScoreInput(): boolean | cdktf.IResolvable | undefined;
    private _cname?;
    get cname(): string;
    set cname(value: string);
    resetCname(): void;
    get cnameInput(): string | undefined;
    private _comments?;
    get comments(): string;
    set comments(value: string);
    resetComments(): void;
    get commentsInput(): string | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    private _dynamicTtl?;
    get dynamicTtl(): number;
    set dynamicTtl(value: number);
    resetDynamicTtl(): void;
    get dynamicTtlInput(): number | undefined;
    private _failbackDelay?;
    get failbackDelay(): number;
    set failbackDelay(value: number);
    resetFailbackDelay(): void;
    get failbackDelayInput(): number | undefined;
    private _failoverDelay?;
    get failoverDelay(): number;
    set failoverDelay(value: number);
    resetFailoverDelay(): void;
    get failoverDelayInput(): number | undefined;
    private _ghostDemandReporting?;
    get ghostDemandReporting(): boolean | cdktf.IResolvable;
    set ghostDemandReporting(value: boolean | cdktf.IResolvable);
    resetGhostDemandReporting(): void;
    get ghostDemandReportingInput(): boolean | cdktf.IResolvable | undefined;
    private _handoutLimit?;
    get handoutLimit(): number;
    set handoutLimit(value: number);
    get handoutLimitInput(): number | undefined;
    private _handoutMode?;
    get handoutMode(): string;
    set handoutMode(value: string);
    get handoutModeInput(): string | undefined;
    private _healthMax?;
    get healthMax(): number;
    set healthMax(value: number);
    resetHealthMax(): void;
    get healthMaxInput(): number | undefined;
    private _healthMultiplier?;
    get healthMultiplier(): number;
    set healthMultiplier(value: number);
    resetHealthMultiplier(): void;
    get healthMultiplierInput(): number | undefined;
    private _healthThreshold?;
    get healthThreshold(): number;
    set healthThreshold(value: number);
    resetHealthThreshold(): void;
    get healthThresholdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ipv6?;
    get ipv6(): boolean | cdktf.IResolvable;
    set ipv6(value: boolean | cdktf.IResolvable);
    resetIpv6(): void;
    get ipv6Input(): boolean | cdktf.IResolvable | undefined;
    private _loadImbalancePercentage?;
    get loadImbalancePercentage(): number;
    set loadImbalancePercentage(value: number);
    resetLoadImbalancePercentage(): void;
    get loadImbalancePercentageInput(): number | undefined;
    private _mapName?;
    get mapName(): string;
    set mapName(value: string);
    resetMapName(): void;
    get mapNameInput(): string | undefined;
    private _maxUnreachablePenalty?;
    get maxUnreachablePenalty(): number;
    set maxUnreachablePenalty(value: number);
    resetMaxUnreachablePenalty(): void;
    get maxUnreachablePenaltyInput(): number | undefined;
    private _minLiveFraction?;
    get minLiveFraction(): number;
    set minLiveFraction(value: number);
    resetMinLiveFraction(): void;
    get minLiveFractionInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _scoreAggregationType?;
    get scoreAggregationType(): string;
    set scoreAggregationType(value: string);
    get scoreAggregationTypeInput(): string | undefined;
    private _staticTtl?;
    get staticTtl(): number;
    set staticTtl(value: number);
    resetStaticTtl(): void;
    get staticTtlInput(): number | undefined;
    private _stickinessBonusConstant?;
    get stickinessBonusConstant(): number;
    set stickinessBonusConstant(value: number);
    resetStickinessBonusConstant(): void;
    get stickinessBonusConstantInput(): number | undefined;
    private _stickinessBonusPercentage?;
    get stickinessBonusPercentage(): number;
    set stickinessBonusPercentage(value: number);
    resetStickinessBonusPercentage(): void;
    get stickinessBonusPercentageInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _unreachableThreshold?;
    get unreachableThreshold(): number;
    set unreachableThreshold(value: number);
    resetUnreachableThreshold(): void;
    get unreachableThresholdInput(): number | undefined;
    private _useComputedTargets?;
    get useComputedTargets(): boolean | cdktf.IResolvable;
    set useComputedTargets(value: boolean | cdktf.IResolvable);
    resetUseComputedTargets(): void;
    get useComputedTargetsInput(): boolean | cdktf.IResolvable | undefined;
    private _waitOnComplete?;
    get waitOnComplete(): boolean | cdktf.IResolvable;
    set waitOnComplete(value: boolean | cdktf.IResolvable);
    resetWaitOnComplete(): void;
    get waitOnCompleteInput(): boolean | cdktf.IResolvable | undefined;
    get weightedHashBitsForIpv4(): number;
    get weightedHashBitsForIpv6(): number;
    private _livenessTest;
    get livenessTest(): GtmPropertyLivenessTestList;
    putLivenessTest(value: GtmPropertyLivenessTest[] | cdktf.IResolvable): void;
    resetLivenessTest(): void;
    get livenessTestInput(): cdktf.IResolvable | GtmPropertyLivenessTest[] | undefined;
    private _staticRrSet;
    get staticRrSet(): GtmPropertyStaticRrSetList;
    putStaticRrSet(value: GtmPropertyStaticRrSet[] | cdktf.IResolvable): void;
    resetStaticRrSet(): void;
    get staticRrSetInput(): cdktf.IResolvable | GtmPropertyStaticRrSet[] | undefined;
    private _trafficTarget;
    get trafficTarget(): GtmPropertyTrafficTargetList;
    putTrafficTarget(value: GtmPropertyTrafficTarget[] | cdktf.IResolvable): void;
    resetTrafficTarget(): void;
    get trafficTargetInput(): cdktf.IResolvable | GtmPropertyTrafficTarget[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
