import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GtmResourceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#aggregation_type GtmResource#aggregation_type}
    */
    readonly aggregationType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#constrained_property GtmResource#constrained_property}
    */
    readonly constrainedProperty?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#decay_rate GtmResource#decay_rate}
    */
    readonly decayRate?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#description GtmResource#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#domain GtmResource#domain}
    */
    readonly domain: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#host_header GtmResource#host_header}
    */
    readonly hostHeader?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#id GtmResource#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#leader_string GtmResource#leader_string}
    */
    readonly leaderString?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#least_squares_decay GtmResource#least_squares_decay}
    */
    readonly leastSquaresDecay?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#load_imbalance_percentage GtmResource#load_imbalance_percentage}
    */
    readonly loadImbalancePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#max_u_multiplicative_increment GtmResource#max_u_multiplicative_increment}
    */
    readonly maxUMultiplicativeIncrement?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#name GtmResource#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#type GtmResource#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#upper_bound GtmResource#upper_bound}
    */
    readonly upperBound?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#wait_on_complete GtmResource#wait_on_complete}
    */
    readonly waitOnComplete?: boolean | cdktf.IResolvable;
    /**
    * resource_instance block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#resource_instance GtmResource#resource_instance}
    */
    readonly resourceInstance?: GtmResourceResourceInstance[] | cdktf.IResolvable;
}
export interface GtmResourceResourceInstance {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#datacenter_id GtmResource#datacenter_id}
    */
    readonly datacenterId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#load_object GtmResource#load_object}
    */
    readonly loadObject?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#load_object_port GtmResource#load_object_port}
    */
    readonly loadObjectPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#load_servers GtmResource#load_servers}
    */
    readonly loadServers?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#use_default_load_object GtmResource#use_default_load_object}
    */
    readonly useDefaultLoadObject?: boolean | cdktf.IResolvable;
}
export declare function gtmResourceResourceInstanceToTerraform(struct?: GtmResourceResourceInstance | cdktf.IResolvable): any;
export declare function gtmResourceResourceInstanceToHclTerraform(struct?: GtmResourceResourceInstance | cdktf.IResolvable): any;
export declare class GtmResourceResourceInstanceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GtmResourceResourceInstance | cdktf.IResolvable | undefined;
    set internalValue(value: GtmResourceResourceInstance | cdktf.IResolvable | undefined);
    private _datacenterId?;
    get datacenterId(): number;
    set datacenterId(value: number);
    get datacenterIdInput(): number | undefined;
    private _loadObject?;
    get loadObject(): string;
    set loadObject(value: string);
    resetLoadObject(): void;
    get loadObjectInput(): string | undefined;
    private _loadObjectPort?;
    get loadObjectPort(): number;
    set loadObjectPort(value: number);
    resetLoadObjectPort(): void;
    get loadObjectPortInput(): number | undefined;
    private _loadServers?;
    get loadServers(): string[];
    set loadServers(value: string[]);
    resetLoadServers(): void;
    get loadServersInput(): string[] | undefined;
    private _useDefaultLoadObject?;
    get useDefaultLoadObject(): boolean | cdktf.IResolvable;
    set useDefaultLoadObject(value: boolean | cdktf.IResolvable);
    resetUseDefaultLoadObject(): void;
    get useDefaultLoadObjectInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class GtmResourceResourceInstanceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GtmResourceResourceInstance[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GtmResourceResourceInstanceOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource akamai_gtm_resource}
*/
export declare class GtmResource extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_gtm_resource";
    /**
    * Generates CDKTF code for importing a GtmResource resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GtmResource to import
    * @param importFromId The id of the existing GtmResource that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GtmResource to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/gtm_resource akamai_gtm_resource} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GtmResourceConfig
    */
    constructor(scope: Construct, id: string, config: GtmResourceConfig);
    private _aggregationType?;
    get aggregationType(): string;
    set aggregationType(value: string);
    get aggregationTypeInput(): string | undefined;
    private _constrainedProperty?;
    get constrainedProperty(): string;
    set constrainedProperty(value: string);
    resetConstrainedProperty(): void;
    get constrainedPropertyInput(): string | undefined;
    private _decayRate?;
    get decayRate(): number;
    set decayRate(value: number);
    resetDecayRate(): void;
    get decayRateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    get domainInput(): string | undefined;
    private _hostHeader?;
    get hostHeader(): string;
    set hostHeader(value: string);
    resetHostHeader(): void;
    get hostHeaderInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _leaderString?;
    get leaderString(): string;
    set leaderString(value: string);
    resetLeaderString(): void;
    get leaderStringInput(): string | undefined;
    private _leastSquaresDecay?;
    get leastSquaresDecay(): number;
    set leastSquaresDecay(value: number);
    resetLeastSquaresDecay(): void;
    get leastSquaresDecayInput(): number | undefined;
    private _loadImbalancePercentage?;
    get loadImbalancePercentage(): number;
    set loadImbalancePercentage(value: number);
    resetLoadImbalancePercentage(): void;
    get loadImbalancePercentageInput(): number | undefined;
    private _maxUMultiplicativeIncrement?;
    get maxUMultiplicativeIncrement(): number;
    set maxUMultiplicativeIncrement(value: number);
    resetMaxUMultiplicativeIncrement(): void;
    get maxUMultiplicativeIncrementInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _upperBound?;
    get upperBound(): number;
    set upperBound(value: number);
    resetUpperBound(): void;
    get upperBoundInput(): number | undefined;
    private _waitOnComplete?;
    get waitOnComplete(): boolean | cdktf.IResolvable;
    set waitOnComplete(value: boolean | cdktf.IResolvable);
    resetWaitOnComplete(): void;
    get waitOnCompleteInput(): boolean | cdktf.IResolvable | undefined;
    private _resourceInstance;
    get resourceInstance(): GtmResourceResourceInstanceList;
    putResourceInstance(value: GtmResourceResourceInstance[] | cdktf.IResolvable): void;
    resetResourceInstance(): void;
    get resourceInstanceInput(): cdktf.IResolvable | GtmResourceResourceInstance[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
