import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IamBlockedUserPropertiesConfig extends cdktf.TerraformMetaArguments {
    /**
    * List of properties to block for a user
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/iam_blocked_user_properties#blocked_properties IamBlockedUserProperties#blocked_properties}
    */
    readonly blockedProperties: number[];
    /**
    * A unique identifier for a group
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/iam_blocked_user_properties#group_id IamBlockedUserProperties#group_id}
    */
    readonly groupId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/iam_blocked_user_properties#id IamBlockedUserProperties#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A unique identifier for a user's profile, which corresponds to a user's actual profile or client ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/iam_blocked_user_properties#identity_id IamBlockedUserProperties#identity_id}
    */
    readonly identityId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/iam_blocked_user_properties akamai_iam_blocked_user_properties}
*/
export declare class IamBlockedUserProperties extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_iam_blocked_user_properties";
    /**
    * Generates CDKTF code for importing a IamBlockedUserProperties resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the IamBlockedUserProperties to import
    * @param importFromId The id of the existing IamBlockedUserProperties that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/iam_blocked_user_properties#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the IamBlockedUserProperties to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/iam_blocked_user_properties akamai_iam_blocked_user_properties} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IamBlockedUserPropertiesConfig
    */
    constructor(scope: Construct, id: string, config: IamBlockedUserPropertiesConfig);
    private _blockedProperties?;
    get blockedProperties(): number[];
    set blockedProperties(value: number[]);
    get blockedPropertiesInput(): number[] | undefined;
    private _groupId?;
    get groupId(): number;
    set groupId(value: number);
    get groupIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _identityId?;
    get identityId(): string;
    set identityId(value: string);
    get identityIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
