import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworklistNetworkListConfig extends cdktf.TerraformMetaArguments {
    /**
    * contract ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#contract_id NetworklistNetworkList#contract_id}
    */
    readonly contractId?: string;
    /**
    * A description of the network list
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#description NetworklistNetworkList#description}
    */
    readonly description: string;
    /**
    * group ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#group_id NetworklistNetworkList#group_id}
    */
    readonly groupId?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#id NetworklistNetworkList#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A list of IP addresses or locations to be included in the list, added to an existing list, or removed from an existing list
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#list NetworklistNetworkList#list}
    */
    readonly list?: string[];
    /**
    * A string specifying the interpretation of the `list` parameter. Must be 'APPEND', 'REPLACE', or 'REMOVE'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#mode NetworklistNetworkList#mode}
    */
    readonly mode: string;
    /**
    * The name to be assigned to the network list
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#name NetworklistNetworkList#name}
    */
    readonly name: string;
    /**
    * The type of the network list; must be either 'IP' or 'GEO'
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#type NetworklistNetworkList#type}
    */
    readonly type: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list akamai_networklist_network_list}
*/
export declare class NetworklistNetworkList extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_networklist_network_list";
    /**
    * Generates CDKTF code for importing a NetworklistNetworkList resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworklistNetworkList to import
    * @param importFromId The id of the existing NetworklistNetworkList that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworklistNetworkList to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_network_list akamai_networklist_network_list} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworklistNetworkListConfig
    */
    constructor(scope: Construct, id: string, config: NetworklistNetworkListConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    resetContractId(): void;
    get contractIdInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    get descriptionInput(): string | undefined;
    private _groupId?;
    get groupId(): number;
    set groupId(value: number);
    resetGroupId(): void;
    get groupIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _list?;
    get list(): string[];
    set list(value: string[]);
    resetList(): void;
    get listInput(): string[] | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    get modeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get networkListId(): string;
    get syncPoint(): number;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    get uniqueid(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
