import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface NetworklistSubscriptionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_subscription#id NetworklistSubscription#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_subscription#network_list NetworklistSubscription#network_list}
    */
    readonly networkList: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_subscription#recipients NetworklistSubscription#recipients}
    */
    readonly recipients: string[];
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_subscription akamai_networklist_subscription}
*/
export declare class NetworklistSubscription extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_networklist_subscription";
    /**
    * Generates CDKTF code for importing a NetworklistSubscription resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the NetworklistSubscription to import
    * @param importFromId The id of the existing NetworklistSubscription that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_subscription#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the NetworklistSubscription to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/networklist_subscription akamai_networklist_subscription} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options NetworklistSubscriptionConfig
    */
    constructor(scope: Construct, id: string, config: NetworklistSubscriptionConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _networkList?;
    get networkList(): string[];
    set networkList(value: string[]);
    get networkListInput(): string[] | undefined;
    private _recipients?;
    get recipients(): string[];
    set recipients(value: string[]);
    get recipientsInput(): string[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
