import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface PropertyActivationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#activation_id PropertyActivation#activation_id}
    */
    readonly activationId?: string;
    /**
    * Automatically acknowledge all rule warnings for activation to continue. Default is false
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#auto_acknowledge_rule_warnings PropertyActivation#auto_acknowledge_rule_warnings}
    */
    readonly autoAcknowledgeRuleWarnings?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#contact PropertyActivation#contact}
    */
    readonly contact: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#id PropertyActivation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#network PropertyActivation#network}
    */
    readonly network?: string;
    /**
    * assigns a log message to the activation request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#note PropertyActivation#note}
    */
    readonly note?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#property_id PropertyActivation#property_id}
    */
    readonly propertyId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#version PropertyActivation#version}
    */
    readonly version: number;
    /**
    * compliance_record block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#compliance_record PropertyActivation#compliance_record}
    */
    readonly complianceRecord?: PropertyActivationComplianceRecord;
    /**
    * rule_errors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#rule_errors PropertyActivation#rule_errors}
    */
    readonly ruleErrors?: PropertyActivationRuleErrors[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#timeouts PropertyActivation#timeouts}
    */
    readonly timeouts?: PropertyActivationTimeouts;
}
export interface PropertyActivationComplianceRecordNoncomplianceReasonEmergency {
    /**
    * Identifies the ticket that describes the need for the activation
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#ticket_id PropertyActivation#ticket_id}
    */
    readonly ticketId?: string;
}
export declare function propertyActivationComplianceRecordNoncomplianceReasonEmergencyToTerraform(struct?: PropertyActivationComplianceRecordNoncomplianceReasonEmergencyOutputReference | PropertyActivationComplianceRecordNoncomplianceReasonEmergency): any;
export declare function propertyActivationComplianceRecordNoncomplianceReasonEmergencyToHclTerraform(struct?: PropertyActivationComplianceRecordNoncomplianceReasonEmergencyOutputReference | PropertyActivationComplianceRecordNoncomplianceReasonEmergency): any;
export declare class PropertyActivationComplianceRecordNoncomplianceReasonEmergencyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PropertyActivationComplianceRecordNoncomplianceReasonEmergency | undefined;
    set internalValue(value: PropertyActivationComplianceRecordNoncomplianceReasonEmergency | undefined);
    private _ticketId?;
    get ticketId(): string;
    set ticketId(value: string);
    resetTicketId(): void;
    get ticketIdInput(): string | undefined;
}
export interface PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTraffic {
    /**
    * Identifies the ticket that describes the need for the activation
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#ticket_id PropertyActivation#ticket_id}
    */
    readonly ticketId?: string;
}
export declare function propertyActivationComplianceRecordNoncomplianceReasonNoProductionTrafficToTerraform(struct?: PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTrafficOutputReference | PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTraffic): any;
export declare function propertyActivationComplianceRecordNoncomplianceReasonNoProductionTrafficToHclTerraform(struct?: PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTrafficOutputReference | PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTraffic): any;
export declare class PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTrafficOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTraffic | undefined;
    set internalValue(value: PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTraffic | undefined);
    private _ticketId?;
    get ticketId(): string;
    set ticketId(value: string);
    resetTicketId(): void;
    get ticketIdInput(): string | undefined;
}
export interface PropertyActivationComplianceRecordNoncomplianceReasonNone {
    /**
    * Identifies the customer
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#customer_email PropertyActivation#customer_email}
    */
    readonly customerEmail?: string;
    /**
    * Identifies person who has independently approved the activation request
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#peer_reviewed_by PropertyActivation#peer_reviewed_by}
    */
    readonly peerReviewedBy?: string;
    /**
    * Identifies the ticket that describes the need for the activation
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#ticket_id PropertyActivation#ticket_id}
    */
    readonly ticketId?: string;
    /**
    * Whether the metadata to activate has been fully tested
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#unit_tested PropertyActivation#unit_tested}
    */
    readonly unitTested?: boolean | cdktf.IResolvable;
}
export declare function propertyActivationComplianceRecordNoncomplianceReasonNoneToTerraform(struct?: PropertyActivationComplianceRecordNoncomplianceReasonNoneOutputReference | PropertyActivationComplianceRecordNoncomplianceReasonNone): any;
export declare function propertyActivationComplianceRecordNoncomplianceReasonNoneToHclTerraform(struct?: PropertyActivationComplianceRecordNoncomplianceReasonNoneOutputReference | PropertyActivationComplianceRecordNoncomplianceReasonNone): any;
export declare class PropertyActivationComplianceRecordNoncomplianceReasonNoneOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PropertyActivationComplianceRecordNoncomplianceReasonNone | undefined;
    set internalValue(value: PropertyActivationComplianceRecordNoncomplianceReasonNone | undefined);
    private _customerEmail?;
    get customerEmail(): string;
    set customerEmail(value: string);
    resetCustomerEmail(): void;
    get customerEmailInput(): string | undefined;
    private _peerReviewedBy?;
    get peerReviewedBy(): string;
    set peerReviewedBy(value: string);
    resetPeerReviewedBy(): void;
    get peerReviewedByInput(): string | undefined;
    private _ticketId?;
    get ticketId(): string;
    set ticketId(value: string);
    resetTicketId(): void;
    get ticketIdInput(): string | undefined;
    private _unitTested?;
    get unitTested(): boolean | cdktf.IResolvable;
    set unitTested(value: boolean | cdktf.IResolvable);
    resetUnitTested(): void;
    get unitTestedInput(): boolean | cdktf.IResolvable | undefined;
}
export interface PropertyActivationComplianceRecordNoncomplianceReasonOther {
    /**
    * Describes the reason why the activation must occur immediately, out of compliance with the standard procedure
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#other_noncompliance_reason PropertyActivation#other_noncompliance_reason}
    */
    readonly otherNoncomplianceReason?: string;
    /**
    * Identifies the ticket that describes the need for the activation
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#ticket_id PropertyActivation#ticket_id}
    */
    readonly ticketId?: string;
}
export declare function propertyActivationComplianceRecordNoncomplianceReasonOtherToTerraform(struct?: PropertyActivationComplianceRecordNoncomplianceReasonOtherOutputReference | PropertyActivationComplianceRecordNoncomplianceReasonOther): any;
export declare function propertyActivationComplianceRecordNoncomplianceReasonOtherToHclTerraform(struct?: PropertyActivationComplianceRecordNoncomplianceReasonOtherOutputReference | PropertyActivationComplianceRecordNoncomplianceReasonOther): any;
export declare class PropertyActivationComplianceRecordNoncomplianceReasonOtherOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PropertyActivationComplianceRecordNoncomplianceReasonOther | undefined;
    set internalValue(value: PropertyActivationComplianceRecordNoncomplianceReasonOther | undefined);
    private _otherNoncomplianceReason?;
    get otherNoncomplianceReason(): string;
    set otherNoncomplianceReason(value: string);
    resetOtherNoncomplianceReason(): void;
    get otherNoncomplianceReasonInput(): string | undefined;
    private _ticketId?;
    get ticketId(): string;
    set ticketId(value: string);
    resetTicketId(): void;
    get ticketIdInput(): string | undefined;
}
export interface PropertyActivationComplianceRecord {
    /**
    * noncompliance_reason_emergency block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#noncompliance_reason_emergency PropertyActivation#noncompliance_reason_emergency}
    */
    readonly noncomplianceReasonEmergency?: PropertyActivationComplianceRecordNoncomplianceReasonEmergency;
    /**
    * noncompliance_reason_no_production_traffic block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#noncompliance_reason_no_production_traffic PropertyActivation#noncompliance_reason_no_production_traffic}
    */
    readonly noncomplianceReasonNoProductionTraffic?: PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTraffic;
    /**
    * noncompliance_reason_none block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#noncompliance_reason_none PropertyActivation#noncompliance_reason_none}
    */
    readonly noncomplianceReasonNone?: PropertyActivationComplianceRecordNoncomplianceReasonNone;
    /**
    * noncompliance_reason_other block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#noncompliance_reason_other PropertyActivation#noncompliance_reason_other}
    */
    readonly noncomplianceReasonOther?: PropertyActivationComplianceRecordNoncomplianceReasonOther;
}
export declare function propertyActivationComplianceRecordToTerraform(struct?: PropertyActivationComplianceRecordOutputReference | PropertyActivationComplianceRecord): any;
export declare function propertyActivationComplianceRecordToHclTerraform(struct?: PropertyActivationComplianceRecordOutputReference | PropertyActivationComplianceRecord): any;
export declare class PropertyActivationComplianceRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PropertyActivationComplianceRecord | undefined;
    set internalValue(value: PropertyActivationComplianceRecord | undefined);
    private _noncomplianceReasonEmergency;
    get noncomplianceReasonEmergency(): PropertyActivationComplianceRecordNoncomplianceReasonEmergencyOutputReference;
    putNoncomplianceReasonEmergency(value: PropertyActivationComplianceRecordNoncomplianceReasonEmergency): void;
    resetNoncomplianceReasonEmergency(): void;
    get noncomplianceReasonEmergencyInput(): PropertyActivationComplianceRecordNoncomplianceReasonEmergency | undefined;
    private _noncomplianceReasonNoProductionTraffic;
    get noncomplianceReasonNoProductionTraffic(): PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTrafficOutputReference;
    putNoncomplianceReasonNoProductionTraffic(value: PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTraffic): void;
    resetNoncomplianceReasonNoProductionTraffic(): void;
    get noncomplianceReasonNoProductionTrafficInput(): PropertyActivationComplianceRecordNoncomplianceReasonNoProductionTraffic | undefined;
    private _noncomplianceReasonNone;
    get noncomplianceReasonNone(): PropertyActivationComplianceRecordNoncomplianceReasonNoneOutputReference;
    putNoncomplianceReasonNone(value: PropertyActivationComplianceRecordNoncomplianceReasonNone): void;
    resetNoncomplianceReasonNone(): void;
    get noncomplianceReasonNoneInput(): PropertyActivationComplianceRecordNoncomplianceReasonNone | undefined;
    private _noncomplianceReasonOther;
    get noncomplianceReasonOther(): PropertyActivationComplianceRecordNoncomplianceReasonOtherOutputReference;
    putNoncomplianceReasonOther(value: PropertyActivationComplianceRecordNoncomplianceReasonOther): void;
    resetNoncomplianceReasonOther(): void;
    get noncomplianceReasonOtherInput(): PropertyActivationComplianceRecordNoncomplianceReasonOther | undefined;
}
export interface PropertyActivationRuleErrors {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#behavior_name PropertyActivation#behavior_name}
    */
    readonly behaviorName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#detail PropertyActivation#detail}
    */
    readonly detail?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#error_location PropertyActivation#error_location}
    */
    readonly errorLocation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#instance PropertyActivation#instance}
    */
    readonly instance?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#status_code PropertyActivation#status_code}
    */
    readonly statusCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#title PropertyActivation#title}
    */
    readonly title?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#type PropertyActivation#type}
    */
    readonly type?: string;
}
export declare function propertyActivationRuleErrorsToTerraform(struct?: PropertyActivationRuleErrors | cdktf.IResolvable): any;
export declare function propertyActivationRuleErrorsToHclTerraform(struct?: PropertyActivationRuleErrors | cdktf.IResolvable): any;
export declare class PropertyActivationRuleErrorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): PropertyActivationRuleErrors | cdktf.IResolvable | undefined;
    set internalValue(value: PropertyActivationRuleErrors | cdktf.IResolvable | undefined);
    private _behaviorName?;
    get behaviorName(): string;
    set behaviorName(value: string);
    resetBehaviorName(): void;
    get behaviorNameInput(): string | undefined;
    private _detail?;
    get detail(): string;
    set detail(value: string);
    resetDetail(): void;
    get detailInput(): string | undefined;
    private _errorLocation?;
    get errorLocation(): string;
    set errorLocation(value: string);
    resetErrorLocation(): void;
    get errorLocationInput(): string | undefined;
    private _instance?;
    get instance(): string;
    set instance(value: string);
    resetInstance(): void;
    get instanceInput(): string | undefined;
    private _statusCode?;
    get statusCode(): number;
    set statusCode(value: number);
    resetStatusCode(): void;
    get statusCodeInput(): number | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    resetTitle(): void;
    get titleInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export declare class PropertyActivationRuleErrorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: PropertyActivationRuleErrors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): PropertyActivationRuleErrorsOutputReference;
}
export interface PropertyActivationTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#default PropertyActivation#default}
    */
    readonly default?: string;
}
export declare function propertyActivationTimeoutsToTerraform(struct?: PropertyActivationTimeoutsOutputReference | PropertyActivationTimeouts): any;
export declare function propertyActivationTimeoutsToHclTerraform(struct?: PropertyActivationTimeoutsOutputReference | PropertyActivationTimeouts): any;
export declare class PropertyActivationTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PropertyActivationTimeouts | undefined;
    set internalValue(value: PropertyActivationTimeouts | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation akamai_property_activation}
*/
export declare class PropertyActivation extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_property_activation";
    /**
    * Generates CDKTF code for importing a PropertyActivation resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the PropertyActivation to import
    * @param importFromId The id of the existing PropertyActivation that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the PropertyActivation to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_activation akamai_property_activation} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options PropertyActivationConfig
    */
    constructor(scope: Construct, id: string, config: PropertyActivationConfig);
    private _activationId?;
    get activationId(): string;
    set activationId(value: string);
    resetActivationId(): void;
    get activationIdInput(): string | undefined;
    private _autoAcknowledgeRuleWarnings?;
    get autoAcknowledgeRuleWarnings(): boolean | cdktf.IResolvable;
    set autoAcknowledgeRuleWarnings(value: boolean | cdktf.IResolvable);
    resetAutoAcknowledgeRuleWarnings(): void;
    get autoAcknowledgeRuleWarningsInput(): boolean | cdktf.IResolvable | undefined;
    private _contact?;
    get contact(): string[];
    set contact(value: string[]);
    get contactInput(): string[] | undefined;
    get errors(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _network?;
    get network(): string;
    set network(value: string);
    resetNetwork(): void;
    get networkInput(): string | undefined;
    private _note?;
    get note(): string;
    set note(value: string);
    resetNote(): void;
    get noteInput(): string | undefined;
    private _propertyId?;
    get propertyId(): string;
    set propertyId(value: string);
    get propertyIdInput(): string | undefined;
    get status(): string;
    private _version?;
    get version(): number;
    set version(value: number);
    get versionInput(): number | undefined;
    get warnings(): string;
    private _complianceRecord;
    get complianceRecord(): PropertyActivationComplianceRecordOutputReference;
    putComplianceRecord(value: PropertyActivationComplianceRecord): void;
    resetComplianceRecord(): void;
    get complianceRecordInput(): PropertyActivationComplianceRecord | undefined;
    private _ruleErrors;
    get ruleErrors(): PropertyActivationRuleErrorsList;
    putRuleErrors(value: PropertyActivationRuleErrors[] | cdktf.IResolvable): void;
    resetRuleErrors(): void;
    get ruleErrorsInput(): cdktf.IResolvable | PropertyActivationRuleErrors[] | undefined;
    private _timeouts;
    get timeouts(): PropertyActivationTimeoutsOutputReference;
    putTimeouts(value: PropertyActivationTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): PropertyActivationTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
