import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface PropertyBootstrapConfig extends cdktf.TerraformMetaArguments {
    /**
    * Contract ID to be assigned to the Property
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_bootstrap#contract_id PropertyBootstrap#contract_id}
    */
    readonly contractId: string;
    /**
    * Group ID to be assigned to the Property
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_bootstrap#group_id PropertyBootstrap#group_id}
    */
    readonly groupId: string;
    /**
    * Name to give to the Property (must be unique)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_bootstrap#name PropertyBootstrap#name}
    */
    readonly name: string;
    /**
    * Product ID to be assigned to the Property
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_bootstrap#product_id PropertyBootstrap#product_id}
    */
    readonly productId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_bootstrap akamai_property_bootstrap}
*/
export declare class PropertyBootstrap extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_property_bootstrap";
    /**
    * Generates CDKTF code for importing a PropertyBootstrap resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the PropertyBootstrap to import
    * @param importFromId The id of the existing PropertyBootstrap that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_bootstrap#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the PropertyBootstrap to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/property_bootstrap akamai_property_bootstrap} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options PropertyBootstrapConfig
    */
    constructor(scope: Construct, id: string, config: PropertyBootstrapConfig);
    private _contractId?;
    get contractId(): string;
    set contractId(value: string);
    get contractIdInput(): string | undefined;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    get groupIdInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _productId?;
    get productId(): string;
    set productId(value: string);
    get productIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
