import * as cdktf from 'cdktf';
export interface DataAkamaiImagingPolicyImagePolicyBreakpoints {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#widths DataAkamaiImagingPolicyImage#widths}
    */
    readonly widths?: number[];
}
export declare function dataAkamaiImagingPolicyImagePolicyBreakpointsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyBreakpointsOutputReference | DataAkamaiImagingPolicyImagePolicyBreakpoints): any;
export declare function dataAkamaiImagingPolicyImagePolicyBreakpointsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyBreakpointsOutputReference | DataAkamaiImagingPolicyImagePolicyBreakpoints): any;
export declare class DataAkamaiImagingPolicyImagePolicyBreakpointsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyBreakpoints | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyBreakpoints | undefined);
    private _widths?;
    get widths(): number[];
    set widths(value: number[]);
    resetWidths(): void;
    get widthsInput(): number[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyOutput {
    /**
    * Override the quality of image to serve when Image & Video Manager detects a slow connection. Specifying lower values lets users with slow connections browse your site with reduced load times without impacting the quality of images for users with faster connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#adaptive_quality DataAkamaiImagingPolicyImage#adaptive_quality}
    */
    readonly adaptiveQuality?: string;
    /**
    * Whether a pristine image wider than the requested breakpoint is allowed as a derivative image if it has the fewest bytes. This will not have an affect if transformations are present.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_pristine_on_downsize DataAkamaiImagingPolicyImage#allow_pristine_on_downsize}
    */
    readonly allowPristineOnDownsize?: string;
    /**
    * The graphics file formats allowed for browser specific results.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_formats DataAkamaiImagingPolicyImage#allowed_formats}
    */
    readonly allowedFormats?: string[];
    /**
    * The forced extra formats for the `imFormat` query parameter, which requests a specific browser type. By default, Image and Video Manager detects the browser and returns the appropriate image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#forced_formats DataAkamaiImagingPolicyImage#forced_formats}
    */
    readonly forcedFormats?: string[];
    /**
    * Mutually exclusive with quality. The perceptual quality to use when comparing resulting images, which overrides the `quality` setting. Perceptual quality tunes each image format's quality parameter dynamically based on the human-perceived quality of the output image. This can result in better byte savings (as compared to using regular quality) as many images can be encoded at a much lower quality without compromising perception of the image. In addition, certain images may need to be encoded at a slightly higher quality in order to maintain human-perceived quality. Values are tiered `high`, `mediumHigh`, `medium`, `mediumLow`, or `low`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality DataAkamaiImagingPolicyImage#perceptual_quality}
    */
    readonly perceptualQuality?: string;
    /**
    * Only applies with perceptualQuality set. Sets a minimum image quality to respect when using perceptual quality. Perceptual quality will not reduce the quality below this value even if it determines the compressed image to be acceptably visually similar.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality_floor DataAkamaiImagingPolicyImage#perceptual_quality_floor}
    */
    readonly perceptualQualityFloor?: string;
    /**
    * Mutually exclusive with quality. The perceptual quality to use when comparing resulting images, which overrides the `quality` setting. Perceptual quality tunes each image format's quality parameter dynamically based on the human-perceived quality of the output image. This can result in better byte savings (as compared to using regular quality) as many images can be encoded at a much lower quality without compromising perception of the image. In addition, certain images may need to be encoded at a slightly higher quality in order to maintain human-perceived quality. Values are tiered `high`, `mediumHigh`, `medium`, `mediumLow`, or `low`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#perceptual_quality_var DataAkamaiImagingPolicyImage#perceptual_quality_var}
    */
    readonly perceptualQualityVar?: string;
    /**
    * Whether derivative image formats should be selected with a preference for modern formats (such as WebP and Avif) instead the format that results in the fewest bytes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#prefer_modern_formats DataAkamaiImagingPolicyImage#prefer_modern_formats}
    */
    readonly preferModernFormats?: string;
    /**
    * Mutually exclusive with perceptualQuality, used by default if neither is specified. The chosen quality of the output images. Using a quality value from 1-100 resembles JPEG quality across output formats.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#quality DataAkamaiImagingPolicyImage#quality}
    */
    readonly quality?: string;
    /**
    * Mutually exclusive with perceptualQuality, used by default if neither is specified. The chosen quality of the output images. Using a quality value from 1-100 resembles JPEG quality across output formats.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#quality_var DataAkamaiImagingPolicyImage#quality_var}
    */
    readonly qualityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyOutputToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyOutputOutputReference | DataAkamaiImagingPolicyImagePolicyOutput): any;
export declare function dataAkamaiImagingPolicyImagePolicyOutputToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyOutputOutputReference | DataAkamaiImagingPolicyImagePolicyOutput): any;
export declare class DataAkamaiImagingPolicyImagePolicyOutputOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyOutput | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyOutput | undefined);
    private _adaptiveQuality?;
    get adaptiveQuality(): string;
    set adaptiveQuality(value: string);
    resetAdaptiveQuality(): void;
    get adaptiveQualityInput(): string | undefined;
    private _allowPristineOnDownsize?;
    get allowPristineOnDownsize(): string;
    set allowPristineOnDownsize(value: string);
    resetAllowPristineOnDownsize(): void;
    get allowPristineOnDownsizeInput(): string | undefined;
    private _allowedFormats?;
    get allowedFormats(): string[];
    set allowedFormats(value: string[]);
    resetAllowedFormats(): void;
    get allowedFormatsInput(): string[] | undefined;
    private _forcedFormats?;
    get forcedFormats(): string[];
    set forcedFormats(value: string[]);
    resetForcedFormats(): void;
    get forcedFormatsInput(): string[] | undefined;
    private _perceptualQuality?;
    get perceptualQuality(): string;
    set perceptualQuality(value: string);
    resetPerceptualQuality(): void;
    get perceptualQualityInput(): string | undefined;
    private _perceptualQualityFloor?;
    get perceptualQualityFloor(): string;
    set perceptualQualityFloor(value: string);
    resetPerceptualQualityFloor(): void;
    get perceptualQualityFloorInput(): string | undefined;
    private _perceptualQualityVar?;
    get perceptualQualityVar(): string;
    set perceptualQualityVar(value: string);
    resetPerceptualQualityVar(): void;
    get perceptualQualityVarInput(): string | undefined;
    private _preferModernFormats?;
    get preferModernFormats(): string;
    set preferModernFormats(value: string);
    resetPreferModernFormats(): void;
    get preferModernFormatsInput(): string | undefined;
    private _quality?;
    get quality(): string;
    set quality(value: string);
    resetQuality(): void;
    get qualityInput(): string | undefined;
    private _qualityVar?;
    get qualityVar(): string;
    set qualityVar(value: string);
    resetQualityVar(): void;
    get qualityVarInput(): string | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage {
    /**
    * The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The height of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageBoxImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage {
    /**
    * The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The diameter of the circle. The diameter will be the width and the height of the image in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
    */
    readonly diameter?: string;
    /**
    * The diameter of the circle. The diameter will be the width and the height of the image in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
    */
    readonly diameterVar?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _diameter?;
    get diameter(): string;
    set diameter(value: string);
    resetDiameter(): void;
    get diameterInput(): string | undefined;
    private _diameterVar?;
    get diameterVar(): string;
    set diameterVar(value: string);
    resetDiameterVar(): void;
    get diameterVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageCircleImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage {
    /**
    * The main fill color of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
    */
    readonly fill?: string;
    /**
    * The main fill color of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
    */
    readonly fillVar?: string;
    /**
    * The size in pixels to render the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
    */
    readonly size?: string;
    /**
    * The size in pixels to render the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
    */
    readonly sizeVar?: string;
    /**
    * The color for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
    */
    readonly stroke?: string;
    /**
    * The thickness in points for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
    */
    readonly strokeSize?: string;
    /**
    * The thickness in points for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
    */
    readonly strokeSizeVar?: string;
    /**
    * The color for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
    */
    readonly strokeVar?: string;
    /**
    * The line of text to render.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
    */
    readonly text?: string;
    /**
    * The line of text to render.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
    */
    readonly textVar?: string;
    /**
    * The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
    */
    readonly typeface?: string;
    /**
    * The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
    */
    readonly typefaceVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage | cdktf.IResolvable | undefined);
    private _fill?;
    get fill(): string;
    set fill(value: string);
    resetFill(): void;
    get fillInput(): string | undefined;
    private _fillVar?;
    get fillVar(): string;
    set fillVar(value: string);
    resetFillVar(): void;
    get fillVarInput(): string | undefined;
    private _size?;
    get size(): string;
    set size(value: string);
    resetSize(): void;
    get sizeInput(): string | undefined;
    private _sizeVar?;
    get sizeVar(): string;
    set sizeVar(value: string);
    resetSizeVar(): void;
    get sizeVarInput(): string | undefined;
    private _stroke?;
    get stroke(): string;
    set stroke(value: string);
    resetStroke(): void;
    get strokeInput(): string | undefined;
    private _strokeSize?;
    get strokeSize(): string;
    set strokeSize(value: string);
    resetStrokeSize(): void;
    get strokeSizeInput(): string | undefined;
    private _strokeSizeVar?;
    get strokeSizeVar(): string;
    set strokeSizeVar(value: string);
    resetStrokeSizeVar(): void;
    get strokeSizeVarInput(): string | undefined;
    private _strokeVar?;
    get strokeVar(): string;
    set strokeVar(value: string);
    resetStrokeVar(): void;
    get strokeVarInput(): string | undefined;
    private _text?;
    get text(): string;
    set text(value: string);
    resetText(): void;
    get textInput(): string | undefined;
    private _textVar?;
    get textVar(): string;
    set textVar(value: string);
    resetTextVar(): void;
    get textVarInput(): string | undefined;
    private _typeface?;
    get typeface(): string;
    set typeface(value: string);
    resetTypeface(): void;
    get typefaceInput(): string | undefined;
    private _typefaceVar?;
    get typefaceVar(): string;
    set typefaceVar(value: string);
    resetTypefaceVar(): void;
    get typefaceVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageTextImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsCompositeImageUrlImageTransformationIfDimensionDefault | undefined);
}
