import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecAdvancedSettingsAttackPayloadLoggingConfig extends cdktf.TerraformMetaArguments {
    /**
    * Whether to enable, disable, or update attack payload logging settings
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_attack_payload_logging#attack_payload_logging AppsecAdvancedSettingsAttackPayloadLogging#attack_payload_logging}
    */
    readonly attackPayloadLogging: string;
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_attack_payload_logging#config_id AppsecAdvancedSettingsAttackPayloadLogging#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_attack_payload_logging#id AppsecAdvancedSettingsAttackPayloadLogging#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_attack_payload_logging#security_policy_id AppsecAdvancedSettingsAttackPayloadLogging#security_policy_id}
    */
    readonly securityPolicyId?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_attack_payload_logging akamai_appsec_advanced_settings_attack_payload_logging}
*/
export declare class AppsecAdvancedSettingsAttackPayloadLogging extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_advanced_settings_attack_payload_logging";
    /**
    * Generates CDKTF code for importing a AppsecAdvancedSettingsAttackPayloadLogging resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecAdvancedSettingsAttackPayloadLogging to import
    * @param importFromId The id of the existing AppsecAdvancedSettingsAttackPayloadLogging that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_attack_payload_logging#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecAdvancedSettingsAttackPayloadLogging to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_advanced_settings_attack_payload_logging akamai_appsec_advanced_settings_attack_payload_logging} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecAdvancedSettingsAttackPayloadLoggingConfig
    */
    constructor(scope: Construct, id: string, config: AppsecAdvancedSettingsAttackPayloadLoggingConfig);
    private _attackPayloadLogging?;
    get attackPayloadLogging(): string;
    set attackPayloadLogging(value: string);
    get attackPayloadLoggingInput(): string | undefined;
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    resetSecurityPolicyId(): void;
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
