import * as cdktf from 'cdktf';
import { DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage, DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImageOutputReference } from './structs12400';
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery {
    /**
    * Specifies the transformations that can be applied using the query string parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
    */
    readonly allowedTransformations: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}
    */
    readonly queryVar: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery | cdktf.IResolvable | undefined);
    private _allowedTransformations?;
    get allowedTransformations(): string[];
    set allowedTransformations(value: string[]);
    get allowedTransformationsInput(): string[] | undefined;
    private _queryVar?;
    get queryVar(): string;
    set queryVar(value: string);
    get queryVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop {
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * region_of_interest block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
    */
    readonly regionOfInterest: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _regionOfInterest;
    get regionOfInterest(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterestOutputReference;
    putRegionOfInterest(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest): void;
    get regionOfInterestInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropRegionOfInterest | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop {
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
    */
    readonly east?: string;
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
    */
    readonly eastVar?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
    */
    readonly north?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
    */
    readonly northVar?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
    */
    readonly south?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
    */
    readonly southVar?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
    */
    readonly west?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
    */
    readonly westVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop | cdktf.IResolvable | undefined);
    private _east?;
    get east(): string;
    set east(value: string);
    resetEast(): void;
    get eastInput(): string | undefined;
    private _eastVar?;
    get eastVar(): string;
    set eastVar(value: string);
    resetEastVar(): void;
    get eastVarInput(): string | undefined;
    private _north?;
    get north(): string;
    set north(value: string);
    resetNorth(): void;
    get northInput(): string | undefined;
    private _northVar?;
    get northVar(): string;
    set northVar(value: string);
    resetNorthVar(): void;
    get northVarInput(): string | undefined;
    private _south?;
    get south(): string;
    set south(value: string);
    resetSouth(): void;
    get southInput(): string | undefined;
    private _southVar?;
    get southVar(): string;
    set southVar(value: string);
    resetSouthVar(): void;
    get southVarInput(): string | undefined;
    private _west?;
    get west(): string;
    set west(value: string);
    resetWest(): void;
    get westInput(): string | undefined;
    private _westVar?;
    get westVar(): string;
    set westVar(value: string);
    resetWestVar(): void;
    get westVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize {
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
    */
    readonly aspect?: string;
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
    */
    readonly aspectVar?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize | cdktf.IResolvable | undefined);
    private _aspect?;
    get aspect(): string;
    set aspect(value: string);
    resetAspect(): void;
    get aspectInput(): string | undefined;
    private _aspectVar?;
    get aspectVar(): string;
    set aspectVar(value: string);
    resetAspectVar(): void;
    get aspectVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate {
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
    */
    readonly degrees?: string;
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
    */
    readonly degreesVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate | cdktf.IResolvable | undefined);
    private _degrees?;
    get degrees(): string;
    set degrees(value: string);
    resetDegrees(): void;
    get degreesInput(): string | undefined;
    private _degreesVar?;
    get degreesVar(): string;
    set degreesVar(value: string);
    resetDegreesVar(): void;
    get degreesVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale {
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear {
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
    */
    readonly xShear?: string;
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
    */
    readonly xShearVar?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
    */
    readonly yShear?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
    */
    readonly yShearVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear | cdktf.IResolvable | undefined);
    private _xShear?;
    get xShear(): string;
    set xShear(value: string);
    resetXShear(): void;
    get xShearInput(): string | undefined;
    private _xShearVar?;
    get xShearVar(): string;
    set xShearVar(value: string);
    resetXShearVar(): void;
    get xShearVarInput(): string | undefined;
    private _yShear?;
    get yShear(): string;
    set yShear(value: string);
    resetYShear(): void;
    get yShearInput(): string | undefined;
    private _yShearVar?;
    get yShearVar(): string;
    set yShearVar(value: string);
    resetYShearVar(): void;
    get yShearVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim {
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
    */
    readonly fuzz?: string;
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
    */
    readonly fuzzVar?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim | cdktf.IResolvable | undefined);
    private _fuzz?;
    get fuzz(): string;
    set fuzz(value: string);
    resetFuzz(): void;
    get fuzzInput(): string | undefined;
    private _fuzzVar?;
    get fuzzVar(): string;
    set fuzzVar(value: string);
    resetFuzzVar(): void;
    get fuzzVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault {
    /**
    * append block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
    */
    readonly append?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend[] | cdktf.IResolvable;
    /**
    * aspect_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
    */
    readonly aspectCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop[] | cdktf.IResolvable;
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast[] | cdktf.IResolvable;
    /**
    * crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
    */
    readonly crop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop[] | cdktf.IResolvable;
    /**
    * face_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
    */
    readonly faceCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop[] | cdktf.IResolvable;
    /**
    * feature_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
    */
    readonly featureCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop[] | cdktf.IResolvable;
    /**
    * fit_and_fill block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
    */
    readonly fitAndFill?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation[] | cdktf.IResolvable;
    /**
    * im_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
    */
    readonly imQuery?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity[] | cdktf.IResolvable;
    /**
    * region_of_interest_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
    */
    readonly regionOfInterestCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * relative_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
    */
    readonly relativeCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor[] | cdktf.IResolvable;
    /**
    * resize block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
    */
    readonly resize?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize[] | cdktf.IResolvable;
    /**
    * rotate block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
    */
    readonly rotate?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate[] | cdktf.IResolvable;
    /**
    * scale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale[] | cdktf.IResolvable;
    /**
    * shear block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
    */
    readonly shear?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear[] | cdktf.IResolvable;
    /**
    * trim block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
    */
    readonly trim?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefault | undefined);
    private _append;
    get append(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppendList;
    putAppend(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend[] | cdktf.IResolvable): void;
    resetAppend(): void;
    get appendInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAppend[] | undefined;
    private _aspectCrop;
    get aspectCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCropList;
    putAspectCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop[] | cdktf.IResolvable): void;
    resetAspectCrop(): void;
    get aspectCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultAspectCrop[] | undefined;
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultContrast[] | undefined;
    private _crop;
    get crop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCropList;
    putCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop[] | cdktf.IResolvable): void;
    resetCrop(): void;
    get cropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultCrop[] | undefined;
    private _faceCrop;
    get faceCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCropList;
    putFaceCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop[] | cdktf.IResolvable): void;
    resetFaceCrop(): void;
    get faceCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFaceCrop[] | undefined;
    private _featureCrop;
    get featureCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCropList;
    putFeatureCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop[] | cdktf.IResolvable): void;
    resetFeatureCrop(): void;
    get featureCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFeatureCrop[] | undefined;
    private _fitAndFill;
    get fitAndFill(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFillList;
    putFitAndFill(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill[] | cdktf.IResolvable): void;
    resetFitAndFill(): void;
    get fitAndFillInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultFitAndFill[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultIfOrientation[] | undefined;
    private _imQuery;
    get imQuery(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQueryList;
    putImQuery(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery[] | cdktf.IResolvable): void;
    resetImQuery(): void;
    get imQueryInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultImQuery[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultOpacity[] | undefined;
    private _regionOfInterestCrop;
    get regionOfInterestCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCropList;
    putRegionOfInterestCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop[] | cdktf.IResolvable): void;
    resetRegionOfInterestCrop(): void;
    get regionOfInterestCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRegionOfInterestCrop[] | undefined;
    private _relativeCrop;
    get relativeCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCropList;
    putRelativeCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop[] | cdktf.IResolvable): void;
    resetRelativeCrop(): void;
    get relativeCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRelativeCrop[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRemoveColor[] | undefined;
    private _resize;
    get resize(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResizeList;
    putResize(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize[] | cdktf.IResolvable): void;
    resetResize(): void;
    get resizeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultResize[] | undefined;
    private _rotate;
    get rotate(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotateList;
    putRotate(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate[] | cdktf.IResolvable): void;
    resetRotate(): void;
    get rotateInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultRotate[] | undefined;
    private _scale;
    get scale(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScaleList;
    putScale(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale[] | cdktf.IResolvable): void;
    resetScale(): void;
    get scaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultScale[] | undefined;
    private _shear;
    get shear(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShearList;
    putShear(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear[] | cdktf.IResolvable): void;
    resetShear(): void;
    get shearInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultShear[] | undefined;
    private _trim;
    get trim(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrimList;
    putTrim(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim[] | cdktf.IResolvable): void;
    resetTrim(): void;
    get trimInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultTrim[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationDefaultUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery {
    /**
    * Specifies the transformations that can be applied using the query string parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
    */
    readonly allowedTransformations: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}
    */
    readonly queryVar: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery | cdktf.IResolvable | undefined);
    private _allowedTransformations?;
    get allowedTransformations(): string[];
    set allowedTransformations(value: string[]);
    get allowedTransformationsInput(): string[] | undefined;
    private _queryVar?;
    get queryVar(): string;
    set queryVar(value: string);
    get queryVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop {
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * region_of_interest block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
    */
    readonly regionOfInterest: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _regionOfInterest;
    get regionOfInterest(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference;
    putRegionOfInterest(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest): void;
    get regionOfInterestInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropRegionOfInterest | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop {
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
    */
    readonly east?: string;
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
    */
    readonly eastVar?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
    */
    readonly north?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
    */
    readonly northVar?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
    */
    readonly south?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
    */
    readonly southVar?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
    */
    readonly west?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
    */
    readonly westVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop | cdktf.IResolvable | undefined);
    private _east?;
    get east(): string;
    set east(value: string);
    resetEast(): void;
    get eastInput(): string | undefined;
    private _eastVar?;
    get eastVar(): string;
    set eastVar(value: string);
    resetEastVar(): void;
    get eastVarInput(): string | undefined;
    private _north?;
    get north(): string;
    set north(value: string);
    resetNorth(): void;
    get northInput(): string | undefined;
    private _northVar?;
    get northVar(): string;
    set northVar(value: string);
    resetNorthVar(): void;
    get northVarInput(): string | undefined;
    private _south?;
    get south(): string;
    set south(value: string);
    resetSouth(): void;
    get southInput(): string | undefined;
    private _southVar?;
    get southVar(): string;
    set southVar(value: string);
    resetSouthVar(): void;
    get southVarInput(): string | undefined;
    private _west?;
    get west(): string;
    set west(value: string);
    resetWest(): void;
    get westInput(): string | undefined;
    private _westVar?;
    get westVar(): string;
    set westVar(value: string);
    resetWestVar(): void;
    get westVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize {
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
    */
    readonly aspect?: string;
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
    */
    readonly aspectVar?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize | cdktf.IResolvable | undefined);
    private _aspect?;
    get aspect(): string;
    set aspect(value: string);
    resetAspect(): void;
    get aspectInput(): string | undefined;
    private _aspectVar?;
    get aspectVar(): string;
    set aspectVar(value: string);
    resetAspectVar(): void;
    get aspectVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate {
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
    */
    readonly degrees?: string;
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
    */
    readonly degreesVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate | cdktf.IResolvable | undefined);
    private _degrees?;
    get degrees(): string;
    set degrees(value: string);
    resetDegrees(): void;
    get degreesInput(): string | undefined;
    private _degreesVar?;
    get degreesVar(): string;
    set degreesVar(value: string);
    resetDegreesVar(): void;
    get degreesVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale {
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear {
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
    */
    readonly xShear?: string;
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
    */
    readonly xShearVar?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
    */
    readonly yShear?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
    */
    readonly yShearVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear | cdktf.IResolvable | undefined);
    private _xShear?;
    get xShear(): string;
    set xShear(value: string);
    resetXShear(): void;
    get xShearInput(): string | undefined;
    private _xShearVar?;
    get xShearVar(): string;
    set xShearVar(value: string);
    resetXShearVar(): void;
    get xShearVarInput(): string | undefined;
    private _yShear?;
    get yShear(): string;
    set yShear(value: string);
    resetYShear(): void;
    get yShearInput(): string | undefined;
    private _yShearVar?;
    get yShearVar(): string;
    set yShearVar(value: string);
    resetYShearVar(): void;
    get yShearVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim {
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
    */
    readonly fuzz?: string;
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
    */
    readonly fuzzVar?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim | cdktf.IResolvable | undefined);
    private _fuzz?;
    get fuzz(): string;
    set fuzz(value: string);
    resetFuzz(): void;
    get fuzzInput(): string | undefined;
    private _fuzzVar?;
    get fuzzVar(): string;
    set fuzzVar(value: string);
    resetFuzzVar(): void;
    get fuzzVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape {
    /**
    * append block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
    */
    readonly append?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend[] | cdktf.IResolvable;
    /**
    * aspect_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
    */
    readonly aspectCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop[] | cdktf.IResolvable;
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast[] | cdktf.IResolvable;
    /**
    * crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
    */
    readonly crop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop[] | cdktf.IResolvable;
    /**
    * face_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
    */
    readonly faceCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop[] | cdktf.IResolvable;
    /**
    * feature_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
    */
    readonly featureCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop[] | cdktf.IResolvable;
    /**
    * fit_and_fill block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
    */
    readonly fitAndFill?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable;
    /**
    * im_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
    */
    readonly imQuery?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity[] | cdktf.IResolvable;
    /**
    * region_of_interest_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
    */
    readonly regionOfInterestCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * relative_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
    */
    readonly relativeCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable;
    /**
    * resize block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
    */
    readonly resize?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize[] | cdktf.IResolvable;
    /**
    * rotate block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
    */
    readonly rotate?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate[] | cdktf.IResolvable;
    /**
    * scale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale[] | cdktf.IResolvable;
    /**
    * shear block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
    */
    readonly shear?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear[] | cdktf.IResolvable;
    /**
    * trim block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
    */
    readonly trim?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscape | undefined);
    private _append;
    get append(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppendList;
    putAppend(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend[] | cdktf.IResolvable): void;
    resetAppend(): void;
    get appendInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAppend[] | undefined;
    private _aspectCrop;
    get aspectCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCropList;
    putAspectCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop[] | cdktf.IResolvable): void;
    resetAspectCrop(): void;
    get aspectCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeAspectCrop[] | undefined;
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeContrast[] | undefined;
    private _crop;
    get crop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCropList;
    putCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop[] | cdktf.IResolvable): void;
    resetCrop(): void;
    get cropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeCrop[] | undefined;
    private _faceCrop;
    get faceCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCropList;
    putFaceCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop[] | cdktf.IResolvable): void;
    resetFaceCrop(): void;
    get faceCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFaceCrop[] | undefined;
    private _featureCrop;
    get featureCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCropList;
    putFeatureCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop[] | cdktf.IResolvable): void;
    resetFeatureCrop(): void;
    get featureCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFeatureCrop[] | undefined;
    private _fitAndFill;
    get fitAndFill(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFillList;
    putFitAndFill(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill[] | cdktf.IResolvable): void;
    resetFitAndFill(): void;
    get fitAndFillInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeFitAndFill[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeIfOrientation[] | undefined;
    private _imQuery;
    get imQuery(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQueryList;
    putImQuery(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery[] | cdktf.IResolvable): void;
    resetImQuery(): void;
    get imQueryInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeImQuery[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeOpacity[] | undefined;
    private _regionOfInterestCrop;
    get regionOfInterestCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCropList;
    putRegionOfInterestCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop[] | cdktf.IResolvable): void;
    resetRegionOfInterestCrop(): void;
    get regionOfInterestCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRegionOfInterestCrop[] | undefined;
    private _relativeCrop;
    get relativeCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCropList;
    putRelativeCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop[] | cdktf.IResolvable): void;
    resetRelativeCrop(): void;
    get relativeCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRelativeCrop[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRemoveColor[] | undefined;
    private _resize;
    get resize(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResizeList;
    putResize(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize[] | cdktf.IResolvable): void;
    resetResize(): void;
    get resizeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeResize[] | undefined;
    private _rotate;
    get rotate(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotateList;
    putRotate(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate[] | cdktf.IResolvable): void;
    resetRotate(): void;
    get rotateInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeRotate[] | undefined;
    private _scale;
    get scale(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScaleList;
    putScale(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale[] | cdktf.IResolvable): void;
    resetScale(): void;
    get scaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeScale[] | undefined;
    private _shear;
    get shear(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShearList;
    putShear(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear[] | cdktf.IResolvable): void;
    resetShear(): void;
    get shearInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeShear[] | undefined;
    private _trim;
    get trim(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrimList;
    putTrim(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim[] | cdktf.IResolvable): void;
    resetTrim(): void;
    get trimInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeTrim[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationLandscapeUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfDimensionLessThanIfOrientationPortraitFitAndFillOutputReference;
}
