import * as cdktf from 'cdktf';
import { DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend, DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendList } from './structs14400';
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery {
    /**
    * Specifies the transformations that can be applied using the query string parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
    */
    readonly allowedTransformations: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}
    */
    readonly queryVar: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery | cdktf.IResolvable | undefined);
    private _allowedTransformations?;
    get allowedTransformations(): string[];
    set allowedTransformations(value: string[]);
    get allowedTransformationsInput(): string[] | undefined;
    private _queryVar?;
    get queryVar(): string;
    set queryVar(value: string);
    get queryVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop {
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * region_of_interest block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
    */
    readonly regionOfInterest: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _regionOfInterest;
    get regionOfInterest(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterestOutputReference;
    putRegionOfInterest(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest): void;
    get regionOfInterestInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropRegionOfInterest | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop {
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
    */
    readonly east?: string;
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
    */
    readonly eastVar?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
    */
    readonly north?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
    */
    readonly northVar?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
    */
    readonly south?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
    */
    readonly southVar?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
    */
    readonly west?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
    */
    readonly westVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop | cdktf.IResolvable | undefined);
    private _east?;
    get east(): string;
    set east(value: string);
    resetEast(): void;
    get eastInput(): string | undefined;
    private _eastVar?;
    get eastVar(): string;
    set eastVar(value: string);
    resetEastVar(): void;
    get eastVarInput(): string | undefined;
    private _north?;
    get north(): string;
    set north(value: string);
    resetNorth(): void;
    get northInput(): string | undefined;
    private _northVar?;
    get northVar(): string;
    set northVar(value: string);
    resetNorthVar(): void;
    get northVarInput(): string | undefined;
    private _south?;
    get south(): string;
    set south(value: string);
    resetSouth(): void;
    get southInput(): string | undefined;
    private _southVar?;
    get southVar(): string;
    set southVar(value: string);
    resetSouthVar(): void;
    get southVarInput(): string | undefined;
    private _west?;
    get west(): string;
    set west(value: string);
    resetWest(): void;
    get westInput(): string | undefined;
    private _westVar?;
    get westVar(): string;
    set westVar(value: string);
    resetWestVar(): void;
    get westVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize {
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
    */
    readonly aspect?: string;
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
    */
    readonly aspectVar?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize | cdktf.IResolvable | undefined);
    private _aspect?;
    get aspect(): string;
    set aspect(value: string);
    resetAspect(): void;
    get aspectInput(): string | undefined;
    private _aspectVar?;
    get aspectVar(): string;
    set aspectVar(value: string);
    resetAspectVar(): void;
    get aspectVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate {
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
    */
    readonly degrees?: string;
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
    */
    readonly degreesVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate | cdktf.IResolvable | undefined);
    private _degrees?;
    get degrees(): string;
    set degrees(value: string);
    resetDegrees(): void;
    get degreesInput(): string | undefined;
    private _degreesVar?;
    get degreesVar(): string;
    set degreesVar(value: string);
    resetDegreesVar(): void;
    get degreesVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale {
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear {
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
    */
    readonly xShear?: string;
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
    */
    readonly xShearVar?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
    */
    readonly yShear?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
    */
    readonly yShearVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear | cdktf.IResolvable | undefined);
    private _xShear?;
    get xShear(): string;
    set xShear(value: string);
    resetXShear(): void;
    get xShearInput(): string | undefined;
    private _xShearVar?;
    get xShearVar(): string;
    set xShearVar(value: string);
    resetXShearVar(): void;
    get xShearVarInput(): string | undefined;
    private _yShear?;
    get yShear(): string;
    set yShear(value: string);
    resetYShear(): void;
    get yShearInput(): string | undefined;
    private _yShearVar?;
    get yShearVar(): string;
    set yShearVar(value: string);
    resetYShearVar(): void;
    get yShearVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim {
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
    */
    readonly fuzz?: string;
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
    */
    readonly fuzzVar?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim | cdktf.IResolvable | undefined);
    private _fuzz?;
    get fuzz(): string;
    set fuzz(value: string);
    resetFuzz(): void;
    get fuzzInput(): string | undefined;
    private _fuzzVar?;
    get fuzzVar(): string;
    set fuzzVar(value: string);
    resetFuzzVar(): void;
    get fuzzVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault {
    /**
    * append block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
    */
    readonly append?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend[] | cdktf.IResolvable;
    /**
    * aspect_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
    */
    readonly aspectCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop[] | cdktf.IResolvable;
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast[] | cdktf.IResolvable;
    /**
    * crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
    */
    readonly crop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop[] | cdktf.IResolvable;
    /**
    * face_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
    */
    readonly faceCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop[] | cdktf.IResolvable;
    /**
    * feature_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
    */
    readonly featureCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop[] | cdktf.IResolvable;
    /**
    * fit_and_fill block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
    */
    readonly fitAndFill?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation[] | cdktf.IResolvable;
    /**
    * im_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
    */
    readonly imQuery?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity[] | cdktf.IResolvable;
    /**
    * region_of_interest_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
    */
    readonly regionOfInterestCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * relative_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
    */
    readonly relativeCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor[] | cdktf.IResolvable;
    /**
    * resize block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
    */
    readonly resize?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize[] | cdktf.IResolvable;
    /**
    * rotate block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
    */
    readonly rotate?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate[] | cdktf.IResolvable;
    /**
    * scale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale[] | cdktf.IResolvable;
    /**
    * shear block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
    */
    readonly shear?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear[] | cdktf.IResolvable;
    /**
    * trim block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
    */
    readonly trim?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefault | undefined);
    private _append;
    get append(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppendList;
    putAppend(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend[] | cdktf.IResolvable): void;
    resetAppend(): void;
    get appendInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAppend[] | undefined;
    private _aspectCrop;
    get aspectCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCropList;
    putAspectCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop[] | cdktf.IResolvable): void;
    resetAspectCrop(): void;
    get aspectCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultAspectCrop[] | undefined;
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultContrast[] | undefined;
    private _crop;
    get crop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCropList;
    putCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop[] | cdktf.IResolvable): void;
    resetCrop(): void;
    get cropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultCrop[] | undefined;
    private _faceCrop;
    get faceCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCropList;
    putFaceCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop[] | cdktf.IResolvable): void;
    resetFaceCrop(): void;
    get faceCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFaceCrop[] | undefined;
    private _featureCrop;
    get featureCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCropList;
    putFeatureCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop[] | cdktf.IResolvable): void;
    resetFeatureCrop(): void;
    get featureCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFeatureCrop[] | undefined;
    private _fitAndFill;
    get fitAndFill(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFillList;
    putFitAndFill(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill[] | cdktf.IResolvable): void;
    resetFitAndFill(): void;
    get fitAndFillInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultFitAndFill[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultIfOrientation[] | undefined;
    private _imQuery;
    get imQuery(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQueryList;
    putImQuery(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery[] | cdktf.IResolvable): void;
    resetImQuery(): void;
    get imQueryInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultImQuery[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultOpacity[] | undefined;
    private _regionOfInterestCrop;
    get regionOfInterestCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCropList;
    putRegionOfInterestCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop[] | cdktf.IResolvable): void;
    resetRegionOfInterestCrop(): void;
    get regionOfInterestCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRegionOfInterestCrop[] | undefined;
    private _relativeCrop;
    get relativeCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCropList;
    putRelativeCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop[] | cdktf.IResolvable): void;
    resetRelativeCrop(): void;
    get relativeCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRelativeCrop[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRemoveColor[] | undefined;
    private _resize;
    get resize(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResizeList;
    putResize(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize[] | cdktf.IResolvable): void;
    resetResize(): void;
    get resizeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultResize[] | undefined;
    private _rotate;
    get rotate(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotateList;
    putRotate(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate[] | cdktf.IResolvable): void;
    resetRotate(): void;
    get rotateInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultRotate[] | undefined;
    private _scale;
    get scale(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScaleList;
    putScale(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale[] | cdktf.IResolvable): void;
    resetScale(): void;
    get scaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultScale[] | undefined;
    private _shear;
    get shear(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShearList;
    putShear(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear[] | cdktf.IResolvable): void;
    resetShear(): void;
    get shearInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultShear[] | undefined;
    private _trim;
    get trim(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrimList;
    putTrim(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim[] | cdktf.IResolvable): void;
    resetTrim(): void;
    get trimInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultTrim[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionDefaultUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery {
    /**
    * Specifies the transformations that can be applied using the query string parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
    */
    readonly allowedTransformations: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}
    */
    readonly queryVar: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery | cdktf.IResolvable | undefined);
    private _allowedTransformations?;
    get allowedTransformations(): string[];
    set allowedTransformations(value: string[]);
    get allowedTransformationsInput(): string[] | undefined;
    private _queryVar?;
    get queryVar(): string;
    set queryVar(value: string);
    get queryVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop {
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * region_of_interest block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
    */
    readonly regionOfInterest: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _regionOfInterest;
    get regionOfInterest(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterestOutputReference;
    putRegionOfInterest(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest): void;
    get regionOfInterestInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropRegionOfInterest | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop {
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
    */
    readonly east?: string;
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
    */
    readonly eastVar?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
    */
    readonly north?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
    */
    readonly northVar?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
    */
    readonly south?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
    */
    readonly southVar?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
    */
    readonly west?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
    */
    readonly westVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop | cdktf.IResolvable | undefined);
    private _east?;
    get east(): string;
    set east(value: string);
    resetEast(): void;
    get eastInput(): string | undefined;
    private _eastVar?;
    get eastVar(): string;
    set eastVar(value: string);
    resetEastVar(): void;
    get eastVarInput(): string | undefined;
    private _north?;
    get north(): string;
    set north(value: string);
    resetNorth(): void;
    get northInput(): string | undefined;
    private _northVar?;
    get northVar(): string;
    set northVar(value: string);
    resetNorthVar(): void;
    get northVarInput(): string | undefined;
    private _south?;
    get south(): string;
    set south(value: string);
    resetSouth(): void;
    get southInput(): string | undefined;
    private _southVar?;
    get southVar(): string;
    set southVar(value: string);
    resetSouthVar(): void;
    get southVarInput(): string | undefined;
    private _west?;
    get west(): string;
    set west(value: string);
    resetWest(): void;
    get westInput(): string | undefined;
    private _westVar?;
    get westVar(): string;
    set westVar(value: string);
    resetWestVar(): void;
    get westVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize {
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
    */
    readonly aspect?: string;
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
    */
    readonly aspectVar?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize | cdktf.IResolvable | undefined);
    private _aspect?;
    get aspect(): string;
    set aspect(value: string);
    resetAspect(): void;
    get aspectInput(): string | undefined;
    private _aspectVar?;
    get aspectVar(): string;
    set aspectVar(value: string);
    resetAspectVar(): void;
    get aspectVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate {
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
    */
    readonly degrees?: string;
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
    */
    readonly degreesVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate | cdktf.IResolvable | undefined);
    private _degrees?;
    get degrees(): string;
    set degrees(value: string);
    resetDegrees(): void;
    get degreesInput(): string | undefined;
    private _degreesVar?;
    get degreesVar(): string;
    set degreesVar(value: string);
    resetDegreesVar(): void;
    get degreesVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale {
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear {
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
    */
    readonly xShear?: string;
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
    */
    readonly xShearVar?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
    */
    readonly yShear?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
    */
    readonly yShearVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear | cdktf.IResolvable | undefined);
    private _xShear?;
    get xShear(): string;
    set xShear(value: string);
    resetXShear(): void;
    get xShearInput(): string | undefined;
    private _xShearVar?;
    get xShearVar(): string;
    set xShearVar(value: string);
    resetXShearVar(): void;
    get xShearVarInput(): string | undefined;
    private _yShear?;
    get yShear(): string;
    set yShear(value: string);
    resetYShear(): void;
    get yShearInput(): string | undefined;
    private _yShearVar?;
    get yShearVar(): string;
    set yShearVar(value: string);
    resetYShearVar(): void;
    get yShearVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim {
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
    */
    readonly fuzz?: string;
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
    */
    readonly fuzzVar?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim | cdktf.IResolvable | undefined);
    private _fuzz?;
    get fuzz(): string;
    set fuzz(value: string);
    resetFuzz(): void;
    get fuzzInput(): string | undefined;
    private _fuzzVar?;
    get fuzzVar(): string;
    set fuzzVar(value: string);
    resetFuzzVar(): void;
    get fuzzVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual {
    /**
    * append block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
    */
    readonly append?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend[] | cdktf.IResolvable;
    /**
    * aspect_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
    */
    readonly aspectCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop[] | cdktf.IResolvable;
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast[] | cdktf.IResolvable;
    /**
    * crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
    */
    readonly crop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop[] | cdktf.IResolvable;
    /**
    * face_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
    */
    readonly faceCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop[] | cdktf.IResolvable;
    /**
    * feature_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
    */
    readonly featureCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop[] | cdktf.IResolvable;
    /**
    * fit_and_fill block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
    */
    readonly fitAndFill?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation[] | cdktf.IResolvable;
    /**
    * im_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
    */
    readonly imQuery?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity[] | cdktf.IResolvable;
    /**
    * region_of_interest_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
    */
    readonly regionOfInterestCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * relative_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
    */
    readonly relativeCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor[] | cdktf.IResolvable;
    /**
    * resize block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
    */
    readonly resize?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize[] | cdktf.IResolvable;
    /**
    * rotate block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
    */
    readonly rotate?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate[] | cdktf.IResolvable;
    /**
    * scale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale[] | cdktf.IResolvable;
    /**
    * shear block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
    */
    readonly shear?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear[] | cdktf.IResolvable;
    /**
    * trim block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
    */
    readonly trim?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqual | undefined);
    private _append;
    get append(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppendList;
    putAppend(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend[] | cdktf.IResolvable): void;
    resetAppend(): void;
    get appendInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAppend[] | undefined;
    private _aspectCrop;
    get aspectCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCropList;
    putAspectCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop[] | cdktf.IResolvable): void;
    resetAspectCrop(): void;
    get aspectCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualAspectCrop[] | undefined;
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualContrast[] | undefined;
    private _crop;
    get crop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCropList;
    putCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop[] | cdktf.IResolvable): void;
    resetCrop(): void;
    get cropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualCrop[] | undefined;
    private _faceCrop;
    get faceCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCropList;
    putFaceCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop[] | cdktf.IResolvable): void;
    resetFaceCrop(): void;
    get faceCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFaceCrop[] | undefined;
    private _featureCrop;
    get featureCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCropList;
    putFeatureCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop[] | cdktf.IResolvable): void;
    resetFeatureCrop(): void;
    get featureCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFeatureCrop[] | undefined;
    private _fitAndFill;
    get fitAndFill(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFillList;
    putFitAndFill(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill[] | cdktf.IResolvable): void;
    resetFitAndFill(): void;
    get fitAndFillInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualFitAndFill[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualIfOrientation[] | undefined;
    private _imQuery;
    get imQuery(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQueryList;
    putImQuery(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery[] | cdktf.IResolvable): void;
    resetImQuery(): void;
    get imQueryInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualImQuery[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualOpacity[] | undefined;
    private _regionOfInterestCrop;
    get regionOfInterestCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCropList;
    putRegionOfInterestCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop[] | cdktf.IResolvable): void;
    resetRegionOfInterestCrop(): void;
    get regionOfInterestCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRegionOfInterestCrop[] | undefined;
    private _relativeCrop;
    get relativeCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCropList;
    putRelativeCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop[] | cdktf.IResolvable): void;
    resetRelativeCrop(): void;
    get relativeCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRelativeCrop[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRemoveColor[] | undefined;
    private _resize;
    get resize(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResizeList;
    putResize(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize[] | cdktf.IResolvable): void;
    resetResize(): void;
    get resizeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualResize[] | undefined;
    private _rotate;
    get rotate(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotateList;
    putRotate(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate[] | cdktf.IResolvable): void;
    resetRotate(): void;
    get rotateInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualRotate[] | undefined;
    private _scale;
    get scale(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScaleList;
    putScale(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale[] | cdktf.IResolvable): void;
    resetScale(): void;
    get scaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualScale[] | undefined;
    private _shear;
    get shear(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShearList;
    putShear(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear[] | cdktf.IResolvable): void;
    resetShear(): void;
    get shearInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualShear[] | undefined;
    private _trim;
    get trim(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrimList;
    putTrim(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim[] | cdktf.IResolvable): void;
    resetTrim(): void;
    get trimInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualTrim[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionEqualUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsIfOrientationLandscapeIfDimensionGreaterThanGoopOutputReference;
}
