import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecMalwarePolicyActionsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy_actions#config_id AppsecMalwarePolicyActions#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy_actions#id AppsecMalwarePolicyActions#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * JSON-formatted list of malware policies and their associated actions
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy_actions#malware_policy_actions AppsecMalwarePolicyActions#malware_policy_actions}
    */
    readonly malwarePolicyActions: string;
    /**
    * Unique identifier of the security policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy_actions#security_policy_id AppsecMalwarePolicyActions#security_policy_id}
    */
    readonly securityPolicyId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy_actions akamai_appsec_malware_policy_actions}
*/
export declare class AppsecMalwarePolicyActions extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_malware_policy_actions";
    /**
    * Generates CDKTF code for importing a AppsecMalwarePolicyActions resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecMalwarePolicyActions to import
    * @param importFromId The id of the existing AppsecMalwarePolicyActions that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy_actions#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecMalwarePolicyActions to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy_actions akamai_appsec_malware_policy_actions} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecMalwarePolicyActionsConfig
    */
    constructor(scope: Construct, id: string, config: AppsecMalwarePolicyActionsConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _malwarePolicyActions?;
    get malwarePolicyActions(): string;
    set malwarePolicyActions(value: string);
    get malwarePolicyActionsInput(): string | undefined;
    private _securityPolicyId?;
    get securityPolicyId(): string;
    set securityPolicyId(value: string);
    get securityPolicyIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
