import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppsecMalwarePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy#config_id AppsecMalwarePolicy#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy#id AppsecMalwarePolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * JSON-formatted definition of the malware policy
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy#malware_policy AppsecMalwarePolicy#malware_policy}
    */
    readonly malwarePolicy: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy akamai_appsec_malware_policy}
*/
export declare class AppsecMalwarePolicy extends cdktf.TerraformResource {
    static readonly tfResourceType = "akamai_appsec_malware_policy";
    /**
    * Generates CDKTF code for importing a AppsecMalwarePolicy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AppsecMalwarePolicy to import
    * @param importFromId The id of the existing AppsecMalwarePolicy that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AppsecMalwarePolicy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/resources/appsec_malware_policy akamai_appsec_malware_policy} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppsecMalwarePolicyConfig
    */
    constructor(scope: Construct, id: string, config: AppsecMalwarePolicyConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _malwarePolicy?;
    get malwarePolicy(): string;
    set malwarePolicy(value: string);
    get malwarePolicyInput(): string | undefined;
    get malwarePolicyId(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
