import * as cdktf from 'cdktf';
import { DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList } from './structs2400';
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefault | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationDefaultUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscape | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationLandscapeUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortrait | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationPortraitUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfDimensionGreaterThanIfOrientationSquareMonoHueOutputReference;
}
