import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkamaiAppsecMalwarePoliciesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique identifier of the security configuration
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_malware_policies#config_id DataAkamaiAppsecMalwarePolicies#config_id}
    */
    readonly configId: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_malware_policies#id DataAkamaiAppsecMalwarePolicies#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Unique identifier of a specific malware policy for which to retrieve information
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_malware_policies#malware_policy_id DataAkamaiAppsecMalwarePolicies#malware_policy_id}
    */
    readonly malwarePolicyId?: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_malware_policies akamai_appsec_malware_policies}
*/
export declare class DataAkamaiAppsecMalwarePolicies extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akamai_appsec_malware_policies";
    /**
    * Generates CDKTF code for importing a DataAkamaiAppsecMalwarePolicies resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkamaiAppsecMalwarePolicies to import
    * @param importFromId The id of the existing DataAkamaiAppsecMalwarePolicies that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_malware_policies#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkamaiAppsecMalwarePolicies to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/appsec_malware_policies akamai_appsec_malware_policies} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkamaiAppsecMalwarePoliciesConfig
    */
    constructor(scope: Construct, id: string, config: DataAkamaiAppsecMalwarePoliciesConfig);
    private _configId?;
    get configId(): number;
    set configId(value: number);
    get configIdInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get json(): string;
    private _malwarePolicyId?;
    get malwarePolicyId(): number;
    set malwarePolicyId(value: number);
    resetMalwarePolicyId(): void;
    get malwarePolicyIdInput(): number | undefined;
    get outputText(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
