import * as cdktf from 'cdktf';
import { DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations, DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsList } from './structs4800';
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefault | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionDefaultUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqual | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionEqualUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan {
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThan | undefined);
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanContrast[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanIfOrientation[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanOpacity[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanRemoveColor[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionGreaterThanUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyPostBreakpointTransformationsIfOrientationPortraitIfDimensionLessThanIfDimensionGreaterThan | undefined);
}
