import * as cdktf from 'cdktf';
import { DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImageOutputReference, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageList, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageList, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage, DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageList } from './structs7200';
import { DataAkamaiImagingPolicyImagePolicyTransformations, DataAkamaiImagingPolicyImagePolicyTransformationsList } from './structs17600';
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery {
    /**
    * Specifies the transformations that can be applied using the query string parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
    */
    readonly allowedTransformations: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}
    */
    readonly queryVar: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery | cdktf.IResolvable | undefined);
    private _allowedTransformations?;
    get allowedTransformations(): string[];
    set allowedTransformations(value: string[]);
    get allowedTransformationsInput(): string[] | undefined;
    private _queryVar?;
    get queryVar(): string;
    set queryVar(value: string);
    get queryVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop {
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * region_of_interest block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
    */
    readonly regionOfInterest: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _regionOfInterest;
    get regionOfInterest(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterestOutputReference;
    putRegionOfInterest(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest): void;
    get regionOfInterestInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropRegionOfInterest | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop {
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
    */
    readonly east?: string;
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
    */
    readonly eastVar?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
    */
    readonly north?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
    */
    readonly northVar?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
    */
    readonly south?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
    */
    readonly southVar?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
    */
    readonly west?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
    */
    readonly westVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop | cdktf.IResolvable | undefined);
    private _east?;
    get east(): string;
    set east(value: string);
    resetEast(): void;
    get eastInput(): string | undefined;
    private _eastVar?;
    get eastVar(): string;
    set eastVar(value: string);
    resetEastVar(): void;
    get eastVarInput(): string | undefined;
    private _north?;
    get north(): string;
    set north(value: string);
    resetNorth(): void;
    get northInput(): string | undefined;
    private _northVar?;
    get northVar(): string;
    set northVar(value: string);
    resetNorthVar(): void;
    get northVarInput(): string | undefined;
    private _south?;
    get south(): string;
    set south(value: string);
    resetSouth(): void;
    get southInput(): string | undefined;
    private _southVar?;
    get southVar(): string;
    set southVar(value: string);
    resetSouthVar(): void;
    get southVarInput(): string | undefined;
    private _west?;
    get west(): string;
    set west(value: string);
    resetWest(): void;
    get westInput(): string | undefined;
    private _westVar?;
    get westVar(): string;
    set westVar(value: string);
    resetWestVar(): void;
    get westVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize {
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
    */
    readonly aspect?: string;
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
    */
    readonly aspectVar?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize | cdktf.IResolvable | undefined);
    private _aspect?;
    get aspect(): string;
    set aspect(value: string);
    resetAspect(): void;
    get aspectInput(): string | undefined;
    private _aspectVar?;
    get aspectVar(): string;
    set aspectVar(value: string);
    resetAspectVar(): void;
    get aspectVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate {
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
    */
    readonly degrees?: string;
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
    */
    readonly degreesVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate | cdktf.IResolvable | undefined);
    private _degrees?;
    get degrees(): string;
    set degrees(value: string);
    resetDegrees(): void;
    get degreesInput(): string | undefined;
    private _degreesVar?;
    get degreesVar(): string;
    set degreesVar(value: string);
    resetDegreesVar(): void;
    get degreesVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale {
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear {
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
    */
    readonly xShear?: string;
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
    */
    readonly xShearVar?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
    */
    readonly yShear?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
    */
    readonly yShearVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear | cdktf.IResolvable | undefined);
    private _xShear?;
    get xShear(): string;
    set xShear(value: string);
    resetXShear(): void;
    get xShearInput(): string | undefined;
    private _xShearVar?;
    get xShearVar(): string;
    set xShearVar(value: string);
    resetXShearVar(): void;
    get xShearVarInput(): string | undefined;
    private _yShear?;
    get yShear(): string;
    set yShear(value: string);
    resetYShear(): void;
    get yShearInput(): string | undefined;
    private _yShearVar?;
    get yShearVar(): string;
    set yShearVar(value: string);
    resetYShearVar(): void;
    get yShearVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim {
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
    */
    readonly fuzz?: string;
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
    */
    readonly fuzzVar?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim | cdktf.IResolvable | undefined);
    private _fuzz?;
    get fuzz(): string;
    set fuzz(value: string);
    resetFuzz(): void;
    get fuzzInput(): string | undefined;
    private _fuzzVar?;
    get fuzzVar(): string;
    set fuzzVar(value: string);
    resetFuzzVar(): void;
    get fuzzVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation {
    /**
    * append block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
    */
    readonly append?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend[] | cdktf.IResolvable;
    /**
    * aspect_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
    */
    readonly aspectCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop[] | cdktf.IResolvable;
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast[] | cdktf.IResolvable;
    /**
    * crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
    */
    readonly crop?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop[] | cdktf.IResolvable;
    /**
    * face_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
    */
    readonly faceCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop[] | cdktf.IResolvable;
    /**
    * feature_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
    */
    readonly featureCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop[] | cdktf.IResolvable;
    /**
    * fit_and_fill block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
    */
    readonly fitAndFill?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation[] | cdktf.IResolvable;
    /**
    * im_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
    */
    readonly imQuery?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity[] | cdktf.IResolvable;
    /**
    * region_of_interest_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
    */
    readonly regionOfInterestCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * relative_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
    */
    readonly relativeCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor[] | cdktf.IResolvable;
    /**
    * resize block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
    */
    readonly resize?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize[] | cdktf.IResolvable;
    /**
    * rotate block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
    */
    readonly rotate?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate[] | cdktf.IResolvable;
    /**
    * scale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale[] | cdktf.IResolvable;
    /**
    * shear block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
    */
    readonly shear?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear[] | cdktf.IResolvable;
    /**
    * trim block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
    */
    readonly trim?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation | undefined);
    private _append;
    get append(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppendList;
    putAppend(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend[] | cdktf.IResolvable): void;
    resetAppend(): void;
    get appendInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAppend[] | undefined;
    private _aspectCrop;
    get aspectCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCropList;
    putAspectCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop[] | cdktf.IResolvable): void;
    resetAspectCrop(): void;
    get aspectCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationAspectCrop[] | undefined;
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationContrast[] | undefined;
    private _crop;
    get crop(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCropList;
    putCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop[] | cdktf.IResolvable): void;
    resetCrop(): void;
    get cropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationCrop[] | undefined;
    private _faceCrop;
    get faceCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCropList;
    putFaceCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop[] | cdktf.IResolvable): void;
    resetFaceCrop(): void;
    get faceCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFaceCrop[] | undefined;
    private _featureCrop;
    get featureCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCropList;
    putFeatureCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop[] | cdktf.IResolvable): void;
    resetFeatureCrop(): void;
    get featureCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFeatureCrop[] | undefined;
    private _fitAndFill;
    get fitAndFill(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFillList;
    putFitAndFill(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill[] | cdktf.IResolvable): void;
    resetFitAndFill(): void;
    get fitAndFillInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationFitAndFill[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationIfOrientation[] | undefined;
    private _imQuery;
    get imQuery(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQueryList;
    putImQuery(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery[] | cdktf.IResolvable): void;
    resetImQuery(): void;
    get imQueryInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationImQuery[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOpacity[] | undefined;
    private _regionOfInterestCrop;
    get regionOfInterestCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCropList;
    putRegionOfInterestCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop[] | cdktf.IResolvable): void;
    resetRegionOfInterestCrop(): void;
    get regionOfInterestCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRegionOfInterestCrop[] | undefined;
    private _relativeCrop;
    get relativeCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCropList;
    putRelativeCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop[] | cdktf.IResolvable): void;
    resetRelativeCrop(): void;
    get relativeCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRelativeCrop[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRemoveColor[] | undefined;
    private _resize;
    get resize(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResizeList;
    putResize(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize[] | cdktf.IResolvable): void;
    resetResize(): void;
    get resizeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationResize[] | undefined;
    private _rotate;
    get rotate(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotateList;
    putRotate(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate[] | cdktf.IResolvable): void;
    resetRotate(): void;
    get rotateInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationRotate[] | undefined;
    private _scale;
    get scale(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScaleList;
    putScale(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale[] | cdktf.IResolvable): void;
    resetScale(): void;
    get scaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationScale[] | undefined;
    private _shear;
    get shear(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShearList;
    putShear(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear[] | cdktf.IResolvable): void;
    resetShear(): void;
    get shearInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationShear[] | undefined;
    private _trim;
    get trim(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrimList;
    putTrim(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim[] | cdktf.IResolvable): void;
    resetTrim(): void;
    get trimInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationTrim[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage {
    /**
    * The URL of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
    */
    readonly url?: string;
    /**
    * The URL of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
    */
    readonly urlVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage | cdktf.IResolvable | undefined);
    private _url?;
    get url(): string;
    set url(value: string);
    resetUrl(): void;
    get urlInput(): string | undefined;
    private _urlVar?;
    get urlVar(): string;
    set urlVar(value: string);
    resetUrlVar(): void;
    get urlVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage {
    /**
    * box_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
    */
    readonly boxImage?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage[] | cdktf.IResolvable;
    /**
    * circle_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
    */
    readonly circleImage?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage[] | cdktf.IResolvable;
    /**
    * text_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
    */
    readonly textImage?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage[] | cdktf.IResolvable;
    /**
    * url_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
    */
    readonly urlImage?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage | undefined);
    private _boxImage;
    get boxImage(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImageList;
    putBoxImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage[] | cdktf.IResolvable): void;
    resetBoxImage(): void;
    get boxImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageBoxImage[] | undefined;
    private _circleImage;
    get circleImage(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImageList;
    putCircleImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage[] | cdktf.IResolvable): void;
    resetCircleImage(): void;
    get circleImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageCircleImage[] | undefined;
    private _textImage;
    get textImage(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImageList;
    putTextImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage[] | cdktf.IResolvable): void;
    resetTextImage(): void;
    get textImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageTextImage[] | undefined;
    private _urlImage;
    get urlImage(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImageList;
    putUrlImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage[] | cdktf.IResolvable): void;
    resetUrlImage(): void;
    get urlImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageUrlImage[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage {
    /**
    * The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The height of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage {
    /**
    * The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The diameter of the circle. The diameter will be the width and the height of the image in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
    */
    readonly diameter?: string;
    /**
    * The diameter of the circle. The diameter will be the width and the height of the image in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
    */
    readonly diameterVar?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _diameter?;
    get diameter(): string;
    set diameter(value: string);
    resetDiameter(): void;
    get diameterInput(): string | undefined;
    private _diameterVar?;
    get diameterVar(): string;
    set diameterVar(value: string);
    resetDiameterVar(): void;
    get diameterVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage {
    /**
    * The main fill color of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
    */
    readonly fill?: string;
    /**
    * The main fill color of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
    */
    readonly fillVar?: string;
    /**
    * The size in pixels to render the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
    */
    readonly size?: string;
    /**
    * The size in pixels to render the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
    */
    readonly sizeVar?: string;
    /**
    * The color for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
    */
    readonly stroke?: string;
    /**
    * The thickness in points for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
    */
    readonly strokeSize?: string;
    /**
    * The thickness in points for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
    */
    readonly strokeSizeVar?: string;
    /**
    * The color for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
    */
    readonly strokeVar?: string;
    /**
    * The line of text to render.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
    */
    readonly text?: string;
    /**
    * The line of text to render.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
    */
    readonly textVar?: string;
    /**
    * The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
    */
    readonly typeface?: string;
    /**
    * The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
    */
    readonly typefaceVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage | cdktf.IResolvable | undefined);
    private _fill?;
    get fill(): string;
    set fill(value: string);
    resetFill(): void;
    get fillInput(): string | undefined;
    private _fillVar?;
    get fillVar(): string;
    set fillVar(value: string);
    resetFillVar(): void;
    get fillVarInput(): string | undefined;
    private _size?;
    get size(): string;
    set size(value: string);
    resetSize(): void;
    get sizeInput(): string | undefined;
    private _sizeVar?;
    get sizeVar(): string;
    set sizeVar(value: string);
    resetSizeVar(): void;
    get sizeVarInput(): string | undefined;
    private _stroke?;
    get stroke(): string;
    set stroke(value: string);
    resetStroke(): void;
    get strokeInput(): string | undefined;
    private _strokeSize?;
    get strokeSize(): string;
    set strokeSize(value: string);
    resetStrokeSize(): void;
    get strokeSizeInput(): string | undefined;
    private _strokeSizeVar?;
    get strokeSizeVar(): string;
    set strokeSizeVar(value: string);
    resetStrokeSizeVar(): void;
    get strokeSizeVarInput(): string | undefined;
    private _strokeVar?;
    get strokeVar(): string;
    set strokeVar(value: string);
    resetStrokeVar(): void;
    get strokeVarInput(): string | undefined;
    private _text?;
    get text(): string;
    set text(value: string);
    resetText(): void;
    get textInput(): string | undefined;
    private _textVar?;
    get textVar(): string;
    set textVar(value: string);
    resetTextVar(): void;
    get textVarInput(): string | undefined;
    private _typeface?;
    get typeface(): string;
    set typeface(value: string);
    resetTypeface(): void;
    get typefaceInput(): string | undefined;
    private _typefaceVar?;
    get typefaceVar(): string;
    set typefaceVar(value: string);
    resetTypefaceVar(): void;
    get typefaceVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage {
    /**
    * The URL of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
    */
    readonly url?: string;
    /**
    * The URL of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
    */
    readonly urlVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage | cdktf.IResolvable | undefined);
    private _url?;
    get url(): string;
    set url(value: string);
    resetUrl(): void;
    get urlInput(): string | undefined;
    private _urlVar?;
    get urlVar(): string;
    set urlVar(value: string);
    resetUrlVar(): void;
    get urlVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage {
    /**
    * box_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
    */
    readonly boxImage?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage[] | cdktf.IResolvable;
    /**
    * circle_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
    */
    readonly circleImage?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage[] | cdktf.IResolvable;
    /**
    * text_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
    */
    readonly textImage?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage[] | cdktf.IResolvable;
    /**
    * url_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
    */
    readonly urlImage?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage | undefined);
    private _boxImage;
    get boxImage(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImageList;
    putBoxImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage[] | cdktf.IResolvable): void;
    resetBoxImage(): void;
    get boxImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageBoxImage[] | undefined;
    private _circleImage;
    get circleImage(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImageList;
    putCircleImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage[] | cdktf.IResolvable): void;
    resetCircleImage(): void;
    get circleImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageCircleImage[] | undefined;
    private _textImage;
    get textImage(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImageList;
    putTextImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage[] | cdktf.IResolvable): void;
    resetTextImage(): void;
    get textImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageTextImage[] | undefined;
    private _urlImage;
    get urlImage(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImageList;
    putUrlImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage[] | cdktf.IResolvable): void;
    resetUrlImage(): void;
    get urlImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageUrlImage[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage {
    /**
    * The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The fill color of the box, not the edge of the box. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The height of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage {
    /**
    * The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The fill color of the circle. The API supports hexadecimal representation and CSS hexadecimal color values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The diameter of the circle. The diameter will be the width and the height of the image in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter DataAkamaiImagingPolicyImage#diameter}
    */
    readonly diameter?: string;
    /**
    * The diameter of the circle. The diameter will be the width and the height of the image in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#diameter_var DataAkamaiImagingPolicyImage#diameter_var}
    */
    readonly diameterVar?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the box in pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _diameter?;
    get diameter(): string;
    set diameter(value: string);
    resetDiameter(): void;
    get diameterInput(): string | undefined;
    private _diameterVar?;
    get diameterVar(): string;
    set diameterVar(value: string);
    resetDiameterVar(): void;
    get diameterVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage {
    /**
    * The main fill color of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill DataAkamaiImagingPolicyImage#fill}
    */
    readonly fill?: string;
    /**
    * The main fill color of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_var DataAkamaiImagingPolicyImage#fill_var}
    */
    readonly fillVar?: string;
    /**
    * The size in pixels to render the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size DataAkamaiImagingPolicyImage#size}
    */
    readonly size?: string;
    /**
    * The size in pixels to render the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#size_var DataAkamaiImagingPolicyImage#size_var}
    */
    readonly sizeVar?: string;
    /**
    * The color for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke DataAkamaiImagingPolicyImage#stroke}
    */
    readonly stroke?: string;
    /**
    * The thickness in points for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size DataAkamaiImagingPolicyImage#stroke_size}
    */
    readonly strokeSize?: string;
    /**
    * The thickness in points for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_size_var DataAkamaiImagingPolicyImage#stroke_size_var}
    */
    readonly strokeSizeVar?: string;
    /**
    * The color for the outline of the text.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#stroke_var DataAkamaiImagingPolicyImage#stroke_var}
    */
    readonly strokeVar?: string;
    /**
    * The line of text to render.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text DataAkamaiImagingPolicyImage#text}
    */
    readonly text?: string;
    /**
    * The line of text to render.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_var DataAkamaiImagingPolicyImage#text_var}
    */
    readonly textVar?: string;
    /**
    * The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface DataAkamaiImagingPolicyImage#typeface}
    */
    readonly typeface?: string;
    /**
    * The font family to apply to the text image. This may be a URL to a TrueType or WOFF (v1) typeface, or a string that refers to one of the standard built-in browser fonts.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#typeface_var DataAkamaiImagingPolicyImage#typeface_var}
    */
    readonly typefaceVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage | cdktf.IResolvable | undefined);
    private _fill?;
    get fill(): string;
    set fill(value: string);
    resetFill(): void;
    get fillInput(): string | undefined;
    private _fillVar?;
    get fillVar(): string;
    set fillVar(value: string);
    resetFillVar(): void;
    get fillVarInput(): string | undefined;
    private _size?;
    get size(): string;
    set size(value: string);
    resetSize(): void;
    get sizeInput(): string | undefined;
    private _sizeVar?;
    get sizeVar(): string;
    set sizeVar(value: string);
    resetSizeVar(): void;
    get sizeVarInput(): string | undefined;
    private _stroke?;
    get stroke(): string;
    set stroke(value: string);
    resetStroke(): void;
    get strokeInput(): string | undefined;
    private _strokeSize?;
    get strokeSize(): string;
    set strokeSize(value: string);
    resetStrokeSize(): void;
    get strokeSizeInput(): string | undefined;
    private _strokeSizeVar?;
    get strokeSizeVar(): string;
    set strokeSizeVar(value: string);
    resetStrokeSizeVar(): void;
    get strokeSizeVarInput(): string | undefined;
    private _strokeVar?;
    get strokeVar(): string;
    set strokeVar(value: string);
    resetStrokeVar(): void;
    get strokeVarInput(): string | undefined;
    private _text?;
    get text(): string;
    set text(value: string);
    resetText(): void;
    get textInput(): string | undefined;
    private _textVar?;
    get textVar(): string;
    set textVar(value: string);
    resetTextVar(): void;
    get textVarInput(): string | undefined;
    private _typeface?;
    get typeface(): string;
    set typeface(value: string);
    resetTypeface(): void;
    get typefaceInput(): string | undefined;
    private _typefaceVar?;
    get typefaceVar(): string;
    set typefaceVar(value: string);
    resetTypefaceVar(): void;
    get typefaceVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage {
    /**
    * The URL of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url DataAkamaiImagingPolicyImage#url}
    */
    readonly url?: string;
    /**
    * The URL of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_var DataAkamaiImagingPolicyImage#url_var}
    */
    readonly urlVar?: string;
    /**
    * transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformation DataAkamaiImagingPolicyImage#transformation}
    */
    readonly transformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage | cdktf.IResolvable | undefined);
    private _url?;
    get url(): string;
    set url(value: string);
    resetUrl(): void;
    get urlInput(): string | undefined;
    private _urlVar?;
    get urlVar(): string;
    set urlVar(value: string);
    resetUrlVar(): void;
    get urlVarInput(): string | undefined;
    private _transformation;
    get transformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformationOutputReference;
    putTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation): void;
    resetTransformation(): void;
    get transformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage {
    /**
    * box_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#box_image DataAkamaiImagingPolicyImage#box_image}
    */
    readonly boxImage?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage[] | cdktf.IResolvable;
    /**
    * circle_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#circle_image DataAkamaiImagingPolicyImage#circle_image}
    */
    readonly circleImage?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage[] | cdktf.IResolvable;
    /**
    * text_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#text_image DataAkamaiImagingPolicyImage#text_image}
    */
    readonly textImage?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage[] | cdktf.IResolvable;
    /**
    * url_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#url_image DataAkamaiImagingPolicyImage#url_image}
    */
    readonly urlImage?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage | undefined);
    private _boxImage;
    get boxImage(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImageList;
    putBoxImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage[] | cdktf.IResolvable): void;
    resetBoxImage(): void;
    get boxImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageBoxImage[] | undefined;
    private _circleImage;
    get circleImage(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImageList;
    putCircleImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage[] | cdktf.IResolvable): void;
    resetCircleImage(): void;
    get circleImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageCircleImage[] | undefined;
    private _textImage;
    get textImage(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImageList;
    putTextImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage[] | cdktf.IResolvable): void;
    resetTextImage(): void;
    get textImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageTextImage[] | undefined;
    private _urlImage;
    get urlImage(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImageList;
    putUrlImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage[] | cdktf.IResolvable): void;
    resetUrlImage(): void;
    get urlImageInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageUrlImage[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfDimensionDefaultHsvOutputReference;
}
