import * as cdktf from 'cdktf';
import { DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendList, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropList, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor, DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorList } from './structs8400';
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery {
    /**
    * Specifies the transformations that can be applied using the query string parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
    */
    readonly allowedTransformations: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}
    */
    readonly queryVar: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery | cdktf.IResolvable | undefined);
    private _allowedTransformations?;
    get allowedTransformations(): string[];
    set allowedTransformations(value: string[]);
    get allowedTransformationsInput(): string[] | undefined;
    private _queryVar?;
    get queryVar(): string;
    set queryVar(value: string);
    get queryVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop {
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * region_of_interest block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
    */
    readonly regionOfInterest: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _regionOfInterest;
    get regionOfInterest(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterestOutputReference;
    putRegionOfInterest(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest): void;
    get regionOfInterestInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropRegionOfInterest | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop {
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
    */
    readonly east?: string;
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
    */
    readonly eastVar?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
    */
    readonly north?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
    */
    readonly northVar?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
    */
    readonly south?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
    */
    readonly southVar?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
    */
    readonly west?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
    */
    readonly westVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop | cdktf.IResolvable | undefined);
    private _east?;
    get east(): string;
    set east(value: string);
    resetEast(): void;
    get eastInput(): string | undefined;
    private _eastVar?;
    get eastVar(): string;
    set eastVar(value: string);
    resetEastVar(): void;
    get eastVarInput(): string | undefined;
    private _north?;
    get north(): string;
    set north(value: string);
    resetNorth(): void;
    get northInput(): string | undefined;
    private _northVar?;
    get northVar(): string;
    set northVar(value: string);
    resetNorthVar(): void;
    get northVarInput(): string | undefined;
    private _south?;
    get south(): string;
    set south(value: string);
    resetSouth(): void;
    get southInput(): string | undefined;
    private _southVar?;
    get southVar(): string;
    set southVar(value: string);
    resetSouthVar(): void;
    get southVarInput(): string | undefined;
    private _west?;
    get west(): string;
    set west(value: string);
    resetWest(): void;
    get westInput(): string | undefined;
    private _westVar?;
    get westVar(): string;
    set westVar(value: string);
    resetWestVar(): void;
    get westVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize {
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
    */
    readonly aspect?: string;
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
    */
    readonly aspectVar?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize | cdktf.IResolvable | undefined);
    private _aspect?;
    get aspect(): string;
    set aspect(value: string);
    resetAspect(): void;
    get aspectInput(): string | undefined;
    private _aspectVar?;
    get aspectVar(): string;
    set aspectVar(value: string);
    resetAspectVar(): void;
    get aspectVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate {
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
    */
    readonly degrees?: string;
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
    */
    readonly degreesVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate | cdktf.IResolvable | undefined);
    private _degrees?;
    get degrees(): string;
    set degrees(value: string);
    resetDegrees(): void;
    get degreesInput(): string | undefined;
    private _degreesVar?;
    get degreesVar(): string;
    set degreesVar(value: string);
    resetDegreesVar(): void;
    get degreesVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale {
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear {
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
    */
    readonly xShear?: string;
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
    */
    readonly xShearVar?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
    */
    readonly yShear?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
    */
    readonly yShearVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear | cdktf.IResolvable | undefined);
    private _xShear?;
    get xShear(): string;
    set xShear(value: string);
    resetXShear(): void;
    get xShearInput(): string | undefined;
    private _xShearVar?;
    get xShearVar(): string;
    set xShearVar(value: string);
    resetXShearVar(): void;
    get xShearVarInput(): string | undefined;
    private _yShear?;
    get yShear(): string;
    set yShear(value: string);
    resetYShear(): void;
    get yShearInput(): string | undefined;
    private _yShearVar?;
    get yShearVar(): string;
    set yShearVar(value: string);
    resetYShearVar(): void;
    get yShearVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim {
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
    */
    readonly fuzz?: string;
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
    */
    readonly fuzzVar?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim | cdktf.IResolvable | undefined);
    private _fuzz?;
    get fuzz(): string;
    set fuzz(value: string);
    resetFuzz(): void;
    get fuzzInput(): string | undefined;
    private _fuzzVar?;
    get fuzzVar(): string;
    set fuzzVar(value: string);
    resetFuzzVar(): void;
    get fuzzVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape {
    /**
    * append block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
    */
    readonly append?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend[] | cdktf.IResolvable;
    /**
    * aspect_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
    */
    readonly aspectCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop[] | cdktf.IResolvable;
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast[] | cdktf.IResolvable;
    /**
    * crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
    */
    readonly crop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop[] | cdktf.IResolvable;
    /**
    * face_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
    */
    readonly faceCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop[] | cdktf.IResolvable;
    /**
    * feature_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
    */
    readonly featureCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop[] | cdktf.IResolvable;
    /**
    * fit_and_fill block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
    */
    readonly fitAndFill?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable;
    /**
    * im_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
    */
    readonly imQuery?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity[] | cdktf.IResolvable;
    /**
    * region_of_interest_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
    */
    readonly regionOfInterestCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * relative_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
    */
    readonly relativeCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable;
    /**
    * resize block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
    */
    readonly resize?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize[] | cdktf.IResolvable;
    /**
    * rotate block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
    */
    readonly rotate?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate[] | cdktf.IResolvable;
    /**
    * scale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale[] | cdktf.IResolvable;
    /**
    * shear block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
    */
    readonly shear?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear[] | cdktf.IResolvable;
    /**
    * trim block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
    */
    readonly trim?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscape | undefined);
    private _append;
    get append(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppendList;
    putAppend(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend[] | cdktf.IResolvable): void;
    resetAppend(): void;
    get appendInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAppend[] | undefined;
    private _aspectCrop;
    get aspectCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCropList;
    putAspectCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop[] | cdktf.IResolvable): void;
    resetAspectCrop(): void;
    get aspectCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeAspectCrop[] | undefined;
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeContrast[] | undefined;
    private _crop;
    get crop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCropList;
    putCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop[] | cdktf.IResolvable): void;
    resetCrop(): void;
    get cropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeCrop[] | undefined;
    private _faceCrop;
    get faceCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCropList;
    putFaceCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop[] | cdktf.IResolvable): void;
    resetFaceCrop(): void;
    get faceCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFaceCrop[] | undefined;
    private _featureCrop;
    get featureCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCropList;
    putFeatureCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop[] | cdktf.IResolvable): void;
    resetFeatureCrop(): void;
    get featureCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFeatureCrop[] | undefined;
    private _fitAndFill;
    get fitAndFill(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFillList;
    putFitAndFill(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill[] | cdktf.IResolvable): void;
    resetFitAndFill(): void;
    get fitAndFillInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeFitAndFill[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeIfOrientation[] | undefined;
    private _imQuery;
    get imQuery(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQueryList;
    putImQuery(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery[] | cdktf.IResolvable): void;
    resetImQuery(): void;
    get imQueryInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeImQuery[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeOpacity[] | undefined;
    private _regionOfInterestCrop;
    get regionOfInterestCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCropList;
    putRegionOfInterestCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop[] | cdktf.IResolvable): void;
    resetRegionOfInterestCrop(): void;
    get regionOfInterestCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRegionOfInterestCrop[] | undefined;
    private _relativeCrop;
    get relativeCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCropList;
    putRelativeCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop[] | cdktf.IResolvable): void;
    resetRelativeCrop(): void;
    get relativeCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRelativeCrop[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRemoveColor[] | undefined;
    private _resize;
    get resize(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResizeList;
    putResize(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize[] | cdktf.IResolvable): void;
    resetResize(): void;
    get resizeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeResize[] | undefined;
    private _rotate;
    get rotate(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotateList;
    putRotate(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate[] | cdktf.IResolvable): void;
    resetRotate(): void;
    get rotateInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeRotate[] | undefined;
    private _scale;
    get scale(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScaleList;
    putScale(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale[] | cdktf.IResolvable): void;
    resetScale(): void;
    get scaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeScale[] | undefined;
    private _shear;
    get shear(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShearList;
    putShear(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear[] | cdktf.IResolvable): void;
    resetShear(): void;
    get shearInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeShear[] | undefined;
    private _trim;
    get trim(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrimList;
    putTrim(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim[] | cdktf.IResolvable): void;
    resetTrim(): void;
    get trimInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeTrim[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationLandscapeUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv {
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * A multiplier to adjust the lightness or darkness of the images base color. Values less than 1.0 decrease the base colors in the image, making them appear darker. Values greater than 1.0 increase the base colors in the image, making them appear lighter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension {
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension DataAkamaiImagingPolicyImage#dimension}
    */
    readonly dimension?: string;
    /**
    * The dimension to use to select the transformation, either `height`, `width`, or `both`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#dimension_var DataAkamaiImagingPolicyImage#dimension_var}
    */
    readonly dimensionVar?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value DataAkamaiImagingPolicyImage#value}
    */
    readonly value?: string;
    /**
    * The value to compare against the source image dimension. For example, if the image dimension is less than the value the lessThan transformation is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#value_var DataAkamaiImagingPolicyImage#value_var}
    */
    readonly valueVar?: string;
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault;
    /**
    * equal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#equal DataAkamaiImagingPolicyImage#equal}
    */
    readonly equal?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual;
    /**
    * greater_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#greater_than DataAkamaiImagingPolicyImage#greater_than}
    */
    readonly greaterThan?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan;
    /**
    * less_than block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#less_than DataAkamaiImagingPolicyImage#less_than}
    */
    readonly lessThan?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension | cdktf.IResolvable | undefined);
    private _dimension?;
    get dimension(): string;
    set dimension(value: string);
    resetDimension(): void;
    get dimensionInput(): string | undefined;
    private _dimensionVar?;
    get dimensionVar(): string;
    set dimensionVar(value: string);
    resetDimensionVar(): void;
    get dimensionVarInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueVar?;
    get valueVar(): string;
    set valueVar(value: string);
    resetValueVar(): void;
    get valueVarInput(): string | undefined;
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionDefault | undefined;
    private _equal;
    get equal(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqualOutputReference;
    putEqual(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual): void;
    resetEqual(): void;
    get equalInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionEqual | undefined;
    private _greaterThan;
    get greaterThan(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThanOutputReference;
    putGreaterThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan): void;
    resetGreaterThan(): void;
    get greaterThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionGreaterThan | undefined;
    private _lessThan;
    get lessThan(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThanOutputReference;
    putLessThan(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan): void;
    resetLessThan(): void;
    get lessThanInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionLessThan | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation {
    /**
    * default block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#default DataAkamaiImagingPolicyImage#default}
    */
    readonly default?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault;
    /**
    * landscape block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#landscape DataAkamaiImagingPolicyImage#landscape}
    */
    readonly landscape?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape;
    /**
    * portrait block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#portrait DataAkamaiImagingPolicyImage#portrait}
    */
    readonly portrait?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait;
    /**
    * square block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#square DataAkamaiImagingPolicyImage#square}
    */
    readonly square?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation | cdktf.IResolvable | undefined);
    private _default;
    get default(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefaultOutputReference;
    putDefault(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault): void;
    resetDefault(): void;
    get defaultInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationDefault | undefined;
    private _landscape;
    get landscape(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscapeOutputReference;
    putLandscape(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape): void;
    resetLandscape(): void;
    get landscapeInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationLandscape | undefined;
    private _portrait;
    get portrait(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortraitOutputReference;
    putPortrait(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait): void;
    resetPortrait(): void;
    get portraitInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationPortrait | undefined;
    private _square;
    get square(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquareOutputReference;
    putSquare(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare): void;
    resetSquare(): void;
    get squareInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationSquare | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery {
    /**
    * Specifies the transformations that can be applied using the query string parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allowed_transformations DataAkamaiImagingPolicyImage#allowed_transformations}
    */
    readonly allowedTransformations: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#query_var DataAkamaiImagingPolicyImage#query_var}
    */
    readonly queryVar: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery | cdktf.IResolvable | undefined);
    private _allowedTransformations?;
    get allowedTransformations(): string[];
    set allowedTransformations(value: string[]);
    get allowedTransformationsInput(): string[] | undefined;
    private _queryVar?;
    get queryVar(): string;
    set queryVar(value: string);
    get queryVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors {
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors DataAkamaiImagingPolicyImage#colors}
    */
    readonly colors?: string;
    /**
    * The value representing the maximum number of colors to use with the source image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#colors_var DataAkamaiImagingPolicyImage#colors_var}
    */
    readonly colorsVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors | cdktf.IResolvable | undefined);
    private _colors?;
    get colors(): string;
    set colors(value: string);
    resetColors(): void;
    get colorsInput(): string | undefined;
    private _colorsVar?;
    get colorsVar(): string;
    set colorsVar(value: string);
    resetColorsVar(): void;
    get colorsVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror {
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal DataAkamaiImagingPolicyImage#horizontal}
    */
    readonly horizontal?: string;
    /**
    * Flips the image horizontally.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#horizontal_var DataAkamaiImagingPolicyImage#horizontal_var}
    */
    readonly horizontalVar?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical DataAkamaiImagingPolicyImage#vertical}
    */
    readonly vertical?: string;
    /**
    * Flips the image vertically.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#vertical_var DataAkamaiImagingPolicyImage#vertical_var}
    */
    readonly verticalVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror | cdktf.IResolvable | undefined);
    private _horizontal?;
    get horizontal(): string;
    set horizontal(value: string);
    resetHorizontal(): void;
    get horizontalInput(): string | undefined;
    private _horizontalVar?;
    get horizontalVar(): string;
    set horizontalVar(value: string);
    resetHorizontalVar(): void;
    get horizontalVarInput(): string | undefined;
    private _vertical?;
    get vertical(): string;
    set vertical(value: string);
    resetVertical(): void;
    get verticalInput(): string | undefined;
    private _verticalVar?;
    get verticalVar(): string;
    set verticalVar(value: string);
    resetVerticalVar(): void;
    get verticalVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue {
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * Specify a hue by indicating the degree of rotation between 0 and 360 degrees around the color wheel. By default Mono Hue applies a red hue, 0.0 on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity {
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: string;
    /**
    * Represents alpha values on a scale of `0` to `1`. Values below `1` increase transparency, and `0` is invisible. For images that have some transparency, values above `1` increase the opacity of the transparent portions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity_var DataAkamaiImagingPolicyImage#opacity_var}
    */
    readonly opacityVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity | cdktf.IResolvable | undefined);
    private _opacity?;
    get opacity(): string;
    set opacity(value: string);
    resetOpacity(): void;
    get opacityInput(): string | undefined;
    private _opacityVar?;
    get opacityVar(): string;
    set opacityVar(value: string);
    resetOpacityVar(): void;
    get opacityVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop {
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * The placement of the crop area relative to the specified area of interest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the specified area of interest in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places raw crop around the point of interest, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and point of interest as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the point of interest, relative to the specified `width` and `height` values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * region_of_interest block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest DataAkamaiImagingPolicyImage#region_of_interest}
    */
    readonly regionOfInterest: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _regionOfInterest;
    get regionOfInterest(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterestOutputReference;
    putRegionOfInterest(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest): void;
    get regionOfInterestInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropRegionOfInterest | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop {
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east DataAkamaiImagingPolicyImage#east}
    */
    readonly east?: string;
    /**
    * The number of pixels to shrink or expand the right side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#east_var DataAkamaiImagingPolicyImage#east_var}
    */
    readonly eastVar?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north DataAkamaiImagingPolicyImage#north}
    */
    readonly north?: string;
    /**
    * The number of pixels to shrink or expand the top side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#north_var DataAkamaiImagingPolicyImage#north_var}
    */
    readonly northVar?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south DataAkamaiImagingPolicyImage#south}
    */
    readonly south?: string;
    /**
    * The number of pixels to shrink or expand the bottom side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#south_var DataAkamaiImagingPolicyImage#south_var}
    */
    readonly southVar?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west DataAkamaiImagingPolicyImage#west}
    */
    readonly west?: string;
    /**
    * The number of pixels to shrink or expand the left side of the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#west_var DataAkamaiImagingPolicyImage#west_var}
    */
    readonly westVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop | cdktf.IResolvable | undefined);
    private _east?;
    get east(): string;
    set east(value: string);
    resetEast(): void;
    get eastInput(): string | undefined;
    private _eastVar?;
    get eastVar(): string;
    set eastVar(value: string);
    resetEastVar(): void;
    get eastVarInput(): string | undefined;
    private _north?;
    get north(): string;
    set north(value: string);
    resetNorth(): void;
    get northInput(): string | undefined;
    private _northVar?;
    get northVar(): string;
    set northVar(value: string);
    resetNorthVar(): void;
    get northVarInput(): string | undefined;
    private _south?;
    get south(): string;
    set south(value: string);
    resetSouth(): void;
    get southInput(): string | undefined;
    private _southVar?;
    get southVar(): string;
    set southVar(value: string);
    resetSouthVar(): void;
    get southVarInput(): string | undefined;
    private _west?;
    get west(): string;
    set west(value: string);
    resetWest(): void;
    get westInput(): string | undefined;
    private _westVar?;
    get westVar(): string;
    set westVar(value: string);
    resetWestVar(): void;
    get westVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor {
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather DataAkamaiImagingPolicyImage#feather}
    */
    readonly feather?: string;
    /**
    * The RemoveColor transformation may create a hard edge around an image. To minimize these hard edges and make the removal of the color more gradual in appearance, use the Feather option. This option allows you to extend the color removal beyond the specified Tolerance. The pixels in this extended tolerance become semi-transparent - creating a softer edge.  The first realtime request for an image using the feather option may result in a slow transformation time. Subsequent requests are not impacted as they are served directly out of cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feather_var DataAkamaiImagingPolicyImage#feather_var}
    */
    readonly featherVar?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance DataAkamaiImagingPolicyImage#tolerance}
    */
    readonly tolerance?: string;
    /**
    * The Tolerance option defines how close the color needs to be to the selected color before it's changed to fully transparent. Set the Tolerance to 0.0 to remove only the exact color specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#tolerance_var DataAkamaiImagingPolicyImage#tolerance_var}
    */
    readonly toleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
    private _feather?;
    get feather(): string;
    set feather(value: string);
    resetFeather(): void;
    get featherInput(): string | undefined;
    private _featherVar?;
    get featherVar(): string;
    set featherVar(value: string);
    resetFeatherVar(): void;
    get featherVarInput(): string | undefined;
    private _tolerance?;
    get tolerance(): string;
    set tolerance(value: string);
    resetTolerance(): void;
    get toleranceInput(): string | undefined;
    private _toleranceVar?;
    get toleranceVar(): string;
    set toleranceVar(value: string);
    resetToleranceVar(): void;
    get toleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize {
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect DataAkamaiImagingPolicyImage#aspect}
    */
    readonly aspect?: string;
    /**
    * Preserves the aspect ratio. Select `fit` to make the image fit entirely within the selected width and height. When using `fit`, the resulting image has the largest possible size for the specified dimensions. Select `fill` to size the image so it both completely fills the dimensions and has the smallest possible file size. Otherwise `ignore` changes the original aspect ratio to fit within an arbitrarily shaped rectangle.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_var DataAkamaiImagingPolicyImage#aspect_var}
    */
    readonly aspectVar?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height to resize the source image to. Must be set if height is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * Sets constraints for the image resize. Select `normal` to resize in all cases, either increasing or decreasing the dimensions. Select `downsize` to ignore this transformation if the result would be larger than the original. Select `upsize` to ignore this transformation if the result would be smaller.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width to resize the source image to. Must be set if width is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize | cdktf.IResolvable | undefined);
    private _aspect?;
    get aspect(): string;
    set aspect(value: string);
    resetAspect(): void;
    get aspectInput(): string | undefined;
    private _aspectVar?;
    get aspectVar(): string;
    set aspectVar(value: string);
    resetAspectVar(): void;
    get aspectVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate {
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees DataAkamaiImagingPolicyImage#degrees}
    */
    readonly degrees?: string;
    /**
    * The value to rotate the image by. Positive values rotate clockwise, while negative values rotate counter-clockwise.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#degrees_var DataAkamaiImagingPolicyImage#degrees_var}
    */
    readonly degreesVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate | cdktf.IResolvable | undefined);
    private _degrees?;
    get degrees(): string;
    set degrees(value: string);
    resetDegrees(): void;
    get degreesInput(): string | undefined;
    private _degreesVar?;
    get degreesVar(): string;
    set degreesVar(value: string);
    resetDegreesVar(): void;
    get degreesVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale {
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * Scaling factor for the input height to determine the output height of the image, where values between `0` and `1` decrease size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * Scaling factor for the input width to determine the output width of the image, where `1` leaves the width unchanged. Values greater than `1` increase the image size. Image dimensions need to be non-zero positive numbers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear {
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear DataAkamaiImagingPolicyImage#x_shear}
    */
    readonly xShear?: string;
    /**
    * The amount to shear along the x-axis, measured in multiples of the image's width. Must be set if yShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_shear_var DataAkamaiImagingPolicyImage#x_shear_var}
    */
    readonly xShearVar?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear DataAkamaiImagingPolicyImage#y_shear}
    */
    readonly yShear?: string;
    /**
    * The amount to shear along the y-axis, measured in multiples of the image's height. Must be set if xShear is not specified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_shear_var DataAkamaiImagingPolicyImage#y_shear_var}
    */
    readonly yShearVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear | cdktf.IResolvable | undefined);
    private _xShear?;
    get xShear(): string;
    set xShear(value: string);
    resetXShear(): void;
    get xShearInput(): string | undefined;
    private _xShearVar?;
    get xShearVar(): string;
    set xShearVar(value: string);
    resetXShearVar(): void;
    get xShearVarInput(): string | undefined;
    private _yShear?;
    get yShear(): string;
    set yShear(value: string);
    resetYShear(): void;
    get yShearInput(): string | undefined;
    private _yShearVar?;
    get yShearVar(): string;
    set yShearVar(value: string);
    resetYShearVar(): void;
    get yShearVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim {
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz DataAkamaiImagingPolicyImage#fuzz}
    */
    readonly fuzz?: string;
    /**
    * The fuzz tolerance of the trim, a value between `0` and `1` that determines the acceptable amount of background variation before trimming stops.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fuzz_var DataAkamaiImagingPolicyImage#fuzz_var}
    */
    readonly fuzzVar?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The amount of padding in pixels to add to the trimmed image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim | cdktf.IResolvable | undefined);
    private _fuzz?;
    get fuzz(): string;
    set fuzz(value: string);
    resetFuzz(): void;
    get fuzzInput(): string | undefined;
    private _fuzzVar?;
    get fuzzVar(): string;
    set fuzzVar(value: string);
    resetFuzzVar(): void;
    get fuzzVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask {
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain DataAkamaiImagingPolicyImage#gain}
    */
    readonly gain?: string;
    /**
    * Set how much emphasis the filter applies to details. Higher values increase apparent sharpness of details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gain_var DataAkamaiImagingPolicyImage#gain_var}
    */
    readonly gainVar?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The standard deviation of the Gaussian distribution used in the in unsharp mask, measured in pixels, `1.0` by default. High values emphasize large details and low values emphasize small details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold DataAkamaiImagingPolicyImage#threshold}
    */
    readonly threshold?: string;
    /**
    * Set the minimum change required to include a detail in the filter. Higher values discard more changes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#threshold_var DataAkamaiImagingPolicyImage#threshold_var}
    */
    readonly thresholdVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask | cdktf.IResolvable | undefined);
    private _gain?;
    get gain(): string;
    set gain(value: string);
    resetGain(): void;
    get gainInput(): string | undefined;
    private _gainVar?;
    get gainVar(): string;
    set gainVar(value: string);
    resetGainVar(): void;
    get gainVarInput(): string | undefined;
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    resetThreshold(): void;
    get thresholdInput(): string | undefined;
    private _thresholdVar?;
    get thresholdVar(): string;
    set thresholdVar(value: string);
    resetThresholdVar(): void;
    get thresholdVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait {
    /**
    * append block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#append DataAkamaiImagingPolicyImage#append}
    */
    readonly append?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend[] | cdktf.IResolvable;
    /**
    * aspect_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#aspect_crop DataAkamaiImagingPolicyImage#aspect_crop}
    */
    readonly aspectCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop[] | cdktf.IResolvable;
    /**
    * background_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#background_color DataAkamaiImagingPolicyImage#background_color}
    */
    readonly backgroundColor?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor[] | cdktf.IResolvable;
    /**
    * blur block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#blur DataAkamaiImagingPolicyImage#blur}
    */
    readonly blur?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur[] | cdktf.IResolvable;
    /**
    * chroma_key block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chroma_key DataAkamaiImagingPolicyImage#chroma_key}
    */
    readonly chromaKey?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey[] | cdktf.IResolvable;
    /**
    * composite block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#composite DataAkamaiImagingPolicyImage#composite}
    */
    readonly composite?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite[] | cdktf.IResolvable;
    /**
    * compound block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#compound DataAkamaiImagingPolicyImage#compound}
    */
    readonly compound?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound[] | cdktf.IResolvable;
    /**
    * contrast block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast[] | cdktf.IResolvable;
    /**
    * crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#crop DataAkamaiImagingPolicyImage#crop}
    */
    readonly crop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop[] | cdktf.IResolvable;
    /**
    * face_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#face_crop DataAkamaiImagingPolicyImage#face_crop}
    */
    readonly faceCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop[] | cdktf.IResolvable;
    /**
    * feature_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_crop DataAkamaiImagingPolicyImage#feature_crop}
    */
    readonly featureCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop[] | cdktf.IResolvable;
    /**
    * fit_and_fill block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fit_and_fill DataAkamaiImagingPolicyImage#fit_and_fill}
    */
    readonly fitAndFill?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill[] | cdktf.IResolvable;
    /**
    * goop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#goop DataAkamaiImagingPolicyImage#goop}
    */
    readonly goop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop[] | cdktf.IResolvable;
    /**
    * grayscale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#grayscale DataAkamaiImagingPolicyImage#grayscale}
    */
    readonly grayscale?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale[] | cdktf.IResolvable;
    /**
    * hsl block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsl DataAkamaiImagingPolicyImage#hsl}
    */
    readonly hsl?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl[] | cdktf.IResolvable;
    /**
    * hsv block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hsv DataAkamaiImagingPolicyImage#hsv}
    */
    readonly hsv?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv[] | cdktf.IResolvable;
    /**
    * if_dimension block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_dimension DataAkamaiImagingPolicyImage#if_dimension}
    */
    readonly ifDimension?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension[] | cdktf.IResolvable;
    /**
    * if_orientation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#if_orientation DataAkamaiImagingPolicyImage#if_orientation}
    */
    readonly ifOrientation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation[] | cdktf.IResolvable;
    /**
    * im_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#im_query DataAkamaiImagingPolicyImage#im_query}
    */
    readonly imQuery?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery[] | cdktf.IResolvable;
    /**
    * max_colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_colors DataAkamaiImagingPolicyImage#max_colors}
    */
    readonly maxColors?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors[] | cdktf.IResolvable;
    /**
    * mirror block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mirror DataAkamaiImagingPolicyImage#mirror}
    */
    readonly mirror?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror[] | cdktf.IResolvable;
    /**
    * mono_hue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#mono_hue DataAkamaiImagingPolicyImage#mono_hue}
    */
    readonly monoHue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue[] | cdktf.IResolvable;
    /**
    * opacity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#opacity DataAkamaiImagingPolicyImage#opacity}
    */
    readonly opacity?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity[] | cdktf.IResolvable;
    /**
    * region_of_interest_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#region_of_interest_crop DataAkamaiImagingPolicyImage#region_of_interest_crop}
    */
    readonly regionOfInterestCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop[] | cdktf.IResolvable;
    /**
    * relative_crop block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#relative_crop DataAkamaiImagingPolicyImage#relative_crop}
    */
    readonly relativeCrop?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop[] | cdktf.IResolvable;
    /**
    * remove_color block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#remove_color DataAkamaiImagingPolicyImage#remove_color}
    */
    readonly removeColor?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor[] | cdktf.IResolvable;
    /**
    * resize block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#resize DataAkamaiImagingPolicyImage#resize}
    */
    readonly resize?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize[] | cdktf.IResolvable;
    /**
    * rotate block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#rotate DataAkamaiImagingPolicyImage#rotate}
    */
    readonly rotate?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate[] | cdktf.IResolvable;
    /**
    * scale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale[] | cdktf.IResolvable;
    /**
    * shear block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#shear DataAkamaiImagingPolicyImage#shear}
    */
    readonly shear?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear[] | cdktf.IResolvable;
    /**
    * trim block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#trim DataAkamaiImagingPolicyImage#trim}
    */
    readonly trim?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim[] | cdktf.IResolvable;
    /**
    * unsharp_mask block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#unsharp_mask DataAkamaiImagingPolicyImage#unsharp_mask}
    */
    readonly unsharpMask?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortrait | undefined);
    private _append;
    get append(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppendList;
    putAppend(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend[] | cdktf.IResolvable): void;
    resetAppend(): void;
    get appendInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAppend[] | undefined;
    private _aspectCrop;
    get aspectCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCropList;
    putAspectCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop[] | cdktf.IResolvable): void;
    resetAspectCrop(): void;
    get aspectCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitAspectCrop[] | undefined;
    private _backgroundColor;
    get backgroundColor(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColorList;
    putBackgroundColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor[] | cdktf.IResolvable): void;
    resetBackgroundColor(): void;
    get backgroundColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBackgroundColor[] | undefined;
    private _blur;
    get blur(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlurList;
    putBlur(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur[] | cdktf.IResolvable): void;
    resetBlur(): void;
    get blurInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitBlur[] | undefined;
    private _chromaKey;
    get chromaKey(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKeyList;
    putChromaKey(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey[] | cdktf.IResolvable): void;
    resetChromaKey(): void;
    get chromaKeyInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitChromaKey[] | undefined;
    private _composite;
    get composite(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompositeList;
    putComposite(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite[] | cdktf.IResolvable): void;
    resetComposite(): void;
    get compositeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitComposite[] | undefined;
    private _compound;
    get compound(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompoundList;
    putCompound(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound[] | cdktf.IResolvable): void;
    resetCompound(): void;
    get compoundInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCompound[] | undefined;
    private _contrast;
    get contrast(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrastList;
    putContrast(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast[] | cdktf.IResolvable): void;
    resetContrast(): void;
    get contrastInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitContrast[] | undefined;
    private _crop;
    get crop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCropList;
    putCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop[] | cdktf.IResolvable): void;
    resetCrop(): void;
    get cropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitCrop[] | undefined;
    private _faceCrop;
    get faceCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCropList;
    putFaceCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop[] | cdktf.IResolvable): void;
    resetFaceCrop(): void;
    get faceCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFaceCrop[] | undefined;
    private _featureCrop;
    get featureCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCropList;
    putFeatureCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop[] | cdktf.IResolvable): void;
    resetFeatureCrop(): void;
    get featureCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFeatureCrop[] | undefined;
    private _fitAndFill;
    get fitAndFill(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFillList;
    putFitAndFill(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill[] | cdktf.IResolvable): void;
    resetFitAndFill(): void;
    get fitAndFillInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitFitAndFill[] | undefined;
    private _goop;
    get goop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoopList;
    putGoop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop[] | cdktf.IResolvable): void;
    resetGoop(): void;
    get goopInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGoop[] | undefined;
    private _grayscale;
    get grayscale(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscaleList;
    putGrayscale(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale[] | cdktf.IResolvable): void;
    resetGrayscale(): void;
    get grayscaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitGrayscale[] | undefined;
    private _hsl;
    get hsl(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHslList;
    putHsl(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl[] | cdktf.IResolvable): void;
    resetHsl(): void;
    get hslInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsl[] | undefined;
    private _hsv;
    get hsv(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsvList;
    putHsv(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv[] | cdktf.IResolvable): void;
    resetHsv(): void;
    get hsvInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitHsv[] | undefined;
    private _ifDimension;
    get ifDimension(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimensionList;
    putIfDimension(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension[] | cdktf.IResolvable): void;
    resetIfDimension(): void;
    get ifDimensionInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfDimension[] | undefined;
    private _ifOrientation;
    get ifOrientation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientationList;
    putIfOrientation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation[] | cdktf.IResolvable): void;
    resetIfOrientation(): void;
    get ifOrientationInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitIfOrientation[] | undefined;
    private _imQuery;
    get imQuery(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQueryList;
    putImQuery(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery[] | cdktf.IResolvable): void;
    resetImQuery(): void;
    get imQueryInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitImQuery[] | undefined;
    private _maxColors;
    get maxColors(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColorsList;
    putMaxColors(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors[] | cdktf.IResolvable): void;
    resetMaxColors(): void;
    get maxColorsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMaxColors[] | undefined;
    private _mirror;
    get mirror(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirrorList;
    putMirror(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror[] | cdktf.IResolvable): void;
    resetMirror(): void;
    get mirrorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMirror[] | undefined;
    private _monoHue;
    get monoHue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHueList;
    putMonoHue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue[] | cdktf.IResolvable): void;
    resetMonoHue(): void;
    get monoHueInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitMonoHue[] | undefined;
    private _opacity;
    get opacity(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacityList;
    putOpacity(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity[] | cdktf.IResolvable): void;
    resetOpacity(): void;
    get opacityInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitOpacity[] | undefined;
    private _regionOfInterestCrop;
    get regionOfInterestCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCropList;
    putRegionOfInterestCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop[] | cdktf.IResolvable): void;
    resetRegionOfInterestCrop(): void;
    get regionOfInterestCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRegionOfInterestCrop[] | undefined;
    private _relativeCrop;
    get relativeCrop(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCropList;
    putRelativeCrop(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop[] | cdktf.IResolvable): void;
    resetRelativeCrop(): void;
    get relativeCropInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRelativeCrop[] | undefined;
    private _removeColor;
    get removeColor(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColorList;
    putRemoveColor(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor[] | cdktf.IResolvable): void;
    resetRemoveColor(): void;
    get removeColorInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRemoveColor[] | undefined;
    private _resize;
    get resize(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResizeList;
    putResize(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize[] | cdktf.IResolvable): void;
    resetResize(): void;
    get resizeInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitResize[] | undefined;
    private _rotate;
    get rotate(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotateList;
    putRotate(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate[] | cdktf.IResolvable): void;
    resetRotate(): void;
    get rotateInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitRotate[] | undefined;
    private _scale;
    get scale(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScaleList;
    putScale(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale[] | cdktf.IResolvable): void;
    resetScale(): void;
    get scaleInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitScale[] | undefined;
    private _shear;
    get shear(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShearList;
    putShear(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear[] | cdktf.IResolvable): void;
    resetShear(): void;
    get shearInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitShear[] | undefined;
    private _trim;
    get trim(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrimList;
    putTrim(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim[] | cdktf.IResolvable): void;
    resetTrim(): void;
    get trimInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitTrim[] | undefined;
    private _unsharpMask;
    get unsharpMask(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMaskList;
    putUnsharpMask(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask[] | cdktf.IResolvable): void;
    resetUnsharpMask(): void;
    get unsharpMaskInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationPortraitUnsharpMask[] | undefined;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend {
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority DataAkamaiImagingPolicyImage#gravity_priority}
    */
    readonly gravityPriority?: string;
    /**
    * Determines the exact placement of the `image` when `gravity` is `Center` or a diagonal. The value is either `horizontal` or `vertical`. Use `horizontal` to append an `image` east or west of the source image. This aligns the `image` on the vertical gravity component, placing `Center` gravity east. Use `vertical` to append an `image` north or south of the source image. This aligns the `image` on the horizontal gravity component, placing `Center` gravity south.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_priority_var DataAkamaiImagingPolicyImage#gravity_priority_var}
    */
    readonly gravityPriorityVar?: string;
    /**
    * Specifies where to place the `image` relative to the source image. The available values represent the eight cardinal directions (`North`, `South`, `East`, `West`, `NorthEast`, `NorthWest`, `SouthEast`, `SouthWest`) and a `Center` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension DataAkamaiImagingPolicyImage#preserve_minor_dimension}
    */
    readonly preserveMinorDimension?: string;
    /**
    * Whether to preserve the source image's minor dimension, `false` by default. The minor dimension is the dimension opposite the dimension that the appending `image` is placed. For example, the dimensions of the source image are 100 &times; 100 pixels. The dimensions of the appending `image` are 50 &times; 150 pixels. The `gravity` is set to `East`. This makes the major dimension horizontal and the source image's minor dimension vertical. To preserve the source image's minor dimension at 100 pixels, the `preserveMinorDimension` is set to `true`. As a result of the append, the major dimension expanded with the appended image to 150 pixels. The source image's minor dimension was maintained at 100 pixels. The total combined dimension of the image is 150 &times; 100 pixels.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#preserve_minor_dimension_var DataAkamaiImagingPolicyImage#preserve_minor_dimension_var}
    */
    readonly preserveMinorDimensionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityPriority?;
    get gravityPriority(): string;
    set gravityPriority(value: string);
    resetGravityPriority(): void;
    get gravityPriorityInput(): string | undefined;
    private _gravityPriorityVar?;
    get gravityPriorityVar(): string;
    set gravityPriorityVar(value: string);
    resetGravityPriorityVar(): void;
    get gravityPriorityVarInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _preserveMinorDimension?;
    get preserveMinorDimension(): string;
    set preserveMinorDimension(value: string);
    resetPreserveMinorDimension(): void;
    get preserveMinorDimensionInput(): string | undefined;
    private _preserveMinorDimensionVar?;
    get preserveMinorDimensionVar(): string;
    set preserveMinorDimensionVar(value: string);
    resetPreserveMinorDimensionVar(): void;
    get preserveMinorDimensionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAppendOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop {
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * Increases the size of the image canvas to achieve the requested aspect ratio instead of cropping the image. Use the Horizontal Offset and Vertical Offset settings to determine where to add the fully transparent pixels on the expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width term of the aspect ratio to crop.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * Specifies the horizontal portion of the image you want to keep when the aspect ratio cropping is applied. When using Allow Expansion this setting defines the horizontal position of the image on the new expanded image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareAspectCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor {
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color DataAkamaiImagingPolicyImage#color}
    */
    readonly color?: string;
    /**
    * The hexadecimal CSS color value for the background.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#color_var DataAkamaiImagingPolicyImage#color_var}
    */
    readonly colorVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _colorVar?;
    get colorVar(): string;
    set colorVar(value: string);
    resetColorVar(): void;
    get colorVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColor[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBackgroundColorOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur {
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma DataAkamaiImagingPolicyImage#sigma}
    */
    readonly sigma?: string;
    /**
    * The number of pixels to scatter the original pixel by to create the blur effect. Resulting images may be larger than the original as pixels at the edge of the image might scatter outside the image's original dimensions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#sigma_var DataAkamaiImagingPolicyImage#sigma_var}
    */
    readonly sigmaVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur | cdktf.IResolvable | undefined);
    private _sigma?;
    get sigma(): string;
    set sigma(value: string);
    resetSigma(): void;
    get sigmaInput(): string | undefined;
    private _sigmaVar?;
    get sigmaVar(): string;
    set sigmaVar(value: string);
    resetSigmaVar(): void;
    get sigmaVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlur[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareBlurOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey {
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather DataAkamaiImagingPolicyImage#hue_feather}
    */
    readonly hueFeather?: string;
    /**
    * How much additional hue to make semi-transparent beyond the Hue Tolerance. By default Hue Feather is 0.083 which applies semi-transparency to hues 30° around the Hue Tolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_feather_var DataAkamaiImagingPolicyImage#hue_feather_var}
    */
    readonly hueFeatherVar?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance DataAkamaiImagingPolicyImage#hue_tolerance}
    */
    readonly hueTolerance?: string;
    /**
    * How close a color's hue needs to be to the selected hue for it to be changed to fully transparent. If you enter the maximum value of 1.0 the entire image is made transparent. By default Hue Tolerance is approximately 0.083 or 8.3% of the color wheel. This value corresponds to 30° around the specified hue.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_tolerance_var DataAkamaiImagingPolicyImage#hue_tolerance_var}
    */
    readonly hueToleranceVar?: string;
    /**
    * The hue to remove. Enter the degree of rotation between 0 and 360 degrees around the color wheel. By default Chroma Key removes a green hue, 120° on the color wheel.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather DataAkamaiImagingPolicyImage#lightness_feather}
    */
    readonly lightnessFeather?: string;
    /**
    * How much additional lightness to make semi-transparent beyond the Lightness Tolerance. The default value of 0.1 corresponds to 10% away from the tolerated lightness towards full black or full white.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_feather_var DataAkamaiImagingPolicyImage#lightness_feather_var}
    */
    readonly lightnessFeatherVar?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance DataAkamaiImagingPolicyImage#lightness_tolerance}
    */
    readonly lightnessTolerance?: string;
    /**
    * How much of the lightest part and darkest part of a color to preserve. For example, you can space this value out from the middle (i.e. 0.5 lightness or full color) to help preserve the splash lighting impact in the image. You can define how close the color needs to be to the full color to remove it from your image. The default value of 0.75 means that a colour must be within 75% of the full color to full white or full black for full removal.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_tolerance_var DataAkamaiImagingPolicyImage#lightness_tolerance_var}
    */
    readonly lightnessToleranceVar?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather DataAkamaiImagingPolicyImage#saturation_feather}
    */
    readonly saturationFeather?: string;
    /**
    * How much additional saturation to make semi-transparent beyond the Saturation Tolerance. By default Saturation Feather is 0.1 which applies semi-transparency to hues 10% below the saturationTolerance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_feather_var DataAkamaiImagingPolicyImage#saturation_feather_var}
    */
    readonly saturationFeatherVar?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance DataAkamaiImagingPolicyImage#saturation_tolerance}
    */
    readonly saturationTolerance?: string;
    /**
    * How close a color's saturation needs to be to full saturation for it to be changed to fully transparent. For example, you can define how green the color needs to be to remove it from your image. The default value of 0.75 means that a color must be within 75% of full saturation in order to be made fully transparent.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_tolerance_var DataAkamaiImagingPolicyImage#saturation_tolerance_var}
    */
    readonly saturationToleranceVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueFeather?;
    get hueFeather(): string;
    set hueFeather(value: string);
    resetHueFeather(): void;
    get hueFeatherInput(): string | undefined;
    private _hueFeatherVar?;
    get hueFeatherVar(): string;
    set hueFeatherVar(value: string);
    resetHueFeatherVar(): void;
    get hueFeatherVarInput(): string | undefined;
    private _hueTolerance?;
    get hueTolerance(): string;
    set hueTolerance(value: string);
    resetHueTolerance(): void;
    get hueToleranceInput(): string | undefined;
    private _hueToleranceVar?;
    get hueToleranceVar(): string;
    set hueToleranceVar(value: string);
    resetHueToleranceVar(): void;
    get hueToleranceVarInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightnessFeather?;
    get lightnessFeather(): string;
    set lightnessFeather(value: string);
    resetLightnessFeather(): void;
    get lightnessFeatherInput(): string | undefined;
    private _lightnessFeatherVar?;
    get lightnessFeatherVar(): string;
    set lightnessFeatherVar(value: string);
    resetLightnessFeatherVar(): void;
    get lightnessFeatherVarInput(): string | undefined;
    private _lightnessTolerance?;
    get lightnessTolerance(): string;
    set lightnessTolerance(value: string);
    resetLightnessTolerance(): void;
    get lightnessToleranceInput(): string | undefined;
    private _lightnessToleranceVar?;
    get lightnessToleranceVar(): string;
    set lightnessToleranceVar(value: string);
    resetLightnessToleranceVar(): void;
    get lightnessToleranceVarInput(): string | undefined;
    private _saturationFeather?;
    get saturationFeather(): string;
    set saturationFeather(value: string);
    resetSaturationFeather(): void;
    get saturationFeatherInput(): string | undefined;
    private _saturationFeatherVar?;
    get saturationFeatherVar(): string;
    set saturationFeatherVar(value: string);
    resetSaturationFeatherVar(): void;
    get saturationFeatherVarInput(): string | undefined;
    private _saturationTolerance?;
    get saturationTolerance(): string;
    set saturationTolerance(value: string);
    resetSaturationTolerance(): void;
    get saturationToleranceInput(): string | undefined;
    private _saturationToleranceVar?;
    get saturationToleranceVar(): string;
    set saturationToleranceVar(value: string);
    resetSaturationToleranceVar(): void;
    get saturationToleranceVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKey[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareChromaKeyOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite {
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Compass direction indicating the corner or edge of the base image to place the applied image. Use Horizontal and Vertical Offset to adjust the applied image's gravity position
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement DataAkamaiImagingPolicyImage#placement}
    */
    readonly placement?: string;
    /**
    * Place applied image on top of or underneath the base image. Watermarks are usually applied over. Backgrounds are usually applied under.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#placement_var DataAkamaiImagingPolicyImage#placement_var}
    */
    readonly placementVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale DataAkamaiImagingPolicyImage#scale}
    */
    readonly scale?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension DataAkamaiImagingPolicyImage#scale_dimension}
    */
    readonly scaleDimension?: string;
    /**
    * The dimension, either `width` or `height`, of the source image to scale.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_dimension_var DataAkamaiImagingPolicyImage#scale_dimension_var}
    */
    readonly scaleDimensionVar?: string;
    /**
    * A multiplier to resize the applied image relative to the source image and preserve aspect ratio, 1 by default. Set the `scaleDimension` to calculate the `scale` from the source image's width or height.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#scale_var DataAkamaiImagingPolicyImage#scale_var}
    */
    readonly scaleVar?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to apply.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#image DataAkamaiImagingPolicyImage#image}
    */
    readonly image: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite | cdktf.IResolvable | undefined);
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _placement?;
    get placement(): string;
    set placement(value: string);
    resetPlacement(): void;
    get placementInput(): string | undefined;
    private _placementVar?;
    get placementVar(): string;
    set placementVar(value: string);
    resetPlacementVar(): void;
    get placementVarInput(): string | undefined;
    private _scale?;
    get scale(): string;
    set scale(value: string);
    resetScale(): void;
    get scaleInput(): string | undefined;
    private _scaleDimension?;
    get scaleDimension(): string;
    set scaleDimension(value: string);
    resetScaleDimension(): void;
    get scaleDimensionInput(): string | undefined;
    private _scaleDimensionVar?;
    get scaleDimensionVar(): string;
    set scaleDimensionVar(value: string);
    resetScaleDimensionVar(): void;
    get scaleDimensionVarInput(): string | undefined;
    private _scaleVar?;
    get scaleVar(): string;
    set scaleVar(value: string);
    resetScaleVar(): void;
    get scaleVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
    private _image;
    get image(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImageOutputReference;
    putImage(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage): void;
    get imageInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeImage | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareComposite[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompositeOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations | cdktf.IResolvable | undefined);
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound {
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#transformations DataAkamaiImagingPolicyImage#transformations}
    */
    readonly transformations?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations[] | cdktf.IResolvable;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound | cdktf.IResolvable | undefined);
    private _transformations;
    get transformations(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformationsList;
    putTransformations(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundTransformations[] | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompound[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCompoundOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast {
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness DataAkamaiImagingPolicyImage#brightness}
    */
    readonly brightness?: string;
    /**
    * Adjusts the brightness of the image. Positive values increase brightness and negative values decrease brightness. A value of  `1` produces a white image. A value of  `-1` produces a black image. The default value is `0`, which leaves the image unchanged. The acceptable value range is `-1.0` to `1.0`. Values outside of the acceptable range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#brightness_var DataAkamaiImagingPolicyImage#brightness_var}
    */
    readonly brightnessVar?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast DataAkamaiImagingPolicyImage#contrast}
    */
    readonly contrast?: string;
    /**
    * Adjusts the contrast of the image. Expressed as a range from `-1` to `1`, positive values increase contrast, negative values decrease it, while `0` leaves the image unchanged. Values outside of the `-1` to `1` range clamp to this range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#contrast_var DataAkamaiImagingPolicyImage#contrast_var}
    */
    readonly contrastVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast | cdktf.IResolvable | undefined);
    private _brightness?;
    get brightness(): string;
    set brightness(value: string);
    resetBrightness(): void;
    get brightnessInput(): string | undefined;
    private _brightnessVar?;
    get brightnessVar(): string;
    set brightnessVar(value: string);
    resetBrightnessVar(): void;
    get brightnessVarInput(): string | undefined;
    private _contrast?;
    get contrast(): string;
    set contrast(value: string);
    resetContrast(): void;
    get contrastInput(): string | undefined;
    private _contrastVar?;
    get contrastVar(): string;
    set contrastVar(value: string);
    resetContrastVar(): void;
    get contrastVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrast[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareContrastOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop {
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion DataAkamaiImagingPolicyImage#allow_expansion}
    */
    readonly allowExpansion?: string;
    /**
    * If cropping an area outside of the existing canvas, expands the image canvas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#allow_expansion_var DataAkamaiImagingPolicyImage#allow_expansion_var}
    */
    readonly allowExpansionVar?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Frame of reference for X and Y Positions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The number of pixels to crop along the y-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The number of pixels to crop along the x-axis.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position DataAkamaiImagingPolicyImage#x_position}
    */
    readonly xPosition?: string;
    /**
    * The x-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#x_position_var DataAkamaiImagingPolicyImage#x_position_var}
    */
    readonly xPositionVar?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position DataAkamaiImagingPolicyImage#y_position}
    */
    readonly yPosition?: string;
    /**
    * The y-axis position of the image to crop from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#y_position_var DataAkamaiImagingPolicyImage#y_position_var}
    */
    readonly yPositionVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop | cdktf.IResolvable | undefined);
    private _allowExpansion?;
    get allowExpansion(): string;
    set allowExpansion(value: string);
    resetAllowExpansion(): void;
    get allowExpansionInput(): string | undefined;
    private _allowExpansionVar?;
    get allowExpansionVar(): string;
    set allowExpansionVar(value: string);
    resetAllowExpansionVar(): void;
    get allowExpansionVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _xPosition?;
    get xPosition(): string;
    set xPosition(value: string);
    resetXPosition(): void;
    get xPositionInput(): string | undefined;
    private _xPositionVar?;
    get xPositionVar(): string;
    set xPositionVar(value: string);
    resetXPositionVar(): void;
    get xPositionVarInput(): string | undefined;
    private _yPosition?;
    get yPosition(): string;
    set yPosition(value: string);
    resetYPosition(): void;
    get yPositionInput(): string | undefined;
    private _yPositionVar?;
    get yPositionVar(): string;
    set yPositionVar(value: string);
    resetYPositionVar(): void;
    get yPositionVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop {
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm DataAkamaiImagingPolicyImage#algorithm}
    */
    readonly algorithm?: string;
    /**
    * Specifies the type of algorithm used to detect faces in the image, either `cascade` for the cascade classifier algorithm or `dnn` for the deep neural network algorithm, `cascade` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#algorithm_var DataAkamaiImagingPolicyImage#algorithm_var}
    */
    readonly algorithmVar?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence DataAkamaiImagingPolicyImage#confidence}
    */
    readonly confidence?: string;
    /**
    * With `algorithm` set to `dnn`, specifies the minimum confidence needed to detect faces in the image. Values range from `0` to `1` for increased confidence, and possibly fewer faces detected.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#confidence_var DataAkamaiImagingPolicyImage#confidence_var}
    */
    readonly confidenceVar?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any faces in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus DataAkamaiImagingPolicyImage#focus}
    */
    readonly focus?: string;
    /**
    * Distinguishes the faces detected, either `biggestFace` or `allFaces` to place the crop rectangle around the full set of faces, `all` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#focus_var DataAkamaiImagingPolicyImage#focus_var}
    */
    readonly focusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the face(s) plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * The padding ratio based on the dimensions of the biggest face detected, `0.5` by default. Larger values increase padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the faces detected in the source image, `zoom` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` places a raw crop around the faces, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and faces as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the faces, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width of the output image in pixels relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop | cdktf.IResolvable | undefined);
    private _algorithm?;
    get algorithm(): string;
    set algorithm(value: string);
    resetAlgorithm(): void;
    get algorithmInput(): string | undefined;
    private _algorithmVar?;
    get algorithmVar(): string;
    set algorithmVar(value: string);
    resetAlgorithmVar(): void;
    get algorithmVarInput(): string | undefined;
    private _confidence?;
    get confidence(): string;
    set confidence(value: string);
    resetConfidence(): void;
    get confidenceInput(): string | undefined;
    private _confidenceVar?;
    get confidenceVar(): string;
    set confidenceVar(value: string);
    resetConfidenceVar(): void;
    get confidenceVarInput(): string | undefined;
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _focus?;
    get focus(): string;
    set focus(value: string);
    resetFocus(): void;
    get focusInput(): string | undefined;
    private _focusVar?;
    get focusVar(): string;
    set focusVar(value: string);
    resetFocusVar(): void;
    get focusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFaceCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop {
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity DataAkamaiImagingPolicyImage#fail_gravity}
    */
    readonly failGravity?: string;
    /**
    * Controls placement of the crop if Image and Video Manager does not detect any features in the image. Directions are relative to the edges of the image being transformed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fail_gravity_var DataAkamaiImagingPolicyImage#fail_gravity_var}
    */
    readonly failGravityVar?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius DataAkamaiImagingPolicyImage#feature_radius}
    */
    readonly featureRadius?: string;
    /**
    * The size in pixels of the important features to search for. If identified, two features never appear closer together than this value, `8.0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#feature_radius_var DataAkamaiImagingPolicyImage#feature_radius_var}
    */
    readonly featureRadiusVar?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity DataAkamaiImagingPolicyImage#gravity}
    */
    readonly gravity?: string;
    /**
    * Controls placement of the crop. Directions are relative to the region of interest plus padding.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#gravity_var DataAkamaiImagingPolicyImage#gravity_var}
    */
    readonly gravityVar?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features DataAkamaiImagingPolicyImage#max_features}
    */
    readonly maxFeatures?: string;
    /**
    * The maximum number of features to identify as important features, `32` by default. The strongest features are always chosen.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#max_features_var DataAkamaiImagingPolicyImage#max_features_var}
    */
    readonly maxFeaturesVar?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality DataAkamaiImagingPolicyImage#min_feature_quality}
    */
    readonly minFeatureQuality?: string;
    /**
    * Determines the minimum quality level of the feature identified. To consider a feature important, the feature needs to surpass this value.  Image and Video Manager measures quality on a scale from `0` for the lowest quality to `1` for the highest quality, `.1` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#min_feature_quality_var DataAkamaiImagingPolicyImage#min_feature_quality_var}
    */
    readonly minFeatureQualityVar?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding DataAkamaiImagingPolicyImage#padding}
    */
    readonly padding?: string;
    /**
    * Adds space around the region of interest. The amount of padding added is directly related to the size of the bounding box of the selected features. Specifically, the region of interest is expanded in all directions by the largest dimension of the bounding box of the selected features multiplied by this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#padding_var DataAkamaiImagingPolicyImage#padding_var}
    */
    readonly paddingVar?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style DataAkamaiImagingPolicyImage#style}
    */
    readonly style?: string;
    /**
    * Specifies how to crop or scale a crop area for the features identified in the source image, `fill` by default. The output image resizes to the specified `width` and `height` values. A value of `crop` performs a raw crop around the features, relative to the specified `gravity` value.  A value of `fill` scales the crop area to include as much of the image and features as possible, relative to the specified `width` and `height` values. A value of `zoom` scales the crop area as small as possible to fit the features, relative to the specified `width` and `height` values. Allows Variable substitution.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#style_var DataAkamaiImagingPolicyImage#style_var}
    */
    readonly styleVar?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width in pixels of the output image relative to the specified `style` value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop | cdktf.IResolvable | undefined);
    private _failGravity?;
    get failGravity(): string;
    set failGravity(value: string);
    resetFailGravity(): void;
    get failGravityInput(): string | undefined;
    private _failGravityVar?;
    get failGravityVar(): string;
    set failGravityVar(value: string);
    resetFailGravityVar(): void;
    get failGravityVarInput(): string | undefined;
    private _featureRadius?;
    get featureRadius(): string;
    set featureRadius(value: string);
    resetFeatureRadius(): void;
    get featureRadiusInput(): string | undefined;
    private _featureRadiusVar?;
    get featureRadiusVar(): string;
    set featureRadiusVar(value: string);
    resetFeatureRadiusVar(): void;
    get featureRadiusVarInput(): string | undefined;
    private _gravity?;
    get gravity(): string;
    set gravity(value: string);
    resetGravity(): void;
    get gravityInput(): string | undefined;
    private _gravityVar?;
    get gravityVar(): string;
    set gravityVar(value: string);
    resetGravityVar(): void;
    get gravityVarInput(): string | undefined;
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _maxFeatures?;
    get maxFeatures(): string;
    set maxFeatures(value: string);
    resetMaxFeatures(): void;
    get maxFeaturesInput(): string | undefined;
    private _maxFeaturesVar?;
    get maxFeaturesVar(): string;
    set maxFeaturesVar(value: string);
    resetMaxFeaturesVar(): void;
    get maxFeaturesVarInput(): string | undefined;
    private _minFeatureQuality?;
    get minFeatureQuality(): string;
    set minFeatureQuality(value: string);
    resetMinFeatureQuality(): void;
    get minFeatureQualityInput(): string | undefined;
    private _minFeatureQualityVar?;
    get minFeatureQualityVar(): string;
    set minFeatureQualityVar(value: string);
    resetMinFeatureQualityVar(): void;
    get minFeatureQualityVarInput(): string | undefined;
    private _padding?;
    get padding(): string;
    set padding(value: string);
    resetPadding(): void;
    get paddingInput(): string | undefined;
    private _paddingVar?;
    get paddingVar(): string;
    set paddingVar(value: string);
    resetPaddingVar(): void;
    get paddingVarInput(): string | undefined;
    private _style?;
    get style(): string;
    set style(value: string);
    resetStyle(): void;
    get styleInput(): string | undefined;
    private _styleVar?;
    get styleVar(): string;
    set styleVar(value: string);
    resetStyleVar(): void;
    get styleVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCrop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFeatureCropOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation {
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference | DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation | undefined);
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill {
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height DataAkamaiImagingPolicyImage#height}
    */
    readonly height?: string;
    /**
    * The height value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#height_var DataAkamaiImagingPolicyImage#height_var}
    */
    readonly heightVar?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width DataAkamaiImagingPolicyImage#width}
    */
    readonly width?: string;
    /**
    * The width value of the resized image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#width_var DataAkamaiImagingPolicyImage#width_var}
    */
    readonly widthVar?: string;
    /**
    * fill_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#fill_transformation DataAkamaiImagingPolicyImage#fill_transformation}
    */
    readonly fillTransformation?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill | cdktf.IResolvable | undefined);
    private _height?;
    get height(): string;
    set height(value: string);
    resetHeight(): void;
    get heightInput(): string | undefined;
    private _heightVar?;
    get heightVar(): string;
    set heightVar(value: string);
    resetHeightVar(): void;
    get heightVarInput(): string | undefined;
    private _width?;
    get width(): string;
    set width(value: string);
    resetWidth(): void;
    get widthInput(): string | undefined;
    private _widthVar?;
    get widthVar(): string;
    set widthVar(value: string);
    resetWidthVar(): void;
    get widthVarInput(): string | undefined;
    private _fillTransformation;
    get fillTransformation(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformationOutputReference;
    putFillTransformation(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation): void;
    resetFillTransformation(): void;
    get fillTransformationInput(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillFillTransformation | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFill[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareFitAndFillOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop {
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos DataAkamaiImagingPolicyImage#chaos}
    */
    readonly chaos?: string;
    /**
    * Specifies the greatest distance control points may move from their original position. A value of `1.0` shifts control points over as far as the next one in the original grid. A value of `0.0` leaves the image unchanged. Values under `0.5` work better for subtle distortions, otherwise control points may pass each other and cause a twisting effect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#chaos_var DataAkamaiImagingPolicyImage#chaos_var}
    */
    readonly chaosVar?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density DataAkamaiImagingPolicyImage#density}
    */
    readonly density?: string;
    /**
    * Controls the density of control points used to distort the image. The largest dimension of the input image is divided up to fit this number of control points. A grid of points is extended on the smaller dimension such that each row and column of control points is equidistant from each adjacent row or column. This parameter strongly affects transformation performance. Be careful choosing values above the default if you expect to transform medium to large size images.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#density_var DataAkamaiImagingPolicyImage#density_var}
    */
    readonly densityVar?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power DataAkamaiImagingPolicyImage#power}
    */
    readonly power?: string;
    /**
    * By default, the distortion algorithm relies on inverse squares to calculate distance but this allows you to change the exponent. You shouldnt need to vary the default value of `2.0`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#power_var DataAkamaiImagingPolicyImage#power_var}
    */
    readonly powerVar?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed DataAkamaiImagingPolicyImage#seed}
    */
    readonly seed?: string;
    /**
    * Specifies your own `seed` value as an alternative to the default, which is subject to variability. This allows for reproducible and deterministic distortions. If all parameters are kept equal and a constant seed is used, `Goop` distorts an input image consistently over many transformations. By default, this value is set to the current Epoch Time measured in milliseconds, which provides inconsistent transformation output.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#seed_var DataAkamaiImagingPolicyImage#seed_var}
    */
    readonly seedVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop | cdktf.IResolvable | undefined);
    private _chaos?;
    get chaos(): string;
    set chaos(value: string);
    resetChaos(): void;
    get chaosInput(): string | undefined;
    private _chaosVar?;
    get chaosVar(): string;
    set chaosVar(value: string);
    resetChaosVar(): void;
    get chaosVarInput(): string | undefined;
    private _density?;
    get density(): string;
    set density(value: string);
    resetDensity(): void;
    get densityInput(): string | undefined;
    private _densityVar?;
    get densityVar(): string;
    set densityVar(value: string);
    resetDensityVar(): void;
    get densityVarInput(): string | undefined;
    private _power?;
    get power(): string;
    set power(value: string);
    resetPower(): void;
    get powerInput(): string | undefined;
    private _powerVar?;
    get powerVar(): string;
    set powerVar(value: string);
    resetPowerVar(): void;
    get powerVarInput(): string | undefined;
    private _seed?;
    get seed(): string;
    set seed(value: string);
    resetSeed(): void;
    get seedInput(): string | undefined;
    private _seedVar?;
    get seedVar(): string;
    set seedVar(value: string);
    resetSeedVar(): void;
    get seedVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoop[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGoopOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale {
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type DataAkamaiImagingPolicyImage#type}
    */
    readonly type?: string;
    /**
    * The algorithm used to transform colors to grays, either `Brightness`, `Lightness`, `Rec601`, or the default `Rec709`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#type_var DataAkamaiImagingPolicyImage#type_var}
    */
    readonly typeVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _typeVar?;
    get typeVar(): string;
    set typeVar(value: string);
    resetTypeVar(): void;
    get typeVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscale[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareGrayscaleOutputReference;
}
export interface DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl {
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue DataAkamaiImagingPolicyImage#hue}
    */
    readonly hue?: string;
    /**
    * The number of degrees to rotate colors around the color wheel, `0` by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#hue_var DataAkamaiImagingPolicyImage#hue_var}
    */
    readonly hueVar?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness DataAkamaiImagingPolicyImage#lightness}
    */
    readonly lightness?: string;
    /**
    * A multiplier to adjust the lightness of colors in the image. Note that lightness is distinct from brightness. For example, reducing the lightness of a light green might give you a lime green whereas reducing the brightness of a light green might give you a darker shade of the same green. Values less than `1.0` decrease the lightness of colors in the image. Values greater than `1.0` increase the lightness of colors in the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#lightness_var DataAkamaiImagingPolicyImage#lightness_var}
    */
    readonly lightnessVar?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation DataAkamaiImagingPolicyImage#saturation}
    */
    readonly saturation?: string;
    /**
    * A multiplier to adjust the saturation of colors in the image. Values less than `1.0` decrease saturation and values greater than `1.0` increase the saturation. A value of `0.0` removes all color from the image.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/imaging_policy_image#saturation_var DataAkamaiImagingPolicyImage#saturation_var}
    */
    readonly saturationVar?: string;
}
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslToTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl | cdktf.IResolvable): any;
export declare function dataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslToHclTerraform(struct?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl | cdktf.IResolvable): any;
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl | cdktf.IResolvable | undefined);
    private _hue?;
    get hue(): string;
    set hue(value: string);
    resetHue(): void;
    get hueInput(): string | undefined;
    private _hueVar?;
    get hueVar(): string;
    set hueVar(value: string);
    resetHueVar(): void;
    get hueVarInput(): string | undefined;
    private _lightness?;
    get lightness(): string;
    set lightness(value: string);
    resetLightness(): void;
    get lightnessInput(): string | undefined;
    private _lightnessVar?;
    get lightnessVar(): string;
    set lightnessVar(value: string);
    resetLightnessVar(): void;
    get lightnessVarInput(): string | undefined;
    private _saturation?;
    get saturation(): string;
    set saturation(value: string);
    resetSaturation(): void;
    get saturationInput(): string | undefined;
    private _saturationVar?;
    get saturationVar(): string;
    set saturationVar(value: string);
    resetSaturationVar(): void;
    get saturationVarInput(): string | undefined;
}
export declare class DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHsl[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiImagingPolicyImagePolicyTransformationsFitAndFillFillTransformationIfOrientationSquareHslOutputReference;
}
