import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt {
    /**
    * Enables the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess {
    /**
    * Denies access when enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Text message that keys why access is denied. Any subsequent `denyAccess` behaviors within the rule tree may refer to the same `reason` key to override the current behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
    */
    readonly reason?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _reason?;
    get reason(): string;
    set reason(value: string);
    resetReason(): void;
    get reasonInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId {
    /**
    * Specifies a set of information about the device with which to generate a separate cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
    */
    readonly elements?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId | undefined);
    private _elements?;
    get elements(): string[];
    set elements(value: string[]);
    resetElements(): void;
    get elementsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader {
    /**
    * Specifies the set of information about the requesting device to send to the origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
    */
    readonly elements?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader | undefined);
    private _elements?;
    get elements(): string[];
    set elements(value: string[]);
    resetElements(): void;
    get elementsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh {
    /**
    * Allows edge servers to refresh an expired DNS record after serving content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Set the maximum allowed time an expired DNS record may be active.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh {
    /**
    * Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
    */
    readonly delay?: string;
    /**
    * Allows edge servers to refresh DNS records before they expire.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh | undefined);
    private _delay?;
    get delay(): string;
    set delay(value: string);
    resetDelay(): void;
    get delayInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol {
    /**
    * Enables the protocol downgrading behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache {
    /**
    * Specify how the edge server calculates the downstream cache by setting the value of the `Expires` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
    */
    readonly allowBehavior?: string;
    /**
    * Specify the caching instructions the edge server sends to the end user's client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the HTTP headers to include in the response to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
    */
    readonly sendHeaders?: string;
    /**
    * Adds a `Cache-Control: private` header to prevent objects from being cached in a shared caching proxy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
    */
    readonly sendPrivate?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Sets the duration of the cache. Setting the value to `0` equates to a `no-cache` header that forces revalidation.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
    */
    readonly ttl?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache | undefined);
    private _allowBehavior?;
    get allowBehavior(): string;
    set allowBehavior(value: string);
    resetAllowBehavior(): void;
    get allowBehaviorInput(): string | undefined;
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _sendHeaders?;
    get sendHeaders(): string;
    set sendHeaders(value: string);
    resetSendHeaders(): void;
    get sendHeadersInput(): string | undefined;
    private _sendPrivate?;
    get sendPrivate(): boolean | cdktf.IResolvable;
    set sendPrivate(value: boolean | cdktf.IResolvable);
    resetSendPrivate(): void;
    get sendPrivateInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _ttl?;
    get ttl(): string;
    set ttl(value: string);
    resetTtl(): void;
    get ttlInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization {
    /**
    * Enables the quick retry feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
    */
    readonly throughput?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _throughput?;
    get throughput(): string;
    set throughput(value: string);
    resetThroughput(): void;
    get throughputInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent {
    /**
    * Enables image compression for subcustomer content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
    */
    readonly imageCompression?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Allows subcustomer content to prefetch over HTTP/2.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
    */
    readonly prefetch?: boolean | cdktf.IResolvable;
    /**
    * Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the `realUserMonitoring` behavior for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
    */
    readonly realUserMonitoring?: boolean | cdktf.IResolvable;
    /**
    * Optimizes how subcustomer traffic routes from origin to edge servers.  See the `sureRoute` behavior for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
    */
    readonly sureRoute?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent | undefined);
    private _imageCompression?;
    get imageCompression(): boolean | cdktf.IResolvable;
    set imageCompression(value: boolean | cdktf.IResolvable);
    resetImageCompression(): void;
    get imageCompressionInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetch?;
    get prefetch(): boolean | cdktf.IResolvable;
    set prefetch(value: boolean | cdktf.IResolvable);
    resetPrefetch(): void;
    get prefetchInput(): boolean | cdktf.IResolvable | undefined;
    private _realUserMonitoring?;
    get realUserMonitoring(): boolean | cdktf.IResolvable;
    set realUserMonitoring(value: boolean | cdktf.IResolvable);
    resetRealUserMonitoring(): void;
    get realUserMonitoringInput(): boolean | cdktf.IResolvable | undefined;
    private _sureRoute?;
    get sureRoute(): boolean | cdktf.IResolvable;
    set sureRoute(value: boolean | cdktf.IResolvable);
    resetSureRoute(): void;
    get sureRouteInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload {
    /**
    * Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: `<hostname>/bulk/<database_name>/<dataset_name>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase {
    /**
    * Specifies a default database for this property. If you don't configure a default data set in the `ecmsDataset` behavior, requests to objects in this database follow the pattern: `<hostname>/datastore/<data_set_name>/<object_key>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
    */
    readonly database?: string;
    /**
    * Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
    */
    readonly extractLocation?: string;
    /**
    * Specifies the request header that passed the database name. By default, it points to `X-KV-Database`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the query string parameter that passed the database name. By default, it points to `database`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
    */
    readonly queryParameterName?: string;
    /**
    * Specifies the regular expression that matches the database name in the URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
    */
    readonly regexPattern?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _extractLocation?;
    get extractLocation(): string;
    set extractLocation(value: string);
    resetExtractLocation(): void;
    get extractLocationInput(): string | undefined;
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _queryParameterName?;
    get queryParameterName(): string;
    set queryParameterName(value: string);
    resetQueryParameterName(): void;
    get queryParameterNameInput(): string | undefined;
    private _regexPattern?;
    get regexPattern(): string;
    set regexPattern(value: string);
    resetRegexPattern(): void;
    get regexPatternInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset {
    /**
    * Specifies a default data set for this property. If you don't configure a default database in the `ecmsDatabase` behavior, requests to objects in this data set follow the pattern: `<hostname>/datastore/<database_name>/<object_key>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
    */
    readonly dataset?: string;
    /**
    * Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
    */
    readonly extractLocation?: string;
    /**
    * Specifies the request header that passed the data set name. By default, it points to `X-KV-Dataset`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the query string parameter that passed the data set name. By default, it points to `dataset`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
    */
    readonly queryParameterName?: string;
    /**
    * Specifies the regular expression that matches the data set name in the URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
    */
    readonly regexPattern?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset | undefined);
    private _dataset?;
    get dataset(): string;
    set dataset(value: string);
    resetDataset(): void;
    get datasetInput(): string | undefined;
    private _extractLocation?;
    get extractLocation(): string;
    set extractLocation(value: string);
    resetExtractLocation(): void;
    get extractLocationInput(): string | undefined;
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _queryParameterName?;
    get queryParameterName(): string;
    set queryParameterName(value: string);
    resetQueryParameterName(): void;
    get queryParameterNameInput(): string | undefined;
    private _regexPattern?;
    get regexPattern(): string;
    set regexPattern(value: string);
    resetRegexPattern(): void;
    get regexPatternInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables sending a compressed archive file with objects to the default path of the target data set: `<hostname>/bulk/<database_name>/<dataset_name>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
    */
    readonly regex?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _regex?;
    get regex(): string;
    set regex(value: string);
    resetRegex(): void;
    get regexInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect {
    /**
    * Specifies the maximum number of lines to include in each log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
    */
    readonly aggregateLines?: string;
    /**
    * Specifies the log's maximum size.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
    */
    readonly aggregateSize?: string;
    /**
    * Specifies how often logs are generated.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
    */
    readonly aggregateTime?: string;
    /**
    * Describes the API connector type.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
    */
    readonly apiConnector?: string;
    /**
    * Specifies the data set to log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
    */
    readonly apiDataElements?: string[];
    /**
    * Specifies the target hostname accepting push API requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
    */
    readonly destinationHostname?: string;
    /**
    * Specifies the push API's endpoint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
    */
    readonly destinationPath?: string;
    /**
    * Enables Cloud Monitor's log-publishing behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, overrides default log settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
    */
    readonly overrideAggregateSettings?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect | undefined);
    private _aggregateLines?;
    get aggregateLines(): string;
    set aggregateLines(value: string);
    resetAggregateLines(): void;
    get aggregateLinesInput(): string | undefined;
    private _aggregateSize?;
    get aggregateSize(): string;
    set aggregateSize(value: string);
    resetAggregateSize(): void;
    get aggregateSizeInput(): string | undefined;
    private _aggregateTime?;
    get aggregateTime(): string;
    set aggregateTime(value: string);
    resetAggregateTime(): void;
    get aggregateTimeInput(): string | undefined;
    private _apiConnector?;
    get apiConnector(): string;
    set apiConnector(value: string);
    resetApiConnector(): void;
    get apiConnectorInput(): string | undefined;
    private _apiDataElements?;
    get apiDataElements(): string[];
    set apiDataElements(value: string[]);
    resetApiDataElements(): void;
    get apiDataElementsInput(): string[] | undefined;
    private _destinationHostname?;
    get destinationHostname(): string;
    set destinationHostname(value: string);
    resetDestinationHostname(): void;
    get destinationHostnameInput(): string | undefined;
    private _destinationPath?;
    get destinationPath(): string;
    set destinationPath(value: string);
    resetDestinationPath(): void;
    get destinationPathInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideAggregateSettings?;
    get overrideAggregateSettings(): boolean | cdktf.IResolvable;
    set overrideAggregateSettings(value: boolean | cdktf.IResolvable);
    resetOverrideAggregateSettings(): void;
    get overrideAggregateSettingsInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced {
    /**
    * A description of what the `xml` block does.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * A block of Akamai XML metadata.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
    */
    readonly xml?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _xml?;
    get xml(): string;
    set xml(value: string);
    resetXml(): void;
    get xmlInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules {
    /**
    * When enabled, interprets the path specified by `context_root` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
    */
    readonly absolutePath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the path to use in the forwarding request, typically the root (`/`) when failing over to a different data center, or a full path such as `/static/error.html` when failing over to an error page.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
    */
    readonly contextRoot?: string;
    /**
    * The hostname of the data center to fail over to.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
    */
    readonly failoverHostname?: string;
    /**
    * Allows you to modify the request's hostname or path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
    */
    readonly modifyRequest?: boolean | cdktf.IResolvable;
    /**
    * Overrides the request's hostname with the `failover_hostname`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
    */
    readonly overrideHostname?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable | undefined);
    private _absolutePath?;
    get absolutePath(): boolean | cdktf.IResolvable;
    set absolutePath(value: boolean | cdktf.IResolvable);
    resetAbsolutePath(): void;
    get absolutePathInput(): boolean | cdktf.IResolvable | undefined;
    private _contextRoot?;
    get contextRoot(): string;
    set contextRoot(value: string);
    resetContextRoot(): void;
    get contextRootInput(): string | undefined;
    private _failoverHostname?;
    get failoverHostname(): string;
    set failoverHostname(value: string);
    resetFailoverHostname(): void;
    get failoverHostnameInput(): string | undefined;
    private _modifyRequest?;
    get modifyRequest(): boolean | cdktf.IResolvable;
    set modifyRequest(value: boolean | cdktf.IResolvable);
    resetModifyRequest(): void;
    get modifyRequestInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideHostname?;
    get overrideHostname(): boolean | cdktf.IResolvable;
    set overrideHostname(value: boolean | cdktf.IResolvable);
    resetOverrideHostname(): void;
    get overrideHostnameInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter {
    /**
    * If using session persistence, this specifies the value of the cookie named in the corresponding `edgeLoadBalancingOrigin` behavior's `cookie_name` option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Provides a description for the ELB data center, for your own reference.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Allows you to specify failover rules.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
    */
    readonly enableFailover?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
    */
    readonly failoverTitle?: string;
    /**
    * Specifies the data center's hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies this data center's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
    */
    readonly ip?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Corresponds to the `id` specified by the `edgeLoadBalancingOrigin` behavior associated with this data center.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
    */
    readonly originId?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * failover_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
    */
    readonly failoverRules?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _enableFailover?;
    get enableFailover(): boolean | cdktf.IResolvable;
    set enableFailover(value: boolean | cdktf.IResolvable);
    resetEnableFailover(): void;
    get enableFailoverInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverTitle?;
    get failoverTitle(): string;
    set failoverTitle(value: string);
    resetFailoverTitle(): void;
    get failoverTitleInput(): string | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _failoverRules;
    get failoverRules(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesList;
    putFailoverRules(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable): void;
    resetFailoverRules(): void;
    get failoverRulesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin {
    /**
    * This specifies the name of the cookie that marks users' persistent sessions. The accompanying `edgeLoadBalancingDataCenter` behavior's `description` option specifies the cookie's value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Provides a description for the ELB origin, for your own reference.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
    */
    readonly enableSessionPersistence?: boolean | cdktf.IResolvable;
    /**
    * Specifies the hostname associated with the ELB rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies a unique descriptive string for this ELB origin. The value needs to match the `origin_id` specified by the `edgeLoadBalancingDataCenter` behavior associated with this origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
    */
    readonly sessionPersistenceTitle?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _enableSessionPersistence?;
    get enableSessionPersistence(): boolean | cdktf.IResolvable;
    set enableSessionPersistence(value: boolean | cdktf.IResolvable);
    resetEnableSessionPersistence(): void;
    get enableSessionPersistenceInput(): boolean | cdktf.IResolvable | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _sessionPersistenceTitle?;
    get sessionPersistenceTitle(): string;
    set sessionPersistenceTitle(value: string);
    resetSessionPersistenceTitle(): void;
    get sessionPersistenceTitleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization {
    /**
    * Specifies the name of the cookie to use for authorization.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Specify the cookie's domain, which needs to match the top-level domain of the `Host` header the origin server receives.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
    */
    readonly domain?: string;
    /**
    * Enables the cookie-authorization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the value of the authorization cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    resetDomain(): void;
    get domainInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector {
    /**
    * Identifies the Cloudlet shared policy to use with this behavior. Use the `Cloudlets API` to list available shared policies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Edge Redirector Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape {
    /**
    * When enabled, sends the `X-Akamai-Edgescape` request header to the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes {
    /**
    * Denies attempts to inject ESI code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
    */
    readonly detectInjection?: boolean | cdktf.IResolvable;
    /**
    * Enable ESI only for content featuring the `Edge-control: dca=esi` HTTP response header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
    */
    readonly enableViaHttp?: boolean | cdktf.IResolvable;
    /**
    * Enables ESI processing.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the character sets to use when transcoding the ESI language, `UTF-8` and `ISO-8859-1` for example.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
    */
    readonly i18NCharset?: string[];
    /**
    * Provides internationalization support for ESI.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
    */
    readonly i18NStatus?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to pass the client IP header to the ESI processor.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
    */
    readonly passClientIp?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to pass your origin server's cookies to the ESI processor.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
    */
    readonly passSetCookie?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes | undefined);
    private _detectInjection?;
    get detectInjection(): boolean | cdktf.IResolvable;
    set detectInjection(value: boolean | cdktf.IResolvable);
    resetDetectInjection(): void;
    get detectInjectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableViaHttp?;
    get enableViaHttp(): boolean | cdktf.IResolvable;
    set enableViaHttp(value: boolean | cdktf.IResolvable);
    resetEnableViaHttp(): void;
    get enableViaHttpInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _i18NCharset?;
    get i18NCharset(): string[];
    set i18NCharset(value: string[]);
    resetI18NCharset(): void;
    get i18NCharsetInput(): string[] | undefined;
    private _i18NStatus?;
    get i18NStatus(): boolean | cdktf.IResolvable;
    set i18NStatus(value: boolean | cdktf.IResolvable);
    resetI18NStatus(): void;
    get i18NStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _passClientIp?;
    get passClientIp(): boolean | cdktf.IResolvable;
    set passClientIp(value: boolean | cdktf.IResolvable);
    resetPassClientIp(): void;
    get passClientIpInput(): boolean | cdktf.IResolvable | undefined;
    private _passSetCookie?;
    get passSetCookie(): boolean | cdktf.IResolvable;
    set passSetCookie(value: boolean | cdktf.IResolvable);
    resetPassSetCookie(): void;
    get passSetCookieInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
    */
    readonly createEdgeWorker?: string;
    /**
    * Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the `EdgeWorkers API` to get this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
    */
    readonly edgeWorkerId?: string;
    /**
    * When enabled, applies specified EdgeWorker functionality to this rule's web traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
    */
    readonly resourceTier?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker | undefined);
    private _createEdgeWorker?;
    get createEdgeWorker(): string;
    set createEdgeWorker(value: string);
    resetCreateEdgeWorker(): void;
    get createEdgeWorkerInput(): string | undefined;
    private _edgeWorkerId?;
    get edgeWorkerId(): string;
    set edgeWorkerId(value: string);
    resetEdgeWorkerId(): void;
    get edgeWorkerIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _resourceTier?;
    get resourceTier(): string;
    set resourceTier(value: string);
    resetResourceTier(): void;
    get resourceTierInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
    */
    readonly display?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol | undefined);
    private _display?;
    get display(): string;
    set display(value: string);
    resetDisplay(): void;
    get displayInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
    */
    readonly anonymousVpn?: string;
    /**
    * Specifies how to field the proxy request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
    */
    readonly bestPracticeAction?: string;
    /**
    * This specifies the URL to which to redirect requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
    */
    readonly bestPracticeRedirecturl?: string;
    /**
    * This enables detection of requests from anonymous VPNs.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
    */
    readonly detectAnonymousVpn?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to field anonymous VPN requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
    */
    readonly detectAnonymousVpnAction?: string;
    /**
    * This specifies the URL to which to redirect anonymous VPN requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
    */
    readonly detectAnonymousVpnRedirecturl?: string;
    /**
    * This detects requests from a hosting provider.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
    */
    readonly detectHostingProvider?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from hosting providers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
    */
    readonly detectHostingProviderAction?: string;
    /**
    * This specifies the absolute URL to which to redirect requests from hosting providers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
    */
    readonly detectHostingProviderRedirecturl?: string;
    /**
    * This enables detection of requests from public proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
    */
    readonly detectPublicProxy?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to field public proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
    */
    readonly detectPublicProxyAction?: string;
    /**
    * This specifies the URL to which to redirect public proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
    */
    readonly detectPublicProxyRedirecturl?: string;
    /**
    * This enables detection of requests from a residential proxy. See `Enhanced Proxy Detection with GeoGuard` and learn more about this GeoGuard category before enabling it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
    */
    readonly detectResidentialProxy?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from residential proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
    */
    readonly detectResidentialProxyAction?: string;
    /**
    * This specifies the URL to which to redirect requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
    */
    readonly detectResidentialProxyRedirecturl?: string;
    /**
    * This enables detection of requests from smart DNS proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
    */
    readonly detectSmartDnsProxy?: boolean | cdktf.IResolvable;
    /**
    * Specifies whether to `DENY`, `ALLOW`, or `REDIRECT` smart DNS proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
    */
    readonly detectSmartDnsProxyAction?: string;
    /**
    * This specifies the URL to which to redirect DNS proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
    */
    readonly detectSmartDnsProxyRedirecturl?: string;
    /**
    * This enables detection of requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
    */
    readonly detectTorExitNode?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
    */
    readonly detectTorExitNodeAction?: string;
    /**
    * This specifies the URL to which to redirect requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
    */
    readonly detectTorExitNodeRedirecturl?: string;
    /**
    * This enables detection of requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
    */
    readonly detectVpnDataCenter?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
    */
    readonly detectVpnDataCenterAction?: string;
    /**
    * This specifies the URL to which to redirect requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
    */
    readonly detectVpnDataCenterRedirecturl?: string;
    /**
    * Specifies how to field the proxy request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
    */
    readonly enableConfigurationMode?: string;
    /**
    * Applies GeoGuard proxy detection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the `epdForwardHeaderEnrichment` behavior for details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
    */
    readonly forwardHeaderEnrichment?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
    */
    readonly hostingProvider?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
    */
    readonly publicProxy?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
    */
    readonly residentialProxy?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
    */
    readonly smartDnsProxy?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
    */
    readonly torExitNode?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
    */
    readonly vpnDataCenter?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection | undefined);
    private _anonymousVpn?;
    get anonymousVpn(): string;
    set anonymousVpn(value: string);
    resetAnonymousVpn(): void;
    get anonymousVpnInput(): string | undefined;
    private _bestPracticeAction?;
    get bestPracticeAction(): string;
    set bestPracticeAction(value: string);
    resetBestPracticeAction(): void;
    get bestPracticeActionInput(): string | undefined;
    private _bestPracticeRedirecturl?;
    get bestPracticeRedirecturl(): string;
    set bestPracticeRedirecturl(value: string);
    resetBestPracticeRedirecturl(): void;
    get bestPracticeRedirecturlInput(): string | undefined;
    private _detectAnonymousVpn?;
    get detectAnonymousVpn(): boolean | cdktf.IResolvable;
    set detectAnonymousVpn(value: boolean | cdktf.IResolvable);
    resetDetectAnonymousVpn(): void;
    get detectAnonymousVpnInput(): boolean | cdktf.IResolvable | undefined;
    private _detectAnonymousVpnAction?;
    get detectAnonymousVpnAction(): string;
    set detectAnonymousVpnAction(value: string);
    resetDetectAnonymousVpnAction(): void;
    get detectAnonymousVpnActionInput(): string | undefined;
    private _detectAnonymousVpnRedirecturl?;
    get detectAnonymousVpnRedirecturl(): string;
    set detectAnonymousVpnRedirecturl(value: string);
    resetDetectAnonymousVpnRedirecturl(): void;
    get detectAnonymousVpnRedirecturlInput(): string | undefined;
    private _detectHostingProvider?;
    get detectHostingProvider(): boolean | cdktf.IResolvable;
    set detectHostingProvider(value: boolean | cdktf.IResolvable);
    resetDetectHostingProvider(): void;
    get detectHostingProviderInput(): boolean | cdktf.IResolvable | undefined;
    private _detectHostingProviderAction?;
    get detectHostingProviderAction(): string;
    set detectHostingProviderAction(value: string);
    resetDetectHostingProviderAction(): void;
    get detectHostingProviderActionInput(): string | undefined;
    private _detectHostingProviderRedirecturl?;
    get detectHostingProviderRedirecturl(): string;
    set detectHostingProviderRedirecturl(value: string);
    resetDetectHostingProviderRedirecturl(): void;
    get detectHostingProviderRedirecturlInput(): string | undefined;
    private _detectPublicProxy?;
    get detectPublicProxy(): boolean | cdktf.IResolvable;
    set detectPublicProxy(value: boolean | cdktf.IResolvable);
    resetDetectPublicProxy(): void;
    get detectPublicProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectPublicProxyAction?;
    get detectPublicProxyAction(): string;
    set detectPublicProxyAction(value: string);
    resetDetectPublicProxyAction(): void;
    get detectPublicProxyActionInput(): string | undefined;
    private _detectPublicProxyRedirecturl?;
    get detectPublicProxyRedirecturl(): string;
    set detectPublicProxyRedirecturl(value: string);
    resetDetectPublicProxyRedirecturl(): void;
    get detectPublicProxyRedirecturlInput(): string | undefined;
    private _detectResidentialProxy?;
    get detectResidentialProxy(): boolean | cdktf.IResolvable;
    set detectResidentialProxy(value: boolean | cdktf.IResolvable);
    resetDetectResidentialProxy(): void;
    get detectResidentialProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectResidentialProxyAction?;
    get detectResidentialProxyAction(): string;
    set detectResidentialProxyAction(value: string);
    resetDetectResidentialProxyAction(): void;
    get detectResidentialProxyActionInput(): string | undefined;
    private _detectResidentialProxyRedirecturl?;
    get detectResidentialProxyRedirecturl(): string;
    set detectResidentialProxyRedirecturl(value: string);
    resetDetectResidentialProxyRedirecturl(): void;
    get detectResidentialProxyRedirecturlInput(): string | undefined;
    private _detectSmartDnsProxy?;
    get detectSmartDnsProxy(): boolean | cdktf.IResolvable;
    set detectSmartDnsProxy(value: boolean | cdktf.IResolvable);
    resetDetectSmartDnsProxy(): void;
    get detectSmartDnsProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectSmartDnsProxyAction?;
    get detectSmartDnsProxyAction(): string;
    set detectSmartDnsProxyAction(value: string);
    resetDetectSmartDnsProxyAction(): void;
    get detectSmartDnsProxyActionInput(): string | undefined;
    private _detectSmartDnsProxyRedirecturl?;
    get detectSmartDnsProxyRedirecturl(): string;
    set detectSmartDnsProxyRedirecturl(value: string);
    resetDetectSmartDnsProxyRedirecturl(): void;
    get detectSmartDnsProxyRedirecturlInput(): string | undefined;
    private _detectTorExitNode?;
    get detectTorExitNode(): boolean | cdktf.IResolvable;
    set detectTorExitNode(value: boolean | cdktf.IResolvable);
    resetDetectTorExitNode(): void;
    get detectTorExitNodeInput(): boolean | cdktf.IResolvable | undefined;
    private _detectTorExitNodeAction?;
    get detectTorExitNodeAction(): string;
    set detectTorExitNodeAction(value: string);
    resetDetectTorExitNodeAction(): void;
    get detectTorExitNodeActionInput(): string | undefined;
    private _detectTorExitNodeRedirecturl?;
    get detectTorExitNodeRedirecturl(): string;
    set detectTorExitNodeRedirecturl(value: string);
    resetDetectTorExitNodeRedirecturl(): void;
    get detectTorExitNodeRedirecturlInput(): string | undefined;
    private _detectVpnDataCenter?;
    get detectVpnDataCenter(): boolean | cdktf.IResolvable;
    set detectVpnDataCenter(value: boolean | cdktf.IResolvable);
    resetDetectVpnDataCenter(): void;
    get detectVpnDataCenterInput(): boolean | cdktf.IResolvable | undefined;
    private _detectVpnDataCenterAction?;
    get detectVpnDataCenterAction(): string;
    set detectVpnDataCenterAction(value: string);
    resetDetectVpnDataCenterAction(): void;
    get detectVpnDataCenterActionInput(): string | undefined;
    private _detectVpnDataCenterRedirecturl?;
    get detectVpnDataCenterRedirecturl(): string;
    set detectVpnDataCenterRedirecturl(value: string);
    resetDetectVpnDataCenterRedirecturl(): void;
    get detectVpnDataCenterRedirecturlInput(): string | undefined;
    private _enableConfigurationMode?;
    get enableConfigurationMode(): string;
    set enableConfigurationMode(value: string);
    resetEnableConfigurationMode(): void;
    get enableConfigurationModeInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _forwardHeaderEnrichment?;
    get forwardHeaderEnrichment(): boolean | cdktf.IResolvable;
    set forwardHeaderEnrichment(value: boolean | cdktf.IResolvable);
    resetForwardHeaderEnrichment(): void;
    get forwardHeaderEnrichmentInput(): boolean | cdktf.IResolvable | undefined;
    private _hostingProvider?;
    get hostingProvider(): string;
    set hostingProvider(value: string);
    resetHostingProvider(): void;
    get hostingProviderInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _publicProxy?;
    get publicProxy(): string;
    set publicProxy(value: string);
    resetPublicProxy(): void;
    get publicProxyInput(): string | undefined;
    private _residentialProxy?;
    get residentialProxy(): string;
    set residentialProxy(value: string);
    resetResidentialProxy(): void;
    get residentialProxyInput(): string | undefined;
    private _smartDnsProxy?;
    get smartDnsProxy(): string;
    set smartDnsProxy(value: string);
    resetSmartDnsProxy(): void;
    get smartDnsProxyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _torExitNode?;
    get torExitNode(): string;
    set torExitNode(value: string);
    resetTorExitNode(): void;
    get torExitNodeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _vpnDataCenter?;
    get vpnDataCenter(): string;
    set vpnDataCenter(value: string);
    resetVpnDataCenter(): void;
    get vpnDataCenterInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment {
    /**
    * Sends the Enhanced Proxy Detection (`Akamai-EPD`) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}
    */
    readonly downloadDomainName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}
    */
    readonly g2OToken?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname | undefined);
    private _cpCode?;
    get cpCode(): number;
    set cpCode(value: number);
    resetCpCode(): void;
    get cpCodeInput(): number | undefined;
    private _downloadDomainName?;
    get downloadDomainName(): string;
    set downloadDomainName(value: string);
    resetDownloadDomainName(): void;
    get downloadDomainNameInput(): string | undefined;
    private _g2OToken?;
    get g2OToken(): string;
    set g2OToken(value: string);
    resetG2OToken(): void;
    get g2OTokenInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction {
    /**
    * Specifies the basic action to take when there is a failure to contact the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
    */
    readonly actionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}
    */
    readonly allowFcmParentOverride?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
    */
    readonly cexCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies a hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
    */
    readonly cexHostname?: string;
    /**
    * Specifies a custom path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
    */
    readonly cexPath?: string;
    /**
    * Specifies a custom redirect path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
    */
    readonly contentCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the static hostname for the alternate redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
    */
    readonly contentHostname?: string;
    /**
    * Specifies a custom redirect path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
    */
    readonly contentPath?: string;
    /**
    * Allows you to modify the original requested path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
    */
    readonly dynamicCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the redirect method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
    */
    readonly dynamicMethod?: string;
    /**
    * Specifies the new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
    */
    readonly dynamicPath?: string;
    /**
    * When enabled in case of a failure to contact the origin, the current behavior applies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Modifies the redirect's protocol using the value of the `protocol` field.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
    */
    readonly modifyProtocol?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `RECREATED_NS`, specifies the path for the `NetStorage` request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
    */
    readonly netStoragePath?: string;
    /**
    * When using either `contentCustomPath`, `cexCustomPath`, `dynamicCustomPath`, or `redirectCustomPath` to specify a custom path, enabling this passes in the original request's query string as part of the path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
    */
    readonly preserveQueryString?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `REDIRECT` and `modifyProtocol` is enabled, this specifies the redirect's protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
    */
    readonly protocol?: string;
    /**
    * Uses the `redirectPath` to customize a new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
    */
    readonly redirectCustomPath?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `REDIRECT` and the `redirectHostnameType` is `ALTERNATE`, this specifies the hostname for the redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
    */
    readonly redirectHostname?: string;
    /**
    * Whether to preserve or customize the hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
    */
    readonly redirectHostnameType?: string;
    /**
    * Specifies the HTTP response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
    */
    readonly redirectMethod?: number;
    /**
    * Specifies a new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
    */
    readonly redirectPath?: string;
    /**
    * Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
    */
    readonly saasCnameEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
    */
    readonly saasCnameLevel?: number;
    /**
    * Specifies the name of the cookie that identifies this SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
    */
    readonly saasCookie?: string;
    /**
    * Specifies the name of the query parameter that identifies this SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
    */
    readonly saasQueryString?: string;
    /**
    * Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
    */
    readonly saasRegex?: string;
    /**
    * Specifies the replacement pattern that defines the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
    */
    readonly saasReplace?: string;
    /**
    * Specifies the static portion of the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
    */
    readonly saasSuffix?: string;
    /**
    * Identifies the component of the request that identifies the SaaS dynamic fail action.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
    */
    readonly saasType?: string;
    /**
    * Assigns a new HTTP status code to the failure response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
    */
    readonly statusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode;
    /**
    * net_storage_hostname block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
    */
    readonly netStorageHostname?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    resetActionType(): void;
    get actionTypeInput(): string | undefined;
    private _allowFcmParentOverride?;
    get allowFcmParentOverride(): boolean | cdktf.IResolvable;
    set allowFcmParentOverride(value: boolean | cdktf.IResolvable);
    resetAllowFcmParentOverride(): void;
    get allowFcmParentOverrideInput(): boolean | cdktf.IResolvable | undefined;
    private _cexCustomPath?;
    get cexCustomPath(): boolean | cdktf.IResolvable;
    set cexCustomPath(value: boolean | cdktf.IResolvable);
    resetCexCustomPath(): void;
    get cexCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _cexHostname?;
    get cexHostname(): string;
    set cexHostname(value: string);
    resetCexHostname(): void;
    get cexHostnameInput(): string | undefined;
    private _cexPath?;
    get cexPath(): string;
    set cexPath(value: string);
    resetCexPath(): void;
    get cexPathInput(): string | undefined;
    private _contentCustomPath?;
    get contentCustomPath(): boolean | cdktf.IResolvable;
    set contentCustomPath(value: boolean | cdktf.IResolvable);
    resetContentCustomPath(): void;
    get contentCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _contentHostname?;
    get contentHostname(): string;
    set contentHostname(value: string);
    resetContentHostname(): void;
    get contentHostnameInput(): string | undefined;
    private _contentPath?;
    get contentPath(): string;
    set contentPath(value: string);
    resetContentPath(): void;
    get contentPathInput(): string | undefined;
    private _dynamicCustomPath?;
    get dynamicCustomPath(): boolean | cdktf.IResolvable;
    set dynamicCustomPath(value: boolean | cdktf.IResolvable);
    resetDynamicCustomPath(): void;
    get dynamicCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _dynamicMethod?;
    get dynamicMethod(): string;
    set dynamicMethod(value: string);
    resetDynamicMethod(): void;
    get dynamicMethodInput(): string | undefined;
    private _dynamicPath?;
    get dynamicPath(): string;
    set dynamicPath(value: string);
    resetDynamicPath(): void;
    get dynamicPathInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _modifyProtocol?;
    get modifyProtocol(): boolean | cdktf.IResolvable;
    set modifyProtocol(value: boolean | cdktf.IResolvable);
    resetModifyProtocol(): void;
    get modifyProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _netStoragePath?;
    get netStoragePath(): string;
    set netStoragePath(value: string);
    resetNetStoragePath(): void;
    get netStoragePathInput(): string | undefined;
    private _preserveQueryString?;
    get preserveQueryString(): boolean | cdktf.IResolvable;
    set preserveQueryString(value: boolean | cdktf.IResolvable);
    resetPreserveQueryString(): void;
    get preserveQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    resetProtocol(): void;
    get protocolInput(): string | undefined;
    private _redirectCustomPath?;
    get redirectCustomPath(): boolean | cdktf.IResolvable;
    set redirectCustomPath(value: boolean | cdktf.IResolvable);
    resetRedirectCustomPath(): void;
    get redirectCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _redirectHostname?;
    get redirectHostname(): string;
    set redirectHostname(value: string);
    resetRedirectHostname(): void;
    get redirectHostnameInput(): string | undefined;
    private _redirectHostnameType?;
    get redirectHostnameType(): string;
    set redirectHostnameType(value: string);
    resetRedirectHostnameType(): void;
    get redirectHostnameTypeInput(): string | undefined;
    private _redirectMethod?;
    get redirectMethod(): number;
    set redirectMethod(value: number);
    resetRedirectMethod(): void;
    get redirectMethodInput(): number | undefined;
    private _redirectPath?;
    get redirectPath(): string;
    set redirectPath(value: string);
    resetRedirectPath(): void;
    get redirectPathInput(): string | undefined;
    private _saasCnameEnabled?;
    get saasCnameEnabled(): boolean | cdktf.IResolvable;
    set saasCnameEnabled(value: boolean | cdktf.IResolvable);
    resetSaasCnameEnabled(): void;
    get saasCnameEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _saasCnameLevel?;
    get saasCnameLevel(): number;
    set saasCnameLevel(value: number);
    resetSaasCnameLevel(): void;
    get saasCnameLevelInput(): number | undefined;
    private _saasCookie?;
    get saasCookie(): string;
    set saasCookie(value: string);
    resetSaasCookie(): void;
    get saasCookieInput(): string | undefined;
    private _saasQueryString?;
    get saasQueryString(): string;
    set saasQueryString(value: string);
    resetSaasQueryString(): void;
    get saasQueryStringInput(): string | undefined;
    private _saasRegex?;
    get saasRegex(): string;
    set saasRegex(value: string);
    resetSaasRegex(): void;
    get saasRegexInput(): string | undefined;
    private _saasReplace?;
    get saasReplace(): string;
    set saasReplace(value: string);
    resetSaasReplace(): void;
    get saasReplaceInput(): string | undefined;
    private _saasSuffix?;
    get saasSuffix(): string;
    set saasSuffix(value: string);
    resetSaasSuffix(): void;
    get saasSuffixInput(): string | undefined;
    private _saasType?;
    get saasType(): string;
    set saasType(value: string);
    resetSaasType(): void;
    get saasTypeInput(): string | undefined;
    private _statusCode?;
    get statusCode(): number;
    set statusCode(value: number);
    resetStatusCode(): void;
    get statusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCode;
    get cpCode(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference;
    putCpCode(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode): void;
    resetCpCode(): void;
    get cpCodeInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode | undefined;
    private _netStorageHostname;
    get netStorageHostname(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference;
    putNetStorageHostname(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname): void;
    resetNetStorageHostname(): void;
    get netStorageHostnameInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility {
    /**
    * This behavior does not include any options. Specifying the behavior itself enables it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
    */
    readonly compatibility?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility | undefined);
    private _compatibility?;
    get compatibility(): boolean | cdktf.IResolvable;
    set compatibility(value: boolean | cdktf.IResolvable);
    resetCompatibility(): void;
    get compatibilityInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate {
    /**
    * When enabled, forces a validation test for all edge content to which the behavior applies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing {
    /**
    * Enables the Cloud Marketing Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Select how to insert the MediaMath JavaScript reference script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
    */
    readonly javaScriptInsertionRule?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash.  For example, if the path prefix is `/mmath`, and the request is for `www.example.com/dir`, the new URL is `www.example.com/mmath/dir`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
    */
    readonly mediaMathPrefix?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _javaScriptInsertionRule?;
    get javaScriptInsertionRule(): string;
    set javaScriptInsertionRule(value: string);
    resetJavaScriptInsertionRule(): void;
    get javaScriptInsertionRuleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mediaMathPrefix?;
    get mediaMathPrefix(): string;
    set mediaMathPrefix(value: string);
    resetMediaMathPrefix(): void;
    get mediaMathPrefixInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus {
    /**
    * Enables the Cloud Marketing Plus Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Select how to insert the MediaMath JavaScript reference script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
    */
    readonly javaScriptInsertionRule?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash.  For example, if the path prefix is `/mmath`, and the request is for `www.example.com/dir`, the new URL is `www.example.com/mmath/dir`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
    */
    readonly mediaMathPrefix?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _javaScriptInsertionRule?;
    get javaScriptInsertionRule(): string;
    set javaScriptInsertionRule(value: string);
    resetJavaScriptInsertionRule(): void;
    get javaScriptInsertionRuleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mediaMathPrefix?;
    get mediaMathPrefix(): string;
    set mediaMathPrefix(value: string);
    resetMediaMathPrefix(): void;
    get mediaMathPrefixInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite {
    /**
    * This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the `Cloudlets API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Forward Rewrite Cloudlet behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader {
    /**
    * Specifies the set of data to be encrypted as a combination of concatenated strings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
    */
    readonly customSignString?: string[];
    /**
    * Specifies the name of the header that contains the request data that needs to be encrypted.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
    */
    readonly dataHeader?: string;
    /**
    * Enables the g2o verification behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the version of the encryption algorithm as an integer from `1` through `5`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
    */
    readonly encodingVersion?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the cryptographic `nonce` string.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
    */
    readonly nonce?: string;
    /**
    * Specifies the shared secret key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
    */
    readonly secretKey?: string;
    /**
    * Specifies the name of the header containing encrypted request data.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
    */
    readonly signedHeader?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use `customSignString` to customize the set of data to encrypt.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
    */
    readonly useCustomSignString?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader | undefined);
    private _customSignString?;
    get customSignString(): string[];
    set customSignString(value: string[]);
    resetCustomSignString(): void;
    get customSignStringInput(): string[] | undefined;
    private _dataHeader?;
    get dataHeader(): string;
    set dataHeader(value: string);
    resetDataHeader(): void;
    get dataHeaderInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _encodingVersion?;
    get encodingVersion(): number;
    set encodingVersion(value: number);
    resetEncodingVersion(): void;
    get encodingVersionInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _nonce?;
    get nonce(): string;
    set nonce(value: string);
    resetNonce(): void;
    get nonceInput(): string | undefined;
    private _secretKey?;
    get secretKey(): string;
    set secretKey(value: string);
    resetSecretKey(): void;
    get secretKeyInput(): string | undefined;
    private _signedHeader?;
    get signedHeader(): string;
    set signedHeader(value: string);
    resetSignedHeader(): void;
    get signedHeaderInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useCustomSignString?;
    get useCustomSignString(): boolean | cdktf.IResolvable;
    set useCustomSignString(value: boolean | cdktf.IResolvable);
    resetUseCustomSignString(): void;
    get useCustomSignStringInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber {
    /**
    * With `outputOption` set to specify any set of headers, this specifies the name of the header to report the GRN value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to report the GRN value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
    */
    readonly outputOption?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * This specifies the name of the variable to assign the GRN value to. You need to pre-declare any `variable` you specify within the rule tree.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
    */
    readonly variableName?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber | undefined);
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _outputOption?;
    get outputOption(): string;
    set outputOption(value: string);
    resetOutputOption(): void;
    get outputOptionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _variableName?;
    get variableName(): string;
    set variableName(value: string);
    resetVariableName(): void;
    get variableNameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: string;
    /**
    * When enabled, caches responses that include an `error` field at the top of the response body object.  Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
    */
    readonly cacheResponsesWithErrors?: boolean | cdktf.IResolvable;
    /**
    * Enables GraphQL caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The name of the JSON body parameter that identifies GraphQL POST requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
    */
    readonly operationsJsonBodyParameterName?: string;
    /**
    * Specifies the name of a query parameter that identifies requests as GraphQL queries.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
    */
    readonly operationsUrlQueryParameterName?: string;
    /**
    * Specify what happens if GraphQL query processing fails on POST requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
    */
    readonly postRequestProcessingErrorHandling?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching | undefined);
    private _advanced?;
    get advanced(): string;
    set advanced(value: string);
    resetAdvanced(): void;
    get advancedInput(): string | undefined;
    private _cacheResponsesWithErrors?;
    get cacheResponsesWithErrors(): boolean | cdktf.IResolvable;
    set cacheResponsesWithErrors(value: boolean | cdktf.IResolvable);
    resetCacheResponsesWithErrors(): void;
    get cacheResponsesWithErrorsInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _operationsJsonBodyParameterName?;
    get operationsJsonBodyParameterName(): string;
    set operationsJsonBodyParameterName(value: string);
    resetOperationsJsonBodyParameterName(): void;
    get operationsJsonBodyParameterNameInput(): string | undefined;
    private _operationsUrlQueryParameterName?;
    get operationsUrlQueryParameterName(): string;
    set operationsUrlQueryParameterName(value: string);
    resetOperationsUrlQueryParameterName(): void;
    get operationsUrlQueryParameterNameInput(): string | undefined;
    private _postRequestProcessingErrorHandling?;
    get postRequestProcessingErrorHandling(): string;
    set postRequestProcessingErrorHandling(value: string);
    resetPostRequestProcessingErrorHandling(): void;
    get postRequestProcessingErrorHandlingInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse {
    /**
    * Specify when to compress responses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced {
    /**
    * Human-readable description of what the XML block does.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * A block of Akamai XML metadata.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
    */
    readonly xml?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _xml?;
    get xml(): string;
    set xml(value: string);
    resetXml(): void;
    get xmlInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, `maximumReconnects` effectively overrides the value of `retryCount`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
    */
    readonly maximumReconnects?: number;
    /**
    * The number of consecutive connection failures that mark an IP address as faulty.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
    */
    readonly retryCount?: number;
    /**
    * Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
    */
    readonly retryInterval?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumReconnects?;
    get maximumReconnects(): number;
    set maximumReconnects(value: number);
    resetMaximumReconnects(): void;
    get maximumReconnectsInput(): number | undefined;
    private _retryCount?;
    get retryCount(): number;
    set retryCount(value: number);
    resetRetryCount(): void;
    get retryCountInput(): number | undefined;
    private _retryInterval?;
    get retryInterval(): string;
    set retryInterval(value: string);
    resetRetryInterval(): void;
    get retryIntervalInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding {
    /**
    * Whether to pull the serial number from the variable value set in the `advanced` behavior. Work with your Akamai Services team to add the `advanced` behavior earlier in your property to extract and apply the `AKA_PM_EIP_HSAF_SERIAL` variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
    */
    readonly customExtractedSerial?: boolean | cdktf.IResolvable;
    /**
    * Enables HSAF for Edge IP Binding customers with a large footprint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than `hashMinValue`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
    */
    readonly hashMaxValue?: number;
    /**
    * Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than `hashMaxValue`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
    */
    readonly hashMinValue?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies where the behavior is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
    */
    readonly tier?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding | undefined);
    private _customExtractedSerial?;
    get customExtractedSerial(): boolean | cdktf.IResolvable;
    set customExtractedSerial(value: boolean | cdktf.IResolvable);
    resetCustomExtractedSerial(): void;
    get customExtractedSerialInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hashMaxValue?;
    get hashMaxValue(): number;
    set hashMaxValue(value: number);
    resetHashMaxValue(): void;
    get hashMaxValueInput(): number | undefined;
    private _hashMinValue?;
    get hashMinValue(): number;
    set hashMinValue(value: number);
    resetHashMinValue(): void;
    get hashMinValueInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tier?;
    get tier(): string;
    set tier(value: string);
    resetTier(): void;
    get tierInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2 {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2ToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2OutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2ToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2OutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2 | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2 | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3 {
    /**
    * This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the `Property Manager documentation` for more details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3ToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3OutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3ToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3OutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3 | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3 | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity {
    /**
    * Applies HSTS to this set of requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * When enabled, applies HSTS to all subdomains.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
    */
    readonly includeSubDomains?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the duration for which to apply HSTS for new browser connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
    */
    readonly maxAge?: string;
    /**
    * When enabled, adds this domain to the browser's preload list. You still need to declare the domain at `hstspreload.org`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
    */
    readonly preload?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects all HTTP requests to HTTPS.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
    */
    readonly redirect?: boolean | cdktf.IResolvable;
    /**
    * Specifies a response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
    */
    readonly redirectStatusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _includeSubDomains?;
    get includeSubDomains(): boolean | cdktf.IResolvable;
    set includeSubDomains(value: boolean | cdktf.IResolvable);
    resetIncludeSubDomains(): void;
    get includeSubDomainsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maxAge?;
    get maxAge(): string;
    set maxAge(value: string);
    resetMaxAge(): void;
    get maxAgeInput(): string | undefined;
    private _preload?;
    get preload(): boolean | cdktf.IResolvable;
    set preload(value: boolean | cdktf.IResolvable);
    resetPreload(): void;
    get preloadInput(): boolean | cdktf.IResolvable | undefined;
    private _redirect?;
    get redirect(): boolean | cdktf.IResolvable;
    set redirect(value: boolean | cdktf.IResolvable);
    resetRedirect(): void;
    get redirectInput(): boolean | cdktf.IResolvable | undefined;
    private _redirectStatusCode?;
    get redirectStatusCode(): number;
    set redirectStatusCode(value: number);
    resetRedirectStatusCode(): void;
    get redirectStatusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
    */
    readonly upgrade?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _upgrade?;
    get upgrade(): string;
    set upgrade(value: string);
    resetUpgrade(): void;
    get upgradeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride {
    /**
    * Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
    */
    readonly dpr?: number;
    /**
    * This selects the variable with the desired pixel density. The variable specifies the same type of data as the `dpr` option below.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
    */
    readonly dprvar?: string;
    /**
    * Whether to exclude all query parameters from the Image and Video Manager cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
    */
    readonly excludeAllQueryParameters?: boolean | cdktf.IResolvable;
    /**
    * Specifies individual query parameters to exclude from the Image and Video Manager cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
    */
    readonly excludedQueryParameters?: string[];
    /**
    * Specifies the type of the browser, or the encodings passed in the `Accept` header, that you want to optimize images for.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
    */
    readonly format?: string;
    /**
    * This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the `format` option below.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
    */
    readonly formatvar?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Selects the type of query parameter you want to set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
    */
    readonly override?: string;
    /**
    * This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
    */
    readonly policy?: string;
    /**
    * This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
    */
    readonly policyvar?: string;
    /**
    * This selects one of the property's rule tree variables to assign to the `policyvarName` variable within Image and Video Manager.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
    */
    readonly policyvarIMvar?: string;
    /**
    * This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
    */
    readonly policyvarName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies how to set a query parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
    */
    readonly typesel?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
    */
    readonly width?: number;
    /**
    * Selects the variable with the desired width.  If the Image and Video Manager policy doesn't define that width, it serves the next largest width.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
    */
    readonly widthvar?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride | undefined);
    private _dpr?;
    get dpr(): number;
    set dpr(value: number);
    resetDpr(): void;
    get dprInput(): number | undefined;
    private _dprvar?;
    get dprvar(): string;
    set dprvar(value: string);
    resetDprvar(): void;
    get dprvarInput(): string | undefined;
    private _excludeAllQueryParameters?;
    get excludeAllQueryParameters(): boolean | cdktf.IResolvable;
    set excludeAllQueryParameters(value: boolean | cdktf.IResolvable);
    resetExcludeAllQueryParameters(): void;
    get excludeAllQueryParametersInput(): boolean | cdktf.IResolvable | undefined;
    private _excludedQueryParameters?;
    get excludedQueryParameters(): string[];
    set excludedQueryParameters(value: string[]);
    resetExcludedQueryParameters(): void;
    get excludedQueryParametersInput(): string[] | undefined;
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _formatvar?;
    get formatvar(): string;
    set formatvar(value: string);
    resetFormatvar(): void;
    get formatvarInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _override?;
    get override(): string;
    set override(value: string);
    resetOverride(): void;
    get overrideInput(): string | undefined;
    private _policy?;
    get policy(): string;
    set policy(value: string);
    resetPolicy(): void;
    get policyInput(): string | undefined;
    private _policyvar?;
    get policyvar(): string;
    set policyvar(value: string);
    resetPolicyvar(): void;
    get policyvarInput(): string | undefined;
    private _policyvarIMvar?;
    get policyvarIMvar(): string;
    set policyvarIMvar(value: string);
    resetPolicyvarIMvar(): void;
    get policyvarIMvarInput(): string | undefined;
    private _policyvarName?;
    get policyvarName(): string;
    set policyvarName(value: string);
    resetPolicyvarName(): void;
    get policyvarNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _typesel?;
    get typesel(): string;
    set typesel(value: string);
    resetTypesel(): void;
    get typeselInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _widthvar?;
    get widthvar(): string;
    set widthvar(value: string);
    resetWidthvar(): void;
    get widthvarInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}
    */
    readonly imageSet?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}
    */
    readonly policySetType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}
    */
    readonly videoSet?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager | undefined);
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _imageSet?;
    get imageSet(): string;
    set imageSet(value: string);
    resetImageSet(): void;
    get imageSetInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySetType?;
    get policySetType(): string;
    set policySetType(value: string);
    resetPolicySetType(): void;
    get policySetTypeInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _videoSet?;
    get videoSet(): string;
    set videoSet(value: string);
    resetVideoSet(): void;
    get videoSetInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager {
    /**
    * Generates a custom `Image and Video Manager API` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the `policyToken`) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
    */
    readonly apiReferenceTitle?: string;
    /**
    * Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Enable image management capabilities and generate a corresponding API token.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Identifies the existing policy set configured with `Image and Video Manager API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
    */
    readonly policySet?: string;
    /**
    * Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, `default` becomes the prefix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
    */
    readonly policyToken?: string;
    /**
    * Specify the default policy identifier, which is registered with the `Image and Video Manager API` once you activate this property.  The `advanced` option needs to be inactive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
    */
    readonly policyTokenDefault?: string;
    /**
    * Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.  Note that enabling this may affect screen layout in unexpected ways.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
    */
    readonly settingsTitle?: string;
    /**
    * Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
    */
    readonly superCacheRegion?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
    */
    readonly trafficTitle?: string;
    /**
    * Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
    */
    readonly useExistingPolicySet?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _apiReferenceTitle?;
    get apiReferenceTitle(): string;
    set apiReferenceTitle(value: string);
    resetApiReferenceTitle(): void;
    get apiReferenceTitleInput(): string | undefined;
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySet?;
    get policySet(): string;
    set policySet(value: string);
    resetPolicySet(): void;
    get policySetInput(): string | undefined;
    private _policyToken?;
    get policyToken(): string;
    set policyToken(value: string);
    resetPolicyToken(): void;
    get policyTokenInput(): string | undefined;
    private _policyTokenDefault?;
    get policyTokenDefault(): string;
    set policyTokenDefault(value: string);
    resetPolicyTokenDefault(): void;
    get policyTokenDefaultInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsTitle?;
    get settingsTitle(): string;
    set settingsTitle(value: string);
    resetSettingsTitle(): void;
    get settingsTitleInput(): string | undefined;
    private _superCacheRegion?;
    get superCacheRegion(): string;
    set superCacheRegion(value: string);
    resetSuperCacheRegion(): void;
    get superCacheRegionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trafficTitle?;
    get trafficTitle(): string;
    set trafficTitle(value: string);
    resetTrafficTitle(): void;
    get trafficTitleInput(): string | undefined;
    private _useExistingPolicySet?;
    get useExistingPolicySet(): boolean | cdktf.IResolvable;
    set useExistingPolicySet(value: boolean | cdktf.IResolvable);
    resetUseExistingPolicySet(): void;
    get useExistingPolicySetInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo {
    /**
    * When disabled, applies a single standard policy based on your property name.  Allows you to reference a rule-specific `policyToken` for videos with different match criteria.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
    */
    readonly apiReferenceTitle?: string;
    /**
    * When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Applies Image and Video Manager's video optimization to the current content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Identifies the existing policy set configured with `Image and Video Manager API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
    */
    readonly policySet?: string;
    /**
    * Specifies a custom policy defined in the Image and Video Manager Policy Manager or the `Image and Video Manager API`. The policy name can include up to 64 alphanumeric, dash, or underscore characters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
    */
    readonly policyToken?: string;
    /**
    * Specifies the default policy identifier, which is registered with the `Image and Video Manager API` once you activate this property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
    */
    readonly policyTokenDefault?: string;
    /**
    * When enabled, scales down video for smaller mobile screens, based on the device's `User-Agent` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
    */
    readonly settingsTitle?: string;
    /**
    * To optimize caching, assign a region close to your site's heaviest traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
    */
    readonly superCacheRegion?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
    */
    readonly trafficTitle?: string;
    /**
    * Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
    */
    readonly useExistingPolicySet?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _apiReferenceTitle?;
    get apiReferenceTitle(): string;
    set apiReferenceTitle(value: string);
    resetApiReferenceTitle(): void;
    get apiReferenceTitleInput(): string | undefined;
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySet?;
    get policySet(): string;
    set policySet(value: string);
    resetPolicySet(): void;
    get policySetInput(): string | undefined;
    private _policyToken?;
    get policyToken(): string;
    set policyToken(value: string);
    resetPolicyToken(): void;
    get policyTokenInput(): string | undefined;
    private _policyTokenDefault?;
    get policyTokenDefault(): string;
    set policyTokenDefault(value: string);
    resetPolicyTokenDefault(): void;
    get policyTokenDefaultInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsTitle?;
    get settingsTitle(): string;
    set settingsTitle(value: string);
    resetSettingsTitle(): void;
    get settingsTitleInput(): string | undefined;
    private _superCacheRegion?;
    get superCacheRegion(): string;
    set superCacheRegion(value: string);
    resetSuperCacheRegion(): void;
    get superCacheRegionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trafficTitle?;
    get trafficTitle(): string;
    set trafficTitle(value: string);
    resetTrafficTitle(): void;
    get trafficTitleInput(): string | undefined;
    private _useExistingPolicySet?;
    get useExistingPolicySet(): boolean | cdktf.IResolvable;
    set useExistingPolicySet(value: boolean | cdktf.IResolvable);
    resetUseExistingPolicySet(): void;
    get useExistingPolicySetInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude {
    /**
    * Identifies the include you want to add to your rule tree. You can get the include ID using `PAPI`. This option only accepts digits, without the `inc_` ID prefix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant {
    /**
    * Specify link relation values that activate the prefetching behavior. For example, specifying `fetch` allows you to use shorter `rel="fetch"` markup.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
    */
    readonly customLinkRelations?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, applies prefetching only to objects already set to be cacheable, for example using the `caching` behavior. Only applies to content with the `tieredDistribution` behavior enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
    */
    readonly prefetchCacheable?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from `<a>` or `<link>` tags with the appropriate link relation attribute.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
    */
    readonly prefetchHtml?: boolean | cdktf.IResolvable;
    /**
    * Allows otherwise non-cacheable `no-store` content to prefetch if the URL path ends with `/` to indicate a request for a default file, or if the extension matches the value of the `prefetchNoStoreExtensions` option. Only applies to content with the `sureRoute` behavior enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
    */
    readonly prefetchNoStore?: boolean | cdktf.IResolvable;
    /**
    * Specifies a set of file extensions for which the `prefetchNoStore` option is allowed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
    */
    readonly prefetchNoStoreExtensions?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant | undefined);
    private _customLinkRelations?;
    get customLinkRelations(): string[];
    set customLinkRelations(value: string[]);
    resetCustomLinkRelations(): void;
    get customLinkRelationsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchCacheable?;
    get prefetchCacheable(): boolean | cdktf.IResolvable;
    set prefetchCacheable(value: boolean | cdktf.IResolvable);
    resetPrefetchCacheable(): void;
    get prefetchCacheableInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchHtml?;
    get prefetchHtml(): boolean | cdktf.IResolvable;
    set prefetchHtml(value: boolean | cdktf.IResolvable);
    resetPrefetchHtml(): void;
    get prefetchHtmlInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchNoStore?;
    get prefetchNoStore(): boolean | cdktf.IResolvable;
    set prefetchNoStore(value: boolean | cdktf.IResolvable);
    resetPrefetchNoStore(): void;
    get prefetchNoStoreInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchNoStoreExtensions?;
    get prefetchNoStoreExtensions(): string[];
    set prefetchNoStoreExtensions(value: string[]);
    resetPrefetchNoStoreExtensions(): void;
    get prefetchNoStoreExtensionsInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig {
    /**
    * Enables the InstantConfig behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization {
    /**
    * Specifies whether to cache partial objects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
    */
    readonly enablePartialObjectCaching?: string;
    /**
    * Enables the file optimization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as `MB` or `GB`. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
    */
    readonly maximumSize?: string;
    /**
    * Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as `MB` or `GB`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
    */
    readonly minimumSize?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When `enablePartialObjectCaching` is set to `PARTIAL_OBJECT_CACHING`, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
    */
    readonly useVersioning?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization | undefined);
    private _enablePartialObjectCaching?;
    get enablePartialObjectCaching(): string;
    set enablePartialObjectCaching(value: string);
    resetEnablePartialObjectCaching(): void;
    get enablePartialObjectCachingInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumSize?;
    get maximumSize(): string;
    set maximumSize(value: string);
    resetMaximumSize(): void;
    get maximumSizeInput(): string | undefined;
    private _minimumSize?;
    get minimumSize(): string;
    set minimumSize(value: string);
    resetMinimumSize(): void;
    get minimumSizeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useVersioning?;
    get useVersioning(): boolean | cdktf.IResolvable;
    set useVersioning(value: boolean | cdktf.IResolvable);
    resetUseVersioning(): void;
    get useVersioningInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced {
    /**
    * Enables the file optimization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the size of each fragment used for partial object caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
    */
    readonly fragmentSize?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a `MB` or `GB` suffix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * The number of POC fragments to prefetch after the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
    */
    readonly prefetchAfterRequest?: number;
    /**
    * The number of POC fragments to prefetch during the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
    */
    readonly prefetchDuringRequest?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _fragmentSize?;
    get fragmentSize(): string;
    set fragmentSize(value: string);
    resetFragmentSize(): void;
    get fragmentSizeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _prefetchAfterRequest?;
    get prefetchAfterRequest(): number;
    set prefetchAfterRequest(value: number);
    resetPrefetchAfterRequest(): void;
    get prefetchAfterRequestInput(): number | undefined;
    private _prefetchDuringRequest?;
    get prefetchDuringRequest(): number;
    set prefetchDuringRequest(value: number);
    resetPrefetchDuringRequest(): void;
    get prefetchDuringRequestInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable {
    /**
    * The unit of measurement, either `KBPS`, `MBPS`, or `GBPS`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
    */
    readonly bitrateUnit?: string;
    /**
    * The numeric indicator of the download rate.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
    */
    readonly bitrateValue?: number;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable | cdktf.IResolvable | undefined);
    private _bitrateUnit?;
    get bitrateUnit(): string;
    set bitrateUnit(value: string);
    resetBitrateUnit(): void;
    get bitrateUnitInput(): string | undefined;
    private _bitrateValue?;
    get bitrateValue(): number;
    set bitrateValue(value: number);
    resetBitrateValue(): void;
    get bitrateValueInput(): number | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable {
    /**
    * The unit of measurement, either `SECONDS` of the elapsed download time, or `BYTES` of the file size.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
    */
    readonly thresholdUnit?: string;
    /**
    * The numeric indicator of the minimum file size or elapsed download time.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
    */
    readonly thresholdValue?: number;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable | cdktf.IResolvable | undefined);
    private _thresholdUnit?;
    get thresholdUnit(): string;
    set thresholdUnit(value: string);
    resetThresholdUnit(): void;
    get thresholdUnitInput(): string | undefined;
    private _thresholdValue?;
    get thresholdValue(): number;
    set thresholdValue(value: number);
    resetThresholdValue(): void;
    get thresholdValueInput(): number | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate {
    /**
    * When enabled, activates the bit rate limiting behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * bitrate_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
    */
    readonly bitrateTable?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable;
    /**
    * threshold_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
    */
    readonly thresholdTable?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _bitrateTable;
    get bitrateTable(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableList;
    putBitrateTable(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable): void;
    resetBitrateTable(): void;
    get bitrateTableInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable[] | undefined;
    private _thresholdTable;
    get thresholdTable(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableList;
    putThresholdTable(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable): void;
    resetThresholdTable(): void;
    get thresholdTableInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable[] | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom {
    /**
    * Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, `round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms` logs the total time to complete the response. See `Support for variables` for more information. Since this option can specify both a request and response, it overrides any `customLogField` settings in the `report` behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
    */
    readonly customLogField?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Whether to append additional custom data to each log line.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
    */
    readonly logCustomLogField?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom | undefined);
    private _customLogField?;
    get customLogField(): string;
    set customLogField(value: string);
    resetCustomLogField(): void;
    get customLogFieldInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _logCustomLogField?;
    get logCustomLogField(): boolean | cdktf.IResolvable;
    set logCustomLogField(value: boolean | cdktf.IResolvable);
    resetLogCustomLogField(): void;
    get logCustomLogFieldInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse {
    /**
    * This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see `Enable mPulse in Property Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
    */
    readonly apiKey?: string;
    /**
    * Allows you to override the browser's default (150) maximum number of reported performance timeline entries.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
    */
    readonly bufferSize?: string;
    /**
    * A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the `window.BOOMR_config` object. For example, this turns on monitoring of Single Page App frameworks: `"{\"history\": {\"enabled\": true, \"auto\": true}}"`.  See `Configuration Overrides` for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
    */
    readonly configOverride?: string;
    /**
    * Applies performance monitoring to this behavior's set of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the version of the Boomerang JavaScript loader snippet. See `mPulse Loader Snippets` for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
    */
    readonly loaderVersion?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
    */
    readonly requirePci?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
    */
    readonly titleOptional?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse | undefined);
    private _apiKey?;
    get apiKey(): string;
    set apiKey(value: string);
    resetApiKey(): void;
    get apiKeyInput(): string | undefined;
    private _bufferSize?;
    get bufferSize(): string;
    set bufferSize(value: string);
    resetBufferSize(): void;
    get bufferSizeInput(): string | undefined;
    private _configOverride?;
    get configOverride(): string;
    set configOverride(value: string);
    resetConfigOverride(): void;
    get configOverrideInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _loaderVersion?;
    get loaderVersion(): string;
    set loaderVersion(value: string);
    resetLoaderVersion(): void;
    get loaderVersionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _requirePci?;
    get requirePci(): boolean | cdktf.IResolvable;
    set requirePci(value: boolean | cdktf.IResolvable);
    resetRequirePci(): void;
    get requirePciInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _titleOptional?;
    get titleOptional(): string;
    set titleOptional(value: string);
    resetTitleOptional(): void;
    get titleOptionalInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization {
    /**
    * Enables the Manifest Personalization feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Includes additional `Akamai-Manifest-Personalization` and `Akamai-Manifest-Personalization-Config-Source` debugging headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
    */
    readonly hlsEnableDebugHeaders?: boolean | cdktf.IResolvable;
    /**
    * Allows you to customize the HLS master manifest that's sent to the requesting client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
    */
    readonly hlsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies a comma-delimited set of bit rate ranges, such as `100-400,1000-4000`. Playlists specified in the `#EXT-X-STREAM-INF` tag with bit rates outside of any of those ranges are excluded from the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
    */
    readonly hlsFilterInBitrateRanges?: string;
    /**
    * Specifies a comma-delimited set of preferred bit rates, such as `100,200,400`. Playlists specified in the `#EXT-X-STREAM-INF` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
    */
    readonly hlsFilterInBitrates?: string;
    /**
    * Applies with `hlsEnabled` on.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
    */
    readonly hlsMode?: string;
    /**
    * Sets the preferred bit rate in Kbps. This causes the media playlist specified in the `#EXT-X-STREAM-INF` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
    */
    readonly hlsPreferredBitrate?: string;
    /**
    * Specifies query parameters for the HLS master manifest to customize the manifest's content.  Any settings specified in the query string override those already configured in Property Manager.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
    */
    readonly hlsQueryParamEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies a primary key as a token to accompany the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
    */
    readonly hlsQueryParamSecretKey?: string;
    /**
    * Specifies a transition key as a token to accompany the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
    */
    readonly hlsQueryParamTransitionKey?: string;
    /**
    * Allows you to configure advanced settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
    */
    readonly hlsShowAdvanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
    */
    readonly hlsTitle?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsEnableDebugHeaders?;
    get hlsEnableDebugHeaders(): boolean | cdktf.IResolvable;
    set hlsEnableDebugHeaders(value: boolean | cdktf.IResolvable);
    resetHlsEnableDebugHeaders(): void;
    get hlsEnableDebugHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsEnabled?;
    get hlsEnabled(): boolean | cdktf.IResolvable;
    set hlsEnabled(value: boolean | cdktf.IResolvable);
    resetHlsEnabled(): void;
    get hlsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsFilterInBitrateRanges?;
    get hlsFilterInBitrateRanges(): string;
    set hlsFilterInBitrateRanges(value: string);
    resetHlsFilterInBitrateRanges(): void;
    get hlsFilterInBitrateRangesInput(): string | undefined;
    private _hlsFilterInBitrates?;
    get hlsFilterInBitrates(): string;
    set hlsFilterInBitrates(value: string);
    resetHlsFilterInBitrates(): void;
    get hlsFilterInBitratesInput(): string | undefined;
    private _hlsMode?;
    get hlsMode(): string;
    set hlsMode(value: string);
    resetHlsMode(): void;
    get hlsModeInput(): string | undefined;
    private _hlsPreferredBitrate?;
    get hlsPreferredBitrate(): string;
    set hlsPreferredBitrate(value: string);
    resetHlsPreferredBitrate(): void;
    get hlsPreferredBitrateInput(): string | undefined;
    private _hlsQueryParamEnabled?;
    get hlsQueryParamEnabled(): boolean | cdktf.IResolvable;
    set hlsQueryParamEnabled(value: boolean | cdktf.IResolvable);
    resetHlsQueryParamEnabled(): void;
    get hlsQueryParamEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsQueryParamSecretKey?;
    get hlsQueryParamSecretKey(): string;
    set hlsQueryParamSecretKey(value: string);
    resetHlsQueryParamSecretKey(): void;
    get hlsQueryParamSecretKeyInput(): string | undefined;
    private _hlsQueryParamTransitionKey?;
    get hlsQueryParamTransitionKey(): string;
    set hlsQueryParamTransitionKey(value: string);
    resetHlsQueryParamTransitionKey(): void;
    get hlsQueryParamTransitionKeyInput(): string | undefined;
    private _hlsShowAdvanced?;
    get hlsShowAdvanced(): boolean | cdktf.IResolvable;
    set hlsShowAdvanced(value: boolean | cdktf.IResolvable);
    resetHlsShowAdvanced(): void;
    get hlsShowAdvancedInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsTitle?;
    get hlsTitle(): string;
    set hlsTitle(value: string);
    resetHlsTitle(): void;
    get hlsTitleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Set this value to `adobe_primetime`, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
    */
    readonly partner?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * The user name for your Adobe Primetime account.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
    */
    readonly username?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _partner?;
    get partner(): string;
    set partner(value: string);
    resetPartner(): void;
    get partnerInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as `www.example.com/js/site.js`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
    */
    readonly serverpushlist?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _serverpushlist?;
    get serverpushlist(): string[];
    set serverpushlist(value: string[]);
    resetServerpushlist(): void;
    get serverpushlistInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration {
    /**
    * Enables Media Acceleration.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
    */
    readonly optout?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _optout?;
    get optout(): string;
    set optout(value: string);
    resetOptout(): void;
    get optoutInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient {
    /**
    * Specifies the ID of data source's beacon.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
    */
    readonly beaconId?: string;
    /**
    * Enables client-side download analytics.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Enables the hybrid HTTP/UDP protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
    */
    readonly useHybridHttpUdp?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient | undefined);
    private _beaconId?;
    get beaconId(): string;
    set beaconId(value: string);
    resetBeaconId(): void;
    get beaconIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useHybridHttpUdp?;
    get useHybridHttpUdp(): boolean | cdktf.IResolvable;
    set useHybridHttpUdp(value: boolean | cdktf.IResolvable);
    resetUseHybridHttpUdp(): void;
    get useHybridHttpUdpInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization {
    /**
    * Enables the partial-object caching behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover {
    /**
    * When enabled, caches the error response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
    */
    readonly cacheErrorResponse?: boolean | cdktf.IResolvable;
    /**
    * This sets error response's TTL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
    */
    readonly cacheWindow?: string;
    /**
    * Specifies the response code served to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
    */
    readonly clientResponseCode?: string;
    /**
    * Allows you to configure failover settings when the origin has content errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
    */
    readonly detectObjectUnavailable?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
    */
    readonly detectObjectUnavailableTitle?: string;
    /**
    * Allows you to configure failover settings when the origin server responds with errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
    */
    readonly detectOriginUnavailable?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
    */
    readonly detectOriginUnavailableTitle?: string;
    /**
    * Allows you to configure what happens when the origin is unresponsive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
    */
    readonly detectOriginUnresponsive?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
    */
    readonly detectOriginUnresponsiveTitle?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
    */
    readonly objectUnavailableAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
    */
    readonly objectUnavailableBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
    */
    readonly objectUnavailableBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
    */
    readonly objectUnavailableBlacklistWindow?: string;
    /**
    * Changes the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
    */
    readonly objectUnavailableChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify `RESPONSE_CODES`, the only available option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
    */
    readonly objectUnavailableDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
    */
    readonly objectUnavailableIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
    */
    readonly objectUnavailableModifiedPath?: string;
    /**
    * Enabling this allows you to modify the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
    */
    readonly objectUnavailableModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies either the `HTTP` or `HTTPS` protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
    */
    readonly objectUnavailableProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
    */
    readonly objectUnavailableRecovery?: string;
    /**
    * Specifies a redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
    */
    readonly objectUnavailableRedirectMethod?: number;
    /**
    * Specifies the set of response codes identifying when there are content errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
    */
    readonly objectUnavailableResponseCodes?: string[];
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
    */
    readonly objectUnavailableRetryLimit?: string;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
    */
    readonly originUnavailableAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
    */
    readonly originUnavailableBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
    */
    readonly originUnavailableBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
    */
    readonly originUnavailableBlacklistWindow?: string;
    /**
    * Modifies the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
    */
    readonly originUnavailableChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify `RESPONSE_CODES`, the only available option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
    */
    readonly originUnavailableDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
    */
    readonly originUnavailableIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
    */
    readonly originUnavailableModifiedPath?: string;
    /**
    * Modifies the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
    */
    readonly originUnavailableModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies either the `HTTP` or `HTTPS` protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
    */
    readonly originUnavailableProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
    */
    readonly originUnavailableRecovery?: string;
    /**
    * Specifies either a redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
    */
    readonly originUnavailableRedirectMethod?: number;
    /**
    * Specifies the set of response codes identifying when the origin responds with errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
    */
    readonly originUnavailableResponseCodes?: string[];
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
    */
    readonly originUnavailableRetryLimit?: string;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
    */
    readonly originUnresponsiveAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
    */
    readonly originUnresponsiveBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
    */
    readonly originUnresponsiveBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
    */
    readonly originUnresponsiveBlacklistWindow?: string;
    /**
    * This allows you to change the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
    */
    readonly originUnresponsiveChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify the level of response to slow origin connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
    */
    readonly originUnresponsiveDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
    */
    readonly originUnresponsiveIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
    */
    readonly originUnresponsiveModifiedPath?: string;
    /**
    * Modifies the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
    */
    readonly originUnresponsiveModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies which protocol to use.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
    */
    readonly originUnresponsiveProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
    */
    readonly originUnresponsiveRecovery?: string;
    /**
    * Specifies the redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
    */
    readonly originUnresponsiveRedirectMethod?: number;
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
    */
    readonly originUnresponsiveRetryLimit?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
    */
    readonly otherOptions?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover | undefined);
    private _cacheErrorResponse?;
    get cacheErrorResponse(): boolean | cdktf.IResolvable;
    set cacheErrorResponse(value: boolean | cdktf.IResolvable);
    resetCacheErrorResponse(): void;
    get cacheErrorResponseInput(): boolean | cdktf.IResolvable | undefined;
    private _cacheWindow?;
    get cacheWindow(): string;
    set cacheWindow(value: string);
    resetCacheWindow(): void;
    get cacheWindowInput(): string | undefined;
    private _clientResponseCode?;
    get clientResponseCode(): string;
    set clientResponseCode(value: string);
    resetClientResponseCode(): void;
    get clientResponseCodeInput(): string | undefined;
    private _detectObjectUnavailable?;
    get detectObjectUnavailable(): boolean | cdktf.IResolvable;
    set detectObjectUnavailable(value: boolean | cdktf.IResolvable);
    resetDetectObjectUnavailable(): void;
    get detectObjectUnavailableInput(): boolean | cdktf.IResolvable | undefined;
    private _detectObjectUnavailableTitle?;
    get detectObjectUnavailableTitle(): string;
    set detectObjectUnavailableTitle(value: string);
    resetDetectObjectUnavailableTitle(): void;
    get detectObjectUnavailableTitleInput(): string | undefined;
    private _detectOriginUnavailable?;
    get detectOriginUnavailable(): boolean | cdktf.IResolvable;
    set detectOriginUnavailable(value: boolean | cdktf.IResolvable);
    resetDetectOriginUnavailable(): void;
    get detectOriginUnavailableInput(): boolean | cdktf.IResolvable | undefined;
    private _detectOriginUnavailableTitle?;
    get detectOriginUnavailableTitle(): string;
    set detectOriginUnavailableTitle(value: string);
    resetDetectOriginUnavailableTitle(): void;
    get detectOriginUnavailableTitleInput(): string | undefined;
    private _detectOriginUnresponsive?;
    get detectOriginUnresponsive(): boolean | cdktf.IResolvable;
    set detectOriginUnresponsive(value: boolean | cdktf.IResolvable);
    resetDetectOriginUnresponsive(): void;
    get detectOriginUnresponsiveInput(): boolean | cdktf.IResolvable | undefined;
    private _detectOriginUnresponsiveTitle?;
    get detectOriginUnresponsiveTitle(): string;
    set detectOriginUnresponsiveTitle(value: string);
    resetDetectOriginUnresponsiveTitle(): void;
    get detectOriginUnresponsiveTitleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableAlternateHost?;
    get objectUnavailableAlternateHost(): string;
    set objectUnavailableAlternateHost(value: string);
    resetObjectUnavailableAlternateHost(): void;
    get objectUnavailableAlternateHostInput(): string | undefined;
    private _objectUnavailableBackupHost?;
    get objectUnavailableBackupHost(): string;
    set objectUnavailableBackupHost(value: string);
    resetObjectUnavailableBackupHost(): void;
    get objectUnavailableBackupHostInput(): string | undefined;
    private _objectUnavailableBlacklistOriginIp?;
    get objectUnavailableBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set objectUnavailableBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableBlacklistOriginIp(): void;
    get objectUnavailableBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableBlacklistWindow?;
    get objectUnavailableBlacklistWindow(): string;
    set objectUnavailableBlacklistWindow(value: string);
    resetObjectUnavailableBlacklistWindow(): void;
    get objectUnavailableBlacklistWindowInput(): string | undefined;
    private _objectUnavailableChangeProtocol?;
    get objectUnavailableChangeProtocol(): boolean | cdktf.IResolvable;
    set objectUnavailableChangeProtocol(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableChangeProtocol(): void;
    get objectUnavailableChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableDetectionLevel?;
    get objectUnavailableDetectionLevel(): string;
    set objectUnavailableDetectionLevel(value: string);
    resetObjectUnavailableDetectionLevel(): void;
    get objectUnavailableDetectionLevelInput(): string | undefined;
    private _objectUnavailableIncludeQueryString?;
    get objectUnavailableIncludeQueryString(): boolean | cdktf.IResolvable;
    set objectUnavailableIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableIncludeQueryString(): void;
    get objectUnavailableIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableModifiedPath?;
    get objectUnavailableModifiedPath(): string;
    set objectUnavailableModifiedPath(value: string);
    resetObjectUnavailableModifiedPath(): void;
    get objectUnavailableModifiedPathInput(): string | undefined;
    private _objectUnavailableModifyRequestPath?;
    get objectUnavailableModifyRequestPath(): boolean | cdktf.IResolvable;
    set objectUnavailableModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableModifyRequestPath(): void;
    get objectUnavailableModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableProtocol?;
    get objectUnavailableProtocol(): string;
    set objectUnavailableProtocol(value: string);
    resetObjectUnavailableProtocol(): void;
    get objectUnavailableProtocolInput(): string | undefined;
    private _objectUnavailableRecovery?;
    get objectUnavailableRecovery(): string;
    set objectUnavailableRecovery(value: string);
    resetObjectUnavailableRecovery(): void;
    get objectUnavailableRecoveryInput(): string | undefined;
    private _objectUnavailableRedirectMethod?;
    get objectUnavailableRedirectMethod(): number;
    set objectUnavailableRedirectMethod(value: number);
    resetObjectUnavailableRedirectMethod(): void;
    get objectUnavailableRedirectMethodInput(): number | undefined;
    private _objectUnavailableResponseCodes?;
    get objectUnavailableResponseCodes(): string[];
    set objectUnavailableResponseCodes(value: string[]);
    resetObjectUnavailableResponseCodes(): void;
    get objectUnavailableResponseCodesInput(): string[] | undefined;
    private _objectUnavailableRetryLimit?;
    get objectUnavailableRetryLimit(): string;
    set objectUnavailableRetryLimit(value: string);
    resetObjectUnavailableRetryLimit(): void;
    get objectUnavailableRetryLimitInput(): string | undefined;
    private _originUnavailableAlternateHost?;
    get originUnavailableAlternateHost(): string;
    set originUnavailableAlternateHost(value: string);
    resetOriginUnavailableAlternateHost(): void;
    get originUnavailableAlternateHostInput(): string | undefined;
    private _originUnavailableBackupHost?;
    get originUnavailableBackupHost(): string;
    set originUnavailableBackupHost(value: string);
    resetOriginUnavailableBackupHost(): void;
    get originUnavailableBackupHostInput(): string | undefined;
    private _originUnavailableBlacklistOriginIp?;
    get originUnavailableBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set originUnavailableBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableBlacklistOriginIp(): void;
    get originUnavailableBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableBlacklistWindow?;
    get originUnavailableBlacklistWindow(): string;
    set originUnavailableBlacklistWindow(value: string);
    resetOriginUnavailableBlacklistWindow(): void;
    get originUnavailableBlacklistWindowInput(): string | undefined;
    private _originUnavailableChangeProtocol?;
    get originUnavailableChangeProtocol(): boolean | cdktf.IResolvable;
    set originUnavailableChangeProtocol(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableChangeProtocol(): void;
    get originUnavailableChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableDetectionLevel?;
    get originUnavailableDetectionLevel(): string;
    set originUnavailableDetectionLevel(value: string);
    resetOriginUnavailableDetectionLevel(): void;
    get originUnavailableDetectionLevelInput(): string | undefined;
    private _originUnavailableIncludeQueryString?;
    get originUnavailableIncludeQueryString(): boolean | cdktf.IResolvable;
    set originUnavailableIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableIncludeQueryString(): void;
    get originUnavailableIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableModifiedPath?;
    get originUnavailableModifiedPath(): string;
    set originUnavailableModifiedPath(value: string);
    resetOriginUnavailableModifiedPath(): void;
    get originUnavailableModifiedPathInput(): string | undefined;
    private _originUnavailableModifyRequestPath?;
    get originUnavailableModifyRequestPath(): boolean | cdktf.IResolvable;
    set originUnavailableModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableModifyRequestPath(): void;
    get originUnavailableModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableProtocol?;
    get originUnavailableProtocol(): string;
    set originUnavailableProtocol(value: string);
    resetOriginUnavailableProtocol(): void;
    get originUnavailableProtocolInput(): string | undefined;
    private _originUnavailableRecovery?;
    get originUnavailableRecovery(): string;
    set originUnavailableRecovery(value: string);
    resetOriginUnavailableRecovery(): void;
    get originUnavailableRecoveryInput(): string | undefined;
    private _originUnavailableRedirectMethod?;
    get originUnavailableRedirectMethod(): number;
    set originUnavailableRedirectMethod(value: number);
    resetOriginUnavailableRedirectMethod(): void;
    get originUnavailableRedirectMethodInput(): number | undefined;
    private _originUnavailableResponseCodes?;
    get originUnavailableResponseCodes(): string[];
    set originUnavailableResponseCodes(value: string[]);
    resetOriginUnavailableResponseCodes(): void;
    get originUnavailableResponseCodesInput(): string[] | undefined;
    private _originUnavailableRetryLimit?;
    get originUnavailableRetryLimit(): string;
    set originUnavailableRetryLimit(value: string);
    resetOriginUnavailableRetryLimit(): void;
    get originUnavailableRetryLimitInput(): string | undefined;
    private _originUnresponsiveAlternateHost?;
    get originUnresponsiveAlternateHost(): string;
    set originUnresponsiveAlternateHost(value: string);
    resetOriginUnresponsiveAlternateHost(): void;
    get originUnresponsiveAlternateHostInput(): string | undefined;
    private _originUnresponsiveBackupHost?;
    get originUnresponsiveBackupHost(): string;
    set originUnresponsiveBackupHost(value: string);
    resetOriginUnresponsiveBackupHost(): void;
    get originUnresponsiveBackupHostInput(): string | undefined;
    private _originUnresponsiveBlacklistOriginIp?;
    get originUnresponsiveBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set originUnresponsiveBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveBlacklistOriginIp(): void;
    get originUnresponsiveBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveBlacklistWindow?;
    get originUnresponsiveBlacklistWindow(): string;
    set originUnresponsiveBlacklistWindow(value: string);
    resetOriginUnresponsiveBlacklistWindow(): void;
    get originUnresponsiveBlacklistWindowInput(): string | undefined;
    private _originUnresponsiveChangeProtocol?;
    get originUnresponsiveChangeProtocol(): boolean | cdktf.IResolvable;
    set originUnresponsiveChangeProtocol(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveChangeProtocol(): void;
    get originUnresponsiveChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveDetectionLevel?;
    get originUnresponsiveDetectionLevel(): string;
    set originUnresponsiveDetectionLevel(value: string);
    resetOriginUnresponsiveDetectionLevel(): void;
    get originUnresponsiveDetectionLevelInput(): string | undefined;
    private _originUnresponsiveIncludeQueryString?;
    get originUnresponsiveIncludeQueryString(): boolean | cdktf.IResolvable;
    set originUnresponsiveIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveIncludeQueryString(): void;
    get originUnresponsiveIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveModifiedPath?;
    get originUnresponsiveModifiedPath(): string;
    set originUnresponsiveModifiedPath(value: string);
    resetOriginUnresponsiveModifiedPath(): void;
    get originUnresponsiveModifiedPathInput(): string | undefined;
    private _originUnresponsiveModifyRequestPath?;
    get originUnresponsiveModifyRequestPath(): boolean | cdktf.IResolvable;
    set originUnresponsiveModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveModifyRequestPath(): void;
    get originUnresponsiveModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveProtocol?;
    get originUnresponsiveProtocol(): string;
    set originUnresponsiveProtocol(value: string);
    resetOriginUnresponsiveProtocol(): void;
    get originUnresponsiveProtocolInput(): string | undefined;
    private _originUnresponsiveRecovery?;
    get originUnresponsiveRecovery(): string;
    set originUnresponsiveRecovery(value: string);
    resetOriginUnresponsiveRecovery(): void;
    get originUnresponsiveRecoveryInput(): string | undefined;
    private _originUnresponsiveRedirectMethod?;
    get originUnresponsiveRedirectMethod(): number;
    set originUnresponsiveRedirectMethod(value: number);
    resetOriginUnresponsiveRedirectMethod(): void;
    get originUnresponsiveRedirectMethodInput(): number | undefined;
    private _originUnresponsiveRetryLimit?;
    get originUnresponsiveRetryLimit(): string;
    set originUnresponsiveRetryLimit(value: string);
    resetOriginUnresponsiveRetryLimit(): void;
    get originUnresponsiveRetryLimitInput(): string | undefined;
    private _otherOptions?;
    get otherOptions(): string;
    set otherOptions(value: string);
    resetOtherOptions(): void;
    get otherOptionsInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching {
    /**
    * Enables metadata caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance {
    /**
    * Enables the Mobile App Performance SDK.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, sends secondary multi-path requests to the origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
    */
    readonly secondaryMultipathToOrigin?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _secondaryMultipathToOrigin?;
    get secondaryMultipathToOrigin(): boolean | cdktf.IResolvable;
    set secondaryMultipathToOrigin(value: boolean | cdktf.IResolvable);
    resetSecondaryMultipathToOrigin(): void;
    get secondaryMultipathToOriginInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader {
    /**
    * Either `ADD`, `DELETE`, `MODIFY`, or `PASS` incoming HTTP request headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
    */
    readonly action?: string;
    /**
    * When enabled with the `action` set to `MODIFY`, prevents creation of more than one instance of a header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
    */
    readonly avoidDuplicateHeaders?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom field name that applies when the relevant `standard` header name is set to `OTHER`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
    */
    readonly customHeaderName?: string;
    /**
    * Specifies the new header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
    */
    readonly headerValue?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Supplies an HTTP header replacement value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
    */
    readonly newHeaderValue?: string;
    /**
    * If the value of `action` is `ADD`, this specifies the name of the field to add.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
    */
    readonly standardAddHeaderName?: string;
    /**
    * If the value of `action` is `DELETE`, this specifies the name of the field to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
    */
    readonly standardDeleteHeaderName?: string;
    /**
    * If the value of `action` is `MODIFY`, this specifies the name of the field to modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
    */
    readonly standardModifyHeaderName?: string;
    /**
    * If the value of `action` is `PASS`, this specifies the name of the field to pass through.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
    */
    readonly standardPassHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _avoidDuplicateHeaders?;
    get avoidDuplicateHeaders(): boolean | cdktf.IResolvable;
    set avoidDuplicateHeaders(value: boolean | cdktf.IResolvable);
    resetAvoidDuplicateHeaders(): void;
    get avoidDuplicateHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _customHeaderName?;
    get customHeaderName(): string;
    set customHeaderName(value: string);
    resetCustomHeaderName(): void;
    get customHeaderNameInput(): string | undefined;
    private _headerValue?;
    get headerValue(): string;
    set headerValue(value: string);
    resetHeaderValue(): void;
    get headerValueInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _newHeaderValue?;
    get newHeaderValue(): string;
    set newHeaderValue(value: string);
    resetNewHeaderValue(): void;
    get newHeaderValueInput(): string | undefined;
    private _standardAddHeaderName?;
    get standardAddHeaderName(): string;
    set standardAddHeaderName(value: string);
    resetStandardAddHeaderName(): void;
    get standardAddHeaderNameInput(): string | undefined;
    private _standardDeleteHeaderName?;
    get standardDeleteHeaderName(): string;
    set standardDeleteHeaderName(value: string);
    resetStandardDeleteHeaderName(): void;
    get standardDeleteHeaderNameInput(): string | undefined;
    private _standardModifyHeaderName?;
    get standardModifyHeaderName(): string;
    set standardModifyHeaderName(value: string);
    resetStandardModifyHeaderName(): void;
    get standardModifyHeaderNameInput(): string | undefined;
    private _standardPassHeaderName?;
    get standardPassHeaderName(): string;
    set standardPassHeaderName(value: string);
    resetStandardPassHeaderName(): void;
    get standardPassHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader {
    /**
    * Either `ADD`, `DELETE`, `MODIFY`, or `PASS` incoming HTTP response headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
    */
    readonly action?: string;
    /**
    * When enabled with the `action` set to `MODIFY`, prevents creation of more than one instance of a header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
    */
    readonly avoidDuplicateHeaders?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom field name that applies when the relevant `standard` header name is set to `OTHER`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
    */
    readonly customHeaderName?: string;
    /**
    * Specifies the header's new value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
    */
    readonly headerValue?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies an HTTP header replacement value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
    */
    readonly newHeaderValue?: string;
    /**
    * If the value of `action` is `ADD`, this specifies the name of the field to add.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
    */
    readonly standardAddHeaderName?: string;
    /**
    * If the value of `action` is `DELETE`, this specifies the name of the field to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
    */
    readonly standardDeleteHeaderName?: string;
    /**
    * If the value of `action` is `MODIFY`, this specifies the name of the field to modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
    */
    readonly standardModifyHeaderName?: string;
    /**
    * If the value of `action` is `PASS`, this specifies the name of the field to pass through.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
    */
    readonly standardPassHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _avoidDuplicateHeaders?;
    get avoidDuplicateHeaders(): boolean | cdktf.IResolvable;
    set avoidDuplicateHeaders(value: boolean | cdktf.IResolvable);
    resetAvoidDuplicateHeaders(): void;
    get avoidDuplicateHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _customHeaderName?;
    get customHeaderName(): string;
    set customHeaderName(value: string);
    resetCustomHeaderName(): void;
    get customHeaderNameInput(): string | undefined;
    private _headerValue?;
    get headerValue(): string;
    set headerValue(value: string);
    resetHeaderValue(): void;
    get headerValueInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _newHeaderValue?;
    get newHeaderValue(): string;
    set newHeaderValue(value: string);
    resetNewHeaderValue(): void;
    get newHeaderValueInput(): string | undefined;
    private _standardAddHeaderName?;
    get standardAddHeaderName(): string;
    set standardAddHeaderName(value: string);
    resetStandardAddHeaderName(): void;
    get standardAddHeaderNameInput(): string | undefined;
    private _standardDeleteHeaderName?;
    get standardDeleteHeaderName(): string;
    set standardDeleteHeaderName(value: string);
    resetStandardDeleteHeaderName(): void;
    get standardDeleteHeaderNameInput(): string | undefined;
    private _standardModifyHeaderName?;
    get standardModifyHeaderName(): string;
    set standardModifyHeaderName(value: string);
    resetStandardModifyHeaderName(): void;
    get standardModifyHeaderNameInput(): string | undefined;
    private _standardPassHeaderName?;
    get standardPassHeaderName(): string;
    set standardPassHeaderName(value: string);
    resetStandardPassHeaderName(): void;
    get standardPassHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader {
    /**
    * Either `ADD` or `DELETE` outgoing HTTP request headers, `MODIFY` their fixed values, or specify a `REGEX` pattern to transform them.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
    */
    readonly action?: string;
    /**
    * When enabled with the `action` set to `MODIFY`, prevents creation of more than one instance of a header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
    */
    readonly avoidDuplicateHeaders?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom field name that applies when the relevant `standard` header name is set to `OTHER`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
    */
    readonly customHeaderName?: string;
    /**
    * Specifies the new header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
    */
    readonly headerValue?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled with the `action` set to `REGEX`, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
    */
    readonly matchMultiple?: boolean | cdktf.IResolvable;
    /**
    * Specifies an HTTP header replacement value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
    */
    readonly newHeaderValue?: string;
    /**
    * Specifies a Perl-compatible regular expression to match within the header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
    */
    readonly regexHeaderMatch?: string;
    /**
    * Specifies text that replaces the `regexHeaderMatch` pattern within the header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
    */
    readonly regexHeaderReplace?: string;
    /**
    * If the value of `action` is `ADD`, this specifies the name of the field to add.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
    */
    readonly standardAddHeaderName?: string;
    /**
    * If the value of `action` is `DELETE`, this specifies the name of the field to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
    */
    readonly standardDeleteHeaderName?: string;
    /**
    * If the value of `action` is `MODIFY` or `REGEX`, this specifies the name of the field to modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
    */
    readonly standardModifyHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _avoidDuplicateHeaders?;
    get avoidDuplicateHeaders(): boolean | cdktf.IResolvable;
    set avoidDuplicateHeaders(value: boolean | cdktf.IResolvable);
    resetAvoidDuplicateHeaders(): void;
    get avoidDuplicateHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _customHeaderName?;
    get customHeaderName(): string;
    set customHeaderName(value: string);
    resetCustomHeaderName(): void;
    get customHeaderNameInput(): string | undefined;
    private _headerValue?;
    get headerValue(): string;
    set headerValue(value: string);
    resetHeaderValue(): void;
    get headerValueInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _matchMultiple?;
    get matchMultiple(): boolean | cdktf.IResolvable;
    set matchMultiple(value: boolean | cdktf.IResolvable);
    resetMatchMultiple(): void;
    get matchMultipleInput(): boolean | cdktf.IResolvable | undefined;
    private _newHeaderValue?;
    get newHeaderValue(): string;
    set newHeaderValue(value: string);
    resetNewHeaderValue(): void;
    get newHeaderValueInput(): string | undefined;
    private _regexHeaderMatch?;
    get regexHeaderMatch(): string;
    set regexHeaderMatch(value: string);
    resetRegexHeaderMatch(): void;
    get regexHeaderMatchInput(): string | undefined;
    private _regexHeaderReplace?;
    get regexHeaderReplace(): string;
    set regexHeaderReplace(value: string);
    resetRegexHeaderReplace(): void;
    get regexHeaderReplaceInput(): string | undefined;
    private _standardAddHeaderName?;
    get standardAddHeaderName(): string;
    set standardAddHeaderName(value: string);
    resetStandardAddHeaderName(): void;
    get standardAddHeaderNameInput(): string | undefined;
    private _standardDeleteHeaderName?;
    get standardDeleteHeaderName(): string;
    set standardDeleteHeaderName(value: string);
    resetStandardDeleteHeaderName(): void;
    get standardDeleteHeaderNameInput(): string | undefined;
    private _standardModifyHeaderName?;
    get standardModifyHeaderName(): string;
    set standardModifyHeaderName(value: string);
    resetStandardModifyHeaderName(): void;
    get standardModifyHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader {
    /**
    * Either `ADD` or `DELETE` outgoing HTTP response headers, `MODIFY` their fixed values, or specify a `REGEX` pattern to transform them.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
    */
    readonly action?: string;
    /**
    * When enabled with the `action` set to `MODIFY`, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
    */
    readonly avoidDuplicateHeaders?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom field name that applies when the relevant `standard` header name is set to `OTHER`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
    */
    readonly customHeaderName?: string;
    /**
    * Specifies the existing value of the header to match.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
    */
    readonly headerValue?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled with the `action` set to `REGEX`, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
    */
    readonly matchMultiple?: boolean | cdktf.IResolvable;
    /**
    * Specifies the new HTTP header replacement value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
    */
    readonly newHeaderValue?: string;
    /**
    * Specifies a Perl-compatible regular expression to match within the header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
    */
    readonly regexHeaderMatch?: string;
    /**
    * Specifies text that replaces the `regexHeaderMatch` pattern within the header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
    */
    readonly regexHeaderReplace?: string;
    /**
    * If the value of `action` is `ADD`, this specifies the name of the field to add.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
    */
    readonly standardAddHeaderName?: string;
    /**
    * If the value of `action` is `DELETE`, this specifies the name of the field to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
    */
    readonly standardDeleteHeaderName?: string;
    /**
    * If the value of `action` is `MODIFY` or `REGEX`, this specifies the name of the field to modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
    */
    readonly standardModifyHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _avoidDuplicateHeaders?;
    get avoidDuplicateHeaders(): boolean | cdktf.IResolvable;
    set avoidDuplicateHeaders(value: boolean | cdktf.IResolvable);
    resetAvoidDuplicateHeaders(): void;
    get avoidDuplicateHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _customHeaderName?;
    get customHeaderName(): string;
    set customHeaderName(value: string);
    resetCustomHeaderName(): void;
    get customHeaderNameInput(): string | undefined;
    private _headerValue?;
    get headerValue(): string;
    set headerValue(value: string);
    resetHeaderValue(): void;
    get headerValueInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _matchMultiple?;
    get matchMultiple(): boolean | cdktf.IResolvable;
    set matchMultiple(value: boolean | cdktf.IResolvable);
    resetMatchMultiple(): void;
    get matchMultipleInput(): boolean | cdktf.IResolvable | undefined;
    private _newHeaderValue?;
    get newHeaderValue(): string;
    set newHeaderValue(value: string);
    resetNewHeaderValue(): void;
    get newHeaderValueInput(): string | undefined;
    private _regexHeaderMatch?;
    get regexHeaderMatch(): string;
    set regexHeaderMatch(value: string);
    resetRegexHeaderMatch(): void;
    get regexHeaderMatchInput(): string | undefined;
    private _regexHeaderReplace?;
    get regexHeaderReplace(): string;
    set regexHeaderReplace(value: string);
    resetRegexHeaderReplace(): void;
    get regexHeaderReplaceInput(): string | undefined;
    private _standardAddHeaderName?;
    get standardAddHeaderName(): string;
    set standardAddHeaderName(value: string);
    resetStandardAddHeaderName(): void;
    get standardAddHeaderNameInput(): string | undefined;
    private _standardDeleteHeaderName?;
    get standardDeleteHeaderName(): string;
    set standardDeleteHeaderName(value: string);
    resetStandardDeleteHeaderName(): void;
    get standardDeleteHeaderNameInput(): string | undefined;
    private _standardModifyHeaderName?;
    get standardModifyHeaderName(): string;
    set standardModifyHeaderName(value: string);
    resetStandardModifyHeaderName(): void;
    get standardModifyHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader {
    /**
    * Enables `Via` header modifications.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify how you want to handle the header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
    */
    readonly modificationOption?: string;
    /**
    * Specifies a new name to replace the existing `Via` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
    */
    readonly renameHeaderTo?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _modificationOption?;
    get modificationOption(): string;
    set modificationOption(value: string);
    resetModificationOption(): void;
    get modificationOptionInput(): string | undefined;
    private _renameHeaderTo?;
    get renameHeaderTo(): string;
    set renameHeaderTo(value: string);
    resetRenameHeaderTo(): void;
    get renameHeaderToInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}
    */
    readonly c?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}
    */
    readonly cn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}
    */
    readonly o?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}
    */
    readonly ou?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns | undefined);
    private _c?;
    get c(): string;
    set c(value: string);
    resetC(): void;
    get cInput(): string | undefined;
    private _cn?;
    get cn(): string;
    set cn(value: string);
    resetCn(): void;
    get cnInput(): string | undefined;
    private _o?;
    get o(): string;
    set o(value: string);
    resetO(): void;
    get oInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}
    */
    readonly c?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}
    */
    readonly cn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}
    */
    readonly o?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}
    */
    readonly ou?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns | undefined);
    private _c?;
    get c(): string;
    set c(value: string);
    resetC(): void;
    get cInput(): string | undefined;
    private _cn?;
    get cn(): string;
    set cn(value: string);
    resetCn(): void;
    get cnInput(): string | undefined;
    private _o?;
    get o(): string;
    set o(value: string);
    resetO(): void;
    get oInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}
    */
    readonly canBeCa?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}
    */
    readonly canBeLeaf?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}
    */
    readonly notAfter?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}
    */
    readonly notBefore?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}
    */
    readonly pemEncodedCert?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}
    */
    readonly publicKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}
    */
    readonly publicKeyAlgorithm?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}
    */
    readonly publicKeyFormat?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}
    */
    readonly selfSigned?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}
    */
    readonly serialNumber?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}
    */
    readonly sha1Fingerprint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}
    */
    readonly sigAlgName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}
    */
    readonly subjectAlternativeNames?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}
    */
    readonly subjectCn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}
    */
    readonly version?: number;
    /**
    * issuer_rdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
    */
    readonly issuerRdns?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns;
    /**
    * subject_rdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
    */
    readonly subjectRdns?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities | cdktf.IResolvable | undefined);
    private _canBeCa?;
    get canBeCa(): boolean | cdktf.IResolvable;
    set canBeCa(value: boolean | cdktf.IResolvable);
    resetCanBeCa(): void;
    get canBeCaInput(): boolean | cdktf.IResolvable | undefined;
    private _canBeLeaf?;
    get canBeLeaf(): boolean | cdktf.IResolvable;
    set canBeLeaf(value: boolean | cdktf.IResolvable);
    resetCanBeLeaf(): void;
    get canBeLeafInput(): boolean | cdktf.IResolvable | undefined;
    private _notAfter?;
    get notAfter(): number;
    set notAfter(value: number);
    resetNotAfter(): void;
    get notAfterInput(): number | undefined;
    private _notBefore?;
    get notBefore(): number;
    set notBefore(value: number);
    resetNotBefore(): void;
    get notBeforeInput(): number | undefined;
    private _pemEncodedCert?;
    get pemEncodedCert(): string;
    set pemEncodedCert(value: string);
    resetPemEncodedCert(): void;
    get pemEncodedCertInput(): string | undefined;
    private _publicKey?;
    get publicKey(): string;
    set publicKey(value: string);
    resetPublicKey(): void;
    get publicKeyInput(): string | undefined;
    private _publicKeyAlgorithm?;
    get publicKeyAlgorithm(): string;
    set publicKeyAlgorithm(value: string);
    resetPublicKeyAlgorithm(): void;
    get publicKeyAlgorithmInput(): string | undefined;
    private _publicKeyFormat?;
    get publicKeyFormat(): string;
    set publicKeyFormat(value: string);
    resetPublicKeyFormat(): void;
    get publicKeyFormatInput(): string | undefined;
    private _selfSigned?;
    get selfSigned(): boolean | cdktf.IResolvable;
    set selfSigned(value: boolean | cdktf.IResolvable);
    resetSelfSigned(): void;
    get selfSignedInput(): boolean | cdktf.IResolvable | undefined;
    private _serialNumber?;
    get serialNumber(): string;
    set serialNumber(value: string);
    resetSerialNumber(): void;
    get serialNumberInput(): string | undefined;
    private _sha1Fingerprint?;
    get sha1Fingerprint(): string;
    set sha1Fingerprint(value: string);
    resetSha1Fingerprint(): void;
    get sha1FingerprintInput(): string | undefined;
    private _sigAlgName?;
    get sigAlgName(): string;
    set sigAlgName(value: string);
    resetSigAlgName(): void;
    get sigAlgNameInput(): string | undefined;
    private _subjectAlternativeNames?;
    get subjectAlternativeNames(): string[];
    set subjectAlternativeNames(value: string[]);
    resetSubjectAlternativeNames(): void;
    get subjectAlternativeNamesInput(): string[] | undefined;
    private _subjectCn?;
    get subjectCn(): string;
    set subjectCn(value: string);
    resetSubjectCn(): void;
    get subjectCnInput(): string | undefined;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    private _issuerRdns;
    get issuerRdns(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference;
    putIssuerRdns(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns): void;
    resetIssuerRdns(): void;
    get issuerRdnsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns | undefined;
    private _subjectRdns;
    get subjectRdns(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference;
    putSubjectRdns(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns): void;
    resetSubjectRdns(): void;
    get subjectRdnsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}
    */
    readonly c?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}
    */
    readonly cn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}
    */
    readonly o?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}
    */
    readonly ou?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns | undefined);
    private _c?;
    get c(): string;
    set c(value: string);
    resetC(): void;
    get cInput(): string | undefined;
    private _cn?;
    get cn(): string;
    set cn(value: string);
    resetCn(): void;
    get cnInput(): string | undefined;
    private _o?;
    get o(): string;
    set o(value: string);
    resetO(): void;
    get oInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}
    */
    readonly c?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}
    */
    readonly cn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}
    */
    readonly o?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}
    */
    readonly ou?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns | undefined);
    private _c?;
    get c(): string;
    set c(value: string);
    resetC(): void;
    get cInput(): string | undefined;
    private _cn?;
    get cn(): string;
    set cn(value: string);
    resetCn(): void;
    get cnInput(): string | undefined;
    private _o?;
    get o(): string;
    set o(value: string);
    resetO(): void;
    get oInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}
    */
    readonly canBeCa?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}
    */
    readonly canBeLeaf?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}
    */
    readonly notAfter?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}
    */
    readonly notBefore?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}
    */
    readonly pemEncodedCert?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}
    */
    readonly publicKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}
    */
    readonly publicKeyAlgorithm?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}
    */
    readonly publicKeyFormat?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}
    */
    readonly selfSigned?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}
    */
    readonly serialNumber?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}
    */
    readonly sha1Fingerprint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}
    */
    readonly sigAlgName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}
    */
    readonly subjectAlternativeNames?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}
    */
    readonly subjectCn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}
    */
    readonly version?: number;
    /**
    * issuer_rdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
    */
    readonly issuerRdns?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns;
    /**
    * subject_rdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
    */
    readonly subjectRdns?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates | cdktf.IResolvable | undefined);
    private _canBeCa?;
    get canBeCa(): boolean | cdktf.IResolvable;
    set canBeCa(value: boolean | cdktf.IResolvable);
    resetCanBeCa(): void;
    get canBeCaInput(): boolean | cdktf.IResolvable | undefined;
    private _canBeLeaf?;
    get canBeLeaf(): boolean | cdktf.IResolvable;
    set canBeLeaf(value: boolean | cdktf.IResolvable);
    resetCanBeLeaf(): void;
    get canBeLeafInput(): boolean | cdktf.IResolvable | undefined;
    private _notAfter?;
    get notAfter(): number;
    set notAfter(value: number);
    resetNotAfter(): void;
    get notAfterInput(): number | undefined;
    private _notBefore?;
    get notBefore(): number;
    set notBefore(value: number);
    resetNotBefore(): void;
    get notBeforeInput(): number | undefined;
    private _pemEncodedCert?;
    get pemEncodedCert(): string;
    set pemEncodedCert(value: string);
    resetPemEncodedCert(): void;
    get pemEncodedCertInput(): string | undefined;
    private _publicKey?;
    get publicKey(): string;
    set publicKey(value: string);
    resetPublicKey(): void;
    get publicKeyInput(): string | undefined;
    private _publicKeyAlgorithm?;
    get publicKeyAlgorithm(): string;
    set publicKeyAlgorithm(value: string);
    resetPublicKeyAlgorithm(): void;
    get publicKeyAlgorithmInput(): string | undefined;
    private _publicKeyFormat?;
    get publicKeyFormat(): string;
    set publicKeyFormat(value: string);
    resetPublicKeyFormat(): void;
    get publicKeyFormatInput(): string | undefined;
    private _selfSigned?;
    get selfSigned(): boolean | cdktf.IResolvable;
    set selfSigned(value: boolean | cdktf.IResolvable);
    resetSelfSigned(): void;
    get selfSignedInput(): boolean | cdktf.IResolvable | undefined;
    private _serialNumber?;
    get serialNumber(): string;
    set serialNumber(value: string);
    resetSerialNumber(): void;
    get serialNumberInput(): string | undefined;
    private _sha1Fingerprint?;
    get sha1Fingerprint(): string;
    set sha1Fingerprint(value: string);
    resetSha1Fingerprint(): void;
    get sha1FingerprintInput(): string | undefined;
    private _sigAlgName?;
    get sigAlgName(): string;
    set sigAlgName(value: string);
    resetSigAlgName(): void;
    get sigAlgNameInput(): string | undefined;
    private _subjectAlternativeNames?;
    get subjectAlternativeNames(): string[];
    set subjectAlternativeNames(value: string[]);
    resetSubjectAlternativeNames(): void;
    get subjectAlternativeNamesInput(): string[] | undefined;
    private _subjectCn?;
    get subjectCn(): string;
    set subjectCn(value: string);
    resetSubjectCn(): void;
    get subjectCnInput(): string | undefined;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    private _issuerRdns;
    get issuerRdns(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference;
    putIssuerRdns(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns): void;
    resetIssuerRdns(): void;
    get issuerRdnsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns | undefined;
    private _subjectRdns;
    get subjectRdns(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference;
    putSubjectRdns(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns): void;
    resetSubjectRdns(): void;
    get subjectRdnsInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}
    */
    readonly downloadDomainName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}
    */
    readonly g2OToken?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage | undefined);
    private _cpCode?;
    get cpCode(): number;
    set cpCode(value: number);
    resetCpCode(): void;
    get cpCodeInput(): number | undefined;
    private _downloadDomainName?;
    get downloadDomainName(): string;
    set downloadDomainName(value: string);
    resetDownloadDomainName(): void;
    get downloadDomainNameInput(): string | undefined;
    private _g2OToken?;
    get g2OToken(): string;
    set g2OToken(value: string);
    resetG2OToken(): void;
    get g2OTokenInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin {
    /**
    * Specifies the hostname to use when forming a cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
    */
    readonly cacheKeyHostname?: string;
    /**
    * Enables `gzip` compression for non-NetStorage origins.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
    */
    readonly compress?: boolean | cdktf.IResolvable;
    /**
    * This specifies the name of the custom host header the edge server should pass to the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
    */
    readonly customForwardHostHeader?: string;
    /**
    * Specifies values to look for in the origin certificate's `Subject Alternate Name` or `Common Name` fields. Specify `{{Origin Hostname}}` and `{{Forward Host Header}}` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line `variables`, which use the same curly-brace syntax.)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
    */
    readonly customValidCnValues?: string[];
    /**
    * When enabled on non-NetStorage origins, allows you to send a custom header (the `trueClientIpHeader`) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard `X-Forward-For` header, which proxies may modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
    */
    readonly enableTrueClientIp?: boolean | cdktf.IResolvable;
    /**
    * When the `originType` is set to either `CUSTOMER` or `SAAS_DYNAMIC_ORIGIN`, this specifies which `Host` header to pass to the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
    */
    readonly forwardHostHeader?: string;
    /**
    * Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily `80`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
    */
    readonly httpPort?: number;
    /**
    * Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily `443`. This option only applies if the property is marked as secure. See `Secure property requirements` for guidance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
    */
    readonly httpsPort?: number;
    /**
    * Specifies which IP version to use when getting content from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
    */
    readonly ipVersion?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This specifies the media's origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
    */
    readonly mslorigin?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
    */
    readonly originCertificate?: string;
    /**
    * Specifies which certificate to trust.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
    */
    readonly originCertsToHonor?: string;
    /**
    * Identifies the Edge Load Balancing origin. This needs to correspond to an `edgeLoadBalancingOrigin` behavior's `id` attribute within the same property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
    */
    readonly originId?: string;
    /**
    * For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the `verification settings in the Origin Server behavior` or contact your Akamai representative for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
    */
    readonly originSni?: boolean | cdktf.IResolvable;
    /**
    * Choose where your content is retrieved from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
    */
    readonly originType?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
    */
    readonly ports?: string;
    /**
    * Enabling this allows you to use a `CNAME chain` to determine the hostname for this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
    */
    readonly saasCnameEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the desired number of hostnames to use in the `CNAME chain`, starting backwards from the edge server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
    */
    readonly saasCnameLevel?: number;
    /**
    * Specifies the name of the cookie that identifies this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
    */
    readonly saasCookie?: string;
    /**
    * Specifies the name of the query parameter that identifies this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
    */
    readonly saasQueryString?: string;
    /**
    * Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
    */
    readonly saasRegex?: string;
    /**
    * Specifies replacement text for what `saasRegex` matches.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
    */
    readonly saasReplace?: string;
    /**
    * Specifies the static part of the SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
    */
    readonly saasSuffix?: string;
    /**
    * Specifies the part of the request that identifies this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
    */
    readonly saasType?: string;
    /**
    * Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
    */
    readonly secondHostname?: string;
    /**
    * Available only for certain products. This specifies whether you want to use an additional origin server address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
    */
    readonly secondHostnameEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}
    */
    readonly standardCertificateAuthorities?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * If a client sets the `True-Client-IP` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
    */
    readonly trueClientIpClientSetting?: boolean | cdktf.IResolvable;
    /**
    * This specifies the name of the field that identifies the end client's IP address, for example `True-Client-IP`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
    */
    readonly trueClientIpHeader?: string;
    /**
    * With a shared `hostname` such as provided by Amazon AWS, sets a unique cache key for your content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
    */
    readonly useUniqueCacheKey?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
    */
    readonly verificationMode?: string;
    /**
    * custom_certificate_authorities block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
    */
    readonly customCertificateAuthorities?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities[] | cdktf.IResolvable;
    /**
    * custom_certificates block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
    */
    readonly customCertificates?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates[] | cdktf.IResolvable;
    /**
    * net_storage block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
    */
    readonly netStorage?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin | undefined);
    private _cacheKeyHostname?;
    get cacheKeyHostname(): string;
    set cacheKeyHostname(value: string);
    resetCacheKeyHostname(): void;
    get cacheKeyHostnameInput(): string | undefined;
    private _compress?;
    get compress(): boolean | cdktf.IResolvable;
    set compress(value: boolean | cdktf.IResolvable);
    resetCompress(): void;
    get compressInput(): boolean | cdktf.IResolvable | undefined;
    private _customForwardHostHeader?;
    get customForwardHostHeader(): string;
    set customForwardHostHeader(value: string);
    resetCustomForwardHostHeader(): void;
    get customForwardHostHeaderInput(): string | undefined;
    private _customValidCnValues?;
    get customValidCnValues(): string[];
    set customValidCnValues(value: string[]);
    resetCustomValidCnValues(): void;
    get customValidCnValuesInput(): string[] | undefined;
    private _enableTrueClientIp?;
    get enableTrueClientIp(): boolean | cdktf.IResolvable;
    set enableTrueClientIp(value: boolean | cdktf.IResolvable);
    resetEnableTrueClientIp(): void;
    get enableTrueClientIpInput(): boolean | cdktf.IResolvable | undefined;
    private _forwardHostHeader?;
    get forwardHostHeader(): string;
    set forwardHostHeader(value: string);
    resetForwardHostHeader(): void;
    get forwardHostHeaderInput(): string | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _httpPort?;
    get httpPort(): number;
    set httpPort(value: number);
    resetHttpPort(): void;
    get httpPortInput(): number | undefined;
    private _httpsPort?;
    get httpsPort(): number;
    set httpsPort(value: number);
    resetHttpsPort(): void;
    get httpsPortInput(): number | undefined;
    private _ipVersion?;
    get ipVersion(): string;
    set ipVersion(value: string);
    resetIpVersion(): void;
    get ipVersionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mslorigin?;
    get mslorigin(): string;
    set mslorigin(value: string);
    resetMslorigin(): void;
    get msloriginInput(): string | undefined;
    private _originCertificate?;
    get originCertificate(): string;
    set originCertificate(value: string);
    resetOriginCertificate(): void;
    get originCertificateInput(): string | undefined;
    private _originCertsToHonor?;
    get originCertsToHonor(): string;
    set originCertsToHonor(value: string);
    resetOriginCertsToHonor(): void;
    get originCertsToHonorInput(): string | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _originSni?;
    get originSni(): boolean | cdktf.IResolvable;
    set originSni(value: boolean | cdktf.IResolvable);
    resetOriginSni(): void;
    get originSniInput(): boolean | cdktf.IResolvable | undefined;
    private _originType?;
    get originType(): string;
    set originType(value: string);
    resetOriginType(): void;
    get originTypeInput(): string | undefined;
    private _ports?;
    get ports(): string;
    set ports(value: string);
    resetPorts(): void;
    get portsInput(): string | undefined;
    private _saasCnameEnabled?;
    get saasCnameEnabled(): boolean | cdktf.IResolvable;
    set saasCnameEnabled(value: boolean | cdktf.IResolvable);
    resetSaasCnameEnabled(): void;
    get saasCnameEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _saasCnameLevel?;
    get saasCnameLevel(): number;
    set saasCnameLevel(value: number);
    resetSaasCnameLevel(): void;
    get saasCnameLevelInput(): number | undefined;
    private _saasCookie?;
    get saasCookie(): string;
    set saasCookie(value: string);
    resetSaasCookie(): void;
    get saasCookieInput(): string | undefined;
    private _saasQueryString?;
    get saasQueryString(): string;
    set saasQueryString(value: string);
    resetSaasQueryString(): void;
    get saasQueryStringInput(): string | undefined;
    private _saasRegex?;
    get saasRegex(): string;
    set saasRegex(value: string);
    resetSaasRegex(): void;
    get saasRegexInput(): string | undefined;
    private _saasReplace?;
    get saasReplace(): string;
    set saasReplace(value: string);
    resetSaasReplace(): void;
    get saasReplaceInput(): string | undefined;
    private _saasSuffix?;
    get saasSuffix(): string;
    set saasSuffix(value: string);
    resetSaasSuffix(): void;
    get saasSuffixInput(): string | undefined;
    private _saasType?;
    get saasType(): string;
    set saasType(value: string);
    resetSaasType(): void;
    get saasTypeInput(): string | undefined;
    private _secondHostname?;
    get secondHostname(): string;
    set secondHostname(value: string);
    resetSecondHostname(): void;
    get secondHostnameInput(): string | undefined;
    private _secondHostnameEnabled?;
    get secondHostnameEnabled(): boolean | cdktf.IResolvable;
    set secondHostnameEnabled(value: boolean | cdktf.IResolvable);
    resetSecondHostnameEnabled(): void;
    get secondHostnameEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _standardCertificateAuthorities?;
    get standardCertificateAuthorities(): string[];
    set standardCertificateAuthorities(value: string[]);
    resetStandardCertificateAuthorities(): void;
    get standardCertificateAuthoritiesInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trueClientIpClientSetting?;
    get trueClientIpClientSetting(): boolean | cdktf.IResolvable;
    set trueClientIpClientSetting(value: boolean | cdktf.IResolvable);
    resetTrueClientIpClientSetting(): void;
    get trueClientIpClientSettingInput(): boolean | cdktf.IResolvable | undefined;
    private _trueClientIpHeader?;
    get trueClientIpHeader(): string;
    set trueClientIpHeader(value: string);
    resetTrueClientIpHeader(): void;
    get trueClientIpHeaderInput(): string | undefined;
    private _useUniqueCacheKey?;
    get useUniqueCacheKey(): boolean | cdktf.IResolvable;
    set useUniqueCacheKey(value: boolean | cdktf.IResolvable);
    resetUseUniqueCacheKey(): void;
    get useUniqueCacheKeyInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _verificationMode?;
    get verificationMode(): string;
    set verificationMode(value: string);
    resetVerificationMode(): void;
    get verificationModeInput(): string | undefined;
    private _customCertificateAuthorities;
    get customCertificateAuthorities(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesList;
    putCustomCertificateAuthorities(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities[] | cdktf.IResolvable): void;
    resetCustomCertificateAuthorities(): void;
    get customCertificateAuthoritiesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities[] | undefined;
    private _customCertificates;
    get customCertificates(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesList;
    putCustomCertificates(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates[] | cdktf.IResolvable): void;
    resetCustomCertificates(): void;
    get customCertificatesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates[] | undefined;
    private _netStorage;
    get netStorage(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference;
    putNetStorage(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage): void;
    resetNetStorage(): void;
    get netStorageInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics {
    /**
    * Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
    */
    readonly accessKeyEncryptedStorage?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
    */
    readonly adcTitle?: string;
    /**
    * Specifies the authentication method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
    */
    readonly authenticationMethod?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
    */
    readonly authenticationMethodTitle?: string;
    /**
    * Specifies active access key ID linked to your AWS account.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
    */
    readonly awsAccessKeyId?: string;
    /**
    * Identifies the unique `awsAccessKeyVersionGuid` access key `created` in Cloud Access Manager to sign your requests to AWS S3.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
    */
    readonly awsAccessKeyVersionGuid?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}
    */
    readonly awsArRegion?: string;
    /**
    * This specifies the AWS hostname, without `http://` or `https://` prefixes. If you leave this option empty, it inherits the hostname from the `origin` behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
    */
    readonly awsHost?: string;
    /**
    * This specifies the AWS region code of the location where your bucket resides.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
    */
    readonly awsRegion?: string;
    /**
    * Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
    */
    readonly awsSecretAccessKey?: string;
    /**
    * This specifies the subdomain of your AWS service. It precedes `amazonaws.com` or the region code in the AWS hostname. For example, `s3.amazonaws.com`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
    */
    readonly awsService?: string;
    /**
    * Specifies the origin's geographic region.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
    */
    readonly country?: string;
    /**
    * Specifies the data to be encrypted as a series of enumerated variable names. See `Built-in system variables` for guidance on each.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
    */
    readonly customSignString?: string[];
    /**
    * Provides a region used by Akamai Direct Connection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
    */
    readonly directConnectGeo?: string;
    /**
    * Specifies the version of the encryption algorithm, an integer from `1` to `5`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
    */
    readonly encodingVersion?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}
    */
    readonly endPointService?: string;
    /**
    * Identifies the unique `gcsAccessKeyVersionGuid` access key `created` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
    */
    readonly gcsAccessKeyVersionGuid?: string;
    /**
    * Specifies the active access ID linked to your Google account.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
    */
    readonly gcsHmacKeyAccessId?: string;
    /**
    * Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
    */
    readonly gcsHmacKeySecret?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}
    */
    readonly hostnameTag?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the access key provided by the hosting service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
    */
    readonly mslkey?: string;
    /**
    * Specifies the origin name provided by the hosting service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
    */
    readonly mslname?: string;
    /**
    * Specifies the nonce.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
    */
    readonly nonce?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
    */
    readonly originLocationTitle?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}
    */
    readonly propertyIdTag?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}
    */
    readonly roleArn?: string;
    /**
    * Specifies the shared secret key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
    */
    readonly secretKey?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies whether to customize your signed string.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
    */
    readonly useCustomSignString?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics | undefined);
    private _accessKeyEncryptedStorage?;
    get accessKeyEncryptedStorage(): boolean | cdktf.IResolvable;
    set accessKeyEncryptedStorage(value: boolean | cdktf.IResolvable);
    resetAccessKeyEncryptedStorage(): void;
    get accessKeyEncryptedStorageInput(): boolean | cdktf.IResolvable | undefined;
    private _adcTitle?;
    get adcTitle(): string;
    set adcTitle(value: string);
    resetAdcTitle(): void;
    get adcTitleInput(): string | undefined;
    private _authenticationMethod?;
    get authenticationMethod(): string;
    set authenticationMethod(value: string);
    resetAuthenticationMethod(): void;
    get authenticationMethodInput(): string | undefined;
    private _authenticationMethodTitle?;
    get authenticationMethodTitle(): string;
    set authenticationMethodTitle(value: string);
    resetAuthenticationMethodTitle(): void;
    get authenticationMethodTitleInput(): string | undefined;
    private _awsAccessKeyId?;
    get awsAccessKeyId(): string;
    set awsAccessKeyId(value: string);
    resetAwsAccessKeyId(): void;
    get awsAccessKeyIdInput(): string | undefined;
    private _awsAccessKeyVersionGuid?;
    get awsAccessKeyVersionGuid(): string;
    set awsAccessKeyVersionGuid(value: string);
    resetAwsAccessKeyVersionGuid(): void;
    get awsAccessKeyVersionGuidInput(): string | undefined;
    private _awsArRegion?;
    get awsArRegion(): string;
    set awsArRegion(value: string);
    resetAwsArRegion(): void;
    get awsArRegionInput(): string | undefined;
    private _awsHost?;
    get awsHost(): string;
    set awsHost(value: string);
    resetAwsHost(): void;
    get awsHostInput(): string | undefined;
    private _awsRegion?;
    get awsRegion(): string;
    set awsRegion(value: string);
    resetAwsRegion(): void;
    get awsRegionInput(): string | undefined;
    private _awsSecretAccessKey?;
    get awsSecretAccessKey(): string;
    set awsSecretAccessKey(value: string);
    resetAwsSecretAccessKey(): void;
    get awsSecretAccessKeyInput(): string | undefined;
    private _awsService?;
    get awsService(): string;
    set awsService(value: string);
    resetAwsService(): void;
    get awsServiceInput(): string | undefined;
    private _country?;
    get country(): string;
    set country(value: string);
    resetCountry(): void;
    get countryInput(): string | undefined;
    private _customSignString?;
    get customSignString(): string[];
    set customSignString(value: string[]);
    resetCustomSignString(): void;
    get customSignStringInput(): string[] | undefined;
    private _directConnectGeo?;
    get directConnectGeo(): string;
    set directConnectGeo(value: string);
    resetDirectConnectGeo(): void;
    get directConnectGeoInput(): string | undefined;
    private _encodingVersion?;
    get encodingVersion(): number;
    set encodingVersion(value: number);
    resetEncodingVersion(): void;
    get encodingVersionInput(): number | undefined;
    private _endPointService?;
    get endPointService(): string;
    set endPointService(value: string);
    resetEndPointService(): void;
    get endPointServiceInput(): string | undefined;
    private _gcsAccessKeyVersionGuid?;
    get gcsAccessKeyVersionGuid(): string;
    set gcsAccessKeyVersionGuid(value: string);
    resetGcsAccessKeyVersionGuid(): void;
    get gcsAccessKeyVersionGuidInput(): string | undefined;
    private _gcsHmacKeyAccessId?;
    get gcsHmacKeyAccessId(): string;
    set gcsHmacKeyAccessId(value: string);
    resetGcsHmacKeyAccessId(): void;
    get gcsHmacKeyAccessIdInput(): string | undefined;
    private _gcsHmacKeySecret?;
    get gcsHmacKeySecret(): string;
    set gcsHmacKeySecret(value: string);
    resetGcsHmacKeySecret(): void;
    get gcsHmacKeySecretInput(): string | undefined;
    private _hostnameTag?;
    get hostnameTag(): boolean | cdktf.IResolvable;
    set hostnameTag(value: boolean | cdktf.IResolvable);
    resetHostnameTag(): void;
    get hostnameTagInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mslkey?;
    get mslkey(): string;
    set mslkey(value: string);
    resetMslkey(): void;
    get mslkeyInput(): string | undefined;
    private _mslname?;
    get mslname(): string;
    set mslname(value: string);
    resetMslname(): void;
    get mslnameInput(): string | undefined;
    private _nonce?;
    get nonce(): string;
    set nonce(value: string);
    resetNonce(): void;
    get nonceInput(): string | undefined;
    private _originLocationTitle?;
    get originLocationTitle(): string;
    set originLocationTitle(value: string);
    resetOriginLocationTitle(): void;
    get originLocationTitleInput(): string | undefined;
    private _propertyIdTag?;
    get propertyIdTag(): boolean | cdktf.IResolvable;
    set propertyIdTag(value: boolean | cdktf.IResolvable);
    resetPropertyIdTag(): void;
    get propertyIdTagInput(): boolean | cdktf.IResolvable | undefined;
    private _roleArn?;
    get roleArn(): string;
    set roleArn(value: string);
    resetRoleArn(): void;
    get roleArnInput(): string | undefined;
    private _secretKey?;
    get secretKey(): string;
    set secretKey(value: string);
    resetSecretKey(): void;
    get secretKeyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useCustomSignString?;
    get useCustomSignString(): boolean | cdktf.IResolvable;
    set useCustomSignString(value: boolean | cdktf.IResolvable);
    resetUseCustomSignString(): void;
    get useCustomSignStringInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies an origin type.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
    */
    readonly origintype?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _origintype?;
    get origintype(): string;
    set origintype(value: string);
    resetOrigintype(): void;
    get origintypeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod {
    /**
    * Specifies the custom status code to be sent to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
    */
    readonly customStatusCode?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
    */
    readonly recoveryMethod?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod | undefined);
    private _customStatusCode?;
    get customStatusCode(): string;
    set customStatusCode(value: string);
    resetCustomStatusCode(): void;
    get customStatusCodeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _recoveryMethod?;
    get recoveryMethod(): string;
    set recoveryMethod(value: string);
    resetRecoveryMethod(): void;
    get recoveryMethodInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy {
    /**
    * Synchronizes content between the primary and backup origins, byte for byte.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
    */
    readonly binaryEquivalentContent?: boolean | cdktf.IResolvable;
    /**
    * Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the `configName` established for `originResponsivenessRecoveryConfigName` is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
    */
    readonly enableIpAvoidance?: boolean | cdktf.IResolvable;
    /**
    * Activates and configures a recovery policy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Defines the number of failures that need to occur to an origin address before it's blocked.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
    */
    readonly ipAvoidanceErrorThreshold?: number;
    /**
    * Defines the number of seconds after which the IP address is removed from the blocklist.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
    */
    readonly ipAvoidanceRetryInterval?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
    */
    readonly monitorOriginResponsiveness?: boolean | cdktf.IResolvable;
    /**
    * Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (`501`) or a range (`501:504`). If you configure other `monitorStatusCodes*` and `monitorResponseCodes*` options, you can't use the same codes here.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
    */
    readonly monitorResponseCodes1?: string[];
    /**
    * Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (`501`) or a range (`501:504`). If you configure other `monitorStatusCodes*` and `monitorResponseCodes*` options, you can't use the same codes here.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
    */
    readonly monitorResponseCodes2?: string[];
    /**
    * Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (`501`) or a range (`501:504`). If you configure other `monitorStatusCodes*` and `monitorResponseCodes*` options, you can't use the same codes here..
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
    */
    readonly monitorResponseCodes3?: string[];
    /**
    * Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
    */
    readonly monitorStatusCodes1?: boolean | cdktf.IResolvable;
    /**
    * Enables the recovery action for the response codes you define.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
    */
    readonly monitorStatusCodes1EnableRecovery?: boolean | cdktf.IResolvable;
    /**
    * When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
    */
    readonly monitorStatusCodes1EnableRetry?: boolean | cdktf.IResolvable;
    /**
    * Specifies a recovery configuration using the `configName` you defined in the `recoveryConfig` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the `recoveryConfig` match criteria to apply this option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
    */
    readonly monitorStatusCodes1RecoveryConfigName?: string;
    /**
    * Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
    */
    readonly monitorStatusCodes2?: boolean | cdktf.IResolvable;
    /**
    * Enables the recovery action for the response codes you define.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
    */
    readonly monitorStatusCodes2EnableRecovery?: boolean | cdktf.IResolvable;
    /**
    * When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
    */
    readonly monitorStatusCodes2EnableRetry?: boolean | cdktf.IResolvable;
    /**
    * Specifies a recovery configuration using the `configName` you defined in the `recoveryConfig` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the `recoveryConfig` match criteria to apply this option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
    */
    readonly monitorStatusCodes2RecoveryConfigName?: string;
    /**
    * Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
    */
    readonly monitorStatusCodes3?: boolean | cdktf.IResolvable;
    /**
    * Enables the recovery action for the response codes you define.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
    */
    readonly monitorStatusCodes3EnableRecovery?: boolean | cdktf.IResolvable;
    /**
    * When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
    */
    readonly monitorStatusCodes3EnableRetry?: boolean | cdktf.IResolvable;
    /**
    * Specifies a recovery configuration using the `configName` you defined in the `recoveryConfig` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the `recoveryConfig` match criteria to apply this option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
    */
    readonly monitorStatusCodes3RecoveryConfigName?: string;
    /**
    * Specify a custom timeout, from 1 to 10 seconds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
    */
    readonly originResponsivenessCustomTimeout?: number;
    /**
    * Enables a recovery action for a specific failure condition.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
    */
    readonly originResponsivenessEnableRecovery?: boolean | cdktf.IResolvable;
    /**
    * If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
    */
    readonly originResponsivenessEnableRetry?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
    */
    readonly originResponsivenessMonitoring?: string;
    /**
    * Specifies a recovery configuration using the `configName` you defined in the `recoveryConfig` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the `recoveryConfig` match criteria to apply this option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
    */
    readonly originResponsivenessRecoveryConfigName?: string;
    /**
    * The timeout threshold that triggers a retry or recovery action.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
    */
    readonly originResponsivenessTimeout?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
    */
    readonly statusCodeMonitoring1?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
    */
    readonly statusCodeMonitoring2?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
    */
    readonly statusCodeMonitoring3?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
    */
    readonly tuningParameters?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy | undefined);
    private _binaryEquivalentContent?;
    get binaryEquivalentContent(): boolean | cdktf.IResolvable;
    set binaryEquivalentContent(value: boolean | cdktf.IResolvable);
    resetBinaryEquivalentContent(): void;
    get binaryEquivalentContentInput(): boolean | cdktf.IResolvable | undefined;
    private _enableIpAvoidance?;
    get enableIpAvoidance(): boolean | cdktf.IResolvable;
    set enableIpAvoidance(value: boolean | cdktf.IResolvable);
    resetEnableIpAvoidance(): void;
    get enableIpAvoidanceInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _ipAvoidanceErrorThreshold?;
    get ipAvoidanceErrorThreshold(): number;
    set ipAvoidanceErrorThreshold(value: number);
    resetIpAvoidanceErrorThreshold(): void;
    get ipAvoidanceErrorThresholdInput(): number | undefined;
    private _ipAvoidanceRetryInterval?;
    get ipAvoidanceRetryInterval(): number;
    set ipAvoidanceRetryInterval(value: number);
    resetIpAvoidanceRetryInterval(): void;
    get ipAvoidanceRetryIntervalInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorOriginResponsiveness?;
    get monitorOriginResponsiveness(): boolean | cdktf.IResolvable;
    set monitorOriginResponsiveness(value: boolean | cdktf.IResolvable);
    resetMonitorOriginResponsiveness(): void;
    get monitorOriginResponsivenessInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorResponseCodes1?;
    get monitorResponseCodes1(): string[];
    set monitorResponseCodes1(value: string[]);
    resetMonitorResponseCodes1(): void;
    get monitorResponseCodes1Input(): string[] | undefined;
    private _monitorResponseCodes2?;
    get monitorResponseCodes2(): string[];
    set monitorResponseCodes2(value: string[]);
    resetMonitorResponseCodes2(): void;
    get monitorResponseCodes2Input(): string[] | undefined;
    private _monitorResponseCodes3?;
    get monitorResponseCodes3(): string[];
    set monitorResponseCodes3(value: string[]);
    resetMonitorResponseCodes3(): void;
    get monitorResponseCodes3Input(): string[] | undefined;
    private _monitorStatusCodes1?;
    get monitorStatusCodes1(): boolean | cdktf.IResolvable;
    set monitorStatusCodes1(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes1(): void;
    get monitorStatusCodes1Input(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes1EnableRecovery?;
    get monitorStatusCodes1EnableRecovery(): boolean | cdktf.IResolvable;
    set monitorStatusCodes1EnableRecovery(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes1EnableRecovery(): void;
    get monitorStatusCodes1EnableRecoveryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes1EnableRetry?;
    get monitorStatusCodes1EnableRetry(): boolean | cdktf.IResolvable;
    set monitorStatusCodes1EnableRetry(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes1EnableRetry(): void;
    get monitorStatusCodes1EnableRetryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes1RecoveryConfigName?;
    get monitorStatusCodes1RecoveryConfigName(): string;
    set monitorStatusCodes1RecoveryConfigName(value: string);
    resetMonitorStatusCodes1RecoveryConfigName(): void;
    get monitorStatusCodes1RecoveryConfigNameInput(): string | undefined;
    private _monitorStatusCodes2?;
    get monitorStatusCodes2(): boolean | cdktf.IResolvable;
    set monitorStatusCodes2(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes2(): void;
    get monitorStatusCodes2Input(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes2EnableRecovery?;
    get monitorStatusCodes2EnableRecovery(): boolean | cdktf.IResolvable;
    set monitorStatusCodes2EnableRecovery(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes2EnableRecovery(): void;
    get monitorStatusCodes2EnableRecoveryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes2EnableRetry?;
    get monitorStatusCodes2EnableRetry(): boolean | cdktf.IResolvable;
    set monitorStatusCodes2EnableRetry(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes2EnableRetry(): void;
    get monitorStatusCodes2EnableRetryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes2RecoveryConfigName?;
    get monitorStatusCodes2RecoveryConfigName(): string;
    set monitorStatusCodes2RecoveryConfigName(value: string);
    resetMonitorStatusCodes2RecoveryConfigName(): void;
    get monitorStatusCodes2RecoveryConfigNameInput(): string | undefined;
    private _monitorStatusCodes3?;
    get monitorStatusCodes3(): boolean | cdktf.IResolvable;
    set monitorStatusCodes3(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes3(): void;
    get monitorStatusCodes3Input(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes3EnableRecovery?;
    get monitorStatusCodes3EnableRecovery(): boolean | cdktf.IResolvable;
    set monitorStatusCodes3EnableRecovery(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes3EnableRecovery(): void;
    get monitorStatusCodes3EnableRecoveryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes3EnableRetry?;
    get monitorStatusCodes3EnableRetry(): boolean | cdktf.IResolvable;
    set monitorStatusCodes3EnableRetry(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes3EnableRetry(): void;
    get monitorStatusCodes3EnableRetryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes3RecoveryConfigName?;
    get monitorStatusCodes3RecoveryConfigName(): string;
    set monitorStatusCodes3RecoveryConfigName(value: string);
    resetMonitorStatusCodes3RecoveryConfigName(): void;
    get monitorStatusCodes3RecoveryConfigNameInput(): string | undefined;
    private _originResponsivenessCustomTimeout?;
    get originResponsivenessCustomTimeout(): number;
    set originResponsivenessCustomTimeout(value: number);
    resetOriginResponsivenessCustomTimeout(): void;
    get originResponsivenessCustomTimeoutInput(): number | undefined;
    private _originResponsivenessEnableRecovery?;
    get originResponsivenessEnableRecovery(): boolean | cdktf.IResolvable;
    set originResponsivenessEnableRecovery(value: boolean | cdktf.IResolvable);
    resetOriginResponsivenessEnableRecovery(): void;
    get originResponsivenessEnableRecoveryInput(): boolean | cdktf.IResolvable | undefined;
    private _originResponsivenessEnableRetry?;
    get originResponsivenessEnableRetry(): boolean | cdktf.IResolvable;
    set originResponsivenessEnableRetry(value: boolean | cdktf.IResolvable);
    resetOriginResponsivenessEnableRetry(): void;
    get originResponsivenessEnableRetryInput(): boolean | cdktf.IResolvable | undefined;
    private _originResponsivenessMonitoring?;
    get originResponsivenessMonitoring(): string;
    set originResponsivenessMonitoring(value: string);
    resetOriginResponsivenessMonitoring(): void;
    get originResponsivenessMonitoringInput(): string | undefined;
    private _originResponsivenessRecoveryConfigName?;
    get originResponsivenessRecoveryConfigName(): string;
    set originResponsivenessRecoveryConfigName(value: string);
    resetOriginResponsivenessRecoveryConfigName(): void;
    get originResponsivenessRecoveryConfigNameInput(): string | undefined;
    private _originResponsivenessTimeout?;
    get originResponsivenessTimeout(): string;
    set originResponsivenessTimeout(value: string);
    resetOriginResponsivenessTimeout(): void;
    get originResponsivenessTimeoutInput(): string | undefined;
    private _statusCodeMonitoring1?;
    get statusCodeMonitoring1(): string;
    set statusCodeMonitoring1(value: string);
    resetStatusCodeMonitoring1(): void;
    get statusCodeMonitoring1Input(): string | undefined;
    private _statusCodeMonitoring2?;
    get statusCodeMonitoring2(): string;
    set statusCodeMonitoring2(value: string);
    resetStatusCodeMonitoring2(): void;
    get statusCodeMonitoring2Input(): string | undefined;
    private _statusCodeMonitoring3?;
    get statusCodeMonitoring3(): string;
    set statusCodeMonitoring3(value: string);
    resetStatusCodeMonitoring3(): void;
    get statusCodeMonitoring3Input(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tuningParameters?;
    get tuningParameters(): string;
    set tuningParameters(value: string);
    resetTuningParameters(): void;
    get tuningParametersInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl {
    /**
    * Enables the Origin IP Access Control List behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection {
    /**
    * Enables the persistent connections behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection {
    /**
    * Enables persistent connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the timeout period after which edge server closes a persistent connection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation {
    /**
    * When enabled, marks content as personally identifiable information (PII).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease {
    /**
    * Identifies the Cloudlet shared policy to use with this behavior. Use the `Cloudlets API` to list available shared policies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Phased Release Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to `0` to immediately request the alternate origin upon failure.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
    */
    readonly failoverDuration?: number;
    /**
    * Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
    */
    readonly failoverEnabled?: boolean | cdktf.IResolvable;
    /**
    * Defines the set of failure codes that initiate the failover response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
    */
    readonly failoverResponseCode?: string[];
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
    */
    readonly failoverTitle?: string;
    /**
    * Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * A label to distinguish this Phased Release policy from any others within the same property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
    */
    readonly label?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's `random` membership option, it overrides this option's value so that it is effectively `NONE`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
    */
    readonly populationCookieType?: string;
    /**
    * Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
    */
    readonly populationDuration?: string;
    /**
    * Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
    */
    readonly populationExpirationDate?: string;
    /**
    * Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
    */
    readonly populationRefresh?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
    */
    readonly populationTitle?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverDuration?;
    get failoverDuration(): number;
    set failoverDuration(value: number);
    resetFailoverDuration(): void;
    get failoverDurationInput(): number | undefined;
    private _failoverEnabled?;
    get failoverEnabled(): boolean | cdktf.IResolvable;
    set failoverEnabled(value: boolean | cdktf.IResolvable);
    resetFailoverEnabled(): void;
    get failoverEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverResponseCode?;
    get failoverResponseCode(): string[];
    set failoverResponseCode(value: string[]);
    resetFailoverResponseCode(): void;
    get failoverResponseCodeInput(): string[] | undefined;
    private _failoverTitle?;
    get failoverTitle(): string;
    set failoverTitle(value: string);
    resetFailoverTitle(): void;
    get failoverTitleInput(): string | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    resetLabel(): void;
    get labelInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _populationCookieType?;
    get populationCookieType(): string;
    set populationCookieType(value: string);
    resetPopulationCookieType(): void;
    get populationCookieTypeInput(): string | undefined;
    private _populationDuration?;
    get populationDuration(): string;
    set populationDuration(value: string);
    resetPopulationDuration(): void;
    get populationDurationInput(): string | undefined;
    private _populationExpirationDate?;
    get populationExpirationDate(): string;
    set populationExpirationDate(value: string);
    resetPopulationExpirationDate(): void;
    get populationExpirationDateInput(): string | undefined;
    private _populationRefresh?;
    get populationRefresh(): boolean | cdktf.IResolvable;
    set populationRefresh(value: boolean | cdktf.IResolvable);
    resetPopulationRefresh(): void;
    get populationRefreshInput(): boolean | cdktf.IResolvable | undefined;
    private _populationTitle?;
    get populationTitle(): string;
    set populationTitle(value: string);
    resetPopulationTitle(): void;
    get populationTitleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of hostnames to which to preconnect over HTTP2.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
    */
    readonly preconnectlist?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _preconnectlist?;
    get preconnectlist(): string[];
    set preconnectlist(value: string[]);
    resetPreconnectlist(): void;
    get preconnectlistInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery {
    /**
    * Enables the predictive content delivery behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching {
    /**
    * The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
    */
    readonly accuracyTarget?: string;
    /**
    * Enables the predictive prefetching behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching | undefined);
    private _accuracyTarget?;
    get accuracyTarget(): string;
    set accuracyTarget(value: string);
    resetAccuracyTarget(): void;
    get accuracyTargetInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch {
    /**
    * Applies prefetching behavior when enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable {
    /**
    * Allows matching content to prefetch when referenced on a requested parent page.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache {
    /**
    * Enables the cache prefreshing behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of `95` prefreshes the content without unnecessarily increasing load on the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
    */
    readonly prefreshval?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefreshval?;
    get prefreshval(): number;
    set prefreshval(value: number);
    resetPrefreshval(): void;
    get prefreshvalInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
    */
    readonly audienceSettings?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
    */
    readonly contentSettings?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
    */
    readonly country?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}
    */
    readonly deliveryFormat?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}
    */
    readonly deliveryType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}
    */
    readonly downloadType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}
    */
    readonly endUserLocation?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}
    */
    readonly maximumConcurrentUsers?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}
    */
    readonly optimizeFor?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
    */
    readonly originSettings?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}
    */
    readonly refreshRate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}
    */
    readonly segmentDuration?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality | undefined);
    private _audienceSettings?;
    get audienceSettings(): string;
    set audienceSettings(value: string);
    resetAudienceSettings(): void;
    get audienceSettingsInput(): string | undefined;
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentSettings?;
    get contentSettings(): string;
    set contentSettings(value: string);
    resetContentSettings(): void;
    get contentSettingsInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _country?;
    get country(): string;
    set country(value: string);
    resetCountry(): void;
    get countryInput(): string | undefined;
    private _deliveryFormat?;
    get deliveryFormat(): string;
    set deliveryFormat(value: string);
    resetDeliveryFormat(): void;
    get deliveryFormatInput(): string | undefined;
    private _deliveryType?;
    get deliveryType(): string;
    set deliveryType(value: string);
    resetDeliveryType(): void;
    get deliveryTypeInput(): string | undefined;
    private _downloadType?;
    get downloadType(): string;
    set downloadType(value: string);
    resetDownloadType(): void;
    get downloadTypeInput(): string | undefined;
    private _endUserLocation?;
    get endUserLocation(): string;
    set endUserLocation(value: string);
    resetEndUserLocation(): void;
    get endUserLocationInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumConcurrentUsers?;
    get maximumConcurrentUsers(): string;
    set maximumConcurrentUsers(value: string);
    resetMaximumConcurrentUsers(): void;
    get maximumConcurrentUsersInput(): string | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _optimizeFor?;
    get optimizeFor(): string;
    set optimizeFor(value: string);
    resetOptimizeFor(): void;
    get optimizeForInput(): string | undefined;
    private _originSettings?;
    get originSettings(): string;
    set originSettings(value: string);
    resetOriginSettings(): void;
    get originSettingsInput(): string | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _refreshRate?;
    get refreshRate(): string;
    set refreshRate(value: string);
    resetRefreshRate(): void;
    get refreshRateInput(): string | undefined;
    private _segmentDuration?;
    get segmentDuration(): number;
    set segmentDuration(value: number);
    resetSegmentDuration(): void;
    get segmentDurationInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta {
    /**
    * Enables QUIC support.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The percentage of responses for which to allow QUIC sessions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
    */
    readonly quicOfferPercentage?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _quicOfferPercentage?;
    get quicOfferPercentage(): number;
    set quicOfferPercentage(value: number);
    resetQuicOfferPercentage(): void;
    get quicOfferPercentageInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek {
    /**
    * Enables random seek optimization in FLV files.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
    */
    readonly flv?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as `MB` or `GB`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
    */
    readonly maximumSize?: string;
    /**
    * Enables random seek optimization in MP4 files.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
    */
    readonly mp4?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek | undefined);
    private _flv?;
    get flv(): boolean | cdktf.IResolvable;
    set flv(value: boolean | cdktf.IResolvable);
    resetFlv(): void;
    get flvInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumSize?;
    get maximumSize(): string;
    set maximumSize(value: string);
    resetMaximumSize(): void;
    get maximumSizeInput(): string | undefined;
    private _mp4?;
    get mp4(): boolean | cdktf.IResolvable;
    set mp4(value: boolean | cdktf.IResolvable);
    resetMp4(): void;
    get mp4Input(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid {
    /**
    * Enables API Gateway for the current set of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the read timeout necessary before failing with a `504` error. This value should never be zero.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting {
    /**
    * Enables advanced options.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * Specifies the percentage for sampling.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
    */
    readonly beaconSamplingPercentage?: number;
    /**
    * Enables reports on delivery of cloud hosted content at near real-time latencies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _beaconSamplingPercentage?;
    get beaconSamplingPercentage(): number;
    set beaconSamplingPercentage(value: number);
    resetBeaconSamplingPercentage(): void;
    get beaconSamplingPercentageInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring {
    /**
    * When enabled, activates real-use monitoring.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect {
    /**
    * Specify how to change the requested hostname, independently from the pathname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
    */
    readonly destinationHostname?: string;
    /**
    * Specifies the full hostname with which to replace the current hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
    */
    readonly destinationHostnameOther?: string;
    /**
    * Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of `m` changes `www.example.com` to `m.example.com`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
    */
    readonly destinationHostnameSibling?: string;
    /**
    * Specifies a subdomain to prepend to the current hostname. For example, a value of `m` changes `www.example.com` to `m.www.example.com`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
    */
    readonly destinationHostnameSubdomain?: string;
    /**
    * Specify how to change the requested pathname, independently from the hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
    */
    readonly destinationPath?: string;
    /**
    * When `destinationPath` is set to `PREFIX_REQUEST`, this replaces the current path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
    */
    readonly destinationPathOther?: string;
    /**
    * When `destinationPath` is set to `PREFIX_REQUEST`, this prepends the current path. For example, a value of `/prefix/path` changes `/example/index.html` to `/prefix/path/example/index.html`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
    */
    readonly destinationPathPrefix?: string;
    /**
    * When `destinationPath` is set to `PREFIX_REQUEST` and `destinationPathSuffixStatus` is set to `SUFFIX`, this specifies the suffix to append to the path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
    */
    readonly destinationPathSuffix?: string;
    /**
    * When `destinationPath` is set to `PREFIX_REQUEST`, this gives you the option of adding a suffix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
    */
    readonly destinationPathSuffixStatus?: string;
    /**
    * Choose the protocol for the redirect URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
    */
    readonly destinationProtocol?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Either specify a default response for mobile browsers, or customize your own.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
    */
    readonly mobileDefaultChoice?: string;
    /**
    * When set to `APPEND`, passes incoming query string parameters as part of the redirect URL. Otherwise set this to `IGNORE`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
    */
    readonly queryString?: string;
    /**
    * Specify the redirect's response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
    */
    readonly responseCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect | undefined);
    private _destinationHostname?;
    get destinationHostname(): string;
    set destinationHostname(value: string);
    resetDestinationHostname(): void;
    get destinationHostnameInput(): string | undefined;
    private _destinationHostnameOther?;
    get destinationHostnameOther(): string;
    set destinationHostnameOther(value: string);
    resetDestinationHostnameOther(): void;
    get destinationHostnameOtherInput(): string | undefined;
    private _destinationHostnameSibling?;
    get destinationHostnameSibling(): string;
    set destinationHostnameSibling(value: string);
    resetDestinationHostnameSibling(): void;
    get destinationHostnameSiblingInput(): string | undefined;
    private _destinationHostnameSubdomain?;
    get destinationHostnameSubdomain(): string;
    set destinationHostnameSubdomain(value: string);
    resetDestinationHostnameSubdomain(): void;
    get destinationHostnameSubdomainInput(): string | undefined;
    private _destinationPath?;
    get destinationPath(): string;
    set destinationPath(value: string);
    resetDestinationPath(): void;
    get destinationPathInput(): string | undefined;
    private _destinationPathOther?;
    get destinationPathOther(): string;
    set destinationPathOther(value: string);
    resetDestinationPathOther(): void;
    get destinationPathOtherInput(): string | undefined;
    private _destinationPathPrefix?;
    get destinationPathPrefix(): string;
    set destinationPathPrefix(value: string);
    resetDestinationPathPrefix(): void;
    get destinationPathPrefixInput(): string | undefined;
    private _destinationPathSuffix?;
    get destinationPathSuffix(): string;
    set destinationPathSuffix(value: string);
    resetDestinationPathSuffix(): void;
    get destinationPathSuffixInput(): string | undefined;
    private _destinationPathSuffixStatus?;
    get destinationPathSuffixStatus(): string;
    set destinationPathSuffixStatus(value: string);
    resetDestinationPathSuffixStatus(): void;
    get destinationPathSuffixStatusInput(): string | undefined;
    private _destinationProtocol?;
    get destinationProtocol(): string;
    set destinationProtocol(value: string);
    resetDestinationProtocol(): void;
    get destinationProtocolInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mobileDefaultChoice?;
    get mobileDefaultChoice(): string;
    set mobileDefaultChoice(value: string);
    resetMobileDefaultChoice(): void;
    get mobileDefaultChoiceInput(): string | undefined;
    private _queryString?;
    get queryString(): string;
    set queryString(value: string);
    resetQueryString(): void;
    get queryStringInput(): string | undefined;
    private _responseCode?;
    get responseCode(): number;
    set responseCode(value: number);
    resetResponseCode(): void;
    get responseCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus {
    /**
    * Specifies the redirect as a path expression starting with a `/` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: `/path/to/{{builtin.AK_FILENAME}}`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
    */
    readonly destination?: string;
    /**
    * Enables the redirect feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Assigns the status code for the redirect response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
    */
    readonly responseCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    resetDestination(): void;
    get destinationInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _responseCode?;
    get responseCode(): number;
    set responseCode(value: number);
    resetResponseCode(): void;
    get responseCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking {
    /**
    * Allows all subdomains for the `domains` set, just like adding a `*.` prefix to each.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
    */
    readonly allowChildren?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of allowed domains. With `allowChildren` disabled, prefixing values with `*.` specifies domains for which subdomains are allowed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
    */
    readonly domains?: string[];
    /**
    * Enables the referer-checking behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, excludes requests whose `Referer` header include a relative path, or that are missing a `Referer`. When disabled, only excludes requests whose `Referer` hostname is not part of the `domains` set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
    */
    readonly strict?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking | undefined);
    private _allowChildren?;
    get allowChildren(): boolean | cdktf.IResolvable;
    set allowChildren(value: boolean | cdktf.IResolvable);
    resetAllowChildren(): void;
    get allowChildrenInput(): boolean | cdktf.IResolvable | undefined;
    private _domains?;
    get domains(): string[];
    set domains(value: string[]);
    resetDomains(): void;
    get domainsInput(): string[] | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _strict?;
    get strict(): boolean | cdktf.IResolvable;
    set strict(value: boolean | cdktf.IResolvable);
    resetStrict(): void;
    get strictInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies parameters to remove from the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
    */
    readonly parameters?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _parameters?;
    get parameters(): string[];
    set parameters(value: string[]);
    resetParameters(): void;
    get parametersInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
