import * as cdktf from 'cdktf';
import { DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicyOutputReference, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorageOutputReference, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeOutputReference } from './structs1600';
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization {
    /**
    * Specifies the alternate response's time to live in the cache, `5` minutes by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
    */
    readonly alternateResponseCacheTtl?: number;
    /**
    * Identifies the Cloudlet shared policy to use with this behavior. Use the `Cloudlets API` to list available shared policies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Activates the API Prioritization feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * A label to distinguish this API Prioritization policy from any others in the same property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
    */
    readonly label?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the full NetStorage path for the alternate response, including trailing file name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
    */
    readonly netStoragePath?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the HTTP response code for requests that receive the alternate response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
    */
    readonly throttledStatusCode?: number;
    /**
    * Specifies whether to apply an alternative CP code for requests served the alternate response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
    */
    readonly useThrottledCpCode?: boolean | cdktf.IResolvable;
    /**
    * Allows you to assign a specific HTTP response code to a throttled request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
    */
    readonly useThrottledStatusCode?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy;
    /**
    * net_storage block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
    */
    readonly netStorage?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage;
    /**
    * throttled_cp_code block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
    */
    readonly throttledCpCode?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization | undefined);
    private _alternateResponseCacheTtl?;
    get alternateResponseCacheTtl(): number;
    set alternateResponseCacheTtl(value: number);
    resetAlternateResponseCacheTtl(): void;
    get alternateResponseCacheTtlInput(): number | undefined;
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    resetLabel(): void;
    get labelInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _netStoragePath?;
    get netStoragePath(): string;
    set netStoragePath(value: string);
    resetNetStoragePath(): void;
    get netStoragePathInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _throttledStatusCode?;
    get throttledStatusCode(): number;
    set throttledStatusCode(value: number);
    resetThrottledStatusCode(): void;
    get throttledStatusCodeInput(): number | undefined;
    private _useThrottledCpCode?;
    get useThrottledCpCode(): boolean | cdktf.IResolvable;
    set useThrottledCpCode(value: boolean | cdktf.IResolvable);
    resetUseThrottledCpCode(): void;
    get useThrottledCpCodeInput(): boolean | cdktf.IResolvable | undefined;
    private _useThrottledStatusCode?;
    get useThrottledStatusCode(): boolean | cdktf.IResolvable;
    set useThrottledStatusCode(value: boolean | cdktf.IResolvable);
    resetUseThrottledStatusCode(): void;
    get useThrottledStatusCodeInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy | undefined;
    private _netStorage;
    get netStorage(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorageOutputReference;
    putNetStorage(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage): void;
    resetNetStorage(): void;
    get netStorageInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage | undefined;
    private _throttledCpCode;
    get throttledCpCode(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeOutputReference;
    putThrottledCpCode(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode): void;
    resetThrottledCpCode(): void;
    get throttledCpCodeInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}
    */
    readonly downloadDomainName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}
    */
    readonly g2OToken?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage | undefined);
    private _cpCode?;
    get cpCode(): number;
    set cpCode(value: number);
    resetCpCode(): void;
    get cpCodeInput(): number | undefined;
    private _downloadDomainName?;
    get downloadDomainName(): string;
    set downloadDomainName(value: string);
    resetDownloadDomainName(): void;
    get downloadDomainNameInput(): string | undefined;
    private _g2OToken?;
    get g2OToken(): string;
    set g2OToken(value: string);
    resetG2OToken(): void;
    get g2OTokenInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap {
    /**
    * Specifies the origin whose failure triggers the mapping rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
    */
    readonly fromOriginId?: string;
    /**
    * Requests stuck to the `fromOriginId` origin retry for each alternate origin `toOriginIds`, until one succeeds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
    */
    readonly toOriginIds?: string[];
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap | cdktf.IResolvable | undefined);
    private _fromOriginId?;
    get fromOriginId(): string;
    set fromOriginId(value: string);
    resetFromOriginId(): void;
    get fromOriginIdInput(): string | undefined;
    private _toOriginIds?;
    get toOriginIds(): string[];
    set toOriginIds(value: string[]);
    resetToOriginIds(): void;
    get toOriginIdsInput(): string[] | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer {
    /**
    * Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
    */
    readonly allDownNetStorageFile?: string;
    /**
    * Specifies the HTTP response code when all load-balancing origins are unavailable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
    */
    readonly allDownStatusCode?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
    */
    readonly allDownTitle?: string;
    /**
    * Allows the cache to prefresh.  Only appropriate if all origins serve the same content for the same URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
    */
    readonly allowCachePrefresh?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
    */
    readonly cachedContentTitle?: string;
    /**
    * Activates the Application Load Balancer Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Sets the number of failed requests that would trigger the failover process.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
    */
    readonly failoverAttemptsThreshold?: number;
    /**
    * Determines what to do if an origin fails.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
    */
    readonly failoverMode?: string;
    /**
    * Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
    */
    readonly failoverStatusCodes?: string[];
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
    */
    readonly failoverTitle?: string;
    /**
    * A label to distinguish this Application Load Balancer policy from any others within the same property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
    */
    readonly label?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the name for your session cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
    */
    readonly originCookieName?: string;
    /**
    * Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
    */
    readonly specifyStickinessCookieDomain?: boolean | cdktf.IResolvable;
    /**
    * Sets whether to assign a `salt` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
    */
    readonly stickinessCookieAutomaticSalt?: boolean | cdktf.IResolvable;
    /**
    * Specifies the domain to track the stickiness cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
    */
    readonly stickinessCookieDomain?: string;
    /**
    * Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
    */
    readonly stickinessCookieSalt?: string;
    /**
    * Ensures the cookie is transmitted only over HTTP.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
    */
    readonly stickinessCookieSetHttpOnlyFlag?: boolean | cdktf.IResolvable;
    /**
    * Determines how a cookie persistently associates the client with a load-balanced origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
    */
    readonly stickinessCookieType?: string;
    /**
    * Sets how long it is before the cookie expires.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
    */
    readonly stickinessDuration?: string;
    /**
    * Specifies when the cookie expires.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
    */
    readonly stickinessExpirationDate?: string;
    /**
    * Extends the duration of the cookie with each new request. When enabled, the `DURATION` thus specifies the latency between requests that would cause the cookie to expire.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
    */
    readonly stickinessRefresh?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
    */
    readonly stickinessTitle?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * all_down_net_storage block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
    */
    readonly allDownNetStorage?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy;
    /**
    * failover_origin_map block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
    */
    readonly failoverOriginMap?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap[] | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer | undefined);
    private _allDownNetStorageFile?;
    get allDownNetStorageFile(): string;
    set allDownNetStorageFile(value: string);
    resetAllDownNetStorageFile(): void;
    get allDownNetStorageFileInput(): string | undefined;
    private _allDownStatusCode?;
    get allDownStatusCode(): string;
    set allDownStatusCode(value: string);
    resetAllDownStatusCode(): void;
    get allDownStatusCodeInput(): string | undefined;
    private _allDownTitle?;
    get allDownTitle(): string;
    set allDownTitle(value: string);
    resetAllDownTitle(): void;
    get allDownTitleInput(): string | undefined;
    private _allowCachePrefresh?;
    get allowCachePrefresh(): boolean | cdktf.IResolvable;
    set allowCachePrefresh(value: boolean | cdktf.IResolvable);
    resetAllowCachePrefresh(): void;
    get allowCachePrefreshInput(): boolean | cdktf.IResolvable | undefined;
    private _cachedContentTitle?;
    get cachedContentTitle(): string;
    set cachedContentTitle(value: string);
    resetCachedContentTitle(): void;
    get cachedContentTitleInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverAttemptsThreshold?;
    get failoverAttemptsThreshold(): number;
    set failoverAttemptsThreshold(value: number);
    resetFailoverAttemptsThreshold(): void;
    get failoverAttemptsThresholdInput(): number | undefined;
    private _failoverMode?;
    get failoverMode(): string;
    set failoverMode(value: string);
    resetFailoverMode(): void;
    get failoverModeInput(): string | undefined;
    private _failoverStatusCodes?;
    get failoverStatusCodes(): string[];
    set failoverStatusCodes(value: string[]);
    resetFailoverStatusCodes(): void;
    get failoverStatusCodesInput(): string[] | undefined;
    private _failoverTitle?;
    get failoverTitle(): string;
    set failoverTitle(value: string);
    resetFailoverTitle(): void;
    get failoverTitleInput(): string | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    resetLabel(): void;
    get labelInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _originCookieName?;
    get originCookieName(): string;
    set originCookieName(value: string);
    resetOriginCookieName(): void;
    get originCookieNameInput(): string | undefined;
    private _specifyStickinessCookieDomain?;
    get specifyStickinessCookieDomain(): boolean | cdktf.IResolvable;
    set specifyStickinessCookieDomain(value: boolean | cdktf.IResolvable);
    resetSpecifyStickinessCookieDomain(): void;
    get specifyStickinessCookieDomainInput(): boolean | cdktf.IResolvable | undefined;
    private _stickinessCookieAutomaticSalt?;
    get stickinessCookieAutomaticSalt(): boolean | cdktf.IResolvable;
    set stickinessCookieAutomaticSalt(value: boolean | cdktf.IResolvable);
    resetStickinessCookieAutomaticSalt(): void;
    get stickinessCookieAutomaticSaltInput(): boolean | cdktf.IResolvable | undefined;
    private _stickinessCookieDomain?;
    get stickinessCookieDomain(): string;
    set stickinessCookieDomain(value: string);
    resetStickinessCookieDomain(): void;
    get stickinessCookieDomainInput(): string | undefined;
    private _stickinessCookieSalt?;
    get stickinessCookieSalt(): string;
    set stickinessCookieSalt(value: string);
    resetStickinessCookieSalt(): void;
    get stickinessCookieSaltInput(): string | undefined;
    private _stickinessCookieSetHttpOnlyFlag?;
    get stickinessCookieSetHttpOnlyFlag(): boolean | cdktf.IResolvable;
    set stickinessCookieSetHttpOnlyFlag(value: boolean | cdktf.IResolvable);
    resetStickinessCookieSetHttpOnlyFlag(): void;
    get stickinessCookieSetHttpOnlyFlagInput(): boolean | cdktf.IResolvable | undefined;
    private _stickinessCookieType?;
    get stickinessCookieType(): string;
    set stickinessCookieType(value: string);
    resetStickinessCookieType(): void;
    get stickinessCookieTypeInput(): string | undefined;
    private _stickinessDuration?;
    get stickinessDuration(): string;
    set stickinessDuration(value: string);
    resetStickinessDuration(): void;
    get stickinessDurationInput(): string | undefined;
    private _stickinessExpirationDate?;
    get stickinessExpirationDate(): string;
    set stickinessExpirationDate(value: string);
    resetStickinessExpirationDate(): void;
    get stickinessExpirationDateInput(): string | undefined;
    private _stickinessRefresh?;
    get stickinessRefresh(): boolean | cdktf.IResolvable;
    set stickinessRefresh(value: boolean | cdktf.IResolvable);
    resetStickinessRefresh(): void;
    get stickinessRefreshInput(): boolean | cdktf.IResolvable | undefined;
    private _stickinessTitle?;
    get stickinessTitle(): string;
    set stickinessTitle(value: string);
    resetStickinessTitle(): void;
    get stickinessTitleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _allDownNetStorage;
    get allDownNetStorage(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference;
    putAllDownNetStorage(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage): void;
    resetAllDownNetStorage(): void;
    get allDownNetStorageInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy | undefined;
    private _failoverOriginMap;
    get failoverOriginMap(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapList;
    putFailoverOriginMap(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap[] | cdktf.IResolvable): void;
    resetFailoverOriginMap(): void;
    get failoverOriginMapInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap[] | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation {
    /**
    * This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the `Cloudlets API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Audience Segmentation cloudlet feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
    */
    readonly label?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Whether to assign a `salt` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
    */
    readonly populationCookieAutomaticSalt?: boolean | cdktf.IResolvable;
    /**
    * Specifies the domain to track the population cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
    */
    readonly populationCookieDomain?: string;
    /**
    * When enabled, includes in the session cookie the name of the rule in which this behavior appears.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
    */
    readonly populationCookieIncludeRuleName?: boolean | cdktf.IResolvable;
    /**
    * Specifies the cookie's salt value. Use this option to share the cookie across many properties.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
    */
    readonly populationCookieSalt?: string;
    /**
    * Specifies when the segmentation cookie expires.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
    */
    readonly populationCookieType?: string;
    /**
    * Specifies the lifetime of the segmentation cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
    */
    readonly populationDuration?: string;
    /**
    * If disabled, sets the expiration time only if the cookie is not yet present in the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
    */
    readonly populationRefresh?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
    */
    readonly populationTitle?: string;
    /**
    * This cookie name specifies the name of the segmentation rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
    */
    readonly segmentTrackingCookieName?: string;
    /**
    * This custom HTTP header specifies the name of the segmentation rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
    */
    readonly segmentTrackingCustomHeader?: string;
    /**
    * Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
    */
    readonly segmentTrackingMethod?: string;
    /**
    * This query parameter specifies the name of the segmentation rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
    */
    readonly segmentTrackingQueryParam?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
    */
    readonly segmentTrackingTitle?: string;
    /**
    * Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
    */
    readonly specifyPopulationCookieDomain?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    resetLabel(): void;
    get labelInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _populationCookieAutomaticSalt?;
    get populationCookieAutomaticSalt(): boolean | cdktf.IResolvable;
    set populationCookieAutomaticSalt(value: boolean | cdktf.IResolvable);
    resetPopulationCookieAutomaticSalt(): void;
    get populationCookieAutomaticSaltInput(): boolean | cdktf.IResolvable | undefined;
    private _populationCookieDomain?;
    get populationCookieDomain(): string;
    set populationCookieDomain(value: string);
    resetPopulationCookieDomain(): void;
    get populationCookieDomainInput(): string | undefined;
    private _populationCookieIncludeRuleName?;
    get populationCookieIncludeRuleName(): boolean | cdktf.IResolvable;
    set populationCookieIncludeRuleName(value: boolean | cdktf.IResolvable);
    resetPopulationCookieIncludeRuleName(): void;
    get populationCookieIncludeRuleNameInput(): boolean | cdktf.IResolvable | undefined;
    private _populationCookieSalt?;
    get populationCookieSalt(): string;
    set populationCookieSalt(value: string);
    resetPopulationCookieSalt(): void;
    get populationCookieSaltInput(): string | undefined;
    private _populationCookieType?;
    get populationCookieType(): string;
    set populationCookieType(value: string);
    resetPopulationCookieType(): void;
    get populationCookieTypeInput(): string | undefined;
    private _populationDuration?;
    get populationDuration(): string;
    set populationDuration(value: string);
    resetPopulationDuration(): void;
    get populationDurationInput(): string | undefined;
    private _populationRefresh?;
    get populationRefresh(): boolean | cdktf.IResolvable;
    set populationRefresh(value: boolean | cdktf.IResolvable);
    resetPopulationRefresh(): void;
    get populationRefreshInput(): boolean | cdktf.IResolvable | undefined;
    private _populationTitle?;
    get populationTitle(): string;
    set populationTitle(value: string);
    resetPopulationTitle(): void;
    get populationTitleInput(): string | undefined;
    private _segmentTrackingCookieName?;
    get segmentTrackingCookieName(): string;
    set segmentTrackingCookieName(value: string);
    resetSegmentTrackingCookieName(): void;
    get segmentTrackingCookieNameInput(): string | undefined;
    private _segmentTrackingCustomHeader?;
    get segmentTrackingCustomHeader(): string;
    set segmentTrackingCustomHeader(value: string);
    resetSegmentTrackingCustomHeader(): void;
    get segmentTrackingCustomHeaderInput(): string | undefined;
    private _segmentTrackingMethod?;
    get segmentTrackingMethod(): string;
    set segmentTrackingMethod(value: string);
    resetSegmentTrackingMethod(): void;
    get segmentTrackingMethodInput(): string | undefined;
    private _segmentTrackingQueryParam?;
    get segmentTrackingQueryParam(): string;
    set segmentTrackingQueryParam(value: string);
    resetSegmentTrackingQueryParam(): void;
    get segmentTrackingQueryParamInput(): string | undefined;
    private _segmentTrackingTitle?;
    get segmentTrackingTitle(): string;
    set segmentTrackingTitle(value: string);
    resetSegmentTrackingTitle(): void;
    get segmentTrackingTitleInput(): string | undefined;
    private _specifyPopulationCookieDomain?;
    get specifyPopulationCookieDomain(): boolean | cdktf.IResolvable;
    set specifyPopulationCookieDomain(value: boolean | cdktf.IResolvable);
    resetSpecifyPopulationCookieDomain(): void;
    get specifyPopulationCookieDomainInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
    */
    readonly autodv?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation | undefined);
    private _autodv?;
    get autodv(): string;
    set autodv(value: string);
    resetAutodv(): void;
    get autodvInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the base path of content on your origin server. The value needs to begin and end with a slash (`/`) character, for example `/parent/child/`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing {
    /**
    * A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where `?` matches a single character and `*` matches zero or more characters. For example, `*CONNECT* *DENIED*` matches two different words as substrings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
    */
    readonly conditionalErrorPattern?: string;
    /**
    * Specifies the set of response status codes or ranges that trigger the beacon.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
    */
    readonly conditionalHttpStatus?: string[];
    /**
    * Specifies a conditional sampling frequency or disables beacons.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
    */
    readonly conditionalSamplingFrequency?: string;
    /**
    * The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
    */
    readonly cpcodes?: string;
    /**
    * Enable diagnostic data beacons.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specify when to trigger a beacon.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
    */
    readonly forwardType?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify when to trigger a beacon.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
    */
    readonly requestType?: string;
    /**
    * Specifies a sampling frequency or disables beacons.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
    */
    readonly samplingFrequency?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing | undefined);
    private _conditionalErrorPattern?;
    get conditionalErrorPattern(): string;
    set conditionalErrorPattern(value: string);
    resetConditionalErrorPattern(): void;
    get conditionalErrorPatternInput(): string | undefined;
    private _conditionalHttpStatus?;
    get conditionalHttpStatus(): string[];
    set conditionalHttpStatus(value: string[]);
    resetConditionalHttpStatus(): void;
    get conditionalHttpStatusInput(): string[] | undefined;
    private _conditionalSamplingFrequency?;
    get conditionalSamplingFrequency(): string;
    set conditionalSamplingFrequency(value: string);
    resetConditionalSamplingFrequency(): void;
    get conditionalSamplingFrequencyInput(): string | undefined;
    private _cpcodes?;
    get cpcodes(): string;
    set cpcodes(value: string);
    resetCpcodes(): void;
    get cpcodesInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _forwardType?;
    get forwardType(): string;
    set forwardType(value: string);
    resetForwardType(): void;
    get forwardTypeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _requestType?;
    get requestType(): string;
    set requestType(value: string);
    resetRequestType(): void;
    get requestTypeInput(): string | undefined;
    private _samplingFrequency?;
    get samplingFrequency(): string;
    set samplingFrequency(value: string);
    resetSamplingFrequency(): void;
    get samplingFrequencyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs {
    /**
    * Enables the Breadcrumbs feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using `DataStream 2` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
    */
    readonly loggingEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies whether to include Breadcrumbs data in the response header. To bypass the current `optMode`, append the opposite `ak-bc` query string to each request from your player.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
    */
    readonly optMode?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _loggingEnabled?;
    get loggingEnabled(): boolean | cdktf.IResolvable;
    set loggingEnabled(value: boolean | cdktf.IResolvable);
    resetLoggingEnabled(): void;
    get loggingEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _optMode?;
    get optMode(): boolean | cdktf.IResolvable;
    set optMode(value: boolean | cdktf.IResolvable);
    resetOptMode(): void;
    get optModeInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection {
    /**
    * Enables the break connection behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli {
    /**
    * Fetches Brotli-compressed assets from your origin and caches them on edge servers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError {
    /**
    * Activates the error-caching behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, the edge server preserves stale cached objects when the origin returns `500`, `502`, `503`, and `504` error codes. This avoids re-fetching and re-caching content after transient errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
    */
    readonly preserveStale?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Overrides the default caching duration of `10s`. Note that if set to `0`, it is equivalent to `no-cache`, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of `500`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
    */
    readonly ttl?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _preserveStale?;
    get preserveStale(): boolean | cdktf.IResolvable;
    set preserveStale(value: boolean | cdktf.IResolvable);
    resetPreserveStale(): void;
    get preserveStaleInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _ttl?;
    get ttl(): string;
    set ttl(value: string);
    resetTtl(): void;
    get ttlInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId {
    /**
    * Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
    */
    readonly elements?: string[];
    /**
    * Includes the value of the specified elements in the cache ID. Otherwise only their names are included.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
    */
    readonly includeValue?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
    */
    readonly optional?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to modify the cache ID.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
    */
    readonly rule?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the name of the variable you want to include in the cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
    */
    readonly variableName?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId | undefined);
    private _elements?;
    get elements(): string[];
    set elements(value: string[]);
    resetElements(): void;
    get elementsInput(): string[] | undefined;
    private _includeValue?;
    get includeValue(): boolean | cdktf.IResolvable;
    set includeValue(value: boolean | cdktf.IResolvable);
    resetIncludeValue(): void;
    get includeValueInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _optional?;
    get optional(): boolean | cdktf.IResolvable;
    set optional(value: boolean | cdktf.IResolvable);
    resetOptional(): void;
    get optionalInput(): boolean | cdktf.IResolvable | undefined;
    private _rule?;
    get rule(): string;
    set rule(value: string);
    resetRule(): void;
    get ruleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _variableName?;
    get variableName(): string;
    set variableName(value: string);
    resetVariableName(): void;
    get variableNameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase {
    /**
    * Ignores case when forming cache keys.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams {
    /**
    * Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is `not` reflected in the cached object.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * When enabled, `parameters` needs to match exactly. Keep disabled to match string prefixes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
    */
    readonly exactMatch?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
    */
    readonly parameters?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _exactMatch?;
    get exactMatch(): boolean | cdktf.IResolvable;
    set exactMatch(value: boolean | cdktf.IResolvable);
    resetExactMatch(): void;
    get exactMatchInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _parameters?;
    get parameters(): string[];
    set parameters(value: string[]);
    resetParameters(): void;
    get parametersInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the new cache key path as an alphanumeric value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
    */
    readonly purgeKey?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _purgeKey?;
    get purgeKey(): string;
    set purgeKey(value: string);
    resetPurgeKey(): void;
    get purgeKeyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost {
    /**
    * Enables caching of POST responses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Define how and whether to use the POST message body as a cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
    */
    readonly useBody?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useBody?;
    get useBody(): string;
    set useBody(value: string);
    resetUseBody(): void;
    get useBodyInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect {
    /**
    * Enables the redirect caching behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ```[!#$%'+./^_`|~-]```
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
    */
    readonly tag?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _tag?;
    get tag(): string;
    set tag(value: string);
    resetTag(): void;
    get tagInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible {
    /**
    * Specifies when to include the `Edge-Cache-Tag` in responses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching {
    /**
    * Specify the caching option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
    */
    readonly cacheControlDirectives?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
    */
    readonly cacheabilitySettings?: string;
    /**
    * Set the `MAX_AGE` header for the cached content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
    */
    readonly defaultTtl?: string;
    /**
    * This enables honoring particular `Cache-Control` header directives from the origin. Supports all official `RFC 7234` directives except for `no-transform`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
    */
    readonly enhancedRfcSupport?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
    */
    readonly expirationSettings?: string;
    /**
    * This instructs edge servers to cache the object for a length of time set by the `max-age` directive in the response. When present in the origin response, this directive takes precedence over the `max-age` directive and the `defaultTtl` setting.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
    */
    readonly honorMaxAge?: boolean | cdktf.IResolvable;
    /**
    * This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
    */
    readonly honorMustRevalidate?: boolean | cdktf.IResolvable;
    /**
    * With the `no-cache` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live `ttl` to zero seconds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
    */
    readonly honorNoCache?: boolean | cdktf.IResolvable;
    /**
    * Instructs edge servers not to cache the response when the origin response includes the `no-store` directive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
    */
    readonly honorNoStore?: boolean | cdktf.IResolvable;
    /**
    * Instructs edge servers not to cache the response when the origin response includes the `private` directive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
    */
    readonly honorPrivate?: boolean | cdktf.IResolvable;
    /**
    * With the `proxy-revalidate` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
    */
    readonly honorProxyRevalidate?: boolean | cdktf.IResolvable;
    /**
    * Instructs edge servers to cache the object for a length of time set by the `s-maxage` directive in the response. When present in the origin response, this directive takes precedence over the `max-age` directive and the `defaultTtl` setting.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
    */
    readonly honorSMaxage?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
    */
    readonly mustRevalidate?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
    */
    readonly revalidationSettings?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * The maximum time content may remain cached. Setting the value to `0` is the same as setting a `no-cache` header, which forces content to revalidate.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
    */
    readonly ttl?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _cacheControlDirectives?;
    get cacheControlDirectives(): string;
    set cacheControlDirectives(value: string);
    resetCacheControlDirectives(): void;
    get cacheControlDirectivesInput(): string | undefined;
    private _cacheabilitySettings?;
    get cacheabilitySettings(): string;
    set cacheabilitySettings(value: string);
    resetCacheabilitySettings(): void;
    get cacheabilitySettingsInput(): string | undefined;
    private _defaultTtl?;
    get defaultTtl(): string;
    set defaultTtl(value: string);
    resetDefaultTtl(): void;
    get defaultTtlInput(): string | undefined;
    private _enhancedRfcSupport?;
    get enhancedRfcSupport(): boolean | cdktf.IResolvable;
    set enhancedRfcSupport(value: boolean | cdktf.IResolvable);
    resetEnhancedRfcSupport(): void;
    get enhancedRfcSupportInput(): boolean | cdktf.IResolvable | undefined;
    private _expirationSettings?;
    get expirationSettings(): string;
    set expirationSettings(value: string);
    resetExpirationSettings(): void;
    get expirationSettingsInput(): string | undefined;
    private _honorMaxAge?;
    get honorMaxAge(): boolean | cdktf.IResolvable;
    set honorMaxAge(value: boolean | cdktf.IResolvable);
    resetHonorMaxAge(): void;
    get honorMaxAgeInput(): boolean | cdktf.IResolvable | undefined;
    private _honorMustRevalidate?;
    get honorMustRevalidate(): boolean | cdktf.IResolvable;
    set honorMustRevalidate(value: boolean | cdktf.IResolvable);
    resetHonorMustRevalidate(): void;
    get honorMustRevalidateInput(): boolean | cdktf.IResolvable | undefined;
    private _honorNoCache?;
    get honorNoCache(): boolean | cdktf.IResolvable;
    set honorNoCache(value: boolean | cdktf.IResolvable);
    resetHonorNoCache(): void;
    get honorNoCacheInput(): boolean | cdktf.IResolvable | undefined;
    private _honorNoStore?;
    get honorNoStore(): boolean | cdktf.IResolvable;
    set honorNoStore(value: boolean | cdktf.IResolvable);
    resetHonorNoStore(): void;
    get honorNoStoreInput(): boolean | cdktf.IResolvable | undefined;
    private _honorPrivate?;
    get honorPrivate(): boolean | cdktf.IResolvable;
    set honorPrivate(value: boolean | cdktf.IResolvable);
    resetHonorPrivate(): void;
    get honorPrivateInput(): boolean | cdktf.IResolvable | undefined;
    private _honorProxyRevalidate?;
    get honorProxyRevalidate(): boolean | cdktf.IResolvable;
    set honorProxyRevalidate(value: boolean | cdktf.IResolvable);
    resetHonorProxyRevalidate(): void;
    get honorProxyRevalidateInput(): boolean | cdktf.IResolvable | undefined;
    private _honorSMaxage?;
    get honorSMaxage(): boolean | cdktf.IResolvable;
    set honorSMaxage(value: boolean | cdktf.IResolvable);
    resetHonorSMaxage(): void;
    get honorSMaxageInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mustRevalidate?;
    get mustRevalidate(): boolean | cdktf.IResolvable;
    set mustRevalidate(value: boolean | cdktf.IResolvable);
    resetMustRevalidate(): void;
    get mustRevalidateInput(): boolean | cdktf.IResolvable | undefined;
    private _revalidationSettings?;
    get revalidationSettings(): string;
    set revalidationSettings(value: string);
    resetRevalidationSettings(): void;
    get revalidationSettingsInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _ttl?;
    get ttl(): string;
    set ttl(value: string);
    resetTtl(): void;
    get ttlInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization {
    /**
    * Enables the centralized authorization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects {
    /**
    * Allows edge servers to chase redirects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies, as a string, the maximum number of redirects to follow.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Once the redirect `limit` is reached, enabling this option serves an HTTP `404` (Not Found) error instead of the last redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
    */
    readonly serve404?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _limit?;
    get limit(): string;
    set limit(value: string);
    resetLimit(): void;
    get limitInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _serve404?;
    get serve404(): boolean | cdktf.IResolvable;
    set serve404(value: boolean | cdktf.IResolvable);
    resetServe404(): void;
    get serve404Input(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth {
    /**
    * Specify client certificate attributes to include in the `Client-To-Edge` authentication header that's sent to your origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
    */
    readonly clientCertificateAttributes?: string[];
    /**
    * Constructs the `Client-To-Edge` authentication header using information from the client to edge mTLS handshake and forwards it to your origin. You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Whether to include the current validation status of the client certificate in the `Client-To-Edge` authentication header. This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
    */
    readonly enableClientCertificateValidationStatus?: boolean | cdktf.IResolvable;
    /**
    * Whether to include the complete client certificate in the header, in its binary (DER) format. DER-formatted certificates leave out the `BEGIN CERTIFICATE/END CERTIFICATE` statements and most often use the `.der` extension. Alternatively, you can specify individual `clientCertificateAttributes` you want included in the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
    */
    readonly enableCompleteClientCertificate?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth | undefined);
    private _clientCertificateAttributes?;
    get clientCertificateAttributes(): string[];
    set clientCertificateAttributes(value: string[]);
    resetClientCertificateAttributes(): void;
    get clientCertificateAttributesInput(): string[] | undefined;
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _enableClientCertificateValidationStatus?;
    get enableClientCertificateValidationStatus(): boolean | cdktf.IResolvable;
    set enableClientCertificateValidationStatus(value: boolean | cdktf.IResolvable);
    resetEnableClientCertificateValidationStatus(): void;
    get enableClientCertificateValidationStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _enableCompleteClientCertificate?;
    get enableCompleteClientCertificate(): boolean | cdktf.IResolvable;
    set enableCompleteClientCertificate(value: boolean | cdktf.IResolvable);
    resetEnableCompleteClientCertificate(): void;
    get enableCompleteClientCertificateInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics {
    /**
    * Specifies the client request's geographic region.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
    */
    readonly country?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics | undefined);
    private _country?;
    get country(): string;
    set country(value: string);
    resetCountry(): void;
    get countryInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects {
    /**
    * Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
    */
    readonly cloudLocations?: string[];
    /**
    * Channels the traffic to maximize the egress discount at the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects | undefined);
    private _cloudLocations?;
    get cloudLocations(): string[];
    set cloudLocations(value: string[]);
    resetCloudLocations(): void;
    get cloudLocationsInput(): string[] | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper {
    /**
    * Enables Cloud Wrapper behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
    */
    readonly location?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced {
    /**
    * Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
    */
    readonly customFailoverMap?: string;
    /**
    * Enables failover for Cloud Wrapper.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
    */
    readonly failoverMap?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced | undefined);
    private _customFailoverMap?;
    get customFailoverMap(): string;
    set customFailoverMap(value: string);
    resetCustomFailoverMap(): void;
    get customFailoverMapInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverMap?;
    get failoverMap(): string;
    set failoverMap(value: string);
    resetFailoverMap(): void;
    get failoverMapInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData {
    /**
    * Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
    */
    readonly enableCmcdSegmentPrefetch?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData | undefined);
    private _enableCmcdSegmentPrefetch?;
    get enableCmcdSegmentPrefetch(): boolean | cdktf.IResolvable;
    set enableCmcdSegmentPrefetch(value: boolean | cdktf.IResolvable);
    resetEnableCmcdSegmentPrefetch(): void;
    get enableCmcdSegmentPrefetchInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
    */
    readonly originId?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse {
    /**
    * HTML response of up to 2000 characters to send to the end-user client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
    */
    readonly body?: string;
    /**
    * Serves the custom response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to `false`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
    */
    readonly forceEviction?: boolean | cdktf.IResolvable;
    /**
    * Whether to ignore the custom response when purging.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
    */
    readonly ignorePurge?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The HTTP response code to send to the end-user client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
    */
    readonly responseCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse | undefined);
    private _body?;
    get body(): string;
    set body(value: string);
    resetBody(): void;
    get bodyInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _forceEviction?;
    get forceEviction(): boolean | cdktf.IResolvable;
    set forceEviction(value: boolean | cdktf.IResolvable);
    resetForceEviction(): void;
    get forceEvictionInput(): boolean | cdktf.IResolvable | undefined;
    private _ignorePurge?;
    get ignorePurge(): boolean | cdktf.IResolvable;
    set ignorePurge(value: boolean | cdktf.IResolvable);
    resetIgnorePurge(): void;
    get ignorePurgeInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _responseCode?;
    get responseCode(): number;
    set responseCode(value: number);
    resetResponseCode(): void;
    get responseCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the type of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the size of the object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the quality of media content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Enable delivery of DASH media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
    */
    readonly dash?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HDS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
    */
    readonly hds?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HLS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
    */
    readonly hls?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
    */
    readonly segmentDurationDash?: string;
    /**
    * Customizes the number of seconds for the segment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
    */
    readonly segmentDurationDashCustom?: number;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
    */
    readonly segmentDurationHds?: string;
    /**
    * Customizes the number of seconds for the fragment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
    */
    readonly segmentDurationHdsCustom?: number;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
    */
    readonly segmentDurationHls?: string;
    /**
    * Customizes the number of seconds for the segment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
    */
    readonly segmentDurationHlsCustom?: number;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
    */
    readonly segmentDurationSmooth?: string;
    /**
    * Customizes the number of seconds for the fragment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
    */
    readonly segmentDurationSmoothCustom?: number;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
    */
    readonly segmentSizeDash?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
    */
    readonly segmentSizeHds?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
    */
    readonly segmentSizeHls?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
    */
    readonly segmentSizeSmooth?: string;
    /**
    * Enable delivery of Smooth media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
    */
    readonly smooth?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _dash?;
    get dash(): boolean | cdktf.IResolvable;
    set dash(value: boolean | cdktf.IResolvable);
    resetDash(): void;
    get dashInput(): boolean | cdktf.IResolvable | undefined;
    private _hds?;
    get hds(): boolean | cdktf.IResolvable;
    set hds(value: boolean | cdktf.IResolvable);
    resetHds(): void;
    get hdsInput(): boolean | cdktf.IResolvable | undefined;
    private _hls?;
    get hls(): boolean | cdktf.IResolvable;
    set hls(value: boolean | cdktf.IResolvable);
    resetHls(): void;
    get hlsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _segmentDurationDash?;
    get segmentDurationDash(): string;
    set segmentDurationDash(value: string);
    resetSegmentDurationDash(): void;
    get segmentDurationDashInput(): string | undefined;
    private _segmentDurationDashCustom?;
    get segmentDurationDashCustom(): number;
    set segmentDurationDashCustom(value: number);
    resetSegmentDurationDashCustom(): void;
    get segmentDurationDashCustomInput(): number | undefined;
    private _segmentDurationHds?;
    get segmentDurationHds(): string;
    set segmentDurationHds(value: string);
    resetSegmentDurationHds(): void;
    get segmentDurationHdsInput(): string | undefined;
    private _segmentDurationHdsCustom?;
    get segmentDurationHdsCustom(): number;
    set segmentDurationHdsCustom(value: number);
    resetSegmentDurationHdsCustom(): void;
    get segmentDurationHdsCustomInput(): number | undefined;
    private _segmentDurationHls?;
    get segmentDurationHls(): string;
    set segmentDurationHls(value: string);
    resetSegmentDurationHls(): void;
    get segmentDurationHlsInput(): string | undefined;
    private _segmentDurationHlsCustom?;
    get segmentDurationHlsCustom(): number;
    set segmentDurationHlsCustom(value: number);
    resetSegmentDurationHlsCustom(): void;
    get segmentDurationHlsCustomInput(): number | undefined;
    private _segmentDurationSmooth?;
    get segmentDurationSmooth(): string;
    set segmentDurationSmooth(value: string);
    resetSegmentDurationSmooth(): void;
    get segmentDurationSmoothInput(): string | undefined;
    private _segmentDurationSmoothCustom?;
    get segmentDurationSmoothCustom(): number;
    set segmentDurationSmoothCustom(value: number);
    resetSegmentDurationSmoothCustom(): void;
    get segmentDurationSmoothCustomInput(): number | undefined;
    private _segmentSizeDash?;
    get segmentSizeDash(): string;
    set segmentSizeDash(value: string);
    resetSegmentSizeDash(): void;
    get segmentSizeDashInput(): string | undefined;
    private _segmentSizeHds?;
    get segmentSizeHds(): string;
    set segmentSizeHds(value: string);
    resetSegmentSizeHds(): void;
    get segmentSizeHdsInput(): string | undefined;
    private _segmentSizeHls?;
    get segmentSizeHls(): string;
    set segmentSizeHls(value: string);
    resetSegmentSizeHls(): void;
    get segmentSizeHlsInput(): string | undefined;
    private _segmentSizeSmooth?;
    get segmentSizeSmooth(): string;
    set segmentSizeSmooth(value: string);
    resetSegmentSizeSmooth(): void;
    get segmentSizeSmoothInput(): string | undefined;
    private _smooth?;
    get smooth(): boolean | cdktf.IResolvable;
    set smooth(value: boolean | cdktf.IResolvable);
    resetSmooth(): void;
    get smoothInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the type of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the size of the object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * Optimizes the delivery throughput and download times for large files.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
    */
    readonly optimizeOption?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _optimizeOption?;
    get optimizeOption(): boolean | cdktf.IResolvable;
    set optimizeOption(value: boolean | cdktf.IResolvable);
    resetOptimizeOption(): void;
    get optimizeOptionInput(): boolean | cdktf.IResolvable | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the type of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the size of the object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the quality of media content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Enable delivery of DASH media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
    */
    readonly dash?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HDS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
    */
    readonly hds?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HLS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
    */
    readonly hls?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
    */
    readonly segmentDurationDash?: string;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
    */
    readonly segmentDurationHds?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
    */
    readonly segmentDurationHls?: string;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
    */
    readonly segmentDurationSmooth?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
    */
    readonly segmentSizeDash?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
    */
    readonly segmentSizeHds?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
    */
    readonly segmentSizeHls?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
    */
    readonly segmentSizeSmooth?: string;
    /**
    * Enable delivery of Smooth media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
    */
    readonly smooth?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _dash?;
    get dash(): boolean | cdktf.IResolvable;
    set dash(value: boolean | cdktf.IResolvable);
    resetDash(): void;
    get dashInput(): boolean | cdktf.IResolvable | undefined;
    private _hds?;
    get hds(): boolean | cdktf.IResolvable;
    set hds(value: boolean | cdktf.IResolvable);
    resetHds(): void;
    get hdsInput(): boolean | cdktf.IResolvable | undefined;
    private _hls?;
    get hls(): boolean | cdktf.IResolvable;
    set hls(value: boolean | cdktf.IResolvable);
    resetHls(): void;
    get hlsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _segmentDurationDash?;
    get segmentDurationDash(): string;
    set segmentDurationDash(value: string);
    resetSegmentDurationDash(): void;
    get segmentDurationDashInput(): string | undefined;
    private _segmentDurationHds?;
    get segmentDurationHds(): string;
    set segmentDurationHds(value: string);
    resetSegmentDurationHds(): void;
    get segmentDurationHdsInput(): string | undefined;
    private _segmentDurationHls?;
    get segmentDurationHls(): string;
    set segmentDurationHls(value: string);
    resetSegmentDurationHls(): void;
    get segmentDurationHlsInput(): string | undefined;
    private _segmentDurationSmooth?;
    get segmentDurationSmooth(): string;
    set segmentDurationSmooth(value: string);
    resetSegmentDurationSmooth(): void;
    get segmentDurationSmoothInput(): string | undefined;
    private _segmentSizeDash?;
    get segmentSizeDash(): string;
    set segmentSizeDash(value: string);
    resetSegmentSizeDash(): void;
    get segmentSizeDashInput(): string | undefined;
    private _segmentSizeHds?;
    get segmentSizeHds(): string;
    set segmentSizeHds(value: string);
    resetSegmentSizeHds(): void;
    get segmentSizeHdsInput(): string | undefined;
    private _segmentSizeHls?;
    get segmentSizeHls(): string;
    set segmentSizeHls(value: string);
    resetSegmentSizeHls(): void;
    get segmentSizeHlsInput(): string | undefined;
    private _segmentSizeSmooth?;
    get segmentSizeSmooth(): string;
    set segmentSizeSmooth(value: string);
    resetSegmentSizeSmooth(): void;
    get segmentSizeSmoothInput(): string | undefined;
    private _smooth?;
    get smooth(): boolean | cdktf.IResolvable;
    set smooth(value: boolean | cdktf.IResolvable);
    resetSmooth(): void;
    get smoothInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the quality of media content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Enable delivery of DASH media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
    */
    readonly dash?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HDS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
    */
    readonly hds?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HLS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
    */
    readonly hls?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
    */
    readonly segmentDurationDash?: string;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
    */
    readonly segmentDurationHds?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
    */
    readonly segmentDurationHls?: string;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
    */
    readonly segmentDurationSmooth?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
    */
    readonly segmentSizeDash?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
    */
    readonly segmentSizeHds?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
    */
    readonly segmentSizeHls?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
    */
    readonly segmentSizeSmooth?: string;
    /**
    * Enable delivery of Smooth media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
    */
    readonly smooth?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _dash?;
    get dash(): boolean | cdktf.IResolvable;
    set dash(value: boolean | cdktf.IResolvable);
    resetDash(): void;
    get dashInput(): boolean | cdktf.IResolvable | undefined;
    private _hds?;
    get hds(): boolean | cdktf.IResolvable;
    set hds(value: boolean | cdktf.IResolvable);
    resetHds(): void;
    get hdsInput(): boolean | cdktf.IResolvable | undefined;
    private _hls?;
    get hls(): boolean | cdktf.IResolvable;
    set hls(value: boolean | cdktf.IResolvable);
    resetHls(): void;
    get hlsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _segmentDurationDash?;
    get segmentDurationDash(): string;
    set segmentDurationDash(value: string);
    resetSegmentDurationDash(): void;
    get segmentDurationDashInput(): string | undefined;
    private _segmentDurationHds?;
    get segmentDurationHds(): string;
    set segmentDurationHds(value: string);
    resetSegmentDurationHds(): void;
    get segmentDurationHdsInput(): string | undefined;
    private _segmentDurationHls?;
    get segmentDurationHls(): string;
    set segmentDurationHls(value: string);
    resetSegmentDurationHls(): void;
    get segmentDurationHlsInput(): string | undefined;
    private _segmentDurationSmooth?;
    get segmentDurationSmooth(): string;
    set segmentDurationSmooth(value: string);
    resetSegmentDurationSmooth(): void;
    get segmentDurationSmoothInput(): string | undefined;
    private _segmentSizeDash?;
    get segmentSizeDash(): string;
    set segmentSizeDash(value: string);
    resetSegmentSizeDash(): void;
    get segmentSizeDashInput(): string | undefined;
    private _segmentSizeHds?;
    get segmentSizeHds(): string;
    set segmentSizeHds(value: string);
    resetSegmentSizeHds(): void;
    get segmentSizeHdsInput(): string | undefined;
    private _segmentSizeHls?;
    get segmentSizeHls(): string;
    set segmentSizeHls(value: string);
    resetSegmentSizeHls(): void;
    get segmentSizeHlsInput(): string | undefined;
    private _segmentSizeSmooth?;
    get segmentSizeSmooth(): string;
    set segmentSizeSmooth(value: string);
    resetSegmentSizeSmooth(): void;
    get segmentSizeSmoothInput(): string | undefined;
    private _smooth?;
    get smooth(): boolean | cdktf.IResolvable;
    set smooth(value: boolean | cdktf.IResolvable);
    resetSmooth(): void;
    get smoothInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition {
    /**
    * Enables the Content PrePosition behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}
    */
    readonly firstLocation?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}
    */
    readonly secondLocation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}
    */
    readonly sourceType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}
    */
    readonly targets?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _firstLocation?;
    get firstLocation(): string;
    set firstLocation(value: string);
    resetFirstLocation(): void;
    get firstLocationInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _secondLocation?;
    get secondLocation(): string;
    set secondLocation(value: string);
    resetSecondLocation(): void;
    get secondLocationInput(): string | undefined;
    private _sourceType?;
    get sourceType(): string;
    set sourceType(value: string);
    resetSourceType(): void;
    get sourceTypeInput(): string | undefined;
    private _targets?;
    get targets(): string;
    set targets(value: string);
    resetTargets(): void;
    get targetsInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection {
    /**
    * Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See `EdgeScape Data Codes` for a list.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
    */
    readonly countries?: string[];
    /**
    * Specifies the set of Designated Market Area codes from which to allow or deny traffic.  See `EdgeScape Data Codes` for a list.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
    */
    readonly dmas?: string[];
    /**
    * When enabled, verifies IP addresses are unique to specific geographic regions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
    */
    readonly enableGeoProtection?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects denied requests rather than responding with an error code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
    */
    readonly enableGeoRedirectOnDeny?: boolean | cdktf.IResolvable;
    /**
    * Allows you to control access to your content from specific sets of IP addresses and CIDR blocks.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
    */
    readonly enableIpProtection?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects denied requests rather than responding with an error code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
    */
    readonly enableIpRedirectOnDeny?: boolean | cdktf.IResolvable;
    /**
    * Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
    */
    readonly enableReferrerProtection?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects denied requests rather than responding with an error code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
    */
    readonly enableReferrerRedirectOnDeny?: boolean | cdktf.IResolvable;
    /**
    * Enables the Content Targeting feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to handle requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
    */
    readonly geoProtectionMode?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
    */
    readonly geoProtectionTitle?: string;
    /**
    * This specifies the full URL to the redirect page for denied requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
    */
    readonly geoRedirectUrl?: string;
    /**
    * Specify a set of IP addresses or CIDR blocks to allow or deny.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
    */
    readonly ipAddresses?: string[];
    /**
    * Specifies how to handle requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
    */
    readonly ipProtectionMode?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
    */
    readonly ipProtectionTitle?: string;
    /**
    * This specifies the full URL to the redirect page for denied requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
    */
    readonly ipRedirectUrl?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
    */
    readonly overrideIpAddresses?: string[];
    /**
    * Specifies the set of domains from which to allow or deny traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
    */
    readonly referrerDomains?: string[];
    /**
    * Specify the action to take.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
    */
    readonly referrerProtectionMode?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
    */
    readonly referrerProtectionTitle?: string;
    /**
    * This specifies the full URL to the redirect page for denied requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
    */
    readonly referrerRedirectUrl?: string;
    /**
    * Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See `EdgeScape Data Codes` for a list.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
    */
    readonly regions?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection | undefined);
    private _countries?;
    get countries(): string[];
    set countries(value: string[]);
    resetCountries(): void;
    get countriesInput(): string[] | undefined;
    private _dmas?;
    get dmas(): string[];
    set dmas(value: string[]);
    resetDmas(): void;
    get dmasInput(): string[] | undefined;
    private _enableGeoProtection?;
    get enableGeoProtection(): boolean | cdktf.IResolvable;
    set enableGeoProtection(value: boolean | cdktf.IResolvable);
    resetEnableGeoProtection(): void;
    get enableGeoProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableGeoRedirectOnDeny?;
    get enableGeoRedirectOnDeny(): boolean | cdktf.IResolvable;
    set enableGeoRedirectOnDeny(value: boolean | cdktf.IResolvable);
    resetEnableGeoRedirectOnDeny(): void;
    get enableGeoRedirectOnDenyInput(): boolean | cdktf.IResolvable | undefined;
    private _enableIpProtection?;
    get enableIpProtection(): boolean | cdktf.IResolvable;
    set enableIpProtection(value: boolean | cdktf.IResolvable);
    resetEnableIpProtection(): void;
    get enableIpProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableIpRedirectOnDeny?;
    get enableIpRedirectOnDeny(): boolean | cdktf.IResolvable;
    set enableIpRedirectOnDeny(value: boolean | cdktf.IResolvable);
    resetEnableIpRedirectOnDeny(): void;
    get enableIpRedirectOnDenyInput(): boolean | cdktf.IResolvable | undefined;
    private _enableReferrerProtection?;
    get enableReferrerProtection(): boolean | cdktf.IResolvable;
    set enableReferrerProtection(value: boolean | cdktf.IResolvable);
    resetEnableReferrerProtection(): void;
    get enableReferrerProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableReferrerRedirectOnDeny?;
    get enableReferrerRedirectOnDeny(): boolean | cdktf.IResolvable;
    set enableReferrerRedirectOnDeny(value: boolean | cdktf.IResolvable);
    resetEnableReferrerRedirectOnDeny(): void;
    get enableReferrerRedirectOnDenyInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _geoProtectionMode?;
    get geoProtectionMode(): string;
    set geoProtectionMode(value: string);
    resetGeoProtectionMode(): void;
    get geoProtectionModeInput(): string | undefined;
    private _geoProtectionTitle?;
    get geoProtectionTitle(): string;
    set geoProtectionTitle(value: string);
    resetGeoProtectionTitle(): void;
    get geoProtectionTitleInput(): string | undefined;
    private _geoRedirectUrl?;
    get geoRedirectUrl(): string;
    set geoRedirectUrl(value: string);
    resetGeoRedirectUrl(): void;
    get geoRedirectUrlInput(): string | undefined;
    private _ipAddresses?;
    get ipAddresses(): string[];
    set ipAddresses(value: string[]);
    resetIpAddresses(): void;
    get ipAddressesInput(): string[] | undefined;
    private _ipProtectionMode?;
    get ipProtectionMode(): string;
    set ipProtectionMode(value: string);
    resetIpProtectionMode(): void;
    get ipProtectionModeInput(): string | undefined;
    private _ipProtectionTitle?;
    get ipProtectionTitle(): string;
    set ipProtectionTitle(value: string);
    resetIpProtectionTitle(): void;
    get ipProtectionTitleInput(): string | undefined;
    private _ipRedirectUrl?;
    get ipRedirectUrl(): string;
    set ipRedirectUrl(value: string);
    resetIpRedirectUrl(): void;
    get ipRedirectUrlInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideIpAddresses?;
    get overrideIpAddresses(): string[];
    set overrideIpAddresses(value: string[]);
    resetOverrideIpAddresses(): void;
    get overrideIpAddressesInput(): string[] | undefined;
    private _referrerDomains?;
    get referrerDomains(): string[];
    set referrerDomains(value: string[]);
    resetReferrerDomains(): void;
    get referrerDomainsInput(): string[] | undefined;
    private _referrerProtectionMode?;
    get referrerProtectionMode(): string;
    set referrerProtectionMode(value: string);
    resetReferrerProtectionMode(): void;
    get referrerProtectionModeInput(): string | undefined;
    private _referrerProtectionTitle?;
    get referrerProtectionTitle(): string;
    set referrerProtectionTitle(value: string);
    resetReferrerProtectionTitle(): void;
    get referrerProtectionTitleInput(): string | undefined;
    private _referrerRedirectUrl?;
    get referrerRedirectUrl(): string;
    set referrerRedirectUrl(value: string);
    resetReferrerRedirectUrl(): void;
    get referrerRedirectUrlInput(): string | undefined;
    private _regions?;
    get regions(): string[];
    set regions(value: string[]);
    resetRegions(): void;
    get regionsInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport {
    /**
    * Accepts requests made using credentials, like cookies or TLS client certificates.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
    */
    readonly allowCredentials?: boolean | cdktf.IResolvable;
    /**
    * In responses to preflight requests, defines which headers to allow when making the actual request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
    */
    readonly allowHeaders?: string;
    /**
    * In responses to preflight requests, sets which origin hostnames to accept requests from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
    */
    readonly allowOrigins?: string;
    /**
    * Enables CORS feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: `Cache-Control`, `Content-Language`, `Content-Type`, `Expires`, `Last-Modified`, and `Pragma`. You can add other header names to make them accessible to clients.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
    */
    readonly exposeHeaders?: string[];
    /**
    * Defines the supported request headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
    */
    readonly headers?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies any combination of the following methods: `DELETE`, `GET`, `PATCH`, `POST`, and `PUT` that are allowed when accessing the resource from an external domain.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
    */
    readonly methods?: string[];
    /**
    * Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with `http` or `https`. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
    */
    readonly origins?: string[];
    /**
    * Defines the number of seconds that the browser should cache the response to a preflight request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
    */
    readonly preflightMaxAge?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport | undefined);
    private _allowCredentials?;
    get allowCredentials(): boolean | cdktf.IResolvable;
    set allowCredentials(value: boolean | cdktf.IResolvable);
    resetAllowCredentials(): void;
    get allowCredentialsInput(): boolean | cdktf.IResolvable | undefined;
    private _allowHeaders?;
    get allowHeaders(): string;
    set allowHeaders(value: string);
    resetAllowHeaders(): void;
    get allowHeadersInput(): string | undefined;
    private _allowOrigins?;
    get allowOrigins(): string;
    set allowOrigins(value: string);
    resetAllowOrigins(): void;
    get allowOriginsInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _exposeHeaders?;
    get exposeHeaders(): string[];
    set exposeHeaders(value: string[]);
    resetExposeHeaders(): void;
    get exposeHeadersInput(): string[] | undefined;
    private _headers?;
    get headers(): string[];
    set headers(value: string[]);
    resetHeaders(): void;
    get headersInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _methods?;
    get methods(): string[];
    set methods(value: string[]);
    resetMethods(): void;
    get methodsInput(): string[] | undefined;
    private _origins?;
    get origins(): string[];
    set origins(value: string[]);
    resetOrigins(): void;
    get originsInput(): string[] | undefined;
    private _preflightMaxAge?;
    get preflightMaxAge(): string;
    set preflightMaxAge(value: string);
    resetPreflightMaxAge(): void;
    get preflightMaxAgeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * value block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value;
    get value(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference;
    putValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue): void;
    resetValue(): void;
    get valueInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior {
    /**
    * The unique identifier for the predefined custom behavior you want to insert into the current rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
    */
    readonly behaviorId?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior | undefined);
    private _behaviorId?;
    get behaviorId(): string;
    set behaviorId(value: string);
    resetBehaviorId(): void;
    get behaviorIdInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
    */
    readonly beaconStreamTitle?: string;
    /**
    * If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
    */
    readonly collectMidgressTraffic?: boolean | cdktf.IResolvable;
    /**
    * A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
    */
    readonly datastreamIds?: string;
    /**
    * Enables DataStream reporting.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables log collection for the property by associating it with DataStream configurations.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
    */
    readonly logEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the `List streams` operation to get stream IDs.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
    */
    readonly logStreamName?: string[];
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
    */
    readonly logStreamTitle?: string;
    /**
    * Specifies the percentage of log data you want to collect for this property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
    */
    readonly samplingPercentage?: number;
    /**
    * Specify the DataStream type.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
    */
    readonly streamType?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream | undefined);
    private _beaconStreamTitle?;
    get beaconStreamTitle(): string;
    set beaconStreamTitle(value: string);
    resetBeaconStreamTitle(): void;
    get beaconStreamTitleInput(): string | undefined;
    private _collectMidgressTraffic?;
    get collectMidgressTraffic(): boolean | cdktf.IResolvable;
    set collectMidgressTraffic(value: boolean | cdktf.IResolvable);
    resetCollectMidgressTraffic(): void;
    get collectMidgressTrafficInput(): boolean | cdktf.IResolvable | undefined;
    private _datastreamIds?;
    get datastreamIds(): string;
    set datastreamIds(value: string);
    resetDatastreamIds(): void;
    get datastreamIdsInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _logEnabled?;
    get logEnabled(): boolean | cdktf.IResolvable;
    set logEnabled(value: boolean | cdktf.IResolvable);
    resetLogEnabled(): void;
    get logEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _logStreamName?;
    get logStreamName(): string[];
    set logStreamName(value: string[]);
    resetLogStreamName(): void;
    get logStreamNameInput(): string[] | undefined;
    private _logStreamTitle?;
    get logStreamTitle(): string;
    set logStreamTitle(value: string);
    resetLogStreamTitle(): void;
    get logStreamTitleInput(): string | undefined;
    private _samplingPercentage?;
    get samplingPercentage(): number;
    set samplingPercentage(value: number);
    resetSamplingPercentage(): void;
    get samplingPercentageInput(): number | undefined;
    private _streamType?;
    get streamType(): string;
    set streamType(value: string);
    resetStreamType(): void;
    get streamTypeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp {
    /**
    * When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
    */
    readonly anonymous?: boolean | cdktf.IResolvable;
    /**
    * Enables IoT Edge Connect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * When enabled, you can publish and receive messages over a secured HTTP connection on port 443.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
    */
    readonly gwenabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as `topics`. This provides a root path for all topics defined within a namespace configuration.  You can use the `IoT Edge Connect API` to configure access control lists for your namespace configuration.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
    */
    readonly namespaceId?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When enabled, you can publish and receive messages over a secured MQTT connection on port 8883.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
    */
    readonly tlsenabled?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
    */
    readonly wsenabled?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp | undefined);
    private _anonymous?;
    get anonymous(): boolean | cdktf.IResolvable;
    set anonymous(value: boolean | cdktf.IResolvable);
    resetAnonymous(): void;
    get anonymousInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _gwenabled?;
    get gwenabled(): boolean | cdktf.IResolvable;
    set gwenabled(value: boolean | cdktf.IResolvable);
    resetGwenabled(): void;
    get gwenabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _namespaceId?;
    get namespaceId(): string;
    set namespaceId(value: string);
    resetNamespaceId(): void;
    get namespaceIdInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tlsenabled?;
    get tlsenabled(): boolean | cdktf.IResolvable;
    set tlsenabled(value: boolean | cdktf.IResolvable);
    resetTlsenabled(): void;
    get tlsenabledInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _wsenabled?;
    get wsenabled(): boolean | cdktf.IResolvable;
    set wsenabled(value: boolean | cdktf.IResolvable);
    resetWsenabled(): void;
    get wsenabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation {
    /**
    * Specifies the hash algorithm.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
    */
    readonly hashConversionAlgorithm?: string;
    /**
    * Specifies the key to generate the hash, ideally a long random string to ensure adequate security.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
    */
    readonly hashConversionKey?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation | undefined);
    private _hashConversionAlgorithm?;
    get hashConversionAlgorithm(): string;
    set hashConversionAlgorithm(value: string);
    resetHashConversionAlgorithm(): void;
    get hashConversionAlgorithmInput(): string | undefined;
    private _hashConversionKey?;
    get hashConversionKey(): string;
    set hashConversionKey(value: string);
    resetHashConversionKey(): void;
    get hashConversionKeyInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies a Perl-compatible regular expression with a single grouping to capture the text.  For example, a value of `^.(.{0,10})` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
    */
    readonly regexPattern?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _regexPattern?;
    get regexPattern(): string;
    set regexPattern(value: string);
    resetRegexPattern(): void;
    get regexPatternInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The zero-based index offset of the last character to extract, where `-1` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
    */
    readonly substringEnd?: string;
    /**
    * The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
    */
    readonly substringStart?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _substringEnd?;
    get substringEnd(): string;
    set substringEnd(value: string);
    resetSubstringEnd(): void;
    get substringEndInput(): string | undefined;
    private _substringStart?;
    get substringStart(): string;
    set substringStart(value: string);
    resetSubstringStart(): void;
    get substringStartInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor {
    /**
    * Specifies the field in the client certificate to extract the variable from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
    */
    readonly certificateField?: string;
    /**
    * Where to store the value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
    */
    readonly dcpMutualAuthProcessingVariableId?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor | undefined);
    private _certificateField?;
    get certificateField(): string;
    set certificateField(value: string);
    resetCertificateField(): void;
    get certificateFieldInput(): string | undefined;
    private _dcpMutualAuthProcessingVariableId?;
    get dcpMutualAuthProcessingVariableId(): string;
    set dcpMutualAuthProcessingVariableId(value: string);
    resetDcpMutualAuthProcessingVariableId(): void;
    get dcpMutualAuthProcessingVariableIdInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups {
    /**
    * Specifies the set of authorization groups to assign to all connecting devices.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
    */
    readonly groupNames?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups | undefined);
    private _groupNames?;
    get groupNames(): string[];
    set groupNames(value: string[]);
    resetGroupNames(): void;
    get groupNamesInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations {
    /**
    * Allows you to specify custom JWT server connection values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
    */
    readonly customValues?: boolean | cdktf.IResolvable;
    /**
    * Enables the default JWT server and sets the authentication endpoint to a default path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the JWT server's hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
    */
    readonly path?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations | undefined);
    private _customValues?;
    get customValues(): boolean | cdktf.IResolvable;
    set customValues(value: boolean | cdktf.IResolvable);
    resetCustomValues(): void;
    get customValuesInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth {
    /**
    * Extracts a hostname from JWT.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
    */
    readonly extractHostname?: boolean | cdktf.IResolvable;
    /**
    * Extracts a jurisdiction that defines a geographically distributed set of servers from JWT.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
    */
    readonly extractJurisdiction?: boolean | cdktf.IResolvable;
    /**
    * Extracts a namespace from JSON web tokens (JWT).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
    */
    readonly extractNamespace?: boolean | cdktf.IResolvable;
    /**
    * Specifies the claim in JWT to extract the hostname from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
    */
    readonly hostnameClaim?: string;
    /**
    * Specifies the claim in JWT to extract the jurisdiction from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
    */
    readonly jurisdictionClaim?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the claim in JWT to extract the namespace from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
    */
    readonly namespaceClaim?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth | undefined);
    private _extractHostname?;
    get extractHostname(): boolean | cdktf.IResolvable;
    set extractHostname(value: boolean | cdktf.IResolvable);
    resetExtractHostname(): void;
    get extractHostnameInput(): boolean | cdktf.IResolvable | undefined;
    private _extractJurisdiction?;
    get extractJurisdiction(): boolean | cdktf.IResolvable;
    set extractJurisdiction(value: boolean | cdktf.IResolvable);
    resetExtractJurisdiction(): void;
    get extractJurisdictionInput(): boolean | cdktf.IResolvable | undefined;
    private _extractNamespace?;
    get extractNamespace(): boolean | cdktf.IResolvable;
    set extractNamespace(value: boolean | cdktf.IResolvable);
    resetExtractNamespace(): void;
    get extractNamespaceInput(): boolean | cdktf.IResolvable | undefined;
    private _hostnameClaim?;
    get hostnameClaim(): string;
    set hostnameClaim(value: string);
    resetHostnameClaim(): void;
    get hostnameClaimInput(): string | undefined;
    private _jurisdictionClaim?;
    get jurisdictionClaim(): string;
    set jurisdictionClaim(value: string);
    resetJurisdictionClaim(): void;
    get jurisdictionClaimInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _namespaceClaim?;
    get namespaceClaim(): string;
    set namespaceClaim(value: string);
    resetNamespaceClaim(): void;
    get namespaceClaimInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt {
    /**
    * Enables the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess {
    /**
    * Denies access when enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Text message that keys why access is denied. Any subsequent `denyAccess` behaviors within the rule tree may refer to the same `reason` key to override the current behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
    */
    readonly reason?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _reason?;
    get reason(): string;
    set reason(value: string);
    resetReason(): void;
    get reasonInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId {
    /**
    * Specifies a set of information about the device with which to generate a separate cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
    */
    readonly elements?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId | undefined);
    private _elements?;
    get elements(): string[];
    set elements(value: string[]);
    resetElements(): void;
    get elementsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader {
    /**
    * Specifies the set of information about the requesting device to send to the origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
    */
    readonly elements?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader | undefined);
    private _elements?;
    get elements(): string[];
    set elements(value: string[]);
    resetElements(): void;
    get elementsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh {
    /**
    * Allows edge servers to refresh an expired DNS record after serving content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Set the maximum allowed time an expired DNS record may be active.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh {
    /**
    * Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
    */
    readonly delay?: string;
    /**
    * Allows edge servers to refresh DNS records before they expire.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh | undefined);
    private _delay?;
    get delay(): string;
    set delay(value: string);
    resetDelay(): void;
    get delayInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol {
    /**
    * Enables the protocol downgrading behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache {
    /**
    * Specify how the edge server calculates the downstream cache by setting the value of the `Expires` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
    */
    readonly allowBehavior?: string;
    /**
    * Specify the caching instructions the edge server sends to the end user's client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the HTTP headers to include in the response to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
    */
    readonly sendHeaders?: string;
    /**
    * Adds a `Cache-Control: private` header to prevent objects from being cached in a shared caching proxy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
    */
    readonly sendPrivate?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Sets the duration of the cache. Setting the value to `0` equates to a `no-cache` header that forces revalidation.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
    */
    readonly ttl?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache | undefined);
    private _allowBehavior?;
    get allowBehavior(): string;
    set allowBehavior(value: string);
    resetAllowBehavior(): void;
    get allowBehaviorInput(): string | undefined;
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _sendHeaders?;
    get sendHeaders(): string;
    set sendHeaders(value: string);
    resetSendHeaders(): void;
    get sendHeadersInput(): string | undefined;
    private _sendPrivate?;
    get sendPrivate(): boolean | cdktf.IResolvable;
    set sendPrivate(value: boolean | cdktf.IResolvable);
    resetSendPrivate(): void;
    get sendPrivateInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _ttl?;
    get ttl(): string;
    set ttl(value: string);
    resetTtl(): void;
    get ttlInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization {
    /**
    * Enables the quick retry feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
    */
    readonly throughput?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _throughput?;
    get throughput(): string;
    set throughput(value: string);
    resetThroughput(): void;
    get throughputInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent {
    /**
    * Enables image compression for subcustomer content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
    */
    readonly imageCompression?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Allows subcustomer content to prefetch over HTTP/2.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
    */
    readonly prefetch?: boolean | cdktf.IResolvable;
    /**
    * Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the `realUserMonitoring` behavior for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
    */
    readonly realUserMonitoring?: boolean | cdktf.IResolvable;
    /**
    * Optimizes how subcustomer traffic routes from origin to edge servers.  See the `sureRoute` behavior for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
    */
    readonly sureRoute?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent | undefined);
    private _imageCompression?;
    get imageCompression(): boolean | cdktf.IResolvable;
    set imageCompression(value: boolean | cdktf.IResolvable);
    resetImageCompression(): void;
    get imageCompressionInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetch?;
    get prefetch(): boolean | cdktf.IResolvable;
    set prefetch(value: boolean | cdktf.IResolvable);
    resetPrefetch(): void;
    get prefetchInput(): boolean | cdktf.IResolvable | undefined;
    private _realUserMonitoring?;
    get realUserMonitoring(): boolean | cdktf.IResolvable;
    set realUserMonitoring(value: boolean | cdktf.IResolvable);
    resetRealUserMonitoring(): void;
    get realUserMonitoringInput(): boolean | cdktf.IResolvable | undefined;
    private _sureRoute?;
    get sureRoute(): boolean | cdktf.IResolvable;
    set sureRoute(value: boolean | cdktf.IResolvable);
    resetSureRoute(): void;
    get sureRouteInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload {
    /**
    * Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: `<hostname>/bulk/<database_name>/<dataset_name>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase {
    /**
    * Specifies a default database for this property. If you don't configure a default data set in the `ecmsDataset` behavior, requests to objects in this database follow the pattern: `<hostname>/datastore/<data_set_name>/<object_key>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
    */
    readonly database?: string;
    /**
    * Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
    */
    readonly extractLocation?: string;
    /**
    * Specifies the request header that passed the database name. By default, it points to `X-KV-Database`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the query string parameter that passed the database name. By default, it points to `database`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
    */
    readonly queryParameterName?: string;
    /**
    * Specifies the regular expression that matches the database name in the URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
    */
    readonly regexPattern?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _extractLocation?;
    get extractLocation(): string;
    set extractLocation(value: string);
    resetExtractLocation(): void;
    get extractLocationInput(): string | undefined;
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _queryParameterName?;
    get queryParameterName(): string;
    set queryParameterName(value: string);
    resetQueryParameterName(): void;
    get queryParameterNameInput(): string | undefined;
    private _regexPattern?;
    get regexPattern(): string;
    set regexPattern(value: string);
    resetRegexPattern(): void;
    get regexPatternInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset {
    /**
    * Specifies a default data set for this property. If you don't configure a default database in the `ecmsDatabase` behavior, requests to objects in this data set follow the pattern: `<hostname>/datastore/<database_name>/<object_key>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
    */
    readonly dataset?: string;
    /**
    * Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
    */
    readonly extractLocation?: string;
    /**
    * Specifies the request header that passed the data set name. By default, it points to `X-KV-Dataset`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the query string parameter that passed the data set name. By default, it points to `dataset`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
    */
    readonly queryParameterName?: string;
    /**
    * Specifies the regular expression that matches the data set name in the URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
    */
    readonly regexPattern?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset | undefined);
    private _dataset?;
    get dataset(): string;
    set dataset(value: string);
    resetDataset(): void;
    get datasetInput(): string | undefined;
    private _extractLocation?;
    get extractLocation(): string;
    set extractLocation(value: string);
    resetExtractLocation(): void;
    get extractLocationInput(): string | undefined;
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _queryParameterName?;
    get queryParameterName(): string;
    set queryParameterName(value: string);
    resetQueryParameterName(): void;
    get queryParameterNameInput(): string | undefined;
    private _regexPattern?;
    get regexPattern(): string;
    set regexPattern(value: string);
    resetRegexPattern(): void;
    get regexPatternInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables sending a compressed archive file with objects to the default path of the target data set: `<hostname>/bulk/<database_name>/<dataset_name>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
    */
    readonly regex?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _regex?;
    get regex(): string;
    set regex(value: string);
    resetRegex(): void;
    get regexInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect {
    /**
    * Specifies the maximum number of lines to include in each log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
    */
    readonly aggregateLines?: string;
    /**
    * Specifies the log's maximum size.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
    */
    readonly aggregateSize?: string;
    /**
    * Specifies how often logs are generated.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
    */
    readonly aggregateTime?: string;
    /**
    * Describes the API connector type.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
    */
    readonly apiConnector?: string;
    /**
    * Specifies the data set to log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
    */
    readonly apiDataElements?: string[];
    /**
    * Specifies the target hostname accepting push API requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
    */
    readonly destinationHostname?: string;
    /**
    * Specifies the push API's endpoint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
    */
    readonly destinationPath?: string;
    /**
    * Enables Cloud Monitor's log-publishing behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, overrides default log settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
    */
    readonly overrideAggregateSettings?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect | undefined);
    private _aggregateLines?;
    get aggregateLines(): string;
    set aggregateLines(value: string);
    resetAggregateLines(): void;
    get aggregateLinesInput(): string | undefined;
    private _aggregateSize?;
    get aggregateSize(): string;
    set aggregateSize(value: string);
    resetAggregateSize(): void;
    get aggregateSizeInput(): string | undefined;
    private _aggregateTime?;
    get aggregateTime(): string;
    set aggregateTime(value: string);
    resetAggregateTime(): void;
    get aggregateTimeInput(): string | undefined;
    private _apiConnector?;
    get apiConnector(): string;
    set apiConnector(value: string);
    resetApiConnector(): void;
    get apiConnectorInput(): string | undefined;
    private _apiDataElements?;
    get apiDataElements(): string[];
    set apiDataElements(value: string[]);
    resetApiDataElements(): void;
    get apiDataElementsInput(): string[] | undefined;
    private _destinationHostname?;
    get destinationHostname(): string;
    set destinationHostname(value: string);
    resetDestinationHostname(): void;
    get destinationHostnameInput(): string | undefined;
    private _destinationPath?;
    get destinationPath(): string;
    set destinationPath(value: string);
    resetDestinationPath(): void;
    get destinationPathInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideAggregateSettings?;
    get overrideAggregateSettings(): boolean | cdktf.IResolvable;
    set overrideAggregateSettings(value: boolean | cdktf.IResolvable);
    resetOverrideAggregateSettings(): void;
    get overrideAggregateSettingsInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced {
    /**
    * A description of what the `xml` block does.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * A block of Akamai XML metadata.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
    */
    readonly xml?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _xml?;
    get xml(): string;
    set xml(value: string);
    resetXml(): void;
    get xmlInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules {
    /**
    * When enabled, interprets the path specified by `context_root` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
    */
    readonly absolutePath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the path to use in the forwarding request, typically the root (`/`) when failing over to a different data center, or a full path such as `/static/error.html` when failing over to an error page.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
    */
    readonly contextRoot?: string;
    /**
    * The hostname of the data center to fail over to.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
    */
    readonly failoverHostname?: string;
    /**
    * Allows you to modify the request's hostname or path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
    */
    readonly modifyRequest?: boolean | cdktf.IResolvable;
    /**
    * Overrides the request's hostname with the `failover_hostname`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
    */
    readonly overrideHostname?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable | undefined);
    private _absolutePath?;
    get absolutePath(): boolean | cdktf.IResolvable;
    set absolutePath(value: boolean | cdktf.IResolvable);
    resetAbsolutePath(): void;
    get absolutePathInput(): boolean | cdktf.IResolvable | undefined;
    private _contextRoot?;
    get contextRoot(): string;
    set contextRoot(value: string);
    resetContextRoot(): void;
    get contextRootInput(): string | undefined;
    private _failoverHostname?;
    get failoverHostname(): string;
    set failoverHostname(value: string);
    resetFailoverHostname(): void;
    get failoverHostnameInput(): string | undefined;
    private _modifyRequest?;
    get modifyRequest(): boolean | cdktf.IResolvable;
    set modifyRequest(value: boolean | cdktf.IResolvable);
    resetModifyRequest(): void;
    get modifyRequestInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideHostname?;
    get overrideHostname(): boolean | cdktf.IResolvable;
    set overrideHostname(value: boolean | cdktf.IResolvable);
    resetOverrideHostname(): void;
    get overrideHostnameInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter {
    /**
    * If using session persistence, this specifies the value of the cookie named in the corresponding `edgeLoadBalancingOrigin` behavior's `cookie_name` option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Provides a description for the ELB data center, for your own reference.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Allows you to specify failover rules.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
    */
    readonly enableFailover?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
    */
    readonly failoverTitle?: string;
    /**
    * Specifies the data center's hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies this data center's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
    */
    readonly ip?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Corresponds to the `id` specified by the `edgeLoadBalancingOrigin` behavior associated with this data center.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
    */
    readonly originId?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * failover_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
    */
    readonly failoverRules?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _enableFailover?;
    get enableFailover(): boolean | cdktf.IResolvable;
    set enableFailover(value: boolean | cdktf.IResolvable);
    resetEnableFailover(): void;
    get enableFailoverInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverTitle?;
    get failoverTitle(): string;
    set failoverTitle(value: string);
    resetFailoverTitle(): void;
    get failoverTitleInput(): string | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _failoverRules;
    get failoverRules(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesList;
    putFailoverRules(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable): void;
    resetFailoverRules(): void;
    get failoverRulesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin {
    /**
    * This specifies the name of the cookie that marks users' persistent sessions. The accompanying `edgeLoadBalancingDataCenter` behavior's `description` option specifies the cookie's value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Provides a description for the ELB origin, for your own reference.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
    */
    readonly enableSessionPersistence?: boolean | cdktf.IResolvable;
    /**
    * Specifies the hostname associated with the ELB rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies a unique descriptive string for this ELB origin. The value needs to match the `origin_id` specified by the `edgeLoadBalancingDataCenter` behavior associated with this origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
    */
    readonly sessionPersistenceTitle?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _enableSessionPersistence?;
    get enableSessionPersistence(): boolean | cdktf.IResolvable;
    set enableSessionPersistence(value: boolean | cdktf.IResolvable);
    resetEnableSessionPersistence(): void;
    get enableSessionPersistenceInput(): boolean | cdktf.IResolvable | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _sessionPersistenceTitle?;
    get sessionPersistenceTitle(): string;
    set sessionPersistenceTitle(value: string);
    resetSessionPersistenceTitle(): void;
    get sessionPersistenceTitleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization {
    /**
    * Specifies the name of the cookie to use for authorization.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Specify the cookie's domain, which needs to match the top-level domain of the `Host` header the origin server receives.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
    */
    readonly domain?: string;
    /**
    * Enables the cookie-authorization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the value of the authorization cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    resetDomain(): void;
    get domainInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector {
    /**
    * Identifies the Cloudlet shared policy to use with this behavior. Use the `Cloudlets API` to list available shared policies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Edge Redirector Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape {
    /**
    * When enabled, sends the `X-Akamai-Edgescape` request header to the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes {
    /**
    * Denies attempts to inject ESI code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
    */
    readonly detectInjection?: boolean | cdktf.IResolvable;
    /**
    * Enable ESI only for content featuring the `Edge-control: dca=esi` HTTP response header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
    */
    readonly enableViaHttp?: boolean | cdktf.IResolvable;
    /**
    * Enables ESI processing.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the character sets to use when transcoding the ESI language, `UTF-8` and `ISO-8859-1` for example.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
    */
    readonly i18NCharset?: string[];
    /**
    * Provides internationalization support for ESI.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
    */
    readonly i18NStatus?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to pass the client IP header to the ESI processor.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
    */
    readonly passClientIp?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to pass your origin server's cookies to the ESI processor.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
    */
    readonly passSetCookie?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes | undefined);
    private _detectInjection?;
    get detectInjection(): boolean | cdktf.IResolvable;
    set detectInjection(value: boolean | cdktf.IResolvable);
    resetDetectInjection(): void;
    get detectInjectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableViaHttp?;
    get enableViaHttp(): boolean | cdktf.IResolvable;
    set enableViaHttp(value: boolean | cdktf.IResolvable);
    resetEnableViaHttp(): void;
    get enableViaHttpInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _i18NCharset?;
    get i18NCharset(): string[];
    set i18NCharset(value: string[]);
    resetI18NCharset(): void;
    get i18NCharsetInput(): string[] | undefined;
    private _i18NStatus?;
    get i18NStatus(): boolean | cdktf.IResolvable;
    set i18NStatus(value: boolean | cdktf.IResolvable);
    resetI18NStatus(): void;
    get i18NStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _passClientIp?;
    get passClientIp(): boolean | cdktf.IResolvable;
    set passClientIp(value: boolean | cdktf.IResolvable);
    resetPassClientIp(): void;
    get passClientIpInput(): boolean | cdktf.IResolvable | undefined;
    private _passSetCookie?;
    get passSetCookie(): boolean | cdktf.IResolvable;
    set passSetCookie(value: boolean | cdktf.IResolvable);
    resetPassSetCookie(): void;
    get passSetCookieInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
    */
    readonly createEdgeWorker?: string;
    /**
    * Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the `EdgeWorkers API` to get this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
    */
    readonly edgeWorkerId?: string;
    /**
    * When enabled, applies specified EdgeWorker functionality to this rule's web traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see `Integrate mPulse reports with EdgeWorkers`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
    */
    readonly mPulse?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
    */
    readonly mPulseInformation?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
    */
    readonly resourceTier?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker | undefined);
    private _createEdgeWorker?;
    get createEdgeWorker(): string;
    set createEdgeWorker(value: string);
    resetCreateEdgeWorker(): void;
    get createEdgeWorkerInput(): string | undefined;
    private _edgeWorkerId?;
    get edgeWorkerId(): string;
    set edgeWorkerId(value: string);
    resetEdgeWorkerId(): void;
    get edgeWorkerIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mPulse?;
    get mPulse(): boolean | cdktf.IResolvable;
    set mPulse(value: boolean | cdktf.IResolvable);
    resetMPulse(): void;
    get mPulseInput(): boolean | cdktf.IResolvable | undefined;
    private _mPulseInformation?;
    get mPulseInformation(): string;
    set mPulseInformation(value: string);
    resetMPulseInformation(): void;
    get mPulseInformationInput(): string | undefined;
    private _resourceTier?;
    get resourceTier(): string;
    set resourceTier(value: string);
    resetResourceTier(): void;
    get resourceTierInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings {
    /**
    * Specify the client certificate authority (CA) sets you want to support in client requests. Run the `List CA Sets` operation in the mTLS Edge TrustStore API to get the `setId` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the `Certificate Provisioning System`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
    */
    readonly certificateAuthoritySet?: string[];
    /**
    * Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
    */
    readonly enableAuthSet?: boolean | cdktf.IResolvable;
    /**
    * This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the `Client-To-Edge` authentication header, or issue a custom message.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
    */
    readonly enableDenyRequest?: boolean | cdktf.IResolvable;
    /**
    * Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
    */
    readonly enableOcspStatus?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings | undefined);
    private _certificateAuthoritySet?;
    get certificateAuthoritySet(): string[];
    set certificateAuthoritySet(value: string[]);
    resetCertificateAuthoritySet(): void;
    get certificateAuthoritySetInput(): string[] | undefined;
    private _enableAuthSet?;
    get enableAuthSet(): boolean | cdktf.IResolvable;
    set enableAuthSet(value: boolean | cdktf.IResolvable);
    resetEnableAuthSet(): void;
    get enableAuthSetInput(): boolean | cdktf.IResolvable | undefined;
    private _enableDenyRequest?;
    get enableDenyRequest(): boolean | cdktf.IResolvable;
    set enableDenyRequest(value: boolean | cdktf.IResolvable);
    resetEnableDenyRequest(): void;
    get enableDenyRequestInput(): boolean | cdktf.IResolvable | undefined;
    private _enableOcspStatus?;
    get enableOcspStatus(): boolean | cdktf.IResolvable;
    set enableOcspStatus(value: boolean | cdktf.IResolvable);
    resetEnableOcspStatus(): void;
    get enableOcspStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
    */
    readonly display?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol | undefined);
    private _display?;
    get display(): string;
    set display(value: string);
    resetDisplay(): void;
    get displayInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
    */
    readonly anonymousVpn?: string;
    /**
    * Specifies how to field the proxy request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
    */
    readonly bestPracticeAction?: string;
    /**
    * This specifies the URL to which to redirect requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
    */
    readonly bestPracticeRedirecturl?: string;
    /**
    * This enables detection of requests from anonymous VPNs.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
    */
    readonly detectAnonymousVpn?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to field anonymous VPN requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
    */
    readonly detectAnonymousVpnAction?: string;
    /**
    * This specifies the URL to which to redirect anonymous VPN requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
    */
    readonly detectAnonymousVpnRedirecturl?: string;
    /**
    * This detects requests from a hosting provider.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
    */
    readonly detectHostingProvider?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from hosting providers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
    */
    readonly detectHostingProviderAction?: string;
    /**
    * This specifies the absolute URL to which to redirect requests from hosting providers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
    */
    readonly detectHostingProviderRedirecturl?: string;
    /**
    * This enables detection of requests from public proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
    */
    readonly detectPublicProxy?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to field public proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
    */
    readonly detectPublicProxyAction?: string;
    /**
    * This specifies the URL to which to redirect public proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
    */
    readonly detectPublicProxyRedirecturl?: string;
    /**
    * This enables detection of requests from a residential proxy. See `Enhanced Proxy Detection with GeoGuard` and learn more about this GeoGuard category before enabling it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
    */
    readonly detectResidentialProxy?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from residential proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
    */
    readonly detectResidentialProxyAction?: string;
    /**
    * This specifies the URL to which to redirect requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
    */
    readonly detectResidentialProxyRedirecturl?: string;
    /**
    * This enables detection of requests from smart DNS proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
    */
    readonly detectSmartDnsProxy?: boolean | cdktf.IResolvable;
    /**
    * Specifies whether to `DENY`, `ALLOW`, or `REDIRECT` smart DNS proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
    */
    readonly detectSmartDnsProxyAction?: string;
    /**
    * This specifies the URL to which to redirect DNS proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
    */
    readonly detectSmartDnsProxyRedirecturl?: string;
    /**
    * This enables detection of requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
    */
    readonly detectTorExitNode?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
    */
    readonly detectTorExitNodeAction?: string;
    /**
    * This specifies the URL to which to redirect requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
    */
    readonly detectTorExitNodeRedirecturl?: string;
    /**
    * This enables detection of requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
    */
    readonly detectVpnDataCenter?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
    */
    readonly detectVpnDataCenterAction?: string;
    /**
    * This specifies the URL to which to redirect requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
    */
    readonly detectVpnDataCenterRedirecturl?: string;
    /**
    * Specifies how to field the proxy request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
    */
    readonly enableConfigurationMode?: string;
    /**
    * Applies GeoGuard proxy detection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the `epdForwardHeaderEnrichment` behavior for details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
    */
    readonly forwardHeaderEnrichment?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
    */
    readonly hostingProvider?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
    */
    readonly publicProxy?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
    */
    readonly residentialProxy?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
    */
    readonly smartDnsProxy?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
    */
    readonly torExitNode?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
    */
    readonly vpnDataCenter?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection | undefined);
    private _anonymousVpn?;
    get anonymousVpn(): string;
    set anonymousVpn(value: string);
    resetAnonymousVpn(): void;
    get anonymousVpnInput(): string | undefined;
    private _bestPracticeAction?;
    get bestPracticeAction(): string;
    set bestPracticeAction(value: string);
    resetBestPracticeAction(): void;
    get bestPracticeActionInput(): string | undefined;
    private _bestPracticeRedirecturl?;
    get bestPracticeRedirecturl(): string;
    set bestPracticeRedirecturl(value: string);
    resetBestPracticeRedirecturl(): void;
    get bestPracticeRedirecturlInput(): string | undefined;
    private _detectAnonymousVpn?;
    get detectAnonymousVpn(): boolean | cdktf.IResolvable;
    set detectAnonymousVpn(value: boolean | cdktf.IResolvable);
    resetDetectAnonymousVpn(): void;
    get detectAnonymousVpnInput(): boolean | cdktf.IResolvable | undefined;
    private _detectAnonymousVpnAction?;
    get detectAnonymousVpnAction(): string;
    set detectAnonymousVpnAction(value: string);
    resetDetectAnonymousVpnAction(): void;
    get detectAnonymousVpnActionInput(): string | undefined;
    private _detectAnonymousVpnRedirecturl?;
    get detectAnonymousVpnRedirecturl(): string;
    set detectAnonymousVpnRedirecturl(value: string);
    resetDetectAnonymousVpnRedirecturl(): void;
    get detectAnonymousVpnRedirecturlInput(): string | undefined;
    private _detectHostingProvider?;
    get detectHostingProvider(): boolean | cdktf.IResolvable;
    set detectHostingProvider(value: boolean | cdktf.IResolvable);
    resetDetectHostingProvider(): void;
    get detectHostingProviderInput(): boolean | cdktf.IResolvable | undefined;
    private _detectHostingProviderAction?;
    get detectHostingProviderAction(): string;
    set detectHostingProviderAction(value: string);
    resetDetectHostingProviderAction(): void;
    get detectHostingProviderActionInput(): string | undefined;
    private _detectHostingProviderRedirecturl?;
    get detectHostingProviderRedirecturl(): string;
    set detectHostingProviderRedirecturl(value: string);
    resetDetectHostingProviderRedirecturl(): void;
    get detectHostingProviderRedirecturlInput(): string | undefined;
    private _detectPublicProxy?;
    get detectPublicProxy(): boolean | cdktf.IResolvable;
    set detectPublicProxy(value: boolean | cdktf.IResolvable);
    resetDetectPublicProxy(): void;
    get detectPublicProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectPublicProxyAction?;
    get detectPublicProxyAction(): string;
    set detectPublicProxyAction(value: string);
    resetDetectPublicProxyAction(): void;
    get detectPublicProxyActionInput(): string | undefined;
    private _detectPublicProxyRedirecturl?;
    get detectPublicProxyRedirecturl(): string;
    set detectPublicProxyRedirecturl(value: string);
    resetDetectPublicProxyRedirecturl(): void;
    get detectPublicProxyRedirecturlInput(): string | undefined;
    private _detectResidentialProxy?;
    get detectResidentialProxy(): boolean | cdktf.IResolvable;
    set detectResidentialProxy(value: boolean | cdktf.IResolvable);
    resetDetectResidentialProxy(): void;
    get detectResidentialProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectResidentialProxyAction?;
    get detectResidentialProxyAction(): string;
    set detectResidentialProxyAction(value: string);
    resetDetectResidentialProxyAction(): void;
    get detectResidentialProxyActionInput(): string | undefined;
    private _detectResidentialProxyRedirecturl?;
    get detectResidentialProxyRedirecturl(): string;
    set detectResidentialProxyRedirecturl(value: string);
    resetDetectResidentialProxyRedirecturl(): void;
    get detectResidentialProxyRedirecturlInput(): string | undefined;
    private _detectSmartDnsProxy?;
    get detectSmartDnsProxy(): boolean | cdktf.IResolvable;
    set detectSmartDnsProxy(value: boolean | cdktf.IResolvable);
    resetDetectSmartDnsProxy(): void;
    get detectSmartDnsProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectSmartDnsProxyAction?;
    get detectSmartDnsProxyAction(): string;
    set detectSmartDnsProxyAction(value: string);
    resetDetectSmartDnsProxyAction(): void;
    get detectSmartDnsProxyActionInput(): string | undefined;
    private _detectSmartDnsProxyRedirecturl?;
    get detectSmartDnsProxyRedirecturl(): string;
    set detectSmartDnsProxyRedirecturl(value: string);
    resetDetectSmartDnsProxyRedirecturl(): void;
    get detectSmartDnsProxyRedirecturlInput(): string | undefined;
    private _detectTorExitNode?;
    get detectTorExitNode(): boolean | cdktf.IResolvable;
    set detectTorExitNode(value: boolean | cdktf.IResolvable);
    resetDetectTorExitNode(): void;
    get detectTorExitNodeInput(): boolean | cdktf.IResolvable | undefined;
    private _detectTorExitNodeAction?;
    get detectTorExitNodeAction(): string;
    set detectTorExitNodeAction(value: string);
    resetDetectTorExitNodeAction(): void;
    get detectTorExitNodeActionInput(): string | undefined;
    private _detectTorExitNodeRedirecturl?;
    get detectTorExitNodeRedirecturl(): string;
    set detectTorExitNodeRedirecturl(value: string);
    resetDetectTorExitNodeRedirecturl(): void;
    get detectTorExitNodeRedirecturlInput(): string | undefined;
    private _detectVpnDataCenter?;
    get detectVpnDataCenter(): boolean | cdktf.IResolvable;
    set detectVpnDataCenter(value: boolean | cdktf.IResolvable);
    resetDetectVpnDataCenter(): void;
    get detectVpnDataCenterInput(): boolean | cdktf.IResolvable | undefined;
    private _detectVpnDataCenterAction?;
    get detectVpnDataCenterAction(): string;
    set detectVpnDataCenterAction(value: string);
    resetDetectVpnDataCenterAction(): void;
    get detectVpnDataCenterActionInput(): string | undefined;
    private _detectVpnDataCenterRedirecturl?;
    get detectVpnDataCenterRedirecturl(): string;
    set detectVpnDataCenterRedirecturl(value: string);
    resetDetectVpnDataCenterRedirecturl(): void;
    get detectVpnDataCenterRedirecturlInput(): string | undefined;
    private _enableConfigurationMode?;
    get enableConfigurationMode(): string;
    set enableConfigurationMode(value: string);
    resetEnableConfigurationMode(): void;
    get enableConfigurationModeInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _forwardHeaderEnrichment?;
    get forwardHeaderEnrichment(): boolean | cdktf.IResolvable;
    set forwardHeaderEnrichment(value: boolean | cdktf.IResolvable);
    resetForwardHeaderEnrichment(): void;
    get forwardHeaderEnrichmentInput(): boolean | cdktf.IResolvable | undefined;
    private _hostingProvider?;
    get hostingProvider(): string;
    set hostingProvider(value: string);
    resetHostingProvider(): void;
    get hostingProviderInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _publicProxy?;
    get publicProxy(): string;
    set publicProxy(value: string);
    resetPublicProxy(): void;
    get publicProxyInput(): string | undefined;
    private _residentialProxy?;
    get residentialProxy(): string;
    set residentialProxy(value: string);
    resetResidentialProxy(): void;
    get residentialProxyInput(): string | undefined;
    private _smartDnsProxy?;
    get smartDnsProxy(): string;
    set smartDnsProxy(value: string);
    resetSmartDnsProxy(): void;
    get smartDnsProxyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _torExitNode?;
    get torExitNode(): string;
    set torExitNode(value: string);
    resetTorExitNode(): void;
    get torExitNodeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _vpnDataCenter?;
    get vpnDataCenter(): string;
    set vpnDataCenter(value: string);
    resetVpnDataCenter(): void;
    get vpnDataCenterInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment {
    /**
    * Sends the Enhanced Proxy Detection (`Akamai-EPD`) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}
    */
    readonly downloadDomainName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}
    */
    readonly g2OToken?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname | undefined);
    private _cpCode?;
    get cpCode(): number;
    set cpCode(value: number);
    resetCpCode(): void;
    get cpCodeInput(): number | undefined;
    private _downloadDomainName?;
    get downloadDomainName(): string;
    set downloadDomainName(value: string);
    resetDownloadDomainName(): void;
    get downloadDomainNameInput(): string | undefined;
    private _g2OToken?;
    get g2OToken(): string;
    set g2OToken(value: string);
    resetG2OToken(): void;
    get g2OTokenInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction {
    /**
    * Specifies the basic action to take when there is a failure to contact the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
    */
    readonly actionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}
    */
    readonly allowFcmParentOverride?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
    */
    readonly cexCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies a hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
    */
    readonly cexHostname?: string;
    /**
    * Specifies a custom path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
    */
    readonly cexPath?: string;
    /**
    * Specifies a custom redirect path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
    */
    readonly contentCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the static hostname for the alternate redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
    */
    readonly contentHostname?: string;
    /**
    * Specifies a custom redirect path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
    */
    readonly contentPath?: string;
    /**
    * Allows you to modify the original requested path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
    */
    readonly dynamicCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the redirect method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
    */
    readonly dynamicMethod?: string;
    /**
    * Specifies the new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
    */
    readonly dynamicPath?: string;
    /**
    * When enabled in case of a failure to contact the origin, the current behavior applies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Modifies the redirect's protocol using the value of the `protocol` field.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
    */
    readonly modifyProtocol?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `RECREATED_NS`, specifies the path for the `NetStorage` request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
    */
    readonly netStoragePath?: string;
    /**
    * When using either `contentCustomPath`, `cexCustomPath`, `dynamicCustomPath`, or `redirectCustomPath` to specify a custom path, enabling this passes in the original request's query string as part of the path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
    */
    readonly preserveQueryString?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `REDIRECT` and `modifyProtocol` is enabled, this specifies the redirect's protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
    */
    readonly protocol?: string;
    /**
    * Uses the `redirectPath` to customize a new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
    */
    readonly redirectCustomPath?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `REDIRECT` and the `redirectHostnameType` is `ALTERNATE`, this specifies the hostname for the redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
    */
    readonly redirectHostname?: string;
    /**
    * Whether to preserve or customize the hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
    */
    readonly redirectHostnameType?: string;
    /**
    * Specifies the HTTP response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
    */
    readonly redirectMethod?: number;
    /**
    * Specifies a new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
    */
    readonly redirectPath?: string;
    /**
    * Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
    */
    readonly saasCnameEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
    */
    readonly saasCnameLevel?: number;
    /**
    * Specifies the name of the cookie that identifies this SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
    */
    readonly saasCookie?: string;
    /**
    * Specifies the name of the query parameter that identifies this SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
    */
    readonly saasQueryString?: string;
    /**
    * Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
    */
    readonly saasRegex?: string;
    /**
    * Specifies the replacement pattern that defines the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
    */
    readonly saasReplace?: string;
    /**
    * Specifies the static portion of the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
    */
    readonly saasSuffix?: string;
    /**
    * Identifies the component of the request that identifies the SaaS dynamic fail action.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
    */
    readonly saasType?: string;
    /**
    * Assigns a new HTTP status code to the failure response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
    */
    readonly statusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode;
    /**
    * net_storage_hostname block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
    */
    readonly netStorageHostname?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    resetActionType(): void;
    get actionTypeInput(): string | undefined;
    private _allowFcmParentOverride?;
    get allowFcmParentOverride(): boolean | cdktf.IResolvable;
    set allowFcmParentOverride(value: boolean | cdktf.IResolvable);
    resetAllowFcmParentOverride(): void;
    get allowFcmParentOverrideInput(): boolean | cdktf.IResolvable | undefined;
    private _cexCustomPath?;
    get cexCustomPath(): boolean | cdktf.IResolvable;
    set cexCustomPath(value: boolean | cdktf.IResolvable);
    resetCexCustomPath(): void;
    get cexCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _cexHostname?;
    get cexHostname(): string;
    set cexHostname(value: string);
    resetCexHostname(): void;
    get cexHostnameInput(): string | undefined;
    private _cexPath?;
    get cexPath(): string;
    set cexPath(value: string);
    resetCexPath(): void;
    get cexPathInput(): string | undefined;
    private _contentCustomPath?;
    get contentCustomPath(): boolean | cdktf.IResolvable;
    set contentCustomPath(value: boolean | cdktf.IResolvable);
    resetContentCustomPath(): void;
    get contentCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _contentHostname?;
    get contentHostname(): string;
    set contentHostname(value: string);
    resetContentHostname(): void;
    get contentHostnameInput(): string | undefined;
    private _contentPath?;
    get contentPath(): string;
    set contentPath(value: string);
    resetContentPath(): void;
    get contentPathInput(): string | undefined;
    private _dynamicCustomPath?;
    get dynamicCustomPath(): boolean | cdktf.IResolvable;
    set dynamicCustomPath(value: boolean | cdktf.IResolvable);
    resetDynamicCustomPath(): void;
    get dynamicCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _dynamicMethod?;
    get dynamicMethod(): string;
    set dynamicMethod(value: string);
    resetDynamicMethod(): void;
    get dynamicMethodInput(): string | undefined;
    private _dynamicPath?;
    get dynamicPath(): string;
    set dynamicPath(value: string);
    resetDynamicPath(): void;
    get dynamicPathInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _modifyProtocol?;
    get modifyProtocol(): boolean | cdktf.IResolvable;
    set modifyProtocol(value: boolean | cdktf.IResolvable);
    resetModifyProtocol(): void;
    get modifyProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _netStoragePath?;
    get netStoragePath(): string;
    set netStoragePath(value: string);
    resetNetStoragePath(): void;
    get netStoragePathInput(): string | undefined;
    private _preserveQueryString?;
    get preserveQueryString(): boolean | cdktf.IResolvable;
    set preserveQueryString(value: boolean | cdktf.IResolvable);
    resetPreserveQueryString(): void;
    get preserveQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    resetProtocol(): void;
    get protocolInput(): string | undefined;
    private _redirectCustomPath?;
    get redirectCustomPath(): boolean | cdktf.IResolvable;
    set redirectCustomPath(value: boolean | cdktf.IResolvable);
    resetRedirectCustomPath(): void;
    get redirectCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _redirectHostname?;
    get redirectHostname(): string;
    set redirectHostname(value: string);
    resetRedirectHostname(): void;
    get redirectHostnameInput(): string | undefined;
    private _redirectHostnameType?;
    get redirectHostnameType(): string;
    set redirectHostnameType(value: string);
    resetRedirectHostnameType(): void;
    get redirectHostnameTypeInput(): string | undefined;
    private _redirectMethod?;
    get redirectMethod(): number;
    set redirectMethod(value: number);
    resetRedirectMethod(): void;
    get redirectMethodInput(): number | undefined;
    private _redirectPath?;
    get redirectPath(): string;
    set redirectPath(value: string);
    resetRedirectPath(): void;
    get redirectPathInput(): string | undefined;
    private _saasCnameEnabled?;
    get saasCnameEnabled(): boolean | cdktf.IResolvable;
    set saasCnameEnabled(value: boolean | cdktf.IResolvable);
    resetSaasCnameEnabled(): void;
    get saasCnameEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _saasCnameLevel?;
    get saasCnameLevel(): number;
    set saasCnameLevel(value: number);
    resetSaasCnameLevel(): void;
    get saasCnameLevelInput(): number | undefined;
    private _saasCookie?;
    get saasCookie(): string;
    set saasCookie(value: string);
    resetSaasCookie(): void;
    get saasCookieInput(): string | undefined;
    private _saasQueryString?;
    get saasQueryString(): string;
    set saasQueryString(value: string);
    resetSaasQueryString(): void;
    get saasQueryStringInput(): string | undefined;
    private _saasRegex?;
    get saasRegex(): string;
    set saasRegex(value: string);
    resetSaasRegex(): void;
    get saasRegexInput(): string | undefined;
    private _saasReplace?;
    get saasReplace(): string;
    set saasReplace(value: string);
    resetSaasReplace(): void;
    get saasReplaceInput(): string | undefined;
    private _saasSuffix?;
    get saasSuffix(): string;
    set saasSuffix(value: string);
    resetSaasSuffix(): void;
    get saasSuffixInput(): string | undefined;
    private _saasType?;
    get saasType(): string;
    set saasType(value: string);
    resetSaasType(): void;
    get saasTypeInput(): string | undefined;
    private _statusCode?;
    get statusCode(): number;
    set statusCode(value: number);
    resetStatusCode(): void;
    get statusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCode;
    get cpCode(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference;
    putCpCode(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode): void;
    resetCpCode(): void;
    get cpCodeInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode | undefined;
    private _netStorageHostname;
    get netStorageHostname(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference;
    putNetStorageHostname(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname): void;
    resetNetStorageHostname(): void;
    get netStorageHostnameInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility {
    /**
    * This behavior does not include any options. Specifying the behavior itself enables it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
    */
    readonly compatibility?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility | undefined);
    private _compatibility?;
    get compatibility(): boolean | cdktf.IResolvable;
    set compatibility(value: boolean | cdktf.IResolvable);
    resetCompatibility(): void;
    get compatibilityInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate {
    /**
    * When enabled, forces a validation test for all edge content to which the behavior applies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips {
    /**
    * When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing {
    /**
    * Enables the Cloud Marketing Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Select how to insert the MediaMath JavaScript reference script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
    */
    readonly javaScriptInsertionRule?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash.  For example, if the path prefix is `/mmath`, and the request is for `www.example.com/dir`, the new URL is `www.example.com/mmath/dir`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
    */
    readonly mediaMathPrefix?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _javaScriptInsertionRule?;
    get javaScriptInsertionRule(): string;
    set javaScriptInsertionRule(value: string);
    resetJavaScriptInsertionRule(): void;
    get javaScriptInsertionRuleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mediaMathPrefix?;
    get mediaMathPrefix(): string;
    set mediaMathPrefix(value: string);
    resetMediaMathPrefix(): void;
    get mediaMathPrefixInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus {
    /**
    * Enables the Cloud Marketing Plus Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Select how to insert the MediaMath JavaScript reference script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
    */
    readonly javaScriptInsertionRule?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash.  For example, if the path prefix is `/mmath`, and the request is for `www.example.com/dir`, the new URL is `www.example.com/mmath/dir`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
    */
    readonly mediaMathPrefix?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _javaScriptInsertionRule?;
    get javaScriptInsertionRule(): string;
    set javaScriptInsertionRule(value: string);
    resetJavaScriptInsertionRule(): void;
    get javaScriptInsertionRuleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mediaMathPrefix?;
    get mediaMathPrefix(): string;
    set mediaMathPrefix(value: string);
    resetMediaMathPrefix(): void;
    get mediaMathPrefixInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite {
    /**
    * This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the `Cloudlets API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Forward Rewrite Cloudlet behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader {
    /**
    * Specifies the set of data to be encrypted as a combination of concatenated strings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
    */
    readonly customSignString?: string[];
    /**
    * Specifies the name of the header that contains the request data that needs to be encrypted.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
    */
    readonly dataHeader?: string;
    /**
    * Enables the g2o verification behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the version of the encryption algorithm as an integer from `1` through `5`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
    */
    readonly encodingVersion?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the cryptographic `nonce` string.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
    */
    readonly nonce?: string;
    /**
    * Specifies the shared secret key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
    */
    readonly secretKey?: string;
    /**
    * Specifies the name of the header containing encrypted request data.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
    */
    readonly signedHeader?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use `customSignString` to customize the set of data to encrypt.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
    */
    readonly useCustomSignString?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader | undefined);
    private _customSignString?;
    get customSignString(): string[];
    set customSignString(value: string[]);
    resetCustomSignString(): void;
    get customSignStringInput(): string[] | undefined;
    private _dataHeader?;
    get dataHeader(): string;
    set dataHeader(value: string);
    resetDataHeader(): void;
    get dataHeaderInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _encodingVersion?;
    get encodingVersion(): number;
    set encodingVersion(value: number);
    resetEncodingVersion(): void;
    get encodingVersionInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _nonce?;
    get nonce(): string;
    set nonce(value: string);
    resetNonce(): void;
    get nonceInput(): string | undefined;
    private _secretKey?;
    get secretKey(): string;
    set secretKey(value: string);
    resetSecretKey(): void;
    get secretKeyInput(): string | undefined;
    private _signedHeader?;
    get signedHeader(): string;
    set signedHeader(value: string);
    resetSignedHeader(): void;
    get signedHeaderInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useCustomSignString?;
    get useCustomSignString(): boolean | cdktf.IResolvable;
    set useCustomSignString(value: boolean | cdktf.IResolvable);
    resetUseCustomSignString(): void;
    get useCustomSignStringInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber {
    /**
    * With `outputOption` set to specify any set of headers, this specifies the name of the header to report the GRN value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to report the GRN value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
    */
    readonly outputOption?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * This specifies the name of the variable to assign the GRN value to. You need to pre-declare any `variable` you specify within the rule tree.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
    */
    readonly variableName?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber | undefined);
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _outputOption?;
    get outputOption(): string;
    set outputOption(value: string);
    resetOutputOption(): void;
    get outputOptionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _variableName?;
    get variableName(): string;
    set variableName(value: string);
    resetVariableName(): void;
    get variableNameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: string;
    /**
    * When enabled, caches responses that include an `error` field at the top of the response body object.  Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
    */
    readonly cacheResponsesWithErrors?: boolean | cdktf.IResolvable;
    /**
    * Enables GraphQL caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The name of the JSON body parameter that identifies GraphQL POST requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
    */
    readonly operationsJsonBodyParameterName?: string;
    /**
    * Specifies the name of a query parameter that identifies requests as GraphQL queries.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
    */
    readonly operationsUrlQueryParameterName?: string;
    /**
    * Specify what happens if GraphQL query processing fails on POST requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
    */
    readonly postRequestProcessingErrorHandling?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching | undefined);
    private _advanced?;
    get advanced(): string;
    set advanced(value: string);
    resetAdvanced(): void;
    get advancedInput(): string | undefined;
    private _cacheResponsesWithErrors?;
    get cacheResponsesWithErrors(): boolean | cdktf.IResolvable;
    set cacheResponsesWithErrors(value: boolean | cdktf.IResolvable);
    resetCacheResponsesWithErrors(): void;
    get cacheResponsesWithErrorsInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _operationsJsonBodyParameterName?;
    get operationsJsonBodyParameterName(): string;
    set operationsJsonBodyParameterName(value: string);
    resetOperationsJsonBodyParameterName(): void;
    get operationsJsonBodyParameterNameInput(): string | undefined;
    private _operationsUrlQueryParameterName?;
    get operationsUrlQueryParameterName(): string;
    set operationsUrlQueryParameterName(value: string);
    resetOperationsUrlQueryParameterName(): void;
    get operationsUrlQueryParameterNameInput(): string | undefined;
    private _postRequestProcessingErrorHandling?;
    get postRequestProcessingErrorHandling(): string;
    set postRequestProcessingErrorHandling(value: string);
    resetPostRequestProcessingErrorHandling(): void;
    get postRequestProcessingErrorHandlingInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse {
    /**
    * Specify when to compress responses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced {
    /**
    * Human-readable description of what the XML block does.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * A block of Akamai XML metadata.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
    */
    readonly xml?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _xml?;
    get xml(): string;
    set xml(value: string);
    resetXml(): void;
    get xmlInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, `maximumReconnects` effectively overrides the value of `retryCount`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
    */
    readonly maximumReconnects?: number;
    /**
    * The number of consecutive connection failures that mark an IP address as faulty.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
    */
    readonly retryCount?: number;
    /**
    * Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
    */
    readonly retryInterval?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumReconnects?;
    get maximumReconnects(): number;
    set maximumReconnects(value: number);
    resetMaximumReconnects(): void;
    get maximumReconnectsInput(): number | undefined;
    private _retryCount?;
    get retryCount(): number;
    set retryCount(value: number);
    resetRetryCount(): void;
    get retryCountInput(): number | undefined;
    private _retryInterval?;
    get retryInterval(): string;
    set retryInterval(value: string);
    resetRetryInterval(): void;
    get retryIntervalInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding {
    /**
    * Whether to pull the serial number from the variable value set in the `advanced` behavior. Work with your Akamai Services team to add the `advanced` behavior earlier in your property to extract and apply the `AKA_PM_EIP_HSAF_SERIAL` variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
    */
    readonly customExtractedSerial?: boolean | cdktf.IResolvable;
    /**
    * Enables HSAF for Edge IP Binding customers with a large footprint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than `hashMinValue`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
    */
    readonly hashMaxValue?: number;
    /**
    * Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than `hashMaxValue`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
    */
    readonly hashMinValue?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies where the behavior is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
    */
    readonly tier?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding | undefined);
    private _customExtractedSerial?;
    get customExtractedSerial(): boolean | cdktf.IResolvable;
    set customExtractedSerial(value: boolean | cdktf.IResolvable);
    resetCustomExtractedSerial(): void;
    get customExtractedSerialInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hashMaxValue?;
    get hashMaxValue(): number;
    set hashMaxValue(value: number);
    resetHashMaxValue(): void;
    get hashMaxValueInput(): number | undefined;
    private _hashMinValue?;
    get hashMinValue(): number;
    set hashMinValue(value: number);
    resetHashMinValue(): void;
    get hashMinValueInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tier?;
    get tier(): string;
    set tier(value: string);
    resetTier(): void;
    get tierInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2 {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2ToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2OutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2ToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2OutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2 | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2 | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3 {
    /**
    * This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the `Property Manager documentation` for more details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3ToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3OutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3ToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3OutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3 | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3 | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity {
    /**
    * Applies HSTS to this set of requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * When enabled, applies HSTS to all subdomains.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
    */
    readonly includeSubDomains?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the duration for which to apply HSTS for new browser connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
    */
    readonly maxAge?: string;
    /**
    * When enabled, adds this domain to the browser's preload list. You still need to declare the domain at `hstspreload.org`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
    */
    readonly preload?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects all HTTP requests to HTTPS.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
    */
    readonly redirect?: boolean | cdktf.IResolvable;
    /**
    * Specifies a response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
    */
    readonly redirectStatusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _includeSubDomains?;
    get includeSubDomains(): boolean | cdktf.IResolvable;
    set includeSubDomains(value: boolean | cdktf.IResolvable);
    resetIncludeSubDomains(): void;
    get includeSubDomainsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maxAge?;
    get maxAge(): string;
    set maxAge(value: string);
    resetMaxAge(): void;
    get maxAgeInput(): string | undefined;
    private _preload?;
    get preload(): boolean | cdktf.IResolvable;
    set preload(value: boolean | cdktf.IResolvable);
    resetPreload(): void;
    get preloadInput(): boolean | cdktf.IResolvable | undefined;
    private _redirect?;
    get redirect(): boolean | cdktf.IResolvable;
    set redirect(value: boolean | cdktf.IResolvable);
    resetRedirect(): void;
    get redirectInput(): boolean | cdktf.IResolvable | undefined;
    private _redirectStatusCode?;
    get redirectStatusCode(): number;
    set redirectStatusCode(value: number);
    resetRedirectStatusCode(): void;
    get redirectStatusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
    */
    readonly upgrade?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _upgrade?;
    get upgrade(): string;
    set upgrade(value: string);
    resetUpgrade(): void;
    get upgradeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride {
    /**
    * Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
    */
    readonly dpr?: number;
    /**
    * This selects the variable with the desired pixel density. The variable specifies the same type of data as the `dpr` option below.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
    */
    readonly dprvar?: string;
    /**
    * Whether to exclude all query parameters from the Image and Video Manager cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
    */
    readonly excludeAllQueryParameters?: boolean | cdktf.IResolvable;
    /**
    * Specifies individual query parameters to exclude from the Image and Video Manager cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
    */
    readonly excludedQueryParameters?: string[];
    /**
    * Specifies the type of the browser, or the encodings passed in the `Accept` header, that you want to optimize images for.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
    */
    readonly format?: string;
    /**
    * This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the `format` option below.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
    */
    readonly formatvar?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Selects the type of query parameter you want to set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
    */
    readonly override?: string;
    /**
    * This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
    */
    readonly policy?: string;
    /**
    * This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
    */
    readonly policyvar?: string;
    /**
    * This selects one of the property's rule tree variables to assign to the `policyvarName` variable within Image and Video Manager.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
    */
    readonly policyvarIMvar?: string;
    /**
    * This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
    */
    readonly policyvarName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies how to set a query parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
    */
    readonly typesel?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
    */
    readonly width?: number;
    /**
    * Selects the variable with the desired width.  If the Image and Video Manager policy doesn't define that width, it serves the next largest width.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
    */
    readonly widthvar?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride | undefined);
    private _dpr?;
    get dpr(): number;
    set dpr(value: number);
    resetDpr(): void;
    get dprInput(): number | undefined;
    private _dprvar?;
    get dprvar(): string;
    set dprvar(value: string);
    resetDprvar(): void;
    get dprvarInput(): string | undefined;
    private _excludeAllQueryParameters?;
    get excludeAllQueryParameters(): boolean | cdktf.IResolvable;
    set excludeAllQueryParameters(value: boolean | cdktf.IResolvable);
    resetExcludeAllQueryParameters(): void;
    get excludeAllQueryParametersInput(): boolean | cdktf.IResolvable | undefined;
    private _excludedQueryParameters?;
    get excludedQueryParameters(): string[];
    set excludedQueryParameters(value: string[]);
    resetExcludedQueryParameters(): void;
    get excludedQueryParametersInput(): string[] | undefined;
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _formatvar?;
    get formatvar(): string;
    set formatvar(value: string);
    resetFormatvar(): void;
    get formatvarInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _override?;
    get override(): string;
    set override(value: string);
    resetOverride(): void;
    get overrideInput(): string | undefined;
    private _policy?;
    get policy(): string;
    set policy(value: string);
    resetPolicy(): void;
    get policyInput(): string | undefined;
    private _policyvar?;
    get policyvar(): string;
    set policyvar(value: string);
    resetPolicyvar(): void;
    get policyvarInput(): string | undefined;
    private _policyvarIMvar?;
    get policyvarIMvar(): string;
    set policyvarIMvar(value: string);
    resetPolicyvarIMvar(): void;
    get policyvarIMvarInput(): string | undefined;
    private _policyvarName?;
    get policyvarName(): string;
    set policyvarName(value: string);
    resetPolicyvarName(): void;
    get policyvarNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _typesel?;
    get typesel(): string;
    set typesel(value: string);
    resetTypesel(): void;
    get typeselInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _widthvar?;
    get widthvar(): string;
    set widthvar(value: string);
    resetWidthvar(): void;
    get widthvarInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}
    */
    readonly imageSet?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}
    */
    readonly policySetType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}
    */
    readonly videoSet?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager | undefined);
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _imageSet?;
    get imageSet(): string;
    set imageSet(value: string);
    resetImageSet(): void;
    get imageSetInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySetType?;
    get policySetType(): string;
    set policySetType(value: string);
    resetPolicySetType(): void;
    get policySetTypeInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _videoSet?;
    get videoSet(): string;
    set videoSet(value: string);
    resetVideoSet(): void;
    get videoSetInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager {
    /**
    * Generates a custom `Image and Video Manager API` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the `policyToken`) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
    */
    readonly apiReferenceTitle?: string;
    /**
    * Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Enable image management capabilities and generate a corresponding API token.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Identifies the existing policy set configured with `Image and Video Manager API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
    */
    readonly policySet?: string;
    /**
    * Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, `default` becomes the prefix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
    */
    readonly policyToken?: string;
    /**
    * Specify the default policy identifier, which is registered with the `Image and Video Manager API` once you activate this property.  The `advanced` option needs to be inactive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
    */
    readonly policyTokenDefault?: string;
    /**
    * Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.  Note that enabling this may affect screen layout in unexpected ways.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
    */
    readonly settingsTitle?: string;
    /**
    * Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
    */
    readonly superCacheRegion?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
    */
    readonly trafficTitle?: string;
    /**
    * Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
    */
    readonly useExistingPolicySet?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _apiReferenceTitle?;
    get apiReferenceTitle(): string;
    set apiReferenceTitle(value: string);
    resetApiReferenceTitle(): void;
    get apiReferenceTitleInput(): string | undefined;
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySet?;
    get policySet(): string;
    set policySet(value: string);
    resetPolicySet(): void;
    get policySetInput(): string | undefined;
    private _policyToken?;
    get policyToken(): string;
    set policyToken(value: string);
    resetPolicyToken(): void;
    get policyTokenInput(): string | undefined;
    private _policyTokenDefault?;
    get policyTokenDefault(): string;
    set policyTokenDefault(value: string);
    resetPolicyTokenDefault(): void;
    get policyTokenDefaultInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsTitle?;
    get settingsTitle(): string;
    set settingsTitle(value: string);
    resetSettingsTitle(): void;
    get settingsTitleInput(): string | undefined;
    private _superCacheRegion?;
    get superCacheRegion(): string;
    set superCacheRegion(value: string);
    resetSuperCacheRegion(): void;
    get superCacheRegionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trafficTitle?;
    get trafficTitle(): string;
    set trafficTitle(value: string);
    resetTrafficTitle(): void;
    get trafficTitleInput(): string | undefined;
    private _useExistingPolicySet?;
    get useExistingPolicySet(): boolean | cdktf.IResolvable;
    set useExistingPolicySet(value: boolean | cdktf.IResolvable);
    resetUseExistingPolicySet(): void;
    get useExistingPolicySetInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo {
    /**
    * When disabled, applies a single standard policy based on your property name.  Allows you to reference a rule-specific `policyToken` for videos with different match criteria.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
    */
    readonly apiReferenceTitle?: string;
    /**
    * When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Applies Image and Video Manager's video optimization to the current content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Identifies the existing policy set configured with `Image and Video Manager API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
    */
    readonly policySet?: string;
    /**
    * Specifies a custom policy defined in the Image and Video Manager Policy Manager or the `Image and Video Manager API`. The policy name can include up to 64 alphanumeric, dash, or underscore characters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
    */
    readonly policyToken?: string;
    /**
    * Specifies the default policy identifier, which is registered with the `Image and Video Manager API` once you activate this property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
    */
    readonly policyTokenDefault?: string;
    /**
    * When enabled, scales down video for smaller mobile screens, based on the device's `User-Agent` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
    */
    readonly settingsTitle?: string;
    /**
    * To optimize caching, assign a region close to your site's heaviest traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
    */
    readonly superCacheRegion?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
    */
    readonly trafficTitle?: string;
    /**
    * Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
    */
    readonly useExistingPolicySet?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _apiReferenceTitle?;
    get apiReferenceTitle(): string;
    set apiReferenceTitle(value: string);
    resetApiReferenceTitle(): void;
    get apiReferenceTitleInput(): string | undefined;
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySet?;
    get policySet(): string;
    set policySet(value: string);
    resetPolicySet(): void;
    get policySetInput(): string | undefined;
    private _policyToken?;
    get policyToken(): string;
    set policyToken(value: string);
    resetPolicyToken(): void;
    get policyTokenInput(): string | undefined;
    private _policyTokenDefault?;
    get policyTokenDefault(): string;
    set policyTokenDefault(value: string);
    resetPolicyTokenDefault(): void;
    get policyTokenDefaultInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsTitle?;
    get settingsTitle(): string;
    set settingsTitle(value: string);
    resetSettingsTitle(): void;
    get settingsTitleInput(): string | undefined;
    private _superCacheRegion?;
    get superCacheRegion(): string;
    set superCacheRegion(value: string);
    resetSuperCacheRegion(): void;
    get superCacheRegionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trafficTitle?;
    get trafficTitle(): string;
    set trafficTitle(value: string);
    resetTrafficTitle(): void;
    get trafficTitleInput(): string | undefined;
    private _useExistingPolicySet?;
    get useExistingPolicySet(): boolean | cdktf.IResolvable;
    set useExistingPolicySet(value: boolean | cdktf.IResolvable);
    resetUseExistingPolicySet(): void;
    get useExistingPolicySetInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude {
    /**
    * Identifies the include you want to add to your rule tree. You can get the include ID using `PAPI`. This option only accepts digits, without the `inc_` ID prefix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant {
    /**
    * Specify link relation values that activate the prefetching behavior. For example, specifying `fetch` allows you to use shorter `rel="fetch"` markup.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
    */
    readonly customLinkRelations?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, applies prefetching only to objects already set to be cacheable, for example using the `caching` behavior. Only applies to content with the `tieredDistribution` behavior enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
    */
    readonly prefetchCacheable?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from `<a>` or `<link>` tags with the appropriate link relation attribute.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
    */
    readonly prefetchHtml?: boolean | cdktf.IResolvable;
    /**
    * Allows otherwise non-cacheable `no-store` content to prefetch if the URL path ends with `/` to indicate a request for a default file, or if the extension matches the value of the `prefetchNoStoreExtensions` option. Only applies to content with the `sureRoute` behavior enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
    */
    readonly prefetchNoStore?: boolean | cdktf.IResolvable;
    /**
    * Specifies a set of file extensions for which the `prefetchNoStore` option is allowed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
    */
    readonly prefetchNoStoreExtensions?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant | undefined);
    private _customLinkRelations?;
    get customLinkRelations(): string[];
    set customLinkRelations(value: string[]);
    resetCustomLinkRelations(): void;
    get customLinkRelationsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchCacheable?;
    get prefetchCacheable(): boolean | cdktf.IResolvable;
    set prefetchCacheable(value: boolean | cdktf.IResolvable);
    resetPrefetchCacheable(): void;
    get prefetchCacheableInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchHtml?;
    get prefetchHtml(): boolean | cdktf.IResolvable;
    set prefetchHtml(value: boolean | cdktf.IResolvable);
    resetPrefetchHtml(): void;
    get prefetchHtmlInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchNoStore?;
    get prefetchNoStore(): boolean | cdktf.IResolvable;
    set prefetchNoStore(value: boolean | cdktf.IResolvable);
    resetPrefetchNoStore(): void;
    get prefetchNoStoreInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchNoStoreExtensions?;
    get prefetchNoStoreExtensions(): string[];
    set prefetchNoStoreExtensions(value: string[]);
    resetPrefetchNoStoreExtensions(): void;
    get prefetchNoStoreExtensionsInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig {
    /**
    * Enables the InstantConfig behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization {
    /**
    * Specifies whether to cache partial objects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
    */
    readonly enablePartialObjectCaching?: string;
    /**
    * Enables the file optimization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as `MB` or `GB`. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
    */
    readonly maximumSize?: string;
    /**
    * Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as `MB` or `GB`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
    */
    readonly minimumSize?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When `enablePartialObjectCaching` is set to `PARTIAL_OBJECT_CACHING`, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
    */
    readonly useVersioning?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization | undefined);
    private _enablePartialObjectCaching?;
    get enablePartialObjectCaching(): string;
    set enablePartialObjectCaching(value: string);
    resetEnablePartialObjectCaching(): void;
    get enablePartialObjectCachingInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumSize?;
    get maximumSize(): string;
    set maximumSize(value: string);
    resetMaximumSize(): void;
    get maximumSizeInput(): string | undefined;
    private _minimumSize?;
    get minimumSize(): string;
    set minimumSize(value: string);
    resetMinimumSize(): void;
    get minimumSizeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useVersioning?;
    get useVersioning(): boolean | cdktf.IResolvable;
    set useVersioning(value: boolean | cdktf.IResolvable);
    resetUseVersioning(): void;
    get useVersioningInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
