import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect {
    /**
    * Specifies the maximum number of lines to include in each log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
    */
    readonly aggregateLines?: string;
    /**
    * Specifies the log's maximum size.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
    */
    readonly aggregateSize?: string;
    /**
    * Specifies how often logs are generated.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
    */
    readonly aggregateTime?: string;
    /**
    * Describes the API connector type.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
    */
    readonly apiConnector?: string;
    /**
    * Specifies the data set to log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
    */
    readonly apiDataElements?: string[];
    /**
    * Specifies the target hostname accepting push API requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
    */
    readonly destinationHostname?: string;
    /**
    * Specifies the push API's endpoint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
    */
    readonly destinationPath?: string;
    /**
    * Enables Cloud Monitor's log-publishing behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, overrides default log settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
    */
    readonly overrideAggregateSettings?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect | undefined);
    private _aggregateLines?;
    get aggregateLines(): string;
    set aggregateLines(value: string);
    resetAggregateLines(): void;
    get aggregateLinesInput(): string | undefined;
    private _aggregateSize?;
    get aggregateSize(): string;
    set aggregateSize(value: string);
    resetAggregateSize(): void;
    get aggregateSizeInput(): string | undefined;
    private _aggregateTime?;
    get aggregateTime(): string;
    set aggregateTime(value: string);
    resetAggregateTime(): void;
    get aggregateTimeInput(): string | undefined;
    private _apiConnector?;
    get apiConnector(): string;
    set apiConnector(value: string);
    resetApiConnector(): void;
    get apiConnectorInput(): string | undefined;
    private _apiDataElements?;
    get apiDataElements(): string[];
    set apiDataElements(value: string[]);
    resetApiDataElements(): void;
    get apiDataElementsInput(): string[] | undefined;
    private _destinationHostname?;
    get destinationHostname(): string;
    set destinationHostname(value: string);
    resetDestinationHostname(): void;
    get destinationHostnameInput(): string | undefined;
    private _destinationPath?;
    get destinationPath(): string;
    set destinationPath(value: string);
    resetDestinationPath(): void;
    get destinationPathInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideAggregateSettings?;
    get overrideAggregateSettings(): boolean | cdktf.IResolvable;
    set overrideAggregateSettings(value: boolean | cdktf.IResolvable);
    resetOverrideAggregateSettings(): void;
    get overrideAggregateSettingsInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced {
    /**
    * A description of what the `xml` block does.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * A block of Akamai XML metadata.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
    */
    readonly xml?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _xml?;
    get xml(): string;
    set xml(value: string);
    resetXml(): void;
    get xmlInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules {
    /**
    * When enabled, interprets the path specified by `context_root` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
    */
    readonly absolutePath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the path to use in the forwarding request, typically the root (`/`) when failing over to a different data center, or a full path such as `/static/error.html` when failing over to an error page.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
    */
    readonly contextRoot?: string;
    /**
    * The hostname of the data center to fail over to.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
    */
    readonly failoverHostname?: string;
    /**
    * Allows you to modify the request's hostname or path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
    */
    readonly modifyRequest?: boolean | cdktf.IResolvable;
    /**
    * Overrides the request's hostname with the `failover_hostname`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
    */
    readonly overrideHostname?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable | undefined);
    private _absolutePath?;
    get absolutePath(): boolean | cdktf.IResolvable;
    set absolutePath(value: boolean | cdktf.IResolvable);
    resetAbsolutePath(): void;
    get absolutePathInput(): boolean | cdktf.IResolvable | undefined;
    private _contextRoot?;
    get contextRoot(): string;
    set contextRoot(value: string);
    resetContextRoot(): void;
    get contextRootInput(): string | undefined;
    private _failoverHostname?;
    get failoverHostname(): string;
    set failoverHostname(value: string);
    resetFailoverHostname(): void;
    get failoverHostnameInput(): string | undefined;
    private _modifyRequest?;
    get modifyRequest(): boolean | cdktf.IResolvable;
    set modifyRequest(value: boolean | cdktf.IResolvable);
    resetModifyRequest(): void;
    get modifyRequestInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideHostname?;
    get overrideHostname(): boolean | cdktf.IResolvable;
    set overrideHostname(value: boolean | cdktf.IResolvable);
    resetOverrideHostname(): void;
    get overrideHostnameInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter {
    /**
    * If using session persistence, this specifies the value of the cookie named in the corresponding `edgeLoadBalancingOrigin` behavior's `cookie_name` option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Provides a description for the ELB data center, for your own reference.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Allows you to specify failover rules.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
    */
    readonly enableFailover?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
    */
    readonly failoverTitle?: string;
    /**
    * Specifies the data center's hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies this data center's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
    */
    readonly ip?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Corresponds to the `id` specified by the `edgeLoadBalancingOrigin` behavior associated with this data center.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
    */
    readonly originId?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * failover_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
    */
    readonly failoverRules?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _enableFailover?;
    get enableFailover(): boolean | cdktf.IResolvable;
    set enableFailover(value: boolean | cdktf.IResolvable);
    resetEnableFailover(): void;
    get enableFailoverInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverTitle?;
    get failoverTitle(): string;
    set failoverTitle(value: string);
    resetFailoverTitle(): void;
    get failoverTitleInput(): string | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _failoverRules;
    get failoverRules(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesList;
    putFailoverRules(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable): void;
    resetFailoverRules(): void;
    get failoverRulesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin {
    /**
    * This specifies the name of the cookie that marks users' persistent sessions. The accompanying `edgeLoadBalancingDataCenter` behavior's `description` option specifies the cookie's value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Provides a description for the ELB origin, for your own reference.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
    */
    readonly enableSessionPersistence?: boolean | cdktf.IResolvable;
    /**
    * Specifies the hostname associated with the ELB rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies a unique descriptive string for this ELB origin. The value needs to match the `origin_id` specified by the `edgeLoadBalancingDataCenter` behavior associated with this origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
    */
    readonly sessionPersistenceTitle?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _enableSessionPersistence?;
    get enableSessionPersistence(): boolean | cdktf.IResolvable;
    set enableSessionPersistence(value: boolean | cdktf.IResolvable);
    resetEnableSessionPersistence(): void;
    get enableSessionPersistenceInput(): boolean | cdktf.IResolvable | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _sessionPersistenceTitle?;
    get sessionPersistenceTitle(): string;
    set sessionPersistenceTitle(value: string);
    resetSessionPersistenceTitle(): void;
    get sessionPersistenceTitleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization {
    /**
    * Specifies the name of the cookie to use for authorization.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Specify the cookie's domain, which needs to match the top-level domain of the `Host` header the origin server receives.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
    */
    readonly domain?: string;
    /**
    * Enables the cookie-authorization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the value of the authorization cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    resetDomain(): void;
    get domainInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector {
    /**
    * Identifies the Cloudlet shared policy to use with this behavior. Use the `Cloudlets API` to list available shared policies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Edge Redirector Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape {
    /**
    * When enabled, sends the `X-Akamai-Edgescape` request header to the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes {
    /**
    * Denies attempts to inject ESI code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
    */
    readonly detectInjection?: boolean | cdktf.IResolvable;
    /**
    * Enable ESI only for content featuring the `Edge-control: dca=esi` HTTP response header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
    */
    readonly enableViaHttp?: boolean | cdktf.IResolvable;
    /**
    * Enables ESI processing.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the character sets to use when transcoding the ESI language, `UTF-8` and `ISO-8859-1` for example.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
    */
    readonly i18NCharset?: string[];
    /**
    * Provides internationalization support for ESI.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
    */
    readonly i18NStatus?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to pass the client IP header to the ESI processor.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
    */
    readonly passClientIp?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to pass your origin server's cookies to the ESI processor.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
    */
    readonly passSetCookie?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes | undefined);
    private _detectInjection?;
    get detectInjection(): boolean | cdktf.IResolvable;
    set detectInjection(value: boolean | cdktf.IResolvable);
    resetDetectInjection(): void;
    get detectInjectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableViaHttp?;
    get enableViaHttp(): boolean | cdktf.IResolvable;
    set enableViaHttp(value: boolean | cdktf.IResolvable);
    resetEnableViaHttp(): void;
    get enableViaHttpInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _i18NCharset?;
    get i18NCharset(): string[];
    set i18NCharset(value: string[]);
    resetI18NCharset(): void;
    get i18NCharsetInput(): string[] | undefined;
    private _i18NStatus?;
    get i18NStatus(): boolean | cdktf.IResolvable;
    set i18NStatus(value: boolean | cdktf.IResolvable);
    resetI18NStatus(): void;
    get i18NStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _passClientIp?;
    get passClientIp(): boolean | cdktf.IResolvable;
    set passClientIp(value: boolean | cdktf.IResolvable);
    resetPassClientIp(): void;
    get passClientIpInput(): boolean | cdktf.IResolvable | undefined;
    private _passSetCookie?;
    get passSetCookie(): boolean | cdktf.IResolvable;
    set passSetCookie(value: boolean | cdktf.IResolvable);
    resetPassSetCookie(): void;
    get passSetCookieInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
    */
    readonly createEdgeWorker?: string;
    /**
    * Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the `EdgeWorkers API` to get this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
    */
    readonly edgeWorkerId?: string;
    /**
    * When enabled, applies specified EdgeWorker functionality to this rule's web traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see `Integrate mPulse reports with EdgeWorkers`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
    */
    readonly mPulse?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
    */
    readonly mPulseInformation?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
    */
    readonly resourceTier?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker | undefined);
    private _createEdgeWorker?;
    get createEdgeWorker(): string;
    set createEdgeWorker(value: string);
    resetCreateEdgeWorker(): void;
    get createEdgeWorkerInput(): string | undefined;
    private _edgeWorkerId?;
    get edgeWorkerId(): string;
    set edgeWorkerId(value: string);
    resetEdgeWorkerId(): void;
    get edgeWorkerIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mPulse?;
    get mPulse(): boolean | cdktf.IResolvable;
    set mPulse(value: boolean | cdktf.IResolvable);
    resetMPulse(): void;
    get mPulseInput(): boolean | cdktf.IResolvable | undefined;
    private _mPulseInformation?;
    get mPulseInformation(): string;
    set mPulseInformation(value: string);
    resetMPulseInformation(): void;
    get mPulseInformationInput(): string | undefined;
    private _resourceTier?;
    get resourceTier(): string;
    set resourceTier(value: string);
    resetResourceTier(): void;
    get resourceTierInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings {
    /**
    * Specify the client certificate authority (CA) sets you want to support in client requests. Run the `List CA Sets` operation in the mTLS Edge TrustStore API to get the `setId` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the `Certificate Provisioning System`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
    */
    readonly certificateAuthoritySet?: string[];
    /**
    * Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
    */
    readonly enableAuthSet?: boolean | cdktf.IResolvable;
    /**
    * This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the `Client-To-Edge` authentication header, or issue a custom message.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
    */
    readonly enableDenyRequest?: boolean | cdktf.IResolvable;
    /**
    * Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
    */
    readonly enableOcspStatus?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings | undefined);
    private _certificateAuthoritySet?;
    get certificateAuthoritySet(): string[];
    set certificateAuthoritySet(value: string[]);
    resetCertificateAuthoritySet(): void;
    get certificateAuthoritySetInput(): string[] | undefined;
    private _enableAuthSet?;
    get enableAuthSet(): boolean | cdktf.IResolvable;
    set enableAuthSet(value: boolean | cdktf.IResolvable);
    resetEnableAuthSet(): void;
    get enableAuthSetInput(): boolean | cdktf.IResolvable | undefined;
    private _enableDenyRequest?;
    get enableDenyRequest(): boolean | cdktf.IResolvable;
    set enableDenyRequest(value: boolean | cdktf.IResolvable);
    resetEnableDenyRequest(): void;
    get enableDenyRequestInput(): boolean | cdktf.IResolvable | undefined;
    private _enableOcspStatus?;
    get enableOcspStatus(): boolean | cdktf.IResolvable;
    set enableOcspStatus(value: boolean | cdktf.IResolvable);
    resetEnableOcspStatus(): void;
    get enableOcspStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
    */
    readonly display?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol | undefined);
    private _display?;
    get display(): string;
    set display(value: string);
    resetDisplay(): void;
    get displayInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
    */
    readonly anonymousVpn?: string;
    /**
    * Specifies how to field the proxy request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
    */
    readonly bestPracticeAction?: string;
    /**
    * This specifies the URL to which to redirect requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
    */
    readonly bestPracticeRedirecturl?: string;
    /**
    * This enables detection of requests from anonymous VPNs.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
    */
    readonly detectAnonymousVpn?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to field anonymous VPN requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
    */
    readonly detectAnonymousVpnAction?: string;
    /**
    * This specifies the URL to which to redirect anonymous VPN requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
    */
    readonly detectAnonymousVpnRedirecturl?: string;
    /**
    * This detects requests from a hosting provider.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
    */
    readonly detectHostingProvider?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from hosting providers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
    */
    readonly detectHostingProviderAction?: string;
    /**
    * This specifies the absolute URL to which to redirect requests from hosting providers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
    */
    readonly detectHostingProviderRedirecturl?: string;
    /**
    * This enables detection of requests from public proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
    */
    readonly detectPublicProxy?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to field public proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
    */
    readonly detectPublicProxyAction?: string;
    /**
    * This specifies the URL to which to redirect public proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
    */
    readonly detectPublicProxyRedirecturl?: string;
    /**
    * This enables detection of requests from a residential proxy. See `Enhanced Proxy Detection with GeoGuard` and learn more about this GeoGuard category before enabling it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
    */
    readonly detectResidentialProxy?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from residential proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
    */
    readonly detectResidentialProxyAction?: string;
    /**
    * This specifies the URL to which to redirect requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
    */
    readonly detectResidentialProxyRedirecturl?: string;
    /**
    * This enables detection of requests from smart DNS proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
    */
    readonly detectSmartDnsProxy?: boolean | cdktf.IResolvable;
    /**
    * Specifies whether to `DENY`, `ALLOW`, or `REDIRECT` smart DNS proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
    */
    readonly detectSmartDnsProxyAction?: string;
    /**
    * This specifies the URL to which to redirect DNS proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
    */
    readonly detectSmartDnsProxyRedirecturl?: string;
    /**
    * This enables detection of requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
    */
    readonly detectTorExitNode?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
    */
    readonly detectTorExitNodeAction?: string;
    /**
    * This specifies the URL to which to redirect requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
    */
    readonly detectTorExitNodeRedirecturl?: string;
    /**
    * This enables detection of requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
    */
    readonly detectVpnDataCenter?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
    */
    readonly detectVpnDataCenterAction?: string;
    /**
    * This specifies the URL to which to redirect requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
    */
    readonly detectVpnDataCenterRedirecturl?: string;
    /**
    * Specifies how to field the proxy request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
    */
    readonly enableConfigurationMode?: string;
    /**
    * Applies GeoGuard proxy detection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the `epdForwardHeaderEnrichment` behavior for details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
    */
    readonly forwardHeaderEnrichment?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
    */
    readonly hostingProvider?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
    */
    readonly publicProxy?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
    */
    readonly residentialProxy?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
    */
    readonly smartDnsProxy?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
    */
    readonly torExitNode?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
    */
    readonly vpnDataCenter?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection | undefined);
    private _anonymousVpn?;
    get anonymousVpn(): string;
    set anonymousVpn(value: string);
    resetAnonymousVpn(): void;
    get anonymousVpnInput(): string | undefined;
    private _bestPracticeAction?;
    get bestPracticeAction(): string;
    set bestPracticeAction(value: string);
    resetBestPracticeAction(): void;
    get bestPracticeActionInput(): string | undefined;
    private _bestPracticeRedirecturl?;
    get bestPracticeRedirecturl(): string;
    set bestPracticeRedirecturl(value: string);
    resetBestPracticeRedirecturl(): void;
    get bestPracticeRedirecturlInput(): string | undefined;
    private _detectAnonymousVpn?;
    get detectAnonymousVpn(): boolean | cdktf.IResolvable;
    set detectAnonymousVpn(value: boolean | cdktf.IResolvable);
    resetDetectAnonymousVpn(): void;
    get detectAnonymousVpnInput(): boolean | cdktf.IResolvable | undefined;
    private _detectAnonymousVpnAction?;
    get detectAnonymousVpnAction(): string;
    set detectAnonymousVpnAction(value: string);
    resetDetectAnonymousVpnAction(): void;
    get detectAnonymousVpnActionInput(): string | undefined;
    private _detectAnonymousVpnRedirecturl?;
    get detectAnonymousVpnRedirecturl(): string;
    set detectAnonymousVpnRedirecturl(value: string);
    resetDetectAnonymousVpnRedirecturl(): void;
    get detectAnonymousVpnRedirecturlInput(): string | undefined;
    private _detectHostingProvider?;
    get detectHostingProvider(): boolean | cdktf.IResolvable;
    set detectHostingProvider(value: boolean | cdktf.IResolvable);
    resetDetectHostingProvider(): void;
    get detectHostingProviderInput(): boolean | cdktf.IResolvable | undefined;
    private _detectHostingProviderAction?;
    get detectHostingProviderAction(): string;
    set detectHostingProviderAction(value: string);
    resetDetectHostingProviderAction(): void;
    get detectHostingProviderActionInput(): string | undefined;
    private _detectHostingProviderRedirecturl?;
    get detectHostingProviderRedirecturl(): string;
    set detectHostingProviderRedirecturl(value: string);
    resetDetectHostingProviderRedirecturl(): void;
    get detectHostingProviderRedirecturlInput(): string | undefined;
    private _detectPublicProxy?;
    get detectPublicProxy(): boolean | cdktf.IResolvable;
    set detectPublicProxy(value: boolean | cdktf.IResolvable);
    resetDetectPublicProxy(): void;
    get detectPublicProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectPublicProxyAction?;
    get detectPublicProxyAction(): string;
    set detectPublicProxyAction(value: string);
    resetDetectPublicProxyAction(): void;
    get detectPublicProxyActionInput(): string | undefined;
    private _detectPublicProxyRedirecturl?;
    get detectPublicProxyRedirecturl(): string;
    set detectPublicProxyRedirecturl(value: string);
    resetDetectPublicProxyRedirecturl(): void;
    get detectPublicProxyRedirecturlInput(): string | undefined;
    private _detectResidentialProxy?;
    get detectResidentialProxy(): boolean | cdktf.IResolvable;
    set detectResidentialProxy(value: boolean | cdktf.IResolvable);
    resetDetectResidentialProxy(): void;
    get detectResidentialProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectResidentialProxyAction?;
    get detectResidentialProxyAction(): string;
    set detectResidentialProxyAction(value: string);
    resetDetectResidentialProxyAction(): void;
    get detectResidentialProxyActionInput(): string | undefined;
    private _detectResidentialProxyRedirecturl?;
    get detectResidentialProxyRedirecturl(): string;
    set detectResidentialProxyRedirecturl(value: string);
    resetDetectResidentialProxyRedirecturl(): void;
    get detectResidentialProxyRedirecturlInput(): string | undefined;
    private _detectSmartDnsProxy?;
    get detectSmartDnsProxy(): boolean | cdktf.IResolvable;
    set detectSmartDnsProxy(value: boolean | cdktf.IResolvable);
    resetDetectSmartDnsProxy(): void;
    get detectSmartDnsProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectSmartDnsProxyAction?;
    get detectSmartDnsProxyAction(): string;
    set detectSmartDnsProxyAction(value: string);
    resetDetectSmartDnsProxyAction(): void;
    get detectSmartDnsProxyActionInput(): string | undefined;
    private _detectSmartDnsProxyRedirecturl?;
    get detectSmartDnsProxyRedirecturl(): string;
    set detectSmartDnsProxyRedirecturl(value: string);
    resetDetectSmartDnsProxyRedirecturl(): void;
    get detectSmartDnsProxyRedirecturlInput(): string | undefined;
    private _detectTorExitNode?;
    get detectTorExitNode(): boolean | cdktf.IResolvable;
    set detectTorExitNode(value: boolean | cdktf.IResolvable);
    resetDetectTorExitNode(): void;
    get detectTorExitNodeInput(): boolean | cdktf.IResolvable | undefined;
    private _detectTorExitNodeAction?;
    get detectTorExitNodeAction(): string;
    set detectTorExitNodeAction(value: string);
    resetDetectTorExitNodeAction(): void;
    get detectTorExitNodeActionInput(): string | undefined;
    private _detectTorExitNodeRedirecturl?;
    get detectTorExitNodeRedirecturl(): string;
    set detectTorExitNodeRedirecturl(value: string);
    resetDetectTorExitNodeRedirecturl(): void;
    get detectTorExitNodeRedirecturlInput(): string | undefined;
    private _detectVpnDataCenter?;
    get detectVpnDataCenter(): boolean | cdktf.IResolvable;
    set detectVpnDataCenter(value: boolean | cdktf.IResolvable);
    resetDetectVpnDataCenter(): void;
    get detectVpnDataCenterInput(): boolean | cdktf.IResolvable | undefined;
    private _detectVpnDataCenterAction?;
    get detectVpnDataCenterAction(): string;
    set detectVpnDataCenterAction(value: string);
    resetDetectVpnDataCenterAction(): void;
    get detectVpnDataCenterActionInput(): string | undefined;
    private _detectVpnDataCenterRedirecturl?;
    get detectVpnDataCenterRedirecturl(): string;
    set detectVpnDataCenterRedirecturl(value: string);
    resetDetectVpnDataCenterRedirecturl(): void;
    get detectVpnDataCenterRedirecturlInput(): string | undefined;
    private _enableConfigurationMode?;
    get enableConfigurationMode(): string;
    set enableConfigurationMode(value: string);
    resetEnableConfigurationMode(): void;
    get enableConfigurationModeInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _forwardHeaderEnrichment?;
    get forwardHeaderEnrichment(): boolean | cdktf.IResolvable;
    set forwardHeaderEnrichment(value: boolean | cdktf.IResolvable);
    resetForwardHeaderEnrichment(): void;
    get forwardHeaderEnrichmentInput(): boolean | cdktf.IResolvable | undefined;
    private _hostingProvider?;
    get hostingProvider(): string;
    set hostingProvider(value: string);
    resetHostingProvider(): void;
    get hostingProviderInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _publicProxy?;
    get publicProxy(): string;
    set publicProxy(value: string);
    resetPublicProxy(): void;
    get publicProxyInput(): string | undefined;
    private _residentialProxy?;
    get residentialProxy(): string;
    set residentialProxy(value: string);
    resetResidentialProxy(): void;
    get residentialProxyInput(): string | undefined;
    private _smartDnsProxy?;
    get smartDnsProxy(): string;
    set smartDnsProxy(value: string);
    resetSmartDnsProxy(): void;
    get smartDnsProxyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _torExitNode?;
    get torExitNode(): string;
    set torExitNode(value: string);
    resetTorExitNode(): void;
    get torExitNodeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _vpnDataCenter?;
    get vpnDataCenter(): string;
    set vpnDataCenter(value: string);
    resetVpnDataCenter(): void;
    get vpnDataCenterInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment {
    /**
    * Sends the Enhanced Proxy Detection (`Akamai-EPD`) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}
    */
    readonly downloadDomainName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}
    */
    readonly g2OToken?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname | undefined);
    private _cpCode?;
    get cpCode(): number;
    set cpCode(value: number);
    resetCpCode(): void;
    get cpCodeInput(): number | undefined;
    private _downloadDomainName?;
    get downloadDomainName(): string;
    set downloadDomainName(value: string);
    resetDownloadDomainName(): void;
    get downloadDomainNameInput(): string | undefined;
    private _g2OToken?;
    get g2OToken(): string;
    set g2OToken(value: string);
    resetG2OToken(): void;
    get g2OTokenInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction {
    /**
    * Specifies the basic action to take when there is a failure to contact the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
    */
    readonly actionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}
    */
    readonly allowFcmParentOverride?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
    */
    readonly cexCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies a hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
    */
    readonly cexHostname?: string;
    /**
    * Specifies a custom path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
    */
    readonly cexPath?: string;
    /**
    * Specifies a custom redirect path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
    */
    readonly contentCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the static hostname for the alternate redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
    */
    readonly contentHostname?: string;
    /**
    * Specifies a custom redirect path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
    */
    readonly contentPath?: string;
    /**
    * Allows you to modify the original requested path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
    */
    readonly dynamicCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the redirect method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
    */
    readonly dynamicMethod?: string;
    /**
    * Specifies the new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
    */
    readonly dynamicPath?: string;
    /**
    * When enabled in case of a failure to contact the origin, the current behavior applies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Modifies the redirect's protocol using the value of the `protocol` field.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
    */
    readonly modifyProtocol?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `RECREATED_NS`, specifies the path for the `NetStorage` request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
    */
    readonly netStoragePath?: string;
    /**
    * When using either `contentCustomPath`, `cexCustomPath`, `dynamicCustomPath`, or `redirectCustomPath` to specify a custom path, enabling this passes in the original request's query string as part of the path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
    */
    readonly preserveQueryString?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `REDIRECT` and `modifyProtocol` is enabled, this specifies the redirect's protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
    */
    readonly protocol?: string;
    /**
    * Uses the `redirectPath` to customize a new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
    */
    readonly redirectCustomPath?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `REDIRECT` and the `redirectHostnameType` is `ALTERNATE`, this specifies the hostname for the redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
    */
    readonly redirectHostname?: string;
    /**
    * Whether to preserve or customize the hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
    */
    readonly redirectHostnameType?: string;
    /**
    * Specifies the HTTP response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
    */
    readonly redirectMethod?: number;
    /**
    * Specifies a new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
    */
    readonly redirectPath?: string;
    /**
    * Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
    */
    readonly saasCnameEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
    */
    readonly saasCnameLevel?: number;
    /**
    * Specifies the name of the cookie that identifies this SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
    */
    readonly saasCookie?: string;
    /**
    * Specifies the name of the query parameter that identifies this SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
    */
    readonly saasQueryString?: string;
    /**
    * Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
    */
    readonly saasRegex?: string;
    /**
    * Specifies the replacement pattern that defines the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
    */
    readonly saasReplace?: string;
    /**
    * Specifies the static portion of the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
    */
    readonly saasSuffix?: string;
    /**
    * Identifies the component of the request that identifies the SaaS dynamic fail action.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
    */
    readonly saasType?: string;
    /**
    * Assigns a new HTTP status code to the failure response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
    */
    readonly statusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode;
    /**
    * net_storage_hostname block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
    */
    readonly netStorageHostname?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    resetActionType(): void;
    get actionTypeInput(): string | undefined;
    private _allowFcmParentOverride?;
    get allowFcmParentOverride(): boolean | cdktf.IResolvable;
    set allowFcmParentOverride(value: boolean | cdktf.IResolvable);
    resetAllowFcmParentOverride(): void;
    get allowFcmParentOverrideInput(): boolean | cdktf.IResolvable | undefined;
    private _cexCustomPath?;
    get cexCustomPath(): boolean | cdktf.IResolvable;
    set cexCustomPath(value: boolean | cdktf.IResolvable);
    resetCexCustomPath(): void;
    get cexCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _cexHostname?;
    get cexHostname(): string;
    set cexHostname(value: string);
    resetCexHostname(): void;
    get cexHostnameInput(): string | undefined;
    private _cexPath?;
    get cexPath(): string;
    set cexPath(value: string);
    resetCexPath(): void;
    get cexPathInput(): string | undefined;
    private _contentCustomPath?;
    get contentCustomPath(): boolean | cdktf.IResolvable;
    set contentCustomPath(value: boolean | cdktf.IResolvable);
    resetContentCustomPath(): void;
    get contentCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _contentHostname?;
    get contentHostname(): string;
    set contentHostname(value: string);
    resetContentHostname(): void;
    get contentHostnameInput(): string | undefined;
    private _contentPath?;
    get contentPath(): string;
    set contentPath(value: string);
    resetContentPath(): void;
    get contentPathInput(): string | undefined;
    private _dynamicCustomPath?;
    get dynamicCustomPath(): boolean | cdktf.IResolvable;
    set dynamicCustomPath(value: boolean | cdktf.IResolvable);
    resetDynamicCustomPath(): void;
    get dynamicCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _dynamicMethod?;
    get dynamicMethod(): string;
    set dynamicMethod(value: string);
    resetDynamicMethod(): void;
    get dynamicMethodInput(): string | undefined;
    private _dynamicPath?;
    get dynamicPath(): string;
    set dynamicPath(value: string);
    resetDynamicPath(): void;
    get dynamicPathInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _modifyProtocol?;
    get modifyProtocol(): boolean | cdktf.IResolvable;
    set modifyProtocol(value: boolean | cdktf.IResolvable);
    resetModifyProtocol(): void;
    get modifyProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _netStoragePath?;
    get netStoragePath(): string;
    set netStoragePath(value: string);
    resetNetStoragePath(): void;
    get netStoragePathInput(): string | undefined;
    private _preserveQueryString?;
    get preserveQueryString(): boolean | cdktf.IResolvable;
    set preserveQueryString(value: boolean | cdktf.IResolvable);
    resetPreserveQueryString(): void;
    get preserveQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    resetProtocol(): void;
    get protocolInput(): string | undefined;
    private _redirectCustomPath?;
    get redirectCustomPath(): boolean | cdktf.IResolvable;
    set redirectCustomPath(value: boolean | cdktf.IResolvable);
    resetRedirectCustomPath(): void;
    get redirectCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _redirectHostname?;
    get redirectHostname(): string;
    set redirectHostname(value: string);
    resetRedirectHostname(): void;
    get redirectHostnameInput(): string | undefined;
    private _redirectHostnameType?;
    get redirectHostnameType(): string;
    set redirectHostnameType(value: string);
    resetRedirectHostnameType(): void;
    get redirectHostnameTypeInput(): string | undefined;
    private _redirectMethod?;
    get redirectMethod(): number;
    set redirectMethod(value: number);
    resetRedirectMethod(): void;
    get redirectMethodInput(): number | undefined;
    private _redirectPath?;
    get redirectPath(): string;
    set redirectPath(value: string);
    resetRedirectPath(): void;
    get redirectPathInput(): string | undefined;
    private _saasCnameEnabled?;
    get saasCnameEnabled(): boolean | cdktf.IResolvable;
    set saasCnameEnabled(value: boolean | cdktf.IResolvable);
    resetSaasCnameEnabled(): void;
    get saasCnameEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _saasCnameLevel?;
    get saasCnameLevel(): number;
    set saasCnameLevel(value: number);
    resetSaasCnameLevel(): void;
    get saasCnameLevelInput(): number | undefined;
    private _saasCookie?;
    get saasCookie(): string;
    set saasCookie(value: string);
    resetSaasCookie(): void;
    get saasCookieInput(): string | undefined;
    private _saasQueryString?;
    get saasQueryString(): string;
    set saasQueryString(value: string);
    resetSaasQueryString(): void;
    get saasQueryStringInput(): string | undefined;
    private _saasRegex?;
    get saasRegex(): string;
    set saasRegex(value: string);
    resetSaasRegex(): void;
    get saasRegexInput(): string | undefined;
    private _saasReplace?;
    get saasReplace(): string;
    set saasReplace(value: string);
    resetSaasReplace(): void;
    get saasReplaceInput(): string | undefined;
    private _saasSuffix?;
    get saasSuffix(): string;
    set saasSuffix(value: string);
    resetSaasSuffix(): void;
    get saasSuffixInput(): string | undefined;
    private _saasType?;
    get saasType(): string;
    set saasType(value: string);
    resetSaasType(): void;
    get saasTypeInput(): string | undefined;
    private _statusCode?;
    get statusCode(): number;
    set statusCode(value: number);
    resetStatusCode(): void;
    get statusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCode;
    get cpCode(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference;
    putCpCode(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode): void;
    resetCpCode(): void;
    get cpCodeInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode | undefined;
    private _netStorageHostname;
    get netStorageHostname(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference;
    putNetStorageHostname(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname): void;
    resetNetStorageHostname(): void;
    get netStorageHostnameInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility {
    /**
    * This behavior does not include any options. Specifying the behavior itself enables it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
    */
    readonly compatibility?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility | undefined);
    private _compatibility?;
    get compatibility(): boolean | cdktf.IResolvable;
    set compatibility(value: boolean | cdktf.IResolvable);
    resetCompatibility(): void;
    get compatibilityInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate {
    /**
    * When enabled, forces a validation test for all edge content to which the behavior applies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips {
    /**
    * When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing {
    /**
    * Enables the Cloud Marketing Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Select how to insert the MediaMath JavaScript reference script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
    */
    readonly javaScriptInsertionRule?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash.  For example, if the path prefix is `/mmath`, and the request is for `www.example.com/dir`, the new URL is `www.example.com/mmath/dir`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
    */
    readonly mediaMathPrefix?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _javaScriptInsertionRule?;
    get javaScriptInsertionRule(): string;
    set javaScriptInsertionRule(value: string);
    resetJavaScriptInsertionRule(): void;
    get javaScriptInsertionRuleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mediaMathPrefix?;
    get mediaMathPrefix(): string;
    set mediaMathPrefix(value: string);
    resetMediaMathPrefix(): void;
    get mediaMathPrefixInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus {
    /**
    * Enables the Cloud Marketing Plus Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Select how to insert the MediaMath JavaScript reference script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
    */
    readonly javaScriptInsertionRule?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash.  For example, if the path prefix is `/mmath`, and the request is for `www.example.com/dir`, the new URL is `www.example.com/mmath/dir`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
    */
    readonly mediaMathPrefix?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _javaScriptInsertionRule?;
    get javaScriptInsertionRule(): string;
    set javaScriptInsertionRule(value: string);
    resetJavaScriptInsertionRule(): void;
    get javaScriptInsertionRuleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mediaMathPrefix?;
    get mediaMathPrefix(): string;
    set mediaMathPrefix(value: string);
    resetMediaMathPrefix(): void;
    get mediaMathPrefixInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite {
    /**
    * This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the `Cloudlets API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Forward Rewrite Cloudlet behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader {
    /**
    * Specifies the set of data to be encrypted as a combination of concatenated strings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
    */
    readonly customSignString?: string[];
    /**
    * Specifies the name of the header that contains the request data that needs to be encrypted.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
    */
    readonly dataHeader?: string;
    /**
    * Enables the g2o verification behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the version of the encryption algorithm as an integer from `1` through `5`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
    */
    readonly encodingVersion?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the cryptographic `nonce` string.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
    */
    readonly nonce?: string;
    /**
    * Specifies the shared secret key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
    */
    readonly secretKey?: string;
    /**
    * Specifies the name of the header containing encrypted request data.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
    */
    readonly signedHeader?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use `customSignString` to customize the set of data to encrypt.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
    */
    readonly useCustomSignString?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader | undefined);
    private _customSignString?;
    get customSignString(): string[];
    set customSignString(value: string[]);
    resetCustomSignString(): void;
    get customSignStringInput(): string[] | undefined;
    private _dataHeader?;
    get dataHeader(): string;
    set dataHeader(value: string);
    resetDataHeader(): void;
    get dataHeaderInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _encodingVersion?;
    get encodingVersion(): number;
    set encodingVersion(value: number);
    resetEncodingVersion(): void;
    get encodingVersionInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _nonce?;
    get nonce(): string;
    set nonce(value: string);
    resetNonce(): void;
    get nonceInput(): string | undefined;
    private _secretKey?;
    get secretKey(): string;
    set secretKey(value: string);
    resetSecretKey(): void;
    get secretKeyInput(): string | undefined;
    private _signedHeader?;
    get signedHeader(): string;
    set signedHeader(value: string);
    resetSignedHeader(): void;
    get signedHeaderInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useCustomSignString?;
    get useCustomSignString(): boolean | cdktf.IResolvable;
    set useCustomSignString(value: boolean | cdktf.IResolvable);
    resetUseCustomSignString(): void;
    get useCustomSignStringInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber {
    /**
    * With `outputOption` set to specify any set of headers, this specifies the name of the header to report the GRN value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to report the GRN value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
    */
    readonly outputOption?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * This specifies the name of the variable to assign the GRN value to. You need to pre-declare any `variable` you specify within the rule tree.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
    */
    readonly variableName?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber | undefined);
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _outputOption?;
    get outputOption(): string;
    set outputOption(value: string);
    resetOutputOption(): void;
    get outputOptionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _variableName?;
    get variableName(): string;
    set variableName(value: string);
    resetVariableName(): void;
    get variableNameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: string;
    /**
    * When enabled, caches responses that include an `error` field at the top of the response body object.  Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
    */
    readonly cacheResponsesWithErrors?: boolean | cdktf.IResolvable;
    /**
    * Enables GraphQL caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The name of the JSON body parameter that identifies GraphQL POST requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
    */
    readonly operationsJsonBodyParameterName?: string;
    /**
    * Specifies the name of a query parameter that identifies requests as GraphQL queries.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
    */
    readonly operationsUrlQueryParameterName?: string;
    /**
    * Specify what happens if GraphQL query processing fails on POST requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
    */
    readonly postRequestProcessingErrorHandling?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching | undefined);
    private _advanced?;
    get advanced(): string;
    set advanced(value: string);
    resetAdvanced(): void;
    get advancedInput(): string | undefined;
    private _cacheResponsesWithErrors?;
    get cacheResponsesWithErrors(): boolean | cdktf.IResolvable;
    set cacheResponsesWithErrors(value: boolean | cdktf.IResolvable);
    resetCacheResponsesWithErrors(): void;
    get cacheResponsesWithErrorsInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _operationsJsonBodyParameterName?;
    get operationsJsonBodyParameterName(): string;
    set operationsJsonBodyParameterName(value: string);
    resetOperationsJsonBodyParameterName(): void;
    get operationsJsonBodyParameterNameInput(): string | undefined;
    private _operationsUrlQueryParameterName?;
    get operationsUrlQueryParameterName(): string;
    set operationsUrlQueryParameterName(value: string);
    resetOperationsUrlQueryParameterName(): void;
    get operationsUrlQueryParameterNameInput(): string | undefined;
    private _postRequestProcessingErrorHandling?;
    get postRequestProcessingErrorHandling(): string;
    set postRequestProcessingErrorHandling(value: string);
    resetPostRequestProcessingErrorHandling(): void;
    get postRequestProcessingErrorHandlingInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse {
    /**
    * Specify when to compress responses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced {
    /**
    * Human-readable description of what the XML block does.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * A block of Akamai XML metadata.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
    */
    readonly xml?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _xml?;
    get xml(): string;
    set xml(value: string);
    resetXml(): void;
    get xmlInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, `maximumReconnects` effectively overrides the value of `retryCount`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
    */
    readonly maximumReconnects?: number;
    /**
    * The number of consecutive connection failures that mark an IP address as faulty.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
    */
    readonly retryCount?: number;
    /**
    * Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
    */
    readonly retryInterval?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumReconnects?;
    get maximumReconnects(): number;
    set maximumReconnects(value: number);
    resetMaximumReconnects(): void;
    get maximumReconnectsInput(): number | undefined;
    private _retryCount?;
    get retryCount(): number;
    set retryCount(value: number);
    resetRetryCount(): void;
    get retryCountInput(): number | undefined;
    private _retryInterval?;
    get retryInterval(): string;
    set retryInterval(value: string);
    resetRetryInterval(): void;
    get retryIntervalInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding {
    /**
    * Whether to pull the serial number from the variable value set in the `advanced` behavior. Work with your Akamai Services team to add the `advanced` behavior earlier in your property to extract and apply the `AKA_PM_EIP_HSAF_SERIAL` variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
    */
    readonly customExtractedSerial?: boolean | cdktf.IResolvable;
    /**
    * Enables HSAF for Edge IP Binding customers with a large footprint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than `hashMinValue`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
    */
    readonly hashMaxValue?: number;
    /**
    * Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than `hashMaxValue`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
    */
    readonly hashMinValue?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies where the behavior is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
    */
    readonly tier?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding | undefined);
    private _customExtractedSerial?;
    get customExtractedSerial(): boolean | cdktf.IResolvable;
    set customExtractedSerial(value: boolean | cdktf.IResolvable);
    resetCustomExtractedSerial(): void;
    get customExtractedSerialInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hashMaxValue?;
    get hashMaxValue(): number;
    set hashMaxValue(value: number);
    resetHashMaxValue(): void;
    get hashMaxValueInput(): number | undefined;
    private _hashMinValue?;
    get hashMinValue(): number;
    set hashMinValue(value: number);
    resetHashMinValue(): void;
    get hashMinValueInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tier?;
    get tier(): string;
    set tier(value: string);
    resetTier(): void;
    get tierInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2 {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2ToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2OutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2ToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2OutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2 | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2 | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3 {
    /**
    * This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the `Property Manager documentation` for more details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3ToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3OutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3ToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3OutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3 | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3 | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity {
    /**
    * Applies HSTS to this set of requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * When enabled, applies HSTS to all subdomains.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
    */
    readonly includeSubDomains?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the duration for which to apply HSTS for new browser connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
    */
    readonly maxAge?: string;
    /**
    * When enabled, adds this domain to the browser's preload list. You still need to declare the domain at `hstspreload.org`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
    */
    readonly preload?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects all HTTP requests to HTTPS.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
    */
    readonly redirect?: boolean | cdktf.IResolvable;
    /**
    * Specifies a response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
    */
    readonly redirectStatusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _includeSubDomains?;
    get includeSubDomains(): boolean | cdktf.IResolvable;
    set includeSubDomains(value: boolean | cdktf.IResolvable);
    resetIncludeSubDomains(): void;
    get includeSubDomainsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maxAge?;
    get maxAge(): string;
    set maxAge(value: string);
    resetMaxAge(): void;
    get maxAgeInput(): string | undefined;
    private _preload?;
    get preload(): boolean | cdktf.IResolvable;
    set preload(value: boolean | cdktf.IResolvable);
    resetPreload(): void;
    get preloadInput(): boolean | cdktf.IResolvable | undefined;
    private _redirect?;
    get redirect(): boolean | cdktf.IResolvable;
    set redirect(value: boolean | cdktf.IResolvable);
    resetRedirect(): void;
    get redirectInput(): boolean | cdktf.IResolvable | undefined;
    private _redirectStatusCode?;
    get redirectStatusCode(): number;
    set redirectStatusCode(value: number);
    resetRedirectStatusCode(): void;
    get redirectStatusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
    */
    readonly upgrade?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _upgrade?;
    get upgrade(): string;
    set upgrade(value: string);
    resetUpgrade(): void;
    get upgradeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride {
    /**
    * Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
    */
    readonly dpr?: number;
    /**
    * This selects the variable with the desired pixel density. The variable specifies the same type of data as the `dpr` option below.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
    */
    readonly dprvar?: string;
    /**
    * Whether to exclude all query parameters from the Image and Video Manager cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
    */
    readonly excludeAllQueryParameters?: boolean | cdktf.IResolvable;
    /**
    * Specifies individual query parameters to exclude from the Image and Video Manager cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
    */
    readonly excludedQueryParameters?: string[];
    /**
    * Specifies the type of the browser, or the encodings passed in the `Accept` header, that you want to optimize images for.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
    */
    readonly format?: string;
    /**
    * This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the `format` option below.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
    */
    readonly formatvar?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Selects the type of query parameter you want to set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
    */
    readonly override?: string;
    /**
    * This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
    */
    readonly policy?: string;
    /**
    * This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
    */
    readonly policyvar?: string;
    /**
    * This selects one of the property's rule tree variables to assign to the `policyvarName` variable within Image and Video Manager.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
    */
    readonly policyvarIMvar?: string;
    /**
    * This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
    */
    readonly policyvarName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies how to set a query parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
    */
    readonly typesel?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
    */
    readonly width?: number;
    /**
    * Selects the variable with the desired width.  If the Image and Video Manager policy doesn't define that width, it serves the next largest width.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
    */
    readonly widthvar?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride | undefined);
    private _dpr?;
    get dpr(): number;
    set dpr(value: number);
    resetDpr(): void;
    get dprInput(): number | undefined;
    private _dprvar?;
    get dprvar(): string;
    set dprvar(value: string);
    resetDprvar(): void;
    get dprvarInput(): string | undefined;
    private _excludeAllQueryParameters?;
    get excludeAllQueryParameters(): boolean | cdktf.IResolvable;
    set excludeAllQueryParameters(value: boolean | cdktf.IResolvable);
    resetExcludeAllQueryParameters(): void;
    get excludeAllQueryParametersInput(): boolean | cdktf.IResolvable | undefined;
    private _excludedQueryParameters?;
    get excludedQueryParameters(): string[];
    set excludedQueryParameters(value: string[]);
    resetExcludedQueryParameters(): void;
    get excludedQueryParametersInput(): string[] | undefined;
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _formatvar?;
    get formatvar(): string;
    set formatvar(value: string);
    resetFormatvar(): void;
    get formatvarInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _override?;
    get override(): string;
    set override(value: string);
    resetOverride(): void;
    get overrideInput(): string | undefined;
    private _policy?;
    get policy(): string;
    set policy(value: string);
    resetPolicy(): void;
    get policyInput(): string | undefined;
    private _policyvar?;
    get policyvar(): string;
    set policyvar(value: string);
    resetPolicyvar(): void;
    get policyvarInput(): string | undefined;
    private _policyvarIMvar?;
    get policyvarIMvar(): string;
    set policyvarIMvar(value: string);
    resetPolicyvarIMvar(): void;
    get policyvarIMvarInput(): string | undefined;
    private _policyvarName?;
    get policyvarName(): string;
    set policyvarName(value: string);
    resetPolicyvarName(): void;
    get policyvarNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _typesel?;
    get typesel(): string;
    set typesel(value: string);
    resetTypesel(): void;
    get typeselInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _widthvar?;
    get widthvar(): string;
    set widthvar(value: string);
    resetWidthvar(): void;
    get widthvarInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}
    */
    readonly imageSet?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}
    */
    readonly policySetType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}
    */
    readonly videoSet?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager | undefined);
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _imageSet?;
    get imageSet(): string;
    set imageSet(value: string);
    resetImageSet(): void;
    get imageSetInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySetType?;
    get policySetType(): string;
    set policySetType(value: string);
    resetPolicySetType(): void;
    get policySetTypeInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _videoSet?;
    get videoSet(): string;
    set videoSet(value: string);
    resetVideoSet(): void;
    get videoSetInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager {
    /**
    * Generates a custom `Image and Video Manager API` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the `policyToken`) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
    */
    readonly apiReferenceTitle?: string;
    /**
    * Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Enable image management capabilities and generate a corresponding API token.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Identifies the existing policy set configured with `Image and Video Manager API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
    */
    readonly policySet?: string;
    /**
    * Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, `default` becomes the prefix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
    */
    readonly policyToken?: string;
    /**
    * Specify the default policy identifier, which is registered with the `Image and Video Manager API` once you activate this property.  The `advanced` option needs to be inactive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
    */
    readonly policyTokenDefault?: string;
    /**
    * Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.  Note that enabling this may affect screen layout in unexpected ways.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
    */
    readonly settingsTitle?: string;
    /**
    * Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
    */
    readonly superCacheRegion?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
    */
    readonly trafficTitle?: string;
    /**
    * Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
    */
    readonly useExistingPolicySet?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _apiReferenceTitle?;
    get apiReferenceTitle(): string;
    set apiReferenceTitle(value: string);
    resetApiReferenceTitle(): void;
    get apiReferenceTitleInput(): string | undefined;
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySet?;
    get policySet(): string;
    set policySet(value: string);
    resetPolicySet(): void;
    get policySetInput(): string | undefined;
    private _policyToken?;
    get policyToken(): string;
    set policyToken(value: string);
    resetPolicyToken(): void;
    get policyTokenInput(): string | undefined;
    private _policyTokenDefault?;
    get policyTokenDefault(): string;
    set policyTokenDefault(value: string);
    resetPolicyTokenDefault(): void;
    get policyTokenDefaultInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsTitle?;
    get settingsTitle(): string;
    set settingsTitle(value: string);
    resetSettingsTitle(): void;
    get settingsTitleInput(): string | undefined;
    private _superCacheRegion?;
    get superCacheRegion(): string;
    set superCacheRegion(value: string);
    resetSuperCacheRegion(): void;
    get superCacheRegionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trafficTitle?;
    get trafficTitle(): string;
    set trafficTitle(value: string);
    resetTrafficTitle(): void;
    get trafficTitleInput(): string | undefined;
    private _useExistingPolicySet?;
    get useExistingPolicySet(): boolean | cdktf.IResolvable;
    set useExistingPolicySet(value: boolean | cdktf.IResolvable);
    resetUseExistingPolicySet(): void;
    get useExistingPolicySetInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo {
    /**
    * When disabled, applies a single standard policy based on your property name.  Allows you to reference a rule-specific `policyToken` for videos with different match criteria.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
    */
    readonly apiReferenceTitle?: string;
    /**
    * When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Applies Image and Video Manager's video optimization to the current content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Identifies the existing policy set configured with `Image and Video Manager API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
    */
    readonly policySet?: string;
    /**
    * Specifies a custom policy defined in the Image and Video Manager Policy Manager or the `Image and Video Manager API`. The policy name can include up to 64 alphanumeric, dash, or underscore characters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
    */
    readonly policyToken?: string;
    /**
    * Specifies the default policy identifier, which is registered with the `Image and Video Manager API` once you activate this property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
    */
    readonly policyTokenDefault?: string;
    /**
    * When enabled, scales down video for smaller mobile screens, based on the device's `User-Agent` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
    */
    readonly settingsTitle?: string;
    /**
    * To optimize caching, assign a region close to your site's heaviest traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
    */
    readonly superCacheRegion?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
    */
    readonly trafficTitle?: string;
    /**
    * Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
    */
    readonly useExistingPolicySet?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _apiReferenceTitle?;
    get apiReferenceTitle(): string;
    set apiReferenceTitle(value: string);
    resetApiReferenceTitle(): void;
    get apiReferenceTitleInput(): string | undefined;
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySet?;
    get policySet(): string;
    set policySet(value: string);
    resetPolicySet(): void;
    get policySetInput(): string | undefined;
    private _policyToken?;
    get policyToken(): string;
    set policyToken(value: string);
    resetPolicyToken(): void;
    get policyTokenInput(): string | undefined;
    private _policyTokenDefault?;
    get policyTokenDefault(): string;
    set policyTokenDefault(value: string);
    resetPolicyTokenDefault(): void;
    get policyTokenDefaultInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsTitle?;
    get settingsTitle(): string;
    set settingsTitle(value: string);
    resetSettingsTitle(): void;
    get settingsTitleInput(): string | undefined;
    private _superCacheRegion?;
    get superCacheRegion(): string;
    set superCacheRegion(value: string);
    resetSuperCacheRegion(): void;
    get superCacheRegionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trafficTitle?;
    get trafficTitle(): string;
    set trafficTitle(value: string);
    resetTrafficTitle(): void;
    get trafficTitleInput(): string | undefined;
    private _useExistingPolicySet?;
    get useExistingPolicySet(): boolean | cdktf.IResolvable;
    set useExistingPolicySet(value: boolean | cdktf.IResolvable);
    resetUseExistingPolicySet(): void;
    get useExistingPolicySetInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude {
    /**
    * Identifies the include you want to add to your rule tree. You can get the include ID using `PAPI`. This option only accepts digits, without the `inc_` ID prefix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant {
    /**
    * Specify link relation values that activate the prefetching behavior. For example, specifying `fetch` allows you to use shorter `rel="fetch"` markup.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
    */
    readonly customLinkRelations?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, applies prefetching only to objects already set to be cacheable, for example using the `caching` behavior. Only applies to content with the `tieredDistribution` behavior enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
    */
    readonly prefetchCacheable?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from `<a>` or `<link>` tags with the appropriate link relation attribute.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
    */
    readonly prefetchHtml?: boolean | cdktf.IResolvable;
    /**
    * Allows otherwise non-cacheable `no-store` content to prefetch if the URL path ends with `/` to indicate a request for a default file, or if the extension matches the value of the `prefetchNoStoreExtensions` option. Only applies to content with the `sureRoute` behavior enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
    */
    readonly prefetchNoStore?: boolean | cdktf.IResolvable;
    /**
    * Specifies a set of file extensions for which the `prefetchNoStore` option is allowed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
    */
    readonly prefetchNoStoreExtensions?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant | undefined);
    private _customLinkRelations?;
    get customLinkRelations(): string[];
    set customLinkRelations(value: string[]);
    resetCustomLinkRelations(): void;
    get customLinkRelationsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchCacheable?;
    get prefetchCacheable(): boolean | cdktf.IResolvable;
    set prefetchCacheable(value: boolean | cdktf.IResolvable);
    resetPrefetchCacheable(): void;
    get prefetchCacheableInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchHtml?;
    get prefetchHtml(): boolean | cdktf.IResolvable;
    set prefetchHtml(value: boolean | cdktf.IResolvable);
    resetPrefetchHtml(): void;
    get prefetchHtmlInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchNoStore?;
    get prefetchNoStore(): boolean | cdktf.IResolvable;
    set prefetchNoStore(value: boolean | cdktf.IResolvable);
    resetPrefetchNoStore(): void;
    get prefetchNoStoreInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchNoStoreExtensions?;
    get prefetchNoStoreExtensions(): string[];
    set prefetchNoStoreExtensions(value: string[]);
    resetPrefetchNoStoreExtensions(): void;
    get prefetchNoStoreExtensionsInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig {
    /**
    * Enables the InstantConfig behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization {
    /**
    * Specifies whether to cache partial objects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
    */
    readonly enablePartialObjectCaching?: string;
    /**
    * Enables the file optimization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as `MB` or `GB`. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
    */
    readonly maximumSize?: string;
    /**
    * Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as `MB` or `GB`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
    */
    readonly minimumSize?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When `enablePartialObjectCaching` is set to `PARTIAL_OBJECT_CACHING`, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
    */
    readonly useVersioning?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization | undefined);
    private _enablePartialObjectCaching?;
    get enablePartialObjectCaching(): string;
    set enablePartialObjectCaching(value: string);
    resetEnablePartialObjectCaching(): void;
    get enablePartialObjectCachingInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumSize?;
    get maximumSize(): string;
    set maximumSize(value: string);
    resetMaximumSize(): void;
    get maximumSizeInput(): string | undefined;
    private _minimumSize?;
    get minimumSize(): string;
    set minimumSize(value: string);
    resetMinimumSize(): void;
    get minimumSizeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useVersioning?;
    get useVersioning(): boolean | cdktf.IResolvable;
    set useVersioning(value: boolean | cdktf.IResolvable);
    resetUseVersioning(): void;
    get useVersioningInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced {
    /**
    * Enables the file optimization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the size of each fragment used for partial object caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
    */
    readonly fragmentSize?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a `MB` or `GB` suffix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * The number of POC fragments to prefetch after the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
    */
    readonly prefetchAfterRequest?: number;
    /**
    * The number of POC fragments to prefetch during the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
    */
    readonly prefetchDuringRequest?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _fragmentSize?;
    get fragmentSize(): string;
    set fragmentSize(value: string);
    resetFragmentSize(): void;
    get fragmentSizeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _prefetchAfterRequest?;
    get prefetchAfterRequest(): number;
    set prefetchAfterRequest(value: number);
    resetPrefetchAfterRequest(): void;
    get prefetchAfterRequestInput(): number | undefined;
    private _prefetchDuringRequest?;
    get prefetchDuringRequest(): number;
    set prefetchDuringRequest(value: number);
    resetPrefetchDuringRequest(): void;
    get prefetchDuringRequestInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable {
    /**
    * The unit of measurement, either `KBPS`, `MBPS`, or `GBPS`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
    */
    readonly bitrateUnit?: string;
    /**
    * The numeric indicator of the download rate.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
    */
    readonly bitrateValue?: number;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable | cdktf.IResolvable | undefined);
    private _bitrateUnit?;
    get bitrateUnit(): string;
    set bitrateUnit(value: string);
    resetBitrateUnit(): void;
    get bitrateUnitInput(): string | undefined;
    private _bitrateValue?;
    get bitrateValue(): number;
    set bitrateValue(value: number);
    resetBitrateValue(): void;
    get bitrateValueInput(): number | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable {
    /**
    * The unit of measurement, either `SECONDS` of the elapsed download time, or `BYTES` of the file size.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
    */
    readonly thresholdUnit?: string;
    /**
    * The numeric indicator of the minimum file size or elapsed download time.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
    */
    readonly thresholdValue?: number;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable | cdktf.IResolvable | undefined);
    private _thresholdUnit?;
    get thresholdUnit(): string;
    set thresholdUnit(value: string);
    resetThresholdUnit(): void;
    get thresholdUnitInput(): string | undefined;
    private _thresholdValue?;
    get thresholdValue(): number;
    set thresholdValue(value: number);
    resetThresholdValue(): void;
    get thresholdValueInput(): number | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate {
    /**
    * When enabled, activates the bit rate limiting behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * bitrate_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
    */
    readonly bitrateTable?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable;
    /**
    * threshold_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
    */
    readonly thresholdTable?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _bitrateTable;
    get bitrateTable(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableList;
    putBitrateTable(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable): void;
    resetBitrateTable(): void;
    get bitrateTableInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable[] | undefined;
    private _thresholdTable;
    get thresholdTable(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableList;
    putThresholdTable(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable): void;
    resetThresholdTable(): void;
    get thresholdTableInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable[] | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom {
    /**
    * Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, `round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms` logs the total time to complete the response. See `Support for variables` for more information. Since this option can specify both a request and response, it overrides any `customLogField` settings in the `report` behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
    */
    readonly customLogField?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Whether to append additional custom data to each log line.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
    */
    readonly logCustomLogField?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom | undefined);
    private _customLogField?;
    get customLogField(): string;
    set customLogField(value: string);
    resetCustomLogField(): void;
    get customLogFieldInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _logCustomLogField?;
    get logCustomLogField(): boolean | cdktf.IResolvable;
    set logCustomLogField(value: boolean | cdktf.IResolvable);
    resetLogCustomLogField(): void;
    get logCustomLogFieldInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse {
    /**
    * This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see `Enable mPulse in Property Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
    */
    readonly apiKey?: string;
    /**
    * Allows you to override the browser's default (150) maximum number of reported performance timeline entries.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
    */
    readonly bufferSize?: string;
    /**
    * A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the `window.BOOMR_config` object. For example, this turns on monitoring of Single Page App frameworks: `"{\"history\": {\"enabled\": true, \"auto\": true}}"`.  See `Configuration Overrides` for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
    */
    readonly configOverride?: string;
    /**
    * Applies performance monitoring to this behavior's set of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the version of the Boomerang JavaScript loader snippet. See `mPulse Loader Snippets` for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
    */
    readonly loaderVersion?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
    */
    readonly requirePci?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
    */
    readonly titleOptional?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse | undefined);
    private _apiKey?;
    get apiKey(): string;
    set apiKey(value: string);
    resetApiKey(): void;
    get apiKeyInput(): string | undefined;
    private _bufferSize?;
    get bufferSize(): string;
    set bufferSize(value: string);
    resetBufferSize(): void;
    get bufferSizeInput(): string | undefined;
    private _configOverride?;
    get configOverride(): string;
    set configOverride(value: string);
    resetConfigOverride(): void;
    get configOverrideInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _loaderVersion?;
    get loaderVersion(): string;
    set loaderVersion(value: string);
    resetLoaderVersion(): void;
    get loaderVersionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _requirePci?;
    get requirePci(): boolean | cdktf.IResolvable;
    set requirePci(value: boolean | cdktf.IResolvable);
    resetRequirePci(): void;
    get requirePciInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _titleOptional?;
    get titleOptional(): string;
    set titleOptional(value: string);
    resetTitleOptional(): void;
    get titleOptionalInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization {
    /**
    * Enables the Manifest Personalization feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Includes additional `Akamai-Manifest-Personalization` and `Akamai-Manifest-Personalization-Config-Source` debugging headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
    */
    readonly hlsEnableDebugHeaders?: boolean | cdktf.IResolvable;
    /**
    * Allows you to customize the HLS master manifest that's sent to the requesting client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
    */
    readonly hlsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies a comma-delimited set of bit rate ranges, such as `100-400,1000-4000`. Playlists specified in the `#EXT-X-STREAM-INF` tag with bit rates outside of any of those ranges are excluded from the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
    */
    readonly hlsFilterInBitrateRanges?: string;
    /**
    * Specifies a comma-delimited set of preferred bit rates, such as `100,200,400`. Playlists specified in the `#EXT-X-STREAM-INF` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
    */
    readonly hlsFilterInBitrates?: string;
    /**
    * Applies with `hlsEnabled` on.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
    */
    readonly hlsMode?: string;
    /**
    * Sets the preferred bit rate in Kbps. This causes the media playlist specified in the `#EXT-X-STREAM-INF` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
    */
    readonly hlsPreferredBitrate?: string;
    /**
    * Specifies query parameters for the HLS master manifest to customize the manifest's content.  Any settings specified in the query string override those already configured in Property Manager.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
    */
    readonly hlsQueryParamEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies a primary key as a token to accompany the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
    */
    readonly hlsQueryParamSecretKey?: string;
    /**
    * Specifies a transition key as a token to accompany the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
    */
    readonly hlsQueryParamTransitionKey?: string;
    /**
    * Allows you to configure advanced settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
    */
    readonly hlsShowAdvanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
    */
    readonly hlsTitle?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsEnableDebugHeaders?;
    get hlsEnableDebugHeaders(): boolean | cdktf.IResolvable;
    set hlsEnableDebugHeaders(value: boolean | cdktf.IResolvable);
    resetHlsEnableDebugHeaders(): void;
    get hlsEnableDebugHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsEnabled?;
    get hlsEnabled(): boolean | cdktf.IResolvable;
    set hlsEnabled(value: boolean | cdktf.IResolvable);
    resetHlsEnabled(): void;
    get hlsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsFilterInBitrateRanges?;
    get hlsFilterInBitrateRanges(): string;
    set hlsFilterInBitrateRanges(value: string);
    resetHlsFilterInBitrateRanges(): void;
    get hlsFilterInBitrateRangesInput(): string | undefined;
    private _hlsFilterInBitrates?;
    get hlsFilterInBitrates(): string;
    set hlsFilterInBitrates(value: string);
    resetHlsFilterInBitrates(): void;
    get hlsFilterInBitratesInput(): string | undefined;
    private _hlsMode?;
    get hlsMode(): string;
    set hlsMode(value: string);
    resetHlsMode(): void;
    get hlsModeInput(): string | undefined;
    private _hlsPreferredBitrate?;
    get hlsPreferredBitrate(): string;
    set hlsPreferredBitrate(value: string);
    resetHlsPreferredBitrate(): void;
    get hlsPreferredBitrateInput(): string | undefined;
    private _hlsQueryParamEnabled?;
    get hlsQueryParamEnabled(): boolean | cdktf.IResolvable;
    set hlsQueryParamEnabled(value: boolean | cdktf.IResolvable);
    resetHlsQueryParamEnabled(): void;
    get hlsQueryParamEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsQueryParamSecretKey?;
    get hlsQueryParamSecretKey(): string;
    set hlsQueryParamSecretKey(value: string);
    resetHlsQueryParamSecretKey(): void;
    get hlsQueryParamSecretKeyInput(): string | undefined;
    private _hlsQueryParamTransitionKey?;
    get hlsQueryParamTransitionKey(): string;
    set hlsQueryParamTransitionKey(value: string);
    resetHlsQueryParamTransitionKey(): void;
    get hlsQueryParamTransitionKeyInput(): string | undefined;
    private _hlsShowAdvanced?;
    get hlsShowAdvanced(): boolean | cdktf.IResolvable;
    set hlsShowAdvanced(value: boolean | cdktf.IResolvable);
    resetHlsShowAdvanced(): void;
    get hlsShowAdvancedInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsTitle?;
    get hlsTitle(): string;
    set hlsTitle(value: string);
    resetHlsTitle(): void;
    get hlsTitleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Set this value to `adobe_primetime`, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
    */
    readonly partner?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * The user name for your Adobe Primetime account.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
    */
    readonly username?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _partner?;
    get partner(): string;
    set partner(value: string);
    resetPartner(): void;
    get partnerInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as `www.example.com/js/site.js`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
    */
    readonly serverpushlist?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _serverpushlist?;
    get serverpushlist(): string[];
    set serverpushlist(value: string[]);
    resetServerpushlist(): void;
    get serverpushlistInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration {
    /**
    * Enables Media Acceleration.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
    */
    readonly optout?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _optout?;
    get optout(): string;
    set optout(value: string);
    resetOptout(): void;
    get optoutInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient {
    /**
    * Specifies the ID of data source's beacon.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
    */
    readonly beaconId?: string;
    /**
    * Enables client-side download analytics.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Enables the hybrid HTTP/UDP protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
    */
    readonly useHybridHttpUdp?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient | undefined);
    private _beaconId?;
    get beaconId(): string;
    set beaconId(value: string);
    resetBeaconId(): void;
    get beaconIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useHybridHttpUdp?;
    get useHybridHttpUdp(): boolean | cdktf.IResolvable;
    set useHybridHttpUdp(value: boolean | cdktf.IResolvable);
    resetUseHybridHttpUdp(): void;
    get useHybridHttpUdpInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization {
    /**
    * Enables the partial-object caching behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover {
    /**
    * When enabled, caches the error response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
    */
    readonly cacheErrorResponse?: boolean | cdktf.IResolvable;
    /**
    * This sets error response's TTL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
    */
    readonly cacheWindow?: string;
    /**
    * Specifies the response code served to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
    */
    readonly clientResponseCode?: string;
    /**
    * Allows you to configure failover settings when the origin has content errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
    */
    readonly detectObjectUnavailable?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
    */
    readonly detectObjectUnavailableTitle?: string;
    /**
    * Allows you to configure failover settings when the origin server responds with errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
    */
    readonly detectOriginUnavailable?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
    */
    readonly detectOriginUnavailableTitle?: string;
    /**
    * Allows you to configure what happens when the origin is unresponsive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
    */
    readonly detectOriginUnresponsive?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
    */
    readonly detectOriginUnresponsiveTitle?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
    */
    readonly objectUnavailableAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
    */
    readonly objectUnavailableBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
    */
    readonly objectUnavailableBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
    */
    readonly objectUnavailableBlacklistWindow?: string;
    /**
    * Changes the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
    */
    readonly objectUnavailableChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify `RESPONSE_CODES`, the only available option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
    */
    readonly objectUnavailableDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
    */
    readonly objectUnavailableIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
    */
    readonly objectUnavailableModifiedPath?: string;
    /**
    * Enabling this allows you to modify the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
    */
    readonly objectUnavailableModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies either the `HTTP` or `HTTPS` protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
    */
    readonly objectUnavailableProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
    */
    readonly objectUnavailableRecovery?: string;
    /**
    * Specifies a redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
    */
    readonly objectUnavailableRedirectMethod?: number;
    /**
    * Specifies the set of response codes identifying when there are content errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
    */
    readonly objectUnavailableResponseCodes?: string[];
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
    */
    readonly objectUnavailableRetryLimit?: string;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
    */
    readonly originUnavailableAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
    */
    readonly originUnavailableBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
    */
    readonly originUnavailableBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
    */
    readonly originUnavailableBlacklistWindow?: string;
    /**
    * Modifies the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
    */
    readonly originUnavailableChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify `RESPONSE_CODES`, the only available option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
    */
    readonly originUnavailableDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
    */
    readonly originUnavailableIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
    */
    readonly originUnavailableModifiedPath?: string;
    /**
    * Modifies the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
    */
    readonly originUnavailableModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies either the `HTTP` or `HTTPS` protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
    */
    readonly originUnavailableProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
    */
    readonly originUnavailableRecovery?: string;
    /**
    * Specifies either a redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
    */
    readonly originUnavailableRedirectMethod?: number;
    /**
    * Specifies the set of response codes identifying when the origin responds with errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
    */
    readonly originUnavailableResponseCodes?: string[];
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
    */
    readonly originUnavailableRetryLimit?: string;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
    */
    readonly originUnresponsiveAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
    */
    readonly originUnresponsiveBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
    */
    readonly originUnresponsiveBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
    */
    readonly originUnresponsiveBlacklistWindow?: string;
    /**
    * This allows you to change the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
    */
    readonly originUnresponsiveChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify the level of response to slow origin connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
    */
    readonly originUnresponsiveDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
    */
    readonly originUnresponsiveIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
    */
    readonly originUnresponsiveModifiedPath?: string;
    /**
    * Modifies the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
    */
    readonly originUnresponsiveModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies which protocol to use.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
    */
    readonly originUnresponsiveProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
    */
    readonly originUnresponsiveRecovery?: string;
    /**
    * Specifies the redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
    */
    readonly originUnresponsiveRedirectMethod?: number;
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
    */
    readonly originUnresponsiveRetryLimit?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
    */
    readonly otherOptions?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover | undefined);
    private _cacheErrorResponse?;
    get cacheErrorResponse(): boolean | cdktf.IResolvable;
    set cacheErrorResponse(value: boolean | cdktf.IResolvable);
    resetCacheErrorResponse(): void;
    get cacheErrorResponseInput(): boolean | cdktf.IResolvable | undefined;
    private _cacheWindow?;
    get cacheWindow(): string;
    set cacheWindow(value: string);
    resetCacheWindow(): void;
    get cacheWindowInput(): string | undefined;
    private _clientResponseCode?;
    get clientResponseCode(): string;
    set clientResponseCode(value: string);
    resetClientResponseCode(): void;
    get clientResponseCodeInput(): string | undefined;
    private _detectObjectUnavailable?;
    get detectObjectUnavailable(): boolean | cdktf.IResolvable;
    set detectObjectUnavailable(value: boolean | cdktf.IResolvable);
    resetDetectObjectUnavailable(): void;
    get detectObjectUnavailableInput(): boolean | cdktf.IResolvable | undefined;
    private _detectObjectUnavailableTitle?;
    get detectObjectUnavailableTitle(): string;
    set detectObjectUnavailableTitle(value: string);
    resetDetectObjectUnavailableTitle(): void;
    get detectObjectUnavailableTitleInput(): string | undefined;
    private _detectOriginUnavailable?;
    get detectOriginUnavailable(): boolean | cdktf.IResolvable;
    set detectOriginUnavailable(value: boolean | cdktf.IResolvable);
    resetDetectOriginUnavailable(): void;
    get detectOriginUnavailableInput(): boolean | cdktf.IResolvable | undefined;
    private _detectOriginUnavailableTitle?;
    get detectOriginUnavailableTitle(): string;
    set detectOriginUnavailableTitle(value: string);
    resetDetectOriginUnavailableTitle(): void;
    get detectOriginUnavailableTitleInput(): string | undefined;
    private _detectOriginUnresponsive?;
    get detectOriginUnresponsive(): boolean | cdktf.IResolvable;
    set detectOriginUnresponsive(value: boolean | cdktf.IResolvable);
    resetDetectOriginUnresponsive(): void;
    get detectOriginUnresponsiveInput(): boolean | cdktf.IResolvable | undefined;
    private _detectOriginUnresponsiveTitle?;
    get detectOriginUnresponsiveTitle(): string;
    set detectOriginUnresponsiveTitle(value: string);
    resetDetectOriginUnresponsiveTitle(): void;
    get detectOriginUnresponsiveTitleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableAlternateHost?;
    get objectUnavailableAlternateHost(): string;
    set objectUnavailableAlternateHost(value: string);
    resetObjectUnavailableAlternateHost(): void;
    get objectUnavailableAlternateHostInput(): string | undefined;
    private _objectUnavailableBackupHost?;
    get objectUnavailableBackupHost(): string;
    set objectUnavailableBackupHost(value: string);
    resetObjectUnavailableBackupHost(): void;
    get objectUnavailableBackupHostInput(): string | undefined;
    private _objectUnavailableBlacklistOriginIp?;
    get objectUnavailableBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set objectUnavailableBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableBlacklistOriginIp(): void;
    get objectUnavailableBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableBlacklistWindow?;
    get objectUnavailableBlacklistWindow(): string;
    set objectUnavailableBlacklistWindow(value: string);
    resetObjectUnavailableBlacklistWindow(): void;
    get objectUnavailableBlacklistWindowInput(): string | undefined;
    private _objectUnavailableChangeProtocol?;
    get objectUnavailableChangeProtocol(): boolean | cdktf.IResolvable;
    set objectUnavailableChangeProtocol(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableChangeProtocol(): void;
    get objectUnavailableChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableDetectionLevel?;
    get objectUnavailableDetectionLevel(): string;
    set objectUnavailableDetectionLevel(value: string);
    resetObjectUnavailableDetectionLevel(): void;
    get objectUnavailableDetectionLevelInput(): string | undefined;
    private _objectUnavailableIncludeQueryString?;
    get objectUnavailableIncludeQueryString(): boolean | cdktf.IResolvable;
    set objectUnavailableIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableIncludeQueryString(): void;
    get objectUnavailableIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableModifiedPath?;
    get objectUnavailableModifiedPath(): string;
    set objectUnavailableModifiedPath(value: string);
    resetObjectUnavailableModifiedPath(): void;
    get objectUnavailableModifiedPathInput(): string | undefined;
    private _objectUnavailableModifyRequestPath?;
    get objectUnavailableModifyRequestPath(): boolean | cdktf.IResolvable;
    set objectUnavailableModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableModifyRequestPath(): void;
    get objectUnavailableModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableProtocol?;
    get objectUnavailableProtocol(): string;
    set objectUnavailableProtocol(value: string);
    resetObjectUnavailableProtocol(): void;
    get objectUnavailableProtocolInput(): string | undefined;
    private _objectUnavailableRecovery?;
    get objectUnavailableRecovery(): string;
    set objectUnavailableRecovery(value: string);
    resetObjectUnavailableRecovery(): void;
    get objectUnavailableRecoveryInput(): string | undefined;
    private _objectUnavailableRedirectMethod?;
    get objectUnavailableRedirectMethod(): number;
    set objectUnavailableRedirectMethod(value: number);
    resetObjectUnavailableRedirectMethod(): void;
    get objectUnavailableRedirectMethodInput(): number | undefined;
    private _objectUnavailableResponseCodes?;
    get objectUnavailableResponseCodes(): string[];
    set objectUnavailableResponseCodes(value: string[]);
    resetObjectUnavailableResponseCodes(): void;
    get objectUnavailableResponseCodesInput(): string[] | undefined;
    private _objectUnavailableRetryLimit?;
    get objectUnavailableRetryLimit(): string;
    set objectUnavailableRetryLimit(value: string);
    resetObjectUnavailableRetryLimit(): void;
    get objectUnavailableRetryLimitInput(): string | undefined;
    private _originUnavailableAlternateHost?;
    get originUnavailableAlternateHost(): string;
    set originUnavailableAlternateHost(value: string);
    resetOriginUnavailableAlternateHost(): void;
    get originUnavailableAlternateHostInput(): string | undefined;
    private _originUnavailableBackupHost?;
    get originUnavailableBackupHost(): string;
    set originUnavailableBackupHost(value: string);
    resetOriginUnavailableBackupHost(): void;
    get originUnavailableBackupHostInput(): string | undefined;
    private _originUnavailableBlacklistOriginIp?;
    get originUnavailableBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set originUnavailableBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableBlacklistOriginIp(): void;
    get originUnavailableBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableBlacklistWindow?;
    get originUnavailableBlacklistWindow(): string;
    set originUnavailableBlacklistWindow(value: string);
    resetOriginUnavailableBlacklistWindow(): void;
    get originUnavailableBlacklistWindowInput(): string | undefined;
    private _originUnavailableChangeProtocol?;
    get originUnavailableChangeProtocol(): boolean | cdktf.IResolvable;
    set originUnavailableChangeProtocol(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableChangeProtocol(): void;
    get originUnavailableChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableDetectionLevel?;
    get originUnavailableDetectionLevel(): string;
    set originUnavailableDetectionLevel(value: string);
    resetOriginUnavailableDetectionLevel(): void;
    get originUnavailableDetectionLevelInput(): string | undefined;
    private _originUnavailableIncludeQueryString?;
    get originUnavailableIncludeQueryString(): boolean | cdktf.IResolvable;
    set originUnavailableIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableIncludeQueryString(): void;
    get originUnavailableIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableModifiedPath?;
    get originUnavailableModifiedPath(): string;
    set originUnavailableModifiedPath(value: string);
    resetOriginUnavailableModifiedPath(): void;
    get originUnavailableModifiedPathInput(): string | undefined;
    private _originUnavailableModifyRequestPath?;
    get originUnavailableModifyRequestPath(): boolean | cdktf.IResolvable;
    set originUnavailableModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableModifyRequestPath(): void;
    get originUnavailableModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableProtocol?;
    get originUnavailableProtocol(): string;
    set originUnavailableProtocol(value: string);
    resetOriginUnavailableProtocol(): void;
    get originUnavailableProtocolInput(): string | undefined;
    private _originUnavailableRecovery?;
    get originUnavailableRecovery(): string;
    set originUnavailableRecovery(value: string);
    resetOriginUnavailableRecovery(): void;
    get originUnavailableRecoveryInput(): string | undefined;
    private _originUnavailableRedirectMethod?;
    get originUnavailableRedirectMethod(): number;
    set originUnavailableRedirectMethod(value: number);
    resetOriginUnavailableRedirectMethod(): void;
    get originUnavailableRedirectMethodInput(): number | undefined;
    private _originUnavailableResponseCodes?;
    get originUnavailableResponseCodes(): string[];
    set originUnavailableResponseCodes(value: string[]);
    resetOriginUnavailableResponseCodes(): void;
    get originUnavailableResponseCodesInput(): string[] | undefined;
    private _originUnavailableRetryLimit?;
    get originUnavailableRetryLimit(): string;
    set originUnavailableRetryLimit(value: string);
    resetOriginUnavailableRetryLimit(): void;
    get originUnavailableRetryLimitInput(): string | undefined;
    private _originUnresponsiveAlternateHost?;
    get originUnresponsiveAlternateHost(): string;
    set originUnresponsiveAlternateHost(value: string);
    resetOriginUnresponsiveAlternateHost(): void;
    get originUnresponsiveAlternateHostInput(): string | undefined;
    private _originUnresponsiveBackupHost?;
    get originUnresponsiveBackupHost(): string;
    set originUnresponsiveBackupHost(value: string);
    resetOriginUnresponsiveBackupHost(): void;
    get originUnresponsiveBackupHostInput(): string | undefined;
    private _originUnresponsiveBlacklistOriginIp?;
    get originUnresponsiveBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set originUnresponsiveBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveBlacklistOriginIp(): void;
    get originUnresponsiveBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveBlacklistWindow?;
    get originUnresponsiveBlacklistWindow(): string;
    set originUnresponsiveBlacklistWindow(value: string);
    resetOriginUnresponsiveBlacklistWindow(): void;
    get originUnresponsiveBlacklistWindowInput(): string | undefined;
    private _originUnresponsiveChangeProtocol?;
    get originUnresponsiveChangeProtocol(): boolean | cdktf.IResolvable;
    set originUnresponsiveChangeProtocol(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveChangeProtocol(): void;
    get originUnresponsiveChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveDetectionLevel?;
    get originUnresponsiveDetectionLevel(): string;
    set originUnresponsiveDetectionLevel(value: string);
    resetOriginUnresponsiveDetectionLevel(): void;
    get originUnresponsiveDetectionLevelInput(): string | undefined;
    private _originUnresponsiveIncludeQueryString?;
    get originUnresponsiveIncludeQueryString(): boolean | cdktf.IResolvable;
    set originUnresponsiveIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveIncludeQueryString(): void;
    get originUnresponsiveIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveModifiedPath?;
    get originUnresponsiveModifiedPath(): string;
    set originUnresponsiveModifiedPath(value: string);
    resetOriginUnresponsiveModifiedPath(): void;
    get originUnresponsiveModifiedPathInput(): string | undefined;
    private _originUnresponsiveModifyRequestPath?;
    get originUnresponsiveModifyRequestPath(): boolean | cdktf.IResolvable;
    set originUnresponsiveModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveModifyRequestPath(): void;
    get originUnresponsiveModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveProtocol?;
    get originUnresponsiveProtocol(): string;
    set originUnresponsiveProtocol(value: string);
    resetOriginUnresponsiveProtocol(): void;
    get originUnresponsiveProtocolInput(): string | undefined;
    private _originUnresponsiveRecovery?;
    get originUnresponsiveRecovery(): string;
    set originUnresponsiveRecovery(value: string);
    resetOriginUnresponsiveRecovery(): void;
    get originUnresponsiveRecoveryInput(): string | undefined;
    private _originUnresponsiveRedirectMethod?;
    get originUnresponsiveRedirectMethod(): number;
    set originUnresponsiveRedirectMethod(value: number);
    resetOriginUnresponsiveRedirectMethod(): void;
    get originUnresponsiveRedirectMethodInput(): number | undefined;
    private _originUnresponsiveRetryLimit?;
    get originUnresponsiveRetryLimit(): string;
    set originUnresponsiveRetryLimit(value: string);
    resetOriginUnresponsiveRetryLimit(): void;
    get originUnresponsiveRetryLimitInput(): string | undefined;
    private _otherOptions?;
    get otherOptions(): string;
    set otherOptions(value: string);
    resetOtherOptions(): void;
    get otherOptionsInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching {
    /**
    * Enables metadata caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance {
    /**
    * Enables the Mobile App Performance SDK.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, sends secondary multi-path requests to the origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
    */
    readonly secondaryMultipathToOrigin?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _secondaryMultipathToOrigin?;
    get secondaryMultipathToOrigin(): boolean | cdktf.IResolvable;
    set secondaryMultipathToOrigin(value: boolean | cdktf.IResolvable);
    resetSecondaryMultipathToOrigin(): void;
    get secondaryMultipathToOriginInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader {
    /**
    * Either `ADD`, `DELETE`, `MODIFY`, or `PASS` incoming HTTP request headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
    */
    readonly action?: string;
    /**
    * When enabled with the `action` set to `MODIFY`, prevents creation of more than one instance of a header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
    */
    readonly avoidDuplicateHeaders?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom field name that applies when the relevant `standard` header name is set to `OTHER`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
    */
    readonly customHeaderName?: string;
    /**
    * Specifies the new header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
    */
    readonly headerValue?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Supplies an HTTP header replacement value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
    */
    readonly newHeaderValue?: string;
    /**
    * If the value of `action` is `ADD`, this specifies the name of the field to add.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
    */
    readonly standardAddHeaderName?: string;
    /**
    * If the value of `action` is `DELETE`, this specifies the name of the field to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
    */
    readonly standardDeleteHeaderName?: string;
    /**
    * If the value of `action` is `MODIFY`, this specifies the name of the field to modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
    */
    readonly standardModifyHeaderName?: string;
    /**
    * If the value of `action` is `PASS`, this specifies the name of the field to pass through.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
    */
    readonly standardPassHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _avoidDuplicateHeaders?;
    get avoidDuplicateHeaders(): boolean | cdktf.IResolvable;
    set avoidDuplicateHeaders(value: boolean | cdktf.IResolvable);
    resetAvoidDuplicateHeaders(): void;
    get avoidDuplicateHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _customHeaderName?;
    get customHeaderName(): string;
    set customHeaderName(value: string);
    resetCustomHeaderName(): void;
    get customHeaderNameInput(): string | undefined;
    private _headerValue?;
    get headerValue(): string;
    set headerValue(value: string);
    resetHeaderValue(): void;
    get headerValueInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _newHeaderValue?;
    get newHeaderValue(): string;
    set newHeaderValue(value: string);
    resetNewHeaderValue(): void;
    get newHeaderValueInput(): string | undefined;
    private _standardAddHeaderName?;
    get standardAddHeaderName(): string;
    set standardAddHeaderName(value: string);
    resetStandardAddHeaderName(): void;
    get standardAddHeaderNameInput(): string | undefined;
    private _standardDeleteHeaderName?;
    get standardDeleteHeaderName(): string;
    set standardDeleteHeaderName(value: string);
    resetStandardDeleteHeaderName(): void;
    get standardDeleteHeaderNameInput(): string | undefined;
    private _standardModifyHeaderName?;
    get standardModifyHeaderName(): string;
    set standardModifyHeaderName(value: string);
    resetStandardModifyHeaderName(): void;
    get standardModifyHeaderNameInput(): string | undefined;
    private _standardPassHeaderName?;
    get standardPassHeaderName(): string;
    set standardPassHeaderName(value: string);
    resetStandardPassHeaderName(): void;
    get standardPassHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader {
    /**
    * Either `ADD`, `DELETE`, `MODIFY`, or `PASS` incoming HTTP response headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
    */
    readonly action?: string;
    /**
    * When enabled with the `action` set to `MODIFY`, prevents creation of more than one instance of a header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
    */
    readonly avoidDuplicateHeaders?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom field name that applies when the relevant `standard` header name is set to `OTHER`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
    */
    readonly customHeaderName?: string;
    /**
    * Specifies the header's new value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
    */
    readonly headerValue?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies an HTTP header replacement value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
    */
    readonly newHeaderValue?: string;
    /**
    * If the value of `action` is `ADD`, this specifies the name of the field to add.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
    */
    readonly standardAddHeaderName?: string;
    /**
    * If the value of `action` is `DELETE`, this specifies the name of the field to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
    */
    readonly standardDeleteHeaderName?: string;
    /**
    * If the value of `action` is `MODIFY`, this specifies the name of the field to modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
    */
    readonly standardModifyHeaderName?: string;
    /**
    * If the value of `action` is `PASS`, this specifies the name of the field to pass through.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
    */
    readonly standardPassHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _avoidDuplicateHeaders?;
    get avoidDuplicateHeaders(): boolean | cdktf.IResolvable;
    set avoidDuplicateHeaders(value: boolean | cdktf.IResolvable);
    resetAvoidDuplicateHeaders(): void;
    get avoidDuplicateHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _customHeaderName?;
    get customHeaderName(): string;
    set customHeaderName(value: string);
    resetCustomHeaderName(): void;
    get customHeaderNameInput(): string | undefined;
    private _headerValue?;
    get headerValue(): string;
    set headerValue(value: string);
    resetHeaderValue(): void;
    get headerValueInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _newHeaderValue?;
    get newHeaderValue(): string;
    set newHeaderValue(value: string);
    resetNewHeaderValue(): void;
    get newHeaderValueInput(): string | undefined;
    private _standardAddHeaderName?;
    get standardAddHeaderName(): string;
    set standardAddHeaderName(value: string);
    resetStandardAddHeaderName(): void;
    get standardAddHeaderNameInput(): string | undefined;
    private _standardDeleteHeaderName?;
    get standardDeleteHeaderName(): string;
    set standardDeleteHeaderName(value: string);
    resetStandardDeleteHeaderName(): void;
    get standardDeleteHeaderNameInput(): string | undefined;
    private _standardModifyHeaderName?;
    get standardModifyHeaderName(): string;
    set standardModifyHeaderName(value: string);
    resetStandardModifyHeaderName(): void;
    get standardModifyHeaderNameInput(): string | undefined;
    private _standardPassHeaderName?;
    get standardPassHeaderName(): string;
    set standardPassHeaderName(value: string);
    resetStandardPassHeaderName(): void;
    get standardPassHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader {
    /**
    * Either `ADD` or `DELETE` outgoing HTTP request headers, `MODIFY` their fixed values, or specify a `REGEX` pattern to transform them.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
    */
    readonly action?: string;
    /**
    * When enabled with the `action` set to `MODIFY`, prevents creation of more than one instance of a header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
    */
    readonly avoidDuplicateHeaders?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom field name that applies when the relevant `standard` header name is set to `OTHER`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
    */
    readonly customHeaderName?: string;
    /**
    * Specifies the new header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
    */
    readonly headerValue?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled with the `action` set to `REGEX`, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
    */
    readonly matchMultiple?: boolean | cdktf.IResolvable;
    /**
    * Specifies an HTTP header replacement value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
    */
    readonly newHeaderValue?: string;
    /**
    * Specifies a Perl-compatible regular expression to match within the header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
    */
    readonly regexHeaderMatch?: string;
    /**
    * Specifies text that replaces the `regexHeaderMatch` pattern within the header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
    */
    readonly regexHeaderReplace?: string;
    /**
    * If the value of `action` is `ADD`, this specifies the name of the field to add.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
    */
    readonly standardAddHeaderName?: string;
    /**
    * If the value of `action` is `DELETE`, this specifies the name of the field to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
    */
    readonly standardDeleteHeaderName?: string;
    /**
    * If the value of `action` is `MODIFY` or `REGEX`, this specifies the name of the field to modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
    */
    readonly standardModifyHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _avoidDuplicateHeaders?;
    get avoidDuplicateHeaders(): boolean | cdktf.IResolvable;
    set avoidDuplicateHeaders(value: boolean | cdktf.IResolvable);
    resetAvoidDuplicateHeaders(): void;
    get avoidDuplicateHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _customHeaderName?;
    get customHeaderName(): string;
    set customHeaderName(value: string);
    resetCustomHeaderName(): void;
    get customHeaderNameInput(): string | undefined;
    private _headerValue?;
    get headerValue(): string;
    set headerValue(value: string);
    resetHeaderValue(): void;
    get headerValueInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _matchMultiple?;
    get matchMultiple(): boolean | cdktf.IResolvable;
    set matchMultiple(value: boolean | cdktf.IResolvable);
    resetMatchMultiple(): void;
    get matchMultipleInput(): boolean | cdktf.IResolvable | undefined;
    private _newHeaderValue?;
    get newHeaderValue(): string;
    set newHeaderValue(value: string);
    resetNewHeaderValue(): void;
    get newHeaderValueInput(): string | undefined;
    private _regexHeaderMatch?;
    get regexHeaderMatch(): string;
    set regexHeaderMatch(value: string);
    resetRegexHeaderMatch(): void;
    get regexHeaderMatchInput(): string | undefined;
    private _regexHeaderReplace?;
    get regexHeaderReplace(): string;
    set regexHeaderReplace(value: string);
    resetRegexHeaderReplace(): void;
    get regexHeaderReplaceInput(): string | undefined;
    private _standardAddHeaderName?;
    get standardAddHeaderName(): string;
    set standardAddHeaderName(value: string);
    resetStandardAddHeaderName(): void;
    get standardAddHeaderNameInput(): string | undefined;
    private _standardDeleteHeaderName?;
    get standardDeleteHeaderName(): string;
    set standardDeleteHeaderName(value: string);
    resetStandardDeleteHeaderName(): void;
    get standardDeleteHeaderNameInput(): string | undefined;
    private _standardModifyHeaderName?;
    get standardModifyHeaderName(): string;
    set standardModifyHeaderName(value: string);
    resetStandardModifyHeaderName(): void;
    get standardModifyHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader {
    /**
    * Either `ADD` or `DELETE` outgoing HTTP response headers, `MODIFY` their fixed values, or specify a `REGEX` pattern to transform them.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
    */
    readonly action?: string;
    /**
    * When enabled with the `action` set to `MODIFY`, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
    */
    readonly avoidDuplicateHeaders?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom field name that applies when the relevant `standard` header name is set to `OTHER`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
    */
    readonly customHeaderName?: string;
    /**
    * Specifies the existing value of the header to match.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
    */
    readonly headerValue?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled with the `action` set to `REGEX`, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
    */
    readonly matchMultiple?: boolean | cdktf.IResolvable;
    /**
    * Specifies the new HTTP header replacement value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
    */
    readonly newHeaderValue?: string;
    /**
    * Specifies a Perl-compatible regular expression to match within the header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
    */
    readonly regexHeaderMatch?: string;
    /**
    * Specifies text that replaces the `regexHeaderMatch` pattern within the header value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
    */
    readonly regexHeaderReplace?: string;
    /**
    * If the value of `action` is `ADD`, this specifies the name of the field to add.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
    */
    readonly standardAddHeaderName?: string;
    /**
    * If the value of `action` is `DELETE`, this specifies the name of the field to remove.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
    */
    readonly standardDeleteHeaderName?: string;
    /**
    * If the value of `action` is `MODIFY` or `REGEX`, this specifies the name of the field to modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
    */
    readonly standardModifyHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _avoidDuplicateHeaders?;
    get avoidDuplicateHeaders(): boolean | cdktf.IResolvable;
    set avoidDuplicateHeaders(value: boolean | cdktf.IResolvable);
    resetAvoidDuplicateHeaders(): void;
    get avoidDuplicateHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _customHeaderName?;
    get customHeaderName(): string;
    set customHeaderName(value: string);
    resetCustomHeaderName(): void;
    get customHeaderNameInput(): string | undefined;
    private _headerValue?;
    get headerValue(): string;
    set headerValue(value: string);
    resetHeaderValue(): void;
    get headerValueInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _matchMultiple?;
    get matchMultiple(): boolean | cdktf.IResolvable;
    set matchMultiple(value: boolean | cdktf.IResolvable);
    resetMatchMultiple(): void;
    get matchMultipleInput(): boolean | cdktf.IResolvable | undefined;
    private _newHeaderValue?;
    get newHeaderValue(): string;
    set newHeaderValue(value: string);
    resetNewHeaderValue(): void;
    get newHeaderValueInput(): string | undefined;
    private _regexHeaderMatch?;
    get regexHeaderMatch(): string;
    set regexHeaderMatch(value: string);
    resetRegexHeaderMatch(): void;
    get regexHeaderMatchInput(): string | undefined;
    private _regexHeaderReplace?;
    get regexHeaderReplace(): string;
    set regexHeaderReplace(value: string);
    resetRegexHeaderReplace(): void;
    get regexHeaderReplaceInput(): string | undefined;
    private _standardAddHeaderName?;
    get standardAddHeaderName(): string;
    set standardAddHeaderName(value: string);
    resetStandardAddHeaderName(): void;
    get standardAddHeaderNameInput(): string | undefined;
    private _standardDeleteHeaderName?;
    get standardDeleteHeaderName(): string;
    set standardDeleteHeaderName(value: string);
    resetStandardDeleteHeaderName(): void;
    get standardDeleteHeaderNameInput(): string | undefined;
    private _standardModifyHeaderName?;
    get standardModifyHeaderName(): string;
    set standardModifyHeaderName(value: string);
    resetStandardModifyHeaderName(): void;
    get standardModifyHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader {
    /**
    * Enables `Via` header modifications.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify how you want to handle the header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
    */
    readonly modificationOption?: string;
    /**
    * Specifies a new name to replace the existing `Via` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
    */
    readonly renameHeaderTo?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _modificationOption?;
    get modificationOption(): string;
    set modificationOption(value: string);
    resetModificationOption(): void;
    get modificationOptionInput(): string | undefined;
    private _renameHeaderTo?;
    get renameHeaderTo(): string;
    set renameHeaderTo(value: string);
    resetRenameHeaderTo(): void;
    get renameHeaderToInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}
    */
    readonly c?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}
    */
    readonly cn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}
    */
    readonly o?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}
    */
    readonly ou?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns | undefined);
    private _c?;
    get c(): string;
    set c(value: string);
    resetC(): void;
    get cInput(): string | undefined;
    private _cn?;
    get cn(): string;
    set cn(value: string);
    resetCn(): void;
    get cnInput(): string | undefined;
    private _o?;
    get o(): string;
    set o(value: string);
    resetO(): void;
    get oInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}
    */
    readonly c?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}
    */
    readonly cn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}
    */
    readonly o?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}
    */
    readonly ou?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns | undefined);
    private _c?;
    get c(): string;
    set c(value: string);
    resetC(): void;
    get cInput(): string | undefined;
    private _cn?;
    get cn(): string;
    set cn(value: string);
    resetCn(): void;
    get cnInput(): string | undefined;
    private _o?;
    get o(): string;
    set o(value: string);
    resetO(): void;
    get oInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}
    */
    readonly canBeCa?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}
    */
    readonly canBeLeaf?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}
    */
    readonly notAfter?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}
    */
    readonly notBefore?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}
    */
    readonly pemEncodedCert?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}
    */
    readonly publicKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}
    */
    readonly publicKeyAlgorithm?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}
    */
    readonly publicKeyFormat?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}
    */
    readonly selfSigned?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}
    */
    readonly serialNumber?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}
    */
    readonly sha1Fingerprint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}
    */
    readonly sigAlgName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}
    */
    readonly subjectAlternativeNames?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}
    */
    readonly subjectCn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}
    */
    readonly version?: number;
    /**
    * issuer_rdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
    */
    readonly issuerRdns?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns;
    /**
    * subject_rdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
    */
    readonly subjectRdns?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities | cdktf.IResolvable | undefined);
    private _canBeCa?;
    get canBeCa(): boolean | cdktf.IResolvable;
    set canBeCa(value: boolean | cdktf.IResolvable);
    resetCanBeCa(): void;
    get canBeCaInput(): boolean | cdktf.IResolvable | undefined;
    private _canBeLeaf?;
    get canBeLeaf(): boolean | cdktf.IResolvable;
    set canBeLeaf(value: boolean | cdktf.IResolvable);
    resetCanBeLeaf(): void;
    get canBeLeafInput(): boolean | cdktf.IResolvable | undefined;
    private _notAfter?;
    get notAfter(): number;
    set notAfter(value: number);
    resetNotAfter(): void;
    get notAfterInput(): number | undefined;
    private _notBefore?;
    get notBefore(): number;
    set notBefore(value: number);
    resetNotBefore(): void;
    get notBeforeInput(): number | undefined;
    private _pemEncodedCert?;
    get pemEncodedCert(): string;
    set pemEncodedCert(value: string);
    resetPemEncodedCert(): void;
    get pemEncodedCertInput(): string | undefined;
    private _publicKey?;
    get publicKey(): string;
    set publicKey(value: string);
    resetPublicKey(): void;
    get publicKeyInput(): string | undefined;
    private _publicKeyAlgorithm?;
    get publicKeyAlgorithm(): string;
    set publicKeyAlgorithm(value: string);
    resetPublicKeyAlgorithm(): void;
    get publicKeyAlgorithmInput(): string | undefined;
    private _publicKeyFormat?;
    get publicKeyFormat(): string;
    set publicKeyFormat(value: string);
    resetPublicKeyFormat(): void;
    get publicKeyFormatInput(): string | undefined;
    private _selfSigned?;
    get selfSigned(): boolean | cdktf.IResolvable;
    set selfSigned(value: boolean | cdktf.IResolvable);
    resetSelfSigned(): void;
    get selfSignedInput(): boolean | cdktf.IResolvable | undefined;
    private _serialNumber?;
    get serialNumber(): string;
    set serialNumber(value: string);
    resetSerialNumber(): void;
    get serialNumberInput(): string | undefined;
    private _sha1Fingerprint?;
    get sha1Fingerprint(): string;
    set sha1Fingerprint(value: string);
    resetSha1Fingerprint(): void;
    get sha1FingerprintInput(): string | undefined;
    private _sigAlgName?;
    get sigAlgName(): string;
    set sigAlgName(value: string);
    resetSigAlgName(): void;
    get sigAlgNameInput(): string | undefined;
    private _subjectAlternativeNames?;
    get subjectAlternativeNames(): string[];
    set subjectAlternativeNames(value: string[]);
    resetSubjectAlternativeNames(): void;
    get subjectAlternativeNamesInput(): string[] | undefined;
    private _subjectCn?;
    get subjectCn(): string;
    set subjectCn(value: string);
    resetSubjectCn(): void;
    get subjectCnInput(): string | undefined;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    private _issuerRdns;
    get issuerRdns(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference;
    putIssuerRdns(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns): void;
    resetIssuerRdns(): void;
    get issuerRdnsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns | undefined;
    private _subjectRdns;
    get subjectRdns(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference;
    putSubjectRdns(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns): void;
    resetSubjectRdns(): void;
    get subjectRdnsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}
    */
    readonly c?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}
    */
    readonly cn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}
    */
    readonly o?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}
    */
    readonly ou?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns | undefined);
    private _c?;
    get c(): string;
    set c(value: string);
    resetC(): void;
    get cInput(): string | undefined;
    private _cn?;
    get cn(): string;
    set cn(value: string);
    resetCn(): void;
    get cnInput(): string | undefined;
    private _o?;
    get o(): string;
    set o(value: string);
    resetO(): void;
    get oInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}
    */
    readonly c?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}
    */
    readonly cn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}
    */
    readonly o?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}
    */
    readonly ou?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns | undefined);
    private _c?;
    get c(): string;
    set c(value: string);
    resetC(): void;
    get cInput(): string | undefined;
    private _cn?;
    get cn(): string;
    set cn(value: string);
    resetCn(): void;
    get cnInput(): string | undefined;
    private _o?;
    get o(): string;
    set o(value: string);
    resetO(): void;
    get oInput(): string | undefined;
    private _ou?;
    get ou(): string;
    set ou(value: string);
    resetOu(): void;
    get ouInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}
    */
    readonly canBeCa?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}
    */
    readonly canBeLeaf?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}
    */
    readonly notAfter?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}
    */
    readonly notBefore?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}
    */
    readonly pemEncodedCert?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}
    */
    readonly publicKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}
    */
    readonly publicKeyAlgorithm?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}
    */
    readonly publicKeyFormat?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}
    */
    readonly selfSigned?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}
    */
    readonly serialNumber?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}
    */
    readonly sha1Fingerprint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}
    */
    readonly sigAlgName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}
    */
    readonly subjectAlternativeNames?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}
    */
    readonly subjectCn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}
    */
    readonly version?: number;
    /**
    * issuer_rdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
    */
    readonly issuerRdns?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns;
    /**
    * subject_rdns block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
    */
    readonly subjectRdns?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates | cdktf.IResolvable | undefined);
    private _canBeCa?;
    get canBeCa(): boolean | cdktf.IResolvable;
    set canBeCa(value: boolean | cdktf.IResolvable);
    resetCanBeCa(): void;
    get canBeCaInput(): boolean | cdktf.IResolvable | undefined;
    private _canBeLeaf?;
    get canBeLeaf(): boolean | cdktf.IResolvable;
    set canBeLeaf(value: boolean | cdktf.IResolvable);
    resetCanBeLeaf(): void;
    get canBeLeafInput(): boolean | cdktf.IResolvable | undefined;
    private _notAfter?;
    get notAfter(): number;
    set notAfter(value: number);
    resetNotAfter(): void;
    get notAfterInput(): number | undefined;
    private _notBefore?;
    get notBefore(): number;
    set notBefore(value: number);
    resetNotBefore(): void;
    get notBeforeInput(): number | undefined;
    private _pemEncodedCert?;
    get pemEncodedCert(): string;
    set pemEncodedCert(value: string);
    resetPemEncodedCert(): void;
    get pemEncodedCertInput(): string | undefined;
    private _publicKey?;
    get publicKey(): string;
    set publicKey(value: string);
    resetPublicKey(): void;
    get publicKeyInput(): string | undefined;
    private _publicKeyAlgorithm?;
    get publicKeyAlgorithm(): string;
    set publicKeyAlgorithm(value: string);
    resetPublicKeyAlgorithm(): void;
    get publicKeyAlgorithmInput(): string | undefined;
    private _publicKeyFormat?;
    get publicKeyFormat(): string;
    set publicKeyFormat(value: string);
    resetPublicKeyFormat(): void;
    get publicKeyFormatInput(): string | undefined;
    private _selfSigned?;
    get selfSigned(): boolean | cdktf.IResolvable;
    set selfSigned(value: boolean | cdktf.IResolvable);
    resetSelfSigned(): void;
    get selfSignedInput(): boolean | cdktf.IResolvable | undefined;
    private _serialNumber?;
    get serialNumber(): string;
    set serialNumber(value: string);
    resetSerialNumber(): void;
    get serialNumberInput(): string | undefined;
    private _sha1Fingerprint?;
    get sha1Fingerprint(): string;
    set sha1Fingerprint(value: string);
    resetSha1Fingerprint(): void;
    get sha1FingerprintInput(): string | undefined;
    private _sigAlgName?;
    get sigAlgName(): string;
    set sigAlgName(value: string);
    resetSigAlgName(): void;
    get sigAlgNameInput(): string | undefined;
    private _subjectAlternativeNames?;
    get subjectAlternativeNames(): string[];
    set subjectAlternativeNames(value: string[]);
    resetSubjectAlternativeNames(): void;
    get subjectAlternativeNamesInput(): string[] | undefined;
    private _subjectCn?;
    get subjectCn(): string;
    set subjectCn(value: string);
    resetSubjectCn(): void;
    get subjectCnInput(): string | undefined;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    private _issuerRdns;
    get issuerRdns(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference;
    putIssuerRdns(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns): void;
    resetIssuerRdns(): void;
    get issuerRdnsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns | undefined;
    private _subjectRdns;
    get subjectRdns(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference;
    putSubjectRdns(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns): void;
    resetSubjectRdns(): void;
    get subjectRdnsInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}
    */
    readonly downloadDomainName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}
    */
    readonly g2OToken?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage | undefined);
    private _cpCode?;
    get cpCode(): number;
    set cpCode(value: number);
    resetCpCode(): void;
    get cpCodeInput(): number | undefined;
    private _downloadDomainName?;
    get downloadDomainName(): string;
    set downloadDomainName(value: string);
    resetDownloadDomainName(): void;
    get downloadDomainNameInput(): string | undefined;
    private _g2OToken?;
    get g2OToken(): string;
    set g2OToken(value: string);
    resetG2OToken(): void;
    get g2OTokenInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin {
    /**
    * Specifies the hostname to use when forming a cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
    */
    readonly cacheKeyHostname?: string;
    /**
    * Enables `gzip` compression for non-NetStorage origins.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
    */
    readonly compress?: boolean | cdktf.IResolvable;
    /**
    * This specifies the name of the custom host header the edge server should pass to the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
    */
    readonly customForwardHostHeader?: string;
    /**
    * Specifies values to look for in the origin certificate's `Subject Alternate Name` or `Common Name` fields. Specify `{{Origin Hostname}}` and `{{Forward Host Header}}` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line `variables`, which use the same curly-brace syntax.)
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
    */
    readonly customValidCnValues?: string[];
    /**
    * When enabled on non-NetStorage origins, allows you to send a custom header (the `trueClientIpHeader`) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard `X-Forward-For` header, which proxies may modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
    */
    readonly enableTrueClientIp?: boolean | cdktf.IResolvable;
    /**
    * When the `originType` is set to either `CUSTOMER` or `SAAS_DYNAMIC_ORIGIN`, this specifies which `Host` header to pass to the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
    */
    readonly forwardHostHeader?: string;
    /**
    * Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily `80`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
    */
    readonly httpPort?: number;
    /**
    * Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily `443`. This option only applies if the property is marked as secure. See `Secure property requirements` for guidance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
    */
    readonly httpsPort?: number;
    /**
    * Specifies which IP version to use when getting content from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
    */
    readonly ipVersion?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum TLS version to use for connections to your origin server. As best practice, use `DYNAMIC` to automatically apply the latest supported version.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
    */
    readonly maxTlsVersion?: string;
    /**
    * Specifies the minimum TLS version to use for connections to your origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
    */
    readonly minTlsVersion?: string;
    /**
    * This specifies the media's origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
    */
    readonly mslorigin?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
    */
    readonly originCertificate?: string;
    /**
    * Specifies which certificate to trust.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
    */
    readonly originCertsToHonor?: string;
    /**
    * Identifies the Edge Load Balancing origin. This needs to correspond to an `edgeLoadBalancingOrigin` behavior's `id` attribute within the same property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
    */
    readonly originId?: string;
    /**
    * For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the `verification settings in the Origin Server behavior` or contact your Akamai representative for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
    */
    readonly originSni?: boolean | cdktf.IResolvable;
    /**
    * Choose where your content is retrieved from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
    */
    readonly originType?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
    */
    readonly ports?: string;
    /**
    * Enabling this allows you to use a `CNAME chain` to determine the hostname for this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
    */
    readonly saasCnameEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the desired number of hostnames to use in the `CNAME chain`, starting backwards from the edge server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
    */
    readonly saasCnameLevel?: number;
    /**
    * Specifies the name of the cookie that identifies this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
    */
    readonly saasCookie?: string;
    /**
    * Specifies the name of the query parameter that identifies this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
    */
    readonly saasQueryString?: string;
    /**
    * Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
    */
    readonly saasRegex?: string;
    /**
    * Specifies replacement text for what `saasRegex` matches.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
    */
    readonly saasReplace?: string;
    /**
    * Specifies the static part of the SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
    */
    readonly saasSuffix?: string;
    /**
    * Specifies the part of the request that identifies this SaaS dynamic origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
    */
    readonly saasType?: string;
    /**
    * Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
    */
    readonly secondHostname?: string;
    /**
    * Available only for certain products. This specifies whether you want to use an additional origin server address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
    */
    readonly secondHostnameEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}
    */
    readonly standardCertificateAuthorities?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Enables transport layer security (TLS) version 1.3 for connections to your origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
    */
    readonly tls13Support?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
    */
    readonly tlsVersionTitle?: string;
    /**
    * If a client sets the `True-Client-IP` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
    */
    readonly trueClientIpClientSetting?: boolean | cdktf.IResolvable;
    /**
    * This specifies the name of the field that identifies the end client's IP address, for example `True-Client-IP`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
    */
    readonly trueClientIpHeader?: string;
    /**
    * With a shared `hostname` such as provided by Amazon AWS, sets a unique cache key for your content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
    */
    readonly useUniqueCacheKey?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
    */
    readonly verificationMode?: string;
    /**
    * custom_certificate_authorities block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
    */
    readonly customCertificateAuthorities?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities[] | cdktf.IResolvable;
    /**
    * custom_certificates block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
    */
    readonly customCertificates?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates[] | cdktf.IResolvable;
    /**
    * net_storage block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
    */
    readonly netStorage?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin | undefined);
    private _cacheKeyHostname?;
    get cacheKeyHostname(): string;
    set cacheKeyHostname(value: string);
    resetCacheKeyHostname(): void;
    get cacheKeyHostnameInput(): string | undefined;
    private _compress?;
    get compress(): boolean | cdktf.IResolvable;
    set compress(value: boolean | cdktf.IResolvable);
    resetCompress(): void;
    get compressInput(): boolean | cdktf.IResolvable | undefined;
    private _customForwardHostHeader?;
    get customForwardHostHeader(): string;
    set customForwardHostHeader(value: string);
    resetCustomForwardHostHeader(): void;
    get customForwardHostHeaderInput(): string | undefined;
    private _customValidCnValues?;
    get customValidCnValues(): string[];
    set customValidCnValues(value: string[]);
    resetCustomValidCnValues(): void;
    get customValidCnValuesInput(): string[] | undefined;
    private _enableTrueClientIp?;
    get enableTrueClientIp(): boolean | cdktf.IResolvable;
    set enableTrueClientIp(value: boolean | cdktf.IResolvable);
    resetEnableTrueClientIp(): void;
    get enableTrueClientIpInput(): boolean | cdktf.IResolvable | undefined;
    private _forwardHostHeader?;
    get forwardHostHeader(): string;
    set forwardHostHeader(value: string);
    resetForwardHostHeader(): void;
    get forwardHostHeaderInput(): string | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _httpPort?;
    get httpPort(): number;
    set httpPort(value: number);
    resetHttpPort(): void;
    get httpPortInput(): number | undefined;
    private _httpsPort?;
    get httpsPort(): number;
    set httpsPort(value: number);
    resetHttpsPort(): void;
    get httpsPortInput(): number | undefined;
    private _ipVersion?;
    get ipVersion(): string;
    set ipVersion(value: string);
    resetIpVersion(): void;
    get ipVersionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maxTlsVersion?;
    get maxTlsVersion(): string;
    set maxTlsVersion(value: string);
    resetMaxTlsVersion(): void;
    get maxTlsVersionInput(): string | undefined;
    private _minTlsVersion?;
    get minTlsVersion(): string;
    set minTlsVersion(value: string);
    resetMinTlsVersion(): void;
    get minTlsVersionInput(): string | undefined;
    private _mslorigin?;
    get mslorigin(): string;
    set mslorigin(value: string);
    resetMslorigin(): void;
    get msloriginInput(): string | undefined;
    private _originCertificate?;
    get originCertificate(): string;
    set originCertificate(value: string);
    resetOriginCertificate(): void;
    get originCertificateInput(): string | undefined;
    private _originCertsToHonor?;
    get originCertsToHonor(): string;
    set originCertsToHonor(value: string);
    resetOriginCertsToHonor(): void;
    get originCertsToHonorInput(): string | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _originSni?;
    get originSni(): boolean | cdktf.IResolvable;
    set originSni(value: boolean | cdktf.IResolvable);
    resetOriginSni(): void;
    get originSniInput(): boolean | cdktf.IResolvable | undefined;
    private _originType?;
    get originType(): string;
    set originType(value: string);
    resetOriginType(): void;
    get originTypeInput(): string | undefined;
    private _ports?;
    get ports(): string;
    set ports(value: string);
    resetPorts(): void;
    get portsInput(): string | undefined;
    private _saasCnameEnabled?;
    get saasCnameEnabled(): boolean | cdktf.IResolvable;
    set saasCnameEnabled(value: boolean | cdktf.IResolvable);
    resetSaasCnameEnabled(): void;
    get saasCnameEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _saasCnameLevel?;
    get saasCnameLevel(): number;
    set saasCnameLevel(value: number);
    resetSaasCnameLevel(): void;
    get saasCnameLevelInput(): number | undefined;
    private _saasCookie?;
    get saasCookie(): string;
    set saasCookie(value: string);
    resetSaasCookie(): void;
    get saasCookieInput(): string | undefined;
    private _saasQueryString?;
    get saasQueryString(): string;
    set saasQueryString(value: string);
    resetSaasQueryString(): void;
    get saasQueryStringInput(): string | undefined;
    private _saasRegex?;
    get saasRegex(): string;
    set saasRegex(value: string);
    resetSaasRegex(): void;
    get saasRegexInput(): string | undefined;
    private _saasReplace?;
    get saasReplace(): string;
    set saasReplace(value: string);
    resetSaasReplace(): void;
    get saasReplaceInput(): string | undefined;
    private _saasSuffix?;
    get saasSuffix(): string;
    set saasSuffix(value: string);
    resetSaasSuffix(): void;
    get saasSuffixInput(): string | undefined;
    private _saasType?;
    get saasType(): string;
    set saasType(value: string);
    resetSaasType(): void;
    get saasTypeInput(): string | undefined;
    private _secondHostname?;
    get secondHostname(): string;
    set secondHostname(value: string);
    resetSecondHostname(): void;
    get secondHostnameInput(): string | undefined;
    private _secondHostnameEnabled?;
    get secondHostnameEnabled(): boolean | cdktf.IResolvable;
    set secondHostnameEnabled(value: boolean | cdktf.IResolvable);
    resetSecondHostnameEnabled(): void;
    get secondHostnameEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _standardCertificateAuthorities?;
    get standardCertificateAuthorities(): string[];
    set standardCertificateAuthorities(value: string[]);
    resetStandardCertificateAuthorities(): void;
    get standardCertificateAuthoritiesInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tls13Support?;
    get tls13Support(): boolean | cdktf.IResolvable;
    set tls13Support(value: boolean | cdktf.IResolvable);
    resetTls13Support(): void;
    get tls13SupportInput(): boolean | cdktf.IResolvable | undefined;
    private _tlsVersionTitle?;
    get tlsVersionTitle(): string;
    set tlsVersionTitle(value: string);
    resetTlsVersionTitle(): void;
    get tlsVersionTitleInput(): string | undefined;
    private _trueClientIpClientSetting?;
    get trueClientIpClientSetting(): boolean | cdktf.IResolvable;
    set trueClientIpClientSetting(value: boolean | cdktf.IResolvable);
    resetTrueClientIpClientSetting(): void;
    get trueClientIpClientSettingInput(): boolean | cdktf.IResolvable | undefined;
    private _trueClientIpHeader?;
    get trueClientIpHeader(): string;
    set trueClientIpHeader(value: string);
    resetTrueClientIpHeader(): void;
    get trueClientIpHeaderInput(): string | undefined;
    private _useUniqueCacheKey?;
    get useUniqueCacheKey(): boolean | cdktf.IResolvable;
    set useUniqueCacheKey(value: boolean | cdktf.IResolvable);
    resetUseUniqueCacheKey(): void;
    get useUniqueCacheKeyInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _verificationMode?;
    get verificationMode(): string;
    set verificationMode(value: string);
    resetVerificationMode(): void;
    get verificationModeInput(): string | undefined;
    private _customCertificateAuthorities;
    get customCertificateAuthorities(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesList;
    putCustomCertificateAuthorities(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities[] | cdktf.IResolvable): void;
    resetCustomCertificateAuthorities(): void;
    get customCertificateAuthoritiesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities[] | undefined;
    private _customCertificates;
    get customCertificates(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesList;
    putCustomCertificates(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates[] | cdktf.IResolvable): void;
    resetCustomCertificates(): void;
    get customCertificatesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates[] | undefined;
    private _netStorage;
    get netStorage(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference;
    putNetStorage(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage): void;
    resetNetStorage(): void;
    get netStorageInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics {
    /**
    * Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
    */
    readonly accessKeyEncryptedStorage?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
    */
    readonly adcTitle?: string;
    /**
    * Specifies the authentication method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
    */
    readonly authenticationMethod?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
    */
    readonly authenticationMethodTitle?: string;
    /**
    * Specifies active access key ID linked to your AWS account.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
    */
    readonly awsAccessKeyId?: string;
    /**
    * Identifies the unique `awsAccessKeyVersionGuid` access key `created` in Cloud Access Manager to sign your requests to AWS S3.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
    */
    readonly awsAccessKeyVersionGuid?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}
    */
    readonly awsArRegion?: string;
    /**
    * This specifies the AWS hostname, without `http://` or `https://` prefixes. If you leave this option empty, it inherits the hostname from the `origin` behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
    */
    readonly awsHost?: string;
    /**
    * This specifies the AWS region code of the location where your bucket resides.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
    */
    readonly awsRegion?: string;
    /**
    * Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
    */
    readonly awsSecretAccessKey?: string;
    /**
    * This specifies the subdomain of your AWS service. It precedes `amazonaws.com` or the region code in the AWS hostname. For example, `s3.amazonaws.com`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
    */
    readonly awsService?: string;
    /**
    * Specifies the origin's geographic region.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
    */
    readonly country?: string;
    /**
    * Specifies the data to be encrypted as a series of enumerated variable names. See `Built-in system variables` for guidance on each.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
    */
    readonly customSignString?: string[];
    /**
    * Provides a region used by Akamai Direct Connection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
    */
    readonly directConnectGeo?: string;
    /**
    * Specifies the version of the encryption algorithm, an integer from `1` to `5`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
    */
    readonly encodingVersion?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}
    */
    readonly endPointService?: string;
    /**
    * Identifies the unique `gcsAccessKeyVersionGuid` access key `created` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
    */
    readonly gcsAccessKeyVersionGuid?: string;
    /**
    * Specifies the active access ID linked to your Google account.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
    */
    readonly gcsHmacKeyAccessId?: string;
    /**
    * Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
    */
    readonly gcsHmacKeySecret?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}
    */
    readonly hostnameTag?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the access key provided by the hosting service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
    */
    readonly mslkey?: string;
    /**
    * Specifies the origin name provided by the hosting service.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
    */
    readonly mslname?: string;
    /**
    * Specifies the nonce.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
    */
    readonly nonce?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
    */
    readonly originLocationTitle?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}
    */
    readonly propertyIdTag?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}
    */
    readonly roleArn?: string;
    /**
    * Specifies the shared secret key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
    */
    readonly secretKey?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies whether to customize your signed string.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
    */
    readonly useCustomSignString?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics | undefined);
    private _accessKeyEncryptedStorage?;
    get accessKeyEncryptedStorage(): boolean | cdktf.IResolvable;
    set accessKeyEncryptedStorage(value: boolean | cdktf.IResolvable);
    resetAccessKeyEncryptedStorage(): void;
    get accessKeyEncryptedStorageInput(): boolean | cdktf.IResolvable | undefined;
    private _adcTitle?;
    get adcTitle(): string;
    set adcTitle(value: string);
    resetAdcTitle(): void;
    get adcTitleInput(): string | undefined;
    private _authenticationMethod?;
    get authenticationMethod(): string;
    set authenticationMethod(value: string);
    resetAuthenticationMethod(): void;
    get authenticationMethodInput(): string | undefined;
    private _authenticationMethodTitle?;
    get authenticationMethodTitle(): string;
    set authenticationMethodTitle(value: string);
    resetAuthenticationMethodTitle(): void;
    get authenticationMethodTitleInput(): string | undefined;
    private _awsAccessKeyId?;
    get awsAccessKeyId(): string;
    set awsAccessKeyId(value: string);
    resetAwsAccessKeyId(): void;
    get awsAccessKeyIdInput(): string | undefined;
    private _awsAccessKeyVersionGuid?;
    get awsAccessKeyVersionGuid(): string;
    set awsAccessKeyVersionGuid(value: string);
    resetAwsAccessKeyVersionGuid(): void;
    get awsAccessKeyVersionGuidInput(): string | undefined;
    private _awsArRegion?;
    get awsArRegion(): string;
    set awsArRegion(value: string);
    resetAwsArRegion(): void;
    get awsArRegionInput(): string | undefined;
    private _awsHost?;
    get awsHost(): string;
    set awsHost(value: string);
    resetAwsHost(): void;
    get awsHostInput(): string | undefined;
    private _awsRegion?;
    get awsRegion(): string;
    set awsRegion(value: string);
    resetAwsRegion(): void;
    get awsRegionInput(): string | undefined;
    private _awsSecretAccessKey?;
    get awsSecretAccessKey(): string;
    set awsSecretAccessKey(value: string);
    resetAwsSecretAccessKey(): void;
    get awsSecretAccessKeyInput(): string | undefined;
    private _awsService?;
    get awsService(): string;
    set awsService(value: string);
    resetAwsService(): void;
    get awsServiceInput(): string | undefined;
    private _country?;
    get country(): string;
    set country(value: string);
    resetCountry(): void;
    get countryInput(): string | undefined;
    private _customSignString?;
    get customSignString(): string[];
    set customSignString(value: string[]);
    resetCustomSignString(): void;
    get customSignStringInput(): string[] | undefined;
    private _directConnectGeo?;
    get directConnectGeo(): string;
    set directConnectGeo(value: string);
    resetDirectConnectGeo(): void;
    get directConnectGeoInput(): string | undefined;
    private _encodingVersion?;
    get encodingVersion(): number;
    set encodingVersion(value: number);
    resetEncodingVersion(): void;
    get encodingVersionInput(): number | undefined;
    private _endPointService?;
    get endPointService(): string;
    set endPointService(value: string);
    resetEndPointService(): void;
    get endPointServiceInput(): string | undefined;
    private _gcsAccessKeyVersionGuid?;
    get gcsAccessKeyVersionGuid(): string;
    set gcsAccessKeyVersionGuid(value: string);
    resetGcsAccessKeyVersionGuid(): void;
    get gcsAccessKeyVersionGuidInput(): string | undefined;
    private _gcsHmacKeyAccessId?;
    get gcsHmacKeyAccessId(): string;
    set gcsHmacKeyAccessId(value: string);
    resetGcsHmacKeyAccessId(): void;
    get gcsHmacKeyAccessIdInput(): string | undefined;
    private _gcsHmacKeySecret?;
    get gcsHmacKeySecret(): string;
    set gcsHmacKeySecret(value: string);
    resetGcsHmacKeySecret(): void;
    get gcsHmacKeySecretInput(): string | undefined;
    private _hostnameTag?;
    get hostnameTag(): boolean | cdktf.IResolvable;
    set hostnameTag(value: boolean | cdktf.IResolvable);
    resetHostnameTag(): void;
    get hostnameTagInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mslkey?;
    get mslkey(): string;
    set mslkey(value: string);
    resetMslkey(): void;
    get mslkeyInput(): string | undefined;
    private _mslname?;
    get mslname(): string;
    set mslname(value: string);
    resetMslname(): void;
    get mslnameInput(): string | undefined;
    private _nonce?;
    get nonce(): string;
    set nonce(value: string);
    resetNonce(): void;
    get nonceInput(): string | undefined;
    private _originLocationTitle?;
    get originLocationTitle(): string;
    set originLocationTitle(value: string);
    resetOriginLocationTitle(): void;
    get originLocationTitleInput(): string | undefined;
    private _propertyIdTag?;
    get propertyIdTag(): boolean | cdktf.IResolvable;
    set propertyIdTag(value: boolean | cdktf.IResolvable);
    resetPropertyIdTag(): void;
    get propertyIdTagInput(): boolean | cdktf.IResolvable | undefined;
    private _roleArn?;
    get roleArn(): string;
    set roleArn(value: string);
    resetRoleArn(): void;
    get roleArnInput(): string | undefined;
    private _secretKey?;
    get secretKey(): string;
    set secretKey(value: string);
    resetSecretKey(): void;
    get secretKeyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useCustomSignString?;
    get useCustomSignString(): boolean | cdktf.IResolvable;
    set useCustomSignString(value: boolean | cdktf.IResolvable);
    resetUseCustomSignString(): void;
    get useCustomSignStringInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies an origin type.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
    */
    readonly origintype?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _origintype?;
    get origintype(): string;
    set origintype(value: string);
    resetOrigintype(): void;
    get origintypeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod {
    /**
    * Specifies the custom status code to be sent to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
    */
    readonly customStatusCode?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
    */
    readonly recoveryMethod?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod | undefined);
    private _customStatusCode?;
    get customStatusCode(): string;
    set customStatusCode(value: string);
    resetCustomStatusCode(): void;
    get customStatusCodeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _recoveryMethod?;
    get recoveryMethod(): string;
    set recoveryMethod(value: string);
    resetRecoveryMethod(): void;
    get recoveryMethodInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy {
    /**
    * Synchronizes content between the primary and backup origins, byte for byte.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
    */
    readonly binaryEquivalentContent?: boolean | cdktf.IResolvable;
    /**
    * Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the `configName` established for `originResponsivenessRecoveryConfigName` is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
    */
    readonly enableIpAvoidance?: boolean | cdktf.IResolvable;
    /**
    * Activates and configures a recovery policy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Defines the number of failures that need to occur to an origin address before it's blocked.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
    */
    readonly ipAvoidanceErrorThreshold?: number;
    /**
    * Defines the number of seconds after which the IP address is removed from the blocklist.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
    */
    readonly ipAvoidanceRetryInterval?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
    */
    readonly monitorOriginResponsiveness?: boolean | cdktf.IResolvable;
    /**
    * Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (`501`) or a range (`501:504`). If you configure other `monitorStatusCodes*` and `monitorResponseCodes*` options, you can't use the same codes here.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
    */
    readonly monitorResponseCodes1?: string[];
    /**
    * Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (`501`) or a range (`501:504`). If you configure other `monitorStatusCodes*` and `monitorResponseCodes*` options, you can't use the same codes here.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
    */
    readonly monitorResponseCodes2?: string[];
    /**
    * Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (`501`) or a range (`501:504`). If you configure other `monitorStatusCodes*` and `monitorResponseCodes*` options, you can't use the same codes here..
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
    */
    readonly monitorResponseCodes3?: string[];
    /**
    * Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
    */
    readonly monitorStatusCodes1?: boolean | cdktf.IResolvable;
    /**
    * Enables the recovery action for the response codes you define.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
    */
    readonly monitorStatusCodes1EnableRecovery?: boolean | cdktf.IResolvable;
    /**
    * When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
    */
    readonly monitorStatusCodes1EnableRetry?: boolean | cdktf.IResolvable;
    /**
    * Specifies a recovery configuration using the `configName` you defined in the `recoveryConfig` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the `recoveryConfig` match criteria to apply this option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
    */
    readonly monitorStatusCodes1RecoveryConfigName?: string;
    /**
    * Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
    */
    readonly monitorStatusCodes2?: boolean | cdktf.IResolvable;
    /**
    * Enables the recovery action for the response codes you define.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
    */
    readonly monitorStatusCodes2EnableRecovery?: boolean | cdktf.IResolvable;
    /**
    * When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
    */
    readonly monitorStatusCodes2EnableRetry?: boolean | cdktf.IResolvable;
    /**
    * Specifies a recovery configuration using the `configName` you defined in the `recoveryConfig` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the `recoveryConfig` match criteria to apply this option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
    */
    readonly monitorStatusCodes2RecoveryConfigName?: string;
    /**
    * Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
    */
    readonly monitorStatusCodes3?: boolean | cdktf.IResolvable;
    /**
    * Enables the recovery action for the response codes you define.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
    */
    readonly monitorStatusCodes3EnableRecovery?: boolean | cdktf.IResolvable;
    /**
    * When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
    */
    readonly monitorStatusCodes3EnableRetry?: boolean | cdktf.IResolvable;
    /**
    * Specifies a recovery configuration using the `configName` you defined in the `recoveryConfig` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the `recoveryConfig` match criteria to apply this option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
    */
    readonly monitorStatusCodes3RecoveryConfigName?: string;
    /**
    * Specify a custom timeout, from 1 to 10 seconds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
    */
    readonly originResponsivenessCustomTimeout?: number;
    /**
    * Enables a recovery action for a specific failure condition.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
    */
    readonly originResponsivenessEnableRecovery?: boolean | cdktf.IResolvable;
    /**
    * If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
    */
    readonly originResponsivenessEnableRetry?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
    */
    readonly originResponsivenessMonitoring?: string;
    /**
    * Specifies a recovery configuration using the `configName` you defined in the `recoveryConfig` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the `recoveryConfig` match criteria to apply this option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
    */
    readonly originResponsivenessRecoveryConfigName?: string;
    /**
    * The timeout threshold that triggers a retry or recovery action.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
    */
    readonly originResponsivenessTimeout?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
    */
    readonly statusCodeMonitoring1?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
    */
    readonly statusCodeMonitoring2?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
    */
    readonly statusCodeMonitoring3?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
    */
    readonly tuningParameters?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy | undefined);
    private _binaryEquivalentContent?;
    get binaryEquivalentContent(): boolean | cdktf.IResolvable;
    set binaryEquivalentContent(value: boolean | cdktf.IResolvable);
    resetBinaryEquivalentContent(): void;
    get binaryEquivalentContentInput(): boolean | cdktf.IResolvable | undefined;
    private _enableIpAvoidance?;
    get enableIpAvoidance(): boolean | cdktf.IResolvable;
    set enableIpAvoidance(value: boolean | cdktf.IResolvable);
    resetEnableIpAvoidance(): void;
    get enableIpAvoidanceInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _ipAvoidanceErrorThreshold?;
    get ipAvoidanceErrorThreshold(): number;
    set ipAvoidanceErrorThreshold(value: number);
    resetIpAvoidanceErrorThreshold(): void;
    get ipAvoidanceErrorThresholdInput(): number | undefined;
    private _ipAvoidanceRetryInterval?;
    get ipAvoidanceRetryInterval(): number;
    set ipAvoidanceRetryInterval(value: number);
    resetIpAvoidanceRetryInterval(): void;
    get ipAvoidanceRetryIntervalInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorOriginResponsiveness?;
    get monitorOriginResponsiveness(): boolean | cdktf.IResolvable;
    set monitorOriginResponsiveness(value: boolean | cdktf.IResolvable);
    resetMonitorOriginResponsiveness(): void;
    get monitorOriginResponsivenessInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorResponseCodes1?;
    get monitorResponseCodes1(): string[];
    set monitorResponseCodes1(value: string[]);
    resetMonitorResponseCodes1(): void;
    get monitorResponseCodes1Input(): string[] | undefined;
    private _monitorResponseCodes2?;
    get monitorResponseCodes2(): string[];
    set monitorResponseCodes2(value: string[]);
    resetMonitorResponseCodes2(): void;
    get monitorResponseCodes2Input(): string[] | undefined;
    private _monitorResponseCodes3?;
    get monitorResponseCodes3(): string[];
    set monitorResponseCodes3(value: string[]);
    resetMonitorResponseCodes3(): void;
    get monitorResponseCodes3Input(): string[] | undefined;
    private _monitorStatusCodes1?;
    get monitorStatusCodes1(): boolean | cdktf.IResolvable;
    set monitorStatusCodes1(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes1(): void;
    get monitorStatusCodes1Input(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes1EnableRecovery?;
    get monitorStatusCodes1EnableRecovery(): boolean | cdktf.IResolvable;
    set monitorStatusCodes1EnableRecovery(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes1EnableRecovery(): void;
    get monitorStatusCodes1EnableRecoveryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes1EnableRetry?;
    get monitorStatusCodes1EnableRetry(): boolean | cdktf.IResolvable;
    set monitorStatusCodes1EnableRetry(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes1EnableRetry(): void;
    get monitorStatusCodes1EnableRetryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes1RecoveryConfigName?;
    get monitorStatusCodes1RecoveryConfigName(): string;
    set monitorStatusCodes1RecoveryConfigName(value: string);
    resetMonitorStatusCodes1RecoveryConfigName(): void;
    get monitorStatusCodes1RecoveryConfigNameInput(): string | undefined;
    private _monitorStatusCodes2?;
    get monitorStatusCodes2(): boolean | cdktf.IResolvable;
    set monitorStatusCodes2(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes2(): void;
    get monitorStatusCodes2Input(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes2EnableRecovery?;
    get monitorStatusCodes2EnableRecovery(): boolean | cdktf.IResolvable;
    set monitorStatusCodes2EnableRecovery(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes2EnableRecovery(): void;
    get monitorStatusCodes2EnableRecoveryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes2EnableRetry?;
    get monitorStatusCodes2EnableRetry(): boolean | cdktf.IResolvable;
    set monitorStatusCodes2EnableRetry(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes2EnableRetry(): void;
    get monitorStatusCodes2EnableRetryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes2RecoveryConfigName?;
    get monitorStatusCodes2RecoveryConfigName(): string;
    set monitorStatusCodes2RecoveryConfigName(value: string);
    resetMonitorStatusCodes2RecoveryConfigName(): void;
    get monitorStatusCodes2RecoveryConfigNameInput(): string | undefined;
    private _monitorStatusCodes3?;
    get monitorStatusCodes3(): boolean | cdktf.IResolvable;
    set monitorStatusCodes3(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes3(): void;
    get monitorStatusCodes3Input(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes3EnableRecovery?;
    get monitorStatusCodes3EnableRecovery(): boolean | cdktf.IResolvable;
    set monitorStatusCodes3EnableRecovery(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes3EnableRecovery(): void;
    get monitorStatusCodes3EnableRecoveryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes3EnableRetry?;
    get monitorStatusCodes3EnableRetry(): boolean | cdktf.IResolvable;
    set monitorStatusCodes3EnableRetry(value: boolean | cdktf.IResolvable);
    resetMonitorStatusCodes3EnableRetry(): void;
    get monitorStatusCodes3EnableRetryInput(): boolean | cdktf.IResolvable | undefined;
    private _monitorStatusCodes3RecoveryConfigName?;
    get monitorStatusCodes3RecoveryConfigName(): string;
    set monitorStatusCodes3RecoveryConfigName(value: string);
    resetMonitorStatusCodes3RecoveryConfigName(): void;
    get monitorStatusCodes3RecoveryConfigNameInput(): string | undefined;
    private _originResponsivenessCustomTimeout?;
    get originResponsivenessCustomTimeout(): number;
    set originResponsivenessCustomTimeout(value: number);
    resetOriginResponsivenessCustomTimeout(): void;
    get originResponsivenessCustomTimeoutInput(): number | undefined;
    private _originResponsivenessEnableRecovery?;
    get originResponsivenessEnableRecovery(): boolean | cdktf.IResolvable;
    set originResponsivenessEnableRecovery(value: boolean | cdktf.IResolvable);
    resetOriginResponsivenessEnableRecovery(): void;
    get originResponsivenessEnableRecoveryInput(): boolean | cdktf.IResolvable | undefined;
    private _originResponsivenessEnableRetry?;
    get originResponsivenessEnableRetry(): boolean | cdktf.IResolvable;
    set originResponsivenessEnableRetry(value: boolean | cdktf.IResolvable);
    resetOriginResponsivenessEnableRetry(): void;
    get originResponsivenessEnableRetryInput(): boolean | cdktf.IResolvable | undefined;
    private _originResponsivenessMonitoring?;
    get originResponsivenessMonitoring(): string;
    set originResponsivenessMonitoring(value: string);
    resetOriginResponsivenessMonitoring(): void;
    get originResponsivenessMonitoringInput(): string | undefined;
    private _originResponsivenessRecoveryConfigName?;
    get originResponsivenessRecoveryConfigName(): string;
    set originResponsivenessRecoveryConfigName(value: string);
    resetOriginResponsivenessRecoveryConfigName(): void;
    get originResponsivenessRecoveryConfigNameInput(): string | undefined;
    private _originResponsivenessTimeout?;
    get originResponsivenessTimeout(): string;
    set originResponsivenessTimeout(value: string);
    resetOriginResponsivenessTimeout(): void;
    get originResponsivenessTimeoutInput(): string | undefined;
    private _statusCodeMonitoring1?;
    get statusCodeMonitoring1(): string;
    set statusCodeMonitoring1(value: string);
    resetStatusCodeMonitoring1(): void;
    get statusCodeMonitoring1Input(): string | undefined;
    private _statusCodeMonitoring2?;
    get statusCodeMonitoring2(): string;
    set statusCodeMonitoring2(value: string);
    resetStatusCodeMonitoring2(): void;
    get statusCodeMonitoring2Input(): string | undefined;
    private _statusCodeMonitoring3?;
    get statusCodeMonitoring3(): string;
    set statusCodeMonitoring3(value: string);
    resetStatusCodeMonitoring3(): void;
    get statusCodeMonitoring3Input(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tuningParameters?;
    get tuningParameters(): string;
    set tuningParameters(value: string);
    resetTuningParameters(): void;
    get tuningParametersInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl {
    /**
    * Enables the Origin IP Access Control List behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy {
    /**
    * The features you've set in `permissionsPolicyDirective` are enabled for domains you specify here. They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to `none`. This generates an empty value in the `Permissions-Policy` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
    */
    readonly allowList?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Each directive represents a browser feature. Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the `guide section` for this behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
    */
    readonly permissionsPolicyDirective?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy | undefined);
    private _allowList?;
    get allowList(): string;
    set allowList(value: string);
    resetAllowList(): void;
    get allowListInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _permissionsPolicyDirective?;
    get permissionsPolicyDirective(): string[];
    set permissionsPolicyDirective(value: string[]);
    resetPermissionsPolicyDirective(): void;
    get permissionsPolicyDirectiveInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection {
    /**
    * Enables the persistent connections behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection {
    /**
    * Enables persistent connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the timeout period after which edge server closes a persistent connection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation {
    /**
    * When enabled, marks content as personally identifiable information (PII).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease {
    /**
    * Identifies the Cloudlet shared policy to use with this behavior. Use the `Cloudlets API` to list available shared policies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Phased Release Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to `0` to immediately request the alternate origin upon failure.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
    */
    readonly failoverDuration?: number;
    /**
    * Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
    */
    readonly failoverEnabled?: boolean | cdktf.IResolvable;
    /**
    * Defines the set of failure codes that initiate the failover response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
    */
    readonly failoverResponseCode?: string[];
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
    */
    readonly failoverTitle?: string;
    /**
    * Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * A label to distinguish this Phased Release policy from any others within the same property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
    */
    readonly label?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's `random` membership option, it overrides this option's value so that it is effectively `NONE`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
    */
    readonly populationCookieType?: string;
    /**
    * Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
    */
    readonly populationDuration?: string;
    /**
    * Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
    */
    readonly populationExpirationDate?: string;
    /**
    * Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
    */
    readonly populationRefresh?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
    */
    readonly populationTitle?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverDuration?;
    get failoverDuration(): number;
    set failoverDuration(value: number);
    resetFailoverDuration(): void;
    get failoverDurationInput(): number | undefined;
    private _failoverEnabled?;
    get failoverEnabled(): boolean | cdktf.IResolvable;
    set failoverEnabled(value: boolean | cdktf.IResolvable);
    resetFailoverEnabled(): void;
    get failoverEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverResponseCode?;
    get failoverResponseCode(): string[];
    set failoverResponseCode(value: string[]);
    resetFailoverResponseCode(): void;
    get failoverResponseCodeInput(): string[] | undefined;
    private _failoverTitle?;
    get failoverTitle(): string;
    set failoverTitle(value: string);
    resetFailoverTitle(): void;
    get failoverTitleInput(): string | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    resetLabel(): void;
    get labelInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _populationCookieType?;
    get populationCookieType(): string;
    set populationCookieType(value: string);
    resetPopulationCookieType(): void;
    get populationCookieTypeInput(): string | undefined;
    private _populationDuration?;
    get populationDuration(): string;
    set populationDuration(value: string);
    resetPopulationDuration(): void;
    get populationDurationInput(): string | undefined;
    private _populationExpirationDate?;
    get populationExpirationDate(): string;
    set populationExpirationDate(value: string);
    resetPopulationExpirationDate(): void;
    get populationExpirationDateInput(): string | undefined;
    private _populationRefresh?;
    get populationRefresh(): boolean | cdktf.IResolvable;
    set populationRefresh(value: boolean | cdktf.IResolvable);
    resetPopulationRefresh(): void;
    get populationRefreshInput(): boolean | cdktf.IResolvable | undefined;
    private _populationTitle?;
    get populationTitle(): string;
    set populationTitle(value: string);
    resetPopulationTitle(): void;
    get populationTitleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of hostnames to which to preconnect over HTTP2.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
    */
    readonly preconnectlist?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _preconnectlist?;
    get preconnectlist(): string[];
    set preconnectlist(value: string[]);
    resetPreconnectlist(): void;
    get preconnectlistInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery {
    /**
    * Enables the predictive content delivery behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching {
    /**
    * The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
    */
    readonly accuracyTarget?: string;
    /**
    * Enables the predictive prefetching behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching | undefined);
    private _accuracyTarget?;
    get accuracyTarget(): string;
    set accuracyTarget(value: string);
    resetAccuracyTarget(): void;
    get accuracyTargetInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch {
    /**
    * Applies prefetching behavior when enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable {
    /**
    * Allows matching content to prefetch when referenced on a requested parent page.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache {
    /**
    * Enables the cache prefreshing behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of `95` prefreshes the content without unnecessarily increasing load on the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
    */
    readonly prefreshval?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefreshval?;
    get prefreshval(): number;
    set prefreshval(value: number);
    resetPrefreshval(): void;
    get prefreshvalInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
    */
    readonly audienceSettings?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
    */
    readonly contentSettings?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
    */
    readonly country?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}
    */
    readonly deliveryFormat?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}
    */
    readonly deliveryType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}
    */
    readonly downloadType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}
    */
    readonly endUserLocation?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}
    */
    readonly maximumConcurrentUsers?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}
    */
    readonly optimizeFor?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
    */
    readonly originSettings?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}
    */
    readonly refreshRate?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}
    */
    readonly segmentDuration?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality | undefined);
    private _audienceSettings?;
    get audienceSettings(): string;
    set audienceSettings(value: string);
    resetAudienceSettings(): void;
    get audienceSettingsInput(): string | undefined;
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentSettings?;
    get contentSettings(): string;
    set contentSettings(value: string);
    resetContentSettings(): void;
    get contentSettingsInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _country?;
    get country(): string;
    set country(value: string);
    resetCountry(): void;
    get countryInput(): string | undefined;
    private _deliveryFormat?;
    get deliveryFormat(): string;
    set deliveryFormat(value: string);
    resetDeliveryFormat(): void;
    get deliveryFormatInput(): string | undefined;
    private _deliveryType?;
    get deliveryType(): string;
    set deliveryType(value: string);
    resetDeliveryType(): void;
    get deliveryTypeInput(): string | undefined;
    private _downloadType?;
    get downloadType(): string;
    set downloadType(value: string);
    resetDownloadType(): void;
    get downloadTypeInput(): string | undefined;
    private _endUserLocation?;
    get endUserLocation(): string;
    set endUserLocation(value: string);
    resetEndUserLocation(): void;
    get endUserLocationInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumConcurrentUsers?;
    get maximumConcurrentUsers(): string;
    set maximumConcurrentUsers(value: string);
    resetMaximumConcurrentUsers(): void;
    get maximumConcurrentUsersInput(): string | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _optimizeFor?;
    get optimizeFor(): string;
    set optimizeFor(value: string);
    resetOptimizeFor(): void;
    get optimizeForInput(): string | undefined;
    private _originSettings?;
    get originSettings(): string;
    set originSettings(value: string);
    resetOriginSettings(): void;
    get originSettingsInput(): string | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _refreshRate?;
    get refreshRate(): string;
    set refreshRate(value: string);
    resetRefreshRate(): void;
    get refreshRateInput(): string | undefined;
    private _segmentDuration?;
    get segmentDuration(): number;
    set segmentDuration(value: number);
    resetSegmentDuration(): void;
    get segmentDurationInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta {
    /**
    * Enables QUIC support.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The percentage of responses for which to allow QUIC sessions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
    */
    readonly quicOfferPercentage?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _quicOfferPercentage?;
    get quicOfferPercentage(): number;
    set quicOfferPercentage(value: number);
    resetQuicOfferPercentage(): void;
    get quicOfferPercentageInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek {
    /**
    * Enables random seek optimization in FLV files.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
    */
    readonly flv?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as `MB` or `GB`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
    */
    readonly maximumSize?: string;
    /**
    * Enables random seek optimization in MP4 files.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
    */
    readonly mp4?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek | undefined);
    private _flv?;
    get flv(): boolean | cdktf.IResolvable;
    set flv(value: boolean | cdktf.IResolvable);
    resetFlv(): void;
    get flvInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumSize?;
    get maximumSize(): string;
    set maximumSize(value: string);
    resetMaximumSize(): void;
    get maximumSizeInput(): string | undefined;
    private _mp4?;
    get mp4(): boolean | cdktf.IResolvable;
    set mp4(value: boolean | cdktf.IResolvable);
    resetMp4(): void;
    get mp4Input(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid {
    /**
    * Enables API Gateway for the current set of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the read timeout necessary before failing with a `504` error. This value should never be zero.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting {
    /**
    * Enables advanced options.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * Specifies the percentage for sampling.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
    */
    readonly beaconSamplingPercentage?: number;
    /**
    * Enables reports on delivery of cloud hosted content at near real-time latencies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _beaconSamplingPercentage?;
    get beaconSamplingPercentage(): number;
    set beaconSamplingPercentage(value: number);
    resetBeaconSamplingPercentage(): void;
    get beaconSamplingPercentageInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring {
    /**
    * When enabled, activates real-use monitoring.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect {
    /**
    * Specify how to change the requested hostname, independently from the pathname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
    */
    readonly destinationHostname?: string;
    /**
    * Specifies the full hostname with which to replace the current hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
    */
    readonly destinationHostnameOther?: string;
    /**
    * Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of `m` changes `www.example.com` to `m.example.com`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
    */
    readonly destinationHostnameSibling?: string;
    /**
    * Specifies a subdomain to prepend to the current hostname. For example, a value of `m` changes `www.example.com` to `m.www.example.com`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
    */
    readonly destinationHostnameSubdomain?: string;
    /**
    * Specify how to change the requested pathname, independently from the hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
    */
    readonly destinationPath?: string;
    /**
    * When `destinationPath` is set to `PREFIX_REQUEST`, this replaces the current path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
    */
    readonly destinationPathOther?: string;
    /**
    * When `destinationPath` is set to `PREFIX_REQUEST`, this prepends the current path. For example, a value of `/prefix/path` changes `/example/index.html` to `/prefix/path/example/index.html`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
    */
    readonly destinationPathPrefix?: string;
    /**
    * When `destinationPath` is set to `PREFIX_REQUEST` and `destinationPathSuffixStatus` is set to `SUFFIX`, this specifies the suffix to append to the path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
    */
    readonly destinationPathSuffix?: string;
    /**
    * When `destinationPath` is set to `PREFIX_REQUEST`, this gives you the option of adding a suffix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
    */
    readonly destinationPathSuffixStatus?: string;
    /**
    * Choose the protocol for the redirect URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
    */
    readonly destinationProtocol?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Either specify a default response for mobile browsers, or customize your own.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
    */
    readonly mobileDefaultChoice?: string;
    /**
    * When set to `APPEND`, passes incoming query string parameters as part of the redirect URL. Otherwise set this to `IGNORE`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
    */
    readonly queryString?: string;
    /**
    * Specify the redirect's response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
    */
    readonly responseCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect | undefined);
    private _destinationHostname?;
    get destinationHostname(): string;
    set destinationHostname(value: string);
    resetDestinationHostname(): void;
    get destinationHostnameInput(): string | undefined;
    private _destinationHostnameOther?;
    get destinationHostnameOther(): string;
    set destinationHostnameOther(value: string);
    resetDestinationHostnameOther(): void;
    get destinationHostnameOtherInput(): string | undefined;
    private _destinationHostnameSibling?;
    get destinationHostnameSibling(): string;
    set destinationHostnameSibling(value: string);
    resetDestinationHostnameSibling(): void;
    get destinationHostnameSiblingInput(): string | undefined;
    private _destinationHostnameSubdomain?;
    get destinationHostnameSubdomain(): string;
    set destinationHostnameSubdomain(value: string);
    resetDestinationHostnameSubdomain(): void;
    get destinationHostnameSubdomainInput(): string | undefined;
    private _destinationPath?;
    get destinationPath(): string;
    set destinationPath(value: string);
    resetDestinationPath(): void;
    get destinationPathInput(): string | undefined;
    private _destinationPathOther?;
    get destinationPathOther(): string;
    set destinationPathOther(value: string);
    resetDestinationPathOther(): void;
    get destinationPathOtherInput(): string | undefined;
    private _destinationPathPrefix?;
    get destinationPathPrefix(): string;
    set destinationPathPrefix(value: string);
    resetDestinationPathPrefix(): void;
    get destinationPathPrefixInput(): string | undefined;
    private _destinationPathSuffix?;
    get destinationPathSuffix(): string;
    set destinationPathSuffix(value: string);
    resetDestinationPathSuffix(): void;
    get destinationPathSuffixInput(): string | undefined;
    private _destinationPathSuffixStatus?;
    get destinationPathSuffixStatus(): string;
    set destinationPathSuffixStatus(value: string);
    resetDestinationPathSuffixStatus(): void;
    get destinationPathSuffixStatusInput(): string | undefined;
    private _destinationProtocol?;
    get destinationProtocol(): string;
    set destinationProtocol(value: string);
    resetDestinationProtocol(): void;
    get destinationProtocolInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mobileDefaultChoice?;
    get mobileDefaultChoice(): string;
    set mobileDefaultChoice(value: string);
    resetMobileDefaultChoice(): void;
    get mobileDefaultChoiceInput(): string | undefined;
    private _queryString?;
    get queryString(): string;
    set queryString(value: string);
    resetQueryString(): void;
    get queryStringInput(): string | undefined;
    private _responseCode?;
    get responseCode(): number;
    set responseCode(value: number);
    resetResponseCode(): void;
    get responseCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus {
    /**
    * Specifies the redirect as a path expression starting with a `/` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: `/path/to/{{builtin.AK_FILENAME}}`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
    */
    readonly destination?: string;
    /**
    * Enables the redirect feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Assigns the status code for the redirect response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
    */
    readonly responseCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus | undefined);
    private _destination?;
    get destination(): string;
    set destination(value: string);
    resetDestination(): void;
    get destinationInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _responseCode?;
    get responseCode(): number;
    set responseCode(value: number);
    resetResponseCode(): void;
    get responseCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking {
    /**
    * Allows all subdomains for the `domains` set, just like adding a `*.` prefix to each.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
    */
    readonly allowChildren?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of allowed domains. With `allowChildren` disabled, prefixing values with `*.` specifies domains for which subdomains are allowed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
    */
    readonly domains?: string[];
    /**
    * Enables the referer-checking behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, excludes requests whose `Referer` header include a relative path, or that are missing a `Referer`. When disabled, only excludes requests whose `Referer` hostname is not part of the `domains` set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
    */
    readonly strict?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking | undefined);
    private _allowChildren?;
    get allowChildren(): boolean | cdktf.IResolvable;
    set allowChildren(value: boolean | cdktf.IResolvable);
    resetAllowChildren(): void;
    get allowChildrenInput(): boolean | cdktf.IResolvable | undefined;
    private _domains?;
    get domains(): string[];
    set domains(value: string[]);
    resetDomains(): void;
    get domainsInput(): string[] | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _strict?;
    get strict(): boolean | cdktf.IResolvable;
    set strict(value: boolean | cdktf.IResolvable);
    resetStrict(): void;
    get strictInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies parameters to remove from the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
    */
    readonly parameters?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _parameters?;
    get parameters(): string[];
    set parameters(value: string[]);
    resetParameters(): void;
    get parametersInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary {
    /**
    * When enabled, removes the `Vary` header to ensure objects can be cached.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport {
    /**
    * This specifies the set of cookies names whose values you want to log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
    */
    readonly cookies?: string[];
    /**
    * Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, `round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms` logs the total time to complete the response. See `Support for variables` for more information. If you enable the `logCustom` behavior, it overrides the `customLogField` option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
    */
    readonly customLogField?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Log the `Accept-Language` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
    */
    readonly logAcceptLanguage?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of cookies to log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
    */
    readonly logCookies?: string;
    /**
    * Whether to append additional custom data to each log line.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
    */
    readonly logCustomLogField?: boolean | cdktf.IResolvable;
    /**
    * Whether to log the IP address of the Akamai edge server that served the response to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
    */
    readonly logEdgeIp?: boolean | cdktf.IResolvable;
    /**
    * Log the `Host` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
    */
    readonly logHost?: boolean | cdktf.IResolvable;
    /**
    * Log the `Referer` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
    */
    readonly logReferer?: boolean | cdktf.IResolvable;
    /**
    * Log the `User-Agent` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
    */
    readonly logUserAgent?: boolean | cdktf.IResolvable;
    /**
    * Log any `X-Forwarded-For` request header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
    */
    readonly logXForwardedFor?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport | undefined);
    private _cookies?;
    get cookies(): string[];
    set cookies(value: string[]);
    resetCookies(): void;
    get cookiesInput(): string[] | undefined;
    private _customLogField?;
    get customLogField(): string;
    set customLogField(value: string);
    resetCustomLogField(): void;
    get customLogFieldInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _logAcceptLanguage?;
    get logAcceptLanguage(): boolean | cdktf.IResolvable;
    set logAcceptLanguage(value: boolean | cdktf.IResolvable);
    resetLogAcceptLanguage(): void;
    get logAcceptLanguageInput(): boolean | cdktf.IResolvable | undefined;
    private _logCookies?;
    get logCookies(): string;
    set logCookies(value: string);
    resetLogCookies(): void;
    get logCookiesInput(): string | undefined;
    private _logCustomLogField?;
    get logCustomLogField(): boolean | cdktf.IResolvable;
    set logCustomLogField(value: boolean | cdktf.IResolvable);
    resetLogCustomLogField(): void;
    get logCustomLogFieldInput(): boolean | cdktf.IResolvable | undefined;
    private _logEdgeIp?;
    get logEdgeIp(): boolean | cdktf.IResolvable;
    set logEdgeIp(value: boolean | cdktf.IResolvable);
    resetLogEdgeIp(): void;
    get logEdgeIpInput(): boolean | cdktf.IResolvable | undefined;
    private _logHost?;
    get logHost(): boolean | cdktf.IResolvable;
    set logHost(value: boolean | cdktf.IResolvable);
    resetLogHost(): void;
    get logHostInput(): boolean | cdktf.IResolvable | undefined;
    private _logReferer?;
    get logReferer(): boolean | cdktf.IResolvable;
    set logReferer(value: boolean | cdktf.IResolvable);
    resetLogReferer(): void;
    get logRefererInput(): boolean | cdktf.IResolvable | undefined;
    private _logUserAgent?;
    get logUserAgent(): boolean | cdktf.IResolvable;
    set logUserAgent(value: boolean | cdktf.IResolvable);
    resetLogUserAgent(): void;
    get logUserAgentInput(): boolean | cdktf.IResolvable | undefined;
    private _logXForwardedFor?;
    get logXForwardedFor(): boolean | cdktf.IResolvable;
    set logXForwardedFor(value: boolean | cdktf.IResolvable);
    resetLogXForwardedFor(): void;
    get logXForwardedForInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints {
    /**
    * The client hint data objects you want to receive from the browser.  You can add custom entries or provide pre-set values from the list. For more details on each value, see the `guide section` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
    */
    readonly acceptCh?: string[];
    /**
    * The critical client hint data objects you want to receive from the browser. The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the `guide section` for this behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
    */
    readonly acceptCriticalCh?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This sends an empty instance of the `Accept-CH` response header to clear other `Accept-CH` values currently stored in the client browser. This empty header doesn't get merged with other objects sent from your origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
    */
    readonly reset?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints | undefined);
    private _acceptCh?;
    get acceptCh(): string[];
    set acceptCh(value: string[]);
    resetAcceptCh(): void;
    get acceptChInput(): string[] | undefined;
    private _acceptCriticalCh?;
    get acceptCriticalCh(): string[];
    set acceptCriticalCh(value: string[]);
    resetAcceptCriticalCh(): void;
    get acceptCriticalChInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _reset?;
    get reset(): boolean | cdktf.IResolvable;
    set reset(value: boolean | cdktf.IResolvable);
    resetReset(): void;
    get resetInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}
    */
    readonly downloadDomainName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}
    */
    readonly g2OToken?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage | undefined);
    private _cpCode?;
    get cpCode(): number;
    set cpCode(value: number);
    resetCpCode(): void;
    get cpCodeInput(): number | undefined;
    private _downloadDomainName?;
    get downloadDomainName(): string;
    set downloadDomainName(value: string);
    resetDownloadDomainName(): void;
    get downloadDomainNameInput(): string | undefined;
    private _g2OToken?;
    get g2OToken(): string;
    set g2OToken(value: string);
    resetG2OToken(): void;
    get g2OTokenInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl {
    /**
    * Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
    */
    readonly branded403File?: string;
    /**
    * Specifies the response status code for the branded deny action.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
    */
    readonly branded403StatusCode?: number;
    /**
    * Specifies the redirect URL for the branded deny action.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
    */
    readonly branded403Url?: string;
    /**
    * Specifies the branded response page's time to live in the cache, `5` minutes by default.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
    */
    readonly brandedDenyCacheTtl?: number;
    /**
    * Identifies the Cloudlet shared policy to use with this behavior. Use the `Cloudlets API` to list available shared policies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * If enabled, serves a branded 403 page for this Cloudlet instance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
    */
    readonly enableBranded403?: boolean | cdktf.IResolvable;
    /**
    * Enables the Request Control Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy;
    /**
    * net_storage block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
    */
    readonly netStorage?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl | undefined);
    private _branded403File?;
    get branded403File(): string;
    set branded403File(value: string);
    resetBranded403File(): void;
    get branded403FileInput(): string | undefined;
    private _branded403StatusCode?;
    get branded403StatusCode(): number;
    set branded403StatusCode(value: number);
    resetBranded403StatusCode(): void;
    get branded403StatusCodeInput(): number | undefined;
    private _branded403Url?;
    get branded403Url(): string;
    set branded403Url(value: string);
    resetBranded403Url(): void;
    get branded403UrlInput(): string | undefined;
    private _brandedDenyCacheTtl?;
    get brandedDenyCacheTtl(): number;
    set brandedDenyCacheTtl(value: number);
    resetBrandedDenyCacheTtl(): void;
    get brandedDenyCacheTtlInput(): number | undefined;
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enableBranded403?;
    get enableBranded403(): boolean | cdktf.IResolvable;
    set enableBranded403(value: boolean | cdktf.IResolvable);
    resetEnableBranded403(): void;
    get enableBranded403Input(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy | undefined;
    private _netStorage;
    get netStorage(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference;
    putNetStorage(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage): void;
    resetNetStorage(): void;
    get netStorageInput(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the type of request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
    */
    readonly requestType?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _requestType?;
    get requestType(): string;
    set requestType(value: string);
    resetRequestType(): void;
    get requestTypeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer {
    /**
    * Enables the Resource Optimizer feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility {
    /**
    * Enables `additional support` and error handling.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
    */
    readonly enableAllFeatures?: boolean | cdktf.IResolvable;
    /**
    * Enables the Resource Optimizer feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility | undefined);
    private _enableAllFeatures?;
    get enableAllFeatures(): boolean | cdktf.IResolvable;
    set enableAllFeatures(value: boolean | cdktf.IResolvable);
    resetEnableAllFeatures(): void;
    get enableAllFeaturesInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Allows any specified `200` success code to override a `206` partial-content code, in which case the response's content length matches the requested range length.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
    */
    readonly override206?: boolean | cdktf.IResolvable;
    /**
    * The HTTP status code to replace the existing one.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
    */
    readonly statusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _override206?;
    get override206(): boolean | cdktf.IResolvable;
    set override206(value: boolean | cdktf.IResolvable);
    resetOverride206(): void;
    get override206Input(): boolean | cdktf.IResolvable | undefined;
    private _statusCode?;
    get statusCode(): number;
    set statusCode(value: number);
    resetStatusCode(): void;
    get statusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie {
    /**
    * Specifies the name of the cookie, which serves as a key to determine if the cookie is set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * When enabled, uses the default domain value, otherwise the set specified in the `domain` field.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
    */
    readonly defaultDomain?: boolean | cdktf.IResolvable;
    /**
    * When enabled, uses the default path value, otherwise the set specified in the `path` field.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
    */
    readonly defaultPath?: boolean | cdktf.IResolvable;
    /**
    * If the `defaultDomain` is disabled, this sets the domain for which the cookie is valid. For example, `example.com` makes the cookie valid for that hostname and all subdomains.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
    */
    readonly domain?: string;
    /**
    * If `expires` is set to `DURATION`, this sets the cookie's lifetime.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
    */
    readonly duration?: string;
    /**
    * Allows you to set a response cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * If `expires` is set to `FIXED_DATE`, this sets when the cookie expires as a UTC date and time.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
    */
    readonly expirationDate?: string;
    /**
    * Sets various ways to specify when the cookie expires.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
    */
    readonly expires?: string;
    /**
    * When the `type` of cookie is set to `UNIQUE`, this sets the date format.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
    */
    readonly format?: string;
    /**
    * When enabled, includes the `HttpOnly` attribute in the `Set-Cookie` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
    */
    readonly httpOnly?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * If the `defaultPath` is disabled, sets the path component for which the cookie is valid.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
    */
    readonly path?: string;
    /**
    * This option controls the `SameSite` cookie attribute that reduces the risk of cross-site request forgery attacks.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
    */
    readonly sameSite?: string;
    /**
    * When enabled, sets the cookie's `Secure` flag to transmit it with `HTTPS`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
    */
    readonly secure?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * What type of value to assign.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
    */
    readonly type?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * If the cookie `type` is `FIXED`, this specifies the cookie value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _defaultDomain?;
    get defaultDomain(): boolean | cdktf.IResolvable;
    set defaultDomain(value: boolean | cdktf.IResolvable);
    resetDefaultDomain(): void;
    get defaultDomainInput(): boolean | cdktf.IResolvable | undefined;
    private _defaultPath?;
    get defaultPath(): boolean | cdktf.IResolvable;
    set defaultPath(value: boolean | cdktf.IResolvable);
    resetDefaultPath(): void;
    get defaultPathInput(): boolean | cdktf.IResolvable | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    resetDomain(): void;
    get domainInput(): string | undefined;
    private _duration?;
    get duration(): string;
    set duration(value: string);
    resetDuration(): void;
    get durationInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _expirationDate?;
    get expirationDate(): string;
    set expirationDate(value: string);
    resetExpirationDate(): void;
    get expirationDateInput(): string | undefined;
    private _expires?;
    get expires(): string;
    set expires(value: string);
    resetExpires(): void;
    get expiresInput(): string | undefined;
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _httpOnly?;
    get httpOnly(): boolean | cdktf.IResolvable;
    set httpOnly(value: boolean | cdktf.IResolvable);
    resetHttpOnly(): void;
    get httpOnlyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
    private _sameSite?;
    get sameSite(): string;
    set sameSite(value: string);
    resetSameSite(): void;
    get sameSiteInput(): string | undefined;
    private _secure?;
    get secure(): boolean | cdktf.IResolvable;
    set secure(value: boolean | cdktf.IResolvable);
    resetSecure(): void;
    get secureInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies a fixed maximum size of non-HTML content to cache.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
    */
    readonly maximumSize?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumSize?;
    get maximumSize(): string;
    set maximumSize(value: string);
    resetMaximumSize(): void;
    get maximumSizeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the name of the HTTP header in which to report the cache status value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
    */
    readonly responseHeaderName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _responseHeaderName?;
    get responseHeaderName(): string;
    set responseHeaderName(value: string);
    resetResponseHeaderName(): void;
    get responseHeaderNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl {
    /**
    * The action to perform on the path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * When enabled, retains the original path's query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
    */
    readonly keepQueryString?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When `behavior` is `REMOVE` or `REPLACE`, specifies the part of the incoming path you'd like to remove or modify.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
    */
    readonly match?: string;
    /**
    * When enabled, replaces all potential matches rather than only the first.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
    */
    readonly matchMultiple?: boolean | cdktf.IResolvable;
    /**
    * When `behavior` is set to `REGEX_REPLACE`, specifies the Perl-compatible regular expression to replace with `targetRegex`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
    */
    readonly matchRegex?: string;
    /**
    * When `behavior` is set to `REPLACE`, this path replaces whatever the `match` field matches in the incoming request's path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
    */
    readonly targetPath?: string;
    /**
    * When `behavior` is set to `PREPEND`, specifies a path to prepend to the incoming request's URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
    */
    readonly targetPathPrepend?: string;
    /**
    * When `behavior` is set to `REGEX_REPLACE`, this replaces whatever the `matchRegex` field matches, along with any captured sequences from `\$1` through `\$9`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
    */
    readonly targetRegex?: string;
    /**
    * When `behavior` is set to `REWRITE`, specifies the full path to request from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
    */
    readonly targetUrl?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _keepQueryString?;
    get keepQueryString(): boolean | cdktf.IResolvable;
    set keepQueryString(value: boolean | cdktf.IResolvable);
    resetKeepQueryString(): void;
    get keepQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _match?;
    get match(): string;
    set match(value: string);
    resetMatch(): void;
    get matchInput(): string | undefined;
    private _matchMultiple?;
    get matchMultiple(): boolean | cdktf.IResolvable;
    set matchMultiple(value: boolean | cdktf.IResolvable);
    resetMatchMultiple(): void;
    get matchMultipleInput(): boolean | cdktf.IResolvable | undefined;
    private _matchRegex?;
    get matchRegex(): string;
    set matchRegex(value: string);
    resetMatchRegex(): void;
    get matchRegexInput(): string | undefined;
    private _targetPath?;
    get targetPath(): string;
    set targetPath(value: string);
    resetTargetPath(): void;
    get targetPathInput(): string | undefined;
    private _targetPathPrepend?;
    get targetPathPrepend(): string;
    set targetPathPrepend(value: string);
    resetTargetPathPrepend(): void;
    get targetPathPrependInput(): string | undefined;
    private _targetRegex?;
    get targetRegex(): string;
    set targetRegex(value: string);
    resetTargetRegex(): void;
    get targetRegexInput(): string | undefined;
    private _targetUrl?;
    get targetUrl(): string;
    set targetUrl(value: string);
    resetTargetUrl(): void;
    get targetUrlInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
    */
    readonly rumGroupName?: string;
    /**
    * Specifies the percentage of web traffic to include in your RUM report.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
    */
    readonly rumSampleRate?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomOutputReference | DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _rumGroupName?;
    get rumGroupName(): string;
    set rumGroupName(value: string);
    resetRumGroupName(): void;
    get rumGroupNameInput(): string | undefined;
    private _rumSampleRate?;
    get rumSampleRate(): number;
    set rumSampleRate(value: number);
    resetRumSampleRate(): void;
    get rumSampleRateInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
