import * as cdktf from 'cdktf';
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId {
    /**
    * Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
    */
    readonly elements?: string[];
    /**
    * Includes the value of the specified elements in the cache ID. Otherwise only their names are included.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
    */
    readonly includeValue?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
    */
    readonly optional?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to modify the cache ID.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
    */
    readonly rule?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the name of the variable you want to include in the cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
    */
    readonly variableName?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId | undefined);
    private _elements?;
    get elements(): string[];
    set elements(value: string[]);
    resetElements(): void;
    get elementsInput(): string[] | undefined;
    private _includeValue?;
    get includeValue(): boolean | cdktf.IResolvable;
    set includeValue(value: boolean | cdktf.IResolvable);
    resetIncludeValue(): void;
    get includeValueInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _optional?;
    get optional(): boolean | cdktf.IResolvable;
    set optional(value: boolean | cdktf.IResolvable);
    resetOptional(): void;
    get optionalInput(): boolean | cdktf.IResolvable | undefined;
    private _rule?;
    get rule(): string;
    set rule(value: string);
    resetRule(): void;
    get ruleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _variableName?;
    get variableName(): string;
    set variableName(value: string);
    resetVariableName(): void;
    get variableNameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase {
    /**
    * Ignores case when forming cache keys.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams {
    /**
    * Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is `not` reflected in the cached object.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * When enabled, `parameters` needs to match exactly. Keep disabled to match string prefixes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
    */
    readonly exactMatch?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
    */
    readonly parameters?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _exactMatch?;
    get exactMatch(): boolean | cdktf.IResolvable;
    set exactMatch(value: boolean | cdktf.IResolvable);
    resetExactMatch(): void;
    get exactMatchInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _parameters?;
    get parameters(): string[];
    set parameters(value: string[]);
    resetParameters(): void;
    get parametersInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the new cache key path as an alphanumeric value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
    */
    readonly purgeKey?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _purgeKey?;
    get purgeKey(): string;
    set purgeKey(value: string);
    resetPurgeKey(): void;
    get purgeKeyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost {
    /**
    * Enables caching of POST responses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Define how and whether to use the POST message body as a cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
    */
    readonly useBody?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useBody?;
    get useBody(): string;
    set useBody(value: string);
    resetUseBody(): void;
    get useBodyInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect {
    /**
    * Enables the redirect caching behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ```[!#$%'+./^_`|~-]```
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
    */
    readonly tag?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _tag?;
    get tag(): string;
    set tag(value: string);
    resetTag(): void;
    get tagInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible {
    /**
    * Specifies when to include the `Edge-Cache-Tag` in responses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching {
    /**
    * Specify the caching option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
    */
    readonly cacheControlDirectives?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
    */
    readonly cacheabilitySettings?: string;
    /**
    * Set the `MAX_AGE` header for the cached content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
    */
    readonly defaultTtl?: string;
    /**
    * This enables honoring particular `Cache-Control` header directives from the origin. Supports all official `RFC 7234` directives except for `no-transform`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
    */
    readonly enhancedRfcSupport?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
    */
    readonly expirationSettings?: string;
    /**
    * This instructs edge servers to cache the object for a length of time set by the `max-age` directive in the response. When present in the origin response, this directive takes precedence over the `max-age` directive and the `defaultTtl` setting.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
    */
    readonly honorMaxAge?: boolean | cdktf.IResolvable;
    /**
    * This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
    */
    readonly honorMustRevalidate?: boolean | cdktf.IResolvable;
    /**
    * With the `no-cache` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live `ttl` to zero seconds.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
    */
    readonly honorNoCache?: boolean | cdktf.IResolvable;
    /**
    * Instructs edge servers not to cache the response when the origin response includes the `no-store` directive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
    */
    readonly honorNoStore?: boolean | cdktf.IResolvable;
    /**
    * Instructs edge servers not to cache the response when the origin response includes the `private` directive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
    */
    readonly honorPrivate?: boolean | cdktf.IResolvable;
    /**
    * With the `proxy-revalidate` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
    */
    readonly honorProxyRevalidate?: boolean | cdktf.IResolvable;
    /**
    * Instructs edge servers to cache the object for a length of time set by the `s-maxage` directive in the response. When present in the origin response, this directive takes precedence over the `max-age` directive and the `defaultTtl` setting.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
    */
    readonly honorSMaxage?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
    */
    readonly mustRevalidate?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
    */
    readonly revalidationSettings?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * The maximum time content may remain cached. Setting the value to `0` is the same as setting a `no-cache` header, which forces content to revalidate.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
    */
    readonly ttl?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _cacheControlDirectives?;
    get cacheControlDirectives(): string;
    set cacheControlDirectives(value: string);
    resetCacheControlDirectives(): void;
    get cacheControlDirectivesInput(): string | undefined;
    private _cacheabilitySettings?;
    get cacheabilitySettings(): string;
    set cacheabilitySettings(value: string);
    resetCacheabilitySettings(): void;
    get cacheabilitySettingsInput(): string | undefined;
    private _defaultTtl?;
    get defaultTtl(): string;
    set defaultTtl(value: string);
    resetDefaultTtl(): void;
    get defaultTtlInput(): string | undefined;
    private _enhancedRfcSupport?;
    get enhancedRfcSupport(): boolean | cdktf.IResolvable;
    set enhancedRfcSupport(value: boolean | cdktf.IResolvable);
    resetEnhancedRfcSupport(): void;
    get enhancedRfcSupportInput(): boolean | cdktf.IResolvable | undefined;
    private _expirationSettings?;
    get expirationSettings(): string;
    set expirationSettings(value: string);
    resetExpirationSettings(): void;
    get expirationSettingsInput(): string | undefined;
    private _honorMaxAge?;
    get honorMaxAge(): boolean | cdktf.IResolvable;
    set honorMaxAge(value: boolean | cdktf.IResolvable);
    resetHonorMaxAge(): void;
    get honorMaxAgeInput(): boolean | cdktf.IResolvable | undefined;
    private _honorMustRevalidate?;
    get honorMustRevalidate(): boolean | cdktf.IResolvable;
    set honorMustRevalidate(value: boolean | cdktf.IResolvable);
    resetHonorMustRevalidate(): void;
    get honorMustRevalidateInput(): boolean | cdktf.IResolvable | undefined;
    private _honorNoCache?;
    get honorNoCache(): boolean | cdktf.IResolvable;
    set honorNoCache(value: boolean | cdktf.IResolvable);
    resetHonorNoCache(): void;
    get honorNoCacheInput(): boolean | cdktf.IResolvable | undefined;
    private _honorNoStore?;
    get honorNoStore(): boolean | cdktf.IResolvable;
    set honorNoStore(value: boolean | cdktf.IResolvable);
    resetHonorNoStore(): void;
    get honorNoStoreInput(): boolean | cdktf.IResolvable | undefined;
    private _honorPrivate?;
    get honorPrivate(): boolean | cdktf.IResolvable;
    set honorPrivate(value: boolean | cdktf.IResolvable);
    resetHonorPrivate(): void;
    get honorPrivateInput(): boolean | cdktf.IResolvable | undefined;
    private _honorProxyRevalidate?;
    get honorProxyRevalidate(): boolean | cdktf.IResolvable;
    set honorProxyRevalidate(value: boolean | cdktf.IResolvable);
    resetHonorProxyRevalidate(): void;
    get honorProxyRevalidateInput(): boolean | cdktf.IResolvable | undefined;
    private _honorSMaxage?;
    get honorSMaxage(): boolean | cdktf.IResolvable;
    set honorSMaxage(value: boolean | cdktf.IResolvable);
    resetHonorSMaxage(): void;
    get honorSMaxageInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mustRevalidate?;
    get mustRevalidate(): boolean | cdktf.IResolvable;
    set mustRevalidate(value: boolean | cdktf.IResolvable);
    resetMustRevalidate(): void;
    get mustRevalidateInput(): boolean | cdktf.IResolvable | undefined;
    private _revalidationSettings?;
    get revalidationSettings(): string;
    set revalidationSettings(value: string);
    resetRevalidationSettings(): void;
    get revalidationSettingsInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _ttl?;
    get ttl(): string;
    set ttl(value: string);
    resetTtl(): void;
    get ttlInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization {
    /**
    * Enables the centralized authorization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects {
    /**
    * Allows edge servers to chase redirects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies, as a string, the maximum number of redirects to follow.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Once the redirect `limit` is reached, enabling this option serves an HTTP `404` (Not Found) error instead of the last redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
    */
    readonly serve404?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _limit?;
    get limit(): string;
    set limit(value: string);
    resetLimit(): void;
    get limitInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _serve404?;
    get serve404(): boolean | cdktf.IResolvable;
    set serve404(value: boolean | cdktf.IResolvable);
    resetServe404(): void;
    get serve404Input(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth {
    /**
    * Specify client certificate attributes to include in the `Client-To-Edge` authentication header that's sent to your origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
    */
    readonly clientCertificateAttributes?: string[];
    /**
    * Constructs the `Client-To-Edge` authentication header using information from the client to edge mTLS handshake and forwards it to your origin. You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Whether to include the current validation status of the client certificate in the `Client-To-Edge` authentication header. This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
    */
    readonly enableClientCertificateValidationStatus?: boolean | cdktf.IResolvable;
    /**
    * Whether to include the complete client certificate in the header, in its binary (DER) format. DER-formatted certificates leave out the `BEGIN CERTIFICATE/END CERTIFICATE` statements and most often use the `.der` extension. Alternatively, you can specify individual `clientCertificateAttributes` you want included in the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
    */
    readonly enableCompleteClientCertificate?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth | undefined);
    private _clientCertificateAttributes?;
    get clientCertificateAttributes(): string[];
    set clientCertificateAttributes(value: string[]);
    resetClientCertificateAttributes(): void;
    get clientCertificateAttributesInput(): string[] | undefined;
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _enableClientCertificateValidationStatus?;
    get enableClientCertificateValidationStatus(): boolean | cdktf.IResolvable;
    set enableClientCertificateValidationStatus(value: boolean | cdktf.IResolvable);
    resetEnableClientCertificateValidationStatus(): void;
    get enableClientCertificateValidationStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _enableCompleteClientCertificate?;
    get enableCompleteClientCertificate(): boolean | cdktf.IResolvable;
    set enableCompleteClientCertificate(value: boolean | cdktf.IResolvable);
    resetEnableCompleteClientCertificate(): void;
    get enableCompleteClientCertificateInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics {
    /**
    * Specifies the client request's geographic region.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
    */
    readonly country?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics | undefined);
    private _country?;
    get country(): string;
    set country(value: string);
    resetCountry(): void;
    get countryInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects {
    /**
    * Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
    */
    readonly cloudLocations?: string[];
    /**
    * Channels the traffic to maximize the egress discount at the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects | undefined);
    private _cloudLocations?;
    get cloudLocations(): string[];
    set cloudLocations(value: string[]);
    resetCloudLocations(): void;
    get cloudLocationsInput(): string[] | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper {
    /**
    * Enables Cloud Wrapper behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
    */
    readonly location?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced {
    /**
    * Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
    */
    readonly customFailoverMap?: string;
    /**
    * Enables failover for Cloud Wrapper.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
    */
    readonly failoverMap?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced | undefined);
    private _customFailoverMap?;
    get customFailoverMap(): string;
    set customFailoverMap(value: string);
    resetCustomFailoverMap(): void;
    get customFailoverMapInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverMap?;
    get failoverMap(): string;
    set failoverMap(value: string);
    resetFailoverMap(): void;
    get failoverMapInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData {
    /**
    * Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
    */
    readonly enableCmcdSegmentPrefetch?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData | undefined);
    private _enableCmcdSegmentPrefetch?;
    get enableCmcdSegmentPrefetch(): boolean | cdktf.IResolvable;
    set enableCmcdSegmentPrefetch(value: boolean | cdktf.IResolvable);
    resetEnableCmcdSegmentPrefetch(): void;
    get enableCmcdSegmentPrefetchInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
    */
    readonly originId?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse {
    /**
    * HTML response of up to 2000 characters to send to the end-user client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
    */
    readonly body?: string;
    /**
    * Serves the custom response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to `false`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
    */
    readonly forceEviction?: boolean | cdktf.IResolvable;
    /**
    * Whether to ignore the custom response when purging.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
    */
    readonly ignorePurge?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The HTTP response code to send to the end-user client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
    */
    readonly responseCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse | undefined);
    private _body?;
    get body(): string;
    set body(value: string);
    resetBody(): void;
    get bodyInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _forceEviction?;
    get forceEviction(): boolean | cdktf.IResolvable;
    set forceEviction(value: boolean | cdktf.IResolvable);
    resetForceEviction(): void;
    get forceEvictionInput(): boolean | cdktf.IResolvable | undefined;
    private _ignorePurge?;
    get ignorePurge(): boolean | cdktf.IResolvable;
    set ignorePurge(value: boolean | cdktf.IResolvable);
    resetIgnorePurge(): void;
    get ignorePurgeInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _responseCode?;
    get responseCode(): number;
    set responseCode(value: number);
    resetResponseCode(): void;
    get responseCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the type of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the size of the object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the quality of media content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Enable delivery of DASH media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
    */
    readonly dash?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HDS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
    */
    readonly hds?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HLS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
    */
    readonly hls?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
    */
    readonly segmentDurationDash?: string;
    /**
    * Customizes the number of seconds for the segment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
    */
    readonly segmentDurationDashCustom?: number;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
    */
    readonly segmentDurationHds?: string;
    /**
    * Customizes the number of seconds for the fragment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
    */
    readonly segmentDurationHdsCustom?: number;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
    */
    readonly segmentDurationHls?: string;
    /**
    * Customizes the number of seconds for the segment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
    */
    readonly segmentDurationHlsCustom?: number;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
    */
    readonly segmentDurationSmooth?: string;
    /**
    * Customizes the number of seconds for the fragment.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
    */
    readonly segmentDurationSmoothCustom?: number;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
    */
    readonly segmentSizeDash?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
    */
    readonly segmentSizeHds?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
    */
    readonly segmentSizeHls?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
    */
    readonly segmentSizeSmooth?: string;
    /**
    * Enable delivery of Smooth media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
    */
    readonly smooth?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _dash?;
    get dash(): boolean | cdktf.IResolvable;
    set dash(value: boolean | cdktf.IResolvable);
    resetDash(): void;
    get dashInput(): boolean | cdktf.IResolvable | undefined;
    private _hds?;
    get hds(): boolean | cdktf.IResolvable;
    set hds(value: boolean | cdktf.IResolvable);
    resetHds(): void;
    get hdsInput(): boolean | cdktf.IResolvable | undefined;
    private _hls?;
    get hls(): boolean | cdktf.IResolvable;
    set hls(value: boolean | cdktf.IResolvable);
    resetHls(): void;
    get hlsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _segmentDurationDash?;
    get segmentDurationDash(): string;
    set segmentDurationDash(value: string);
    resetSegmentDurationDash(): void;
    get segmentDurationDashInput(): string | undefined;
    private _segmentDurationDashCustom?;
    get segmentDurationDashCustom(): number;
    set segmentDurationDashCustom(value: number);
    resetSegmentDurationDashCustom(): void;
    get segmentDurationDashCustomInput(): number | undefined;
    private _segmentDurationHds?;
    get segmentDurationHds(): string;
    set segmentDurationHds(value: string);
    resetSegmentDurationHds(): void;
    get segmentDurationHdsInput(): string | undefined;
    private _segmentDurationHdsCustom?;
    get segmentDurationHdsCustom(): number;
    set segmentDurationHdsCustom(value: number);
    resetSegmentDurationHdsCustom(): void;
    get segmentDurationHdsCustomInput(): number | undefined;
    private _segmentDurationHls?;
    get segmentDurationHls(): string;
    set segmentDurationHls(value: string);
    resetSegmentDurationHls(): void;
    get segmentDurationHlsInput(): string | undefined;
    private _segmentDurationHlsCustom?;
    get segmentDurationHlsCustom(): number;
    set segmentDurationHlsCustom(value: number);
    resetSegmentDurationHlsCustom(): void;
    get segmentDurationHlsCustomInput(): number | undefined;
    private _segmentDurationSmooth?;
    get segmentDurationSmooth(): string;
    set segmentDurationSmooth(value: string);
    resetSegmentDurationSmooth(): void;
    get segmentDurationSmoothInput(): string | undefined;
    private _segmentDurationSmoothCustom?;
    get segmentDurationSmoothCustom(): number;
    set segmentDurationSmoothCustom(value: number);
    resetSegmentDurationSmoothCustom(): void;
    get segmentDurationSmoothCustomInput(): number | undefined;
    private _segmentSizeDash?;
    get segmentSizeDash(): string;
    set segmentSizeDash(value: string);
    resetSegmentSizeDash(): void;
    get segmentSizeDashInput(): string | undefined;
    private _segmentSizeHds?;
    get segmentSizeHds(): string;
    set segmentSizeHds(value: string);
    resetSegmentSizeHds(): void;
    get segmentSizeHdsInput(): string | undefined;
    private _segmentSizeHls?;
    get segmentSizeHls(): string;
    set segmentSizeHls(value: string);
    resetSegmentSizeHls(): void;
    get segmentSizeHlsInput(): string | undefined;
    private _segmentSizeSmooth?;
    get segmentSizeSmooth(): string;
    set segmentSizeSmooth(value: string);
    resetSegmentSizeSmooth(): void;
    get segmentSizeSmoothInput(): string | undefined;
    private _smooth?;
    get smooth(): boolean | cdktf.IResolvable;
    set smooth(value: boolean | cdktf.IResolvable);
    resetSmooth(): void;
    get smoothInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the type of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the size of the object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * Optimizes the delivery throughput and download times for large files.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
    */
    readonly optimizeOption?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _optimizeOption?;
    get optimizeOption(): boolean | cdktf.IResolvable;
    set optimizeOption(value: boolean | cdktf.IResolvable);
    resetOptimizeOption(): void;
    get optimizeOptionInput(): boolean | cdktf.IResolvable | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the type of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the size of the object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the quality of media content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Enable delivery of DASH media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
    */
    readonly dash?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HDS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
    */
    readonly hds?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HLS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
    */
    readonly hls?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
    */
    readonly segmentDurationDash?: string;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
    */
    readonly segmentDurationHds?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
    */
    readonly segmentDurationHls?: string;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
    */
    readonly segmentDurationSmooth?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
    */
    readonly segmentSizeDash?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
    */
    readonly segmentSizeHds?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
    */
    readonly segmentSizeHls?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
    */
    readonly segmentSizeSmooth?: string;
    /**
    * Enable delivery of Smooth media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
    */
    readonly smooth?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _dash?;
    get dash(): boolean | cdktf.IResolvable;
    set dash(value: boolean | cdktf.IResolvable);
    resetDash(): void;
    get dashInput(): boolean | cdktf.IResolvable | undefined;
    private _hds?;
    get hds(): boolean | cdktf.IResolvable;
    set hds(value: boolean | cdktf.IResolvable);
    resetHds(): void;
    get hdsInput(): boolean | cdktf.IResolvable | undefined;
    private _hls?;
    get hls(): boolean | cdktf.IResolvable;
    set hls(value: boolean | cdktf.IResolvable);
    resetHls(): void;
    get hlsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _segmentDurationDash?;
    get segmentDurationDash(): string;
    set segmentDurationDash(value: string);
    resetSegmentDurationDash(): void;
    get segmentDurationDashInput(): string | undefined;
    private _segmentDurationHds?;
    get segmentDurationHds(): string;
    set segmentDurationHds(value: string);
    resetSegmentDurationHds(): void;
    get segmentDurationHdsInput(): string | undefined;
    private _segmentDurationHls?;
    get segmentDurationHls(): string;
    set segmentDurationHls(value: string);
    resetSegmentDurationHls(): void;
    get segmentDurationHlsInput(): string | undefined;
    private _segmentDurationSmooth?;
    get segmentDurationSmooth(): string;
    set segmentDurationSmooth(value: string);
    resetSegmentDurationSmooth(): void;
    get segmentDurationSmoothInput(): string | undefined;
    private _segmentSizeDash?;
    get segmentSizeDash(): string;
    set segmentSizeDash(value: string);
    resetSegmentSizeDash(): void;
    get segmentSizeDashInput(): string | undefined;
    private _segmentSizeHds?;
    get segmentSizeHds(): string;
    set segmentSizeHds(value: string);
    resetSegmentSizeHds(): void;
    get segmentSizeHdsInput(): string | undefined;
    private _segmentSizeHls?;
    get segmentSizeHls(): string;
    set segmentSizeHls(value: string);
    resetSegmentSizeHls(): void;
    get segmentSizeHlsInput(): string | undefined;
    private _segmentSizeSmooth?;
    get segmentSizeSmooth(): string;
    set segmentSizeSmooth(value: string);
    resetSegmentSizeSmooth(): void;
    get segmentSizeSmoothInput(): string | undefined;
    private _smooth?;
    get smooth(): boolean | cdktf.IResolvable;
    set smooth(value: boolean | cdktf.IResolvable);
    resetSmooth(): void;
    get smoothInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod {
    /**
    * Optimize based on the total size of the content library delivered.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
    */
    readonly catalogSize?: string;
    /**
    * Optimize based on the quality of media content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
    */
    readonly contentType?: string;
    /**
    * Enable delivery of DASH media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
    */
    readonly dash?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HDS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
    */
    readonly hds?: boolean | cdktf.IResolvable;
    /**
    * Enable delivery of HLS media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
    */
    readonly hls?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimize based on the content's expected popularity.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
    */
    readonly popularityDistribution?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
    */
    readonly segmentDurationDash?: string;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
    */
    readonly segmentDurationHds?: string;
    /**
    * Specifies the duration of individual segments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
    */
    readonly segmentDurationHls?: string;
    /**
    * Specifies the duration of individual fragments.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
    */
    readonly segmentDurationSmooth?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
    */
    readonly segmentSizeDash?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
    */
    readonly segmentSizeHds?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
    */
    readonly segmentSizeHls?: string;
    /**
    * Specifies the size of the media object retrieved from the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
    */
    readonly segmentSizeSmooth?: string;
    /**
    * Enable delivery of Smooth media.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
    */
    readonly smooth?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod | undefined);
    private _catalogSize?;
    get catalogSize(): string;
    set catalogSize(value: string);
    resetCatalogSize(): void;
    get catalogSizeInput(): string | undefined;
    private _contentType?;
    get contentType(): string;
    set contentType(value: string);
    resetContentType(): void;
    get contentTypeInput(): string | undefined;
    private _dash?;
    get dash(): boolean | cdktf.IResolvable;
    set dash(value: boolean | cdktf.IResolvable);
    resetDash(): void;
    get dashInput(): boolean | cdktf.IResolvable | undefined;
    private _hds?;
    get hds(): boolean | cdktf.IResolvable;
    set hds(value: boolean | cdktf.IResolvable);
    resetHds(): void;
    get hdsInput(): boolean | cdktf.IResolvable | undefined;
    private _hls?;
    get hls(): boolean | cdktf.IResolvable;
    set hls(value: boolean | cdktf.IResolvable);
    resetHls(): void;
    get hlsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _popularityDistribution?;
    get popularityDistribution(): string;
    set popularityDistribution(value: string);
    resetPopularityDistribution(): void;
    get popularityDistributionInput(): string | undefined;
    private _segmentDurationDash?;
    get segmentDurationDash(): string;
    set segmentDurationDash(value: string);
    resetSegmentDurationDash(): void;
    get segmentDurationDashInput(): string | undefined;
    private _segmentDurationHds?;
    get segmentDurationHds(): string;
    set segmentDurationHds(value: string);
    resetSegmentDurationHds(): void;
    get segmentDurationHdsInput(): string | undefined;
    private _segmentDurationHls?;
    get segmentDurationHls(): string;
    set segmentDurationHls(value: string);
    resetSegmentDurationHls(): void;
    get segmentDurationHlsInput(): string | undefined;
    private _segmentDurationSmooth?;
    get segmentDurationSmooth(): string;
    set segmentDurationSmooth(value: string);
    resetSegmentDurationSmooth(): void;
    get segmentDurationSmoothInput(): string | undefined;
    private _segmentSizeDash?;
    get segmentSizeDash(): string;
    set segmentSizeDash(value: string);
    resetSegmentSizeDash(): void;
    get segmentSizeDashInput(): string | undefined;
    private _segmentSizeHds?;
    get segmentSizeHds(): string;
    set segmentSizeHds(value: string);
    resetSegmentSizeHds(): void;
    get segmentSizeHdsInput(): string | undefined;
    private _segmentSizeHls?;
    get segmentSizeHls(): string;
    set segmentSizeHls(value: string);
    resetSegmentSizeHls(): void;
    get segmentSizeHlsInput(): string | undefined;
    private _segmentSizeSmooth?;
    get segmentSizeSmooth(): string;
    set segmentSizeSmooth(value: string);
    resetSegmentSizeSmooth(): void;
    get segmentSizeSmoothInput(): string | undefined;
    private _smooth?;
    get smooth(): boolean | cdktf.IResolvable;
    set smooth(value: boolean | cdktf.IResolvable);
    resetSmooth(): void;
    get smoothInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition {
    /**
    * Enables the Content PrePosition behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}
    */
    readonly firstLocation?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}
    */
    readonly secondLocation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}
    */
    readonly sourceType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}
    */
    readonly targets?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _firstLocation?;
    get firstLocation(): string;
    set firstLocation(value: string);
    resetFirstLocation(): void;
    get firstLocationInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _secondLocation?;
    get secondLocation(): string;
    set secondLocation(value: string);
    resetSecondLocation(): void;
    get secondLocationInput(): string | undefined;
    private _sourceType?;
    get sourceType(): string;
    set sourceType(value: string);
    resetSourceType(): void;
    get sourceTypeInput(): string | undefined;
    private _targets?;
    get targets(): string;
    set targets(value: string);
    resetTargets(): void;
    get targetsInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection {
    /**
    * Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See `EdgeScape Data Codes` for a list.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
    */
    readonly countries?: string[];
    /**
    * Specifies the set of Designated Market Area codes from which to allow or deny traffic.  See `EdgeScape Data Codes` for a list.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
    */
    readonly dmas?: string[];
    /**
    * When enabled, verifies IP addresses are unique to specific geographic regions.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
    */
    readonly enableGeoProtection?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects denied requests rather than responding with an error code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
    */
    readonly enableGeoRedirectOnDeny?: boolean | cdktf.IResolvable;
    /**
    * Allows you to control access to your content from specific sets of IP addresses and CIDR blocks.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
    */
    readonly enableIpProtection?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects denied requests rather than responding with an error code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
    */
    readonly enableIpRedirectOnDeny?: boolean | cdktf.IResolvable;
    /**
    * Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
    */
    readonly enableReferrerProtection?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects denied requests rather than responding with an error code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
    */
    readonly enableReferrerRedirectOnDeny?: boolean | cdktf.IResolvable;
    /**
    * Enables the Content Targeting feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to handle requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
    */
    readonly geoProtectionMode?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
    */
    readonly geoProtectionTitle?: string;
    /**
    * This specifies the full URL to the redirect page for denied requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
    */
    readonly geoRedirectUrl?: string;
    /**
    * Specify a set of IP addresses or CIDR blocks to allow or deny.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
    */
    readonly ipAddresses?: string[];
    /**
    * Specifies how to handle requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
    */
    readonly ipProtectionMode?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
    */
    readonly ipProtectionTitle?: string;
    /**
    * This specifies the full URL to the redirect page for denied requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
    */
    readonly ipRedirectUrl?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
    */
    readonly overrideIpAddresses?: string[];
    /**
    * Specifies the set of domains from which to allow or deny traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
    */
    readonly referrerDomains?: string[];
    /**
    * Specify the action to take.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
    */
    readonly referrerProtectionMode?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
    */
    readonly referrerProtectionTitle?: string;
    /**
    * This specifies the full URL to the redirect page for denied requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
    */
    readonly referrerRedirectUrl?: string;
    /**
    * Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See `EdgeScape Data Codes` for a list.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
    */
    readonly regions?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection | undefined);
    private _countries?;
    get countries(): string[];
    set countries(value: string[]);
    resetCountries(): void;
    get countriesInput(): string[] | undefined;
    private _dmas?;
    get dmas(): string[];
    set dmas(value: string[]);
    resetDmas(): void;
    get dmasInput(): string[] | undefined;
    private _enableGeoProtection?;
    get enableGeoProtection(): boolean | cdktf.IResolvable;
    set enableGeoProtection(value: boolean | cdktf.IResolvable);
    resetEnableGeoProtection(): void;
    get enableGeoProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableGeoRedirectOnDeny?;
    get enableGeoRedirectOnDeny(): boolean | cdktf.IResolvable;
    set enableGeoRedirectOnDeny(value: boolean | cdktf.IResolvable);
    resetEnableGeoRedirectOnDeny(): void;
    get enableGeoRedirectOnDenyInput(): boolean | cdktf.IResolvable | undefined;
    private _enableIpProtection?;
    get enableIpProtection(): boolean | cdktf.IResolvable;
    set enableIpProtection(value: boolean | cdktf.IResolvable);
    resetEnableIpProtection(): void;
    get enableIpProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableIpRedirectOnDeny?;
    get enableIpRedirectOnDeny(): boolean | cdktf.IResolvable;
    set enableIpRedirectOnDeny(value: boolean | cdktf.IResolvable);
    resetEnableIpRedirectOnDeny(): void;
    get enableIpRedirectOnDenyInput(): boolean | cdktf.IResolvable | undefined;
    private _enableReferrerProtection?;
    get enableReferrerProtection(): boolean | cdktf.IResolvable;
    set enableReferrerProtection(value: boolean | cdktf.IResolvable);
    resetEnableReferrerProtection(): void;
    get enableReferrerProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableReferrerRedirectOnDeny?;
    get enableReferrerRedirectOnDeny(): boolean | cdktf.IResolvable;
    set enableReferrerRedirectOnDeny(value: boolean | cdktf.IResolvable);
    resetEnableReferrerRedirectOnDeny(): void;
    get enableReferrerRedirectOnDenyInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _geoProtectionMode?;
    get geoProtectionMode(): string;
    set geoProtectionMode(value: string);
    resetGeoProtectionMode(): void;
    get geoProtectionModeInput(): string | undefined;
    private _geoProtectionTitle?;
    get geoProtectionTitle(): string;
    set geoProtectionTitle(value: string);
    resetGeoProtectionTitle(): void;
    get geoProtectionTitleInput(): string | undefined;
    private _geoRedirectUrl?;
    get geoRedirectUrl(): string;
    set geoRedirectUrl(value: string);
    resetGeoRedirectUrl(): void;
    get geoRedirectUrlInput(): string | undefined;
    private _ipAddresses?;
    get ipAddresses(): string[];
    set ipAddresses(value: string[]);
    resetIpAddresses(): void;
    get ipAddressesInput(): string[] | undefined;
    private _ipProtectionMode?;
    get ipProtectionMode(): string;
    set ipProtectionMode(value: string);
    resetIpProtectionMode(): void;
    get ipProtectionModeInput(): string | undefined;
    private _ipProtectionTitle?;
    get ipProtectionTitle(): string;
    set ipProtectionTitle(value: string);
    resetIpProtectionTitle(): void;
    get ipProtectionTitleInput(): string | undefined;
    private _ipRedirectUrl?;
    get ipRedirectUrl(): string;
    set ipRedirectUrl(value: string);
    resetIpRedirectUrl(): void;
    get ipRedirectUrlInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideIpAddresses?;
    get overrideIpAddresses(): string[];
    set overrideIpAddresses(value: string[]);
    resetOverrideIpAddresses(): void;
    get overrideIpAddressesInput(): string[] | undefined;
    private _referrerDomains?;
    get referrerDomains(): string[];
    set referrerDomains(value: string[]);
    resetReferrerDomains(): void;
    get referrerDomainsInput(): string[] | undefined;
    private _referrerProtectionMode?;
    get referrerProtectionMode(): string;
    set referrerProtectionMode(value: string);
    resetReferrerProtectionMode(): void;
    get referrerProtectionModeInput(): string | undefined;
    private _referrerProtectionTitle?;
    get referrerProtectionTitle(): string;
    set referrerProtectionTitle(value: string);
    resetReferrerProtectionTitle(): void;
    get referrerProtectionTitleInput(): string | undefined;
    private _referrerRedirectUrl?;
    get referrerRedirectUrl(): string;
    set referrerRedirectUrl(value: string);
    resetReferrerRedirectUrl(): void;
    get referrerRedirectUrlInput(): string | undefined;
    private _regions?;
    get regions(): string[];
    set regions(value: string[]);
    resetRegions(): void;
    get regionsInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport {
    /**
    * Accepts requests made using credentials, like cookies or TLS client certificates.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
    */
    readonly allowCredentials?: boolean | cdktf.IResolvable;
    /**
    * In responses to preflight requests, defines which headers to allow when making the actual request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
    */
    readonly allowHeaders?: string;
    /**
    * In responses to preflight requests, sets which origin hostnames to accept requests from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
    */
    readonly allowOrigins?: string;
    /**
    * Enables CORS feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: `Cache-Control`, `Content-Language`, `Content-Type`, `Expires`, `Last-Modified`, and `Pragma`. You can add other header names to make them accessible to clients.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
    */
    readonly exposeHeaders?: string[];
    /**
    * Defines the supported request headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
    */
    readonly headers?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies any combination of the following methods: `DELETE`, `GET`, `PATCH`, `POST`, and `PUT` that are allowed when accessing the resource from an external domain.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
    */
    readonly methods?: string[];
    /**
    * Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with `http` or `https`. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
    */
    readonly origins?: string[];
    /**
    * Defines the number of seconds that the browser should cache the response to a preflight request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
    */
    readonly preflightMaxAge?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport | undefined);
    private _allowCredentials?;
    get allowCredentials(): boolean | cdktf.IResolvable;
    set allowCredentials(value: boolean | cdktf.IResolvable);
    resetAllowCredentials(): void;
    get allowCredentialsInput(): boolean | cdktf.IResolvable | undefined;
    private _allowHeaders?;
    get allowHeaders(): string;
    set allowHeaders(value: string);
    resetAllowHeaders(): void;
    get allowHeadersInput(): string | undefined;
    private _allowOrigins?;
    get allowOrigins(): string;
    set allowOrigins(value: string);
    resetAllowOrigins(): void;
    get allowOriginsInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _exposeHeaders?;
    get exposeHeaders(): string[];
    set exposeHeaders(value: string[]);
    resetExposeHeaders(): void;
    get exposeHeadersInput(): string[] | undefined;
    private _headers?;
    get headers(): string[];
    set headers(value: string[]);
    resetHeaders(): void;
    get headersInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _methods?;
    get methods(): string[];
    set methods(value: string[]);
    resetMethods(): void;
    get methodsInput(): string[] | undefined;
    private _origins?;
    get origins(): string[];
    set origins(value: string[]);
    resetOrigins(): void;
    get originsInput(): string[] | undefined;
    private _preflightMaxAge?;
    get preflightMaxAge(): string;
    set preflightMaxAge(value: string);
    resetPreflightMaxAge(): void;
    get preflightMaxAgeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * value block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value;
    get value(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference;
    putValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue): void;
    resetValue(): void;
    get valueInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior {
    /**
    * The unique identifier for the predefined custom behavior you want to insert into the current rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
    */
    readonly behaviorId?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior | undefined);
    private _behaviorId?;
    get behaviorId(): string;
    set behaviorId(value: string);
    resetBehaviorId(): void;
    get behaviorIdInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
    */
    readonly beaconStreamTitle?: string;
    /**
    * If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
    */
    readonly collectMidgressTraffic?: boolean | cdktf.IResolvable;
    /**
    * A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
    */
    readonly datastreamIds?: string;
    /**
    * Enables DataStream reporting.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables log collection for the property by associating it with DataStream configurations.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
    */
    readonly logEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the `List streams` operation to get stream IDs.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
    */
    readonly logStreamName?: string[];
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
    */
    readonly logStreamTitle?: string;
    /**
    * Specifies the percentage of log data you want to collect for this property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
    */
    readonly samplingPercentage?: number;
    /**
    * Specify the DataStream type.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
    */
    readonly streamType?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream | undefined);
    private _beaconStreamTitle?;
    get beaconStreamTitle(): string;
    set beaconStreamTitle(value: string);
    resetBeaconStreamTitle(): void;
    get beaconStreamTitleInput(): string | undefined;
    private _collectMidgressTraffic?;
    get collectMidgressTraffic(): boolean | cdktf.IResolvable;
    set collectMidgressTraffic(value: boolean | cdktf.IResolvable);
    resetCollectMidgressTraffic(): void;
    get collectMidgressTrafficInput(): boolean | cdktf.IResolvable | undefined;
    private _datastreamIds?;
    get datastreamIds(): string;
    set datastreamIds(value: string);
    resetDatastreamIds(): void;
    get datastreamIdsInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _logEnabled?;
    get logEnabled(): boolean | cdktf.IResolvable;
    set logEnabled(value: boolean | cdktf.IResolvable);
    resetLogEnabled(): void;
    get logEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _logStreamName?;
    get logStreamName(): string[];
    set logStreamName(value: string[]);
    resetLogStreamName(): void;
    get logStreamNameInput(): string[] | undefined;
    private _logStreamTitle?;
    get logStreamTitle(): string;
    set logStreamTitle(value: string);
    resetLogStreamTitle(): void;
    get logStreamTitleInput(): string | undefined;
    private _samplingPercentage?;
    get samplingPercentage(): number;
    set samplingPercentage(value: number);
    resetSamplingPercentage(): void;
    get samplingPercentageInput(): number | undefined;
    private _streamType?;
    get streamType(): string;
    set streamType(value: string);
    resetStreamType(): void;
    get streamTypeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp {
    /**
    * When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
    */
    readonly anonymous?: boolean | cdktf.IResolvable;
    /**
    * Enables IoT Edge Connect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * When enabled, you can publish and receive messages over a secured HTTP connection on port 443.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
    */
    readonly gwenabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as `topics`. This provides a root path for all topics defined within a namespace configuration.  You can use the `IoT Edge Connect API` to configure access control lists for your namespace configuration.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
    */
    readonly namespaceId?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When enabled, you can publish and receive messages over a secured MQTT connection on port 8883.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
    */
    readonly tlsenabled?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
    */
    readonly wsenabled?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp | undefined);
    private _anonymous?;
    get anonymous(): boolean | cdktf.IResolvable;
    set anonymous(value: boolean | cdktf.IResolvable);
    resetAnonymous(): void;
    get anonymousInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _gwenabled?;
    get gwenabled(): boolean | cdktf.IResolvable;
    set gwenabled(value: boolean | cdktf.IResolvable);
    resetGwenabled(): void;
    get gwenabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _namespaceId?;
    get namespaceId(): string;
    set namespaceId(value: string);
    resetNamespaceId(): void;
    get namespaceIdInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tlsenabled?;
    get tlsenabled(): boolean | cdktf.IResolvable;
    set tlsenabled(value: boolean | cdktf.IResolvable);
    resetTlsenabled(): void;
    get tlsenabledInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _wsenabled?;
    get wsenabled(): boolean | cdktf.IResolvable;
    set wsenabled(value: boolean | cdktf.IResolvable);
    resetWsenabled(): void;
    get wsenabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation {
    /**
    * Specifies the hash algorithm.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
    */
    readonly hashConversionAlgorithm?: string;
    /**
    * Specifies the key to generate the hash, ideally a long random string to ensure adequate security.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
    */
    readonly hashConversionKey?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation | undefined);
    private _hashConversionAlgorithm?;
    get hashConversionAlgorithm(): string;
    set hashConversionAlgorithm(value: string);
    resetHashConversionAlgorithm(): void;
    get hashConversionAlgorithmInput(): string | undefined;
    private _hashConversionKey?;
    get hashConversionKey(): string;
    set hashConversionKey(value: string);
    resetHashConversionKey(): void;
    get hashConversionKeyInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies a Perl-compatible regular expression with a single grouping to capture the text.  For example, a value of `^.(.{0,10})` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
    */
    readonly regexPattern?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _regexPattern?;
    get regexPattern(): string;
    set regexPattern(value: string);
    resetRegexPattern(): void;
    get regexPatternInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The zero-based index offset of the last character to extract, where `-1` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
    */
    readonly substringEnd?: string;
    /**
    * The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
    */
    readonly substringStart?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _substringEnd?;
    get substringEnd(): string;
    set substringEnd(value: string);
    resetSubstringEnd(): void;
    get substringEndInput(): string | undefined;
    private _substringStart?;
    get substringStart(): string;
    set substringStart(value: string);
    resetSubstringStart(): void;
    get substringStartInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor {
    /**
    * Specifies the field in the client certificate to extract the variable from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
    */
    readonly certificateField?: string;
    /**
    * Where to store the value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
    */
    readonly dcpMutualAuthProcessingVariableId?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor | undefined);
    private _certificateField?;
    get certificateField(): string;
    set certificateField(value: string);
    resetCertificateField(): void;
    get certificateFieldInput(): string | undefined;
    private _dcpMutualAuthProcessingVariableId?;
    get dcpMutualAuthProcessingVariableId(): string;
    set dcpMutualAuthProcessingVariableId(value: string);
    resetDcpMutualAuthProcessingVariableId(): void;
    get dcpMutualAuthProcessingVariableIdInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups {
    /**
    * Specifies the set of authorization groups to assign to all connecting devices.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
    */
    readonly groupNames?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups | undefined);
    private _groupNames?;
    get groupNames(): string[];
    set groupNames(value: string[]);
    resetGroupNames(): void;
    get groupNamesInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations {
    /**
    * Allows you to specify custom JWT server connection values.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
    */
    readonly customValues?: boolean | cdktf.IResolvable;
    /**
    * Enables the default JWT server and sets the authentication endpoint to a default path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the JWT server's hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
    */
    readonly path?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations | undefined);
    private _customValues?;
    get customValues(): boolean | cdktf.IResolvable;
    set customValues(value: boolean | cdktf.IResolvable);
    resetCustomValues(): void;
    get customValuesInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth {
    /**
    * Extracts a hostname from JWT.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
    */
    readonly extractHostname?: boolean | cdktf.IResolvable;
    /**
    * Extracts a jurisdiction that defines a geographically distributed set of servers from JWT.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
    */
    readonly extractJurisdiction?: boolean | cdktf.IResolvable;
    /**
    * Extracts a namespace from JSON web tokens (JWT).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
    */
    readonly extractNamespace?: boolean | cdktf.IResolvable;
    /**
    * Specifies the claim in JWT to extract the hostname from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
    */
    readonly hostnameClaim?: string;
    /**
    * Specifies the claim in JWT to extract the jurisdiction from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
    */
    readonly jurisdictionClaim?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the claim in JWT to extract the namespace from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
    */
    readonly namespaceClaim?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth | undefined);
    private _extractHostname?;
    get extractHostname(): boolean | cdktf.IResolvable;
    set extractHostname(value: boolean | cdktf.IResolvable);
    resetExtractHostname(): void;
    get extractHostnameInput(): boolean | cdktf.IResolvable | undefined;
    private _extractJurisdiction?;
    get extractJurisdiction(): boolean | cdktf.IResolvable;
    set extractJurisdiction(value: boolean | cdktf.IResolvable);
    resetExtractJurisdiction(): void;
    get extractJurisdictionInput(): boolean | cdktf.IResolvable | undefined;
    private _extractNamespace?;
    get extractNamespace(): boolean | cdktf.IResolvable;
    set extractNamespace(value: boolean | cdktf.IResolvable);
    resetExtractNamespace(): void;
    get extractNamespaceInput(): boolean | cdktf.IResolvable | undefined;
    private _hostnameClaim?;
    get hostnameClaim(): string;
    set hostnameClaim(value: string);
    resetHostnameClaim(): void;
    get hostnameClaimInput(): string | undefined;
    private _jurisdictionClaim?;
    get jurisdictionClaim(): string;
    set jurisdictionClaim(value: string);
    resetJurisdictionClaim(): void;
    get jurisdictionClaimInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _namespaceClaim?;
    get namespaceClaim(): string;
    set namespaceClaim(value: string);
    resetNamespaceClaim(): void;
    get namespaceClaimInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt {
    /**
    * Enables the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess {
    /**
    * Denies access when enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Text message that keys why access is denied. Any subsequent `denyAccess` behaviors within the rule tree may refer to the same `reason` key to override the current behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
    */
    readonly reason?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _reason?;
    get reason(): string;
    set reason(value: string);
    resetReason(): void;
    get reasonInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId {
    /**
    * Specifies a set of information about the device with which to generate a separate cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
    */
    readonly elements?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId | undefined);
    private _elements?;
    get elements(): string[];
    set elements(value: string[]);
    resetElements(): void;
    get elementsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader {
    /**
    * Specifies the set of information about the requesting device to send to the origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
    */
    readonly elements?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader | undefined);
    private _elements?;
    get elements(): string[];
    set elements(value: string[]);
    resetElements(): void;
    get elementsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh {
    /**
    * Allows edge servers to refresh an expired DNS record after serving content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Set the maximum allowed time an expired DNS record may be active.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh {
    /**
    * Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
    */
    readonly delay?: string;
    /**
    * Allows edge servers to refresh DNS records before they expire.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
    */
    readonly timeout?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh | undefined);
    private _delay?;
    get delay(): string;
    set delay(value: string);
    resetDelay(): void;
    get delayInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol {
    /**
    * Enables the protocol downgrading behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache {
    /**
    * Specify how the edge server calculates the downstream cache by setting the value of the `Expires` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
    */
    readonly allowBehavior?: string;
    /**
    * Specify the caching instructions the edge server sends to the end user's client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the HTTP headers to include in the response to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
    */
    readonly sendHeaders?: string;
    /**
    * Adds a `Cache-Control: private` header to prevent objects from being cached in a shared caching proxy.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
    */
    readonly sendPrivate?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Sets the duration of the cache. Setting the value to `0` equates to a `no-cache` header that forces revalidation.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
    */
    readonly ttl?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache | undefined);
    private _allowBehavior?;
    get allowBehavior(): string;
    set allowBehavior(value: string);
    resetAllowBehavior(): void;
    get allowBehaviorInput(): string | undefined;
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _sendHeaders?;
    get sendHeaders(): string;
    set sendHeaders(value: string);
    resetSendHeaders(): void;
    get sendHeadersInput(): string | undefined;
    private _sendPrivate?;
    get sendPrivate(): boolean | cdktf.IResolvable;
    set sendPrivate(value: boolean | cdktf.IResolvable);
    resetSendPrivate(): void;
    get sendPrivateInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _ttl?;
    get ttl(): string;
    set ttl(value: string);
    resetTtl(): void;
    get ttlInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization {
    /**
    * Enables the quick retry feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
    */
    readonly throughput?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _throughput?;
    get throughput(): string;
    set throughput(value: string);
    resetThroughput(): void;
    get throughputInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent {
    /**
    * Enables image compression for subcustomer content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
    */
    readonly imageCompression?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Allows subcustomer content to prefetch over HTTP/2.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
    */
    readonly prefetch?: boolean | cdktf.IResolvable;
    /**
    * Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the `realUserMonitoring` behavior for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
    */
    readonly realUserMonitoring?: boolean | cdktf.IResolvable;
    /**
    * Optimizes how subcustomer traffic routes from origin to edge servers.  See the `sureRoute` behavior for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
    */
    readonly sureRoute?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent | undefined);
    private _imageCompression?;
    get imageCompression(): boolean | cdktf.IResolvable;
    set imageCompression(value: boolean | cdktf.IResolvable);
    resetImageCompression(): void;
    get imageCompressionInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetch?;
    get prefetch(): boolean | cdktf.IResolvable;
    set prefetch(value: boolean | cdktf.IResolvable);
    resetPrefetch(): void;
    get prefetchInput(): boolean | cdktf.IResolvable | undefined;
    private _realUserMonitoring?;
    get realUserMonitoring(): boolean | cdktf.IResolvable;
    set realUserMonitoring(value: boolean | cdktf.IResolvable);
    resetRealUserMonitoring(): void;
    get realUserMonitoringInput(): boolean | cdktf.IResolvable | undefined;
    private _sureRoute?;
    get sureRoute(): boolean | cdktf.IResolvable;
    set sureRoute(value: boolean | cdktf.IResolvable);
    resetSureRoute(): void;
    get sureRouteInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload {
    /**
    * Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: `<hostname>/bulk/<database_name>/<dataset_name>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase {
    /**
    * Specifies a default database for this property. If you don't configure a default data set in the `ecmsDataset` behavior, requests to objects in this database follow the pattern: `<hostname>/datastore/<data_set_name>/<object_key>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
    */
    readonly database?: string;
    /**
    * Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
    */
    readonly extractLocation?: string;
    /**
    * Specifies the request header that passed the database name. By default, it points to `X-KV-Database`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the query string parameter that passed the database name. By default, it points to `database`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
    */
    readonly queryParameterName?: string;
    /**
    * Specifies the regular expression that matches the database name in the URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
    */
    readonly regexPattern?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _extractLocation?;
    get extractLocation(): string;
    set extractLocation(value: string);
    resetExtractLocation(): void;
    get extractLocationInput(): string | undefined;
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _queryParameterName?;
    get queryParameterName(): string;
    set queryParameterName(value: string);
    resetQueryParameterName(): void;
    get queryParameterNameInput(): string | undefined;
    private _regexPattern?;
    get regexPattern(): string;
    set regexPattern(value: string);
    resetRegexPattern(): void;
    get regexPatternInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset {
    /**
    * Specifies a default data set for this property. If you don't configure a default database in the `ecmsDatabase` behavior, requests to objects in this data set follow the pattern: `<hostname>/datastore/<database_name>/<object_key>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
    */
    readonly dataset?: string;
    /**
    * Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
    */
    readonly extractLocation?: string;
    /**
    * Specifies the request header that passed the data set name. By default, it points to `X-KV-Dataset`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the query string parameter that passed the data set name. By default, it points to `dataset`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
    */
    readonly queryParameterName?: string;
    /**
    * Specifies the regular expression that matches the data set name in the URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
    */
    readonly regexPattern?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset | undefined);
    private _dataset?;
    get dataset(): string;
    set dataset(value: string);
    resetDataset(): void;
    get datasetInput(): string | undefined;
    private _extractLocation?;
    get extractLocation(): string;
    set extractLocation(value: string);
    resetExtractLocation(): void;
    get extractLocationInput(): string | undefined;
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _queryParameterName?;
    get queryParameterName(): string;
    set queryParameterName(value: string);
    resetQueryParameterName(): void;
    get queryParameterNameInput(): string | undefined;
    private _regexPattern?;
    get regexPattern(): string;
    set regexPattern(value: string);
    resetRegexPattern(): void;
    get regexPatternInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables sending a compressed archive file with objects to the default path of the target data set: `<hostname>/bulk/<database_name>/<dataset_name>`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
    */
    readonly regex?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _regex?;
    get regex(): string;
    set regex(value: string);
    resetRegex(): void;
    get regexInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect {
    /**
    * Specifies the maximum number of lines to include in each log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
    */
    readonly aggregateLines?: string;
    /**
    * Specifies the log's maximum size.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
    */
    readonly aggregateSize?: string;
    /**
    * Specifies how often logs are generated.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
    */
    readonly aggregateTime?: string;
    /**
    * Describes the API connector type.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
    */
    readonly apiConnector?: string;
    /**
    * Specifies the data set to log.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
    */
    readonly apiDataElements?: string[];
    /**
    * Specifies the target hostname accepting push API requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
    */
    readonly destinationHostname?: string;
    /**
    * Specifies the push API's endpoint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
    */
    readonly destinationPath?: string;
    /**
    * Enables Cloud Monitor's log-publishing behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, overrides default log settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
    */
    readonly overrideAggregateSettings?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect | undefined);
    private _aggregateLines?;
    get aggregateLines(): string;
    set aggregateLines(value: string);
    resetAggregateLines(): void;
    get aggregateLinesInput(): string | undefined;
    private _aggregateSize?;
    get aggregateSize(): string;
    set aggregateSize(value: string);
    resetAggregateSize(): void;
    get aggregateSizeInput(): string | undefined;
    private _aggregateTime?;
    get aggregateTime(): string;
    set aggregateTime(value: string);
    resetAggregateTime(): void;
    get aggregateTimeInput(): string | undefined;
    private _apiConnector?;
    get apiConnector(): string;
    set apiConnector(value: string);
    resetApiConnector(): void;
    get apiConnectorInput(): string | undefined;
    private _apiDataElements?;
    get apiDataElements(): string[];
    set apiDataElements(value: string[]);
    resetApiDataElements(): void;
    get apiDataElementsInput(): string[] | undefined;
    private _destinationHostname?;
    get destinationHostname(): string;
    set destinationHostname(value: string);
    resetDestinationHostname(): void;
    get destinationHostnameInput(): string | undefined;
    private _destinationPath?;
    get destinationPath(): string;
    set destinationPath(value: string);
    resetDestinationPath(): void;
    get destinationPathInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideAggregateSettings?;
    get overrideAggregateSettings(): boolean | cdktf.IResolvable;
    set overrideAggregateSettings(value: boolean | cdktf.IResolvable);
    resetOverrideAggregateSettings(): void;
    get overrideAggregateSettingsInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced {
    /**
    * A description of what the `xml` block does.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * A block of Akamai XML metadata.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
    */
    readonly xml?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _xml?;
    get xml(): string;
    set xml(value: string);
    resetXml(): void;
    get xmlInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules {
    /**
    * When enabled, interprets the path specified by `context_root` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
    */
    readonly absolutePath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the path to use in the forwarding request, typically the root (`/`) when failing over to a different data center, or a full path such as `/static/error.html` when failing over to an error page.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
    */
    readonly contextRoot?: string;
    /**
    * The hostname of the data center to fail over to.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
    */
    readonly failoverHostname?: string;
    /**
    * Allows you to modify the request's hostname or path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
    */
    readonly modifyRequest?: boolean | cdktf.IResolvable;
    /**
    * Overrides the request's hostname with the `failover_hostname`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
    */
    readonly overrideHostname?: boolean | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules | cdktf.IResolvable | undefined);
    private _absolutePath?;
    get absolutePath(): boolean | cdktf.IResolvable;
    set absolutePath(value: boolean | cdktf.IResolvable);
    resetAbsolutePath(): void;
    get absolutePathInput(): boolean | cdktf.IResolvable | undefined;
    private _contextRoot?;
    get contextRoot(): string;
    set contextRoot(value: string);
    resetContextRoot(): void;
    get contextRootInput(): string | undefined;
    private _failoverHostname?;
    get failoverHostname(): string;
    set failoverHostname(value: string);
    resetFailoverHostname(): void;
    get failoverHostnameInput(): string | undefined;
    private _modifyRequest?;
    get modifyRequest(): boolean | cdktf.IResolvable;
    set modifyRequest(value: boolean | cdktf.IResolvable);
    resetModifyRequest(): void;
    get modifyRequestInput(): boolean | cdktf.IResolvable | undefined;
    private _overrideHostname?;
    get overrideHostname(): boolean | cdktf.IResolvable;
    set overrideHostname(value: boolean | cdktf.IResolvable);
    resetOverrideHostname(): void;
    get overrideHostnameInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter {
    /**
    * If using session persistence, this specifies the value of the cookie named in the corresponding `edgeLoadBalancingOrigin` behavior's `cookie_name` option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Provides a description for the ELB data center, for your own reference.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Allows you to specify failover rules.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
    */
    readonly enableFailover?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
    */
    readonly failoverTitle?: string;
    /**
    * Specifies the data center's hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies this data center's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
    */
    readonly ip?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Corresponds to the `id` specified by the `edgeLoadBalancingOrigin` behavior associated with this data center.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
    */
    readonly originId?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * failover_rules block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
    */
    readonly failoverRules?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _enableFailover?;
    get enableFailover(): boolean | cdktf.IResolvable;
    set enableFailover(value: boolean | cdktf.IResolvable);
    resetEnableFailover(): void;
    get enableFailoverInput(): boolean | cdktf.IResolvable | undefined;
    private _failoverTitle?;
    get failoverTitle(): string;
    set failoverTitle(value: string);
    resetFailoverTitle(): void;
    get failoverTitleInput(): string | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _ip?;
    get ip(): string;
    set ip(value: string);
    resetIp(): void;
    get ipInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _originId?;
    get originId(): string;
    set originId(value: string);
    resetOriginId(): void;
    get originIdInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _failoverRules;
    get failoverRules(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesList;
    putFailoverRules(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | cdktf.IResolvable): void;
    resetFailoverRules(): void;
    get failoverRulesInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules[] | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin {
    /**
    * This specifies the name of the cookie that marks users' persistent sessions. The accompanying `edgeLoadBalancingDataCenter` behavior's `description` option specifies the cookie's value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Provides a description for the ELB origin, for your own reference.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
    */
    readonly enableSessionPersistence?: boolean | cdktf.IResolvable;
    /**
    * Specifies the hostname associated with the ELB rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
    */
    readonly hostname?: string;
    /**
    * Specifies a unique descriptive string for this ELB origin. The value needs to match the `origin_id` specified by the `edgeLoadBalancingDataCenter` behavior associated with this origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
    */
    readonly sessionPersistenceTitle?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _enableSessionPersistence?;
    get enableSessionPersistence(): boolean | cdktf.IResolvable;
    set enableSessionPersistence(value: boolean | cdktf.IResolvable);
    resetEnableSessionPersistence(): void;
    get enableSessionPersistenceInput(): boolean | cdktf.IResolvable | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _sessionPersistenceTitle?;
    get sessionPersistenceTitle(): string;
    set sessionPersistenceTitle(value: string);
    resetSessionPersistenceTitle(): void;
    get sessionPersistenceTitleInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization {
    /**
    * Specifies the name of the cookie to use for authorization.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
    */
    readonly cookieName?: string;
    /**
    * Specify the cookie's domain, which needs to match the top-level domain of the `Host` header the origin server receives.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
    */
    readonly domain?: string;
    /**
    * Enables the cookie-authorization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Specifies the value of the authorization cookie.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
    */
    readonly value?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization | undefined);
    private _cookieName?;
    get cookieName(): string;
    set cookieName(value: string);
    resetCookieName(): void;
    get cookieNameInput(): string | undefined;
    private _domain?;
    get domain(): string;
    set domain(value: string);
    resetDomain(): void;
    get domainInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector {
    /**
    * Identifies the Cloudlet shared policy to use with this behavior. Use the `Cloudlets API` to list available shared policies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Edge Redirector Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape {
    /**
    * When enabled, sends the `X-Akamai-Edgescape` request header to the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes {
    /**
    * Denies attempts to inject ESI code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
    */
    readonly detectInjection?: boolean | cdktf.IResolvable;
    /**
    * Enable ESI only for content featuring the `Edge-control: dca=esi` HTTP response header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
    */
    readonly enableViaHttp?: boolean | cdktf.IResolvable;
    /**
    * Enables ESI processing.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the character sets to use when transcoding the ESI language, `UTF-8` and `ISO-8859-1` for example.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
    */
    readonly i18NCharset?: string[];
    /**
    * Provides internationalization support for ESI.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
    */
    readonly i18NStatus?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to pass the client IP header to the ESI processor.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
    */
    readonly passClientIp?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to pass your origin server's cookies to the ESI processor.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
    */
    readonly passSetCookie?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes | undefined);
    private _detectInjection?;
    get detectInjection(): boolean | cdktf.IResolvable;
    set detectInjection(value: boolean | cdktf.IResolvable);
    resetDetectInjection(): void;
    get detectInjectionInput(): boolean | cdktf.IResolvable | undefined;
    private _enableViaHttp?;
    get enableViaHttp(): boolean | cdktf.IResolvable;
    set enableViaHttp(value: boolean | cdktf.IResolvable);
    resetEnableViaHttp(): void;
    get enableViaHttpInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _i18NCharset?;
    get i18NCharset(): string[];
    set i18NCharset(value: string[]);
    resetI18NCharset(): void;
    get i18NCharsetInput(): string[] | undefined;
    private _i18NStatus?;
    get i18NStatus(): boolean | cdktf.IResolvable;
    set i18NStatus(value: boolean | cdktf.IResolvable);
    resetI18NStatus(): void;
    get i18NStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _passClientIp?;
    get passClientIp(): boolean | cdktf.IResolvable;
    set passClientIp(value: boolean | cdktf.IResolvable);
    resetPassClientIp(): void;
    get passClientIpInput(): boolean | cdktf.IResolvable | undefined;
    private _passSetCookie?;
    get passSetCookie(): boolean | cdktf.IResolvable;
    set passSetCookie(value: boolean | cdktf.IResolvable);
    resetPassSetCookie(): void;
    get passSetCookieInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
    */
    readonly createEdgeWorker?: string;
    /**
    * Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the `EdgeWorkers API` to get this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
    */
    readonly edgeWorkerId?: string;
    /**
    * When enabled, applies specified EdgeWorker functionality to this rule's web traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see `Integrate mPulse reports with EdgeWorkers`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
    */
    readonly mPulse?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
    */
    readonly mPulseInformation?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
    */
    readonly resourceTier?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker | undefined);
    private _createEdgeWorker?;
    get createEdgeWorker(): string;
    set createEdgeWorker(value: string);
    resetCreateEdgeWorker(): void;
    get createEdgeWorkerInput(): string | undefined;
    private _edgeWorkerId?;
    get edgeWorkerId(): string;
    set edgeWorkerId(value: string);
    resetEdgeWorkerId(): void;
    get edgeWorkerIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mPulse?;
    get mPulse(): boolean | cdktf.IResolvable;
    set mPulse(value: boolean | cdktf.IResolvable);
    resetMPulse(): void;
    get mPulseInput(): boolean | cdktf.IResolvable | undefined;
    private _mPulseInformation?;
    get mPulseInformation(): string;
    set mPulseInformation(value: string);
    resetMPulseInformation(): void;
    get mPulseInformationInput(): string | undefined;
    private _resourceTier?;
    get resourceTier(): string;
    set resourceTier(value: string);
    resetResourceTier(): void;
    get resourceTierInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings {
    /**
    * Specify the client certificate authority (CA) sets you want to support in client requests. Run the `List CA Sets` operation in the mTLS Edge TrustStore API to get the `setId` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the `Certificate Provisioning System`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
    */
    readonly certificateAuthoritySet?: string[];
    /**
    * Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
    */
    readonly enableAuthSet?: boolean | cdktf.IResolvable;
    /**
    * This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the `Client-To-Edge` authentication header, or issue a custom message.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
    */
    readonly enableDenyRequest?: boolean | cdktf.IResolvable;
    /**
    * Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
    */
    readonly enableOcspStatus?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings | undefined);
    private _certificateAuthoritySet?;
    get certificateAuthoritySet(): string[];
    set certificateAuthoritySet(value: string[]);
    resetCertificateAuthoritySet(): void;
    get certificateAuthoritySetInput(): string[] | undefined;
    private _enableAuthSet?;
    get enableAuthSet(): boolean | cdktf.IResolvable;
    set enableAuthSet(value: boolean | cdktf.IResolvable);
    resetEnableAuthSet(): void;
    get enableAuthSetInput(): boolean | cdktf.IResolvable | undefined;
    private _enableDenyRequest?;
    get enableDenyRequest(): boolean | cdktf.IResolvable;
    set enableDenyRequest(value: boolean | cdktf.IResolvable);
    resetEnableDenyRequest(): void;
    get enableDenyRequestInput(): boolean | cdktf.IResolvable | undefined;
    private _enableOcspStatus?;
    get enableOcspStatus(): boolean | cdktf.IResolvable;
    set enableOcspStatus(value: boolean | cdktf.IResolvable);
    resetEnableOcspStatus(): void;
    get enableOcspStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
    */
    readonly display?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol | undefined);
    private _display?;
    get display(): string;
    set display(value: string);
    resetDisplay(): void;
    get displayInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
    */
    readonly anonymousVpn?: string;
    /**
    * Specifies how to field the proxy request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
    */
    readonly bestPracticeAction?: string;
    /**
    * This specifies the URL to which to redirect requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
    */
    readonly bestPracticeRedirecturl?: string;
    /**
    * This enables detection of requests from anonymous VPNs.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
    */
    readonly detectAnonymousVpn?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to field anonymous VPN requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
    */
    readonly detectAnonymousVpnAction?: string;
    /**
    * This specifies the URL to which to redirect anonymous VPN requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
    */
    readonly detectAnonymousVpnRedirecturl?: string;
    /**
    * This detects requests from a hosting provider.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
    */
    readonly detectHostingProvider?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from hosting providers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
    */
    readonly detectHostingProviderAction?: string;
    /**
    * This specifies the absolute URL to which to redirect requests from hosting providers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
    */
    readonly detectHostingProviderRedirecturl?: string;
    /**
    * This enables detection of requests from public proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
    */
    readonly detectPublicProxy?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to field public proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
    */
    readonly detectPublicProxyAction?: string;
    /**
    * This specifies the URL to which to redirect public proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
    */
    readonly detectPublicProxyRedirecturl?: string;
    /**
    * This enables detection of requests from a residential proxy. See `Enhanced Proxy Detection with GeoGuard` and learn more about this GeoGuard category before enabling it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
    */
    readonly detectResidentialProxy?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from residential proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
    */
    readonly detectResidentialProxyAction?: string;
    /**
    * This specifies the URL to which to redirect requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
    */
    readonly detectResidentialProxyRedirecturl?: string;
    /**
    * This enables detection of requests from smart DNS proxies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
    */
    readonly detectSmartDnsProxy?: boolean | cdktf.IResolvable;
    /**
    * Specifies whether to `DENY`, `ALLOW`, or `REDIRECT` smart DNS proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
    */
    readonly detectSmartDnsProxyAction?: string;
    /**
    * This specifies the URL to which to redirect DNS proxy requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
    */
    readonly detectSmartDnsProxyRedirecturl?: string;
    /**
    * This enables detection of requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
    */
    readonly detectTorExitNode?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
    */
    readonly detectTorExitNodeAction?: string;
    /**
    * This specifies the URL to which to redirect requests from Tor exit nodes.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
    */
    readonly detectTorExitNodeRedirecturl?: string;
    /**
    * This enables detection of requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
    */
    readonly detectVpnDataCenter?: boolean | cdktf.IResolvable;
    /**
    * This specifies whether to `DENY`, `ALLOW`, or `REDIRECT` requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
    */
    readonly detectVpnDataCenterAction?: string;
    /**
    * This specifies the URL to which to redirect requests from VPN data centers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
    */
    readonly detectVpnDataCenterRedirecturl?: string;
    /**
    * Specifies how to field the proxy request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
    */
    readonly enableConfigurationMode?: string;
    /**
    * Applies GeoGuard proxy detection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the `epdForwardHeaderEnrichment` behavior for details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
    */
    readonly forwardHeaderEnrichment?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
    */
    readonly hostingProvider?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
    */
    readonly publicProxy?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
    */
    readonly residentialProxy?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
    */
    readonly smartDnsProxy?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
    */
    readonly torExitNode?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
    */
    readonly vpnDataCenter?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection | undefined);
    private _anonymousVpn?;
    get anonymousVpn(): string;
    set anonymousVpn(value: string);
    resetAnonymousVpn(): void;
    get anonymousVpnInput(): string | undefined;
    private _bestPracticeAction?;
    get bestPracticeAction(): string;
    set bestPracticeAction(value: string);
    resetBestPracticeAction(): void;
    get bestPracticeActionInput(): string | undefined;
    private _bestPracticeRedirecturl?;
    get bestPracticeRedirecturl(): string;
    set bestPracticeRedirecturl(value: string);
    resetBestPracticeRedirecturl(): void;
    get bestPracticeRedirecturlInput(): string | undefined;
    private _detectAnonymousVpn?;
    get detectAnonymousVpn(): boolean | cdktf.IResolvable;
    set detectAnonymousVpn(value: boolean | cdktf.IResolvable);
    resetDetectAnonymousVpn(): void;
    get detectAnonymousVpnInput(): boolean | cdktf.IResolvable | undefined;
    private _detectAnonymousVpnAction?;
    get detectAnonymousVpnAction(): string;
    set detectAnonymousVpnAction(value: string);
    resetDetectAnonymousVpnAction(): void;
    get detectAnonymousVpnActionInput(): string | undefined;
    private _detectAnonymousVpnRedirecturl?;
    get detectAnonymousVpnRedirecturl(): string;
    set detectAnonymousVpnRedirecturl(value: string);
    resetDetectAnonymousVpnRedirecturl(): void;
    get detectAnonymousVpnRedirecturlInput(): string | undefined;
    private _detectHostingProvider?;
    get detectHostingProvider(): boolean | cdktf.IResolvable;
    set detectHostingProvider(value: boolean | cdktf.IResolvable);
    resetDetectHostingProvider(): void;
    get detectHostingProviderInput(): boolean | cdktf.IResolvable | undefined;
    private _detectHostingProviderAction?;
    get detectHostingProviderAction(): string;
    set detectHostingProviderAction(value: string);
    resetDetectHostingProviderAction(): void;
    get detectHostingProviderActionInput(): string | undefined;
    private _detectHostingProviderRedirecturl?;
    get detectHostingProviderRedirecturl(): string;
    set detectHostingProviderRedirecturl(value: string);
    resetDetectHostingProviderRedirecturl(): void;
    get detectHostingProviderRedirecturlInput(): string | undefined;
    private _detectPublicProxy?;
    get detectPublicProxy(): boolean | cdktf.IResolvable;
    set detectPublicProxy(value: boolean | cdktf.IResolvable);
    resetDetectPublicProxy(): void;
    get detectPublicProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectPublicProxyAction?;
    get detectPublicProxyAction(): string;
    set detectPublicProxyAction(value: string);
    resetDetectPublicProxyAction(): void;
    get detectPublicProxyActionInput(): string | undefined;
    private _detectPublicProxyRedirecturl?;
    get detectPublicProxyRedirecturl(): string;
    set detectPublicProxyRedirecturl(value: string);
    resetDetectPublicProxyRedirecturl(): void;
    get detectPublicProxyRedirecturlInput(): string | undefined;
    private _detectResidentialProxy?;
    get detectResidentialProxy(): boolean | cdktf.IResolvable;
    set detectResidentialProxy(value: boolean | cdktf.IResolvable);
    resetDetectResidentialProxy(): void;
    get detectResidentialProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectResidentialProxyAction?;
    get detectResidentialProxyAction(): string;
    set detectResidentialProxyAction(value: string);
    resetDetectResidentialProxyAction(): void;
    get detectResidentialProxyActionInput(): string | undefined;
    private _detectResidentialProxyRedirecturl?;
    get detectResidentialProxyRedirecturl(): string;
    set detectResidentialProxyRedirecturl(value: string);
    resetDetectResidentialProxyRedirecturl(): void;
    get detectResidentialProxyRedirecturlInput(): string | undefined;
    private _detectSmartDnsProxy?;
    get detectSmartDnsProxy(): boolean | cdktf.IResolvable;
    set detectSmartDnsProxy(value: boolean | cdktf.IResolvable);
    resetDetectSmartDnsProxy(): void;
    get detectSmartDnsProxyInput(): boolean | cdktf.IResolvable | undefined;
    private _detectSmartDnsProxyAction?;
    get detectSmartDnsProxyAction(): string;
    set detectSmartDnsProxyAction(value: string);
    resetDetectSmartDnsProxyAction(): void;
    get detectSmartDnsProxyActionInput(): string | undefined;
    private _detectSmartDnsProxyRedirecturl?;
    get detectSmartDnsProxyRedirecturl(): string;
    set detectSmartDnsProxyRedirecturl(value: string);
    resetDetectSmartDnsProxyRedirecturl(): void;
    get detectSmartDnsProxyRedirecturlInput(): string | undefined;
    private _detectTorExitNode?;
    get detectTorExitNode(): boolean | cdktf.IResolvable;
    set detectTorExitNode(value: boolean | cdktf.IResolvable);
    resetDetectTorExitNode(): void;
    get detectTorExitNodeInput(): boolean | cdktf.IResolvable | undefined;
    private _detectTorExitNodeAction?;
    get detectTorExitNodeAction(): string;
    set detectTorExitNodeAction(value: string);
    resetDetectTorExitNodeAction(): void;
    get detectTorExitNodeActionInput(): string | undefined;
    private _detectTorExitNodeRedirecturl?;
    get detectTorExitNodeRedirecturl(): string;
    set detectTorExitNodeRedirecturl(value: string);
    resetDetectTorExitNodeRedirecturl(): void;
    get detectTorExitNodeRedirecturlInput(): string | undefined;
    private _detectVpnDataCenter?;
    get detectVpnDataCenter(): boolean | cdktf.IResolvable;
    set detectVpnDataCenter(value: boolean | cdktf.IResolvable);
    resetDetectVpnDataCenter(): void;
    get detectVpnDataCenterInput(): boolean | cdktf.IResolvable | undefined;
    private _detectVpnDataCenterAction?;
    get detectVpnDataCenterAction(): string;
    set detectVpnDataCenterAction(value: string);
    resetDetectVpnDataCenterAction(): void;
    get detectVpnDataCenterActionInput(): string | undefined;
    private _detectVpnDataCenterRedirecturl?;
    get detectVpnDataCenterRedirecturl(): string;
    set detectVpnDataCenterRedirecturl(value: string);
    resetDetectVpnDataCenterRedirecturl(): void;
    get detectVpnDataCenterRedirecturlInput(): string | undefined;
    private _enableConfigurationMode?;
    get enableConfigurationMode(): string;
    set enableConfigurationMode(value: string);
    resetEnableConfigurationMode(): void;
    get enableConfigurationModeInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _forwardHeaderEnrichment?;
    get forwardHeaderEnrichment(): boolean | cdktf.IResolvable;
    set forwardHeaderEnrichment(value: boolean | cdktf.IResolvable);
    resetForwardHeaderEnrichment(): void;
    get forwardHeaderEnrichmentInput(): boolean | cdktf.IResolvable | undefined;
    private _hostingProvider?;
    get hostingProvider(): string;
    set hostingProvider(value: string);
    resetHostingProvider(): void;
    get hostingProviderInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _publicProxy?;
    get publicProxy(): string;
    set publicProxy(value: string);
    resetPublicProxy(): void;
    get publicProxyInput(): string | undefined;
    private _residentialProxy?;
    get residentialProxy(): string;
    set residentialProxy(value: string);
    resetResidentialProxy(): void;
    get residentialProxyInput(): string | undefined;
    private _smartDnsProxy?;
    get smartDnsProxy(): string;
    set smartDnsProxy(value: string);
    resetSmartDnsProxy(): void;
    get smartDnsProxyInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _torExitNode?;
    get torExitNode(): string;
    set torExitNode(value: string);
    resetTorExitNode(): void;
    get torExitNodeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _vpnDataCenter?;
    get vpnDataCenter(): string;
    set vpnDataCenter(value: string);
    resetVpnDataCenter(): void;
    get vpnDataCenterInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment {
    /**
    * Sends the Enhanced Proxy Detection (`Akamai-EPD`) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}
    */
    readonly downloadDomainName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}
    */
    readonly g2OToken?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname | undefined);
    private _cpCode?;
    get cpCode(): number;
    set cpCode(value: number);
    resetCpCode(): void;
    get cpCodeInput(): number | undefined;
    private _downloadDomainName?;
    get downloadDomainName(): string;
    set downloadDomainName(value: string);
    resetDownloadDomainName(): void;
    get downloadDomainNameInput(): string | undefined;
    private _g2OToken?;
    get g2OToken(): string;
    set g2OToken(value: string);
    resetG2OToken(): void;
    get g2OTokenInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction {
    /**
    * Specifies the basic action to take when there is a failure to contact the origin.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
    */
    readonly actionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}
    */
    readonly allowFcmParentOverride?: boolean | cdktf.IResolvable;
    /**
    * Specifies a custom path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
    */
    readonly cexCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies a hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
    */
    readonly cexHostname?: string;
    /**
    * Specifies a custom path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
    */
    readonly cexPath?: string;
    /**
    * Specifies a custom redirect path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
    */
    readonly contentCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the static hostname for the alternate redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
    */
    readonly contentHostname?: string;
    /**
    * Specifies a custom redirect path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
    */
    readonly contentPath?: string;
    /**
    * Allows you to modify the original requested path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
    */
    readonly dynamicCustomPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies the redirect method.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
    */
    readonly dynamicMethod?: string;
    /**
    * Specifies the new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
    */
    readonly dynamicPath?: string;
    /**
    * When enabled in case of a failure to contact the origin, the current behavior applies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Modifies the redirect's protocol using the value of the `protocol` field.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
    */
    readonly modifyProtocol?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `RECREATED_NS`, specifies the path for the `NetStorage` request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
    */
    readonly netStoragePath?: string;
    /**
    * When using either `contentCustomPath`, `cexCustomPath`, `dynamicCustomPath`, or `redirectCustomPath` to specify a custom path, enabling this passes in the original request's query string as part of the path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
    */
    readonly preserveQueryString?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `REDIRECT` and `modifyProtocol` is enabled, this specifies the redirect's protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
    */
    readonly protocol?: string;
    /**
    * Uses the `redirectPath` to customize a new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
    */
    readonly redirectCustomPath?: boolean | cdktf.IResolvable;
    /**
    * When the `actionType` is `REDIRECT` and the `redirectHostnameType` is `ALTERNATE`, this specifies the hostname for the redirect.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
    */
    readonly redirectHostname?: string;
    /**
    * Whether to preserve or customize the hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
    */
    readonly redirectHostnameType?: string;
    /**
    * Specifies the HTTP response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
    */
    readonly redirectMethod?: number;
    /**
    * Specifies a new path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
    */
    readonly redirectPath?: string;
    /**
    * Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
    */
    readonly saasCnameEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
    */
    readonly saasCnameLevel?: number;
    /**
    * Specifies the name of the cookie that identifies this SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
    */
    readonly saasCookie?: string;
    /**
    * Specifies the name of the query parameter that identifies this SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
    */
    readonly saasQueryString?: string;
    /**
    * Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
    */
    readonly saasRegex?: string;
    /**
    * Specifies the replacement pattern that defines the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
    */
    readonly saasReplace?: string;
    /**
    * Specifies the static portion of the SaaS dynamic failaction.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
    */
    readonly saasSuffix?: string;
    /**
    * Identifies the component of the request that identifies the SaaS dynamic fail action.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
    */
    readonly saasType?: string;
    /**
    * Assigns a new HTTP status code to the failure response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
    */
    readonly statusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
    */
    readonly cpCode?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode;
    /**
    * net_storage_hostname block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
    */
    readonly netStorageHostname?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    resetActionType(): void;
    get actionTypeInput(): string | undefined;
    private _allowFcmParentOverride?;
    get allowFcmParentOverride(): boolean | cdktf.IResolvable;
    set allowFcmParentOverride(value: boolean | cdktf.IResolvable);
    resetAllowFcmParentOverride(): void;
    get allowFcmParentOverrideInput(): boolean | cdktf.IResolvable | undefined;
    private _cexCustomPath?;
    get cexCustomPath(): boolean | cdktf.IResolvable;
    set cexCustomPath(value: boolean | cdktf.IResolvable);
    resetCexCustomPath(): void;
    get cexCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _cexHostname?;
    get cexHostname(): string;
    set cexHostname(value: string);
    resetCexHostname(): void;
    get cexHostnameInput(): string | undefined;
    private _cexPath?;
    get cexPath(): string;
    set cexPath(value: string);
    resetCexPath(): void;
    get cexPathInput(): string | undefined;
    private _contentCustomPath?;
    get contentCustomPath(): boolean | cdktf.IResolvable;
    set contentCustomPath(value: boolean | cdktf.IResolvable);
    resetContentCustomPath(): void;
    get contentCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _contentHostname?;
    get contentHostname(): string;
    set contentHostname(value: string);
    resetContentHostname(): void;
    get contentHostnameInput(): string | undefined;
    private _contentPath?;
    get contentPath(): string;
    set contentPath(value: string);
    resetContentPath(): void;
    get contentPathInput(): string | undefined;
    private _dynamicCustomPath?;
    get dynamicCustomPath(): boolean | cdktf.IResolvable;
    set dynamicCustomPath(value: boolean | cdktf.IResolvable);
    resetDynamicCustomPath(): void;
    get dynamicCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _dynamicMethod?;
    get dynamicMethod(): string;
    set dynamicMethod(value: string);
    resetDynamicMethod(): void;
    get dynamicMethodInput(): string | undefined;
    private _dynamicPath?;
    get dynamicPath(): string;
    set dynamicPath(value: string);
    resetDynamicPath(): void;
    get dynamicPathInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _modifyProtocol?;
    get modifyProtocol(): boolean | cdktf.IResolvable;
    set modifyProtocol(value: boolean | cdktf.IResolvable);
    resetModifyProtocol(): void;
    get modifyProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _netStoragePath?;
    get netStoragePath(): string;
    set netStoragePath(value: string);
    resetNetStoragePath(): void;
    get netStoragePathInput(): string | undefined;
    private _preserveQueryString?;
    get preserveQueryString(): boolean | cdktf.IResolvable;
    set preserveQueryString(value: boolean | cdktf.IResolvable);
    resetPreserveQueryString(): void;
    get preserveQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    resetProtocol(): void;
    get protocolInput(): string | undefined;
    private _redirectCustomPath?;
    get redirectCustomPath(): boolean | cdktf.IResolvable;
    set redirectCustomPath(value: boolean | cdktf.IResolvable);
    resetRedirectCustomPath(): void;
    get redirectCustomPathInput(): boolean | cdktf.IResolvable | undefined;
    private _redirectHostname?;
    get redirectHostname(): string;
    set redirectHostname(value: string);
    resetRedirectHostname(): void;
    get redirectHostnameInput(): string | undefined;
    private _redirectHostnameType?;
    get redirectHostnameType(): string;
    set redirectHostnameType(value: string);
    resetRedirectHostnameType(): void;
    get redirectHostnameTypeInput(): string | undefined;
    private _redirectMethod?;
    get redirectMethod(): number;
    set redirectMethod(value: number);
    resetRedirectMethod(): void;
    get redirectMethodInput(): number | undefined;
    private _redirectPath?;
    get redirectPath(): string;
    set redirectPath(value: string);
    resetRedirectPath(): void;
    get redirectPathInput(): string | undefined;
    private _saasCnameEnabled?;
    get saasCnameEnabled(): boolean | cdktf.IResolvable;
    set saasCnameEnabled(value: boolean | cdktf.IResolvable);
    resetSaasCnameEnabled(): void;
    get saasCnameEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _saasCnameLevel?;
    get saasCnameLevel(): number;
    set saasCnameLevel(value: number);
    resetSaasCnameLevel(): void;
    get saasCnameLevelInput(): number | undefined;
    private _saasCookie?;
    get saasCookie(): string;
    set saasCookie(value: string);
    resetSaasCookie(): void;
    get saasCookieInput(): string | undefined;
    private _saasQueryString?;
    get saasQueryString(): string;
    set saasQueryString(value: string);
    resetSaasQueryString(): void;
    get saasQueryStringInput(): string | undefined;
    private _saasRegex?;
    get saasRegex(): string;
    set saasRegex(value: string);
    resetSaasRegex(): void;
    get saasRegexInput(): string | undefined;
    private _saasReplace?;
    get saasReplace(): string;
    set saasReplace(value: string);
    resetSaasReplace(): void;
    get saasReplaceInput(): string | undefined;
    private _saasSuffix?;
    get saasSuffix(): string;
    set saasSuffix(value: string);
    resetSaasSuffix(): void;
    get saasSuffixInput(): string | undefined;
    private _saasType?;
    get saasType(): string;
    set saasType(value: string);
    resetSaasType(): void;
    get saasTypeInput(): string | undefined;
    private _statusCode?;
    get statusCode(): number;
    set statusCode(value: number);
    resetStatusCode(): void;
    get statusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCode;
    get cpCode(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference;
    putCpCode(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode): void;
    resetCpCode(): void;
    get cpCodeInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode | undefined;
    private _netStorageHostname;
    get netStorageHostname(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference;
    putNetStorageHostname(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname): void;
    resetNetStorageHostname(): void;
    get netStorageHostnameInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility {
    /**
    * This behavior does not include any options. Specifying the behavior itself enables it.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
    */
    readonly compatibility?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility | undefined);
    private _compatibility?;
    get compatibility(): boolean | cdktf.IResolvable;
    set compatibility(value: boolean | cdktf.IResolvable);
    resetCompatibility(): void;
    get compatibilityInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate {
    /**
    * When enabled, forces a validation test for all edge content to which the behavior applies.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips {
    /**
    * When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing {
    /**
    * Enables the Cloud Marketing Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Select how to insert the MediaMath JavaScript reference script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
    */
    readonly javaScriptInsertionRule?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash.  For example, if the path prefix is `/mmath`, and the request is for `www.example.com/dir`, the new URL is `www.example.com/mmath/dir`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
    */
    readonly mediaMathPrefix?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _javaScriptInsertionRule?;
    get javaScriptInsertionRule(): string;
    set javaScriptInsertionRule(value: string);
    resetJavaScriptInsertionRule(): void;
    get javaScriptInsertionRuleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mediaMathPrefix?;
    get mediaMathPrefix(): string;
    set mediaMathPrefix(value: string);
    resetMediaMathPrefix(): void;
    get mediaMathPrefixInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus {
    /**
    * Enables the Cloud Marketing Plus Cloudlet.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Select how to insert the MediaMath JavaScript reference script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
    */
    readonly javaScriptInsertionRule?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash.  For example, if the path prefix is `/mmath`, and the request is for `www.example.com/dir`, the new URL is `www.example.com/mmath/dir`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
    */
    readonly mediaMathPrefix?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _javaScriptInsertionRule?;
    get javaScriptInsertionRule(): string;
    set javaScriptInsertionRule(value: string);
    resetJavaScriptInsertionRule(): void;
    get javaScriptInsertionRuleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _mediaMathPrefix?;
    get mediaMathPrefix(): string;
    set mediaMathPrefix(value: string);
    resetMediaMathPrefix(): void;
    get mediaMathPrefixInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy | undefined);
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite {
    /**
    * This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the `Cloudlets API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
    */
    readonly cloudletSharedPolicy?: number;
    /**
    * Enables the Forward Rewrite Cloudlet behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in `Cloudlets Policy Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
    */
    readonly isSharedPolicy?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cloudlet_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
    */
    readonly cloudletPolicy?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite | undefined);
    private _cloudletSharedPolicy?;
    get cloudletSharedPolicy(): number;
    set cloudletSharedPolicy(value: number);
    resetCloudletSharedPolicy(): void;
    get cloudletSharedPolicyInput(): number | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSharedPolicy?;
    get isSharedPolicy(): boolean | cdktf.IResolvable;
    set isSharedPolicy(value: boolean | cdktf.IResolvable);
    resetIsSharedPolicy(): void;
    get isSharedPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cloudletPolicy;
    get cloudletPolicy(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference;
    putCloudletPolicy(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy): void;
    resetCloudletPolicy(): void;
    get cloudletPolicyInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader {
    /**
    * Specifies the set of data to be encrypted as a combination of concatenated strings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
    */
    readonly customSignString?: string[];
    /**
    * Specifies the name of the header that contains the request data that needs to be encrypted.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
    */
    readonly dataHeader?: string;
    /**
    * Enables the g2o verification behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the version of the encryption algorithm as an integer from `1` through `5`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
    */
    readonly encodingVersion?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the cryptographic `nonce` string.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
    */
    readonly nonce?: string;
    /**
    * Specifies the shared secret key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
    */
    readonly secretKey?: string;
    /**
    * Specifies the name of the header containing encrypted request data.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
    */
    readonly signedHeader?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use `customSignString` to customize the set of data to encrypt.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
    */
    readonly useCustomSignString?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader | undefined);
    private _customSignString?;
    get customSignString(): string[];
    set customSignString(value: string[]);
    resetCustomSignString(): void;
    get customSignStringInput(): string[] | undefined;
    private _dataHeader?;
    get dataHeader(): string;
    set dataHeader(value: string);
    resetDataHeader(): void;
    get dataHeaderInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _encodingVersion?;
    get encodingVersion(): number;
    set encodingVersion(value: number);
    resetEncodingVersion(): void;
    get encodingVersionInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _nonce?;
    get nonce(): string;
    set nonce(value: string);
    resetNonce(): void;
    get nonceInput(): string | undefined;
    private _secretKey?;
    get secretKey(): string;
    set secretKey(value: string);
    resetSecretKey(): void;
    get secretKeyInput(): string | undefined;
    private _signedHeader?;
    get signedHeader(): string;
    set signedHeader(value: string);
    resetSignedHeader(): void;
    get signedHeaderInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useCustomSignString?;
    get useCustomSignString(): boolean | cdktf.IResolvable;
    set useCustomSignString(value: boolean | cdktf.IResolvable);
    resetUseCustomSignString(): void;
    get useCustomSignStringInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber {
    /**
    * With `outputOption` set to specify any set of headers, this specifies the name of the header to report the GRN value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
    */
    readonly headerName?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies how to report the GRN value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
    */
    readonly outputOption?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * This specifies the name of the variable to assign the GRN value to. You need to pre-declare any `variable` you specify within the rule tree.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
    */
    readonly variableName?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber | undefined);
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    resetHeaderName(): void;
    get headerNameInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _outputOption?;
    get outputOption(): string;
    set outputOption(value: string);
    resetOutputOption(): void;
    get outputOptionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _variableName?;
    get variableName(): string;
    set variableName(value: string);
    resetVariableName(): void;
    get variableNameInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: string;
    /**
    * When enabled, caches responses that include an `error` field at the top of the response body object.  Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
    */
    readonly cacheResponsesWithErrors?: boolean | cdktf.IResolvable;
    /**
    * Enables GraphQL caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * The name of the JSON body parameter that identifies GraphQL POST requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
    */
    readonly operationsJsonBodyParameterName?: string;
    /**
    * Specifies the name of a query parameter that identifies requests as GraphQL queries.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
    */
    readonly operationsUrlQueryParameterName?: string;
    /**
    * Specify what happens if GraphQL query processing fails on POST requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
    */
    readonly postRequestProcessingErrorHandling?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching | undefined);
    private _advanced?;
    get advanced(): string;
    set advanced(value: string);
    resetAdvanced(): void;
    get advancedInput(): string | undefined;
    private _cacheResponsesWithErrors?;
    get cacheResponsesWithErrors(): boolean | cdktf.IResolvable;
    set cacheResponsesWithErrors(value: boolean | cdktf.IResolvable);
    resetCacheResponsesWithErrors(): void;
    get cacheResponsesWithErrorsInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _operationsJsonBodyParameterName?;
    get operationsJsonBodyParameterName(): string;
    set operationsJsonBodyParameterName(value: string);
    resetOperationsJsonBodyParameterName(): void;
    get operationsJsonBodyParameterNameInput(): string | undefined;
    private _operationsUrlQueryParameterName?;
    get operationsUrlQueryParameterName(): string;
    set operationsUrlQueryParameterName(value: string);
    resetOperationsUrlQueryParameterName(): void;
    get operationsUrlQueryParameterNameInput(): string | undefined;
    private _postRequestProcessingErrorHandling?;
    get postRequestProcessingErrorHandling(): string;
    set postRequestProcessingErrorHandling(value: string);
    resetPostRequestProcessingErrorHandling(): void;
    get postRequestProcessingErrorHandlingInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse {
    /**
    * Specify when to compress responses.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
    */
    readonly behavior?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse | undefined);
    private _behavior?;
    get behavior(): string;
    set behavior(value: string);
    resetBehavior(): void;
    get behaviorInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced {
    /**
    * Human-readable description of what the XML block does.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * A block of Akamai XML metadata.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
    */
    readonly xml?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _xml?;
    get xml(): string;
    set xml(value: string);
    resetXml(): void;
    get xmlInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, `maximumReconnects` effectively overrides the value of `retryCount`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
    */
    readonly maximumReconnects?: number;
    /**
    * The number of consecutive connection failures that mark an IP address as faulty.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
    */
    readonly retryCount?: number;
    /**
    * Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
    */
    readonly retryInterval?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumReconnects?;
    get maximumReconnects(): number;
    set maximumReconnects(value: number);
    resetMaximumReconnects(): void;
    get maximumReconnectsInput(): number | undefined;
    private _retryCount?;
    get retryCount(): number;
    set retryCount(value: number);
    resetRetryCount(): void;
    get retryCountInput(): number | undefined;
    private _retryInterval?;
    get retryInterval(): string;
    set retryInterval(value: string);
    resetRetryInterval(): void;
    get retryIntervalInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding {
    /**
    * Whether to pull the serial number from the variable value set in the `advanced` behavior. Work with your Akamai Services team to add the `advanced` behavior earlier in your property to extract and apply the `AKA_PM_EIP_HSAF_SERIAL` variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
    */
    readonly customExtractedSerial?: boolean | cdktf.IResolvable;
    /**
    * Enables HSAF for Edge IP Binding customers with a large footprint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than `hashMinValue`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
    */
    readonly hashMaxValue?: number;
    /**
    * Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than `hashMaxValue`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
    */
    readonly hashMinValue?: number;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies where the behavior is applied.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
    */
    readonly tier?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding | undefined);
    private _customExtractedSerial?;
    get customExtractedSerial(): boolean | cdktf.IResolvable;
    set customExtractedSerial(value: boolean | cdktf.IResolvable);
    resetCustomExtractedSerial(): void;
    get customExtractedSerialInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hashMaxValue?;
    get hashMaxValue(): number;
    set hashMaxValue(value: number);
    resetHashMaxValue(): void;
    get hashMaxValueInput(): number | undefined;
    private _hashMinValue?;
    get hashMinValue(): number;
    set hashMinValue(value: number);
    resetHashMinValue(): void;
    get hashMinValueInput(): number | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _tier?;
    get tier(): string;
    set tier(value: string);
    resetTier(): void;
    get tierInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2 {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2ToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2OutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2ToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2OutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2 | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2 | undefined);
    private _enabled?;
    get enabled(): string;
    set enabled(value: string);
    resetEnabled(): void;
    get enabledInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3 {
    /**
    * This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the `Property Manager documentation` for more details.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3ToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3OutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3ToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3OutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3 | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3 | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity {
    /**
    * Applies HSTS to this set of requests.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
    */
    readonly enable?: boolean | cdktf.IResolvable;
    /**
    * When enabled, applies HSTS to all subdomains.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
    */
    readonly includeSubDomains?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the duration for which to apply HSTS for new browser connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
    */
    readonly maxAge?: string;
    /**
    * When enabled, adds this domain to the browser's preload list. You still need to declare the domain at `hstspreload.org`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
    */
    readonly preload?: boolean | cdktf.IResolvable;
    /**
    * When enabled, redirects all HTTP requests to HTTPS.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
    */
    readonly redirect?: boolean | cdktf.IResolvable;
    /**
    * Specifies a response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
    */
    readonly redirectStatusCode?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity | undefined);
    private _enable?;
    get enable(): boolean | cdktf.IResolvable;
    set enable(value: boolean | cdktf.IResolvable);
    resetEnable(): void;
    get enableInput(): boolean | cdktf.IResolvable | undefined;
    private _includeSubDomains?;
    get includeSubDomains(): boolean | cdktf.IResolvable;
    set includeSubDomains(value: boolean | cdktf.IResolvable);
    resetIncludeSubDomains(): void;
    get includeSubDomainsInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maxAge?;
    get maxAge(): string;
    set maxAge(value: string);
    resetMaxAge(): void;
    get maxAgeInput(): string | undefined;
    private _preload?;
    get preload(): boolean | cdktf.IResolvable;
    set preload(value: boolean | cdktf.IResolvable);
    resetPreload(): void;
    get preloadInput(): boolean | cdktf.IResolvable | undefined;
    private _redirect?;
    get redirect(): boolean | cdktf.IResolvable;
    set redirect(value: boolean | cdktf.IResolvable);
    resetRedirect(): void;
    get redirectInput(): boolean | cdktf.IResolvable | undefined;
    private _redirectStatusCode?;
    get redirectStatusCode(): number;
    set redirectStatusCode(value: number);
    resetRedirectStatusCode(): void;
    get redirectStatusCodeInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
    */
    readonly upgrade?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _upgrade?;
    get upgrade(): string;
    set upgrade(value: string);
    resetUpgrade(): void;
    get upgradeInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride {
    /**
    * Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
    */
    readonly dpr?: number;
    /**
    * This selects the variable with the desired pixel density. The variable specifies the same type of data as the `dpr` option below.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
    */
    readonly dprvar?: string;
    /**
    * Whether to exclude all query parameters from the Image and Video Manager cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
    */
    readonly excludeAllQueryParameters?: boolean | cdktf.IResolvable;
    /**
    * Specifies individual query parameters to exclude from the Image and Video Manager cache key.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
    */
    readonly excludedQueryParameters?: string[];
    /**
    * Specifies the type of the browser, or the encodings passed in the `Accept` header, that you want to optimize images for.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
    */
    readonly format?: string;
    /**
    * This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the `format` option below.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
    */
    readonly formatvar?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Selects the type of query parameter you want to set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
    */
    readonly override?: string;
    /**
    * This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
    */
    readonly policy?: string;
    /**
    * This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
    */
    readonly policyvar?: string;
    /**
    * This selects one of the property's rule tree variables to assign to the `policyvarName` variable within Image and Video Manager.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
    */
    readonly policyvarIMvar?: string;
    /**
    * This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
    */
    readonly policyvarName?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Specifies how to set a query parameter.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
    */
    readonly typesel?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
    */
    readonly width?: number;
    /**
    * Selects the variable with the desired width.  If the Image and Video Manager policy doesn't define that width, it serves the next largest width.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
    */
    readonly widthvar?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride | undefined);
    private _dpr?;
    get dpr(): number;
    set dpr(value: number);
    resetDpr(): void;
    get dprInput(): number | undefined;
    private _dprvar?;
    get dprvar(): string;
    set dprvar(value: string);
    resetDprvar(): void;
    get dprvarInput(): string | undefined;
    private _excludeAllQueryParameters?;
    get excludeAllQueryParameters(): boolean | cdktf.IResolvable;
    set excludeAllQueryParameters(value: boolean | cdktf.IResolvable);
    resetExcludeAllQueryParameters(): void;
    get excludeAllQueryParametersInput(): boolean | cdktf.IResolvable | undefined;
    private _excludedQueryParameters?;
    get excludedQueryParameters(): string[];
    set excludedQueryParameters(value: string[]);
    resetExcludedQueryParameters(): void;
    get excludedQueryParametersInput(): string[] | undefined;
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _formatvar?;
    get formatvar(): string;
    set formatvar(value: string);
    resetFormatvar(): void;
    get formatvarInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _override?;
    get override(): string;
    set override(value: string);
    resetOverride(): void;
    get overrideInput(): string | undefined;
    private _policy?;
    get policy(): string;
    set policy(value: string);
    resetPolicy(): void;
    get policyInput(): string | undefined;
    private _policyvar?;
    get policyvar(): string;
    set policyvar(value: string);
    resetPolicyvar(): void;
    get policyvarInput(): string | undefined;
    private _policyvarIMvar?;
    get policyvarIMvar(): string;
    set policyvarIMvar(value: string);
    resetPolicyvarIMvar(): void;
    get policyvarIMvarInput(): string | undefined;
    private _policyvarName?;
    get policyvarName(): string;
    set policyvarName(value: string);
    resetPolicyvarName(): void;
    get policyvarNameInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _typesel?;
    get typesel(): string;
    set typesel(value: string);
    resetTypesel(): void;
    get typeselInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _widthvar?;
    get widthvar(): string;
    set widthvar(value: string);
    resetWidthvar(): void;
    get widthvarInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}
    */
    readonly imageSet?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}
    */
    readonly policySetType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}
    */
    readonly videoSet?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager | undefined);
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _imageSet?;
    get imageSet(): string;
    set imageSet(value: string);
    resetImageSet(): void;
    get imageSetInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySetType?;
    get policySetType(): string;
    set policySetType(value: string);
    resetPolicySetType(): void;
    get policySetTypeInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _videoSet?;
    get videoSet(): string;
    set videoSet(value: string);
    resetVideoSet(): void;
    get videoSetInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager {
    /**
    * Generates a custom `Image and Video Manager API` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the `policyToken`) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
    */
    readonly apiReferenceTitle?: string;
    /**
    * Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Enable image management capabilities and generate a corresponding API token.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Identifies the existing policy set configured with `Image and Video Manager API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
    */
    readonly policySet?: string;
    /**
    * Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, `default` becomes the prefix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
    */
    readonly policyToken?: string;
    /**
    * Specify the default policy identifier, which is registered with the `Image and Video Manager API` once you activate this property.  The `advanced` option needs to be inactive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
    */
    readonly policyTokenDefault?: string;
    /**
    * Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.  Note that enabling this may affect screen layout in unexpected ways.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
    */
    readonly settingsTitle?: string;
    /**
    * Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
    */
    readonly superCacheRegion?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
    */
    readonly trafficTitle?: string;
    /**
    * Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
    */
    readonly useExistingPolicySet?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _apiReferenceTitle?;
    get apiReferenceTitle(): string;
    set apiReferenceTitle(value: string);
    resetApiReferenceTitle(): void;
    get apiReferenceTitleInput(): string | undefined;
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySet?;
    get policySet(): string;
    set policySet(value: string);
    resetPolicySet(): void;
    get policySetInput(): string | undefined;
    private _policyToken?;
    get policyToken(): string;
    set policyToken(value: string);
    resetPolicyToken(): void;
    get policyTokenInput(): string | undefined;
    private _policyTokenDefault?;
    get policyTokenDefault(): string;
    set policyTokenDefault(value: string);
    resetPolicyTokenDefault(): void;
    get policyTokenDefaultInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsTitle?;
    get settingsTitle(): string;
    set settingsTitle(value: string);
    resetSettingsTitle(): void;
    get settingsTitleInput(): string | undefined;
    private _superCacheRegion?;
    get superCacheRegion(): string;
    set superCacheRegion(value: string);
    resetSuperCacheRegion(): void;
    get superCacheRegionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trafficTitle?;
    get trafficTitle(): string;
    set trafficTitle(value: string);
    resetTrafficTitle(): void;
    get trafficTitleInput(): string | undefined;
    private _useExistingPolicySet?;
    get useExistingPolicySet(): boolean | cdktf.IResolvable;
    set useExistingPolicySet(value: boolean | cdktf.IResolvable);
    resetUseExistingPolicySet(): void;
    get useExistingPolicySetInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
    */
    readonly currentCapacity?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
    */
    readonly limit?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
    */
    readonly limitType?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined);
    private _currentCapacity?;
    get currentCapacity(): number;
    set currentCapacity(value: number);
    resetCurrentCapacity(): void;
    get currentCapacityInput(): number | undefined;
    private _limit?;
    get limit(): number;
    set limit(value: number);
    resetLimit(): void;
    get limitInput(): number | undefined;
    private _limitType?;
    get limitType(): string;
    set limitType(value: string);
    resetLimitType(): void;
    get limitTypeInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed {
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
    */
    readonly createdDate?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: number;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
    */
    readonly name?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
    */
    readonly products?: string[];
    /**
    * cp_code_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
    */
    readonly cpCodeLimits?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed | undefined);
    private _createdDate?;
    get createdDate(): number;
    set createdDate(value: number);
    resetCreatedDate(): void;
    get createdDateInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): number;
    set id(value: number);
    resetId(): void;
    get idInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _products?;
    get products(): string[];
    set products(value: string[]);
    resetProducts(): void;
    get productsInput(): string[] | undefined;
    private _cpCodeLimits;
    get cpCodeLimits(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference;
    putCpCodeLimits(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits): void;
    resetCpCodeLimits(): void;
    get cpCodeLimitsInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo {
    /**
    * When disabled, applies a single standard policy based on your property name.  Allows you to reference a rule-specific `policyToken` for videos with different match criteria.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
    */
    readonly advanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
    */
    readonly apiReferenceTitle?: string;
    /**
    * When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
    */
    readonly applyBestFileType?: boolean | cdktf.IResolvable;
    /**
    * Applies Image and Video Manager's video optimization to the current content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Identifies the existing policy set configured with `Image and Video Manager API`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
    */
    readonly policySet?: string;
    /**
    * Specifies a custom policy defined in the Image and Video Manager Policy Manager or the `Image and Video Manager API`. The policy name can include up to 64 alphanumeric, dash, or underscore characters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
    */
    readonly policyToken?: string;
    /**
    * Specifies the default policy identifier, which is registered with the `Image and Video Manager API` once you activate this property.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
    */
    readonly policyTokenDefault?: string;
    /**
    * When enabled, scales down video for smaller mobile screens, based on the device's `User-Agent` header.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
    */
    readonly resize?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
    */
    readonly settingsTitle?: string;
    /**
    * To optimize caching, assign a region close to your site's heaviest traffic.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
    */
    readonly superCacheRegion?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
    */
    readonly trafficTitle?: string;
    /**
    * Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
    */
    readonly useExistingPolicySet?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * cp_code_original block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
    */
    readonly cpCodeOriginal?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal;
    /**
    * cp_code_transformed block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
    */
    readonly cpCodeTransformed?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo | undefined);
    private _advanced?;
    get advanced(): boolean | cdktf.IResolvable;
    set advanced(value: boolean | cdktf.IResolvable);
    resetAdvanced(): void;
    get advancedInput(): boolean | cdktf.IResolvable | undefined;
    private _apiReferenceTitle?;
    get apiReferenceTitle(): string;
    set apiReferenceTitle(value: string);
    resetApiReferenceTitle(): void;
    get apiReferenceTitleInput(): string | undefined;
    private _applyBestFileType?;
    get applyBestFileType(): boolean | cdktf.IResolvable;
    set applyBestFileType(value: boolean | cdktf.IResolvable);
    resetApplyBestFileType(): void;
    get applyBestFileTypeInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _policySet?;
    get policySet(): string;
    set policySet(value: string);
    resetPolicySet(): void;
    get policySetInput(): string | undefined;
    private _policyToken?;
    get policyToken(): string;
    set policyToken(value: string);
    resetPolicyToken(): void;
    get policyTokenInput(): string | undefined;
    private _policyTokenDefault?;
    get policyTokenDefault(): string;
    set policyTokenDefault(value: string);
    resetPolicyTokenDefault(): void;
    get policyTokenDefaultInput(): string | undefined;
    private _resize?;
    get resize(): boolean | cdktf.IResolvable;
    set resize(value: boolean | cdktf.IResolvable);
    resetResize(): void;
    get resizeInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsTitle?;
    get settingsTitle(): string;
    set settingsTitle(value: string);
    resetSettingsTitle(): void;
    get settingsTitleInput(): string | undefined;
    private _superCacheRegion?;
    get superCacheRegion(): string;
    set superCacheRegion(value: string);
    resetSuperCacheRegion(): void;
    get superCacheRegionInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _trafficTitle?;
    get trafficTitle(): string;
    set trafficTitle(value: string);
    resetTrafficTitle(): void;
    get trafficTitleInput(): string | undefined;
    private _useExistingPolicySet?;
    get useExistingPolicySet(): boolean | cdktf.IResolvable;
    set useExistingPolicySet(value: boolean | cdktf.IResolvable);
    resetUseExistingPolicySet(): void;
    get useExistingPolicySetInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _cpCodeOriginal;
    get cpCodeOriginal(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference;
    putCpCodeOriginal(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal): void;
    resetCpCodeOriginal(): void;
    get cpCodeOriginalInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal | undefined;
    private _cpCodeTransformed;
    get cpCodeTransformed(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference;
    putCpCodeTransformed(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed): void;
    resetCpCodeTransformed(): void;
    get cpCodeTransformedInput(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude {
    /**
    * Identifies the include you want to add to your rule tree. You can get the include ID using `PAPI`. This option only accepts digits, without the `inc_` ID prefix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant {
    /**
    * Specify link relation values that activate the prefetching behavior. For example, specifying `fetch` allows you to use shorter `rel="fetch"` markup.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
    */
    readonly customLinkRelations?: string[];
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * When enabled, applies prefetching only to objects already set to be cacheable, for example using the `caching` behavior. Only applies to content with the `tieredDistribution` behavior enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
    */
    readonly prefetchCacheable?: boolean | cdktf.IResolvable;
    /**
    * Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from `<a>` or `<link>` tags with the appropriate link relation attribute.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
    */
    readonly prefetchHtml?: boolean | cdktf.IResolvable;
    /**
    * Allows otherwise non-cacheable `no-store` content to prefetch if the URL path ends with `/` to indicate a request for a default file, or if the extension matches the value of the `prefetchNoStoreExtensions` option. Only applies to content with the `sureRoute` behavior enabled.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
    */
    readonly prefetchNoStore?: boolean | cdktf.IResolvable;
    /**
    * Specifies a set of file extensions for which the `prefetchNoStore` option is allowed.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
    */
    readonly prefetchNoStoreExtensions?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant | undefined);
    private _customLinkRelations?;
    get customLinkRelations(): string[];
    set customLinkRelations(value: string[]);
    resetCustomLinkRelations(): void;
    get customLinkRelationsInput(): string[] | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchCacheable?;
    get prefetchCacheable(): boolean | cdktf.IResolvable;
    set prefetchCacheable(value: boolean | cdktf.IResolvable);
    resetPrefetchCacheable(): void;
    get prefetchCacheableInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchHtml?;
    get prefetchHtml(): boolean | cdktf.IResolvable;
    set prefetchHtml(value: boolean | cdktf.IResolvable);
    resetPrefetchHtml(): void;
    get prefetchHtmlInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchNoStore?;
    get prefetchNoStore(): boolean | cdktf.IResolvable;
    set prefetchNoStore(value: boolean | cdktf.IResolvable);
    resetPrefetchNoStore(): void;
    get prefetchNoStoreInput(): boolean | cdktf.IResolvable | undefined;
    private _prefetchNoStoreExtensions?;
    get prefetchNoStoreExtensions(): string[];
    set prefetchNoStoreExtensions(value: string[]);
    resetPrefetchNoStoreExtensions(): void;
    get prefetchNoStoreExtensionsInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig {
    /**
    * Enables the InstantConfig behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization {
    /**
    * Specifies whether to cache partial objects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
    */
    readonly enablePartialObjectCaching?: string;
    /**
    * Enables the file optimization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as `MB` or `GB`. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
    */
    readonly maximumSize?: string;
    /**
    * Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as `MB` or `GB`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
    */
    readonly minimumSize?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * When `enablePartialObjectCaching` is set to `PARTIAL_OBJECT_CACHING`, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
    */
    readonly useVersioning?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization | undefined);
    private _enablePartialObjectCaching?;
    get enablePartialObjectCaching(): string;
    set enablePartialObjectCaching(value: string);
    resetEnablePartialObjectCaching(): void;
    get enablePartialObjectCachingInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _maximumSize?;
    get maximumSize(): string;
    set maximumSize(value: string);
    resetMaximumSize(): void;
    get maximumSizeInput(): string | undefined;
    private _minimumSize?;
    get minimumSize(): string;
    set minimumSize(value: string);
    resetMinimumSize(): void;
    get minimumSizeInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useVersioning?;
    get useVersioning(): boolean | cdktf.IResolvable;
    set useVersioning(value: boolean | cdktf.IResolvable);
    resetUseVersioning(): void;
    get useVersioningInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced {
    /**
    * Enables the file optimization behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the size of each fragment used for partial object caching.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
    */
    readonly fragmentSize?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a `MB` or `GB` suffix.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
    */
    readonly objectSize?: string;
    /**
    * The number of POC fragments to prefetch after the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
    */
    readonly prefetchAfterRequest?: number;
    /**
    * The number of POC fragments to prefetch during the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
    */
    readonly prefetchDuringRequest?: number;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _fragmentSize?;
    get fragmentSize(): string;
    set fragmentSize(value: string);
    resetFragmentSize(): void;
    get fragmentSizeInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectSize?;
    get objectSize(): string;
    set objectSize(value: string);
    resetObjectSize(): void;
    get objectSizeInput(): string | undefined;
    private _prefetchAfterRequest?;
    get prefetchAfterRequest(): number;
    set prefetchAfterRequest(value: number);
    resetPrefetchAfterRequest(): void;
    get prefetchAfterRequestInput(): number | undefined;
    private _prefetchDuringRequest?;
    get prefetchDuringRequest(): number;
    set prefetchDuringRequest(value: number);
    resetPrefetchDuringRequest(): void;
    get prefetchDuringRequestInput(): number | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable {
    /**
    * The unit of measurement, either `KBPS`, `MBPS`, or `GBPS`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
    */
    readonly bitrateUnit?: string;
    /**
    * The numeric indicator of the download rate.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
    */
    readonly bitrateValue?: number;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable | cdktf.IResolvable | undefined);
    private _bitrateUnit?;
    get bitrateUnit(): string;
    set bitrateUnit(value: string);
    resetBitrateUnit(): void;
    get bitrateUnitInput(): string | undefined;
    private _bitrateValue?;
    get bitrateValue(): number;
    set bitrateValue(value: number);
    resetBitrateValue(): void;
    get bitrateValueInput(): number | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable {
    /**
    * The unit of measurement, either `SECONDS` of the elapsed download time, or `BYTES` of the file size.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
    */
    readonly thresholdUnit?: string;
    /**
    * The numeric indicator of the minimum file size or elapsed download time.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
    */
    readonly thresholdValue?: number;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable | cdktf.IResolvable): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable | cdktf.IResolvable): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable | cdktf.IResolvable | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable | cdktf.IResolvable | undefined);
    private _thresholdUnit?;
    get thresholdUnit(): string;
    set thresholdUnit(value: string);
    resetThresholdUnit(): void;
    get thresholdUnitInput(): string | undefined;
    private _thresholdValue?;
    get thresholdValue(): number;
    set thresholdValue(value: number);
    resetThresholdValue(): void;
    get thresholdValueInput(): number | undefined;
}
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableOutputReference;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate {
    /**
    * When enabled, activates the bit rate limiting behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
    /**
    * bitrate_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
    */
    readonly bitrateTable?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable;
    /**
    * threshold_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
    */
    readonly thresholdTable?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
    private _bitrateTable;
    get bitrateTable(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableList;
    putBitrateTable(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable[] | cdktf.IResolvable): void;
    resetBitrateTable(): void;
    get bitrateTableInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable[] | undefined;
    private _thresholdTable;
    get thresholdTable(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableList;
    putThresholdTable(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable[] | cdktf.IResolvable): void;
    resetThresholdTable(): void;
    get thresholdTableInput(): cdktf.IResolvable | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable[] | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom {
    /**
    * Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, `round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms` logs the total time to complete the response. See `Support for variables` for more information. Since this option can specify both a request and response, it overrides any `customLogField` settings in the `report` behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
    */
    readonly customLogField?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Whether to append additional custom data to each log line.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
    */
    readonly logCustomLogField?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom | undefined);
    private _customLogField?;
    get customLogField(): string;
    set customLogField(value: string);
    resetCustomLogField(): void;
    get customLogFieldInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _logCustomLogField?;
    get logCustomLogField(): boolean | cdktf.IResolvable;
    set logCustomLogField(value: boolean | cdktf.IResolvable);
    resetLogCustomLogField(): void;
    get logCustomLogFieldInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse {
    /**
    * This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see `Enable mPulse in Property Manager`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
    */
    readonly apiKey?: string;
    /**
    * Allows you to override the browser's default (150) maximum number of reported performance timeline entries.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
    */
    readonly bufferSize?: string;
    /**
    * A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the `window.BOOMR_config` object. For example, this turns on monitoring of Single Page App frameworks: `"{\"history\": {\"enabled\": true, \"auto\": true}}"`.  See `Configuration Overrides` for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
    */
    readonly configOverride?: string;
    /**
    * Applies performance monitoring to this behavior's set of content.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies the version of the Boomerang JavaScript loader snippet. See `mPulse Loader Snippets` for more information.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
    */
    readonly loaderVersion?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
    */
    readonly requirePci?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
    */
    readonly titleOptional?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse | undefined);
    private _apiKey?;
    get apiKey(): string;
    set apiKey(value: string);
    resetApiKey(): void;
    get apiKeyInput(): string | undefined;
    private _bufferSize?;
    get bufferSize(): string;
    set bufferSize(value: string);
    resetBufferSize(): void;
    get bufferSizeInput(): string | undefined;
    private _configOverride?;
    get configOverride(): string;
    set configOverride(value: string);
    resetConfigOverride(): void;
    get configOverrideInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _loaderVersion?;
    get loaderVersion(): string;
    set loaderVersion(value: string);
    resetLoaderVersion(): void;
    get loaderVersionInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _requirePci?;
    get requirePci(): boolean | cdktf.IResolvable;
    set requirePci(value: boolean | cdktf.IResolvable);
    resetRequirePci(): void;
    get requirePciInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _titleOptional?;
    get titleOptional(): string;
    set titleOptional(value: string);
    resetTitleOptional(): void;
    get titleOptionalInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization {
    /**
    * Enables the Manifest Personalization feature.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Includes additional `Akamai-Manifest-Personalization` and `Akamai-Manifest-Personalization-Config-Source` debugging headers.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
    */
    readonly hlsEnableDebugHeaders?: boolean | cdktf.IResolvable;
    /**
    * Allows you to customize the HLS master manifest that's sent to the requesting client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
    */
    readonly hlsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies a comma-delimited set of bit rate ranges, such as `100-400,1000-4000`. Playlists specified in the `#EXT-X-STREAM-INF` tag with bit rates outside of any of those ranges are excluded from the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
    */
    readonly hlsFilterInBitrateRanges?: string;
    /**
    * Specifies a comma-delimited set of preferred bit rates, such as `100,200,400`. Playlists specified in the `#EXT-X-STREAM-INF` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
    */
    readonly hlsFilterInBitrates?: string;
    /**
    * Applies with `hlsEnabled` on.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
    */
    readonly hlsMode?: string;
    /**
    * Sets the preferred bit rate in Kbps. This causes the media playlist specified in the `#EXT-X-STREAM-INF` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
    */
    readonly hlsPreferredBitrate?: string;
    /**
    * Specifies query parameters for the HLS master manifest to customize the manifest's content.  Any settings specified in the query string override those already configured in Property Manager.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
    */
    readonly hlsQueryParamEnabled?: boolean | cdktf.IResolvable;
    /**
    * Specifies a primary key as a token to accompany the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
    */
    readonly hlsQueryParamSecretKey?: string;
    /**
    * Specifies a transition key as a token to accompany the request.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
    */
    readonly hlsQueryParamTransitionKey?: string;
    /**
    * Allows you to configure advanced settings.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
    */
    readonly hlsShowAdvanced?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
    */
    readonly hlsTitle?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsEnableDebugHeaders?;
    get hlsEnableDebugHeaders(): boolean | cdktf.IResolvable;
    set hlsEnableDebugHeaders(value: boolean | cdktf.IResolvable);
    resetHlsEnableDebugHeaders(): void;
    get hlsEnableDebugHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsEnabled?;
    get hlsEnabled(): boolean | cdktf.IResolvable;
    set hlsEnabled(value: boolean | cdktf.IResolvable);
    resetHlsEnabled(): void;
    get hlsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsFilterInBitrateRanges?;
    get hlsFilterInBitrateRanges(): string;
    set hlsFilterInBitrateRanges(value: string);
    resetHlsFilterInBitrateRanges(): void;
    get hlsFilterInBitrateRangesInput(): string | undefined;
    private _hlsFilterInBitrates?;
    get hlsFilterInBitrates(): string;
    set hlsFilterInBitrates(value: string);
    resetHlsFilterInBitrates(): void;
    get hlsFilterInBitratesInput(): string | undefined;
    private _hlsMode?;
    get hlsMode(): string;
    set hlsMode(value: string);
    resetHlsMode(): void;
    get hlsModeInput(): string | undefined;
    private _hlsPreferredBitrate?;
    get hlsPreferredBitrate(): string;
    set hlsPreferredBitrate(value: string);
    resetHlsPreferredBitrate(): void;
    get hlsPreferredBitrateInput(): string | undefined;
    private _hlsQueryParamEnabled?;
    get hlsQueryParamEnabled(): boolean | cdktf.IResolvable;
    set hlsQueryParamEnabled(value: boolean | cdktf.IResolvable);
    resetHlsQueryParamEnabled(): void;
    get hlsQueryParamEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsQueryParamSecretKey?;
    get hlsQueryParamSecretKey(): string;
    set hlsQueryParamSecretKey(value: string);
    resetHlsQueryParamSecretKey(): void;
    get hlsQueryParamSecretKeyInput(): string | undefined;
    private _hlsQueryParamTransitionKey?;
    get hlsQueryParamTransitionKey(): string;
    set hlsQueryParamTransitionKey(value: string);
    resetHlsQueryParamTransitionKey(): void;
    get hlsQueryParamTransitionKeyInput(): string | undefined;
    private _hlsShowAdvanced?;
    get hlsShowAdvanced(): boolean | cdktf.IResolvable;
    set hlsShowAdvanced(value: boolean | cdktf.IResolvable);
    resetHlsShowAdvanced(): void;
    get hlsShowAdvancedInput(): boolean | cdktf.IResolvable | undefined;
    private _hlsTitle?;
    get hlsTitle(): string;
    set hlsTitle(value: string);
    resetHlsTitle(): void;
    get hlsTitleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Set this value to `adobe_primetime`, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
    */
    readonly partner?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * The user name for your Adobe Primetime account.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
    */
    readonly username?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _partner?;
    get partner(): string;
    set partner(value: string);
    resetPartner(): void;
    get partnerInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as `www.example.com/js/site.js`.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
    */
    readonly serverpushlist?: string[];
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _serverpushlist?;
    get serverpushlist(): string[];
    set serverpushlist(value: string[]);
    resetServerpushlist(): void;
    get serverpushlistInput(): string[] | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration {
    /**
    * Enables Media Acceleration.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout {
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
    */
    readonly optout?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout | undefined);
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _optout?;
    get optout(): string;
    set optout(value: string);
    resetOptout(): void;
    get optoutInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient {
    /**
    * Specifies the ID of data source's beacon.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
    */
    readonly beaconId?: string;
    /**
    * Enables client-side download analytics.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * Enables the hybrid HTTP/UDP protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
    */
    readonly useHybridHttpUdp?: boolean | cdktf.IResolvable;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient | undefined);
    private _beaconId?;
    get beaconId(): string;
    set beaconId(value: string);
    resetBeaconId(): void;
    get beaconIdInput(): string | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _useHybridHttpUdp?;
    get useHybridHttpUdp(): boolean | cdktf.IResolvable;
    set useHybridHttpUdp(value: boolean | cdktf.IResolvable);
    resetUseHybridHttpUdp(): void;
    get useHybridHttpUdpInput(): boolean | cdktf.IResolvable | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization {
    /**
    * Enables the partial-object caching behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
export interface DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover {
    /**
    * When enabled, caches the error response.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
    */
    readonly cacheErrorResponse?: boolean | cdktf.IResolvable;
    /**
    * This sets error response's TTL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
    */
    readonly cacheWindow?: string;
    /**
    * Specifies the response code served to the client.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
    */
    readonly clientResponseCode?: string;
    /**
    * Allows you to configure failover settings when the origin has content errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
    */
    readonly detectObjectUnavailable?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
    */
    readonly detectObjectUnavailableTitle?: string;
    /**
    * Allows you to configure failover settings when the origin server responds with errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
    */
    readonly detectOriginUnavailable?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
    */
    readonly detectOriginUnavailableTitle?: string;
    /**
    * Allows you to configure what happens when the origin is unresponsive.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
    */
    readonly detectOriginUnresponsive?: boolean | cdktf.IResolvable;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
    */
    readonly detectOriginUnresponsiveTitle?: string;
    /**
    * Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
    */
    readonly locked?: boolean | cdktf.IResolvable;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
    */
    readonly objectUnavailableAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
    */
    readonly objectUnavailableBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
    */
    readonly objectUnavailableBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
    */
    readonly objectUnavailableBlacklistWindow?: string;
    /**
    * Changes the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
    */
    readonly objectUnavailableChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify `RESPONSE_CODES`, the only available option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
    */
    readonly objectUnavailableDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
    */
    readonly objectUnavailableIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
    */
    readonly objectUnavailableModifiedPath?: string;
    /**
    * Enabling this allows you to modify the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
    */
    readonly objectUnavailableModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies either the `HTTP` or `HTTPS` protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
    */
    readonly objectUnavailableProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
    */
    readonly objectUnavailableRecovery?: string;
    /**
    * Specifies a redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
    */
    readonly objectUnavailableRedirectMethod?: number;
    /**
    * Specifies the set of response codes identifying when there are content errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
    */
    readonly objectUnavailableResponseCodes?: string[];
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
    */
    readonly objectUnavailableRetryLimit?: string;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
    */
    readonly originUnavailableAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
    */
    readonly originUnavailableBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
    */
    readonly originUnavailableBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
    */
    readonly originUnavailableBlacklistWindow?: string;
    /**
    * Modifies the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
    */
    readonly originUnavailableChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify `RESPONSE_CODES`, the only available option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
    */
    readonly originUnavailableDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
    */
    readonly originUnavailableIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
    */
    readonly originUnavailableModifiedPath?: string;
    /**
    * Modifies the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
    */
    readonly originUnavailableModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies either the `HTTP` or `HTTPS` protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
    */
    readonly originUnavailableProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
    */
    readonly originUnavailableRecovery?: string;
    /**
    * Specifies either a redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
    */
    readonly originUnavailableRedirectMethod?: number;
    /**
    * Specifies the set of response codes identifying when the origin responds with errors.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
    */
    readonly originUnavailableResponseCodes?: string[];
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
    */
    readonly originUnavailableRetryLimit?: string;
    /**
    * This specifies the redirect's destination hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
    */
    readonly originUnresponsiveAlternateHost?: string;
    /**
    * This specifies the origin hostname.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
    */
    readonly originUnresponsiveBackupHost?: string;
    /**
    * Enabling this blacklists the origin's IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
    */
    readonly originUnresponsiveBlacklistOriginIp?: boolean | cdktf.IResolvable;
    /**
    * This sets the delay before blacklisting an IP address.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
    */
    readonly originUnresponsiveBlacklistWindow?: string;
    /**
    * This allows you to change the request protocol.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
    */
    readonly originUnresponsiveChangeProtocol?: boolean | cdktf.IResolvable;
    /**
    * Specify the level of response to slow origin connections.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
    */
    readonly originUnresponsiveDetectionLevel?: string;
    /**
    * Enabling this includes the original set of query parameters.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
    */
    readonly originUnresponsiveIncludeQueryString?: boolean | cdktf.IResolvable;
    /**
    * This specifies the path to form the new URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
    */
    readonly originUnresponsiveModifiedPath?: string;
    /**
    * Modifies the request path.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
    */
    readonly originUnresponsiveModifyRequestPath?: boolean | cdktf.IResolvable;
    /**
    * Specifies which protocol to use.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
    */
    readonly originUnresponsiveProtocol?: string;
    /**
    * This sets the recovery option.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
    */
    readonly originUnresponsiveRecovery?: string;
    /**
    * Specifies the redirect response code.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
    */
    readonly originUnresponsiveRedirectMethod?: number;
    /**
    * Sets how many times to retry.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
    */
    readonly originUnresponsiveRetryLimit?: string;
    /**
    * This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
    */
    readonly otherOptions?: string;
    /**
    * This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
    */
    readonly templateUuid?: string;
    /**
    * A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
    */
    readonly uuid?: string;
}
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverToTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover): any;
export declare function dataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverToHclTerraform(struct?: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverOutputReference | DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover): any;
export declare class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover | undefined;
    set internalValue(value: DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover | undefined);
    private _cacheErrorResponse?;
    get cacheErrorResponse(): boolean | cdktf.IResolvable;
    set cacheErrorResponse(value: boolean | cdktf.IResolvable);
    resetCacheErrorResponse(): void;
    get cacheErrorResponseInput(): boolean | cdktf.IResolvable | undefined;
    private _cacheWindow?;
    get cacheWindow(): string;
    set cacheWindow(value: string);
    resetCacheWindow(): void;
    get cacheWindowInput(): string | undefined;
    private _clientResponseCode?;
    get clientResponseCode(): string;
    set clientResponseCode(value: string);
    resetClientResponseCode(): void;
    get clientResponseCodeInput(): string | undefined;
    private _detectObjectUnavailable?;
    get detectObjectUnavailable(): boolean | cdktf.IResolvable;
    set detectObjectUnavailable(value: boolean | cdktf.IResolvable);
    resetDetectObjectUnavailable(): void;
    get detectObjectUnavailableInput(): boolean | cdktf.IResolvable | undefined;
    private _detectObjectUnavailableTitle?;
    get detectObjectUnavailableTitle(): string;
    set detectObjectUnavailableTitle(value: string);
    resetDetectObjectUnavailableTitle(): void;
    get detectObjectUnavailableTitleInput(): string | undefined;
    private _detectOriginUnavailable?;
    get detectOriginUnavailable(): boolean | cdktf.IResolvable;
    set detectOriginUnavailable(value: boolean | cdktf.IResolvable);
    resetDetectOriginUnavailable(): void;
    get detectOriginUnavailableInput(): boolean | cdktf.IResolvable | undefined;
    private _detectOriginUnavailableTitle?;
    get detectOriginUnavailableTitle(): string;
    set detectOriginUnavailableTitle(value: string);
    resetDetectOriginUnavailableTitle(): void;
    get detectOriginUnavailableTitleInput(): string | undefined;
    private _detectOriginUnresponsive?;
    get detectOriginUnresponsive(): boolean | cdktf.IResolvable;
    set detectOriginUnresponsive(value: boolean | cdktf.IResolvable);
    resetDetectOriginUnresponsive(): void;
    get detectOriginUnresponsiveInput(): boolean | cdktf.IResolvable | undefined;
    private _detectOriginUnresponsiveTitle?;
    get detectOriginUnresponsiveTitle(): string;
    set detectOriginUnresponsiveTitle(value: string);
    resetDetectOriginUnresponsiveTitle(): void;
    get detectOriginUnresponsiveTitleInput(): string | undefined;
    private _locked?;
    get locked(): boolean | cdktf.IResolvable;
    set locked(value: boolean | cdktf.IResolvable);
    resetLocked(): void;
    get lockedInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableAlternateHost?;
    get objectUnavailableAlternateHost(): string;
    set objectUnavailableAlternateHost(value: string);
    resetObjectUnavailableAlternateHost(): void;
    get objectUnavailableAlternateHostInput(): string | undefined;
    private _objectUnavailableBackupHost?;
    get objectUnavailableBackupHost(): string;
    set objectUnavailableBackupHost(value: string);
    resetObjectUnavailableBackupHost(): void;
    get objectUnavailableBackupHostInput(): string | undefined;
    private _objectUnavailableBlacklistOriginIp?;
    get objectUnavailableBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set objectUnavailableBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableBlacklistOriginIp(): void;
    get objectUnavailableBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableBlacklistWindow?;
    get objectUnavailableBlacklistWindow(): string;
    set objectUnavailableBlacklistWindow(value: string);
    resetObjectUnavailableBlacklistWindow(): void;
    get objectUnavailableBlacklistWindowInput(): string | undefined;
    private _objectUnavailableChangeProtocol?;
    get objectUnavailableChangeProtocol(): boolean | cdktf.IResolvable;
    set objectUnavailableChangeProtocol(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableChangeProtocol(): void;
    get objectUnavailableChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableDetectionLevel?;
    get objectUnavailableDetectionLevel(): string;
    set objectUnavailableDetectionLevel(value: string);
    resetObjectUnavailableDetectionLevel(): void;
    get objectUnavailableDetectionLevelInput(): string | undefined;
    private _objectUnavailableIncludeQueryString?;
    get objectUnavailableIncludeQueryString(): boolean | cdktf.IResolvable;
    set objectUnavailableIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableIncludeQueryString(): void;
    get objectUnavailableIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableModifiedPath?;
    get objectUnavailableModifiedPath(): string;
    set objectUnavailableModifiedPath(value: string);
    resetObjectUnavailableModifiedPath(): void;
    get objectUnavailableModifiedPathInput(): string | undefined;
    private _objectUnavailableModifyRequestPath?;
    get objectUnavailableModifyRequestPath(): boolean | cdktf.IResolvable;
    set objectUnavailableModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetObjectUnavailableModifyRequestPath(): void;
    get objectUnavailableModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _objectUnavailableProtocol?;
    get objectUnavailableProtocol(): string;
    set objectUnavailableProtocol(value: string);
    resetObjectUnavailableProtocol(): void;
    get objectUnavailableProtocolInput(): string | undefined;
    private _objectUnavailableRecovery?;
    get objectUnavailableRecovery(): string;
    set objectUnavailableRecovery(value: string);
    resetObjectUnavailableRecovery(): void;
    get objectUnavailableRecoveryInput(): string | undefined;
    private _objectUnavailableRedirectMethod?;
    get objectUnavailableRedirectMethod(): number;
    set objectUnavailableRedirectMethod(value: number);
    resetObjectUnavailableRedirectMethod(): void;
    get objectUnavailableRedirectMethodInput(): number | undefined;
    private _objectUnavailableResponseCodes?;
    get objectUnavailableResponseCodes(): string[];
    set objectUnavailableResponseCodes(value: string[]);
    resetObjectUnavailableResponseCodes(): void;
    get objectUnavailableResponseCodesInput(): string[] | undefined;
    private _objectUnavailableRetryLimit?;
    get objectUnavailableRetryLimit(): string;
    set objectUnavailableRetryLimit(value: string);
    resetObjectUnavailableRetryLimit(): void;
    get objectUnavailableRetryLimitInput(): string | undefined;
    private _originUnavailableAlternateHost?;
    get originUnavailableAlternateHost(): string;
    set originUnavailableAlternateHost(value: string);
    resetOriginUnavailableAlternateHost(): void;
    get originUnavailableAlternateHostInput(): string | undefined;
    private _originUnavailableBackupHost?;
    get originUnavailableBackupHost(): string;
    set originUnavailableBackupHost(value: string);
    resetOriginUnavailableBackupHost(): void;
    get originUnavailableBackupHostInput(): string | undefined;
    private _originUnavailableBlacklistOriginIp?;
    get originUnavailableBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set originUnavailableBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableBlacklistOriginIp(): void;
    get originUnavailableBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableBlacklistWindow?;
    get originUnavailableBlacklistWindow(): string;
    set originUnavailableBlacklistWindow(value: string);
    resetOriginUnavailableBlacklistWindow(): void;
    get originUnavailableBlacklistWindowInput(): string | undefined;
    private _originUnavailableChangeProtocol?;
    get originUnavailableChangeProtocol(): boolean | cdktf.IResolvable;
    set originUnavailableChangeProtocol(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableChangeProtocol(): void;
    get originUnavailableChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableDetectionLevel?;
    get originUnavailableDetectionLevel(): string;
    set originUnavailableDetectionLevel(value: string);
    resetOriginUnavailableDetectionLevel(): void;
    get originUnavailableDetectionLevelInput(): string | undefined;
    private _originUnavailableIncludeQueryString?;
    get originUnavailableIncludeQueryString(): boolean | cdktf.IResolvable;
    set originUnavailableIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableIncludeQueryString(): void;
    get originUnavailableIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableModifiedPath?;
    get originUnavailableModifiedPath(): string;
    set originUnavailableModifiedPath(value: string);
    resetOriginUnavailableModifiedPath(): void;
    get originUnavailableModifiedPathInput(): string | undefined;
    private _originUnavailableModifyRequestPath?;
    get originUnavailableModifyRequestPath(): boolean | cdktf.IResolvable;
    set originUnavailableModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetOriginUnavailableModifyRequestPath(): void;
    get originUnavailableModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnavailableProtocol?;
    get originUnavailableProtocol(): string;
    set originUnavailableProtocol(value: string);
    resetOriginUnavailableProtocol(): void;
    get originUnavailableProtocolInput(): string | undefined;
    private _originUnavailableRecovery?;
    get originUnavailableRecovery(): string;
    set originUnavailableRecovery(value: string);
    resetOriginUnavailableRecovery(): void;
    get originUnavailableRecoveryInput(): string | undefined;
    private _originUnavailableRedirectMethod?;
    get originUnavailableRedirectMethod(): number;
    set originUnavailableRedirectMethod(value: number);
    resetOriginUnavailableRedirectMethod(): void;
    get originUnavailableRedirectMethodInput(): number | undefined;
    private _originUnavailableResponseCodes?;
    get originUnavailableResponseCodes(): string[];
    set originUnavailableResponseCodes(value: string[]);
    resetOriginUnavailableResponseCodes(): void;
    get originUnavailableResponseCodesInput(): string[] | undefined;
    private _originUnavailableRetryLimit?;
    get originUnavailableRetryLimit(): string;
    set originUnavailableRetryLimit(value: string);
    resetOriginUnavailableRetryLimit(): void;
    get originUnavailableRetryLimitInput(): string | undefined;
    private _originUnresponsiveAlternateHost?;
    get originUnresponsiveAlternateHost(): string;
    set originUnresponsiveAlternateHost(value: string);
    resetOriginUnresponsiveAlternateHost(): void;
    get originUnresponsiveAlternateHostInput(): string | undefined;
    private _originUnresponsiveBackupHost?;
    get originUnresponsiveBackupHost(): string;
    set originUnresponsiveBackupHost(value: string);
    resetOriginUnresponsiveBackupHost(): void;
    get originUnresponsiveBackupHostInput(): string | undefined;
    private _originUnresponsiveBlacklistOriginIp?;
    get originUnresponsiveBlacklistOriginIp(): boolean | cdktf.IResolvable;
    set originUnresponsiveBlacklistOriginIp(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveBlacklistOriginIp(): void;
    get originUnresponsiveBlacklistOriginIpInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveBlacklistWindow?;
    get originUnresponsiveBlacklistWindow(): string;
    set originUnresponsiveBlacklistWindow(value: string);
    resetOriginUnresponsiveBlacklistWindow(): void;
    get originUnresponsiveBlacklistWindowInput(): string | undefined;
    private _originUnresponsiveChangeProtocol?;
    get originUnresponsiveChangeProtocol(): boolean | cdktf.IResolvable;
    set originUnresponsiveChangeProtocol(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveChangeProtocol(): void;
    get originUnresponsiveChangeProtocolInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveDetectionLevel?;
    get originUnresponsiveDetectionLevel(): string;
    set originUnresponsiveDetectionLevel(value: string);
    resetOriginUnresponsiveDetectionLevel(): void;
    get originUnresponsiveDetectionLevelInput(): string | undefined;
    private _originUnresponsiveIncludeQueryString?;
    get originUnresponsiveIncludeQueryString(): boolean | cdktf.IResolvable;
    set originUnresponsiveIncludeQueryString(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveIncludeQueryString(): void;
    get originUnresponsiveIncludeQueryStringInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveModifiedPath?;
    get originUnresponsiveModifiedPath(): string;
    set originUnresponsiveModifiedPath(value: string);
    resetOriginUnresponsiveModifiedPath(): void;
    get originUnresponsiveModifiedPathInput(): string | undefined;
    private _originUnresponsiveModifyRequestPath?;
    get originUnresponsiveModifyRequestPath(): boolean | cdktf.IResolvable;
    set originUnresponsiveModifyRequestPath(value: boolean | cdktf.IResolvable);
    resetOriginUnresponsiveModifyRequestPath(): void;
    get originUnresponsiveModifyRequestPathInput(): boolean | cdktf.IResolvable | undefined;
    private _originUnresponsiveProtocol?;
    get originUnresponsiveProtocol(): string;
    set originUnresponsiveProtocol(value: string);
    resetOriginUnresponsiveProtocol(): void;
    get originUnresponsiveProtocolInput(): string | undefined;
    private _originUnresponsiveRecovery?;
    get originUnresponsiveRecovery(): string;
    set originUnresponsiveRecovery(value: string);
    resetOriginUnresponsiveRecovery(): void;
    get originUnresponsiveRecoveryInput(): string | undefined;
    private _originUnresponsiveRedirectMethod?;
    get originUnresponsiveRedirectMethod(): number;
    set originUnresponsiveRedirectMethod(value: number);
    resetOriginUnresponsiveRedirectMethod(): void;
    get originUnresponsiveRedirectMethodInput(): number | undefined;
    private _originUnresponsiveRetryLimit?;
    get originUnresponsiveRetryLimit(): string;
    set originUnresponsiveRetryLimit(value: string);
    resetOriginUnresponsiveRetryLimit(): void;
    get originUnresponsiveRetryLimitInput(): string | undefined;
    private _otherOptions?;
    get otherOptions(): string;
    set otherOptions(value: string);
    resetOtherOptions(): void;
    get otherOptionsInput(): string | undefined;
    private _templateUuid?;
    get templateUuid(): string;
    set templateUuid(value: string);
    resetTemplateUuid(): void;
    get templateUuidInput(): string | undefined;
    private _uuid?;
    get uuid(): string;
    set uuid(value: string);
    resetUuid(): void;
    get uuidInput(): string | undefined;
}
